/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/errors","vs/base/common/types","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/editor/common/core/range","vs/base/common/process","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/platform/registry/common/platform","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/editor/common/core/position","vs/base/common/errorMessage","vs/base/common/stopwatch","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/ternarySearchTree","fs","vs/editor/common/languages","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/lazy","vs/base/common/normalization","vs/base/common/mime","vs/base/common/hash","vs/base/common/marshalling","os","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/processes","vs/base/common/filters","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/observableValue","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],ye=function(te){for(var e=[],a=0,t=te.length;a<t;a++)e[a]=Se[te[a]];return e};define(Se[78],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function a(A){return A?A.replace(/\$\((.*?)\)/g,(D,T)=>` ${T} `).trim():""}e.getCodiconAriaLabel=a;class t{constructor(D,T,S){this.id=D,this.definition=T,this.description=S,t.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t.a}}e.Codicon=t,t.a=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);var k;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function T(R){if(R instanceof t)return["codicon","codicon-"+R.id];const P=D.exec(R.id);if(!P)return T(t.error);const[,E,y]=P,v=["codicon","codicon-"+E];return y&&v.push("codicon-modifier-"+y.substring(1)),v}A.asClassNameArray=T;function S(R){return T(R).join(" ")}A.asClassName=S;function C(R){return"."+T(R).join(".")}A.asCSSSelector=C})(k=e.CSSIcon||(e.CSSIcon={}))}),define(Se[79],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function a(D,T){const S=Object.create(null);for(const C of D){const R=T(C);let P=S[R];P||(P=S[R]=[]),P.push(C)}return S}e.groupBy=a;function t(D,T){const S=[],C=[];for(const R of D)T.has(R)||S.push(R);for(const R of T)D.has(R)||C.push(R);return{removed:S,added:C}}e.diffSets=t;function k(D,T){const S=[],C=[];for(const[R,P]of D)T.has(R)||S.push(P);for(const[R,P]of T)D.has(R)||C.push(P);return{removed:S,added:C}}e.diffMaps=k;class A{constructor(){this.a=new Map}add(T,S){let C=this.a.get(T);C||(C=new Set,this.a.set(T,C)),C.add(S)}delete(T,S){const C=this.a.get(T);!C||(C.delete(S),C.size===0&&this.a.delete(T))}forEach(T,S){const C=this.a.get(T);!C||C.forEach(S)}}e.SetMap=A}),define(Se[60],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function a(D){return(T,S,C)=>{let R=null,P=null;if(typeof C.value=="function"?(R="value",P=C.value):typeof C.get=="function"&&(R="get",P=C.get),!P)throw new Error("not supported");C[R]=D(P,S)}}function t(D,T,S){let C=null,R=null;if(typeof S.value=="function"?(C="value",R=S.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(C="get",R=S.get),!R)throw new Error("not supported");const P=`$memoize$${T}`;S[C]=function(...E){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,E)}),this[P]}}e.memoize=t;function k(D,T,S){return a((C,R)=>{const P=`$debounce$${R}`,E=`$debounce$result$${R}`;return function(...y){this[E]||(this[E]=S?S():void 0),clearTimeout(this[P]),T&&(this[E]=T(this[E],...y),y=[this[E]]),this[P]=setTimeout(()=>{C.apply(this,y),this[E]=S?S():void 0},D)}})}e.debounce=k;function A(D,T,S){return a((C,R)=>{const P=`$throttle$timer$${R}`,E=`$throttle$result$${R}`,y=`$throttle$lastRun$${R}`,v=`$throttle$pending$${R}`;return function(...d){if(this[E]||(this[E]=S?S():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),T&&(this[E]=T(this[E],...d)),this[v])return;const g=this[y]+D;g<=Date.now()?(this[y]=Date.now(),C.apply(this,[this[E]]),this[E]=S?S():void 0):(this[v]=!0,this[P]=setTimeout(()=>{this[v]=!1,this[y]=Date.now(),C.apply(this,[this[E]]),this[E]=S?S():void 0},g-Date.now()))}})}e.throttle=A}),define(Se[10],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class a{constructor(){this.b=[],this.a=function(s){setTimeout(()=>{throw s.stack?m.isErrorNoTelemetry(s)?new m(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.b.push(s),()=>{this.d(s)}}c(s){this.b.forEach(o=>{o(s)})}d(s){this.b.splice(this.b.indexOf(s),1)}setUnexpectedErrorHandler(s){this.a=s}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(s){this.a(s),this.c(s)}onUnexpectedExternalError(s){this.a(s)}}e.ErrorHandler=a,e.errorHandler=new a;function t(b){e.errorHandler.setUnexpectedErrorHandler(b)}e.setUnexpectedErrorHandler=t;function k(b){S(b)||e.errorHandler.onUnexpectedError(b)}e.onUnexpectedError=k;function A(b){S(b)||e.errorHandler.onUnexpectedExternalError(b)}e.onUnexpectedExternalError=A;function D(b){if(b instanceof Error){const{name:s,message:o}=b,c=b.stacktrace||b.stack;return{$isError:!0,name:s,message:o,stack:c,noTelemetry:m.isErrorNoTelemetry(b)}}return b}e.transformErrorForSerialization=D;const T="Canceled";function S(b){return b instanceof C?!0:b instanceof Error&&b.name===T&&b.message===T}e.isCancellationError=S;class C extends Error{constructor(){super(T),this.name=this.message}}e.CancellationError=C;function R(){const b=new Error(T);return b.name=b.message,b}e.canceled=R;function P(b){return b?new Error(`Illegal argument: ${b}`):new Error("Illegal argument")}e.illegalArgument=P;function E(b){return b?new Error(`Illegal state: ${b}`):new Error("Illegal state")}e.illegalState=E;function y(b){return b?new Error(`readonly property '${b} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function v(b){const s=new Error(`${b} has been disposed`);return s.name="DISPOSED",s}e.disposed=v;function d(b){return b?b.message?b.message:b.stack?b.stack.split(`
`)[0]:String(b):"Error"}e.getErrorMessage=d;class g extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.NotImplementedError=g;class h extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.NotSupportedError=h;class w extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=w;class m extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof m)return s;const o=new m;return o.message=s.message,o.stack=s.stack,o}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.ErrorNoTelemetry=m;class f extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,f.prototype);debugger}}e.BugIndicatingError=f}),define(Se[17],ye([1,0,10]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(re,le=0){return re[re.length-(1+le)]}e.tail=t;function k(re){if(re.length===0)throw new Error("Invalid tail call");return[re.slice(0,re.length-1),re[re.length-1]]}e.tail2=k;function A(re,le,fe=(Z,se)=>Z===se){if(re===le)return!0;if(!re||!le||re.length!==le.length)return!1;for(let Z=0,se=re.length;Z<se;Z++)if(!fe(re[Z],le[Z]))return!1;return!0}e.equals=A;function D(re,le){const fe=re.length-1;le<fe&&(re[le]=re[fe]),re.pop()}e.removeFastWithoutKeepingOrder=D;function T(re,le,fe){return S(re.length,Z=>fe(re[Z],le))}e.binarySearch=T;function S(re,le){let fe=0,Z=re-1;for(;fe<=Z;){const se=(fe+Z)/2|0,ne=le(se);if(ne<0)fe=se+1;else if(ne>0)Z=se-1;else return se}return-(fe+1)}e.binarySearch2=S;function C(re,le){let fe=0,Z=re.length;if(Z===0)return 0;for(;fe<Z;){const se=Math.floor((fe+Z)/2);le(re[se])?Z=se:fe=se+1}return fe}e.findFirstInSorted=C;function R(re,le,fe){if(re=re|0,re>=le.length)throw new TypeError("invalid index");const Z=le[Math.floor(le.length*Math.random())],se=[],ne=[],N=[];for(const z of le){const X=fe(z,Z);X<0?se.push(z):X>0?ne.push(z):N.push(z)}return re<se.length?R(re,se,fe):re<se.length+N.length?N[0]:R(re-(se.length+N.length),ne,fe)}e.quickSelect=R;function P(re,le){const fe=[];let Z;for(const se of re.slice(0).sort(le))!Z||le(Z[0],se)!==0?(Z=[se],fe.push(Z)):Z.push(se);return fe}e.groupBy=P;function E(re,le,fe){const Z=[];function se(z,X,_){if(X===0&&_.length===0)return;const ue=Z[Z.length-1];ue&&ue.start+ue.deleteCount===z?(ue.deleteCount+=X,ue.toInsert.push(..._)):Z.push({start:z,deleteCount:X,toInsert:_})}let ne=0,N=0;for(;;){if(ne===re.length){se(ne,0,le.slice(N));break}if(N===le.length){se(ne,re.length-ne,[]);break}const z=re[ne],X=le[N],_=fe(z,X);_===0?(ne+=1,N+=1):_<0?(se(ne,1,[]),ne+=1):_>0&&(se(ne,0,[X]),N+=1)}return Z}e.sortedDiff=E;function y(re,le,fe){const Z=E(re,le,fe),se=[],ne=[];for(const N of Z)se.push(...re.slice(N.start,N.start+N.deleteCount)),ne.push(...N.toInsert);return{removed:se,added:ne}}e.delta=y;function v(re,le,fe){if(fe===0)return[];const Z=re.slice(0,fe).sort(le);return g(re,le,Z,fe,re.length),Z}e.top=v;function d(re,le,fe,Z,se){return fe===0?Promise.resolve([]):new Promise((ne,N)=>{(async()=>{const z=re.length,X=re.slice(0,fe).sort(le);for(let _=fe,ue=Math.min(fe+Z,z);_<z;_=ue,ue=Math.min(ue+Z,z)){if(_>fe&&await new Promise(be=>setTimeout(be)),se&&se.isCancellationRequested)throw new a.CancellationError;g(re,le,X,_,ue)}return X})().then(ne,N)})}e.topAsync=d;function g(re,le,fe,Z,se){for(const ne=fe.length;Z<se;Z++){const N=re[Z];if(le(N,fe[ne-1])<0){fe.pop();const z=C(fe,X=>le(N,X)<0);fe.splice(z,0,N)}}}function h(re){return re.filter(le=>!!le)}e.coalesce=h;function w(re){let le=0;for(let fe=0;fe<re.length;fe++)re[fe]&&(re[le]=re[fe],le+=1);re.length=le}e.coalesceInPlace=w;function m(re,le,fe){re.splice(fe,0,re.splice(le,1)[0])}e.move=m;function f(re){return!Array.isArray(re)||re.length===0}e.isFalsyOrEmpty=f;function b(re){return Array.isArray(re)&&re.length>0}e.isNonEmptyArray=b;function s(re,le=fe=>fe){const fe=new Set;return re.filter(Z=>{const se=le(Z);return fe.has(se)?!1:(fe.add(se),!0)})}e.distinct=s;function o(re){const le=new Set;return fe=>{const Z=re(fe);return le.has(Z)?!1:(le.add(Z),!0)}}e.uniqueFilter=o;function c(re,le){const fe=u(re,le);if(fe!==-1)return re[fe]}e.findLast=c;function u(re,le){for(let fe=re.length-1;fe>=0;fe--){const Z=re[fe];if(le(Z))return fe}return-1}e.lastIndex=u;function r(re,le){return re.length>0?re[0]:le}e.firstOrDefault=r;function l(re,le){return re.length>0?re[re.length-1]:le}e.lastOrDefault=l;function n(re,le,fe=(Z,se)=>Z===se){let Z=0;for(let se=0,ne=Math.min(re.length,le.length);se<ne&&fe(re[se],le[se]);se++)Z++;return Z}e.commonPrefixLength=n;function i(re){return[].concat(...re)}e.flatten=i;function p(re,le){let fe=typeof le=="number"?re:0;typeof le=="number"?fe=re:(fe=0,le=re);const Z=[];if(fe<=le)for(let se=fe;se<le;se++)Z.push(se);else for(let se=fe;se>le;se--)Z.push(se);return Z}e.range=p;function I(re,le,fe){return re.reduce((Z,se)=>(Z[le(se)]=fe?fe(se):se,Z),Object.create(null))}e.index=I;function L(re,le){return re.push(le),()=>U(re,le)}e.insert=L;function U(re,le){const fe=re.indexOf(le);if(fe>-1)return re.splice(fe,1),le}e.remove=U;function G(re,le,fe){const Z=re.slice(0,le),se=re.slice(le);return Z.concat(fe,se)}e.arrayInsert=G;function V(re,le){let fe;if(typeof le=="number"){let Z=le;fe=()=>{const se=Math.sin(Z++)*179426549;return se-Math.floor(se)}}else fe=Math.random;for(let Z=re.length-1;Z>0;Z-=1){const se=Math.floor(fe()*(Z+1)),ne=re[Z];re[Z]=re[se],re[se]=ne}}e.shuffle=V;function O(re,le){const fe=re.indexOf(le);fe>-1&&(re.splice(fe,1),re.unshift(le))}e.pushToStart=O;function B(re,le){const fe=re.indexOf(le);fe>-1&&(re.splice(fe,1),re.push(le))}e.pushToEnd=B;function F(re,le){for(const fe of le)re.push(fe)}e.pushMany=F;function $(re,le){return Array.isArray(re)?re.map(le):le(re)}e.mapArrayOrNot=$;function M(re){return Array.isArray(re)?re:[re]}e.asArray=M;function H(re){return re[Math.floor(Math.random()*re.length)]}e.getRandomElement=H;function K(re,le){for(const fe of re){const Z=le(fe);if(Z!==void 0)return Z}}e.mapFind=K;function q(re,le,fe){const Z=Q(re,le),se=re.length,ne=fe.length;re.length=se+ne;for(let N=se-1;N>=Z;N--)re[N+ne]=re[N];for(let N=0;N<ne;N++)re[N+Z]=fe[N]}e.insertInto=q;function Y(re,le,fe,Z){const se=Q(re,le),ne=re.splice(se,fe);return q(re,se,Z),ne}e.splice=Y;function Q(re,le){return le<0?Math.max(le+re.length,0):Math.min(le,re.length)}var ce;(function(re){function le(se){return se<0}re.isLessThan=le;function fe(se){return se>0}re.isGreaterThan=fe;function Z(se){return se===0}re.isNeitherLessOrGreaterThan=Z,re.greaterThan=1,re.lessThan=-1,re.neitherLessOrGreaterThan=0})(ce=e.CompareResult||(e.CompareResult={}));function ie(re,le){return(fe,Z)=>le(re(fe),re(Z))}e.compareBy=ie;function de(...re){return(le,fe)=>{for(const Z of re){const se=Z(le,fe);if(!ce.isNeitherLessOrGreaterThan(se))return se}return ce.neitherLessOrGreaterThan}}e.tieBreakComparators=de;const J=(re,le)=>re-le;e.numberComparator=J;function pe(re,le){if(re.length===0)return;let fe=re[0];for(let Z=1;Z<re.length;Z++){const se=re[Z];le(se,fe)>0&&(fe=se)}return fe}e.findMaxBy=pe;function ve(re,le){if(re.length===0)return;let fe=re[0];for(let Z=1;Z<re.length;Z++){const se=re[Z];le(se,fe)>=0&&(fe=se)}return fe}e.findLastMaxBy=ve;function De(re,le){return pe(re,(fe,Z)=>-le(fe,Z))}e.findMinBy=De;class Re{constructor(le){this.f=le,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(le){let fe=this.c;for(;fe<this.f.length&&le(this.f[fe]);)fe++;const Z=fe===this.c?null:this.f.slice(this.c,fe);return this.c=fe,Z}takeFromEndWhile(le){let fe=this.d;for(;fe>=0&&le(this.f[fe]);)fe--;const Z=fe===this.d?null:this.f.slice(fe+1,this.d+1);return this.d=fe,Z}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const le=this.f[this.c];return this.c++,le}removeLast(){const le=this.f[this.d];return this.d--,le}takeCount(le){const fe=this.f.slice(this.c,this.c+le);return this.c+=le,fe}}e.ArrayQueue=Re;class $e{constructor(le){this.iterate=le}forEach(le){this.iterate(fe=>(le(fe),!0))}toArray(){const le=[];return this.iterate(fe=>(le.push(fe),!0)),le}filter(le){return new $e(fe=>this.iterate(Z=>le(Z)?fe(Z):!0))}map(le){return new $e(fe=>this.iterate(Z=>fe(le(Z))))}some(le){let fe=!1;return this.iterate(Z=>(fe=le(Z),!fe)),fe}findFirst(le){let fe;return this.iterate(Z=>le(Z)?(fe=Z,!1):!0),fe}findLast(le){let fe;return this.iterate(Z=>(le(Z)&&(fe=Z),!0)),fe}findLastMaxBy(le){let fe,Z=!0;return this.iterate(se=>((Z||ce.isGreaterThan(le(se,fe)))&&(Z=!1,fe=se),!0)),fe}}e.CallbackIterable=$e,$e.empty=new $e(re=>{})}),define(Se[48],ye([1,0,10]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(S,C){if(!S)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=t;function k(S,C="Unreachable"){throw new Error(C)}e.assertNever=k;function A(S){if(!S)throw new a.BugIndicatingError("Assertion Failed")}e.assert=A;function D(S){if(!S()){debugger;S(),(0,a.onUnexpectedError)(new a.BugIndicatingError("Assertion Failed"))}}e.assertFn=D;function T(S,C){let R=0;for(;R<S.length-1;){const P=S[R],E=S[R+1];if(!C(P,E))return!1;R++}return!0}e.checkAdjacentItems=T}),define(Se[61],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function a(t){const k=this;let A=!1,D;return function(){return A||(A=!0,D=t.apply(k,arguments)),D}}e.once=a}),define(Se[99],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class a{constructor(k){this.a=k,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=a,e.defaultGenerator=new a("id#")}),define(Se[62],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var a;(function(t){function k(f){return f&&typeof f=="object"&&typeof f[Symbol.iterator]=="function"}t.is=k;const A=Object.freeze([]);function D(){return A}t.empty=D;function*T(f){yield f}t.single=T;function S(f){return k(f)?f:T(f)}t.wrap=S;function C(f){return f||A}t.from=C;function R(f){return!f||f[Symbol.iterator]().next().done===!0}t.isEmpty=R;function P(f){return f[Symbol.iterator]().next().value}t.first=P;function E(f,b){for(const s of f)if(b(s))return!0;return!1}t.some=E;function y(f,b){for(const s of f)if(b(s))return s}t.find=y;function*v(f,b){for(const s of f)b(s)&&(yield s)}t.filter=v;function*d(f,b){let s=0;for(const o of f)yield b(o,s++)}t.map=d;function*g(...f){for(const b of f)for(const s of b)yield s}t.concat=g;function h(f,b,s){let o=s;for(const c of f)o=b(o,c);return o}t.reduce=h;function*w(f,b,s=f.length){for(b<0&&(b+=f.length),s<0?s+=f.length:s>f.length&&(s=f.length);b<s;b++)yield f[b]}t.slice=w;function m(f,b=Number.POSITIVE_INFINITY){const s=[];if(b===0)return[s,f];const o=f[Symbol.iterator]();for(let c=0;c<b;c++){const u=o.next();if(u.done)return[s,t.empty()];s.push(u.value)}return[s,{[Symbol.iterator](){return o}}]}t.consume=m})(a=e.Iterable||(e.Iterable={}))}),define(Se[145],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var a;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(a=e.ScanError||(e.ScanError={}));var t;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(s){s.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function D(s,o=!1){let c=0;const u=s.length;let r="",l=0,n=16,i=0;function p(B){let F=0,$=0;for(;F<B;){const M=s.charCodeAt(c);if(M>=48&&M<=57)$=$*16+M-48;else if(M>=65&&M<=70)$=$*16+M-65+10;else if(M>=97&&M<=102)$=$*16+M-97+10;else break;c++,F++}return F<B&&($=-1),$}function I(B){c=B,r="",l=0,n=16,i=0}function L(){const B=c;if(s.charCodeAt(c)===48)c++;else for(c++;c<s.length&&C(s.charCodeAt(c));)c++;if(c<s.length&&s.charCodeAt(c)===46)if(c++,c<s.length&&C(s.charCodeAt(c)))for(c++;c<s.length&&C(s.charCodeAt(c));)c++;else return i=3,s.substring(B,c);let F=c;if(c<s.length&&(s.charCodeAt(c)===69||s.charCodeAt(c)===101))if(c++,(c<s.length&&s.charCodeAt(c)===43||s.charCodeAt(c)===45)&&c++,c<s.length&&C(s.charCodeAt(c))){for(c++;c<s.length&&C(s.charCodeAt(c));)c++;F=c}else i=3;return s.substring(B,F)}function U(){let B="",F=c;for(;;){if(c>=u){B+=s.substring(F,c),i=2;break}const $=s.charCodeAt(c);if($===34){B+=s.substring(F,c),c++;break}if($===92){if(B+=s.substring(F,c),c++,c>=u){i=2;break}switch(s.charCodeAt(c++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const H=p(4);H>=0?B+=String.fromCharCode(H):i=4;break}default:i=5}F=c;continue}if($>=0&&$<=31)if(S($)){B+=s.substring(F,c),i=2;break}else i=6;c++}return B}function G(){if(r="",i=0,l=c,c>=u)return l=u,n=17;let B=s.charCodeAt(c);if(T(B)){do c++,r+=String.fromCharCode(B),B=s.charCodeAt(c);while(T(B));return n=15}if(S(B))return c++,r+=String.fromCharCode(B),B===13&&s.charCodeAt(c)===10&&(c++,r+=`
`),n=14;switch(B){case 123:return c++,n=1;case 125:return c++,n=2;case 91:return c++,n=3;case 93:return c++,n=4;case 58:return c++,n=6;case 44:return c++,n=5;case 34:return c++,r=U(),n=10;case 47:{const F=c-1;if(s.charCodeAt(c+1)===47){for(c+=2;c<u&&!S(s.charCodeAt(c));)c++;return r=s.substring(F,c),n=12}if(s.charCodeAt(c+1)===42){c+=2;const $=u-1;let M=!1;for(;c<$;){if(s.charCodeAt(c)===42&&s.charCodeAt(c+1)===47){c+=2,M=!0;break}c++}return M||(c++,i=1),r=s.substring(F,c),n=13}return r+=String.fromCharCode(B),c++,n=16}case 45:if(r+=String.fromCharCode(B),c++,c===u||!C(s.charCodeAt(c)))return n=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=L(),n=11;default:for(;c<u&&V(B);)c++,B=s.charCodeAt(c);if(l!==c){switch(r=s.substring(l,c),r){case"true":return n=8;case"false":return n=9;case"null":return n=7}return n=16}return r+=String.fromCharCode(B),c++,n=16}}function V(B){if(T(B)||S(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function O(){let B;do B=G();while(B>=12&&B<=15);return B}return{setPosition:I,getPosition:()=>c,scan:o?O:G,getToken:()=>n,getTokenValue:()=>r,getTokenOffset:()=>l,getTokenLength:()=>c-l,getTokenError:()=>i}}e.createScanner=D;function T(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function S(s){return s===10||s===13||s===8232||s===8233}function C(s){return s>=48&&s<=57}var R;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(R||(R={}));function P(s,o){const c=[],u=new Object;let r;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let n=!1;function i(p,I,L,U){l.value=p,l.offset=I,l.length=L,l.type=U,l.colonOffset=void 0,r=l}try{m(s,{onObjectBegin:(p,I)=>{if(o<=p)throw u;r=void 0,n=o>p,c.push("")},onObjectProperty:(p,I,L)=>{if(o<I||(i(p,I,L,"property"),c[c.length-1]=p,o<=I+L))throw u},onObjectEnd:(p,I)=>{if(o<=p)throw u;r=void 0,c.pop()},onArrayBegin:(p,I)=>{if(o<=p)throw u;r=void 0,c.push(0)},onArrayEnd:(p,I)=>{if(o<=p)throw u;r=void 0,c.pop()},onLiteralValue:(p,I,L)=>{if(o<I||(i(p,I,L,b(p)),o<=I+L))throw u},onSeparator:(p,I,L)=>{if(o<=I)throw u;if(p===":"&&r&&r.type==="property")r.colonOffset=I,n=!1,r=void 0;else if(p===","){const U=c[c.length-1];typeof U=="number"?c[c.length-1]=U+1:(n=!0,c[c.length-1]=""),r=void 0}}})}catch(p){if(p!==u)throw p}return{path:c,previousNode:r,isAtPropertyKey:n,matches:p=>{let I=0;for(let L=0;I<p.length&&L<c.length;L++)if(p[I]===c[L]||p[I]==="*")I++;else if(p[I]!=="**")return!1;return I===p.length}}}e.getLocation=P;function E(s,o=[],c=A.DEFAULT){let u=null,r=[];const l=[];function n(p){Array.isArray(r)?r.push(p):u!==null&&(r[u]=p)}return m(s,{onObjectBegin:()=>{const p={};n(p),l.push(r),r=p,u=null},onObjectProperty:p=>{u=p},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{const p=[];n(p),l.push(r),r=p,u=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:n,onError:(p,I,L)=>{o.push({error:p,offset:I,length:L})}},c),r[0]}e.parse=E;function y(s,o=[],c=A.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(p){u.type==="property"&&(u.length=p-u.offset,u=u.parent)}function l(p){return u.children.push(p),p}m(s,{onObjectBegin:p=>{u=l({type:"object",offset:p,length:-1,parent:u,children:[]})},onObjectProperty:(p,I,L)=>{u=l({type:"property",offset:I,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:p,offset:I,length:L,parent:u})},onObjectEnd:(p,I)=>{u.length=p+I-u.offset,u=u.parent,r(p+I)},onArrayBegin:(p,I)=>{u=l({type:"array",offset:p,length:-1,parent:u,children:[]})},onArrayEnd:(p,I)=>{u.length=p+I-u.offset,u=u.parent,r(p+I)},onLiteralValue:(p,I,L)=>{l({type:b(p),offset:I,length:L,parent:u,value:p}),r(I+L)},onSeparator:(p,I,L)=>{u.type==="property"&&(p===":"?u.colonOffset=I:p===","&&r(I))},onError:(p,I,L)=>{o.push({error:p,offset:I,length:L})}},c);const i=u.children[0];return i&&delete i.parent,i}e.parseTree=y;function v(s,o){if(!s)return;let c=s;for(const u of o)if(typeof u=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let r=!1;for(const l of c.children)if(Array.isArray(l.children)&&l.children[0].value===u){c=l.children[1],r=!0;break}if(!r)return}else{const r=u;if(c.type!=="array"||r<0||!Array.isArray(c.children)||r>=c.children.length)return;c=c.children[r]}return c}e.findNodeAtLocation=v;function d(s){if(!s.parent||!s.parent.children)return[];const o=d(s.parent);if(s.parent.type==="property"){const c=s.parent.children[0].value;o.push(c)}else if(s.parent.type==="array"){const c=s.parent.children.indexOf(s);c!==-1&&o.push(c)}return o}e.getNodePath=d;function g(s){switch(s.type){case"array":return s.children.map(g);case"object":{const o=Object.create(null);for(const c of s.children){const u=c.children[1];u&&(o[c.children[0].value]=g(u))}return o}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=g;function h(s,o,c=!1){return o>=s.offset&&o<s.offset+s.length||c&&o===s.offset+s.length}e.contains=h;function w(s,o,c=!1){if(h(s,o,c)){const u=s.children;if(Array.isArray(u))for(let r=0;r<u.length&&u[r].offset<=o;r++){const l=w(u[r],o,c);if(l)return l}return s}}e.findNodeAtOffset=w;function m(s,o,c=A.DEFAULT){const u=D(s,!1);function r(ie){return ie?()=>ie(u.getTokenOffset(),u.getTokenLength()):()=>!0}function l(ie){return ie?de=>ie(de,u.getTokenOffset(),u.getTokenLength()):()=>!0}const n=r(o.onObjectBegin),i=l(o.onObjectProperty),p=r(o.onObjectEnd),I=r(o.onArrayBegin),L=r(o.onArrayEnd),U=l(o.onLiteralValue),G=l(o.onSeparator),V=r(o.onComment),O=l(o.onError),B=c&&c.disallowComments,F=c&&c.allowTrailingComma;function $(){for(;;){const ie=u.scan();switch(u.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:B||M(11);break;case 2:M(12);break;case 6:M(16);break}switch(ie){case 12:case 13:B?M(10):V();break;case 16:M(1);break;case 15:case 14:break;default:return ie}}}function M(ie,de=[],J=[]){if(O(ie),de.length+J.length>0){let pe=u.getToken();for(;pe!==17;){if(de.indexOf(pe)!==-1){$();break}else if(J.indexOf(pe)!==-1)break;pe=$()}}}function H(ie){const de=u.getTokenValue();return ie?U(de):i(de),$(),!0}function K(){switch(u.getToken()){case 11:{let ie=0;try{ie=JSON.parse(u.getTokenValue()),typeof ie!="number"&&(M(2),ie=0)}catch{M(2)}U(ie);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return $(),!0}function q(){return u.getToken()!==10?(M(3,[],[2,5]),!1):(H(!1),u.getToken()===6?(G(":"),$(),ce()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function Y(){n(),$();let ie=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(ie||M(4,[],[]),G(","),$(),u.getToken()===2&&F)break}else ie&&M(6,[],[]);q()||M(4,[],[2,5]),ie=!0}return p(),u.getToken()!==2?M(7,[2],[]):$(),!0}function Q(){I(),$();let ie=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(ie||M(4,[],[]),G(","),$(),u.getToken()===4&&F)break}else ie&&M(6,[],[]);ce()||M(4,[],[4,5]),ie=!0}return L(),u.getToken()!==4?M(8,[4],[]):$(),!0}function ce(){switch(u.getToken()){case 3:return Q();case 1:return Y();case 10:return H(!0);default:return K()}}return $(),u.getToken()===17?c.allowEmptyContent?!0:(M(4,[],[]),!1):ce()?(u.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=m;function f(s,o){const c=D(s),u=[];let r,l=0,n;do switch(n=c.getPosition(),r=c.scan(),r){case 12:case 13:case 17:l!==n&&u.push(s.substring(l,n)),o!==void 0&&u.push(c.getTokenValue().replace(/[^\r\n]/g,o)),l=c.getPosition();break}while(r!==17);return u.join("")}e.stripComments=f;function b(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=b}),define(Se[80],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class a{constructor(k){this.d=k,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(k){this.c=k}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(k){return new a(()=>k(this.getValue()))}}e.Lazy=a}),define(Se[6],ye([1,0,61,62]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let A=null;function D(l){A=l}if(e.setDisposableTracker=D,k){const l="__is_disposable_tracked__";D(new class{trackDisposable(n){const i=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[l]||console.log(i)},3e3)}setParent(n,i){if(n&&n!==w.None)try{n[l]=!0}catch{}}markAsDisposed(n){if(n&&n!==w.None)try{n[l]=!0}catch{}}markAsSingleton(n){}})}function T(l){return A?.trackDisposable(l),l}function S(l){A?.markAsDisposed(l)}function C(l,n){A?.setParent(l,n)}function R(l,n){if(!!A)for(const i of l)A.setParent(i,n)}function P(l){return A?.markAsSingleton(l),l}e.markAsSingleton=P;function E(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=E;function y(l){if(t.Iterable.is(l)){const n=[];for(const i of l)if(i)try{i.dispose()}catch(p){n.push(p)}if(n.length===1)throw n[0];if(n.length>1)throw new AggregateError(n,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}e.dispose=y;function v(l){for(const n of l)E(n)&&n.dispose();return[]}e.disposeIfDisposable=v;function d(...l){const n=g(()=>y(l));return R(l,n),n}e.combinedDisposable=d;function g(l){const n=T({dispose:(0,a.once)(()=>{S(n),l()})});return n}e.toDisposable=g;class h{constructor(){this.c=new Set,this.f=!1,T(this)}dispose(){this.f||(S(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{y(this.c)}finally{this.c.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return C(n,this),this.f?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(n),n}}e.DisposableStore=h,h.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this.q=new h,T(this),C(this.q,this)}dispose(){S(this),this.q.dispose()}B(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(n)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class m{constructor(){this.b=!1,T(this)}get value(){return this.b?void 0:this.a}set value(n){this.b||n===this.a||(this.a?.dispose(),n&&C(n,this),this.a=n)}clear(){this.value=void 0}dispose(){this.b=!0,S(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const n=this.a;return this.a=void 0,n&&C(n,null),n}}e.MutableDisposable=m;class f{constructor(n){this.b=n,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=f;class b{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,T(this)}set(n){let i=n;return this.unset=()=>i=void 0,this.isset=()=>i!==void 0,this.dispose=()=>{i&&(i(),i=void 0,S(this))},this}}e.SafeDisposable=b;class s{constructor(){this.a=new Map}acquire(n,...i){let p=this.a.get(n);p||(p={counter:0,object:this.b(n,...i)},this.a.set(n,p));const{object:I}=p,L=(0,a.once)(()=>{--p.counter===0&&(this.c(n,p.object),this.a.delete(n))});return p.counter++,{object:I,dispose:L}}}e.ReferenceCollection=s;class o{constructor(n){this.a=n}async acquire(n,...i){const p=this.a.acquire(n,...i);try{return{object:await p.object,dispose:()=>p.dispose()}}catch(I){throw p.dispose(),I}}}e.AsyncReferenceCollection=o;class c{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=c;function u(l){const n=new h;try{l(n)}finally{n.dispose()}}e.disposeOnReturn=u;class r{constructor(){this.a=new Map,this.b=!1,T(this)}dispose(){S(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{y(this.a.values())}finally{this.a.clear()}}has(n){return this.a.has(n)}get(n){return this.a.get(n)}set(n,i,p=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),p||this.a.get(n)?.dispose(),this.a.set(n,i)}deleteAndDispose(n){this.a.get(n)?.dispose(),this.a.delete(n)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=r}),define(Se[63],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class a{constructor(A){this.element=A,this.next=a.Undefined,this.prev=a.Undefined}}a.Undefined=new a(void 0);class t{constructor(){this.a=a.Undefined,this.b=a.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===a.Undefined}clear(){let A=this.a;for(;A!==a.Undefined;){const D=A.next;A.prev=a.Undefined,A.next=a.Undefined,A=D}this.a=a.Undefined,this.b=a.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,D){const T=new a(A);if(this.a===a.Undefined)this.a=T,this.b=T;else if(D){const C=this.b;this.b=T,T.prev=C,C.next=T}else{const C=this.a;this.a=T,T.next=C,C.prev=T}this.c+=1;let S=!1;return()=>{S||(S=!0,this.e(T))}}shift(){if(this.a!==a.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==a.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==a.Undefined&&A.next!==a.Undefined){const D=A.prev;D.next=A.next,A.next.prev=D}else A.prev===a.Undefined&&A.next===a.Undefined?(this.a=a.Undefined,this.b=a.Undefined):A.next===a.Undefined?(this.b=this.b.prev,this.b.next=a.Undefined):A.prev===a.Undefined&&(this.a=this.a.next,this.a.prev=a.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==a.Undefined;)yield A.element,A=A.next}}e.LinkedList=t}),define(Se[28],ye([1,0]),function(te,e){"use strict";var a,t,k;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(v,d,g){let h=v.get(d);return h===void 0&&(h=g,v.set(d,h)),h}e.getOrSet=A;function D(v){const d=[];return v.forEach((g,h)=>{d.push(`${h} => ${g}`)}),`Map(${v.size}) {${d.join(", ")}}`}e.mapToString=D;function T(v){const d=[];return v.forEach(g=>{d.push(g)}),`Set(${v.size}) {${d.join(", ")}}`}e.setToString=T;class S{constructor(d,g){this.uri=d,this.value=g}}class C{constructor(d,g){this[a]="ResourceMap",d instanceof C?(this.b=new Map(d.b),this.c=g??C.a):(this.b=new Map,this.c=d??C.a)}set(d,g){return this.b.set(this.c(d),new S(d,g)),this}get(d){return this.b.get(this.c(d))?.value}has(d){return this.b.has(this.c(d))}get size(){return this.b.size}clear(){this.b.clear()}delete(d){return this.b.delete(this.c(d))}forEach(d,g){typeof g<"u"&&(d=d.bind(g));for(const[h,w]of this.b)d(w.value,w.uri,this)}*values(){for(const d of this.b.values())yield d.value}*keys(){for(const d of this.b.values())yield d.uri}*entries(){for(const d of this.b.values())yield[d.uri,d.value]}*[(a=Symbol.toStringTag,Symbol.iterator)](){for(const[,d]of this.b)yield[d.uri,d.value]}}e.ResourceMap=C,C.a=v=>v.toString();class R{constructor(d,g){this[t]="ResourceSet",!d||typeof d=="function"?this.a=new C(d):(this.a=new C(g),d.forEach(this.add,this))}get size(){return this.a.size}add(d){return this.a.set(d,d),this}clear(){this.a.clear()}delete(d){return this.a.delete(d)}forEach(d,g){this.a.forEach((h,w)=>d.call(g,w,w,this))}has(d){return this.a.has(d)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=R;var P;(function(v){v[v.None=0]="None",v[v.AsOld=1]="AsOld",v[v.AsNew=2]="AsNew"})(P=e.Touch||(e.Touch={}));class E{constructor(){this[k]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(d){return this.a.has(d)}get(d,g=0){const h=this.a.get(d);if(!!h)return g!==0&&this.j(h,g),h.value}set(d,g,h=0){let w=this.a.get(d);if(w)w.value=g,h!==0&&this.j(w,h);else{switch(w={key:d,value:g,next:void 0,previous:void 0},h){case 0:this.h(w);break;case 1:this.g(w);break;case 2:this.h(w);break;default:this.h(w);break}this.a.set(d,w),this.d++}return this}delete(d){return!!this.remove(d)}remove(d){const g=this.a.get(d);if(!!g)return this.a.delete(d),this.i(g),this.d--,g.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const d=this.b;return this.a.delete(d.key),this.i(d),this.d--,d.value}forEach(d,g){const h=this.e;let w=this.b;for(;w;){if(g?d.bind(g)(w.value,w.key,this):d(w.value,w.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");w=w.next}}keys(){const d=this,g=this.e;let h=this.b;const w={[Symbol.iterator](){return w},next(){if(d.e!==g)throw new Error("LinkedMap got modified during iteration.");if(h){const m={value:h.key,done:!1};return h=h.next,m}else return{value:void 0,done:!0}}};return w}values(){const d=this,g=this.e;let h=this.b;const w={[Symbol.iterator](){return w},next(){if(d.e!==g)throw new Error("LinkedMap got modified during iteration.");if(h){const m={value:h.value,done:!1};return h=h.next,m}else return{value:void 0,done:!0}}};return w}entries(){const d=this,g=this.e;let h=this.b;const w={[Symbol.iterator](){return w},next(){if(d.e!==g)throw new Error("LinkedMap got modified during iteration.");if(h){const m={value:[h.key,h.value],done:!1};return h=h.next,m}else return{value:void 0,done:!0}}};return w}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(d){if(d>=this.size)return;if(d===0){this.clear();return}let g=this.b,h=this.size;for(;g&&h>d;)this.a.delete(g.key),g=g.next,h--;this.b=g,this.d=h,g&&(g.previous=void 0),this.e++}g(d){if(!this.b&&!this.c)this.c=d;else if(this.b)d.next=this.b,this.b.previous=d;else throw new Error("Invalid list");this.b=d,this.e++}h(d){if(!this.b&&!this.c)this.b=d;else if(this.c)d.previous=this.c,this.c.next=d;else throw new Error("Invalid list");this.c=d,this.e++}i(d){if(d===this.b&&d===this.c)this.b=void 0,this.c=void 0;else if(d===this.b){if(!d.next)throw new Error("Invalid list");d.next.previous=void 0,this.b=d.next}else if(d===this.c){if(!d.previous)throw new Error("Invalid list");d.previous.next=void 0,this.c=d.previous}else{const g=d.next,h=d.previous;if(!g||!h)throw new Error("Invalid list");g.previous=h,h.next=g}d.next=void 0,d.previous=void 0,this.e++}j(d,g){if(!this.b||!this.c)throw new Error("Invalid list");if(!(g!==1&&g!==2)){if(g===1){if(d===this.b)return;const h=d.next,w=d.previous;d===this.c?(w.next=void 0,this.c=w):(h.previous=w,w.next=h),d.previous=void 0,d.next=this.b,this.b.previous=d,this.b=d,this.e++}else if(g===2){if(d===this.c)return;const h=d.next,w=d.previous;d===this.b?(h.previous=void 0,this.b=h):(h.previous=w,w.next=h),d.next=void 0,d.previous=this.c,this.c.next=d,this.c=d,this.e++}}}toJSON(){const d=[];return this.forEach((g,h)=>{d.push([h,g])}),d}fromJSON(d){this.clear();for(const[g,h]of d)this.set(g,h)}}e.LinkedMap=E;class y extends E{constructor(d,g=1){super(),this.k=d,this.l=Math.min(Math.max(0,g),1)}get limit(){return this.k}set limit(d){this.k=d,this.m()}get ratio(){return this.l}set ratio(d){this.l=Math.min(Math.max(0,d),1),this.m()}get(d,g=2){return super.get(d,g)}peek(d){return super.get(d,0)}set(d,g){return super.set(d,g,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=y}),function(te,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Se[146],ye([0]),e):(te=typeof globalThis<"u"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(re,le){for(var fe=0;fe<le.length;fe++){var Z=le[fe];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(re,Z.key,Z)}}function a(re,le,fe){return le&&e(re.prototype,le),fe&&e(re,fe),Object.defineProperty(re,"prototype",{writable:!1}),re}function t(re,le){if(!!re){if(typeof re=="string")return k(re,le);var fe=Object.prototype.toString.call(re).slice(8,-1);if(fe==="Object"&&re.constructor&&(fe=re.constructor.name),fe==="Map"||fe==="Set")return Array.from(re);if(fe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(fe))return k(re,le)}}function k(re,le){(le==null||le>re.length)&&(le=re.length);for(var fe=0,Z=new Array(le);fe<le;fe++)Z[fe]=re[fe];return Z}function A(re,le){var fe=typeof Symbol<"u"&&re[Symbol.iterator]||re["@@iterator"];if(fe)return(fe=fe.call(re)).next.bind(fe);if(Array.isArray(re)||(fe=t(re))||le&&re&&typeof re.length=="number"){fe&&(re=fe);var Z=0;return function(){return Z>=re.length?{done:!0}:{done:!1,value:re[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=D();function T(re){te.defaults=re}var S=/[&<>"']/,C=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,E={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(le){return E[le]};function v(re,le){if(le){if(S.test(re))return re.replace(C,y)}else if(R.test(re))return re.replace(P,y);return re}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(re){return re.replace(d,function(le,fe){return fe=fe.toLowerCase(),fe==="colon"?":":fe.charAt(0)==="#"?fe.charAt(1)==="x"?String.fromCharCode(parseInt(fe.substring(2),16)):String.fromCharCode(+fe.substring(1)):""})}var h=/(^|[^\[])\^/g;function w(re,le){re=typeof re=="string"?re:re.source,le=le||"";var fe={replace:function(se,ne){return ne=ne.source||ne,ne=ne.replace(h,"$1"),re=re.replace(se,ne),fe},getRegex:function(){return new RegExp(re,le)}};return fe}var m=/[^\w:]/g,f=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function b(re,le,fe){if(re){var Z;try{Z=decodeURIComponent(g(fe)).replace(m,"").toLowerCase()}catch{return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}le&&!f.test(fe)&&(fe=r(le,fe));try{fe=encodeURI(fe).replace(/%25/g,"%")}catch{return null}return fe}var s={},o=/^[^:]+:\/*[^/]*$/,c=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(re,le){s[" "+re]||(o.test(re)?s[" "+re]=re+"/":s[" "+re]=p(re,"/",!0)),re=s[" "+re];var fe=re.indexOf(":")===-1;return le.substring(0,2)==="//"?fe?le:re.replace(c,"$1")+le:le.charAt(0)==="/"?fe?le:re.replace(u,"$1")+le:re+le}var l={exec:function(){}};function n(re){for(var le=1,fe,Z;le<arguments.length;le++){fe=arguments[le];for(Z in fe)Object.prototype.hasOwnProperty.call(fe,Z)&&(re[Z]=fe[Z])}return re}function i(re,le){var fe=re.replace(/\|/g,function(ne,N,z){for(var X=!1,_=N;--_>=0&&z[_]==="\\";)X=!X;return X?"|":" |"}),Z=fe.split(/ \|/),se=0;if(Z[0].trim()||Z.shift(),Z.length>0&&!Z[Z.length-1].trim()&&Z.pop(),Z.length>le)Z.splice(le);else for(;Z.length<le;)Z.push("");for(;se<Z.length;se++)Z[se]=Z[se].trim().replace(/\\\|/g,"|");return Z}function p(re,le,fe){var Z=re.length;if(Z===0)return"";for(var se=0;se<Z;){var ne=re.charAt(Z-se-1);if(ne===le&&!fe)se++;else if(ne!==le&&fe)se++;else break}return re.slice(0,Z-se)}function I(re,le){if(re.indexOf(le[1])===-1)return-1;for(var fe=re.length,Z=0,se=0;se<fe;se++)if(re[se]==="\\")se++;else if(re[se]===le[0])Z++;else if(re[se]===le[1]&&(Z--,Z<0))return se;return-1}function L(re){re&&re.sanitize&&!re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function U(re,le){if(le<1)return"";for(var fe="";le>1;)le&1&&(fe+=re),le>>=1,re+=re;return fe+re}function G(re,le,fe,Z){var se=le.href,ne=le.title?v(le.title):null,N=re[1].replace(/\\([\[\]])/g,"$1");if(re[0].charAt(0)!=="!"){Z.state.inLink=!0;var z={type:"link",raw:fe,href:se,title:ne,text:N,tokens:Z.inlineTokens(N)};return Z.state.inLink=!1,z}return{type:"image",raw:fe,href:se,title:ne,text:v(N)}}function V(re,le){var fe=re.match(/^(\s+)(?:```)/);if(fe===null)return le;var Z=fe[1];return le.split(`
`).map(function(se){var ne=se.match(/^\s+/);if(ne===null)return se;var N=ne[0];return N.length>=Z.length?se.slice(Z.length):se}).join(`
`)}var O=function(){function re(fe){this.options=fe||te.defaults}var le=re.prototype;return le.space=function(Z){var se=this.rules.block.newline.exec(Z);if(se&&se[0].length>0)return{type:"space",raw:se[0]}},le.code=function(Z){var se=this.rules.block.code.exec(Z);if(se){var ne=se[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:se[0],codeBlockStyle:"indented",text:this.options.pedantic?ne:p(ne,`
`)}}},le.fences=function(Z){var se=this.rules.block.fences.exec(Z);if(se){var ne=se[0],N=V(ne,se[3]||"");return{type:"code",raw:ne,lang:se[2]?se[2].trim():se[2],text:N}}},le.heading=function(Z){var se=this.rules.block.heading.exec(Z);if(se){var ne=se[2].trim();if(/#$/.test(ne)){var N=p(ne,"#");(this.options.pedantic||!N||/ $/.test(N))&&(ne=N.trim())}return{type:"heading",raw:se[0],depth:se[1].length,text:ne,tokens:this.lexer.inline(ne)}}},le.hr=function(Z){var se=this.rules.block.hr.exec(Z);if(se)return{type:"hr",raw:se[0]}},le.blockquote=function(Z){var se=this.rules.block.blockquote.exec(Z);if(se){var ne=se[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:se[0],tokens:this.lexer.blockTokens(ne,[]),text:ne}}},le.list=function(Z){var se=this.rules.block.list.exec(Z);if(se){var ne,N,z,X,_,ue,be,ke,ge,Pe,Ie,je,qe=se[1].trim(),et=qe.length>1,_e={type:"list",raw:"",ordered:et,start:et?+qe.slice(0,-1):"",loose:!1,items:[]};qe=et?"\\d{1,9}\\"+qe.slice(-1):"\\"+qe,this.options.pedantic&&(qe=et?qe:"[*+-]");for(var nt=new RegExp("^( {0,3}"+qe+")((?:[	 ][^\\n]*)?(?:\\n|$))");Z&&(je=!1,!(!(se=nt.exec(Z))||this.rules.block.hr.test(Z)));){if(ne=se[0],Z=Z.substring(ne.length),ke=se[2].split(`
`,1)[0],ge=Z.split(`
`,1)[0],this.options.pedantic?(X=2,Ie=ke.trimLeft()):(X=se[2].search(/[^ ]/),X=X>4?1:X,Ie=ke.slice(X),X+=se[1].length),ue=!1,!ke&&/^ *$/.test(ge)&&(ne+=ge+`
`,Z=Z.substring(ge.length+1),je=!0),!je)for(var st=new RegExp("^ {0,"+Math.min(3,X-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ht=new RegExp("^ {0,"+Math.min(3,X-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ue=new RegExp("^ {0,"+Math.min(3,X-1)+"}(?:```|~~~)"),it=new RegExp("^ {0,"+Math.min(3,X-1)+"}#");Z&&(Pe=Z.split(`
`,1)[0],ke=Pe,this.options.pedantic&&(ke=ke.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ue.test(ke)||it.test(ke)||st.test(ke)||ht.test(Z)));){if(ke.search(/[^ ]/)>=X||!ke.trim())Ie+=`
`+ke.slice(X);else if(!ue)Ie+=`
`+ke;else break;!ue&&!ke.trim()&&(ue=!0),ne+=Pe+`
`,Z=Z.substring(Pe.length+1)}_e.loose||(be?_e.loose=!0:/\n *\n *$/.test(ne)&&(be=!0)),this.options.gfm&&(N=/^\[[ xX]\] /.exec(Ie),N&&(z=N[0]!=="[ ] ",Ie=Ie.replace(/^\[[ xX]\] +/,""))),_e.items.push({type:"list_item",raw:ne,task:!!N,checked:z,loose:!1,text:Ie}),_e.raw+=ne}_e.items[_e.items.length-1].raw=ne.trimRight(),_e.items[_e.items.length-1].text=Ie.trimRight(),_e.raw=_e.raw.trimRight();var oe=_e.items.length;for(_=0;_<oe;_++){this.lexer.state.top=!1,_e.items[_].tokens=this.lexer.blockTokens(_e.items[_].text,[]);var W=_e.items[_].tokens.filter(function(Ce){return Ce.type==="space"}),ae=W.every(function(Ce){for(var Le=Ce.raw.split(""),Be=0,Xe=A(Le),Ze;!(Ze=Xe()).done;){var ft=Ze.value;if(ft===`
`&&(Be+=1),Be>1)return!0}return!1});!_e.loose&&W.length&&ae&&(_e.loose=!0,_e.items[_].loose=!0)}return _e}},le.html=function(Z){var se=this.rules.block.html.exec(Z);if(se){var ne={type:"html",raw:se[0],pre:!this.options.sanitizer&&(se[1]==="pre"||se[1]==="script"||se[1]==="style"),text:se[0]};if(this.options.sanitize){var N=this.options.sanitizer?this.options.sanitizer(se[0]):v(se[0]);ne.type="paragraph",ne.text=N,ne.tokens=this.lexer.inline(N)}return ne}},le.def=function(Z){var se=this.rules.block.def.exec(Z);if(se){se[3]&&(se[3]=se[3].substring(1,se[3].length-1));var ne=se[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ne,raw:se[0],href:se[2],title:se[3]}}},le.table=function(Z){var se=this.rules.block.table.exec(Z);if(se){var ne={type:"table",header:i(se[1]).map(function(be){return{text:be}}),align:se[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:se[3]&&se[3].trim()?se[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ne.header.length===ne.align.length){ne.raw=se[0];var N=ne.align.length,z,X,_,ue;for(z=0;z<N;z++)/^ *-+: *$/.test(ne.align[z])?ne.align[z]="right":/^ *:-+: *$/.test(ne.align[z])?ne.align[z]="center":/^ *:-+ *$/.test(ne.align[z])?ne.align[z]="left":ne.align[z]=null;for(N=ne.rows.length,z=0;z<N;z++)ne.rows[z]=i(ne.rows[z],ne.header.length).map(function(be){return{text:be}});for(N=ne.header.length,X=0;X<N;X++)ne.header[X].tokens=this.lexer.inline(ne.header[X].text);for(N=ne.rows.length,X=0;X<N;X++)for(ue=ne.rows[X],_=0;_<ue.length;_++)ue[_].tokens=this.lexer.inline(ue[_].text);return ne}}},le.lheading=function(Z){var se=this.rules.block.lheading.exec(Z);if(se)return{type:"heading",raw:se[0],depth:se[2].charAt(0)==="="?1:2,text:se[1],tokens:this.lexer.inline(se[1])}},le.paragraph=function(Z){var se=this.rules.block.paragraph.exec(Z);if(se){var ne=se[1].charAt(se[1].length-1)===`
`?se[1].slice(0,-1):se[1];return{type:"paragraph",raw:se[0],text:ne,tokens:this.lexer.inline(ne)}}},le.text=function(Z){var se=this.rules.block.text.exec(Z);if(se)return{type:"text",raw:se[0],text:se[0],tokens:this.lexer.inline(se[0])}},le.escape=function(Z){var se=this.rules.inline.escape.exec(Z);if(se)return{type:"escape",raw:se[0],text:v(se[1])}},le.tag=function(Z){var se=this.rules.inline.tag.exec(Z);if(se)return!this.lexer.state.inLink&&/^<a /i.test(se[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(se[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(se[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(se[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:se[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):v(se[0]):se[0]}},le.link=function(Z){var se=this.rules.inline.link.exec(Z);if(se){var ne=se[2].trim();if(!this.options.pedantic&&/^</.test(ne)){if(!/>$/.test(ne))return;var N=p(ne.slice(0,-1),"\\");if((ne.length-N.length)%2===0)return}else{var z=I(se[2],"()");if(z>-1){var X=se[0].indexOf("!")===0?5:4,_=X+se[1].length+z;se[2]=se[2].substring(0,z),se[0]=se[0].substring(0,_).trim(),se[3]=""}}var ue=se[2],be="";if(this.options.pedantic){var ke=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ue);ke&&(ue=ke[1],be=ke[3])}else be=se[3]?se[3].slice(1,-1):"";return ue=ue.trim(),/^</.test(ue)&&(this.options.pedantic&&!/>$/.test(ne)?ue=ue.slice(1):ue=ue.slice(1,-1)),G(se,{href:ue&&ue.replace(this.rules.inline._escapes,"$1"),title:be&&be.replace(this.rules.inline._escapes,"$1")},se[0],this.lexer)}},le.reflink=function(Z,se){var ne;if((ne=this.rules.inline.reflink.exec(Z))||(ne=this.rules.inline.nolink.exec(Z))){var N=(ne[2]||ne[1]).replace(/\s+/g," ");if(N=se[N.toLowerCase()],!N||!N.href){var z=ne[0].charAt(0);return{type:"text",raw:z,text:z}}return G(ne,N,ne[0],this.lexer)}},le.emStrong=function(Z,se,ne){ne===void 0&&(ne="");var N=this.rules.inline.emStrong.lDelim.exec(Z);if(!!N&&!(N[3]&&ne.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var z=N[1]||N[2]||"";if(!z||z&&(ne===""||this.rules.inline.punctuation.exec(ne))){var X=N[0].length-1,_,ue,be=X,ke=0,ge=N[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ge.lastIndex=0,se=se.slice(-1*Z.length+X);(N=ge.exec(se))!=null;)if(_=N[1]||N[2]||N[3]||N[4]||N[5]||N[6],!!_){if(ue=_.length,N[3]||N[4]){be+=ue;continue}else if((N[5]||N[6])&&X%3&&!((X+ue)%3)){ke+=ue;continue}if(be-=ue,!(be>0)){if(ue=Math.min(ue,ue+be+ke),Math.min(X,ue)%2){var Pe=Z.slice(1,X+N.index+ue);return{type:"em",raw:Z.slice(0,X+N.index+ue+1),text:Pe,tokens:this.lexer.inlineTokens(Pe)}}var Ie=Z.slice(2,X+N.index+ue-1);return{type:"strong",raw:Z.slice(0,X+N.index+ue+1),text:Ie,tokens:this.lexer.inlineTokens(Ie)}}}}}},le.codespan=function(Z){var se=this.rules.inline.code.exec(Z);if(se){var ne=se[2].replace(/\n/g," "),N=/[^ ]/.test(ne),z=/^ /.test(ne)&&/ $/.test(ne);return N&&z&&(ne=ne.substring(1,ne.length-1)),ne=v(ne,!0),{type:"codespan",raw:se[0],text:ne}}},le.br=function(Z){var se=this.rules.inline.br.exec(Z);if(se)return{type:"br",raw:se[0]}},le.del=function(Z){var se=this.rules.inline.del.exec(Z);if(se)return{type:"del",raw:se[0],text:se[2],tokens:this.lexer.inlineTokens(se[2])}},le.autolink=function(Z,se){var ne=this.rules.inline.autolink.exec(Z);if(ne){var N,z;return ne[2]==="@"?(N=v(this.options.mangle?se(ne[1]):ne[1]),z="mailto:"+N):(N=v(ne[1]),z=N),{type:"link",raw:ne[0],text:N,href:z,tokens:[{type:"text",raw:N,text:N}]}}},le.url=function(Z,se){var ne;if(ne=this.rules.inline.url.exec(Z)){var N,z;if(ne[2]==="@")N=v(this.options.mangle?se(ne[0]):ne[0]),z="mailto:"+N;else{var X;do X=ne[0],ne[0]=this.rules.inline._backpedal.exec(ne[0])[0];while(X!==ne[0]);N=v(ne[0]),ne[1]==="www."?z="http://"+N:z=N}return{type:"link",raw:ne[0],text:N,href:z,tokens:[{type:"text",raw:N,text:N}]}}},le.inlineText=function(Z,se){var ne=this.rules.inline.text.exec(Z);if(ne){var N;return this.lexer.state.inRawBlock?N=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):v(ne[0]):ne[0]:N=v(this.options.smartypants?se(ne[0]):ne[0]),{type:"text",raw:ne[0],text:N}}},re}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:l,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=w(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=w(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=w(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=w(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=w(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=w(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=n({},B),B.gfm=n({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=w(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=w(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=n({},B.normal,{html:w(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:l,paragraph:w(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var F={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:l,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:l,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};F._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",F.punctuation=w(F.punctuation).replace(/punctuation/g,F._punctuation).getRegex(),F.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,F.escapedEmSt=/\\\*|\\_/g,F._comment=w(B._comment).replace("(?:-->|$)","-->").getRegex(),F.emStrong.lDelim=w(F.emStrong.lDelim).replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimAst=w(F.emStrong.rDelimAst,"g").replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimUnd=w(F.emStrong.rDelimUnd,"g").replace(/punct/g,F._punctuation).getRegex(),F._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,F._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,F._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,F.autolink=w(F.autolink).replace("scheme",F._scheme).replace("email",F._email).getRegex(),F._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,F.tag=w(F.tag).replace("comment",F._comment).replace("attribute",F._attribute).getRegex(),F._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,F._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,F._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,F.link=w(F.link).replace("label",F._label).replace("href",F._href).replace("title",F._title).getRegex(),F.reflink=w(F.reflink).replace("label",F._label).replace("ref",B._label).getRegex(),F.nolink=w(F.nolink).replace("ref",B._label).getRegex(),F.reflinkSearch=w(F.reflinkSearch,"g").replace("reflink",F.reflink).replace("nolink",F.nolink).getRegex(),F.normal=n({},F),F.pedantic=n({},F.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:w(/^!?\[(label)\]\((.*?)\)/).replace("label",F._label).getRegex(),reflink:w(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",F._label).getRegex()}),F.gfm=n({},F.normal,{escape:w(F.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),F.gfm.url=w(F.gfm.url,"i").replace("email",F.gfm._extended_email).getRegex(),F.breaks=n({},F.gfm,{br:w(F.br).replace("{2,}","*").getRegex(),text:w(F.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function $(re){return re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function M(re){var le="",fe,Z,se=re.length;for(fe=0;fe<se;fe++)Z=re.charCodeAt(fe),Math.random()>.5&&(Z="x"+Z.toString(16)),le+="&#"+Z+";";return le}var H=function(){function re(fe){this.tokens=[],this.tokens.links=Object.create(null),this.options=fe||te.defaults,this.options.tokenizer=this.options.tokenizer||new O,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:B.normal,inline:F.normal};this.options.pedantic?(Z.block=B.pedantic,Z.inline=F.pedantic):this.options.gfm&&(Z.block=B.gfm,this.options.breaks?Z.inline=F.breaks:Z.inline=F.gfm),this.tokenizer.rules=Z}re.lex=function(Z,se){var ne=new re(se);return ne.lex(Z)},re.lexInline=function(Z,se){var ne=new re(se);return ne.inlineTokens(Z)};var le=re.prototype;return le.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`),this.blockTokens(Z,this.tokens);for(var se;se=this.inlineQueue.shift();)this.inlineTokens(se.src,se.tokens);return this.tokens},le.blockTokens=function(Z,se){var ne=this;se===void 0&&(se=[]),this.options.pedantic?Z=Z.replace(/\t/g,"    ").replace(/^ +$/gm,""):Z=Z.replace(/^( *)(\t+)/gm,function(be,ke,ge){return ke+"    ".repeat(ge.length)});for(var N,z,X,_;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(be){return(N=be.call({lexer:ne},Z,se))?(Z=Z.substring(N.raw.length),se.push(N),!0):!1}))){if(N=this.tokenizer.space(Z)){Z=Z.substring(N.raw.length),N.raw.length===1&&se.length>0?se[se.length-1].raw+=`
`:se.push(N);continue}if(N=this.tokenizer.code(Z)){Z=Z.substring(N.raw.length),z=se[se.length-1],z&&(z.type==="paragraph"||z.type==="text")?(z.raw+=`
`+N.raw,z.text+=`
`+N.text,this.inlineQueue[this.inlineQueue.length-1].src=z.text):se.push(N);continue}if(N=this.tokenizer.fences(Z)){Z=Z.substring(N.raw.length),se.push(N);continue}if(N=this.tokenizer.heading(Z)){Z=Z.substring(N.raw.length),se.push(N);continue}if(N=this.tokenizer.hr(Z)){Z=Z.substring(N.raw.length),se.push(N);continue}if(N=this.tokenizer.blockquote(Z)){Z=Z.substring(N.raw.length),se.push(N);continue}if(N=this.tokenizer.list(Z)){Z=Z.substring(N.raw.length),se.push(N);continue}if(N=this.tokenizer.html(Z)){Z=Z.substring(N.raw.length),se.push(N);continue}if(N=this.tokenizer.def(Z)){Z=Z.substring(N.raw.length),z=se[se.length-1],z&&(z.type==="paragraph"||z.type==="text")?(z.raw+=`
`+N.raw,z.text+=`
`+N.raw,this.inlineQueue[this.inlineQueue.length-1].src=z.text):this.tokens.links[N.tag]||(this.tokens.links[N.tag]={href:N.href,title:N.title});continue}if(N=this.tokenizer.table(Z)){Z=Z.substring(N.raw.length),se.push(N);continue}if(N=this.tokenizer.lheading(Z)){Z=Z.substring(N.raw.length),se.push(N);continue}if(X=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var be=1/0,ke=Z.slice(1),ge=void 0;ne.options.extensions.startBlock.forEach(function(Pe){ge=Pe.call({lexer:this},ke),typeof ge=="number"&&ge>=0&&(be=Math.min(be,ge))}),be<1/0&&be>=0&&(X=Z.substring(0,be+1))}(),this.state.top&&(N=this.tokenizer.paragraph(X))){z=se[se.length-1],_&&z.type==="paragraph"?(z.raw+=`
`+N.raw,z.text+=`
`+N.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=z.text):se.push(N),_=X.length!==Z.length,Z=Z.substring(N.raw.length);continue}if(N=this.tokenizer.text(Z)){Z=Z.substring(N.raw.length),z=se[se.length-1],z&&z.type==="text"?(z.raw+=`
`+N.raw,z.text+=`
`+N.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=z.text):se.push(N);continue}if(Z){var ue="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(ue);break}else throw new Error(ue)}}return this.state.top=!0,se},le.inline=function(Z,se){return se===void 0&&(se=[]),this.inlineQueue.push({src:Z,tokens:se}),se},le.inlineTokens=function(Z,se){var ne=this;se===void 0&&(se=[]);var N,z,X,_=Z,ue,be,ke;if(this.tokens.links){var ge=Object.keys(this.tokens.links);if(ge.length>0)for(;(ue=this.tokenizer.rules.inline.reflinkSearch.exec(_))!=null;)ge.includes(ue[0].slice(ue[0].lastIndexOf("[")+1,-1))&&(_=_.slice(0,ue.index)+"["+U("a",ue[0].length-2)+"]"+_.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ue=this.tokenizer.rules.inline.blockSkip.exec(_))!=null;)_=_.slice(0,ue.index)+"["+U("a",ue[0].length-2)+"]"+_.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ue=this.tokenizer.rules.inline.escapedEmSt.exec(_))!=null;)_=_.slice(0,ue.index)+"++"+_.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(be||(ke=""),be=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ie){return(N=Ie.call({lexer:ne},Z,se))?(Z=Z.substring(N.raw.length),se.push(N),!0):!1}))){if(N=this.tokenizer.escape(Z)){Z=Z.substring(N.raw.length),se.push(N);continue}if(N=this.tokenizer.tag(Z)){Z=Z.substring(N.raw.length),z=se[se.length-1],z&&N.type==="text"&&z.type==="text"?(z.raw+=N.raw,z.text+=N.text):se.push(N);continue}if(N=this.tokenizer.link(Z)){Z=Z.substring(N.raw.length),se.push(N);continue}if(N=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(N.raw.length),z=se[se.length-1],z&&N.type==="text"&&z.type==="text"?(z.raw+=N.raw,z.text+=N.text):se.push(N);continue}if(N=this.tokenizer.emStrong(Z,_,ke)){Z=Z.substring(N.raw.length),se.push(N);continue}if(N=this.tokenizer.codespan(Z)){Z=Z.substring(N.raw.length),se.push(N);continue}if(N=this.tokenizer.br(Z)){Z=Z.substring(N.raw.length),se.push(N);continue}if(N=this.tokenizer.del(Z)){Z=Z.substring(N.raw.length),se.push(N);continue}if(N=this.tokenizer.autolink(Z,M)){Z=Z.substring(N.raw.length),se.push(N);continue}if(!this.state.inLink&&(N=this.tokenizer.url(Z,M))){Z=Z.substring(N.raw.length),se.push(N);continue}if(X=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var Ie=1/0,je=Z.slice(1),qe=void 0;ne.options.extensions.startInline.forEach(function(et){qe=et.call({lexer:this},je),typeof qe=="number"&&qe>=0&&(Ie=Math.min(Ie,qe))}),Ie<1/0&&Ie>=0&&(X=Z.substring(0,Ie+1))}(),N=this.tokenizer.inlineText(X,$)){Z=Z.substring(N.raw.length),N.raw.slice(-1)!=="_"&&(ke=N.raw.slice(-1)),be=!0,z=se[se.length-1],z&&z.type==="text"?(z.raw+=N.raw,z.text+=N.text):se.push(N);continue}if(Z){var Pe="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(Pe);break}else throw new Error(Pe)}}return se},a(re,null,[{key:"rules",get:function(){return{block:B,inline:F}}}]),re}(),K=function(){function re(fe){this.options=fe||te.defaults}var le=re.prototype;return le.code=function(Z,se,ne){var N=(se||"").match(/\S*/)[0];if(this.options.highlight){var z=this.options.highlight(Z,N);z!=null&&z!==Z&&(ne=!0,Z=z)}return Z=Z.replace(/\n$/,"")+`
`,N?'<pre><code class="'+this.options.langPrefix+v(N,!0)+'">'+(ne?Z:v(Z,!0))+`</code></pre>
`:"<pre><code>"+(ne?Z:v(Z,!0))+`</code></pre>
`},le.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},le.html=function(Z){return Z},le.heading=function(Z,se,ne,N){if(this.options.headerIds){var z=this.options.headerPrefix+N.slug(ne);return"<h"+se+' id="'+z+'">'+Z+"</h"+se+`>
`}return"<h"+se+">"+Z+"</h"+se+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(Z,se,ne){var N=se?"ol":"ul",z=se&&ne!==1?' start="'+ne+'"':"";return"<"+N+z+`>
`+Z+"</"+N+`>
`},le.listitem=function(Z){return"<li>"+Z+`</li>
`},le.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(Z){return"<p>"+Z+`</p>
`},le.table=function(Z,se){return se&&(se="<tbody>"+se+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+se+`</table>
`},le.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},le.tablecell=function(Z,se){var ne=se.header?"th":"td",N=se.align?"<"+ne+' align="'+se.align+'">':"<"+ne+">";return N+Z+("</"+ne+`>
`)},le.strong=function(Z){return"<strong>"+Z+"</strong>"},le.em=function(Z){return"<em>"+Z+"</em>"},le.codespan=function(Z){return"<code>"+Z+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(Z){return"<del>"+Z+"</del>"},le.link=function(Z,se,ne){if(Z=b(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ne;var N='<a href="'+v(Z)+'"';return se&&(N+=' title="'+se+'"'),N+=">"+ne+"</a>",N},le.image=function(Z,se,ne){if(Z=b(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ne;var N='<img src="'+Z+'" alt="'+ne+'"';return se&&(N+=' title="'+se+'"'),N+=this.options.xhtml?"/>":">",N},le.text=function(Z){return Z},re}(),q=function(){function re(){}var le=re.prototype;return le.strong=function(Z){return Z},le.em=function(Z){return Z},le.codespan=function(Z){return Z},le.del=function(Z){return Z},le.html=function(Z){return Z},le.text=function(Z){return Z},le.link=function(Z,se,ne){return""+ne},le.image=function(Z,se,ne){return""+ne},le.br=function(){return""},re}(),Y=function(){function re(){this.seen={}}var le=re.prototype;return le.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(Z,se){var ne=Z,N=0;if(this.seen.hasOwnProperty(ne)){N=this.seen[Z];do N++,ne=Z+"-"+N;while(this.seen.hasOwnProperty(ne))}return se||(this.seen[Z]=N,this.seen[ne]=0),ne},le.slug=function(Z,se){se===void 0&&(se={});var ne=this.serialize(Z);return this.getNextSafeSlug(ne,se.dryrun)},re}(),Q=function(){function re(fe){this.options=fe||te.defaults,this.options.renderer=this.options.renderer||new K,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new q,this.slugger=new Y}re.parse=function(Z,se){var ne=new re(se);return ne.parse(Z)},re.parseInline=function(Z,se){var ne=new re(se);return ne.parseInline(Z)};var le=re.prototype;return le.parse=function(Z,se){se===void 0&&(se=!0);var ne="",N,z,X,_,ue,be,ke,ge,Pe,Ie,je,qe,et,_e,nt,st,ht,Ue,it,oe=Z.length;for(N=0;N<oe;N++){if(Ie=Z[N],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ie.type]&&(it=this.options.extensions.renderers[Ie.type].call({parser:this},Ie),it!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ie.type))){ne+=it||"";continue}switch(Ie.type){case"space":continue;case"hr":{ne+=this.renderer.hr();continue}case"heading":{ne+=this.renderer.heading(this.parseInline(Ie.tokens),Ie.depth,g(this.parseInline(Ie.tokens,this.textRenderer)),this.slugger);continue}case"code":{ne+=this.renderer.code(Ie.text,Ie.lang,Ie.escaped);continue}case"table":{for(ge="",ke="",_=Ie.header.length,z=0;z<_;z++)ke+=this.renderer.tablecell(this.parseInline(Ie.header[z].tokens),{header:!0,align:Ie.align[z]});for(ge+=this.renderer.tablerow(ke),Pe="",_=Ie.rows.length,z=0;z<_;z++){for(be=Ie.rows[z],ke="",ue=be.length,X=0;X<ue;X++)ke+=this.renderer.tablecell(this.parseInline(be[X].tokens),{header:!1,align:Ie.align[X]});Pe+=this.renderer.tablerow(ke)}ne+=this.renderer.table(ge,Pe);continue}case"blockquote":{Pe=this.parse(Ie.tokens),ne+=this.renderer.blockquote(Pe);continue}case"list":{for(je=Ie.ordered,qe=Ie.start,et=Ie.loose,_=Ie.items.length,Pe="",z=0;z<_;z++)nt=Ie.items[z],st=nt.checked,ht=nt.task,_e="",nt.task&&(Ue=this.renderer.checkbox(st),et?nt.tokens.length>0&&nt.tokens[0].type==="paragraph"?(nt.tokens[0].text=Ue+" "+nt.tokens[0].text,nt.tokens[0].tokens&&nt.tokens[0].tokens.length>0&&nt.tokens[0].tokens[0].type==="text"&&(nt.tokens[0].tokens[0].text=Ue+" "+nt.tokens[0].tokens[0].text)):nt.tokens.unshift({type:"text",text:Ue}):_e+=Ue),_e+=this.parse(nt.tokens,et),Pe+=this.renderer.listitem(_e,ht,st);ne+=this.renderer.list(Pe,je,qe);continue}case"html":{ne+=this.renderer.html(Ie.text);continue}case"paragraph":{ne+=this.renderer.paragraph(this.parseInline(Ie.tokens));continue}case"text":{for(Pe=Ie.tokens?this.parseInline(Ie.tokens):Ie.text;N+1<oe&&Z[N+1].type==="text";)Ie=Z[++N],Pe+=`
`+(Ie.tokens?this.parseInline(Ie.tokens):Ie.text);ne+=se?this.renderer.paragraph(Pe):Pe;continue}default:{var W='Token with "'+Ie.type+'" type was not found.';if(this.options.silent){console.error(W);return}else throw new Error(W)}}}return ne},le.parseInline=function(Z,se){se=se||this.renderer;var ne="",N,z,X,_=Z.length;for(N=0;N<_;N++){if(z=Z[N],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[z.type]&&(X=this.options.extensions.renderers[z.type].call({parser:this},z),X!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(z.type))){ne+=X||"";continue}switch(z.type){case"escape":{ne+=se.text(z.text);break}case"html":{ne+=se.html(z.text);break}case"link":{ne+=se.link(z.href,z.title,this.parseInline(z.tokens,se));break}case"image":{ne+=se.image(z.href,z.title,z.text);break}case"strong":{ne+=se.strong(this.parseInline(z.tokens,se));break}case"em":{ne+=se.em(this.parseInline(z.tokens,se));break}case"codespan":{ne+=se.codespan(z.text);break}case"br":{ne+=se.br();break}case"del":{ne+=se.del(this.parseInline(z.tokens,se));break}case"text":{ne+=se.text(z.text);break}default:{var ue='Token with "'+z.type+'" type was not found.';if(this.options.silent){console.error(ue);return}else throw new Error(ue)}}}return ne},re}();function ce(re,le,fe){if(typeof re>"u"||re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(re)+", string expected");if(typeof le=="function"&&(fe=le,le=null),le=n({},ce.defaults,le||{}),L(le),fe){var Z=le.highlight,se;try{se=H.lex(re,le)}catch(_){return fe(_)}var ne=function(ue){var be;if(!ue)try{le.walkTokens&&ce.walkTokens(se,le.walkTokens),be=Q.parse(se,le)}catch(ke){ue=ke}return le.highlight=Z,ue?fe(ue):fe(null,be)};if(!Z||Z.length<3||(delete le.highlight,!se.length))return ne();var N=0;ce.walkTokens(se,function(_){_.type==="code"&&(N++,setTimeout(function(){Z(_.text,_.lang,function(ue,be){if(ue)return ne(ue);be!=null&&be!==_.text&&(_.text=be,_.escaped=!0),N--,N===0&&ne()})},0))}),N===0&&ne();return}function z(_){if(_.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+v(_.message+"",!0)+"</pre>";throw _}try{var X=H.lex(re,le);if(le.walkTokens){if(le.async)return Promise.all(ce.walkTokens(X,le.walkTokens)).then(function(){return Q.parse(X,le)}).catch(z);ce.walkTokens(X,le.walkTokens)}return Q.parse(X,le)}catch(_){z(_)}}ce.options=ce.setOptions=function(re){return n(ce.defaults,re),T(ce.defaults),ce},ce.getDefaults=D,ce.defaults=te.defaults,ce.use=function(){for(var re=arguments.length,le=new Array(re),fe=0;fe<re;fe++)le[fe]=arguments[fe];var Z=n.apply(void 0,[{}].concat(le)),se=ce.defaults.extensions||{renderers:{},childTokens:{}},ne;le.forEach(function(N){if(N.extensions&&(ne=!0,N.extensions.forEach(function(X){if(!X.name)throw new Error("extension name required");if(X.renderer){var _=se.renderers?se.renderers[X.name]:null;_?se.renderers[X.name]=function(){for(var ue=arguments.length,be=new Array(ue),ke=0;ke<ue;ke++)be[ke]=arguments[ke];var ge=X.renderer.apply(this,be);return ge===!1&&(ge=_.apply(this,be)),ge}:se.renderers[X.name]=X.renderer}if(X.tokenizer){if(!X.level||X.level!=="block"&&X.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");se[X.level]?se[X.level].unshift(X.tokenizer):se[X.level]=[X.tokenizer],X.start&&(X.level==="block"?se.startBlock?se.startBlock.push(X.start):se.startBlock=[X.start]:X.level==="inline"&&(se.startInline?se.startInline.push(X.start):se.startInline=[X.start]))}X.childTokens&&(se.childTokens[X.name]=X.childTokens)})),N.renderer&&function(){var X=ce.defaults.renderer||new K,_=function(ke){var ge=X[ke];X[ke]=function(){for(var Pe=arguments.length,Ie=new Array(Pe),je=0;je<Pe;je++)Ie[je]=arguments[je];var qe=N.renderer[ke].apply(X,Ie);return qe===!1&&(qe=ge.apply(X,Ie)),qe}};for(var ue in N.renderer)_(ue);Z.renderer=X}(),N.tokenizer&&function(){var X=ce.defaults.tokenizer||new O,_=function(ke){var ge=X[ke];X[ke]=function(){for(var Pe=arguments.length,Ie=new Array(Pe),je=0;je<Pe;je++)Ie[je]=arguments[je];var qe=N.tokenizer[ke].apply(X,Ie);return qe===!1&&(qe=ge.apply(X,Ie)),qe}};for(var ue in N.tokenizer)_(ue);Z.tokenizer=X}(),N.walkTokens){var z=ce.defaults.walkTokens;Z.walkTokens=function(X){var _=[];return _.push(N.walkTokens.call(this,X)),z&&(_=_.concat(z.call(this,X))),_}}ne&&(Z.extensions=se),ce.setOptions(Z)})},ce.walkTokens=function(re,le){for(var fe=[],Z=function(){var z=ne.value;switch(fe=fe.concat(le.call(ce,z)),z.type){case"table":{for(var X=A(z.header),_;!(_=X()).done;){var ue=_.value;fe=fe.concat(ce.walkTokens(ue.tokens,le))}for(var be=A(z.rows),ke;!(ke=be()).done;)for(var ge=ke.value,Pe=A(ge),Ie;!(Ie=Pe()).done;){var je=Ie.value;fe=fe.concat(ce.walkTokens(je.tokens,le))}break}case"list":{fe=fe.concat(ce.walkTokens(z.items,le));break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[z.type]?ce.defaults.extensions.childTokens[z.type].forEach(function(qe){fe=fe.concat(ce.walkTokens(z[qe],le))}):z.tokens&&(fe=fe.concat(ce.walkTokens(z.tokens,le)))}},se=A(re),ne;!(ne=se()).done;)Z();return fe},ce.parseInline=function(re,le){if(typeof re>"u"||re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(re)+", string expected");le=n({},ce.defaults,le||{}),L(le);try{var fe=H.lexInline(re,le);return le.walkTokens&&ce.walkTokens(fe,le.walkTokens),Q.parseInline(fe,le)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+v(Z.message+"",!0)+"</pre>";throw Z}},ce.Parser=Q,ce.parser=Q.parse,ce.Renderer=K,ce.TextRenderer=q,ce.Lexer=H,ce.lexer=H.lex,ce.Tokenizer=O,ce.Slugger=Y,ce.parse=ce;var ie=ce.options,de=ce.setOptions,J=ce.use,pe=ce.walkTokens,ve=ce.parseInline,De=ce,Re=Q.parse,$e=H.lex;te.Lexer=H,te.Parser=Q,te.Renderer=K,te.Slugger=Y,te.TextRenderer=q,te.Tokenizer=O,te.getDefaults=D,te.lexer=$e,te.marked=ce,te.options=ie,te.parse=De,te.parseInline=ve,te.parser=Re,te.setOptions=de,te.use=J,te.walkTokens=pe,Object.defineProperty(te,"__esModule",{value:!0})}),define(Se[81],ye([1,0,28]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new a.LRUCache(1e4);function k(C){return S(C,"NFC",t)}e.normalizeNFC=k;const A=new a.LRUCache(1e4);function D(C){return S(C,"NFD",A)}e.normalizeNFD=D;const T=/[^\u0000-\u0080]/;function S(C,R,P){if(!C)return C;const E=P.get(C);if(E)return E;let y;return T.test(C)?y=C.normalize(R):y=C,P.set(C,y),y}e.removeAccents=function(){const C=/[\u0300-\u036f]/g;return function(R){return D(R).replace(C,"")}}()}),define(Se[100],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function a(T,S,C){return Math.min(Math.max(T,S),C)}e.clamp=a;function t(T,S){return(S+T%S)%S}e.rot=t;class k{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=k;class A{constructor(){this.a=1,this.b=0}update(S){return this.b=this.b+(S-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=A;class D{constructor(S){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(S),this.c.fill(0,0,S)}update(S){const C=this.c[this.d];return this.c[this.d]=S,this.d=(this.d+1)%this.c.length,this.e-=C,this.e+=S,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=D}),function(){function te(k){const A=[];typeof k=="number"&&A.push("code/timeOrigin",k);function D(S){A.push(S,Date.now())}function T(){const S=[];for(let C=0;C<A.length;C+=2)S.push({name:A[C],startTime:A[C+1]});return S}return{mark:D,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const D of performance.getEntriesByType("mark"))A.push({name:D.name,startTime:Math.round(k+D.startTime)});return A}};if(typeof process=="object"){const k=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function a(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return a(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=a(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=a(t))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var a=e();for(var t in a)(typeof exports=="object"?exports:te)[t]=a[t]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function a(t){if(e[t])return e[t].exports;var k=e[t]={i:t,l:!1,exports:{}};return te[t].call(k.exports,k,k.exports,a),k.l=!0,k.exports}return a.m=te,a.c=e,a.d=function(t,k,A){a.o(t,k)||Object.defineProperty(t,k,{enumerable:!0,get:A})},a.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},a.t=function(t,k){if(1&k&&(t=a(t)),8&k||4&k&&typeof t=="object"&&t&&t.__esModule)return t;var A=Object.create(null);if(a.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:t}),2&k&&typeof t!="string")for(var D in t)a.d(A,D,function(T){return t[T]}.bind(null,D));return A},a.n=function(t){var k=t&&t.__esModule?function(){return t.default}:function(){return t};return a.d(k,"a",k),k},a.o=function(t,k){return Object.prototype.hasOwnProperty.call(t,k)},a.p="",a(a.s=0)}([function(te,e,a){(function(t){var k;e=te.exports=J,k=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var ge=Array.prototype.slice.call(arguments,0);ge.unshift("SEMVER"),console.log.apply(console,ge)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],S=e.src=[],C=0,R=C++;S[R]="0|[1-9]\\d*";var P=C++;S[P]="[0-9]+";var E=C++;S[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=C++;S[y]="("+S[R]+")\\.("+S[R]+")\\.("+S[R]+")";var v=C++;S[v]="("+S[P]+")\\.("+S[P]+")\\.("+S[P]+")";var d=C++;S[d]="(?:"+S[R]+"|"+S[E]+")";var g=C++;S[g]="(?:"+S[P]+"|"+S[E]+")";var h=C++;S[h]="(?:-("+S[d]+"(?:\\."+S[d]+")*))";var w=C++;S[w]="(?:-?("+S[g]+"(?:\\."+S[g]+")*))";var m=C++;S[m]="[0-9A-Za-z-]+";var f=C++;S[f]="(?:\\+("+S[m]+"(?:\\."+S[m]+")*))";var b=C++,s="v?"+S[y]+S[h]+"?"+S[f]+"?";S[b]="^"+s+"$";var o="[v=\\s]*"+S[v]+S[w]+"?"+S[f]+"?",c=C++;S[c]="^"+o+"$";var u=C++;S[u]="((?:<|>)?=?)";var r=C++;S[r]=S[P]+"|x|X|\\*";var l=C++;S[l]=S[R]+"|x|X|\\*";var n=C++;S[n]="[v=\\s]*("+S[l]+")(?:\\.("+S[l]+")(?:\\.("+S[l]+")(?:"+S[h]+")?"+S[f]+"?)?)?";var i=C++;S[i]="[v=\\s]*("+S[r]+")(?:\\.("+S[r]+")(?:\\.("+S[r]+")(?:"+S[w]+")?"+S[f]+"?)?)?";var p=C++;S[p]="^"+S[u]+"\\s*"+S[n]+"$";var I=C++;S[I]="^"+S[u]+"\\s*"+S[i]+"$";var L=C++;S[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=C++;S[U]="(?:~>?)";var G=C++;S[G]="(\\s*)"+S[U]+"\\s+",T[G]=new RegExp(S[G],"g");var V=C++;S[V]="^"+S[U]+S[n]+"$";var O=C++;S[O]="^"+S[U]+S[i]+"$";var B=C++;S[B]="(?:\\^)";var F=C++;S[F]="(\\s*)"+S[B]+"\\s+",T[F]=new RegExp(S[F],"g");var $=C++;S[$]="^"+S[B]+S[n]+"$";var M=C++;S[M]="^"+S[B]+S[i]+"$";var H=C++;S[H]="^"+S[u]+"\\s*("+o+")$|^$";var K=C++;S[K]="^"+S[u]+"\\s*("+s+")$|^$";var q=C++;S[q]="(\\s*)"+S[u]+"\\s*("+o+"|"+S[n]+")",T[q]=new RegExp(S[q],"g");var Y=C++;S[Y]="^\\s*("+S[n]+")\\s+-\\s+("+S[n]+")\\s*$";var Q=C++;S[Q]="^\\s*("+S[i]+")\\s+-\\s+("+S[i]+")\\s*$";var ce=C++;S[ce]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)k(ie,S[ie]),T[ie]||(T[ie]=new RegExp(S[ie]));function de(ge,Pe){if(ge instanceof J)return ge;if(typeof ge!="string"||ge.length>A||!(Pe?T[c]:T[b]).test(ge))return null;try{return new J(ge,Pe)}catch{return null}}function J(ge,Pe){if(ge instanceof J){if(ge.loose===Pe)return ge;ge=ge.version}else if(typeof ge!="string")throw new TypeError("Invalid Version: "+ge);if(ge.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof J))return new J(ge,Pe);k("SemVer",ge,Pe),this.loose=Pe;var Ie=ge.trim().match(Pe?T[c]:T[b]);if(!Ie)throw new TypeError("Invalid Version: "+ge);if(this.raw=ge,this.major=+Ie[1],this.minor=+Ie[2],this.patch=+Ie[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");Ie[4]?this.prerelease=Ie[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var qe=+je;if(qe>=0&&qe<D)return qe}return je}):this.prerelease=[],this.build=Ie[5]?Ie[5].split("."):[],this.format()}e.parse=de,e.valid=function(ge,Pe){var Ie=de(ge,Pe);return Ie?Ie.version:null},e.clean=function(ge,Pe){var Ie=de(ge.trim().replace(/^[=v]+/,""),Pe);return Ie?Ie.version:null},e.SemVer=J,J.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},J.prototype.toString=function(){return this.version},J.prototype.compare=function(ge){return k("SemVer.compare",this.version,this.loose,ge),ge instanceof J||(ge=new J(ge,this.loose)),this.compareMain(ge)||this.comparePre(ge)},J.prototype.compareMain=function(ge){return ge instanceof J||(ge=new J(ge,this.loose)),ve(this.major,ge.major)||ve(this.minor,ge.minor)||ve(this.patch,ge.patch)},J.prototype.comparePre=function(ge){if(ge instanceof J||(ge=new J(ge,this.loose)),this.prerelease.length&&!ge.prerelease.length)return-1;if(!this.prerelease.length&&ge.prerelease.length)return 1;if(!this.prerelease.length&&!ge.prerelease.length)return 0;var Pe=0;do{var Ie=this.prerelease[Pe],je=ge.prerelease[Pe];if(k("prerelease compare",Pe,Ie,je),Ie===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(Ie===void 0)return-1;if(Ie!==je)return ve(Ie,je)}while(++Pe)},J.prototype.inc=function(ge,Pe){switch(ge){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Pe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Pe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Pe),this.inc("pre",Pe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Pe),this.inc("pre",Pe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ie=this.prerelease.length;--Ie>=0;)typeof this.prerelease[Ie]=="number"&&(this.prerelease[Ie]++,Ie=-2);Ie===-1&&this.prerelease.push(0)}Pe&&(this.prerelease[0]===Pe?isNaN(this.prerelease[1])&&(this.prerelease=[Pe,0]):this.prerelease=[Pe,0]);break;default:throw new Error("invalid increment argument: "+ge)}return this.format(),this.raw=this.version,this},e.inc=function(ge,Pe,Ie,je){typeof Ie=="string"&&(je=Ie,Ie=void 0);try{return new J(ge,Ie).inc(Pe,je).version}catch{return null}},e.diff=function(ge,Pe){if(re(ge,Pe))return null;var Ie=de(ge),je=de(Pe);if(Ie.prerelease.length||je.prerelease.length){for(var qe in Ie)if((qe==="major"||qe==="minor"||qe==="patch")&&Ie[qe]!==je[qe])return"pre"+qe;return"prerelease"}for(var qe in Ie)if((qe==="major"||qe==="minor"||qe==="patch")&&Ie[qe]!==je[qe])return qe},e.compareIdentifiers=ve;var pe=/^[0-9]+$/;function ve(ge,Pe){var Ie=pe.test(ge),je=pe.test(Pe);return Ie&&je&&(ge=+ge,Pe=+Pe),Ie&&!je?-1:je&&!Ie?1:ge<Pe?-1:ge>Pe?1:0}function De(ge,Pe,Ie){return new J(ge,Ie).compare(new J(Pe,Ie))}function Re(ge,Pe,Ie){return De(ge,Pe,Ie)>0}function $e(ge,Pe,Ie){return De(ge,Pe,Ie)<0}function re(ge,Pe,Ie){return De(ge,Pe,Ie)===0}function le(ge,Pe,Ie){return De(ge,Pe,Ie)!==0}function fe(ge,Pe,Ie){return De(ge,Pe,Ie)>=0}function Z(ge,Pe,Ie){return De(ge,Pe,Ie)<=0}function se(ge,Pe,Ie,je){var qe;switch(Pe){case"===":typeof ge=="object"&&(ge=ge.version),typeof Ie=="object"&&(Ie=Ie.version),qe=ge===Ie;break;case"!==":typeof ge=="object"&&(ge=ge.version),typeof Ie=="object"&&(Ie=Ie.version),qe=ge!==Ie;break;case"":case"=":case"==":qe=re(ge,Ie,je);break;case"!=":qe=le(ge,Ie,je);break;case">":qe=Re(ge,Ie,je);break;case">=":qe=fe(ge,Ie,je);break;case"<":qe=$e(ge,Ie,je);break;case"<=":qe=Z(ge,Ie,je);break;default:throw new TypeError("Invalid operator: "+Pe)}return qe}function ne(ge,Pe){if(ge instanceof ne){if(ge.loose===Pe)return ge;ge=ge.value}if(!(this instanceof ne))return new ne(ge,Pe);k("comparator",ge,Pe),this.loose=Pe,this.parse(ge),this.semver===N?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(ge,Pe){return ve(Pe,ge)},e.major=function(ge,Pe){return new J(ge,Pe).major},e.minor=function(ge,Pe){return new J(ge,Pe).minor},e.patch=function(ge,Pe){return new J(ge,Pe).patch},e.compare=De,e.compareLoose=function(ge,Pe){return De(ge,Pe,!0)},e.rcompare=function(ge,Pe,Ie){return De(Pe,ge,Ie)},e.sort=function(ge,Pe){return ge.sort(function(Ie,je){return e.compare(Ie,je,Pe)})},e.rsort=function(ge,Pe){return ge.sort(function(Ie,je){return e.rcompare(Ie,je,Pe)})},e.gt=Re,e.lt=$e,e.eq=re,e.neq=le,e.gte=fe,e.lte=Z,e.cmp=se,e.Comparator=ne;var N={};function z(ge,Pe){if(ge instanceof z)return ge.loose===Pe?ge:new z(ge.raw,Pe);if(ge instanceof ne)return new z(ge.value,Pe);if(!(this instanceof z))return new z(ge,Pe);if(this.loose=Pe,this.raw=ge,this.set=ge.split(/\s*\|\|\s*/).map(function(Ie){return this.parseRange(Ie.trim())},this).filter(function(Ie){return Ie.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ge);this.format()}function X(ge){return!ge||ge.toLowerCase()==="x"||ge==="*"}function _(ge,Pe,Ie,je,qe,et,_e,nt,st,ht,Ue,it,oe){return((Pe=X(Ie)?"":X(je)?">="+Ie+".0.0":X(qe)?">="+Ie+"."+je+".0":">="+Pe)+" "+(nt=X(st)?"":X(ht)?"<"+(+st+1)+".0.0":X(Ue)?"<"+st+"."+(+ht+1)+".0":it?"<="+st+"."+ht+"."+Ue+"-"+it:"<="+nt)).trim()}function ue(ge,Pe){for(var Ie=0;Ie<ge.length;Ie++)if(!ge[Ie].test(Pe))return!1;if(Pe.prerelease.length){for(Ie=0;Ie<ge.length;Ie++)if(k(ge[Ie].semver),ge[Ie].semver!==N&&ge[Ie].semver.prerelease.length>0){var je=ge[Ie].semver;if(je.major===Pe.major&&je.minor===Pe.minor&&je.patch===Pe.patch)return!0}return!1}return!0}function be(ge,Pe,Ie){try{Pe=new z(Pe,Ie)}catch{return!1}return Pe.test(ge)}function ke(ge,Pe,Ie,je){var qe,et,_e,nt,st;switch(ge=new J(ge,je),Pe=new z(Pe,je),Ie){case">":qe=Re,et=Z,_e=$e,nt=">",st=">=";break;case"<":qe=$e,et=fe,_e=Re,nt="<",st="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(be(ge,Pe,je))return!1;for(var ht=0;ht<Pe.set.length;++ht){var Ue=Pe.set[ht],it=null,oe=null;if(Ue.forEach(function(W){W.semver===N&&(W=new ne(">=0.0.0")),it=it||W,oe=oe||W,qe(W.semver,it.semver,je)?it=W:_e(W.semver,oe.semver,je)&&(oe=W)}),it.operator===nt||it.operator===st||(!oe.operator||oe.operator===nt)&&et(ge,oe.semver)||oe.operator===st&&_e(ge,oe.semver))return!1}return!0}ne.prototype.parse=function(ge){var Pe=this.loose?T[H]:T[K],Ie=ge.match(Pe);if(!Ie)throw new TypeError("Invalid comparator: "+ge);this.operator=Ie[1],this.operator==="="&&(this.operator=""),Ie[2]?this.semver=new J(Ie[2],this.loose):this.semver=N},ne.prototype.toString=function(){return this.value},ne.prototype.test=function(ge){return k("Comparator.test",ge,this.loose),this.semver===N||(typeof ge=="string"&&(ge=new J(ge,this.loose)),se(ge,this.operator,this.semver,this.loose))},ne.prototype.intersects=function(ge,Pe){if(!(ge instanceof ne))throw new TypeError("a Comparator is required");var Ie;if(this.operator==="")return Ie=new z(ge.value,Pe),be(this.value,Ie,Pe);if(ge.operator==="")return Ie=new z(this.value,Pe),be(ge.semver,Ie,Pe);var je=!(this.operator!==">="&&this.operator!==">"||ge.operator!==">="&&ge.operator!==">"),qe=!(this.operator!=="<="&&this.operator!=="<"||ge.operator!=="<="&&ge.operator!=="<"),et=this.semver.version===ge.semver.version,_e=!(this.operator!==">="&&this.operator!=="<="||ge.operator!==">="&&ge.operator!=="<="),nt=se(this.semver,"<",ge.semver,Pe)&&(this.operator===">="||this.operator===">")&&(ge.operator==="<="||ge.operator==="<"),st=se(this.semver,">",ge.semver,Pe)&&(this.operator==="<="||this.operator==="<")&&(ge.operator===">="||ge.operator===">");return je||qe||et&&_e||nt||st},e.Range=z,z.prototype.format=function(){return this.range=this.set.map(function(ge){return ge.join(" ").trim()}).join("||").trim(),this.range},z.prototype.toString=function(){return this.range},z.prototype.parseRange=function(ge){var Pe=this.loose;ge=ge.trim(),k("range",ge,Pe);var Ie=Pe?T[Q]:T[Y];ge=ge.replace(Ie,_),k("hyphen replace",ge),ge=ge.replace(T[q],"$1$2$3"),k("comparator trim",ge,T[q]),ge=(ge=(ge=ge.replace(T[G],"$1~")).replace(T[F],"$1^")).split(/\s+/).join(" ");var je=Pe?T[H]:T[K],qe=ge.split(" ").map(function(et){return function(_e,nt){return k("comp",_e),_e=function(st,ht){return st.trim().split(/\s+/).map(function(Ue){return function(it,oe){k("caret",it,oe);var W=oe?T[M]:T[$];return it.replace(W,function(ae,Ce,Le,Be,Xe){var Ze;return k("caret",it,ae,Ce,Le,Be,Xe),X(Ce)?Ze="":X(Le)?Ze=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":X(Be)?Ze=Ce==="0"?">="+Ce+"."+Le+".0 <"+Ce+"."+(+Le+1)+".0":">="+Ce+"."+Le+".0 <"+(+Ce+1)+".0.0":Xe?(k("replaceCaret pr",Xe),Xe.charAt(0)!=="-"&&(Xe="-"+Xe),Ze=Ce==="0"?Le==="0"?">="+Ce+"."+Le+"."+Be+Xe+" <"+Ce+"."+Le+"."+(+Be+1):">="+Ce+"."+Le+"."+Be+Xe+" <"+Ce+"."+(+Le+1)+".0":">="+Ce+"."+Le+"."+Be+Xe+" <"+(+Ce+1)+".0.0"):(k("no pr"),Ze=Ce==="0"?Le==="0"?">="+Ce+"."+Le+"."+Be+" <"+Ce+"."+Le+"."+(+Be+1):">="+Ce+"."+Le+"."+Be+" <"+Ce+"."+(+Le+1)+".0":">="+Ce+"."+Le+"."+Be+" <"+(+Ce+1)+".0.0"),k("caret return",Ze),Ze})}(Ue,ht)}).join(" ")}(_e,nt),k("caret",_e),_e=function(st,ht){return st.trim().split(/\s+/).map(function(Ue){return function(it,oe){var W=oe?T[O]:T[V];return it.replace(W,function(ae,Ce,Le,Be,Xe){var Ze;return k("tilde",it,ae,Ce,Le,Be,Xe),X(Ce)?Ze="":X(Le)?Ze=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":X(Be)?Ze=">="+Ce+"."+Le+".0 <"+Ce+"."+(+Le+1)+".0":Xe?(k("replaceTilde pr",Xe),Xe.charAt(0)!=="-"&&(Xe="-"+Xe),Ze=">="+Ce+"."+Le+"."+Be+Xe+" <"+Ce+"."+(+Le+1)+".0"):Ze=">="+Ce+"."+Le+"."+Be+" <"+Ce+"."+(+Le+1)+".0",k("tilde return",Ze),Ze})}(Ue,ht)}).join(" ")}(_e,nt),k("tildes",_e),_e=function(st,ht){return k("replaceXRanges",st,ht),st.split(/\s+/).map(function(Ue){return function(it,oe){it=it.trim();var W=oe?T[I]:T[p];return it.replace(W,function(ae,Ce,Le,Be,Xe,Ze){k("xRange",it,ae,Ce,Le,Be,Xe,Ze);var ft=X(Le),mt=ft||X(Be),lt=mt||X(Xe);return Ce==="="&&lt&&(Ce=""),ft?ae=Ce===">"||Ce==="<"?"<0.0.0":"*":Ce&&lt?(mt&&(Be=0),lt&&(Xe=0),Ce===">"?(Ce=">=",mt?(Le=+Le+1,Be=0,Xe=0):lt&&(Be=+Be+1,Xe=0)):Ce==="<="&&(Ce="<",mt?Le=+Le+1:Be=+Be+1),ae=Ce+Le+"."+Be+"."+Xe):mt?ae=">="+Le+".0.0 <"+(+Le+1)+".0.0":lt&&(ae=">="+Le+"."+Be+".0 <"+Le+"."+(+Be+1)+".0"),k("xRange return",ae),ae})}(Ue,ht)}).join(" ")}(_e,nt),k("xrange",_e),_e=function(st,ht){return k("replaceStars",st,ht),st.trim().replace(T[ce],"")}(_e,nt),k("stars",_e),_e}(et,Pe)}).join(" ").split(/\s+/);return this.loose&&(qe=qe.filter(function(et){return!!et.match(je)})),qe=qe.map(function(et){return new ne(et,Pe)})},z.prototype.intersects=function(ge,Pe){if(!(ge instanceof z))throw new TypeError("a Range is required");return this.set.some(function(Ie){return Ie.every(function(je){return ge.set.some(function(qe){return qe.every(function(et){return je.intersects(et,Pe)})})})})},e.toComparators=function(ge,Pe){return new z(ge,Pe).set.map(function(Ie){return Ie.map(function(je){return je.value}).join(" ").trim().split(" ")})},z.prototype.test=function(ge){if(!ge)return!1;typeof ge=="string"&&(ge=new J(ge,this.loose));for(var Pe=0;Pe<this.set.length;Pe++)if(ue(this.set[Pe],ge))return!0;return!1},e.satisfies=be,e.maxSatisfying=function(ge,Pe,Ie){var je=null,qe=null;try{var et=new z(Pe,Ie)}catch{return null}return ge.forEach(function(_e){et.test(_e)&&(je&&qe.compare(_e)!==-1||(qe=new J(je=_e,Ie)))}),je},e.minSatisfying=function(ge,Pe,Ie){var je=null,qe=null;try{var et=new z(Pe,Ie)}catch{return null}return ge.forEach(function(_e){et.test(_e)&&(je&&qe.compare(_e)!==1||(qe=new J(je=_e,Ie)))}),je},e.validRange=function(ge,Pe){try{return new z(ge,Pe).range||"*"}catch{return null}},e.ltr=function(ge,Pe,Ie){return ke(ge,Pe,"<",Ie)},e.gtr=function(ge,Pe,Ie){return ke(ge,Pe,">",Ie)},e.outside=ke,e.prerelease=function(ge,Pe){var Ie=de(ge,Pe);return Ie&&Ie.prerelease.length?Ie.prerelease:null},e.intersects=function(ge,Pe,Ie){return ge=new z(ge,Ie),Pe=new z(Pe,Ie),ge.intersects(Pe)},e.coerce=function(ge){if(ge instanceof J)return ge;if(typeof ge!="string")return null;var Pe=ge.match(T[L]);return Pe==null?null:de((Pe[1]||"0")+"."+(Pe[2]||"0")+"."+(Pe[3]||"0"))}}).call(this,a(1))},function(te,e){var a,t,k=te.exports={};function A(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function T(g){if(a===setTimeout)return setTimeout(g,0);if((a===A||!a)&&setTimeout)return a=setTimeout,setTimeout(g,0);try{return a(g,0)}catch{try{return a.call(null,g,0)}catch{return a.call(this,g,0)}}}(function(){try{a=typeof setTimeout=="function"?setTimeout:A}catch{a=A}try{t=typeof clearTimeout=="function"?clearTimeout:D}catch{t=D}})();var S,C=[],R=!1,P=-1;function E(){R&&S&&(R=!1,S.length?C=S.concat(C):P=-1,C.length&&y())}function y(){if(!R){var g=T(E);R=!0;for(var h=C.length;h;){for(S=C,C=[];++P<h;)S&&S[P].run();P=-1,h=C.length}S=null,R=!1,function(w){if(t===clearTimeout)return clearTimeout(w);if((t===D||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(w);try{t(w)}catch{try{return t.call(null,w)}catch{return t.call(this,w)}}}(g)}}function v(g,h){this.fun=g,this.array=h}function d(){}k.nextTick=function(g){var h=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)h[w-1]=arguments[w];C.push(new v(g,h)),C.length!==1||R||T(y)},v.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=d,k.addListener=d,k.once=d,k.off=d,k.removeListener=d,k.removeAllListeners=d,k.emit=d,k.prependListener=d,k.prependOnceListener=d,k.listeners=function(g){return[]},k.binding=function(g){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(g){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(Se[101],ye([1,0,10,6]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(f){const b=f;return b?typeof b.read=="function":!1}e.isReadable=k;function A(f){const b=f;return b?[b.on,b.pause,b.resume,b.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=A;function D(f){const b=f;return b?A(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}e.isReadableBufferedStream=D;function T(f,b){return new S(f,b)}e.newWriteableStream=T;class S{constructor(b,s){this.e=b,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(b){if(!this.a.destroyed){if(this.a.flowing)this.g(b);else if(this.b.data.push(b),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(b){this.a.destroyed||(this.a.flowing?this.h(b):this.b.error.push(b))}end(b){this.a.destroyed||(typeof b<"u"&&this.write(b),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(b){this.c.data.slice(0).forEach(s=>s(b))}h(b){this.c.error.length===0?(0,a.onUnexpectedError)(b):this.c.error.slice(0).forEach(s=>s(b))}i(){this.c.end.slice(0).forEach(b=>b())}on(b,s){if(!this.a.destroyed)switch(b){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(b,s){if(this.a.destroyed)return;let o;switch(b){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const c=o.indexOf(s);c>=0&&o.splice(c,1)}}j(){if(this.b.data.length>0){const b=this.e(this.b.data);this.g(b),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const b of this.b.error)this.h(b);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function C(f,b){const s=[];let o;for(;(o=f.read())!==null;)s.push(o);return b(s)}e.consumeReadable=C;function R(f,b,s){const o=[];let c;for(;(c=f.read())!==null&&o.length<s;)o.push(c);return c===null&&o.length>0?b(o):{read:()=>{if(o.length>0)return o.shift();if(typeof c<"u"){const u=c;return c=void 0,u}return f.read()}}}e.peekReadable=R;function P(f,b){return new Promise((s,o)=>{const c=[];E(f,{onData:u=>{b&&c.push(u)},onError:u=>{b?o(u):s(void 0)},onEnd:()=>{s(b?b(c):void 0)}})})}e.consumeStream=P;function E(f,b){let s=!1;return f.on("error",o=>{s||b.onError(o)}),f.on("end",()=>{s||b.onEnd()}),f.on("data",o=>{s||b.onData(o)}),(0,t.toDisposable)(()=>s=!0)}e.listenStream=E;function y(f,b){return new Promise((s,o)=>{const c=new t.DisposableStore,u=[],r=i=>{if(u.push(i),u.length>b)return c.dispose(),f.pause(),s({stream:f,buffer:u,ended:!1})},l=i=>o(i),n=()=>s({stream:f,buffer:u,ended:!0});c.add((0,t.toDisposable)(()=>f.removeListener("error",l))),f.on("error",l),c.add((0,t.toDisposable)(()=>f.removeListener("end",n))),f.on("end",n),c.add((0,t.toDisposable)(()=>f.removeListener("data",r))),f.on("data",r)})}e.peekStream=y;function v(f,b){const s=T(b);return s.end(f),s}e.toStream=v;function d(){const f=T(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=d;function g(f){let b=!1;return{read:()=>b?null:(b=!0,f)}}e.toReadable=g;function h(f,b,s){const o=T(s);return E(f,{onData:c=>o.write(b.data(c)),onError:c=>o.error(b.error?b.error(c):c),onEnd:()=>o.end()}),o}e.transform=h;function w(f,b,s){let o=!1;return{read:()=>{const c=b.read();return o?c:(o=!0,c!==null?s([f,c]):f)}}}e.prefixedReadable=w;function m(f,b,s){let o=!1;const c=T(s);return E(b,{onData:u=>o?c.write(u):(o=!0,c.write(s([f,u]))),onError:u=>c.error(u),onEnd:()=>{o||(o=!0,c.write(f)),c.end()}}),c}e.prefixedStream=m}),define(Se[22],ye([1,0,101]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let k,A;class D{static alloc(i){return t?new D(Buffer.allocUnsafe(i)):new D(new Uint8Array(i))}static wrap(i){return t&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new D(i)}static fromString(i,p){return!(p?.dontUseNodeBuffer||!1)&&t?new D(Buffer.from(i)):(k||(k=new TextEncoder),new D(k.encode(i)))}static fromByteArray(i){const p=D.alloc(i.length);for(let I=0,L=i.length;I<L;I++)p.buffer[I]=i[I];return p}static concat(i,p){if(typeof p>"u"){p=0;for(let U=0,G=i.length;U<G;U++)p+=i[U].byteLength}const I=D.alloc(p);let L=0;for(let U=0,G=i.length;U<G;U++){const V=i[U];I.set(V,L),L+=V.byteLength}return I}constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}clone(){const i=D.alloc(this.byteLength);return i.set(this),i}toString(){return t?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(i,p){return new D(this.buffer.subarray(i,p))}set(i,p){if(i instanceof D)this.buffer.set(i.buffer,p);else if(i instanceof Uint8Array)this.buffer.set(i,p);else if(i instanceof ArrayBuffer)this.buffer.set(new Uint8Array(i),p);else if(ArrayBuffer.isView(i))this.buffer.set(new Uint8Array(i.buffer,i.byteOffset,i.byteLength),p);else throw new Error("Unknown argument 'array'")}readUInt32BE(i){return C(this.buffer,i)}writeUInt32BE(i,p){R(this.buffer,i,p)}readUInt32LE(i){return P(this.buffer,i)}writeUInt32LE(i,p){E(this.buffer,i,p)}readUInt8(i){return y(this.buffer,i)}writeUInt8(i,p){v(this.buffer,i,p)}}e.VSBuffer=D;function T(n,i){return n[i+0]<<0>>>0|n[i+1]<<8>>>0}e.readUInt16LE=T;function S(n,i,p){n[p+0]=i&255,i=i>>>8,n[p+1]=i&255}e.writeUInt16LE=S;function C(n,i){return n[i]*2**24+n[i+1]*2**16+n[i+2]*2**8+n[i+3]}e.readUInt32BE=C;function R(n,i,p){n[p+3]=i,i=i>>>8,n[p+2]=i,i=i>>>8,n[p+1]=i,i=i>>>8,n[p]=i}e.writeUInt32BE=R;function P(n,i){return n[i+0]<<0>>>0|n[i+1]<<8>>>0|n[i+2]<<16>>>0|n[i+3]<<24>>>0}e.readUInt32LE=P;function E(n,i,p){n[p+0]=i&255,i=i>>>8,n[p+1]=i&255,i=i>>>8,n[p+2]=i&255,i=i>>>8,n[p+3]=i&255}e.writeUInt32LE=E;function y(n,i){return n[i]}e.readUInt8=y;function v(n,i,p){n[p]=i}e.writeUInt8=v;function d(n){return a.consumeReadable(n,i=>D.concat(i))}e.readableToBuffer=d;function g(n){return a.toReadable(n)}e.bufferToReadable=g;function h(n){return a.consumeStream(n,i=>D.concat(i))}e.streamToBuffer=h;async function w(n){return n.ended?D.concat(n.buffer):D.concat([...n.buffer,await h(n.stream)])}e.bufferedStreamToBuffer=w;function m(n){return a.toStream(n,i=>D.concat(i))}e.bufferToStream=m;function f(n){return a.transform(n,{data:i=>typeof i=="string"?D.fromString(i):D.wrap(i)},i=>D.concat(i))}e.streamToBufferReadableStream=f;function b(n){return a.newWriteableStream(i=>D.concat(i),n)}e.newWriteableBufferStream=b;function s(n,i){return a.prefixedReadable(n,i,p=>D.concat(p))}e.prefixedBufferReadable=s;function o(n,i){return a.prefixedStream(n,i,p=>D.concat(p))}e.prefixedBufferStream=o;function c(n){let i=0,p=0,I=0;const L=new Uint8Array(Math.floor(n.length/4*3)),U=V=>{switch(p){case 3:L[I++]=i|V,p=0;break;case 2:L[I++]=i|V>>>2,i=V<<6,p=3;break;case 1:L[I++]=i|V>>>4,i=V<<4,p=2;break;default:i=V<<2,p=1}};for(let V=0;V<n.length;V++){const O=n.charCodeAt(V);if(O>=65&&O<=90)U(O-65);else if(O>=97&&O<=122)U(O-97+26);else if(O>=48&&O<=57)U(O-48+52);else if(O===43||O===45)U(62);else if(O===47||O===95)U(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${n[V]}`)}}const G=I;for(;p>0;)U(0);return D.wrap(L).slice(0,G)}e.decodeBase64=c;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:n},i=!0,p=!1){const I=p?r:u;let L="";const U=n.byteLength%3;let G=0;for(;G<n.byteLength-U;G+=3){const V=n[G+0],O=n[G+1],B=n[G+2];L+=I[V>>>2],L+=I[(V<<4|O>>>4)&63],L+=I[(O<<2|B>>>6)&63],L+=I[B&63]}if(U===1){const V=n[G+0];L+=I[V>>>2],L+=I[V<<4&63],i&&(L+="==")}else if(U===2){const V=n[G+0],O=n[G+1];L+=I[V>>>2],L+=I[(V<<4|O>>>4)&63],L+=I[O<<2&63],i&&(L+="=")}return L}e.encodeBase64=l}),define(Se[11],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function a(o){return typeof o=="string"}e.isString=a;function t(o){return Array.isArray(o)&&o.every(c=>a(c))}e.isStringArray=t;function k(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=k;function A(o){const c=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof c}e.isTypedArray=A;function D(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=D;function T(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=T;function S(o){return o===!0||o===!1}e.isBoolean=S;function C(o){return typeof o>"u"}e.isUndefined=C;function R(o){return!P(o)}e.isDefined=R;function P(o){return C(o)||o===null}e.isUndefinedOrNull=P;function E(o,c){if(!o)throw new Error(c?`Unexpected type, expected '${c}'`:"Unexpected type")}e.assertType=E;function y(o){if(P(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=y;function v(...o){const c=[];for(let u=0;u<o.length;u++){const r=o[u];if(P(r))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);c.push(r)}return c}e.assertAllDefined=v;const d=Object.prototype.hasOwnProperty;function g(o){if(!k(o))return!1;for(const c in o)if(d.call(o,c))return!1;return!0}e.isEmptyObject=g;function h(o){return typeof o=="function"}e.isFunction=h;function w(...o){return o.length>0&&o.every(h)}e.areFunctions=w;function m(o,c){const u=Math.min(o.length,c.length);for(let r=0;r<u;r++)f(o[r],c[r])}e.validateConstraints=m;function f(o,c){if(a(c)){if(typeof o!==c)throw new Error(`argument does not match constraint: typeof ${c}`)}else if(h(c)){try{if(o instanceof c)return}catch{}if(!P(o)&&o.constructor===c||c.length===1&&c.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=f;function b(o){return o===null?void 0:o}e.withNullAsUndefined=b;function s(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=s}),define(Se[23],ye([1,0,11]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const w=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([m,f])=>{w[m]=f&&typeof f=="object"?t(f):f}),w}e.deepClone=t;function k(h){if(!h||typeof h!="object")return h;const w=[h];for(;w.length>0;){const m=w.shift();Object.freeze(m);for(const f in m)if(A.call(m,f)){const b=m[f];typeof b=="object"&&!Object.isFrozen(b)&&!(0,a.isTypedArray)(b)&&w.push(b)}}return h}e.deepFreeze=k;const A=Object.prototype.hasOwnProperty;function D(h,w){return T(h,w,new Set)}e.cloneAndChange=D;function T(h,w,m){if((0,a.isUndefinedOrNull)(h))return h;const f=w(h);if(typeof f<"u")return f;if(Array.isArray(h)){const b=[];for(const s of h)b.push(T(s,w,m));return b}if((0,a.isObject)(h)){if(m.has(h))throw new Error("Cannot clone recursive data-structure");m.add(h);const b={};for(const s in h)A.call(h,s)&&(b[s]=T(h[s],w,m));return m.delete(h),b}return h}function S(h,w,m=!0){return(0,a.isObject)(h)?((0,a.isObject)(w)&&Object.keys(w).forEach(f=>{f in h?m&&((0,a.isObject)(h[f])&&(0,a.isObject)(w[f])?S(h[f],w[f],m):h[f]=w[f]):h[f]=w[f]}),h):w}e.mixin=S;function C(h,w){if(h===w)return!0;if(h==null||w===null||w===void 0||typeof h!=typeof w||typeof h!="object"||Array.isArray(h)!==Array.isArray(w))return!1;let m,f;if(Array.isArray(h)){if(h.length!==w.length)return!1;for(m=0;m<h.length;m++)if(!C(h[m],w[m]))return!1}else{const b=[];for(f in h)b.push(f);b.sort();const s=[];for(f in w)s.push(f);if(s.sort(),!C(b,s))return!1;for(m=0;m<b.length;m++)if(!C(h[b[m]],w[b[m]]))return!1}return!0}e.equals=C;function R(h){const w=new Set;return JSON.stringify(h,(m,f)=>{if((0,a.isObject)(f)||Array.isArray(f)){if(w.has(f))return"[Circular]";w.add(f)}return f})}e.safeStringify=R;function P(h,w){const m=Object.create(null);return!h||!w||Object.keys(w).forEach(b=>{const s=h[b],o=w[b];C(s,o)||(m[b]=o)}),m}e.distinct=P;function E(h,w){const m=w.toLowerCase(),f=Object.keys(h).find(b=>b.toLowerCase()===m);return f?h[f]:h[w]}e.getCaseInsensitive=E;function y(h,w){const m=Object.create(null);for(const[f,b]of Object.entries(h))w(f,b)&&(m[f]=b);return m}e.filter=y;function v(h){let w=[],m=Object.getPrototypeOf(h);for(;Object.prototype!==m;)w=w.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return w}e.getAllPropertyNames=v;function d(h){const w=[];for(const m of v(h))typeof h[m]=="function"&&w.push(m);return w}e.getAllMethodNames=d;function g(h,w){const m=b=>function(){const s=Array.prototype.slice.call(arguments,0);return w(b,s)},f={};for(const b of h)f[b]=m(b);return f}e.createProxyObject=g}),define(Se[102],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var a;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(a=e.Constants||(e.Constants={}));function t(A){return A<0?0:A>255?255:A|0}e.toUint8=t;function k(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=k}),define(Se[30],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const a=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(k){return a.test(k)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(T){for(let S=0;S<T.length;S++)T[S]=Math.floor(Math.random()*256);return T};const A=new Uint8Array(16),D=[];for(let T=0;T<256;T++)D.push(T.toString(16).padStart(2,"0"));return function(){k(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let S=0,C="";return C+=D[A[S++]],C+=D[A[S++]],C+=D[A[S++]],C+=D[A[S++]],C+="-",C+=D[A[S++]],C+=D[A[S++]],C+="-",C+=D[A[S++]],C+=D[A[S++]],C+="-",C+=D[A[S++]],C+=D[A[S++]],C+="-",C+=D[A[S++]],C+=D[A[S++]],C+=D[A[S++]],C+=D[A[S++]],C+=D[A[S++]],C+=D[A[S++]],C}}()}),define(Se[147],ye([1,0,17,30]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function k(T){return{id:(0,t.generateUuid)(),asString:async()=>T,asFile:()=>{},value:typeof T=="string"?T:void 0}}e.createStringDataTransferItem=k;function A(T,S,C){return{id:(0,t.generateUuid)(),asString:async()=>"",asFile:()=>({name:T,uri:S,data:C}),value:void 0}}e.createFileDataTransferItem=A;class D{constructor(){this.a=new Map}get size(){return this.a.size}has(S){return this.a.has(this.b(S))}get(S){return this.a.get(this.b(S))?.[0]}append(S,C){const R=this.a.get(S);R?R.push(C):this.a.set(this.b(S),[C])}replace(S,C){this.a.set(this.b(S),[C])}delete(S){this.a.delete(this.b(S))}*entries(){for(const[S,C]of this.a.entries())for(const R of C)yield[S,R]}values(){return Array.from(this.a.values()).flat()}forEach(S){for(const[C,R]of this.entries())S(R,C)}b(S){return S.toLowerCase()}}e.VSDataTransfer=D,e.UriList=Object.freeze({create:T=>(0,a.distinct)(T.map(S=>S.toString())).join(`\r
`),split:T=>T.split(`\r
`),parse:T=>e.UriList.split(T).filter(S=>!S.startsWith("#"))})}),define(Se[103],ye([1,0,102]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(T){const S=(0,a.toUint8)(T);this.c=S,this.a=t.d(S),this.b=new Map}static d(T){const S=new Uint8Array(256);return S.fill(T),S}set(T,S){const C=(0,a.toUint8)(S);T>=0&&T<256?this.a[T]=C:this.b.set(T,C)}get(T){return T>=0&&T<256?this.a[T]:this.b.get(T)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.CharacterClassifier=t;var k;(function(D){D[D.False=0]="False",D[D.True=1]="True"})(k||(k={}));class A{constructor(){this.a=new t(0)}add(T){this.a.set(T,1)}has(T){return this.a.get(T)===1}clear(){return this.a.clear()}}e.CharacterSet=A}),define(Se[49],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class a{constructor(k,A){this.lineNumber=k,this.column=A}with(k=this.lineNumber,A=this.column){return k===this.lineNumber&&A===this.column?this:new a(k,A)}delta(k=0,A=0){return this.with(this.lineNumber+k,this.column+A)}equals(k){return a.equals(this,k)}static equals(k,A){return!k&&!A?!0:!!k&&!!A&&k.lineNumber===A.lineNumber&&k.column===A.column}isBefore(k){return a.isBefore(this,k)}static isBefore(k,A){return k.lineNumber<A.lineNumber?!0:A.lineNumber<k.lineNumber?!1:k.column<A.column}isBeforeOrEqual(k){return a.isBeforeOrEqual(this,k)}static isBeforeOrEqual(k,A){return k.lineNumber<A.lineNumber?!0:A.lineNumber<k.lineNumber?!1:k.column<=A.column}static compare(k,A){const D=k.lineNumber|0,T=A.lineNumber|0;if(D===T){const S=k.column|0,C=A.column|0;return S-C}return D-T}clone(){return new a(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(k){return new a(k.lineNumber,k.column)}static isIPosition(k){return k&&typeof k.lineNumber=="number"&&typeof k.column=="number"}}e.Position=a}),define(Se[35],ye([1,0,49]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(A,D,T,S){A>T||A===T&&D>S?(this.startLineNumber=T,this.startColumn=S,this.endLineNumber=A,this.endColumn=D):(this.startLineNumber=A,this.startColumn=D,this.endLineNumber=T,this.endColumn=S)}isEmpty(){return t.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return t.containsPosition(this,A)}static containsPosition(A,D){return!(D.lineNumber<A.startLineNumber||D.lineNumber>A.endLineNumber||D.lineNumber===A.startLineNumber&&D.column<A.startColumn||D.lineNumber===A.endLineNumber&&D.column>A.endColumn)}static strictContainsPosition(A,D){return!(D.lineNumber<A.startLineNumber||D.lineNumber>A.endLineNumber||D.lineNumber===A.startLineNumber&&D.column<=A.startColumn||D.lineNumber===A.endLineNumber&&D.column>=A.endColumn)}containsRange(A){return t.containsRange(this,A)}static containsRange(A,D){return!(D.startLineNumber<A.startLineNumber||D.endLineNumber<A.startLineNumber||D.startLineNumber>A.endLineNumber||D.endLineNumber>A.endLineNumber||D.startLineNumber===A.startLineNumber&&D.startColumn<A.startColumn||D.endLineNumber===A.endLineNumber&&D.endColumn>A.endColumn)}strictContainsRange(A){return t.strictContainsRange(this,A)}static strictContainsRange(A,D){return!(D.startLineNumber<A.startLineNumber||D.endLineNumber<A.startLineNumber||D.startLineNumber>A.endLineNumber||D.endLineNumber>A.endLineNumber||D.startLineNumber===A.startLineNumber&&D.startColumn<=A.startColumn||D.endLineNumber===A.endLineNumber&&D.endColumn>=A.endColumn)}plusRange(A){return t.plusRange(this,A)}static plusRange(A,D){let T,S,C,R;return D.startLineNumber<A.startLineNumber?(T=D.startLineNumber,S=D.startColumn):D.startLineNumber===A.startLineNumber?(T=D.startLineNumber,S=Math.min(D.startColumn,A.startColumn)):(T=A.startLineNumber,S=A.startColumn),D.endLineNumber>A.endLineNumber?(C=D.endLineNumber,R=D.endColumn):D.endLineNumber===A.endLineNumber?(C=D.endLineNumber,R=Math.max(D.endColumn,A.endColumn)):(C=A.endLineNumber,R=A.endColumn),new t(T,S,C,R)}intersectRanges(A){return t.intersectRanges(this,A)}static intersectRanges(A,D){let T=A.startLineNumber,S=A.startColumn,C=A.endLineNumber,R=A.endColumn;const P=D.startLineNumber,E=D.startColumn,y=D.endLineNumber,v=D.endColumn;return T<P?(T=P,S=E):T===P&&(S=Math.max(S,E)),C>y?(C=y,R=v):C===y&&(R=Math.min(R,v)),T>C||T===C&&S>R?null:new t(T,S,C,R)}equalsRange(A){return t.equalsRange(this,A)}static equalsRange(A,D){return!A&&!D?!0:!!A&&!!D&&A.startLineNumber===D.startLineNumber&&A.startColumn===D.startColumn&&A.endLineNumber===D.endLineNumber&&A.endColumn===D.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(A){return new a.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(A){return new a.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,D){return new t(this.startLineNumber,this.startColumn,A,D)}setStartPosition(A,D){return new t(A,D,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}delta(A){return new t(this.startLineNumber+A,this.startColumn,this.endLineNumber+A,this.endColumn)}static collapseToStart(A){return new t(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}static fromPositions(A,D=A){return new t(A.lineNumber,A.column,D.lineNumber,D.column)}static lift(A){return A?new t(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,D){return!(A.endLineNumber<D.startLineNumber||A.endLineNumber===D.startLineNumber&&A.endColumn<D.startColumn||D.endLineNumber<A.startLineNumber||D.endLineNumber===A.startLineNumber&&D.endColumn<A.startColumn)}static areIntersecting(A,D){return!(A.endLineNumber<D.startLineNumber||A.endLineNumber===D.startLineNumber&&A.endColumn<=D.startColumn||D.endLineNumber<A.startLineNumber||D.endLineNumber===A.startLineNumber&&D.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,D){if(A&&D){const C=A.startLineNumber|0,R=D.startLineNumber|0;if(C===R){const P=A.startColumn|0,E=D.startColumn|0;if(P===E){const y=A.endLineNumber|0,v=D.endLineNumber|0;if(y===v){const d=A.endColumn|0,g=D.endColumn|0;return d-g}return y-v}return P-E}return C-R}return(A?1:0)-(D?1:0)}static compareRangesUsingEnds(A,D){return A.endLineNumber===D.endLineNumber?A.endColumn===D.endColumn?A.startLineNumber===D.startLineNumber?A.startColumn-D.startColumn:A.startLineNumber-D.startLineNumber:A.endColumn-D.endColumn:A.endLineNumber-D.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.Range=t}),define(Se[148],ye([1,0,49,35]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var k;(function(D){D[D.LTR=0]="LTR",D[D.RTL=1]="RTL"})(k=e.SelectionDirection||(e.SelectionDirection={}));class A extends t.Range{constructor(T,S,C,R){super(T,S,C,R),this.selectionStartLineNumber=T,this.selectionStartColumn=S,this.positionLineNumber=C,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(T){return A.selectionsEqual(this,T)}static selectionsEqual(T,S){return T.selectionStartLineNumber===S.selectionStartLineNumber&&T.selectionStartColumn===S.selectionStartColumn&&T.positionLineNumber===S.positionLineNumber&&T.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(T,S){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,T,S):new A(T,S,this.startLineNumber,this.startColumn)}getPosition(){return new a.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new a.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(T,S){return this.getDirection()===0?new A(T,S,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,T,S)}static fromPositions(T,S=T){return new A(T.lineNumber,T.column,S.lineNumber,S.column)}static fromRange(T,S){return S===0?new A(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):new A(T.endLineNumber,T.endColumn,T.startLineNumber,T.startColumn)}static liftSelection(T){return new A(T.selectionStartLineNumber,T.selectionStartColumn,T.positionLineNumber,T.positionColumn)}static selectionsArrEqual(T,S){if(T&&!S||!T&&S)return!1;if(!T&&!S)return!0;if(T.length!==S.length)return!1;for(let C=0,R=T.length;C<R;C++)if(!this.selectionsEqual(T[C],S[C]))return!1;return!0}static isISelection(T){return T&&typeof T.selectionStartLineNumber=="number"&&typeof T.selectionStartColumn=="number"&&typeof T.positionLineNumber=="number"&&typeof T.positionColumn=="number"}static createWithDirection(T,S,C,R,P){return P===0?new A(T,S,C,R):new A(C,R,T,S)}}e.Selection=A}),define(Se[149],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[150],ye([1,0,103]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(D){D[D.Regular=0]="Regular",D[D.Whitespace=1]="Whitespace",D[D.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class k extends a.CharacterClassifier{constructor(T){super(0);for(let S=0,C=T.length;S<C;S++)this.set(T.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=k;function A(D){const T={};return S=>(T.hasOwnProperty(S)||(T[S]=D(S)),T[S])}e.getMapForWordSeparators=A(D=>new k(D))}),define(Se[104],ye([1,0,62,6,63]),function(te,e,a,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(P=""){let E="(-?\\d*\\.\\d\\w*)|([^";for(const y of e.USUAL_WORD_SEPARATORS)P.indexOf(y)>=0||(E+="\\"+y);return E+="\\s]+)",new RegExp(E,"g")}e.DEFAULT_WORD_REGEXP=A();function D(P){let E=e.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)E=P;else{let y="g";P.ignoreCase&&(y+="i"),P.multiline&&(y+="m"),P.unicode&&(y+="u"),E=new RegExp(P.source,y)}return E.lastIndex=0,E}e.ensureValidWordDefinition=D;const T=new k.LinkedList;T.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function S(P){const E=T.unshift(P);return(0,t.toDisposable)(E)}e.setDefaultGetWordAtTextConfig=S;function C(P,E,y,v,d){if(d||(d=a.Iterable.first(T)),y.length>d.maxLen){let f=P-d.maxLen/2;return f<0?f=0:v+=f,y=y.substring(f,P+d.maxLen/2),C(P,E,y,v,d)}const g=Date.now(),h=P-1-v;let w=-1,m=null;for(let f=1;!(Date.now()-g>=d.timeBudget);f++){const b=h-d.windowSize*f;E.lastIndex=Math.max(0,b);const s=R(E,y,h,w);if(!s&&m||(m=s,b<=0))break;w=b}if(m){const f={word:m[0],startColumn:v+1+m.index,endColumn:v+1+m.index+m[0].length};return E.lastIndex=0,f}return null}e.getWordAtText=C;function R(P,E,y,v){let d;for(;d=P.exec(E);){const g=d.index||0;if(g<=y&&P.lastIndex>=y)return d;if(v>0&&g>v)return null}return null}}),define(Se[151],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var a;(function(D){D[D.None=0]="None",D[D.Indent=1]="Indent",D[D.IndentOutdent=2]="IndentOutdent",D[D.Outdent=3]="Outdent"})(a=e.IndentAction||(e.IndentAction={}));class t{constructor(T){if(this.e=null,this.f=!1,this.open=T.open,this.close=T.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(T.notIn))for(let S=0,C=T.notIn.length;S<C;S++)switch(T.notIn[S]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(T){switch(T){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(T,S){if(T.getTokenCount()===0)return!0;const C=T.findTokenIndexAtOffset(S-2),R=T.getStandardTokenType(C);return this.isOK(R)}g(T,S){for(let C=T;C<=S;C++){const R=String.fromCharCode(C);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=t;class k{constructor(T){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of T)A(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),A(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),A(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),A(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&A(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=k;function A(D,T,S){D.has(T)?D.get(T).push(S):D.set(T,[S])}}),define(Se[152],ye([1,0,103]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var t;(function(y){y[y.Invalid=0]="Invalid",y[y.Start=1]="Start",y[y.H=2]="H",y[y.HT=3]="HT",y[y.HTT=4]="HTT",y[y.HTTP=5]="HTTP",y[y.F=6]="F",y[y.FI=7]="FI",y[y.FIL=8]="FIL",y[y.BeforeColon=9]="BeforeColon",y[y.AfterColon=10]="AfterColon",y[y.AlmostThere=11]="AlmostThere",y[y.End=12]="End",y[y.Accept=13]="Accept",y[y.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class k{constructor(v,d,g){const h=new Uint8Array(v*d);for(let w=0,m=v*d;w<m;w++)h[w]=g;this.a=h,this.rows=v,this.cols=d}get(v,d){return this.a[v*this.cols+d]}set(v,d,g){this.a[v*this.cols+d]=g}}class A{constructor(v){let d=0,g=0;for(let w=0,m=v.length;w<m;w++){const[f,b,s]=v[w];b>d&&(d=b),f>g&&(g=f),s>g&&(g=s)}d++,g++;const h=new k(g,d,0);for(let w=0,m=v.length;w<m;w++){const[f,b,s]=v[w];h.set(f,b,s)}this.a=h,this.b=d}nextState(v,d){return d<0||d>=this.b?0:this.a.get(v,d)}}e.StateMachine=A;let D=null;function T(){return D===null&&(D=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),D}var S;(function(y){y[y.None=0]="None",y[y.ForceTermination=1]="ForceTermination",y[y.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let C=null;function R(){if(C===null){C=new a.CharacterClassifier(0);const y=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<y.length;d++)C.set(y.charCodeAt(d),1);const v=".,;:";for(let d=0;d<v.length;d++)C.set(v.charCodeAt(d),2)}return C}class P{static a(v,d,g,h,w){let m=w-1;do{const f=d.charCodeAt(m);if(v.get(f)!==2)break;m--}while(m>h);if(h>0){const f=d.charCodeAt(h-1),b=d.charCodeAt(m);(f===40&&b===41||f===91&&b===93||f===123&&b===125)&&m--}return{range:{startLineNumber:g,startColumn:h+1,endLineNumber:g,endColumn:m+2},url:d.substring(h,m+1)}}static computeLinks(v,d=T()){const g=R(),h=[];for(let w=1,m=v.getLineCount();w<=m;w++){const f=v.getLineContent(w),b=f.length;let s=0,o=0,c=0,u=1,r=!1,l=!1,n=!1,i=!1;for(;s<b;){let p=!1;const I=f.charCodeAt(s);if(u===13){let L;switch(I){case 40:r=!0,L=0;break;case 41:L=r?0:1;break;case 91:n=!0,l=!0,L=0;break;case 93:n=!1,L=l?0:1;break;case 123:i=!0,L=0;break;case 125:L=i?0:1;break;case 39:case 34:case 96:c===I?L=1:c===39||c===34||c===96?L=0:L=1;break;case 42:L=c===42?1:0;break;case 124:L=c===124?1:0;break;case 32:L=n?0:1;break;default:L=g.get(I)}L===1&&(h.push(P.a(g,f,w,o,s)),p=!0)}else if(u===12){let L;I===91?(l=!0,L=0):L=g.get(I),L===1?p=!0:u=13}else u=d.nextState(u,I),u===0&&(p=!0);p&&(u=1,r=!1,l=!1,i=!1,o=s+1,c=I),s++}u===13&&h.push(P.a(g,f,w,o,b))}return h}}e.LinkComputer=P;function E(y){return!y||typeof y.getLineCount!="function"||typeof y.getLineContent!="function"?[]:P.computeLinks(y)}e.computeLinks=E}),define(Se[105],ye([1,0,23]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(m){m[m.Left=1]="Left",m[m.Center=2]="Center",m[m.Right=4]="Right",m[m.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var k;(function(m){m[m.Inline=1]="Inline",m[m.Gutter=2]="Gutter"})(k=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(m){m[m.Both=0]="Both",m[m.Right=1]="Right",m[m.Left=2]="Left",m[m.None=3]="None"})(A=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var D;(function(m){m[m.TextDefined=0]="TextDefined",m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(D=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(m){m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(m){m[m.LF=0]="LF",m[m.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{constructor(f){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,f.tabSize|0),this.indentSize=Math.max(1,f.indentSize|0),this.insertSpaces=Boolean(f.insertSpaces),this.defaultEOL=f.defaultEOL|0,this.trimAutoWhitespace=Boolean(f.trimAutoWhitespace),this.bracketPairColorizationOptions=f.bracketPairColorizationOptions}equals(f){return this.tabSize===f.tabSize&&this.indentSize===f.indentSize&&this.insertSpaces===f.insertSpaces&&this.defaultEOL===f.defaultEOL&&this.trimAutoWhitespace===f.trimAutoWhitespace&&(0,a.equals)(this.bracketPairColorizationOptions,f.bracketPairColorizationOptions)}createChangeEvent(f){return{tabSize:this.tabSize!==f.tabSize,indentSize:this.indentSize!==f.indentSize,insertSpaces:this.insertSpaces!==f.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==f.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class R{constructor(f,b){this._findMatchBrand=void 0,this.range=f,this.matches=b}}e.FindMatch=R;var P;(function(m){m[m.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",m[m.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",m[m.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",m[m.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function E(m){return m&&typeof m.read=="function"}e.isITextSnapshot=E;var y;(function(m){m[m.Left=0]="Left",m[m.Right=1]="Right",m[m.None=2]="None",m[m.LeftOfInjectedText=3]="LeftOfInjectedText",m[m.RightOfInjectedText=4]="RightOfInjectedText"})(y=e.PositionAffinity||(e.PositionAffinity={}));var v;(function(m){m[m.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(v=e.ModelConstants||(e.ModelConstants={}));class d{constructor(f,b,s,o,c,u){this.identifier=f,this.range=b,this.text=s,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=c,this._isTracked=u}}e.ValidAnnotatedEditOperation=d;class g{constructor(f,b,s){this.regex=f,this.wordSeparators=b,this.simpleSearch=s}}e.SearchData=g;class h{constructor(f,b,s){this.reverseEdits=f,this.changes=b,this.trimAutoWhitespaceLineNumbers=s}}e.ApplyEditsResult=h;function w(m){return!m.isTooLargeForSyncing()&&!m.isForSimpleWidget}e.shouldSynchronizeModel=w}),define(Se[153],ye([1,0,17,102]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class k{constructor(S){this.a=S,this.b=new Uint32Array(S.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(S,C){S=(0,t.toUint32)(S);const R=this.a,P=this.b,E=C.length;return E===0?!1:(this.a=new Uint32Array(R.length+E),this.a.set(R.subarray(0,S),0),this.a.set(R.subarray(S),S+E),this.a.set(C,S),S-1<this.c[0]&&(this.c[0]=S-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}setValue(S,C){return S=(0,t.toUint32)(S),C=(0,t.toUint32)(C),this.a[S]===C?!1:(this.a[S]=C,S-1<this.c[0]&&(this.c[0]=S-1),!0)}removeValues(S,C){S=(0,t.toUint32)(S),C=(0,t.toUint32)(C);const R=this.a,P=this.b;if(S>=R.length)return!1;const E=R.length-S;return C>=E&&(C=E),C===0?!1:(this.a=new Uint32Array(R.length-C),this.a.set(R.subarray(0,S),0),this.a.set(R.subarray(S+C),S),this.b=new Uint32Array(this.a.length),S-1<this.c[0]&&(this.c[0]=S-1),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(S){return S<0?0:(S=(0,t.toUint32)(S),this.d(S))}d(S){if(S<=this.c[0])return this.b[S];let C=this.c[0]+1;C===0&&(this.b[0]=this.a[0],C++),S>=this.a.length&&(S=this.a.length-1);for(let R=C;R<=S;R++)this.b[R]=this.b[R-1]+this.a[R];return this.c[0]=Math.max(this.c[0],S),this.b[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let C=0,R=this.a.length-1,P=0,E=0,y=0;for(;C<=R;)if(P=C+(R-C)/2|0,E=this.b[P],y=E-this.a[P],S<y)R=P-1;else if(S>=E)C=P+1;else break;return new D(P,S-y)}}e.PrefixSumComputer=k;class A{constructor(S){this.a=S,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(S){return this.g(),S===0?0:this.d[S-1]}getIndexOf(S){this.g();const C=this.e[S],R=C>0?this.d[C-1]:0;return new D(C,S-R)}removeValues(S,C){this.a.splice(S,C),this.f(S)}insertValues(S,C){this.a=(0,a.arrayInsert)(this.a,S,C),this.f(S)}f(S){this.b=!1,this.c=Math.min(this.c,S-1)}g(){if(!this.b){for(let S=this.c+1,C=this.a.length;S<C;S++){const R=this.a[S],P=S>0?this.d[S-1]:0;this.d[S]=P+R;for(let E=0;E<R;E++)this.e[P+E]=S}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(S,C){this.a[S]!==C&&(this.a[S]=C,this.f(S))}}e.ConstantTimePrefixSumComputer=A;class D{constructor(S,C){this.index=S,this.remainder=C,this._prefixSumIndexOfResultBrand=void 0,this.index=S,this.remainder=C}}e.PrefixSumIndexOfResult=D}),define(Se[154],ye([19,20]),function(te,e){return te.create("vs/base/common/date",e)}),define(Se[155],ye([1,0,154]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,k=t*60,A=k*24,D=A*7,T=A*30,S=A*365;function C(P,E,y){typeof P!="number"&&(P=P.getTime());const v=Math.round((new Date().getTime()-P)/1e3);if(v<-30)return(0,a.localize)(0,null,C(new Date().getTime()+v*1e3,!1));if(v<30)return(0,a.localize)(1,null);let d;return v<t?(d=v,E?d===1?y?(0,a.localize)(2,null,d):(0,a.localize)(3,null,d):y?(0,a.localize)(4,null,d):(0,a.localize)(5,null,d):d===1?y?(0,a.localize)(6,null,d):(0,a.localize)(7,null,d):y?(0,a.localize)(8,null,d):(0,a.localize)(9,null,d)):v<k?(d=Math.floor(v/t),E?d===1?y?(0,a.localize)(10,null,d):(0,a.localize)(11,null,d):y?(0,a.localize)(12,null,d):(0,a.localize)(13,null,d):d===1?y?(0,a.localize)(14,null,d):(0,a.localize)(15,null,d):y?(0,a.localize)(16,null,d):(0,a.localize)(17,null,d)):v<A?(d=Math.floor(v/k),E?d===1?y?(0,a.localize)(18,null,d):(0,a.localize)(19,null,d):y?(0,a.localize)(20,null,d):(0,a.localize)(21,null,d):d===1?y?(0,a.localize)(22,null,d):(0,a.localize)(23,null,d):y?(0,a.localize)(24,null,d):(0,a.localize)(25,null,d)):v<D?(d=Math.floor(v/A),E?d===1?(0,a.localize)(26,null,d):(0,a.localize)(27,null,d):d===1?(0,a.localize)(28,null,d):(0,a.localize)(29,null,d)):v<T?(d=Math.floor(v/D),E?d===1?y?(0,a.localize)(30,null,d):(0,a.localize)(31,null,d):y?(0,a.localize)(32,null,d):(0,a.localize)(33,null,d):d===1?y?(0,a.localize)(34,null,d):(0,a.localize)(35,null,d):y?(0,a.localize)(36,null,d):(0,a.localize)(37,null,d)):v<S?(d=Math.floor(v/T),E?d===1?y?(0,a.localize)(38,null,d):(0,a.localize)(39,null,d):y?(0,a.localize)(40,null,d):(0,a.localize)(41,null,d):d===1?y?(0,a.localize)(42,null,d):(0,a.localize)(43,null,d):y?(0,a.localize)(44,null,d):(0,a.localize)(45,null,d)):(d=Math.floor(v/S),E?d===1?y?(0,a.localize)(46,null,d):(0,a.localize)(47,null,d):y?(0,a.localize)(48,null,d):(0,a.localize)(49,null,d):d===1?y?(0,a.localize)(50,null,d):(0,a.localize)(51,null,d):y?(0,a.localize)(52,null,d):(0,a.localize)(53,null,d))}e.fromNow=C;function R(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(Se[156],ye([19,20]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(Se[50],ye([1,0,17,11,156]),function(te,e,a,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(P,E){return E&&(P.stack||P.stacktrace)?k.localize(0,null,T(P),D(P.stack)||D(P.stacktrace)):T(P)}function D(P){return Array.isArray(P)?P.join(`
`):P}function T(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?k.localize(1,null,P.message):P.message||k.localize(2,null)}function S(P=null,E=!1){if(!P)return k.localize(3,null);if(Array.isArray(P)){const y=a.coalesce(P),v=S(y[0],E);return y.length>1?k.localize(4,null,v,y.length):v}if(t.isString(P))return P;if(P.detail){const y=P.detail;if(y.error)return A(y.error,E);if(y.exception)return A(y.exception,E)}return P.stack?A(P,E):P.message?P.message:k.localize(5,null)}e.toErrorMessage=S;function C(P){const E=P;return E instanceof Error&&Array.isArray(E.actions)}e.isErrorWithActions=C;function R(P,E){let y;return typeof P=="string"?y=new Error(P):y=P,y.actions=E,y}e.createErrorWithActions=R}),define(Se[157],ye([19,20]),function(te,e){return te.create("vs/base/common/platform",e)}),define(Se[12],ye([1,0,157]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,k=!1,A=!1,D=!1,T=!1,S=!1,C=!1,R=!1,P=!1,E=!1,y,v=e.LANGUAGE_DEFAULT,d,g;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?h=e.globals.vscode.process:typeof process<"u"&&(h=process);const w=typeof h?.versions?.electron=="string",m=w&&h?.type==="renderer";if(typeof navigator=="object"&&!m)g=navigator.userAgent,t=g.indexOf("Windows")>=0,k=g.indexOf("Macintosh")>=0,R=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=g.indexOf("Linux")>=0,E=g?.indexOf("Mobi")>=0,S=!0,y=a.getConfiguredDefaultLocale(a.localize(0,null))||e.LANGUAGE_DEFAULT,v=y;else if(typeof h=="object"){t=h.platform==="win32",k=h.platform==="darwin",A=h.platform==="linux",D=A&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,C=w,P=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=e.LANGUAGE_DEFAULT,v=e.LANGUAGE_DEFAULT;const n=h.env.VSCODE_NLS_CONFIG;if(n)try{const i=JSON.parse(n),p=i.availableLanguages["*"];y=i.locale,v=p||e.LANGUAGE_DEFAULT,d=i._translationsConfigFile}catch{}T=!0}else console.error("Unable to resolve platform.");var f;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(f=e.Platform||(e.Platform={}));function b(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let s=0;k?s=1:t?s=3:A&&(s=2),e.isWindows=t,e.isMacintosh=k,e.isLinux=A,e.isLinuxSnap=D,e.isNative=T,e.isElectron=C,e.isWeb=S,e.isWebWorker=S&&typeof e.globals.importScripts=="function",e.isIOS=R,e.isMobile=E,e.isCI=P,e.platform=s,e.userAgent=g,e.language=v;var o;(function(n){function i(){return e.language}n.value=i;function p(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=p;function I(){return e.language==="en"}n.isDefault=I})(o=e.Language||(e.Language={})),e.locale=y,e.translationsConfigFile=d,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const n=[];e.globals.addEventListener("message",p=>{if(p.data&&p.data.vscodeScheduleAsyncWork)for(let I=0,L=n.length;I<L;I++){const U=n[I];if(U.id===p.data.vscodeScheduleAsyncWork){n.splice(I,1),U.callback();return}}});let i=0;return p=>{const I=++i;n.push({id:I,callback:p}),e.globals.postMessage({vscodeScheduleAsyncWork:I},"*")}}return n=>setTimeout(n)})();var c;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(c=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||R?2:t?1:3;let u=!0,r=!1;function l(){if(!r){r=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,u=new Uint16Array(n.buffer)[0]===(2<<8)+1}return u}e.isLittleEndian=l,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Se[36],ye([1,0,12]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof a.globals.vscode<"u"&&typeof a.globals.vscode.process<"u"){const k=a.globals.vscode.process;t={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return a.isWindows?"win32":a.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(Se[9],ye([1,0,36]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,k=97,A=90,D=122,T=46,S=47,C=92,R=58,P=63;class E extends Error{constructor(f,b,s){let o;typeof b=="string"&&b.indexOf("not ")===0?(o="must not be",b=b.replace(/^not /,"")):o="must be";const c=f.indexOf(".")!==-1?"property":"argument";let u=`The "${f}" ${c} ${o} of type ${b}`;u+=`. Received type ${typeof s}`,super(u),this.code="ERR_INVALID_ARG_TYPE"}}function y(m,f){if(typeof m!="string")throw new E(f,"string",m)}function v(m){return m===S||m===C}function d(m){return m===S}function g(m){return m>=t&&m<=A||m>=k&&m<=D}function h(m,f,b,s){let o="",c=0,u=-1,r=0,l=0;for(let n=0;n<=m.length;++n){if(n<m.length)l=m.charCodeAt(n);else{if(s(l))break;l=S}if(s(l)){if(!(u===n-1||r===1))if(r===2){if(o.length<2||c!==2||o.charCodeAt(o.length-1)!==T||o.charCodeAt(o.length-2)!==T){if(o.length>2){const i=o.lastIndexOf(b);i===-1?(o="",c=0):(o=o.slice(0,i),c=o.length-1-o.lastIndexOf(b)),u=n,r=0;continue}else if(o.length!==0){o="",c=0,u=n,r=0;continue}}f&&(o+=o.length>0?`${b}..`:"..",c=2)}else o.length>0?o+=`${b}${m.slice(u+1,n)}`:o=m.slice(u+1,n),c=n-u-1;u=n,r=0}else l===T&&r!==-1?++r:r=-1}return o}function w(m,f){if(f===null||typeof f!="object")throw new E("pathObject","Object",f);const b=f.dir||f.root,s=f.base||`${f.name||""}${f.ext||""}`;return b?b===f.root?`${b}${s}`:`${b}${m}${s}`:s}e.win32={resolve(...m){let f="",b="",s=!1;for(let o=m.length-1;o>=-1;o--){let c;if(o>=0){if(c=m[o],y(c,"path"),c.length===0)continue}else f.length===0?c=a.cwd():(c=a.env[`=${f}`]||a.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==f.toLowerCase()&&c.charCodeAt(2)===C)&&(c=`${f}\\`));const u=c.length;let r=0,l="",n=!1;const i=c.charCodeAt(0);if(u===1)v(i)&&(r=1,n=!0);else if(v(i))if(n=!0,v(c.charCodeAt(1))){let p=2,I=p;for(;p<u&&!v(c.charCodeAt(p));)p++;if(p<u&&p!==I){const L=c.slice(I,p);for(I=p;p<u&&v(c.charCodeAt(p));)p++;if(p<u&&p!==I){for(I=p;p<u&&!v(c.charCodeAt(p));)p++;(p===u||p!==I)&&(l=`\\\\${L}\\${c.slice(I,p)}`,r=p)}}}else r=1;else g(i)&&c.charCodeAt(1)===R&&(l=c.slice(0,2),r=2,u>2&&v(c.charCodeAt(2))&&(n=!0,r=3));if(l.length>0)if(f.length>0){if(l.toLowerCase()!==f.toLowerCase())continue}else f=l;if(s){if(f.length>0)break}else if(b=`${c.slice(r)}\\${b}`,s=n,n&&f.length>0)break}return b=h(b,!s,"\\",v),s?`${f}\\${b}`:`${f}${b}`||"."},normalize(m){y(m,"path");const f=m.length;if(f===0)return".";let b=0,s,o=!1;const c=m.charCodeAt(0);if(f===1)return d(c)?"\\":m;if(v(c))if(o=!0,v(m.charCodeAt(1))){let r=2,l=r;for(;r<f&&!v(m.charCodeAt(r));)r++;if(r<f&&r!==l){const n=m.slice(l,r);for(l=r;r<f&&v(m.charCodeAt(r));)r++;if(r<f&&r!==l){for(l=r;r<f&&!v(m.charCodeAt(r));)r++;if(r===f)return`\\\\${n}\\${m.slice(l)}\\`;r!==l&&(s=`\\\\${n}\\${m.slice(l,r)}`,b=r)}}}else b=1;else g(c)&&m.charCodeAt(1)===R&&(s=m.slice(0,2),b=2,f>2&&v(m.charCodeAt(2))&&(o=!0,b=3));let u=b<f?h(m.slice(b),!o,"\\",v):"";return u.length===0&&!o&&(u="."),u.length>0&&v(m.charCodeAt(f-1))&&(u+="\\"),s===void 0?o?`\\${u}`:u:o?`${s}\\${u}`:`${s}${u}`},isAbsolute(m){y(m,"path");const f=m.length;if(f===0)return!1;const b=m.charCodeAt(0);return v(b)||f>2&&g(b)&&m.charCodeAt(1)===R&&v(m.charCodeAt(2))},join(...m){if(m.length===0)return".";let f,b;for(let c=0;c<m.length;++c){const u=m[c];y(u,"path"),u.length>0&&(f===void 0?f=b=u:f+=`\\${u}`)}if(f===void 0)return".";let s=!0,o=0;if(typeof b=="string"&&v(b.charCodeAt(0))){++o;const c=b.length;c>1&&v(b.charCodeAt(1))&&(++o,c>2&&(v(b.charCodeAt(2))?++o:s=!1))}if(s){for(;o<f.length&&v(f.charCodeAt(o));)o++;o>=2&&(f=`\\${f.slice(o)}`)}return e.win32.normalize(f)},relative(m,f){if(y(m,"from"),y(f,"to"),m===f)return"";const b=e.win32.resolve(m),s=e.win32.resolve(f);if(b===s||(m=b.toLowerCase(),f=s.toLowerCase(),m===f))return"";let o=0;for(;o<m.length&&m.charCodeAt(o)===C;)o++;let c=m.length;for(;c-1>o&&m.charCodeAt(c-1)===C;)c--;const u=c-o;let r=0;for(;r<f.length&&f.charCodeAt(r)===C;)r++;let l=f.length;for(;l-1>r&&f.charCodeAt(l-1)===C;)l--;const n=l-r,i=u<n?u:n;let p=-1,I=0;for(;I<i;I++){const U=m.charCodeAt(o+I);if(U!==f.charCodeAt(r+I))break;U===C&&(p=I)}if(I!==i){if(p===-1)return s}else{if(n>i){if(f.charCodeAt(r+I)===C)return s.slice(r+I+1);if(I===2)return s.slice(r+I)}u>i&&(m.charCodeAt(o+I)===C?p=I:I===2&&(p=3)),p===-1&&(p=0)}let L="";for(I=o+p+1;I<=c;++I)(I===c||m.charCodeAt(I)===C)&&(L+=L.length===0?"..":"\\..");return r+=p,L.length>0?`${L}${s.slice(r,l)}`:(s.charCodeAt(r)===C&&++r,s.slice(r,l))},toNamespacedPath(m){if(typeof m!="string")return m;if(m.length===0)return"";const f=e.win32.resolve(m);if(f.length<=2)return m;if(f.charCodeAt(0)===C){if(f.charCodeAt(1)===C){const b=f.charCodeAt(2);if(b!==P&&b!==T)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(g(f.charCodeAt(0))&&f.charCodeAt(1)===R&&f.charCodeAt(2)===C)return`\\\\?\\${f}`;return m},dirname(m){y(m,"path");const f=m.length;if(f===0)return".";let b=-1,s=0;const o=m.charCodeAt(0);if(f===1)return v(o)?m:".";if(v(o)){if(b=s=1,v(m.charCodeAt(1))){let r=2,l=r;for(;r<f&&!v(m.charCodeAt(r));)r++;if(r<f&&r!==l){for(l=r;r<f&&v(m.charCodeAt(r));)r++;if(r<f&&r!==l){for(l=r;r<f&&!v(m.charCodeAt(r));)r++;if(r===f)return m;r!==l&&(b=s=r+1)}}}}else g(o)&&m.charCodeAt(1)===R&&(b=f>2&&v(m.charCodeAt(2))?3:2,s=b);let c=-1,u=!0;for(let r=f-1;r>=s;--r)if(v(m.charCodeAt(r))){if(!u){c=r;break}}else u=!1;if(c===-1){if(b===-1)return".";c=b}return m.slice(0,c)},basename(m,f){f!==void 0&&y(f,"ext"),y(m,"path");let b=0,s=-1,o=!0,c;if(m.length>=2&&g(m.charCodeAt(0))&&m.charCodeAt(1)===R&&(b=2),f!==void 0&&f.length>0&&f.length<=m.length){if(f===m)return"";let u=f.length-1,r=-1;for(c=m.length-1;c>=b;--c){const l=m.charCodeAt(c);if(v(l)){if(!o){b=c+1;break}}else r===-1&&(o=!1,r=c+1),u>=0&&(l===f.charCodeAt(u)?--u===-1&&(s=c):(u=-1,s=r))}return b===s?s=r:s===-1&&(s=m.length),m.slice(b,s)}for(c=m.length-1;c>=b;--c)if(v(m.charCodeAt(c))){if(!o){b=c+1;break}}else s===-1&&(o=!1,s=c+1);return s===-1?"":m.slice(b,s)},extname(m){y(m,"path");let f=0,b=-1,s=0,o=-1,c=!0,u=0;m.length>=2&&m.charCodeAt(1)===R&&g(m.charCodeAt(0))&&(f=s=2);for(let r=m.length-1;r>=f;--r){const l=m.charCodeAt(r);if(v(l)){if(!c){s=r+1;break}continue}o===-1&&(c=!1,o=r+1),l===T?b===-1?b=r:u!==1&&(u=1):b!==-1&&(u=-1)}return b===-1||o===-1||u===0||u===1&&b===o-1&&b===s+1?"":m.slice(b,o)},format:w.bind(null,"\\"),parse(m){y(m,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return f;const b=m.length;let s=0,o=m.charCodeAt(0);if(b===1)return v(o)?(f.root=f.dir=m,f):(f.base=f.name=m,f);if(v(o)){if(s=1,v(m.charCodeAt(1))){let p=2,I=p;for(;p<b&&!v(m.charCodeAt(p));)p++;if(p<b&&p!==I){for(I=p;p<b&&v(m.charCodeAt(p));)p++;if(p<b&&p!==I){for(I=p;p<b&&!v(m.charCodeAt(p));)p++;p===b?s=p:p!==I&&(s=p+1)}}}}else if(g(o)&&m.charCodeAt(1)===R){if(b<=2)return f.root=f.dir=m,f;if(s=2,v(m.charCodeAt(2))){if(b===3)return f.root=f.dir=m,f;s=3}}s>0&&(f.root=m.slice(0,s));let c=-1,u=s,r=-1,l=!0,n=m.length-1,i=0;for(;n>=s;--n){if(o=m.charCodeAt(n),v(o)){if(!l){u=n+1;break}continue}r===-1&&(l=!1,r=n+1),o===T?c===-1?c=n:i!==1&&(i=1):c!==-1&&(i=-1)}return r!==-1&&(c===-1||i===0||i===1&&c===r-1&&c===u+1?f.base=f.name=m.slice(u,r):(f.name=m.slice(u,c),f.base=m.slice(u,r),f.ext=m.slice(c,r))),u>0&&u!==s?f.dir=m.slice(0,u-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...m){let f="",b=!1;for(let s=m.length-1;s>=-1&&!b;s--){const o=s>=0?m[s]:a.cwd();y(o,"path"),o.length!==0&&(f=`${o}/${f}`,b=o.charCodeAt(0)===S)}return f=h(f,!b,"/",d),b?`/${f}`:f.length>0?f:"."},normalize(m){if(y(m,"path"),m.length===0)return".";const f=m.charCodeAt(0)===S,b=m.charCodeAt(m.length-1)===S;return m=h(m,!f,"/",d),m.length===0?f?"/":b?"./":".":(b&&(m+="/"),f?`/${m}`:m)},isAbsolute(m){return y(m,"path"),m.length>0&&m.charCodeAt(0)===S},join(...m){if(m.length===0)return".";let f;for(let b=0;b<m.length;++b){const s=m[b];y(s,"path"),s.length>0&&(f===void 0?f=s:f+=`/${s}`)}return f===void 0?".":e.posix.normalize(f)},relative(m,f){if(y(m,"from"),y(f,"to"),m===f||(m=e.posix.resolve(m),f=e.posix.resolve(f),m===f))return"";const b=1,s=m.length,o=s-b,c=1,u=f.length-c,r=o<u?o:u;let l=-1,n=0;for(;n<r;n++){const p=m.charCodeAt(b+n);if(p!==f.charCodeAt(c+n))break;p===S&&(l=n)}if(n===r)if(u>r){if(f.charCodeAt(c+n)===S)return f.slice(c+n+1);if(n===0)return f.slice(c+n)}else o>r&&(m.charCodeAt(b+n)===S?l=n:n===0&&(l=0));let i="";for(n=b+l+1;n<=s;++n)(n===s||m.charCodeAt(n)===S)&&(i+=i.length===0?"..":"/..");return`${i}${f.slice(c+l)}`},toNamespacedPath(m){return m},dirname(m){if(y(m,"path"),m.length===0)return".";const f=m.charCodeAt(0)===S;let b=-1,s=!0;for(let o=m.length-1;o>=1;--o)if(m.charCodeAt(o)===S){if(!s){b=o;break}}else s=!1;return b===-1?f?"/":".":f&&b===1?"//":m.slice(0,b)},basename(m,f){f!==void 0&&y(f,"ext"),y(m,"path");let b=0,s=-1,o=!0,c;if(f!==void 0&&f.length>0&&f.length<=m.length){if(f===m)return"";let u=f.length-1,r=-1;for(c=m.length-1;c>=0;--c){const l=m.charCodeAt(c);if(l===S){if(!o){b=c+1;break}}else r===-1&&(o=!1,r=c+1),u>=0&&(l===f.charCodeAt(u)?--u===-1&&(s=c):(u=-1,s=r))}return b===s?s=r:s===-1&&(s=m.length),m.slice(b,s)}for(c=m.length-1;c>=0;--c)if(m.charCodeAt(c)===S){if(!o){b=c+1;break}}else s===-1&&(o=!1,s=c+1);return s===-1?"":m.slice(b,s)},extname(m){y(m,"path");let f=-1,b=0,s=-1,o=!0,c=0;for(let u=m.length-1;u>=0;--u){const r=m.charCodeAt(u);if(r===S){if(!o){b=u+1;break}continue}s===-1&&(o=!1,s=u+1),r===T?f===-1?f=u:c!==1&&(c=1):f!==-1&&(c=-1)}return f===-1||s===-1||c===0||c===1&&f===s-1&&f===b+1?"":m.slice(f,s)},format:w.bind(null,"/"),parse(m){y(m,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return f;const b=m.charCodeAt(0)===S;let s;b?(f.root="/",s=1):s=0;let o=-1,c=0,u=-1,r=!0,l=m.length-1,n=0;for(;l>=s;--l){const i=m.charCodeAt(l);if(i===S){if(!r){c=l+1;break}continue}u===-1&&(r=!1,u=l+1),i===T?o===-1?o=l:n!==1&&(n=1):o!==-1&&(n=-1)}if(u!==-1){const i=c===0&&b?1:c;o===-1||n===0||n===1&&o===u-1&&o===c+1?f.base=f.name=m.slice(i,u):(f.name=m.slice(i,o),f.base=m.slice(i,u),f.ext=m.slice(o,u))}return c>0?f.dir=m.slice(0,c-1):b&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=a.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=a.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=a.platform==="win32"?e.win32.join:e.posix.join,e.resolve=a.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=a.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=a.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=a.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=a.platform==="win32"?e.win32.extname:e.posix.extname,e.format=a.platform==="win32"?e.win32.format:e.posix.format,e.parse=a.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=a.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=a.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=a.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Se[82],ye([1,0,9]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},k={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(R){const P=(0,a.extname)(R),E=t[P.toLowerCase()];return E!==void 0?E:D(R)}e.getMediaOrTextMime=A;function D(R){const P=(0,a.extname)(R);return k[P.toLowerCase()]}e.getMediaMime=D;function T(R){for(const P in k)if(k[P]===R)return P}e.getExtensionForMimeType=T;const S=/^(.+)\/(.+?)(;.+)?$/;function C(R,P){const E=S.exec(R);return E?`${E[1].toLowerCase()}/${E[2].toLowerCase()}${E[3]??""}`:P?void 0:R}e.normalizeMimeType=C}),define(Se[106],ye([1,0,12]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var k;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(T,...S){const C=S.reduce((E,y)=>(E[y]=!0,E),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(E=>!C[E]).forEach(E=>{for(let y=0;y<R.length;y++)if(E.search(R[y])!==-1){delete T[E];break}})}e.sanitizeProcessEnvironment=A;function D(T){!T||(delete T.DEBUG,a.isMacintosh&&delete T.DYLD_LIBRARY_PATH,a.isLinux&&delete T.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(Se[51],ye([1,0,12]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=a.globals.performance&&typeof a.globals.performance.now=="function";class k{static create(D=!0){return new k(D)}constructor(D){this.a=t&&D,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?a.globals.performance.now():Date.now()}}e.StopWatch=k}),define(Se[4],ye([1,0,10,61,6,63,51]),function(te,e,a,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const T=!1,S=!1;var C;(function(l){l.None=()=>k.Disposable.None;function n(De){if(S){const{onDidAddListener:Re}=De,$e=v.create();let re=0;De.onDidAddListener=()=>{++re===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$e.print()),Re?.()}}}function i(De,Re){return F(De,()=>{},0,void 0,void 0,Re)}l.defer=i;function p(De){return(Re,$e=null,re)=>{let le=!1,fe;return fe=De(Z=>{if(!le)return fe?fe.dispose():le=!0,Re.call($e,Z)},null,re),le&&fe.dispose(),fe}}l.once=p;function I(De,Re,$e){return B((re,le=null,fe)=>De(Z=>re.call(le,Re(Z)),null,fe),$e)}l.map=I;function L(De,Re,$e){return B((re,le=null,fe)=>De(Z=>{Re(Z),re.call(le,Z)},null,fe),$e)}l.forEach=L;function U(De,Re,$e){return B((re,le=null,fe)=>De(Z=>Re(Z)&&re.call(le,Z),null,fe),$e)}l.filter=U;function G(De){return De}l.signal=G;function V(...De){return(Re,$e=null,re)=>(0,k.combinedDisposable)(...De.map(le=>le(fe=>Re.call($e,fe),null,re)))}l.any=V;function O(De,Re,$e,re){let le=$e;return I(De,fe=>(le=Re(le,fe),le),re)}l.reduce=O;function B(De,Re){let $e;const re={onWillAddFirstListener(){$e=De(le.fire,le)},onDidRemoveLastListener(){$e?.dispose()}};Re||n(re);const le=new g(re);return Re?.add(le),le.event}function F(De,Re,$e=100,re=!1,le,fe){let Z,se,ne,N=0;const z={leakWarningThreshold:le,onWillAddFirstListener(){Z=De(_=>{N++,se=Re(se,_),re&&!ne&&(X.fire(se),se=void 0),clearTimeout(ne),ne=setTimeout(()=>{const ue=se;se=void 0,ne=void 0,(!re||N>1)&&X.fire(ue),N=0},$e)})},onDidRemoveLastListener(){Z.dispose()}};fe||n(z);const X=new g(z);return fe?.add(X),X.event}l.debounce=F;function $(De,Re=0,$e){return l.debounce(De,(re,le)=>re?(re.push(le),re):[le],Re,void 0,void 0,$e)}l.accumulate=$;function M(De,Re=(re,le)=>re===le,$e){let re=!0,le;return U(De,fe=>{const Z=re||!Re(fe,le);return re=!1,le=fe,Z},$e)}l.latch=M;function H(De,Re,$e){return[l.filter(De,Re,$e),l.filter(De,re=>!Re(re),$e)]}l.split=H;function K(De,Re=!1,$e=[]){let re=$e.slice(),le=De(se=>{re?re.push(se):Z.fire(se)});const fe=()=>{re?.forEach(se=>Z.fire(se)),re=null},Z=new g({onWillAddFirstListener(){le||(le=De(se=>Z.fire(se)))},onDidAddFirstListener(){re&&(Re?setTimeout(fe):fe())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return Z.event}l.buffer=K;class q{constructor(Re){this.event=Re,this.c=new k.DisposableStore}map(Re){return new q(I(this.event,Re,this.c))}forEach(Re){return new q(L(this.event,Re,this.c))}filter(Re){return new q(U(this.event,Re,this.c))}reduce(Re,$e){return new q(O(this.event,Re,$e,this.c))}latch(){return new q(M(this.event,void 0,this.c))}debounce(Re,$e=100,re=!1,le){return new q(F(this.event,Re,$e,re,le,this.c))}on(Re,$e,re){return this.event(Re,$e,re)}once(Re,$e,re){return p(this.event)(Re,$e,re)}dispose(){this.c.dispose()}}function Y(De){return new q(De)}l.chain=Y;function Q(De,Re,$e=re=>re){const re=(...se)=>Z.fire($e(...se)),le=()=>De.on(Re,re),fe=()=>De.removeListener(Re,re),Z=new g({onWillAddFirstListener:le,onDidRemoveLastListener:fe});return Z.event}l.fromNodeEventEmitter=Q;function ce(De,Re,$e=re=>re){const re=(...se)=>Z.fire($e(...se)),le=()=>De.addEventListener(Re,re),fe=()=>De.removeEventListener(Re,re),Z=new g({onWillAddFirstListener:le,onDidRemoveLastListener:fe});return Z.event}l.fromDOMEventEmitter=ce;function ie(De){return new Promise(Re=>p(De)(Re))}l.toPromise=ie;function de(De,Re){return Re(void 0),De($e=>Re($e))}l.runAndSubscribe=de;function J(De,Re){let $e=null;function re(fe){$e?.dispose(),$e=new k.DisposableStore,Re(fe,$e)}re(void 0);const le=De(fe=>re(fe));return(0,k.toDisposable)(()=>{le.dispose(),$e?.dispose()})}l.runAndSubscribeWithStore=J;class pe{constructor(Re,$e){this.obs=Re,this.c=0,this.d=!1;const re={onWillAddFirstListener:()=>{Re.addObserver(this)},onDidRemoveLastListener:()=>{Re.removeObserver(this)}};$e||n(re),this.emitter=new g(re),$e&&$e.add(this.emitter)}beginUpdate(Re){this.c++}handleChange(Re,$e){this.d=!0}endUpdate(Re){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function ve(De,Re){return new pe(De,Re).emitter.event}l.fromObservable=ve})(C=e.Event||(e.Event={}));class R{constructor(n){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${n}_${R.c++}`,R.all.add(this)}start(n){this.d=new D.StopWatch(!0),this.listenerCount=n}stop(){if(this.d){const n=this.d.elapsed();this.durations.push(n),this.elapsedOverall+=n,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=R,R.all=new Set,R.c=0;let P=-1;function E(l){const n=P;return P=l,{dispose(){P=n}}}e.setGlobalLeakWarningThreshold=E;class y{constructor(n,i=Math.random().toString(18).slice(2,5)){this.threshold=n,this.name=i,this.d=0}dispose(){this.c?.clear()}check(n,i){const p=this.threshold;if(p<=0||i<p)return;this.c||(this.c=new Map);const I=this.c.get(n.value)||0;if(this.c.set(n.value,I+1),this.d-=1,this.d<=0){this.d=p*.5;let L,U=0;for(const[G,V]of this.c)(!L||U<V)&&(L=G,U=V);console.warn(`[${this.name}] potential listener LEAK detected, having ${i} listeners already. MOST frequent listener (${U}):`),console.warn(L)}return()=>{const L=this.c.get(n.value)||0;this.c.set(n.value,L-1)}}}class v{static create(){return new v(new Error().stack??"")}constructor(n){this.value=n}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class d{constructor(n,i,p){this.callback=n,this.callbackThis=i,this.stack=p,this.subscription=new k.SafeDisposable}invoke(n){this.callback.call(this.callbackThis,n)}}class g{constructor(n){this.j=!1,this.d=n,this.f=P>0||this.d?.leakWarningThreshold?new y(this.d?.leakWarningThreshold??P):void 0,this.g=this.d?._profName?new R(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(T){const n=Array.from(this.q);queueMicrotask(()=>{for(const i of n)i.subscription.isset()&&(i.subscription.unset(),i.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(n,i,p)=>{if(this.q||(this.q=new A.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),k.Disposable.None;const I=this.q.isEmpty();I&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let L,U;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(U=v.create(),L=this.f.check(U,this.q.size+1)),T&&(U=U??v.create());const G=new d(n,i,U),V=this.q.push(G);I&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,n,i);const O=G.subscription.set(()=>{L?.(),this.j||(V(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return p instanceof k.DisposableStore?p.add(O):Array.isArray(p)&&p.push(O),O}),this.l}fire(n){if(this.q){this.m||(this.m=new w);for(const i of this.q)this.m.push(this,i,n);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=g;class h{constructor(){this.c=new A.LinkedList}get size(){return this.c.size}push(n,i,p){this.c.push(new m(n,i,p))}clear(n){const i=new A.LinkedList;for(const p of this.c)p.emitter!==n&&i.push(p);this.c=i}deliver(){for(;this.c.size>0;){const n=this.c.shift();try{n.listener.invoke(n.event)}catch(i){(0,a.onUnexpectedError)(i)}}}}e.EventDeliveryQueue=h;class w extends h{clear(n){this.c.clear()}}class m{constructor(n,i,p){this.emitter=n,this.listener=i,this.event=p}}class f extends g{async fireAsync(n,i,p){if(!!this.q){this.c||(this.c=new A.LinkedList);for(const I of this.q)this.c.push([I,n]);for(;this.c.size>0&&!i.isCancellationRequested;){const[I,L]=this.c.shift(),U=[],G={...L,token:i,waitUntil:V=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");p&&(V=p(V,I.callback)),U.push(V)}};try{I.invoke(G)}catch(V){(0,a.onUnexpectedError)(V);continue}Object.freeze(U),await Promise.allSettled(U).then(V=>{for(const O of V)O.status==="rejected"&&(0,a.onUnexpectedError)(O.reason)})}}}}e.AsyncEmitter=f;class b extends g{constructor(n){super(n),this.h=0,this.s=new A.LinkedList,this.t=n?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const n=Array.from(this.s);this.s.clear(),super.fire(this.t(n))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(n){this.q&&(this.h!==0?this.s.push(n):super.fire(n))}}e.PauseableEmitter=b;class s extends b{constructor(n){super(n),this.c=n.delay??100}fire(n){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(n)}}e.DebounceEmitter=s;class o extends g{constructor(n){super(n),this.c=[],this.h=n?.merge}fire(n){!this.hasListeners()||(this.c.push(n),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(i=>super.fire(i)),this.c=[]}))}}e.MicrotaskEmitter=o;class c{constructor(){this.d=!1,this.f=[],this.c=new g({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(n){const i={event:n,listener:null};this.f.push(i),this.d&&this.j(i);const p=()=>{this.d&&this.k(i);const I=this.f.indexOf(i);this.f.splice(I,1)};return(0,k.toDisposable)((0,t.once)(p))}g(){this.d=!0,this.f.forEach(n=>this.j(n))}h(){this.d=!1,this.f.forEach(n=>this.k(n))}j(n){n.listener=n.event(i=>this.c.fire(i))}k(n){n.listener&&n.listener.dispose(),n.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=c;class u{constructor(){this.c=[]}wrapEvent(n){return(i,p,I)=>n(L=>{const U=this.c[this.c.length-1];U?U.push(()=>i.call(p,L)):i.call(p,L)},void 0,I)}bufferEvents(n){const i=[];this.c.push(i);const p=n();return this.c.pop(),i.forEach(I=>I()),p}}e.EventBufferer=u;class r{constructor(){this.c=!1,this.d=C.None,this.f=k.Disposable.None,this.g=new g({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(n){this.d=n,this.c&&(this.f.dispose(),this.f=n(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=r}),define(Se[21],ye([1,0,4]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(T,S){const C=setTimeout(T.bind(S),0);return{dispose(){clearTimeout(C)}}});var k;(function(T){function S(C){return C===T.None||C===T.Cancelled||C instanceof A?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}T.isCancellationToken=S,T.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:a.Event.None}),T.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(k=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new a.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(S){this.a=void 0,this.b=void 0,this.b=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new A),this.a}cancel(){this.a?this.a instanceof A&&this.a.cancel():this.a=k.Cancelled}dispose(S=!1){S&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof A&&this.a.dispose():this.a=k.None}}e.CancellationTokenSource=D}),define(Se[158],ye([1,0,21]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(T){this.b=T,this.a=null}get(){if(this.a)return this.a;const T=new a.CancellationTokenSource,S=this.b(T.token);return this.a={promise:S,dispose:()=>{this.a=null,T.cancel(),T.dispose()}},this.a}}e.Cache=t;class k{constructor(T){this.c=T,this.a=void 0,this.b=void 0}get(T){const S=JSON.stringify(T);return this.b!==S&&(this.b=S,this.a=this.c(T)),this.a}}e.LRUCachedFunction=k;class A{get cachedValues(){return this.a}constructor(T){this.b=T,this.a=new Map}get(T){if(this.a.has(T))return this.a.get(T);const S=this.b(T);return this.a.set(T,S),S}}e.CachedFunction=A}),define(Se[159],ye([1,0,4,6]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const k=D=>({onDidChange:a.Event.None,value:D});e.staticObservableValue=k;class A extends t.Disposable{get value(){return this.b}set value(T){T!==this.b&&(this.b=T,this.a.fire(T))}constructor(T){super(),this.b=T,this.a=this.B(new a.Emitter),this.onDidChange=this.a.event}}e.MutableObservableValue=A}),define(Se[8],ye([1,0,158,80]),function(te,e,a,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(W){return!W||typeof W!="string"?!0:W.trim().length===0}e.isFalsyOrWhitespace=A;const D=/{(\d+)}/g;function T(W,...ae){return ae.length===0?W:W.replace(D,function(Ce,Le){const Be=parseInt(Le,10);return isNaN(Be)||Be<0||Be>=ae.length?Ce:ae[Be]})}e.format=T;const S=/{([^}]+)}/g;function C(W,ae){return W.replace(S,(Ce,Le)=>ae[Le]??Ce)}e.format2=C;function R(W){return W.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}e.escape=R;function P(W){return W.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function E(W,ae){let Ce=0;const Le=ae.charCodeAt(0);for(let Be=W.length-1;Be>=0;Be--)W.charCodeAt(Be)===Le&&Ce++;return Ce}e.count=E;function y(W,ae,Ce="\u2026"){return W.length<=ae?W:`${W.substr(0,ae)}${Ce}`}e.truncate=y;function v(W,ae=" "){const Ce=d(W,ae);return g(Ce,ae)}e.trim=v;function d(W,ae){if(!W||!ae)return W;const Ce=ae.length;if(Ce===0||W.length===0)return W;let Le=0;for(;W.indexOf(ae,Le)===Le;)Le=Le+Ce;return W.substring(Le)}e.ltrim=d;function g(W,ae){if(!W||!ae)return W;const Ce=ae.length,Le=W.length;if(Ce===0||Le===0)return W;let Be=Le,Xe=-1;for(;Xe=W.lastIndexOf(ae,Be-1),!(Xe===-1||Xe+Ce!==Be);){if(Xe===0)return"";Be=Xe}return W.substring(0,Be)}e.rtrim=g;function h(W){return W.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function w(W){return W.replace(/\*/g,"")}e.stripWildcards=w;function m(W,ae,Ce={}){if(!W)throw new Error("Cannot create regex from empty string");ae||(W=P(W)),Ce.wholeWord&&(/\B/.test(W.charAt(0))||(W="\\b"+W),/\B/.test(W.charAt(W.length-1))||(W=W+"\\b"));let Le="";return Ce.global&&(Le+="g"),Ce.matchCase||(Le+="i"),Ce.multiline&&(Le+="m"),Ce.unicode&&(Le+="u"),new RegExp(W,Le)}e.createRegExp=m;function f(W){return W.source==="^"||W.source==="^$"||W.source==="$"||W.source==="^\\s*$"?!1:!!(W.exec("")&&W.lastIndex===0)}e.regExpLeadsToEndlessLoop=f;function b(W){return!!W.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=b;function s(W){return(W.global?"g":"")+(W.ignoreCase?"i":"")+(W.multiline?"m":"")+(W.unicode?"u":"")}e.regExpFlags=s;function o(W){return W.split(/\r\n|\r|\n/)}e.splitLines=o;function c(W){for(let ae=0,Ce=W.length;ae<Ce;ae++){const Le=W.charCodeAt(ae);if(Le!==32&&Le!==9)return ae}return-1}e.firstNonWhitespaceIndex=c;function u(W,ae=0,Ce=W.length){for(let Le=ae;Le<Ce;Le++){const Be=W.charCodeAt(Le);if(Be!==32&&Be!==9)return W.substring(ae,Le)}return W.substring(ae,Ce)}e.getLeadingWhitespace=u;function r(W,ae=W.length-1){for(let Ce=ae;Ce>=0;Ce--){const Le=W.charCodeAt(Ce);if(Le!==32&&Le!==9)return Ce}return-1}e.lastNonWhitespaceIndex=r;function l(W,ae,Ce){const Le=[];let Be=0;for(const Xe of W.matchAll(ae)){if(Le.push(W.slice(Be,Xe.index)),Xe.index===void 0)throw new Error("match.index should be defined");Be=Xe.index+Xe[0].length,Le.push(Ce(Xe[0],...Xe.slice(1),Xe.index,W,Xe.groups))}return Le.push(W.slice(Be)),Promise.all(Le).then(Xe=>Xe.join(""))}e.replaceAsync=l;function n(W,ae){return W<ae?-1:W>ae?1:0}e.compare=n;function i(W,ae,Ce=0,Le=W.length,Be=0,Xe=ae.length){for(;Ce<Le&&Be<Xe;Ce++,Be++){const mt=W.charCodeAt(Ce),lt=ae.charCodeAt(Be);if(mt<lt)return-1;if(mt>lt)return 1}const Ze=Le-Ce,ft=Xe-Be;return Ze<ft?-1:Ze>ft?1:0}e.compareSubstring=i;function p(W,ae){return I(W,ae,0,W.length,0,ae.length)}e.compareIgnoreCase=p;function I(W,ae,Ce=0,Le=W.length,Be=0,Xe=ae.length){for(;Ce<Le&&Be<Xe;Ce++,Be++){let mt=W.charCodeAt(Ce),lt=ae.charCodeAt(Be);if(mt===lt)continue;if(mt>=128||lt>=128)return i(W.toLowerCase(),ae.toLowerCase(),Ce,Le,Be,Xe);U(mt)&&(mt-=32),U(lt)&&(lt-=32);const ot=mt-lt;if(ot!==0)return ot}const Ze=Le-Ce,ft=Xe-Be;return Ze<ft?-1:Ze>ft?1:0}e.compareSubstringIgnoreCase=I;function L(W){return W>=48&&W<=57}e.isAsciiDigit=L;function U(W){return W>=97&&W<=122}e.isLowerAsciiLetter=U;function G(W){return W>=65&&W<=90}e.isUpperAsciiLetter=G;function V(W,ae){return W.length===ae.length&&I(W,ae)===0}e.equalsIgnoreCase=V;function O(W,ae){const Ce=ae.length;return ae.length>W.length?!1:I(W,ae,0,Ce)===0}e.startsWithIgnoreCase=O;function B(W,ae){const Ce=Math.min(W.length,ae.length);let Le;for(Le=0;Le<Ce;Le++)if(W.charCodeAt(Le)!==ae.charCodeAt(Le))return Le;return Ce}e.commonPrefixLength=B;function F(W,ae){const Ce=Math.min(W.length,ae.length);let Le;const Be=W.length-1,Xe=ae.length-1;for(Le=0;Le<Ce;Le++)if(W.charCodeAt(Be-Le)!==ae.charCodeAt(Xe-Le))return Le;return Ce}e.commonSuffixLength=F;function $(W){return 55296<=W&&W<=56319}e.isHighSurrogate=$;function M(W){return 56320<=W&&W<=57343}e.isLowSurrogate=M;function H(W,ae){return(W-55296<<10)+(ae-56320)+65536}e.computeCodePoint=H;function K(W,ae,Ce){const Le=W.charCodeAt(Ce);if($(Le)&&Ce+1<ae){const Be=W.charCodeAt(Ce+1);if(M(Be))return H(Le,Be)}return Le}e.getNextCodePoint=K;function q(W,ae){const Ce=W.charCodeAt(ae-1);if(M(Ce)&&ae>1){const Le=W.charCodeAt(ae-2);if($(Le))return H(Le,Ce)}return Ce}class Y{get offset(){return this.e}constructor(ae,Ce=0){this.c=ae,this.d=ae.length,this.e=Ce}setOffset(ae){this.e=ae}prevCodePoint(){const ae=q(this.c,this.e);return this.e-=ae>=65536?2:1,ae}nextCodePoint(){const ae=K(this.c,this.d,this.e);return this.e+=ae>=65536?2:1,ae}eol(){return this.e>=this.d}}e.CodePointIterator=Y;class Q{get offset(){return this.c.offset}constructor(ae,Ce=0){this.c=new Y(ae,Ce)}nextGraphemeLength(){const ae=et.getInstance(),Ce=this.c,Le=Ce.offset;let Be=ae.getGraphemeBreakType(Ce.nextCodePoint());for(;!Ce.eol();){const Xe=Ce.offset,Ze=ae.getGraphemeBreakType(Ce.nextCodePoint());if(je(Be,Ze)){Ce.setOffset(Xe);break}Be=Ze}return Ce.offset-Le}prevGraphemeLength(){const ae=et.getInstance(),Ce=this.c,Le=Ce.offset;let Be=ae.getGraphemeBreakType(Ce.prevCodePoint());for(;Ce.offset>0;){const Xe=Ce.offset,Ze=ae.getGraphemeBreakType(Ce.prevCodePoint());if(je(Ze,Be)){Ce.setOffset(Xe);break}Be=Ze}return Le-Ce.offset}eol(){return this.c.eol()}}e.GraphemeIterator=Q;function ce(W,ae){return new Q(W,ae).nextGraphemeLength()}e.nextCharLength=ce;function ie(W,ae){return new Q(W,ae).prevGraphemeLength()}e.prevCharLength=ie;function de(W,ae){ae>0&&M(W.charCodeAt(ae))&&ae--;const Ce=ae+ce(W,ae);return[Ce-ie(W,Ce),Ce]}e.getCharContainingOffset=de;function J(W){const ae=new Q(W);let Ce=0;for(;!ae.eol();)Ce++,ae.nextGraphemeLength();return Ce}e.charCount=J;let pe;function ve(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function De(W){return pe||(pe=ve()),pe.test(W)}e.containsRTL=De;const Re=/^[\t\n\r\x20-\x7E]*$/;function $e(W){return Re.test(W)}e.isBasicASCII=$e,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function re(W){return e.UNUSUAL_LINE_TERMINATORS.test(W)}e.containsUnusualLineTerminators=re;function le(W){return W>=11904&&W<=55215||W>=63744&&W<=64255||W>=65281&&W<=65374}e.isFullWidthCharacter=le;function fe(W){return W>=127462&&W<=127487||W===8986||W===8987||W===9200||W===9203||W>=9728&&W<=10175||W===11088||W===11093||W>=127744&&W<=128591||W>=128640&&W<=128764||W>=128992&&W<=129008||W>=129280&&W<=129535||W>=129648&&W<=129782}e.isEmojiImprecise=fe;function Z(W,ae){if(W.length<ae)return W;const Ce=/\b/g;let Le=0;for(;Ce.test(W)&&!(W.length-Ce.lastIndex<ae);)Le=Ce.lastIndex,Ce.lastIndex+=1;return W.substring(Le).replace(/^\s/,"")}e.lcut=Z;const se=/\x1B\x5B[12]?K/g,ne=/\x1b\[\d+m/g,N=/\x1b\[0?m/g;function z(W){return W&&(W=W.replace(se,""),W=W.replace(ne,""),W=W.replace(N,"")),W}e.removeAnsiEscapeCodes=z,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function X(W){return!!(W&&W.length>0&&W.charCodeAt(0)===65279)}e.startsWithUTF8BOM=X;function _(W){return X(W)?W.substr(1):W}e.stripUTF8BOM=_;function ue(W,ae){if(!W||!ae||W.length<ae.length)return!1;const Ce=ae.length,Le=W.toLowerCase();let Be=0,Xe=-1;for(;Be<Ce;){const Ze=Le.indexOf(ae[Be],Xe+1);if(Ze<0)return!1;Xe=Ze,Be++}return!0}e.fuzzyContains=ue;function be(W,ae=!1){return W?(ae&&(W=W.replace(/\\./g,"")),W.toLowerCase()!==W):!1}e.containsUppercaseCharacter=be;function ke(W){return W.charAt(0).toUpperCase()+W.slice(1)}e.uppercaseFirstLetter=ke;function ge(W,ae=1){if(ae===0)return"";let Ce=-1;do Ce=W.indexOf(`
`,Ce+1),ae--;while(ae>0&&Ce>=0);return Ce===-1?W:(W[Ce-1]==="\r"&&Ce--,W.substr(0,Ce))}e.getNLines=ge;function Pe(W){return W=W%(2*26),W<26?String.fromCharCode(97+W):String.fromCharCode(65+W-26)}e.singleLetterHash=Pe;function Ie(W){return et.getInstance().getGraphemeBreakType(W)}e.getGraphemeBreakType=Ie;function je(W,ae){return W===0?ae!==5&&ae!==7:W===2&&ae===3?!1:W===4||W===2||W===3||ae===4||ae===2||ae===3?!0:!(W===8&&(ae===8||ae===9||ae===11||ae===12)||(W===11||W===9)&&(ae===9||ae===10)||(W===12||W===10)&&ae===10||ae===5||ae===13||ae===7||W===1||W===13&&ae===14||W===6&&ae===6)}var qe;(function(W){W[W.Other=0]="Other",W[W.Prepend=1]="Prepend",W[W.CR=2]="CR",W[W.LF=3]="LF",W[W.Control=4]="Control",W[W.Extend=5]="Extend",W[W.Regional_Indicator=6]="Regional_Indicator",W[W.SpacingMark=7]="SpacingMark",W[W.L=8]="L",W[W.V=9]="V",W[W.T=10]="T",W[W.LV=11]="LV",W[W.LVT=12]="LVT",W[W.ZWJ=13]="ZWJ",W[W.Extended_Pictographic=14]="Extended_Pictographic"})(qe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class et{static getInstance(){return et.c||(et.c=new et),et.c}constructor(){this.d=_e()}getGraphemeBreakType(ae){if(ae<32)return ae===10?3:ae===13?2:4;if(ae<127)return 0;const Ce=this.d,Le=Ce.length/3;let Be=1;for(;Be<=Le;)if(ae<Ce[3*Be])Be=2*Be;else if(ae>Ce[3*Be+1])Be=2*Be+1;else return Ce[3*Be+2];return 0}}et.c=null;function _e(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function nt(W,ae){if(W===0)return 0;const Ce=st(W,ae);if(Ce!==void 0)return Ce;const Le=new Y(ae,W);return Le.prevCodePoint(),Le.offset}e.getLeftDeleteOffset=nt;function st(W,ae){const Ce=new Y(ae,W);let Le=Ce.prevCodePoint();for(;ht(Le)||Le===65039||Le===8419;){if(Ce.offset===0)return;Le=Ce.prevCodePoint()}if(!fe(Le))return;let Be=Ce.offset;return Be>0&&Ce.prevCodePoint()===8205&&(Be=Ce.offset),Be}function ht(W){return 127995<=W&&W<=127999}var Ue;(function(W){W[W.zwj=8205]="zwj",W[W.emojiVariantSelector=65039]="emojiVariantSelector",W[W.enclosingKeyCap=8419]="enclosingKeyCap"})(Ue||(Ue={})),e.noBreakWhitespace="\xA0";class it{static getInstance(ae){return it.d.get(Array.from(ae))}static getLocales(){return it.e.getValue()}constructor(ae){this.f=ae}isAmbiguous(ae){return this.f.has(ae)}getPrimaryConfusable(ae){return this.f.get(ae)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=it,k=it,it.c=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),it.d=new a.LRUCachedFunction(W=>{function ae(lt){const ot=new Map;for(let rt=0;rt<lt.length;rt+=2)ot.set(lt[rt],lt[rt+1]);return ot}function Ce(lt,ot){const rt=new Map(lt);for(const[Tt,kt]of ot)rt.set(Tt,kt);return rt}function Le(lt,ot){if(!lt)return ot;const rt=new Map;for(const[Tt,kt]of lt)ot.has(Tt)&&rt.set(Tt,kt);return rt}const Be=k.c.getValue();let Xe=W.filter(lt=>!lt.startsWith("_")&&lt in Be);Xe.length===0&&(Xe=["_default"]);let Ze;for(const lt of Xe){const ot=ae(Be[lt]);Ze=Le(Ze,ot)}const ft=ae(Be._common),mt=Ce(ft,Ze);return new it(mt)}),it.e=new t.Lazy(()=>Object.keys(it.c.getValue()).filter(W=>!W.startsWith("_")));class oe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(oe.c())),this.d}static isInvisibleCharacter(ae){return oe.e().has(ae)}static get codePoints(){return oe.e()}}e.InvisibleCharacters=oe,oe.d=void 0}),define(Se[32],ye([1,0,9,12,8,11]),function(te,e,a,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(r){return r===47||r===92}e.isPathSeparator=D;function T(r){return r.replace(/[\\/]/g,a.posix.sep)}e.toSlashes=T;function S(r){return r.indexOf("/")===-1&&(r=T(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=S;function C(r,l=a.posix.sep){if(!r)return"";const n=r.length,i=r.charCodeAt(0);if(D(i)){if(D(r.charCodeAt(1))&&!D(r.charCodeAt(2))){let I=3;const L=I;for(;I<n&&!D(r.charCodeAt(I));I++);if(L!==I&&!D(r.charCodeAt(I+1))){for(I+=1;I<n;I++)if(D(r.charCodeAt(I)))return r.slice(0,I+1).replace(/[\\/]/g,l)}}return l}else if(h(i)&&r.charCodeAt(1)===58)return D(r.charCodeAt(2))?r.slice(0,2)+l:r.slice(0,2);let p=r.indexOf("://");if(p!==-1){for(p+=3;p<n;p++)if(D(r.charCodeAt(p)))return r.slice(0,p+1)}return""}e.getRoot=C;function R(r){if(!t.isWindows||!r||r.length<5)return!1;let l=r.charCodeAt(0);if(l!==92||(l=r.charCodeAt(1),l!==92))return!1;let n=2;const i=n;for(;n<r.length&&(l=r.charCodeAt(n),l!==92);n++);return!(i===n||(l=r.charCodeAt(n+1),isNaN(l)||l===92))}e.isUNC=R;const P=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(r,l=t.isWindows){const n=l?P:E;return!(!r||r.length===0||/^\s+$/.test(r)||(n.lastIndex=0,n.test(r))||l&&y.test(r)||r==="."||r===".."||l&&r[r.length-1]==="."||l&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=v;function d(r,l,n){const i=r===l;return!n||i?i:!r||!l?!1:(0,k.equalsIgnoreCase)(r,l)}e.isEqual=d;function g(r,l,n,i=a.sep){if(r===l)return!0;if(!r||!l||l.length>r.length)return!1;if(n){if(!(0,k.startsWithIgnoreCase)(r,l))return!1;if(l.length===r.length)return!0;let I=l.length;return l.charAt(l.length-1)===i&&I--,r.charAt(I)===i}return l.charAt(l.length-1)!==i&&(l+=i),r.indexOf(l)===0}e.isEqualOrParent=g;function h(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=h;function w(r,l){return t.isWindows&&r.endsWith(":")&&(r+=a.sep),(0,a.isAbsolute)(r)||(r=(0,a.join)(l,r)),r=(0,a.normalize)(r),t.isWindows?(r=(0,k.rtrim)(r,a.sep),r.endsWith(":")&&(r+=a.sep)):(r=(0,k.rtrim)(r,a.sep),r||(r=a.sep)),r}e.sanitizeFilePath=w;function m(r){const l=(0,a.normalize)(r);return t.isWindows?r.length>3?!1:f(l)&&(r.length===2||l.charCodeAt(2)===92):l===a.posix.sep}e.isRootOrDriveLetter=m;function f(r,l=t.isWindows){return l?h(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function b(r){return f(r)?r[0]:void 0}e.getDriveLetter=b;function s(r,l,n){return l.length>r.length?-1:r===l?0:(n&&(r=r.toLowerCase(),l=l.toLowerCase()),r.indexOf(l))}e.indexOfPath=s;function o(r){const l=r.split(":");let n,i,p;for(const I of l){const L=Number(I);(0,A.isNumber)(L)?i===void 0?i=L:p===void 0&&(p=L):n=n?[n,I].join(":"):I}if(!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:i!==void 0?i:void 0,column:p!==void 0?p:i!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function u(r,l,n=8){let i="";for(let I=0;I<n;I++)i+=c.charAt(Math.floor(Math.random()*c.length));let p;return l?p=`${l}-${i}`:p=i,r?(0,a.join)(r,p):p}e.randomPath=u}),define(Se[107],ye([1,0,28,8]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function k(...ne){return function(N,z){for(let X=0,_=ne.length;X<_;X++){const ue=ne[X](N,z);if(ue)return ue}return null}}e.or=k,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(ne,N,z){if(!z||z.length<N.length)return null;let X;return ne?X=t.startsWithIgnoreCase(z,N):X=z.indexOf(N)===0,X?N.length>0?[{start:0,end:N.length}]:[]:null}function D(ne,N){const z=N.toLowerCase().indexOf(ne.toLowerCase());return z===-1?null:[{start:z,end:z+ne.length}]}e.matchesContiguousSubString=D;function T(ne,N){return S(ne.toLowerCase(),N.toLowerCase(),0,0)}e.matchesSubString=T;function S(ne,N,z,X){if(z===ne.length)return[];if(X===N.length)return null;if(ne[z]===N[X]){let _=null;return(_=S(ne,N,z+1,X+1))?h({start:X,end:X+1},_):null}return S(ne,N,z,X+1)}function C(ne){return 97<=ne&&ne<=122}function R(ne){return 65<=ne&&ne<=90}e.isUpper=R;function P(ne){return 48<=ne&&ne<=57}function E(ne){return ne===32||ne===9||ne===10||ne===13}const y=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ne=>y.add(ne.charCodeAt(0)));function v(ne){return E(ne)||y.has(ne)}function d(ne,N){return ne===N||v(ne)&&v(N)}function g(ne){return C(ne)||R(ne)||P(ne)}function h(ne,N){return N.length===0?N=[ne]:ne.end===N[0].start?N[0].start=ne.start:N.unshift(ne),N}function w(ne,N){for(let z=N;z<ne.length;z++){const X=ne.charCodeAt(z);if(R(X)||P(X)||z>0&&!g(ne.charCodeAt(z-1)))return z}return ne.length}function m(ne,N,z,X){if(z===ne.length)return[];if(X===N.length)return null;if(ne[z]!==N[X].toLowerCase())return null;{let _=null,ue=X+1;for(_=m(ne,N,z+1,X+1);!_&&(ue=w(N,ue))<N.length;)_=m(ne,N,z+1,ue),ue++;return _===null?null:h({start:X,end:X+1},_)}}function f(ne){let N=0,z=0,X=0,_=0,ue=0;for(let Ie=0;Ie<ne.length;Ie++)ue=ne.charCodeAt(Ie),R(ue)&&N++,C(ue)&&z++,g(ue)&&X++,P(ue)&&_++;const be=N/ne.length,ke=z/ne.length,ge=X/ne.length,Pe=_/ne.length;return{upperPercent:be,lowerPercent:ke,alphaPercent:ge,numericPercent:Pe}}function b(ne){const{upperPercent:N,lowerPercent:z}=ne;return z===0&&N>.6}function s(ne){const{upperPercent:N,lowerPercent:z,alphaPercent:X,numericPercent:_}=ne;return z>.2&&N<.8&&X>.6&&_<.2}function o(ne){let N=0,z=0,X=0,_=0;for(let ue=0;ue<ne.length;ue++)X=ne.charCodeAt(ue),R(X)&&N++,C(X)&&z++,E(X)&&_++;return(N===0||z===0)&&_===0?ne.length<=30:N<=5}function c(ne,N){if(!N||(N=N.trim(),N.length===0)||!o(ne)||N.length>60)return null;const z=f(N);if(!s(z)){if(!b(z))return null;N=N.toLowerCase()}let X=null,_=0;for(ne=ne.toLowerCase();_<N.length&&(X=m(ne,N,0,_))===null;)_=w(N,_+1);return X}e.matchesCamelCase=c;function u(ne,N,z=!1){if(!N||N.length===0)return null;let X=null,_=0;for(ne=ne.toLowerCase(),N=N.toLowerCase();_<N.length&&(X=r(ne,N,0,_,z))===null;)_=l(N,_+1);return X}e.matchesWords=u;function r(ne,N,z,X,_){if(z===ne.length)return[];if(X===N.length)return null;if(d(ne.charCodeAt(z),N.charCodeAt(X))){let ue=null,be=X+1;if(ue=r(ne,N,z+1,X+1,_),!_)for(;!ue&&(be=l(N,be))<N.length;)ue=r(ne,N,z+1,be,_),be++;return ue?ne.charCodeAt(z)!==N.charCodeAt(X)?ue:h({start:X,end:X+1},ue):null}else return null}function l(ne,N){for(let z=N;z<ne.length;z++)if(v(ne.charCodeAt(z))||z>0&&v(ne.charCodeAt(z-1)))return z;return ne.length}const n=k(e.matchesPrefix,c,D),i=k(e.matchesPrefix,c,T),p=new a.LRUCache(1e4);function I(ne,N,z=!1){if(typeof ne!="string"||typeof N!="string")return null;let X=p.get(ne);X||(X=new RegExp(t.convertSimple2RegExpPattern(ne),"i"),p.set(ne,X));const _=X.exec(N);return _?[{start:_.index,end:_.index+_[0].length}]:z?i(ne,N):n(ne,N)}e.matchesFuzzy=I;function L(ne,N){const z=Re(ne,ne.toLowerCase(),0,N,N.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return z?G(z):null}e.matchesFuzzy2=L;function U(ne,N,z,X,_,ue){const be=Math.min(13,ne.length);for(;z<be;z++){const ke=Re(ne,N,z,X,_,ue,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(ke)return ke}return[0,ue]}e.anyScore=U;function G(ne){if(typeof ne>"u")return[];const N=[],z=ne[1];for(let X=ne.length-1;X>1;X--){const _=ne[X]+z,ue=N[N.length-1];ue&&ue.end===_?ue.end=_+1:N.push({start:_,end:_+1})}return N}e.createMatches=G;const V=128;function O(){const ne=[],N=[];for(let z=0;z<=V;z++)N[z]=0;for(let z=0;z<=V;z++)ne.push(N.slice(0));return ne}function B(ne){const N=[];for(let z=0;z<=ne;z++)N[z]=0;return N}const F=B(2*V),$=B(2*V),M=O(),H=O(),K=O(),q=!1;function Y(ne,N,z,X,_){function ue(ke,ge,Pe=" "){for(;ke.length<ge;)ke=Pe+ke;return ke}let be=` |   |${X.split("").map(ke=>ue(ke,3)).join("|")}
`;for(let ke=0;ke<=z;ke++)ke===0?be+=" |":be+=`${N[ke-1]}|`,be+=ne[ke].slice(0,_+1).map(ge=>ue(ge.toString(),3)).join("|")+`
`;return be}function Q(ne,N,z,X){ne=ne.substr(N),z=z.substr(X),console.log(Y(H,ne,ne.length,z,z.length)),console.log(Y(K,ne,ne.length,z,z.length)),console.log(Y(M,ne,ne.length,z,z.length))}function ce(ne,N){if(N<0||N>=ne.length)return!1;const z=ne.codePointAt(N);switch(z){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(z)}}function ie(ne,N){if(N<0||N>=ne.length)return!1;switch(ne.charCodeAt(N)){case 32:case 9:return!0;default:return!1}}function de(ne,N,z){return N[ne]!==z[ne]}function J(ne,N,z,X,_,ue,be=!1){for(;N<z&&_<ue;)ne[N]===X[_]&&(be&&(F[N]=_),N+=1),_+=1;return N===z}e.isPatternInWord=J;var pe;(function(ne){ne[ne.Diag=1]="Diag",ne[ne.Left=2]="Left",ne[ne.LeftLeft=3]="LeftLeft"})(pe||(pe={}));var ve;(function(ne){ne.Default=[-100,0];function N(z){return!z||z.length===2&&z[0]===-100&&z[1]===0}ne.isDefault=N})(ve=e.FuzzyScore||(e.FuzzyScore={}));class De{constructor(N,z){this.firstMatchCanBeWeak=N,this.boostFullMatch=z}}e.FuzzyScoreOptions=De,De.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Re(ne,N,z,X,_,ue,be=De.default){const ke=ne.length>V?V:ne.length,ge=X.length>V?V:X.length;if(z>=ke||ue>=ge||ke-z>ge-ue||!J(N,z,ke,_,ue,ge,!0))return;$e(ke,ge,z,ue,N,_);let Pe=1,Ie=1,je=z,qe=ue;const et=[!1];for(Pe=1,je=z;je<ke;Pe++,je++){const Ue=F[je],it=$[je],oe=je+1<ke?$[je+1]:ge;for(Ie=Ue-ue+1,qe=Ue;qe<oe;Ie++,qe++){let W=Number.MIN_SAFE_INTEGER,ae=!1;qe<=it&&(W=re(ne,N,je,z,X,_,qe,ge,ue,M[Pe-1][Ie-1]===0,et));let Ce=0;W!==Number.MAX_SAFE_INTEGER&&(ae=!0,Ce=W+H[Pe-1][Ie-1]);const Le=qe>Ue,Be=Le?H[Pe][Ie-1]+(M[Pe][Ie-1]>0?-5:0):0,Xe=qe>Ue+1&&M[Pe][Ie-1]>0,Ze=Xe?H[Pe][Ie-2]+(M[Pe][Ie-2]>0?-5:0):0;if(Xe&&(!Le||Ze>=Be)&&(!ae||Ze>=Ce))H[Pe][Ie]=Ze,K[Pe][Ie]=3,M[Pe][Ie]=0;else if(Le&&(!ae||Be>=Ce))H[Pe][Ie]=Be,K[Pe][Ie]=2,M[Pe][Ie]=0;else if(ae)H[Pe][Ie]=Ce,K[Pe][Ie]=1,M[Pe][Ie]=M[Pe-1][Ie-1]+1;else throw new Error("not possible")}}if(q&&Q(ne,z,X,ue),!et[0]&&!be.firstMatchCanBeWeak)return;Pe--,Ie--;const _e=[H[Pe][Ie],ue];let nt=0,st=0;for(;Pe>=1;){let Ue=Ie;do{const it=K[Pe][Ue];if(it===3)Ue=Ue-2;else if(it===2)Ue=Ue-1;else break}while(Ue>=1);nt>1&&N[z+Pe-1]===_[ue+Ie-1]&&!de(Ue+ue-1,X,_)&&nt+1>M[Pe][Ue]&&(Ue=Ie),Ue===Ie?nt++:nt=1,st||(st=Ue),Pe--,Ie=Ue-1,_e.push(Ie)}ge===ke&&be.boostFullMatch&&(_e[0]+=2);const ht=st-ke;return _e[0]-=ht,_e}e.fuzzyScore=Re;function $e(ne,N,z,X,_,ue){let be=ne-1,ke=N-1;for(;be>=z&&ke>=X;)_[be]===ue[ke]&&($[be]=ke,be--),ke--}function re(ne,N,z,X,_,ue,be,ke,ge,Pe,Ie){if(N[z]!==ue[be])return Number.MIN_SAFE_INTEGER;let je=1,qe=!1;return be===z-X?je=ne[z]===_[be]?7:5:de(be,_,ue)&&(be===0||!de(be-1,_,ue))?(je=ne[z]===_[be]?7:5,qe=!0):ce(ue,be)&&(be===0||!ce(ue,be-1))?je=5:(ce(ue,be-1)||ie(ue,be-1))&&(je=5,qe=!0),je>1&&z===X&&(Ie[0]=!0),qe||(qe=de(be,_,ue)||ce(ue,be-1)||ie(ue,be-1)),z===X?be>ge&&(je-=qe?3:5):Pe?je+=qe?2:0:je+=qe?0:1,be+1===ke&&(je-=qe?3:5),je}function le(ne,N,z,X,_,ue,be){return Z(ne,N,z,X,_,ue,!0,be)}e.fuzzyScoreGracefulAggressive=le;function fe(ne,N,z,X,_,ue,be){return Z(ne,N,z,X,_,ue,!1,be)}e.fuzzyScoreGraceful=fe;function Z(ne,N,z,X,_,ue,be,ke){let ge=Re(ne,N,z,X,_,ue,ke);if(ge&&!be)return ge;if(ne.length>=3){const Pe=Math.min(7,ne.length-1);for(let Ie=z+1;Ie<Pe;Ie++){const je=se(ne,Ie);if(je){const qe=Re(je,je.toLowerCase(),z,X,_,ue,ke);qe&&(qe[0]-=3,(!ge||qe[0]>ge[0])&&(ge=qe))}}}return ge}function se(ne,N){if(N+1>=ne.length)return;const z=ne[N],X=ne[N+1];if(z!==X)return ne.slice(0,N)+X+z+ne.slice(N+2)}}),define(Se[83],ye([1,0,8]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(h){return k(h,0)}e.hash=t;function k(h,w){switch(typeof h){case"object":return h===null?A(349,w):Array.isArray(h)?S(h,w):C(h,w);case"string":return T(h,w);case"boolean":return D(h,w);case"number":return A(h,w);case"undefined":return A(937,w);default:return A(617,w)}}e.doHash=k;function A(h,w){return(w<<5)-w+h|0}e.numberHash=A;function D(h,w){return A(h?433:863,w)}function T(h,w){w=A(149417,w);for(let m=0,f=h.length;m<f;m++)w=A(h.charCodeAt(m),w);return w}e.stringHash=T;function S(h,w){return w=A(104579,w),h.reduce((m,f)=>k(f,m),w)}function C(h,w){return w=A(181387,w),Object.keys(h).sort().reduce((m,f)=>(m=T(f,m),k(h[f],m)),w)}class R{constructor(){this.g=0}get value(){return this.g}hash(w){return this.g=k(w,this.g),this.g}}e.Hasher=R;var P;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function E(h,w,m=32){const f=m-w,b=~((1<<f)-1);return(h<<w|(b&h)>>>f)>>>0}function y(h,w=0,m=h.byteLength,f=0){for(let b=0;b<m;b++)h[w+b]=f}function v(h,w,m="0"){for(;h.length<w;)h=m+h;return h}function d(h,w=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(m=>m.toString(16).padStart(2,"0")).join(""):v((h>>>0).toString(16),w/4)}e.toHexString=d;class g{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(w){const m=w.length;if(m===0)return;const f=this.p;let b=this.r,s=this.u,o,c;for(s!==0?(o=s,c=-1,s=0):(o=w.charCodeAt(0),c=0);;){let u=o;if(a.isHighSurrogate(o))if(c+1<m){const r=w.charCodeAt(c+1);a.isLowSurrogate(r)?(c++,u=a.computeCodePoint(o,r)):u=65533}else{s=o;break}else a.isLowSurrogate(o)&&(u=65533);if(b=this.w(f,b,u),c++,c<m)o=w.charCodeAt(c);else break}this.r=b,this.u=s}w(w,m,f){return f<128?w[m++]=f:f<2048?(w[m++]=192|(f&1984)>>>6,w[m++]=128|(f&63)>>>0):f<65536?(w[m++]=224|(f&61440)>>>12,w[m++]=128|(f&4032)>>>6,w[m++]=128|(f&63)>>>0):(w[m++]=240|(f&1835008)>>>18,w[m++]=128|(f&258048)>>>12,w[m++]=128|(f&4032)>>>6,w[m++]=128|(f&63)>>>0),m>=64&&(this.y(),m-=64,this.t+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),m}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),d(this.h)+d(this.l)+d(this.m)+d(this.n)+d(this.o)}x(){this.p[this.r++]=128,y(this.p,this.r),this.r>56&&(this.y(),y(this.p));const w=8*this.t;this.q.setUint32(56,Math.floor(w/4294967296),!1),this.q.setUint32(60,w%4294967296,!1),this.y()}y(){const w=g.g,m=this.q;for(let n=0;n<64;n+=4)w.setUint32(n,m.getUint32(n,!1),!1);for(let n=64;n<320;n+=4)w.setUint32(n,E(w.getUint32(n-12,!1)^w.getUint32(n-32,!1)^w.getUint32(n-56,!1)^w.getUint32(n-64,!1),1),!1);let f=this.h,b=this.l,s=this.m,o=this.n,c=this.o,u,r,l;for(let n=0;n<80;n++)n<20?(u=b&s|~b&o,r=1518500249):n<40?(u=b^s^o,r=1859775393):n<60?(u=b&s|b&o|s&o,r=2400959708):(u=b^s^o,r=3395469782),l=E(f,5)+u+c+r+w.getUint32(n*4,!1)&4294967295,c=o,o=s,s=E(b,30),b=f,f=l;this.h=this.h+f&4294967295,this.l=this.l+b&4294967295,this.m=this.m+s&4294967295,this.n=this.n+o&4294967295,this.o=this.o+c&4294967295}}e.StringSHA1=g,g.g=new DataView(new ArrayBuffer(320))}),define(Se[160],ye([1,0,78,107,8]),function(te,e,a,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const A="$(",D=new RegExp(`\\$\\(${a.CSSIcon.iconNameExpression}(?:${a.CSSIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(a.CSSIcon.iconNameCharacter),S=new RegExp(`(\\\\)?${D.source}`,"g");function C(h){return h.replace(S,(w,m)=>m?w:`\\${w}`)}e.escapeIcons=C;const R=new RegExp(`\\\\${D.source}`,"g");function P(h){return h.replace(R,w=>`\\${w}`)}e.markdownEscapeEscapedIcons=P;const E=new RegExp(`(\\s)?(\\\\)?${D.source}(\\s)?`,"g");function y(h){return h.indexOf(A)===-1?h:h.replace(E,(w,m,f,b)=>f?w:m||b||"")}e.stripIcons=y;function v(h){const w=h.indexOf(A);return w===-1?{text:h}:d(h,w)}e.parseLabelWithIcons=v;function d(h,w){const m=[];let f="";function b(i){if(i){f+=i;for(const p of i)m.push(c)}}let s=-1,o="",c=0,u,r,l=w;const n=h.length;for(b(h.substr(0,w));l<n;)u=h[l],r=h[l+1],u===A[0]&&r===A[1]?(s=l,b(o),o=A,l++):u===")"&&s!==-1?(c+=l-s+1,s=-1,o=""):s!==-1?T.test(u)?o+=u:(b(o),s=-1,o=""):b(u),l++;return b(o),{text:f,iconOffsets:m}}function g(h,w,m=!1){const{text:f,iconOffsets:b}=w;if(!b||b.length===0)return(0,t.matchesFuzzy)(h,f,m);const s=(0,k.ltrim)(f," "),o=f.length-s.length,c=(0,t.matchesFuzzy)(h,s,m);if(c)for(const u of c){const r=b[u.start+o]+o;u.start+=r,u.end+=r}return c}e.matchesFuzzyIconAware=g}),define(Se[42],ye([1,0,8]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(t||(t={})),function(k){const A="error",D="warning",T="warn",S="info",C="ignore";function R(E){return E?a.equalsIgnoreCase(A,E)?k.Error:a.equalsIgnoreCase(D,E)||a.equalsIgnoreCase(T,E)?k.Warning:a.equalsIgnoreCase(S,E)?k.Info:k.Ignore:k.Ignore}k.fromValue=R;function P(E){switch(E){case k.Error:return A;case k.Warning:return D;case k.Info:return S;default:return C}}k.toString=P}(t||(t={})),e.default=t}),define(Se[64],ye([1,0,17,8]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class k{constructor(){this.b="",this.c=0}reset(y){return this.b=y,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(y){const v=y.charCodeAt(0),d=this.b.charCodeAt(this.c);return v-d}value(){return this.b[this.c]}}e.StringIterator=k;class A{constructor(y=!0){this.e=y}reset(y){return this.b=y,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let y=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(y)this.c++;else break;else y=!1;return this}cmp(y){return this.e?(0,t.compareSubstring)(y,this.b,0,y.length,this.c,this.d):(0,t.compareSubstringIgnoreCase)(y,this.b,0,y.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=A;class D{constructor(y=!0,v=!0){this.f=y,this.g=v}reset(y){this.d=0,this.e=0,this.b=y,this.c=y.length;for(let v=y.length-1;v>=0;v--,this.c--){const d=this.b.charCodeAt(v);if(!(d===47||this.f&&d===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let y=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(y)this.d++;else break;else y=!1}return this}cmp(y){return this.g?(0,t.compareSubstring)(y,this.b,0,y.length,this.d,this.e):(0,t.compareSubstringIgnoreCase)(y,this.b,0,y.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=D;var T;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(T||(T={}));class S{constructor(y,v){this.f=y,this.g=v,this.d=[],this.e=0}reset(y){return this.c=y,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(y)),this.b.reset(y.path),this.b.value()&&this.d.push(3)),this.g(y)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(y){if(this.d[this.e]===1)return(0,t.compareIgnoreCase)(y,this.c.scheme);if(this.d[this.e]===2)return(0,t.compareIgnoreCase)(y,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(y);if(this.d[this.e]===4)return(0,t.compare)(y,this.c.query);if(this.d[this.e]===5)return(0,t.compare)(y,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=S;class C{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(R||(R={}));class P{static forUris(y=()=>!1,v=()=>!1){return new P(new S(y,v))}static forPaths(y=!1){return new P(new D(void 0,!y))}static forStrings(){return new P(new k)}static forConfigKeys(){return new P(new A)}constructor(y){this.b=y}clear(){this.c=void 0}fill(y,v){if(v){const d=v.slice(0);(0,a.shuffle)(d);for(const g of d)this.set(g,y)}else{const d=y.slice(0);(0,a.shuffle)(d);for(const g of d)this.set(g[0],g[1])}}set(y,v){const d=this.b.reset(y);let g;this.c||(this.c=new C,this.c.segment=d.value());const h=[];for(g=this.c;;){const m=d.cmp(g.segment);if(m>0)g.left||(g.left=new C,g.left.segment=d.value()),h.push([-1,g]),g=g.left;else if(m<0)g.right||(g.right=new C,g.right.segment=d.value()),h.push([1,g]),g=g.right;else if(d.hasNext())d.next(),g.mid||(g.mid=new C,g.mid.segment=d.value()),h.push([0,g]),g=g.mid;else break}const w=g.value;g.value=v,g.key=y;for(let m=h.length-1;m>=0;m--){const f=h[m][1];f.updateHeight();const b=f.balanceFactor();if(b<-1||b>1){const s=h[m][0],o=h[m+1][0];if(s===1&&o===1)h[m][1]=f.rotateLeft();else if(s===-1&&o===-1)h[m][1]=f.rotateRight();else if(s===1&&o===-1)f.right=h[m+1][1]=h[m+1][1].rotateRight(),h[m][1]=f.rotateLeft();else if(s===-1&&o===1)f.left=h[m+1][1]=h[m+1][1].rotateLeft(),h[m][1]=f.rotateRight();else throw new Error;if(m>0)switch(h[m-1][0]){case-1:h[m-1][1].left=h[m][1];break;case 1:h[m-1][1].right=h[m][1];break;case 0:h[m-1][1].mid=h[m][1];break}else this.c=h[0][1]}}return w}get(y){return this.d(y)?.value}d(y){const v=this.b.reset(y);let d=this.c;for(;d;){const g=v.cmp(d.segment);if(g>0)d=d.left;else if(g<0)d=d.right;else if(v.hasNext())v.next(),d=d.mid;else break}return d}has(y){const v=this.d(y);return!(v?.value===void 0&&v?.mid===void 0)}delete(y){return this.e(y,!1)}deleteSuperstr(y){return this.e(y,!0)}e(y,v){const d=this.b.reset(y),g=[];let h=this.c;for(;h;){const w=d.cmp(h.segment);if(w>0)g.push([-1,h]),h=h.left;else if(w<0)g.push([1,h]),h=h.right;else if(d.hasNext())d.next(),g.push([0,h]),h=h.mid;else break}if(!!h){if(v?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const w=this.f(h.right);if(w.key){const{key:m,value:f,segment:b}=w;this.e(w.key,!1),h.key=m,h.value=f,h.segment=b}}else{const w=h.left??h.right;if(g.length>0){const[m,f]=g[g.length-1];switch(m){case-1:f.left=w;break;case 0:f.mid=w;break;case 1:f.right=w;break}}else this.c=w}for(let w=g.length-1;w>=0;w--){const m=g[w][1];m.updateHeight();const f=m.balanceFactor();if(f>1?(m.right.balanceFactor()>=0||(m.right=m.right.rotateRight()),g[w][1]=m.rotateLeft()):f<-1&&(m.left.balanceFactor()<=0||(m.left=m.left.rotateLeft()),g[w][1]=m.rotateRight()),w>0)switch(g[w-1][0]){case-1:g[w-1][1].left=g[w][1];break;case 1:g[w-1][1].right=g[w][1];break;case 0:g[w-1][1].mid=g[w][1];break}else this.c=g[0][1]}}}f(y){for(;y.left;)y=y.left;return y}findSubstr(y){const v=this.b.reset(y);let d=this.c,g;for(;d;){const h=v.cmp(d.segment);if(h>0)d=d.left;else if(h<0)d=d.right;else if(v.hasNext())v.next(),g=d.value||g,d=d.mid;else break}return d&&d.value||g}findSuperstr(y){const v=this.b.reset(y);let d=this.c;for(;d;){const g=v.cmp(d.segment);if(g>0)d=d.left;else if(g<0)d=d.right;else if(v.hasNext())v.next(),d=d.mid;else return d.mid?this.g(d.mid):void 0}}forEach(y){for(const[v,d]of this)y(d,v)}*[Symbol.iterator](){yield*this.g(this.c)}g(y){const v=[];return this.h(y,v),v[Symbol.iterator]()}h(y,v){!y||(y.left&&this.h(y.left,v),y.value&&v.push([y.key,y.value]),y.mid&&this.h(y.mid,v),y.right&&this.h(y.right,v))}_isBalanced(){const y=v=>{if(!v)return!0;const d=v.balanceFactor();return d<-1||d>1?!1:y(v.left)&&y(v.right)};return y(this.c)}}e.TernarySearchTree=P}),define(Se[2],ye([1,0,9,12]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,A=/^\//,D=/^\/\//;function T(c,u){if(!c.scheme&&u)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${c.authority}", path: "${c.path}", query: "${c.query}", fragment: "${c.fragment}"}`);if(c.scheme&&!k.test(c.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(c.path){if(c.authority){if(!A.test(c.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(c.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(c,u){return!c&&!u?"file":c}function C(c,u){switch(c){case"https":case"http":case"file":u?u[0]!==P&&(u=P+u):u=P;break}return u}const R="",P="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(u){return u instanceof y?!0:u?typeof u.authority=="string"&&typeof u.fragment=="string"&&typeof u.path=="string"&&typeof u.query=="string"&&typeof u.scheme=="string"&&typeof u.fsPath=="string"&&typeof u.with=="function"&&typeof u.toString=="function":!1}constructor(u,r,l,n,i,p=!1){typeof u=="object"?(this.scheme=u.scheme||R,this.authority=u.authority||R,this.path=u.path||R,this.query=u.query||R,this.fragment=u.fragment||R):(this.scheme=S(u,p),this.authority=r||R,this.path=C(this.scheme,l||R),this.query=n||R,this.fragment=i||R,T(this,p))}get fsPath(){return m(this,!1)}with(u){if(!u)return this;let{scheme:r,authority:l,path:n,query:i,fragment:p}=u;return r===void 0?r=this.scheme:r===null&&(r=R),l===void 0?l=this.authority:l===null&&(l=R),n===void 0?n=this.path:n===null&&(n=R),i===void 0?i=this.query:i===null&&(i=R),p===void 0?p=this.fragment:p===null&&(p=R),r===this.scheme&&l===this.authority&&n===this.path&&i===this.query&&p===this.fragment?this:new d(r,l,n,i,p)}static parse(u,r=!1){const l=E.exec(u);return l?new d(l[2]||R,o(l[4]||R),o(l[5]||R),o(l[7]||R),o(l[9]||R),r):new d(R,R,R,R,R)}static file(u){let r=R;if(t.isWindows&&(u=u.replace(/\\/g,P)),u[0]===P&&u[1]===P){const l=u.indexOf(P,2);l===-1?(r=u.substring(2),u=P):(r=u.substring(2,l),u=u.substring(l)||P)}return new d("file",r,u,R,R)}static from(u){const r=new d(u.scheme,u.authority,u.path,u.query,u.fragment);return T(r,!0),r}static joinPath(u,...r){if(!u.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return t.isWindows&&u.scheme==="file"?l=y.file(a.win32.join(m(u,!0),...r)).path:l=a.posix.join(u.path,...r),u.with({path:l})}toString(u=!1){return f(this,u)}toJSON(){return this}static revive(u){if(u){if(u instanceof y)return u;{const r=new d(u);return r._formatted=u.external,r._fsPath=u._sep===v?u.fsPath:null,r}}else return u}}e.URI=y;const v=t.isWindows?1:void 0;class d extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(u=!1){return u?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const u={$mid:1};return this._fsPath&&(u.fsPath=this._fsPath,u._sep=v),this._formatted&&(u.external=this._formatted),this.path&&(u.path=this.path),this.scheme&&(u.scheme=this.scheme),this.authority&&(u.authority=this.authority),this.query&&(u.query=this.query),this.fragment&&(u.fragment=this.fragment),u}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(c,u){let r,l=-1;for(let n=0;n<c.length;n++){const i=c.charCodeAt(n);if(i>=97&&i<=122||i>=65&&i<=90||i>=48&&i<=57||i===45||i===46||i===95||i===126||u&&i===47)l!==-1&&(r+=encodeURIComponent(c.substring(l,n)),l=-1),r!==void 0&&(r+=c.charAt(n));else{r===void 0&&(r=c.substr(0,n));const p=g[i];p!==void 0?(l!==-1&&(r+=encodeURIComponent(c.substring(l,n)),l=-1),r+=p):l===-1&&(l=n)}}return l!==-1&&(r+=encodeURIComponent(c.substring(l))),r!==void 0?r:c}function w(c){let u;for(let r=0;r<c.length;r++){const l=c.charCodeAt(r);l===35||l===63?(u===void 0&&(u=c.substr(0,r)),u+=g[l]):u!==void 0&&(u+=c[r])}return u!==void 0?u:c}function m(c,u){let r;return c.authority&&c.path.length>1&&c.scheme==="file"?r=`//${c.authority}${c.path}`:c.path.charCodeAt(0)===47&&(c.path.charCodeAt(1)>=65&&c.path.charCodeAt(1)<=90||c.path.charCodeAt(1)>=97&&c.path.charCodeAt(1)<=122)&&c.path.charCodeAt(2)===58?u?r=c.path.substr(1):r=c.path[1].toLowerCase()+c.path.substr(2):r=c.path,t.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=m;function f(c,u){const r=u?w:h;let l="",{scheme:n,authority:i,path:p,query:I,fragment:L}=c;if(n&&(l+=n,l+=":"),(i||n==="file")&&(l+=P,l+=P),i){let U=i.indexOf("@");if(U!==-1){const G=i.substr(0,U);i=i.substr(U+1),U=G.indexOf(":"),U===-1?l+=r(G,!1):(l+=r(G.substr(0,U),!1),l+=":",l+=r(G.substr(U+1),!1)),l+="@"}i=i.toLowerCase(),U=i.indexOf(":"),U===-1?l+=r(i,!1):(l+=r(i.substr(0,U),!1),l+=i.substr(U))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const U=p.charCodeAt(1);U>=65&&U<=90&&(p=`/${String.fromCharCode(U+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const U=p.charCodeAt(0);U>=65&&U<=90&&(p=`${String.fromCharCode(U+32)}:${p.substr(2)}`)}l+=r(p,!0)}return I&&(l+="?",l+=r(I,!1)),L&&(l+="#",l+=u?L:h(L,!1)),l}function b(c){try{return decodeURIComponent(c)}catch{return c.length>3?c.substr(0,3)+b(c.substr(3)):c}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(c){return c.match(s)?c.replace(s,u=>b(u)):c}}),define(Se[84],ye([1,0,22,8,2]),function(te,e,a,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(C){return JSON.stringify(C,T)}e.stringify=A;function D(C){let R=JSON.parse(C);return R=S(R),R}e.parse=D;function T(C,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,t.regExpFlags)(R)}:R}function S(C,R=0){if(!C||R>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return k.URI.revive(C);case 2:return new RegExp(C.source,C.flags);case 16:return new Date(C.source)}if(C instanceof a.VSBuffer||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let P=0;P<C.length;++P)C[P]=S(C[P],R+1);else for(const P in C)Object.hasOwnProperty.call(C,P)&&(C[P]=S(C[P],R+1))}return C}e.revive=S}),define(Se[15],ye([1,0,12,2]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(C){this.d=C}setDelegate(C){this.e=C}setServerRootPath(C){this.f=`${C}/${k.vscodeRemoteResource}`}set(C,R,P){this.a[C]=R,this.b[C]=P}setConnectionToken(C,R){this.c[C]=R}getPreferredWebSchema(){return this.d}rewrite(C){if(this.e)return this.e(C);const R=C.authority;let P=this.a[R];P&&P.indexOf(":")!==-1&&P.indexOf("[")===-1&&(P=`[${P}]`);const E=this.b[R],y=this.c[R];let v=`path=${encodeURIComponent(C.path)}`;return typeof y=="string"&&(v+=`&${e.connectionTokenQueryName}=${encodeURIComponent(y)}`),t.URI.from({scheme:a.isWeb?this.d:k.vscodeRemoteResource,authority:`${P}:${E}`,path:this.f,query:v})}}e.RemoteAuthorities=new A,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class D{asBrowserUri(C){const R=this.b(C,te);return this.uriToBrowserUri(R)}uriToBrowserUri(C){return C.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(C):C.scheme===k.file&&(a.isNative||a.isWebWorker&&a.globals.origin===`${k.vscodeFileResource}://${D.a}`)?C.with({scheme:k.vscodeFileResource,authority:C.authority||D.a,query:null,fragment:null}):C}asFileUri(C){const R=this.b(C,te);return this.uriToFileUri(R)}uriToFileUri(C){return C.scheme===k.vscodeFileResource?C.with({scheme:k.file,authority:C.authority!==D.a?C.authority:null,query:null,fragment:null}):C}b(C,R){return t.URI.isUri(C)?C:t.URI.parse(R.toUrl(C))}}D.a="vscode-app",e.FileAccess=new D;var T;(function(S){const C=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);S.CoopAndCoep=Object.freeze(C.get("3"));const R="vscode-coi";function P(y){let v;typeof y=="string"?v=new URL(y).searchParams:y instanceof URL?v=y.searchParams:t.URI.isUri(y)&&(v=new URL(y.toString(!0)).searchParams);const d=v?.get(R);if(!!d)return C.get(d)}S.getHeadersFromQuery=P;function E(y,v,d){if(!globalThis.crossOriginIsolated)return;const g=v&&d?"3":d?"2":"1";y instanceof URLSearchParams?y.set(R,g):y[R]=g}S.addSearchParam=E})(T=e.COI||(e.COI={}))}),define(Se[24],ye([1,0,32,15,9,12,8,2]),function(te,e,a,t,k,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(y){return(0,T.uriToFsPath)(y,!0)}e.originalFSPath=S;class C{constructor(v){this.a=v}compare(v,d,g=!1){return v===d?0:(0,D.compare)(this.getComparisonKey(v,g),this.getComparisonKey(d,g))}isEqual(v,d,g=!1){return v===d?!0:!v||!d?!1:this.getComparisonKey(v,g)===this.getComparisonKey(d,g)}getComparisonKey(v,d=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,d,g=!1){if(v.scheme===d.scheme){if(v.scheme===t.Schemas.file)return a.isEqualOrParent(S(v),S(d),this.a(v))&&v.query===d.query&&(g||v.fragment===d.fragment);if((0,e.isEqualAuthority)(v.authority,d.authority))return a.isEqualOrParent(v.path,d.path,this.a(v),"/")&&v.query===d.query&&(g||v.fragment===d.fragment)}return!1}joinPath(v,...d){return T.URI.joinPath(v,...d)}basenameOrAuthority(v){return(0,e.basename)(v)||v.authority}basename(v){return k.posix.basename(v.path)}extname(v){return k.posix.extname(v.path)}dirname(v){if(v.path.length===0)return v;let d;return v.scheme===t.Schemas.file?d=T.URI.file(k.dirname(S(v))).path:(d=k.posix.dirname(v.path),v.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),d="/")),v.with({path:d})}normalizePath(v){if(!v.path.length)return v;let d;return v.scheme===t.Schemas.file?d=T.URI.file(k.normalize(S(v))).path:d=k.posix.normalize(v.path),v.with({path:d})}relativePath(v,d){if(v.scheme!==d.scheme||!(0,e.isEqualAuthority)(v.authority,d.authority))return;if(v.scheme===t.Schemas.file){const w=k.relative(S(v),S(d));return A.isWindows?a.toSlashes(w):w}let g=v.path||"/";const h=d.path||"/";if(this.a(v)){let w=0;for(const m=Math.min(g.length,h.length);w<m&&!(g.charCodeAt(w)!==h.charCodeAt(w)&&g.charAt(w).toLowerCase()!==h.charAt(w).toLowerCase());w++);g=h.substr(0,w)+g.substr(w)}return k.posix.relative(g,h)}resolvePath(v,d){if(v.scheme===t.Schemas.file){const g=T.URI.file(k.resolve(S(v),d));return v.with({authority:g.authority,path:g.path})}return d=a.toPosixPath(d),v.with({path:k.posix.resolve(v.path,d)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,d){return v===d||v!==void 0&&d!==void 0&&(0,D.equalsIgnoreCase)(v,d)}hasTrailingPathSeparator(v,d=k.sep){if(v.scheme===t.Schemas.file){const g=S(v);return g.length>a.getRoot(g).length&&g[g.length-1]===d}else{const g=v.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,d=k.sep){return(0,e.hasTrailingPathSeparator)(v,d)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,d=k.sep){let g=!1;if(v.scheme===t.Schemas.file){const h=S(v);g=h!==void 0&&h.length===a.getRoot(h).length&&h[h.length-1]===d}else{d="/";const h=v.path;g=h.length===1&&h.charCodeAt(h.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(v,d)?v.with({path:v.path+"/"}):v}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(y=>y.scheme===t.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new C(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(y,v){const d=[];for(let g=0;g<y.length;g++){const h=v(y[g]);y.some((w,m)=>m===g?!1:(0,e.isEqualOrParent)(h,v(w)))||d.push(y[g])}return d}e.distinctParents=R;var P;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function v(d){const g=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(m=>{const[f,b]=m.split(":");f&&b&&g.set(f,b)});const w=d.path.substring(0,d.path.indexOf(";"));return w&&g.set(y.META_DATA_MIME,w),g}y.parseMetaData=v})(P=e.DataUri||(e.DataUri={}));function E(y,v,d){if(v){let g=y.path;return g&&g[0]!==k.posix.sep&&(g=k.posix.sep+g),y.with({scheme:d,authority:v,path:g})}return y.with({scheme:d})}e.toLocalResource=E}),define(Se[18],ye([1,0,21,10,4,6,24,12]),function(te,e,a,t,k,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(de){return!!de&&typeof de.then=="function"}e.isThenable=S;function C(de){const J=new a.CancellationTokenSource,pe=de(J.token),ve=new Promise((De,Re)=>{const $e=J.token.onCancellationRequested(()=>{$e.dispose(),J.dispose(),Re(new t.CancellationError)});Promise.resolve(pe).then(re=>{$e.dispose(),J.dispose(),De(re)},re=>{$e.dispose(),J.dispose(),Re(re)})});return new class{cancel(){J.cancel()}then(De,Re){return ve.then(De,Re)}catch(De){return this.then(void 0,De)}finally(De){return ve.finally(De)}}}e.createCancelablePromise=C;function R(de,J,pe){return new Promise((ve,De)=>{const Re=J.onCancellationRequested(()=>{Re.dispose(),ve(pe)});de.then(ve,De).finally(()=>Re.dispose())})}e.raceCancellation=R;function P(de,J){return new Promise((pe,ve)=>{const De=J.onCancellationRequested(()=>{De.dispose(),ve(new t.CancellationError)});de.then(pe,ve).finally(()=>De.dispose())})}e.raceCancellationError=P;async function E(de){let J=-1;const pe=de.map((De,Re)=>De.then($e=>(J=Re,$e))),ve=await Promise.race(pe);return de.forEach((De,Re)=>{Re!==J&&De.cancel()}),ve}e.raceCancellablePromises=E;function y(de,J,pe){let ve;const De=setTimeout(()=>{ve?.(void 0),pe?.()},J);return Promise.race([de.finally(()=>clearTimeout(De)),new Promise(Re=>ve=Re)])}e.raceTimeout=y;function v(de){return new Promise((J,pe)=>{const ve=de();S(ve)?ve.then(J,pe):J(ve)})}e.asPromise=v;class d{constructor(){this.a=null,this.b=null,this.d=null}queue(J){if(this.a){if(this.d=J,!this.b){const pe=()=>{this.b=null;const ve=this.queue(this.d);return this.d=null,ve};this.b=new Promise(ve=>{this.a.then(pe,pe).then(ve)})}return new Promise((pe,ve)=>{this.b.then(pe,ve)})}return this.a=J(),new Promise((pe,ve)=>{this.a.then(De=>{this.a=null,pe(De)},De=>{this.a=null,ve(De)})})}}e.Throttler=d;class g{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.Sequencer=g;class h{constructor(){this.a=new Map}queue(J,pe){const De=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(pe).finally(()=>{this.a.get(J)===De&&this.a.delete(J)});return this.a.set(J,De),De}}e.SequencerByKey=h;const w=(de,J)=>{let pe=!0;const ve=setTimeout(()=>{pe=!1,J()},de);return{isTriggered:()=>pe,dispose:()=>{clearTimeout(ve),pe=!1}}},m=de=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,de())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class f{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,pe=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((De,Re)=>{this.d=De,this.f=Re}).then(()=>{if(this.b=null,this.d=null,this.g){const De=this.g;return this.g=null,De()}}));const ve=()=>{this.a=null,this.d?.(null)};return this.a=pe===e.MicrotaskDelay?m(ve):w(pe,ve),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=f;class b{constructor(J){this.a=new f(J),this.b=new d}trigger(J,pe){return this.a.trigger(()=>this.b.queue(J),pe)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=b;class s{constructor(){this.a=!1,this.b=new Promise((J,pe)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=s;class o extends s{constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=o;function c(de,J){return J?new Promise((pe,ve)=>{const De=setTimeout(()=>{Re.dispose(),pe()},de),Re=J.onCancellationRequested(()=>{clearTimeout(De),Re.dispose(),ve(new t.CancellationError)})}):C(pe=>c(de,pe))}e.timeout=c;function u(de,J=0){const pe=setTimeout(de,J);return(0,A.toDisposable)(()=>clearTimeout(pe))}e.disposableTimeout=u;function r(de){const J=[];let pe=0;const ve=de.length;function De(){return pe<ve?de[pe++]():null}function Re($e){$e!=null&&J.push($e);const re=De();return re?re.then(Re):Promise.resolve(J)}return Promise.resolve(null).then(Re)}e.sequence=r;function l(de,J=ve=>!!ve,pe=null){let ve=0;const De=de.length,Re=()=>{if(ve>=De)return Promise.resolve(pe);const $e=de[ve++];return Promise.resolve($e()).then(le=>J(le)?Promise.resolve(le):Re())};return Re()}e.first=l;function n(de,J=ve=>!!ve,pe=null){if(de.length===0)return Promise.resolve(pe);let ve=de.length;const De=()=>{ve=-1;for(const Re of de)Re.cancel?.()};return new Promise((Re,$e)=>{for(const re of de)re.then(le=>{--ve>=0&&J(le)?(De(),Re(le)):ve===0&&Re(pe)}).catch(le=>{--ve>=0&&(De(),$e(le))})})}e.firstParallel=n;class i{constructor(J){this.a=0,this.d=J,this.f=[],this.b=0,this.g=new k.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(J){return this.a++,new Promise((pe,ve)=>{this.f.push({factory:J,c:pe,e:ve}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const J=this.f.shift();this.b++;const pe=J.factory();pe.then(J.c,J.e),pe.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=i;class p extends i{constructor(){super(1)}}e.Queue=p;class I{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const J=new K;return this.b.add(J),J.p}d(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueFor(J,pe=D.extUri){const ve=pe.getComparisonKey(J);let De=this.a.get(ve);return De||(De=new p,k.Event.once(De.onDrained)(()=>{De?.dispose(),this.a.delete(ve),this.f()}),this.a.set(ve,De)),De}f(){!this.d()||this.g()}g(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.g()}}e.ResourceQueue=I;class L{constructor(J,pe){this.a=-1,typeof J=="function"&&typeof pe=="number"&&this.setIfNotSet(J,pe)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,pe){this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},pe)}setIfNotSet(J,pe){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},pe))}}e.TimeoutTimer=L;class U{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(J,pe){this.cancel(),this.a=setInterval(()=>{J()},pe)}}e.IntervalTimer=U;class G{constructor(J,pe){this.b=-1,this.a=J,this.d=pe,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=G;class V{constructor(J,pe){pe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${pe}ms is not a multiple of 1000ms.`),this.a=J,this.b=pe,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=V;class O extends G{constructor(J,pe){super(J,pe),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=O;class B extends A.Disposable{constructor(J,pe){super(),this.g=J,this.h=pe,this.a=[],this.b=this.B(new A.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}return this.a.push(...J),this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new G(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=B,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=de=>{(0,T.setTimeout0)(()=>{if(J)return;const pe=Date.now()+15;de(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let J=!1;return{dispose(){J||(J=!0)}}}:e.runWhenIdle=(de,J)=>{const pe=requestIdleCallback(de,typeof J=="number"?{timeout:J}:void 0);let ve=!1;return{dispose(){ve||(ve=!0,cancelIdleCallback(pe))}}}}();class F{constructor(J){this.d=!1,this.a=()=>{try{this.f=J()}catch(pe){this.g=pe}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=F;async function $(de,J,pe){let ve;for(let De=0;De<pe;De++)try{return await de()}catch(Re){ve=Re,await c(J)}throw ve}e.retry=$;class M{hasPending(J){return this.a?typeof J=="number"?this.a.taskId===J:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(J,pe,ve){return this.a={taskId:J,cancel:()=>ve?.(),promise:pe},pe.then(()=>this.d(J),()=>this.d(J)),pe}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}setNext(J){if(this.b)this.b.run=J;else{let pe,ve;const De=new Promise((Re,$e)=>{pe=Re,ve=$e});this.b={run:J,promise:De,promiseResolve:pe,promiseReject:ve}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=M;class H{constructor(J,pe=()=>Date.now()){this.d=J,this.f=pe,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.IntervalCounter=H;class K{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((J,pe)=>{this.a=J,this.b=pe})}complete(J){return new Promise(pe=>{this.a(J),this.f=!0,pe()})}error(J){return new Promise(pe=>{this.b(J),this.d=!0,pe()})}cancel(){new Promise(J=>{this.b(new t.CancellationError),this.d=!0,J()})}}e.DeferredPromise=K;var q;(function(de){async function J(ve){let De;const Re=await Promise.all(ve.map($e=>$e.then(re=>re,re=>{De||(De=re)})));if(typeof De<"u")throw De;return Re}de.settled=J;function pe(ve){return new Promise(async(De,Re)=>{try{await ve(De,Re)}catch($e){Re($e)}})}de.withAsyncBody=pe})(q=e.Promises||(e.Promises={}));var Y;(function(de){de[de.Initial=0]="Initial",de[de.DoneOK=1]="DoneOK",de[de.DoneError=2]="DoneError"})(Y||(Y={}));class Q{static fromArray(J){return new Q(pe=>{pe.emitMany(J)})}static fromPromise(J){return new Q(async pe=>{pe.emitMany(await J)})}static fromPromises(J){return new Q(async pe=>{await Promise.all(J.map(async ve=>pe.emitOne(await ve)))})}static merge(J){return new Q(async pe=>{await Promise.all(J.map(async ve=>{for await(const De of ve)pe.emitOne(De)}))})}constructor(J){this.a=0,this.b=[],this.d=null,this.f=new k.Emitter,queueMicrotask(async()=>{const pe={emitOne:ve=>this.g(ve),emitMany:ve=>this.h(ve),reject:ve=>this.k(ve)};try{await Promise.resolve(J(pe)),this.j()}catch(ve){this.k(ve)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===1)return{done:!0,value:void 0};await k.Event.toPromise(this.f.event)}while(!0)}}}static map(J,pe){return new Q(async ve=>{for await(const De of J)ve.emitOne(pe(De))})}map(J){return Q.map(this,J)}static filter(J,pe){return new Q(async ve=>{for await(const De of J)pe(De)&&ve.emitOne(De)})}filter(J){return Q.filter(this,J)}static coalesce(J){return Q.filter(J,pe=>!!pe)}coalesce(){return Q.coalesce(this)}static async toPromise(J){const pe=[];for await(const ve of J)pe.push(ve);return pe}toPromise(){return Q.toPromise(this)}g(J){this.a===0&&(this.b.push(J),this.f.fire())}h(J){this.a===0&&(this.b=this.b.concat(J),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(J){this.a===0&&(this.a=2,this.d=J,this.f.fire())}}e.AsyncIterableObject=Q,Q.EMPTY=Q.fromArray([]);class ce extends Q{constructor(J,pe){super(pe),this.l=J}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ce;function ie(de){const J=new a.CancellationTokenSource,pe=de(J.token);return new ce(J,async ve=>{const De=J.token.onCancellationRequested(()=>{De.dispose(),J.dispose(),ve.reject(new t.CancellationError)});try{for await(const Re of pe){if(J.token.isCancellationRequested)return;ve.emitOne(Re)}De.dispose(),J.dispose()}catch(Re){De.dispose(),J.dispose(),ve.reject(Re)}})}e.createCancelableAsyncIterable=ie}),define(Se[108],ye([1,0,18,9]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const k=new a.IdleValue(()=>{const p=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:p,collatorIsNumeric:p.resolvedOptions().numeric}}),A=new a.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),D=new a.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(p,I,L=!1){const U=p||"",G=I||"",V=k.value.collator.compare(U,G);return k.value.collatorIsNumeric&&V===0&&U!==G?U<G?-1:1:V}e.compareFileNames=T;function S(p,I){const L=A.value.collator;return p=p||"",I=I||"",b(L,p,I)}e.compareFileNamesDefault=S;function C(p,I){const L=A.value.collator;return p=p||"",I=I||"",u(p,I)||b(L,p,I)}e.compareFileNamesUpper=C;function R(p,I){const L=A.value.collator;return p=p||"",I=I||"",c(p,I)||b(L,p,I)}e.compareFileNamesLower=R;function P(p,I){return p=p||"",I=I||"",p===I?0:p<I?-1:1}e.compareFileNamesUnicode=P;function E(p,I,L=!1){L||(p=p&&p.toLowerCase(),I=I&&I.toLowerCase());const[U,G]=m(p),[V,O]=m(I);return U!==V?U<V?-1:1:G===O?0:G<O?-1:1}e.noIntlCompareFileNames=E;function y(p,I){const[L,U]=m(p),[G,V]=m(I);let O=k.value.collator.compare(U,V);if(O===0){if(k.value.collatorIsNumeric&&U!==V)return U<V?-1:1;if(O=k.value.collator.compare(L,G),k.value.collatorIsNumeric&&O===0&&L!==G)return L<G?-1:1}return O}e.compareFileExtensions=y;function v(p,I){p=p||"",I=I||"";const L=f(p),U=f(I),G=A.value.collator,V=D.value.collator;return b(V,L,U)||b(G,p,I)}e.compareFileExtensionsDefault=v;function d(p,I){p=p||"",I=I||"";const L=f(p),U=f(I),G=A.value.collator,V=D.value.collator;return b(V,L,U)||u(p,I)||b(G,p,I)}e.compareFileExtensionsUpper=d;function g(p,I){p=p||"",I=I||"";const L=f(p),U=f(I),G=A.value.collator,V=D.value.collator;return b(V,L,U)||c(p,I)||b(G,p,I)}e.compareFileExtensionsLower=g;function h(p,I){p=p||"",I=I||"";const L=f(p).toLowerCase(),U=f(I).toLowerCase();return L!==U?L<U?-1:1:p!==I?p<I?-1:1:0}e.compareFileExtensionsUnicode=h;const w=/^(.*?)(\.([^.]*))?$/;function m(p,I=!1){const L=p?w.exec(p):[];let U=[L&&L[1]||"",L&&L[3]||""];return I&&(!U[0]&&U[1]||U[0]&&U[0].charAt(0)===".")&&(U=[U[0]+"."+U[1],""]),U}function f(p){const I=p?w.exec(p):[];return I&&I[1]&&I[1].charAt(0)!=="."&&I[3]||""}function b(p,I,L){const U=p.compare(I,L);return U!==0?U:I.length!==L.length?I.length<L.length?-1:1:0}function s(p){const I=p.charAt(0);return I.toLocaleUpperCase()!==I}function o(p){const I=p.charAt(0);return I.toLocaleLowerCase()!==I}function c(p,I){return s(p)&&o(I)?-1:o(p)&&s(I)?1:0}function u(p,I){return o(p)&&s(I)?-1:s(p)&&o(I)?1:0}function r(p,I,L=!1){return L||(p=p&&p.toLowerCase(),I=I&&I.toLowerCase()),p===I?0:p<I?-1:1}function l(p,I,L=!1){const U=p.split(t.sep),G=I.split(t.sep),V=U.length-1,O=G.length-1;let B,F;for(let $=0;;$++){if(B=V===$,F=O===$,B&&F)return T(U[$],G[$],L);if(B)return-1;if(F)return 1;const M=r(U[$],G[$],L);if(M!==0)return M}}e.comparePaths=l;function n(p,I,L){const U=p.toLowerCase(),G=I.toLowerCase(),V=i(p,I,L);if(V)return V;const O=U.endsWith(L),B=G.endsWith(L);if(O!==B)return O?-1:1;const F=T(U,G);return F!==0?F:U.localeCompare(G)}e.compareAnything=n;function i(p,I,L){const U=p.toLowerCase(),G=I.toLowerCase(),V=U.startsWith(L),O=G.startsWith(L);if(V!==O)return V?-1:1;if(V&&O){if(U.length<G.length)return-1;if(U.length>G.length)return 1}return 0}e.compareByPrefix=i}),define(Se[109],ye([1,0,108,107,83,9,12,8]),function(te,e,a,t,k,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,C=[S,[]];function R(M,H,K,q){if(!M||!H)return C;const Y=M.length,Q=H.length;if(Y<Q)return C;const ce=M.toLowerCase();return P(H,K,Q,M,ce,Y,q)}e.scoreFuzzy=R;function P(M,H,K,q,Y,Q,ce){const ie=[],de=[];for(let De=0;De<K;De++){const Re=De*Q,$e=Re-Q,re=De>0,le=M[De],fe=H[De];for(let Z=0;Z<Q;Z++){const se=Z>0,ne=Re+Z,N=ne-1,z=$e+Z-1,X=se?ie[N]:0,_=re&&se?ie[z]:0,ue=re&&se?de[z]:0;let be;!_&&re?be=0:be=E(le,fe,q,Y,Z,ue),be&&_+be>=X&&(ce||re||Y.startsWith(H,Z))?(de[ne]=ue+1,ie[ne]=_+be):(de[ne]=S,ie[ne]=X)}}const J=[];let pe=K-1,ve=Q-1;for(;pe>=0&&ve>=0;){const De=pe*Q+ve;de[De]===S||(J.push(ve),pe--),ve--}return[ie[K*Q-1],J.reverse()]}function E(M,H,K,q,Y,Q){let ce=0;if(!y(H,q[Y]))return ce;if(ce+=1,Q>0&&(ce+=Q*5),M===K[Y]&&(ce+=1),Y===0)ce+=8;else{const ie=v(K.charCodeAt(Y-1));ie?ce+=ie:(0,t.isUpper)(K.charCodeAt(Y))&&Q===0&&(ce+=2)}return ce}function y(M,H){return M===H?!0:M==="/"||M==="\\"?H==="/"||H==="\\":!1}function v(M){switch(M){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const d=[void 0,[]];function g(M,H,K=0,q=0){const Y=H;return Y.values&&Y.values.length>1?h(M,Y.values,K,q):w(M,H,K,q)}e.scoreFuzzy2=g;function h(M,H,K,q){let Y=0;const Q=[];for(const ce of H){const[ie,de]=w(M,ce,K,q);if(typeof ie!="number")return d;Y+=ie,Q.push(...de)}return[Y,i(Q)]}function w(M,H,K,q){const Y=(0,t.fuzzyScore)(H.original,H.originalLowercase,K,M,M.toLowerCase(),q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Y?[Y[0],(0,t.createMatches)(Y)]:d}const m=Object.freeze({score:0}),f=1<<18,b=1<<17,s=1<<16;function o(M,H,K,q){const Y=q.values?q.values:[q];return(0,k.hash)({[q.normalized]:{values:Y.map(ce=>({value:ce.normalized,expectContiguousMatch:ce.expectContiguousMatch})),label:M,description:H,allowNonContiguousMatches:K}})}function c(M,H,K,q,Y){if(!M||!H.normalized)return m;const Q=q.getItemLabel(M);if(!Q)return m;const ce=q.getItemDescription(M),ie=o(Q,ce,K,H),de=Y[ie];if(de)return de;const J=u(Q,ce,q.getItemPath(M),H,K);return Y[ie]=J,J}e.scoreItemFuzzy=c;function u(M,H,K,q,Y){const Q=!K||!q.containsPathSeparator;return K&&(D.isLinux?q.pathNormalized===K:(0,T.equalsIgnoreCase)(q.pathNormalized,K))?{score:f,labelMatch:[{start:0,end:M.length}],descriptionMatch:H?[{start:0,end:H.length}]:void 0}:q.values&&q.values.length>1?r(M,H,K,q.values,Q,Y):l(M,H,K,q,Q,Y)}function r(M,H,K,q,Y,Q){let ce=0;const ie=[],de=[];for(const J of q){const{score:pe,labelMatch:ve,descriptionMatch:De}=l(M,H,K,J,Y,Q);if(pe===S)return m;ce+=pe,ve&&ie.push(...ve),De&&de.push(...De)}return{score:ce,labelMatch:i(ie),descriptionMatch:i(de)}}function l(M,H,K,q,Y,Q){if(Y||!H){const[ce,ie]=R(M,q.normalized,q.normalizedLowercase,Q&&!q.expectContiguousMatch);if(ce){const de=(0,t.matchesPrefix)(q.normalized,M);let J;return de?(J=b,J+=Math.round(q.normalized.length/M.length*100)):J=s,{score:J+ce,labelMatch:de||n(ie)}}}if(H){let ce=H;K&&(ce=`${H}${A.sep}`);const ie=ce.length,de=`${ce}${M}`,[J,pe]=R(de,q.normalized,q.normalizedLowercase,Q&&!q.expectContiguousMatch);if(J){const ve=n(pe),De=[],Re=[];return ve.forEach($e=>{$e.start<ie&&$e.end>ie?(De.push({start:0,end:$e.end-ie}),Re.push({start:$e.start,end:ie})):$e.start>=ie?De.push({start:$e.start-ie,end:$e.end-ie}):Re.push($e)}),{score:J,labelMatch:De,descriptionMatch:Re}}}return m}function n(M){const H=[];if(!M)return H;let K;for(const q of M)K&&K.end===q?K.end+=1:(K={start:q,end:q+1},H.push(K));return H}function i(M){const H=M.sort((Y,Q)=>Y.start-Q.start),K=[];let q;for(const Y of H)!q||!p(q,Y)?(q=Y,K.push(Y)):(q.start=Math.min(q.start,Y.start),q.end=Math.max(q.end,Y.end));return K}function p(M,H){return!(M.end<H.start||H.end<M.start)}function I(M,H,K,q,Y,Q){const ce=c(M,K,q,Y,Q),ie=c(H,K,q,Y,Q),de=ce.score,J=ie.score;if((de===f||J===f)&&de!==J)return de===f?-1:1;if(de>s||J>s){if(de!==J)return de>J?-1:1;if(de<b&&J<b){const le=U(ce.labelMatch,ie.labelMatch);if(le!==0)return le}const $e=Y.getItemLabel(M)||"",re=Y.getItemLabel(H)||"";if($e.length!==re.length)return $e.length-re.length}if(de!==J)return de>J?-1:1;const pe=Array.isArray(ce.labelMatch)&&ce.labelMatch.length>0,ve=Array.isArray(ie.labelMatch)&&ie.labelMatch.length>0;if(pe&&!ve)return-1;if(ve&&!pe)return 1;const De=L(M,ce,Y),Re=L(H,ie,Y);return De&&Re&&De!==Re?Re>De?-1:1:G(M,H,K,Y)}e.compareItemsByFuzzyScore=I;function L(M,H,K){let q=-1,Y=-1;if(H.descriptionMatch&&H.descriptionMatch.length?q=H.descriptionMatch[0].start:H.labelMatch&&H.labelMatch.length&&(q=H.labelMatch[0].start),H.labelMatch&&H.labelMatch.length){if(Y=H.labelMatch[H.labelMatch.length-1].end,H.descriptionMatch&&H.descriptionMatch.length){const Q=K.getItemDescription(M);Q&&(Y+=Q.length)}}else H.descriptionMatch&&H.descriptionMatch.length&&(Y=H.descriptionMatch[H.descriptionMatch.length-1].end);return Y-q}function U(M,H){if(!M&&!H||(!M||!M.length)&&(!H||!H.length))return 0;if(!H||!H.length)return-1;if(!M||!M.length)return 1;const K=M[0].start,Y=M[M.length-1].end-K,Q=H[0].start,ie=H[H.length-1].end-Q;return Y===ie?0:ie<Y?1:-1}function G(M,H,K,q){const Y=q.getItemLabel(M)||"",Q=q.getItemLabel(H)||"",ce=q.getItemDescription(M),ie=q.getItemDescription(H),de=Y.length+(ce?ce.length:0),J=Q.length+(ie?ie.length:0);if(de!==J)return de-J;const pe=q.getItemPath(M),ve=q.getItemPath(H);return pe&&ve&&pe.length!==ve.length?pe.length-ve.length:Y!==Q?(0,a.compareAnything)(Y,Q,K.normalized):ce&&ie&&ce!==ie?(0,a.compareAnything)(ce,ie,K.normalized):pe&&ve&&pe!==ve?(0,a.compareAnything)(pe,ve,K.normalized):0}function V(M){return M.startsWith('"')&&M.endsWith('"')}const O=" ";function B(M){typeof M!="string"&&(M="");const H=M.toLowerCase(),{pathNormalized:K,normalized:q,normalizedLowercase:Y}=F(M),Q=K.indexOf(A.sep)>=0,ce=V(M);let ie;const de=M.split(O);if(de.length>1)for(const J of de){const pe=V(J),{pathNormalized:ve,normalized:De,normalizedLowercase:Re}=F(J);De&&(ie||(ie=[]),ie.push({original:J,originalLowercase:J.toLowerCase(),pathNormalized:ve,normalized:De,normalizedLowercase:Re,expectContiguousMatch:pe}))}return{original:M,originalLowercase:H,pathNormalized:K,normalized:q,normalizedLowercase:Y,values:ie,containsPathSeparator:Q,expectContiguousMatch:ce}}e.prepareQuery=B;function F(M){let H;D.isWindows?H=M.replace(/\//g,A.sep):H=M.replace(/\\/g,A.sep);const K=(0,T.stripWildcards)(H).replace(/\s|"/g,"");return{pathNormalized:H,normalized:K,normalizedLowercase:K.toLowerCase()}}function $(M){return Array.isArray(M)?B(M.map(H=>H.original).join(O)):B(M.original)}e.pieceToQuery=$}),define(Se[37],ye([1,0,17,18,32,28,9,12,8]),function(te,e,a,t,k,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",P="[^/\\\\]",E=/\//g;function y(K,q){switch(K){case 0:return"";case 1:return`${P}*?`;default:return`(?:${R}|${P}+${R}${q?`|${R}${P}+`:""})*?`}}function v(K,q){if(!K)return[];const Y=[];let Q=!1,ce=!1,ie="";for(const de of K){switch(de){case q:if(!Q&&!ce){Y.push(ie),ie="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}ie+=de}return ie&&Y.push(ie),Y}e.splitGlobAware=v;function d(K){if(!K)return"";let q="";const Y=v(K,e.GLOB_SPLIT);if(Y.every(Q=>Q===e.GLOBSTAR))q=".*";else{let Q=!1;Y.forEach((ce,ie)=>{if(ce===e.GLOBSTAR){if(Q)return;q+=y(2,ie===Y.length-1)}else{let de=!1,J="",pe=!1,ve="";for(const De of ce){if(De!=="}"&&de){J+=De;continue}if(pe&&(De!=="]"||!ve)){let Re;De==="-"?Re=De:(De==="^"||De==="!")&&!ve?Re="^":De===e.GLOB_SPLIT?Re="":Re=(0,S.escapeRegExpCharacters)(De),ve+=Re;continue}switch(De){case"{":de=!0;continue;case"[":pe=!0;continue;case"}":{q+=`(?:${v(J,",").map(re=>d(re)).join("|")})`,de=!1,J="";break}case"]":{q+="["+ve+"]",pe=!1,ve="";break}case"?":q+=P;continue;case"*":q+=y(1);continue;default:q+=(0,S.escapeRegExpCharacters)(De)}}ie<Y.length-1&&(Y[ie+1]!==e.GLOBSTAR||ie+2<Y.length)&&(q+=R)}Q=ce===e.GLOBSTAR})}return q}const g=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,b=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new A.LRUCache(1e4),o=function(){return!1},c=function(){return null};function u(K,q){if(!K)return c;let Y;typeof K!="string"?Y=K.pattern:Y=K,Y=Y.trim();const Q=`${Y}_${!!q.trimForExclusions}`;let ce=s.get(Q);if(ce)return r(ce,K);let ie;return g.test(Y)?ce=n(Y.substr(4),Y):(ie=h.exec(l(Y,q)))?ce=i(ie[1],Y):(q.trimForExclusions?m:w).test(Y)?ce=p(Y,q):(ie=f.exec(l(Y,q)))?ce=I(ie[1].substr(1),Y,!0):(ie=b.exec(l(Y,q)))?ce=I(ie[1],Y,!1):ce=L(Y),s.set(Q,ce),r(ce,K)}function r(K,q){if(typeof q=="string")return K;const Y=function(Q,ce){return(0,k.isEqualOrParent)(Q,q.base,!T.isLinux)?K((0,S.ltrim)(Q.substr(q.base.length),D.sep),ce):null};return Y.allBasenames=K.allBasenames,Y.allPaths=K.allPaths,Y.basenames=K.basenames,Y.patterns=K.patterns,Y}function l(K,q){return q.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function n(K,q){return function(Y,Q){return typeof Y=="string"&&Y.endsWith(K)?q:null}}function i(K,q){const Y=`/${K}`,Q=`\\${K}`,ce=function(de,J){return typeof de!="string"?null:J?J===K?q:null:de===K||de.endsWith(Y)||de.endsWith(Q)?q:null},ie=[K];return ce.basenames=ie,ce.patterns=[q],ce.allBasenames=ie,ce}function p(K,q){const Y=M(K.slice(1,-1).split(",").map(J=>u(J,q)).filter(J=>J!==c),K),Q=Y.length;if(!Q)return c;if(Q===1)return Y[0];const ce=function(J,pe){for(let ve=0,De=Y.length;ve<De;ve++)if(Y[ve](J,pe))return K;return null},ie=Y.find(J=>!!J.allBasenames);ie&&(ce.allBasenames=ie.allBasenames);const de=Y.reduce((J,pe)=>pe.allPaths?J.concat(pe.allPaths):J,[]);return de.length&&(ce.allPaths=de),ce}function I(K,q,Y){const Q=D.sep===D.posix.sep,ce=Q?K:K.replace(E,D.sep),ie=D.sep+ce,de=D.posix.sep+K;let J;return Y?J=function(pe,ve){return typeof pe=="string"&&(pe===ce||pe.endsWith(ie)||!Q&&(pe===K||pe.endsWith(de)))?q:null}:J=function(pe,ve){return typeof pe=="string"&&(pe===ce||!Q&&pe===K)?q:null},J.allPaths=[(Y?"*/":"./")+K],J}function L(K){try{const q=new RegExp(`^${d(K)}$`);return function(Y){return q.lastIndex=0,typeof Y=="string"&&q.test(Y)?K:null}}catch{return c}}function U(K,q,Y){return!K||typeof q!="string"?!1:G(K)(q,void 0,Y)}e.match=U;function G(K,q={}){if(!K)return o;if(typeof K=="string"||V(K)){const Y=u(K,q);if(Y===c)return o;const Q=function(ce,ie){return!!Y(ce,ie)};return Y.allBasenames&&(Q.allBasenames=Y.allBasenames),Y.allPaths&&(Q.allPaths=Y.allPaths),Q}return F(K,q)}e.parse=G;function V(K){const q=K;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}e.isRelativePattern=V;function O(K){return K.allBasenames||[]}e.getBasenameTerms=O;function B(K){return K.allPaths||[]}e.getPathTerms=B;function F(K,q){const Y=M(Object.getOwnPropertyNames(K).map(J=>$(J,K[J],q)).filter(J=>J!==c)),Q=Y.length;if(!Q)return c;if(!Y.some(J=>!!J.requiresSiblings)){if(Q===1)return Y[0];const J=function(De,Re){let $e;for(let re=0,le=Y.length;re<le;re++){const fe=Y[re](De,Re);if(typeof fe=="string")return fe;(0,t.isThenable)(fe)&&($e||($e=[]),$e.push(fe))}return $e?(async()=>{for(const re of $e){const le=await re;if(typeof le=="string")return le}return null})():null},pe=Y.find(De=>!!De.allBasenames);pe&&(J.allBasenames=pe.allBasenames);const ve=Y.reduce((De,Re)=>Re.allPaths?De.concat(Re.allPaths):De,[]);return ve.length&&(J.allPaths=ve),J}const ce=function(J,pe,ve){let De,Re;for(let $e=0,re=Y.length;$e<re;$e++){const le=Y[$e];le.requiresSiblings&&ve&&(pe||(pe=(0,D.basename)(J)),De||(De=pe.substr(0,pe.length-(0,D.extname)(J).length)));const fe=le(J,pe,De,ve);if(typeof fe=="string")return fe;(0,t.isThenable)(fe)&&(Re||(Re=[]),Re.push(fe))}return Re?(async()=>{for(const $e of Re){const re=await $e;if(typeof re=="string")return re}return null})():null},ie=Y.find(J=>!!J.allBasenames);ie&&(ce.allBasenames=ie.allBasenames);const de=Y.reduce((J,pe)=>pe.allPaths?J.concat(pe.allPaths):J,[]);return de.length&&(ce.allPaths=de),ce}function $(K,q,Y){if(q===!1)return c;const Q=u(K,Y);if(Q===c)return c;if(typeof q=="boolean")return Q;if(q){const ce=q.when;if(typeof ce=="string"){const ie=(de,J,pe,ve)=>{if(!ve||!Q(de,J))return null;const De=ce.replace("$(basename)",pe),Re=ve(De);return(0,t.isThenable)(Re)?Re.then($e=>$e?K:null):Re?K:null};return ie.requiresSiblings=!0,ie}}return Q}function M(K,q){const Y=K.filter(J=>!!J.basenames);if(Y.length<2)return K;const Q=Y.reduce((J,pe)=>{const ve=pe.basenames;return ve?J.concat(ve):J},[]);let ce;if(q){ce=[];for(let J=0,pe=Q.length;J<pe;J++)ce.push(q)}else ce=Y.reduce((J,pe)=>{const ve=pe.patterns;return ve?J.concat(ve):J},[]);const ie=function(J,pe){if(typeof J!="string")return null;if(!pe){let De;for(De=J.length;De>0;De--){const Re=J.charCodeAt(De-1);if(Re===47||Re===92)break}pe=J.substr(De)}const ve=Q.indexOf(pe);return ve!==-1?ce[ve]:null};ie.basenames=Q,ie.patterns=ce,ie.allBasenames=Q;const de=K.filter(J=>!J.basenames);return de.push(ie),de}function H(K,q){return(0,a.equals)(K,q,(Y,Q)=>typeof Y=="string"&&typeof Q=="string"?Y===Q:typeof Y!="string"&&typeof Q!="string"?Y.base===Q.base&&Y.pattern===Q.pattern:!1)}e.patternsEquals=H}),define(Se[110],ye([1,0,10,160,24,8,2]),function(te,e,a,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(g){g[g.Paragraph=0]="Paragraph",g[g.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(h="",w=!1){if(this.value=h,typeof this.value!="string")throw(0,a.illegalArgument)("value");typeof w=="boolean"?(this.isTrusted=w,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=w.isTrusted??void 0,this.supportThemeIcons=w.supportThemeIcons??!1,this.supportHtml=w.supportHtml??!1)}appendText(h,w=0){return this.value+=E(this.supportThemeIcons?(0,t.escapeIcons)(h):h).replace(/([ \t]+)/g,(m,f)=>"&nbsp;".repeat(f.length)).replace(/\>/gm,"\\>").replace(/\n/g,w===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,w){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=w,this.value+="\n```\n",this}appendLink(h,w,m){return this.value+="[",this.value+=this.c(w,"]"),this.value+="](",this.value+=this.c(String(h),")"),m&&(this.value+=` "${this.c(this.c(m,'"'),")")}"`),this.value+=")",this}c(h,w){const m=new RegExp((0,A.escapeRegExpCharacters)(w),"g");return h.replace(m,(f,b)=>h.charAt(b-1)!=="\\"?`\\${f}`:f)}}e.MarkdownString=S;function C(g){return R(g)?!g.value:Array.isArray(g)?g.every(C):!0}e.isEmptyMarkdownString=C;function R(g){return g instanceof S?!0:g&&typeof g=="object"?typeof g.value=="string"&&(typeof g.isTrusted=="boolean"||g.isTrusted===void 0)&&(typeof g.supportThemeIcons=="boolean"||g.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function P(g,h){return g===h?!0:!g||!h?!1:g.value===h.value&&g.isTrusted===h.isTrusted&&g.supportThemeIcons===h.supportThemeIcons&&g.supportHtml===h.supportHtml&&(g.baseUri===h.baseUri||!!g.baseUri&&!!h.baseUri&&(0,k.isEqual)(D.URI.from(g.baseUri),D.URI.from(h.baseUri)))}e.markdownStringEqual=P;function E(g){return g.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=E;function y(g){return g.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=y;function v(g){return g&&g.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=v;function d(g){const h=[],w=g.split("|").map(f=>f.trim());g=w[0];const m=w[1];if(m){const f=/height=(\d+)/.exec(m),b=/width=(\d+)/.exec(m),s=f?f[1]:"",o=b?b[1]:"",c=isFinite(parseInt(o)),u=isFinite(parseInt(s));c&&h.push(`width="${o}"`),u&&h.push(`height="${s}"`)}return{href:g,dimensions:h}}e.parseHrefAndDimensions=d}),define(Se[111],ye([1,0,17,32,9,12,24,8]),function(te,e,a,t,k,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(c,u){const{os:r,tildify:l,relative:n}=u;if(n){const I=C(c,n,r);if(typeof I=="string")return I}let i=c.fsPath;if(r===1&&!A.isWindows?i=i.replace(/\//g,"\\"):r!==1&&A.isWindows&&(i=i.replace(/\\/g,"/")),r!==1&&l?.userHome){const I=l.userHome.fsPath;let L;c.scheme!==l.userHome.scheme&&c.path.startsWith(k.posix.sep)?L=l.userHome.with({path:c.path}).fsPath:L=c.fsPath,i=E(L,I,r)}return(r===1?k.win32:k.posix).normalize(R(i,r===1))}e.getPathLabel=S;function C(c,u,r){const l=r===1?k.win32:k.posix,n=r===3?D.extUri:D.extUriIgnorePathCase,i=u.getWorkspace(),p=(0,a.firstOrDefault)(i.folders);if(!p)return;c.scheme!==p.uri.scheme&&c.path.startsWith(k.posix.sep)&&(c=p.uri.with({path:c.path}));const I=u.getWorkspaceFolder(c);if(!I)return;let L;if(n.isEqual(I.uri,c)?L="":L=n.relativePath(I.uri,c)??"",L&&(L=l.normalize(L)),i.folders.length>1&&!u.noPrefix){const U=I.name?I.name:n.basenameOrAuthority(I.uri);L=L?`${U} \u2022 ${L}`:U}return L}function R(c,u=A.isWindows){return(0,t.hasDriveLetter)(c,u)?c.charAt(0).toUpperCase()+c.slice(1):c}e.normalizeDriveLetter=R;let P=Object.create(null);function E(c,u,r=A.OS){if(r===1||!c||!u)return c;let l=P.original===u?P.normalized:void 0;l||(l=u,A.isWindows&&(l=(0,t.toSlashes)(l)),l=`${(0,T.rtrim)(l,k.posix.sep)}${k.posix.sep}`,P={original:u,normalized:l});let n=c;return A.isWindows&&(n=(0,t.toSlashes)(n)),(r===3?n.startsWith(l):(0,T.startsWithIgnoreCase)(n,l))?`~/${n.substr(l.length)}`:c}e.tildify=E;function y(c,u){return c.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=y;const v="\u2026",d="\\\\",g="~";function h(c,u=k.sep){const r=new Array(c.length);let l=!1;for(let n=0;n<c.length;n++){const i=c[n];if(i===""){r[n]=`.${u}`;continue}if(!i){r[n]=i;continue}l=!0;let p="",I=i;I.indexOf(d)===0?(p=I.substr(0,I.indexOf(d)+d.length),I=I.substr(I.indexOf(d)+d.length)):I.indexOf(u)===0?(p=I.substr(0,I.indexOf(u)+u.length),I=I.substr(I.indexOf(u)+u.length)):I.indexOf(g)===0&&(p=I.substr(0,I.indexOf(g)+g.length),I=I.substr(I.indexOf(g)+g.length));const L=I.split(u);for(let U=1;l&&U<=L.length;U++)for(let G=L.length-U;l&&G>=0;G--){l=!1;let V=L.slice(G,G+U).join(u);for(let O=0;!l&&O<c.length;O++)if(O!==n&&c[O]&&c[O].indexOf(V)>-1){const B=G+U===L.length,F=G>0&&c[O].indexOf(u)>-1?u+V:V,$=c[O].endsWith(F);l=!B||$}if(!l){let O="";(L[0].endsWith(":")||p!=="")&&(G===1&&(G=0,U++,V=L[0]+u+V),G>0&&(O=L[0]+u),O=p+O),G>0&&(O=O+v+u),O=O+V,G+U<L.length&&(O=O+u+v),r[n]=O}}l&&(r[n]=i)}return r}e.shorten=h;var w;(function(c){c[c.TEXT=0]="TEXT",c[c.VARIABLE=1]="VARIABLE",c[c.SEPARATOR=2]="SEPARATOR"})(w||(w={}));function m(c,u=Object.create(null)){const r=[];let l=!1,n="";for(const i of c)if(i==="$"||l&&i==="{")n&&r.push({value:n,type:w.TEXT}),n="",l=!0;else if(i==="}"&&l){const p=u[n];if(typeof p=="string")p.length&&r.push({value:p,type:w.VARIABLE});else if(p){const I=r[r.length-1];(!I||I.type!==w.SEPARATOR)&&r.push({value:p.label,type:w.SEPARATOR})}n="",l=!1}else n+=i;return n&&!l&&r.push({value:n,type:w.TEXT}),r.filter((i,p)=>{if(i.type===w.SEPARATOR){const I=r[p-1],L=r[p+1];return[I,L].every(U=>U&&(U.type===w.VARIABLE||U.type===w.TEXT)&&U.value.length>0)}return!0}).map(i=>i.value).join("")}e.template=m;function f(c,u){return A.isMacintosh||u?c.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):c.replace(/&&|&/g,r=>r==="&"?"&&":"&")}e.mnemonicMenuLabel=f;function b(c,u){return A.isMacintosh||u?c.replace(/\(&&\w\)|&&/g,""):A.isWindows?c.replace(/&&|&/g,r=>r==="&"?"&&":"&"):c.replace(/&&/g,"_")}e.mnemonicButtonLabel=b;function s(c){return c.replace(/&/g,"&&")}e.unmnemonicLabel=s;function o(c){const u=c.indexOf("/")!==-1?k.posix:k.win32,r=u.basename(c),l=u.dirname(c);return r.length?{name:r,parentPath:l}:{name:l,parentPath:""}}e.splitName=o}),define(Se[112],ye([1,0,2]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(R){return R.toJSON()}class k{constructor(P){this.a=P}transformIncoming(P){const E=this.a.transformIncoming(P);return E===P?P:t(a.URI.from(E))}transformOutgoing(P){const E=this.a.transformOutgoing(P);return E===P?P:t(a.URI.from(E))}transformOutgoingURI(P){const E=this.a.transformOutgoing(P);return E===P?P:a.URI.from(E)}transformOutgoingScheme(P){return this.a.transformOutgoingScheme(P)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function A(R,P,E){if(!R||E>200)return null;if(typeof R=="object"){if(R instanceof a.URI)return P.transformOutgoing(R);for(const y in R)if(Object.hasOwnProperty.call(R,y)){const v=A(R[y],P,E+1);v!==null&&(R[y]=v)}}return null}function D(R,P){const E=A(R,P,0);return E===null?R:E}e.transformOutgoingURIs=D;function T(R,P,E,y){if(!R||y>200)return null;if(typeof R=="object"){if(R.$mid===1)return E?a.URI.revive(P.transformIncoming(R)):P.transformIncoming(R);for(const v in R)if(Object.hasOwnProperty.call(R,v)){const d=T(R[v],P,E,y+1);d!==null&&(R[v]=d)}}return null}function S(R,P){const E=T(R,P,!1,0);return E===null?R:E}e.transformIncomingURIs=S;function C(R,P){const E=T(R,P,!0,0);return E===null?R:E}e.transformAndReviveIncomingURIs=C}),define(Se[29],ye([1,0,65,85,310,18,32,81,9,12,24,2]),function(te,e,a,t,k,A,D,T,S,C,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function y(F,$=E.UNLINK){if((0,D.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");return $===E.UNLINK?d(F):v(F)}async function v(F){try{const $=(0,D.randomPath)((0,t.tmpdir)());try{await a.promises.rename(F,$)}catch(M){return M.code==="ENOENT"?void 0:d(F)}d($).catch(M=>{})}catch($){if($.code!=="ENOENT")throw $}}async function d(F){return(0,k.promisify)(a.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function g(F){if((0,D.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");a.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=g;async function h(F,$){return f(await($?w(F):(0,k.promisify)(a.readdir)(F)))}async function w(F){try{return await(0,k.promisify)(a.readdir)(F,{withFileTypes:!0})}catch(H){console.warn("[node.js fs] readdir with filetypes failed with error: ",H)}const $=[],M=await h(F);for(const H of M){let K=!1,q=!1,Y=!1;try{const Q=await e.Promises.lstat((0,S.join)(F,H));K=Q.isFile(),q=Q.isDirectory(),Y=Q.isSymbolicLink()}catch(Q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Q)}$.push({name:H,isFile:()=>K,isDirectory:()=>q,isSymbolicLink:()=>Y})}return $}function m(F){return f(a.readdirSync(F))}e.readdirSync=m;function f(F){return F.map($=>typeof $=="string"?C.isMacintosh?(0,T.normalizeNFC)($):$:($.name=C.isMacintosh?(0,T.normalizeNFC)($.name):$.name,$))}async function b(F){const $=await h(F),M=[];for(const H of $)await o.existsDirectory((0,S.join)(F,H))&&M.push(H);return M}function s(F,$=1e3){return new Promise(M=>{let H=!1;const K=setInterval(()=>{H||(H=!0,a.access(F,q=>{H=!1,q&&(clearInterval(K),M(void 0))}))},$)})}e.whenDeleted=s;var o;(function(F){async function $(K){let q;try{if(q=await e.Promises.lstat(K),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(K),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(C.isWindows&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(K)),symbolicLink:{dangling:!1}}}catch(Q){if(Q.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw Q}throw Y}}F.stat=$;async function M(K){try{const{stat:q,symbolicLink:Y}=await F.stat(K);return q.isFile()&&Y?.dangling!==!0}catch{}return!1}F.existsFile=M;async function H(K){try{const{stat:q,symbolicLink:Y}=await F.stat(K);return q.isDirectory()&&Y?.dangling!==!0}catch{}return!1}F.existsDirectory=H})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const c=new A.ResourceQueue;function u(F,$,M){return c.queueFor(P.URI.file(F),R.extUriBiasedIgnorePathCase).queue(()=>{const H=p(M);return new Promise((K,q)=>n(F,$,H,Y=>Y?q(Y):K()))})}let r=!0;function l(F){r=F}e.configureFlushOnWrite=l;function n(F,$,M,H){if(!r)return a.writeFile(F,$,{mode:M.mode,flag:M.flag},H);a.open(F,M.flag,M.mode,(K,q)=>{if(K)return H(K);a.writeFile(q,$,Y=>{if(Y)return a.close(q,()=>H(Y));a.fdatasync(q,Q=>(Q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Q),l(!1)),a.close(q,ce=>H(ce))))})})}function i(F,$,M){const H=p(M);if(!r)return a.writeFileSync(F,$,{mode:H.mode,flag:H.flag});const K=a.openSync(F,H.flag,H.mode);try{a.writeFileSync(K,$);try{a.fdatasyncSync(K)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),l(!1)}}finally{a.closeSync(K)}}e.writeFileSync=i;function p(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function I(F,$){if(F!==$)try{await e.Promises.rename(F,$)}catch(M){if(F.toLowerCase()!==$.toLowerCase()&&M.code==="EXDEV"||F.endsWith("."))await L(F,$,{preserveSymlinks:!1}),await y(F,E.MOVE);else throw M}}async function L(F,$,M){return G(F,$,{root:{source:F,target:$},options:M,handledSourcePaths:new Set})}const U=511;async function G(F,$,M){if(M.handledSourcePaths.has(F))return;M.handledSourcePaths.add(F);const{stat:H,symbolicLink:K}=await o.stat(F);if(K){if(M.options.preserveSymlinks)try{return await B(F,$,M)}catch(q){console.warn("[node.js fs] copy of symlink failed: ",q)}if(K.dangling)return}return H.isDirectory()?V(F,$,H.mode&U,M):O(F,$,H.mode&U)}async function V(F,$,M,H){await e.Promises.mkdir($,{recursive:!0,mode:M});const K=await h(F);for(const q of K)await G((0,S.join)(F,q),(0,S.join)($,q),H)}async function O(F,$,M){await e.Promises.copyFile(F,$),await e.Promises.chmod($,M)}async function B(F,$,M){let H=await e.Promises.readlink(F);(0,D.isEqualOrParent)(H,M.root.source,!C.isLinux)&&(H=(0,S.join)(M.root.target,H.substr(M.root.source.length+1))),await e.Promises.symlink(H,$)}e.Promises=new class{get access(){return(0,k.promisify)(a.access)}get stat(){return(0,k.promisify)(a.stat)}get lstat(){return(0,k.promisify)(a.lstat)}get utimes(){return(0,k.promisify)(a.utimes)}get read(){return(F,$,M,H,K)=>new Promise((q,Y)=>{a.read(F,$,M,H,K,(Q,ce,ie)=>Q?Y(Q):q({bytesRead:ce,buffer:ie}))})}get readFile(){return(0,k.promisify)(a.readFile)}get write(){return(F,$,M,H,K)=>new Promise((q,Y)=>{a.write(F,$,M,H,K,(Q,ce,ie)=>Q?Y(Q):q({bytesWritten:ce,buffer:ie}))})}get appendFile(){return(0,k.promisify)(a.appendFile)}get fdatasync(){return(0,k.promisify)(a.fdatasync)}get truncate(){return(0,k.promisify)(a.truncate)}get rename(){return(0,k.promisify)(a.rename)}get copyFile(){return(0,k.promisify)(a.copyFile)}get open(){return(0,k.promisify)(a.open)}get close(){return(0,k.promisify)(a.close)}get symlink(){return(0,k.promisify)(a.symlink)}get readlink(){return(0,k.promisify)(a.readlink)}get chmod(){return(0,k.promisify)(a.chmod)}get mkdir(){return(0,k.promisify)(a.mkdir)}get unlink(){return(0,k.promisify)(a.unlink)}get rmdir(){return(0,k.promisify)(a.rmdir)}get realpath(){return(0,k.promisify)(a.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return b}get writeFile(){return u}get rm(){return y}get move(){return I}get copy(){return L}}}),define(Se[113],ye([1,0,65,9,12,8,29]),function(te,e,a,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function T(E){if(k.isLinux)return E;const y=(0,t.dirname)(E);if(E===y)return E;const v=((0,t.basename)(E)||E).toLowerCase();try{const g=(0,D.readdirSync)(y).filter(h=>h.toLowerCase()===v);if(g.length===1){const h=T(y);if(h)return(0,t.join)(h,g[0])}else if(g.length>1){const h=g.indexOf(v);if(h>=0){const w=T(y);if(w)return(0,t.join)(w,g[h])}}}catch{}return null}e.realcaseSync=T;async function S(E){if(k.isLinux)return E;const y=(0,t.dirname)(E);if(E===y)return E;const v=((0,t.basename)(E)||E).toLowerCase();try{const g=(await D.Promises.readdir(y)).filter(h=>h.toLowerCase()===v);if(g.length===1){const h=await S(y);if(h)return(0,t.join)(h,g[0])}else if(g.length>1){const h=g.indexOf(v);if(h>=0){const w=await S(y);if(w)return(0,t.join)(w,g[h])}}}catch{}return null}e.realcase=S;async function C(E){try{return await D.Promises.realpath(E)}catch{const v=P(E);return await D.Promises.access(v,a.constants.R_OK),v}}e.realpath=C;function R(E){try{return a.realpathSync(E)}catch{const v=P(E);return a.accessSync(v,a.constants.R_OK),v}}e.realpathSync=R;function P(E){return(0,A.rtrim)((0,t.normalize)(E),t.sep)}}),define(Se[114],ye([1,0,9,12,36,106,11,29]),function(te,e,a,t,k,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function S(P=k.env){return P.comspec||"cmd.exe"}e.getWindowsShell=S;function C(P){let E=[],y=!1;const v=function(d){if(y){E.push(d);return}(!P.send(d,h=>{if(h&&console.error(h),y=!1,E.length>0){const w=E.slice(0);E=[],w.forEach(m=>v(m))}})||t.isWindows)&&(y=!0)};return{send:v}}e.createQueuedSender=C;var R;(function(P){async function E(y,v,d){if(a.isAbsolute(y))return y;if(v===void 0&&(v=k.cwd()),a.dirname(y)!=="."||(d===void 0&&D.isString(k.env.PATH)&&(d=k.env.PATH.split(a.delimiter)),d===void 0||d.length===0))return a.join(v,y);async function h(w){if(await T.Promises.exists(w)){let m;try{m=await T.Promises.stat(w)}catch(f){f.message.startsWith("EACCES")&&(m=await T.Promises.lstat(w))}return m?!m.isDirectory():!1}return!1}for(const w of d){let m;if(a.isAbsolute(w)?m=a.join(w,y):m=a.join(v,w,y),await h(m))return m;let f=m+".com";if(await h(f)||(f=m+".exe",await h(f)))return f}return a.join(v,y)}P.findExecutable=E})(R=e.win32||(e.win32={}))});var Ve=this&&this.__decorate||function(te,e,a,t){var k=arguments.length,A=k<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,a):t,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(te,e,a,t);else for(var T=te.length-1;T>=0;T--)(D=te[T])&&(A=(k<3?D(A):k>3?D(e,a,A):D(e,a))||A);return k>3&&A&&Object.defineProperty(e,a,A),A};define(Se[115],ye([1,0,17,18,22,21,60,10,4,6,84,8,11]),function(te,e,a,t,k,A,D,T,S,C,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=void 0;var y;(function(K){K[K.Promise=100]="Promise",K[K.PromiseCancel=101]="PromiseCancel",K[K.EventListen=102]="EventListen",K[K.EventDispose=103]="EventDispose"})(y||(y={}));function v(K){switch(K){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(K){K[K.Initialize=200]="Initialize",K[K.PromiseSuccess=201]="PromiseSuccess",K[K.PromiseError=202]="PromiseError",K[K.PromiseErrorObj=203]="PromiseErrorObj",K[K.EventFire=204]="EventFire"})(d||(d={}));function g(K){switch(K){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(K){K[K.Uninitialized=0]="Uninitialized",K[K.Idle=1]="Idle"})(h||(h={}));class w{constructor(q){this.b=q,this.a=0}read(q){const Y=this.b.slice(this.a,this.a+q);return this.a+=Y.byteLength,Y}}class m{constructor(){this.a=[]}get buffer(){return k.VSBuffer.concat(this.a)}write(q){this.a.push(q)}}var f;(function(K){K[K.Undefined=0]="Undefined",K[K.String=1]="String",K[K.Buffer=2]="Buffer",K[K.VSBuffer=3]="VSBuffer",K[K.Array=4]="Array",K[K.Object=5]="Object"})(f||(f={}));function b(K){const q=k.VSBuffer.alloc(4);return q.writeUInt32BE(K,0),q}function s(K){return K.read(4).readUInt32BE(0)}function o(K){const q=k.VSBuffer.alloc(1);return q.writeUInt8(K,0),q}const c={Undefined:o(f.Undefined),String:o(f.String),Buffer:o(f.Buffer),VSBuffer:o(f.VSBuffer),Array:o(f.Array),Object:o(f.Object)},u=typeof Buffer<"u";function r(K,q){if(typeof q>"u")K.write(c.Undefined);else if(typeof q=="string"){const Y=k.VSBuffer.fromString(q);K.write(c.String),K.write(b(Y.byteLength)),K.write(Y)}else if(u&&Buffer.isBuffer(q)){const Y=k.VSBuffer.wrap(q);K.write(c.Buffer),K.write(b(Y.byteLength)),K.write(Y)}else if(q instanceof k.VSBuffer)K.write(c.VSBuffer),K.write(b(q.byteLength)),K.write(q);else if(Array.isArray(q)){K.write(c.Array),K.write(b(q.length));for(const Y of q)r(K,Y)}else{const Y=k.VSBuffer.fromString(JSON.stringify(q));K.write(c.Object),K.write(b(Y.byteLength)),K.write(Y)}}function l(K){switch(K.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return K.read(s(K)).toString();case f.Buffer:return K.read(s(K)).buffer;case f.VSBuffer:return K.read(s(K));case f.Array:{const Y=s(K),Q=[];for(let ce=0;ce<Y;ce++)Q.push(l(K));return Q}case f.Object:return JSON.parse(K.read(s(K)).toString())}}class n{constructor(q,Y,Q=null,ce=1e3){this.h=q,this.j=Y,this.k=Q,this.l=ce,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ie=>this.p(ie)),this.m({type:200})}registerChannel(q,Y){this.b.set(q,Y),setTimeout(()=>this.v(q),0)}m(q){switch(q.type){case 200:{const Y=this.n([q.type]);this.k?.logOutgoing(Y,0,1,g(q.type));return}case 201:case 202:case 204:case 203:{const Y=this.n([q.type,q.id],q.data);this.k?.logOutgoing(Y,q.id,1,g(q.type),q.data);return}}}n(q,Y=void 0){const Q=new m;return r(Q,q),r(Q,Y),this.o(Q.buffer)}o(q){try{return this.h.send(q),q.byteLength}catch{return 0}}p(q){const Y=new w(q),Q=l(Y),ce=l(Y),ie=Q[0];switch(ie){case 100:return this.k?.logIncoming(q.byteLength,Q[1],1,`${v(ie)}: ${Q[2]}.${Q[3]}`,ce),this.q({type:ie,id:Q[1],channelName:Q[2],name:Q[3],arg:ce});case 102:return this.k?.logIncoming(q.byteLength,Q[1],1,`${v(ie)}: ${Q[2]}.${Q[3]}`,ce),this.s({type:ie,id:Q[1],channelName:Q[2],name:Q[3],arg:ce});case 101:return this.k?.logIncoming(q.byteLength,Q[1],1,`${v(ie)}`),this.t({type:ie,id:Q[1]});case 103:return this.k?.logIncoming(q.byteLength,Q[1],1,`${v(ie)}`),this.t({type:ie,id:Q[1]})}}q(q){const Y=this.b.get(q.channelName);if(!Y){this.u(q);return}const Q=new A.CancellationTokenSource;let ce;try{ce=Y.call(this.j,q.name,q.arg,Q.token)}catch(J){ce=Promise.reject(J)}const ie=q.id;ce.then(J=>{this.m({id:ie,data:J,type:201}),this.d.delete(q.id)},J=>{J instanceof Error?this.m({id:ie,data:{message:J.message,name:J.name,stack:J.stack?J.stack.split?J.stack.split(`
`):J.stack:void 0},type:202}):this.m({id:ie,data:J,type:203}),this.d.delete(q.id)});const de=(0,C.toDisposable)(()=>Q.cancel());this.d.set(q.id,de)}s(q){const Y=this.b.get(q.channelName);if(!Y){this.u(q);return}const Q=q.id,ie=Y.listen(this.j,q.name,q.arg)(de=>this.m({id:Q,data:de,type:204}));this.d.set(q.id,ie)}t(q){const Y=this.d.get(q.id);Y&&(Y.dispose(),this.d.delete(q.id))}u(q){let Y=this.g.get(q.channelName);Y||(Y=[],this.g.set(q.channelName,Y));const Q=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.m({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Y.push({request:q,timeoutTimer:Q})}v(q){const Y=this.g.get(q);if(Y){for(const Q of Y)switch(clearTimeout(Q.timeoutTimer),Q.request.type){case 100:this.q(Q.request);break;case 102:this.s(Q.request);break}this.g.delete(q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,C.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=n;var i;(function(K){K[K.LocalSide=0]="LocalSide",K[K.OtherSide=1]="OtherSide"})(i=e.RequestInitiator||(e.RequestInitiator={}));class p{constructor(q,Y=null){this.l=q,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new S.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Q=>this.r(Q)),this.j=Y}getChannel(q){const Y=this;return{call(Q,ce,ie){return Y.a?Promise.reject(new T.CancellationError):Y.m(q,Q,ce,ie)},listen(Q,ce){return Y.a?S.Event.None:Y.n(q,Q,ce)}}}m(q,Y,Q,ce=A.CancellationToken.None){const ie=this.g++,J={id:ie,type:100,channelName:q,name:Y,arg:Q};if(ce.isCancellationRequested)return Promise.reject(new T.CancellationError);let pe;return new Promise((De,Re)=>{if(ce.isCancellationRequested)return Re(new T.CancellationError);const $e=()=>{const Z=se=>{switch(se.type){case 201:this.f.delete(ie),De(se.data);break;case 202:{this.f.delete(ie);const ne=new Error(se.data.message);ne.stack=Array.isArray(se.data.stack)?se.data.stack.join(`
`):se.data.stack,ne.name=se.data.name,Re(ne);break}case 203:this.f.delete(ie),Re(se.data);break}};this.f.set(ie,Z),this.o(J)};let re=null;this.b===h.Idle?$e():(re=(0,t.createCancelablePromise)(Z=>this.t()),re.then(()=>{re=null,$e()}));const le=()=>{re?(re.cancel(),re=null):this.o({id:ie,type:101}),Re(new T.CancellationError)},fe=ce.onCancellationRequested(le);pe=(0,C.combinedDisposable)((0,C.toDisposable)(le),fe),this.d.add(pe)}).finally(()=>{this.d.delete(pe)})}n(q,Y,Q){const ce=this.g++,de={id:ce,type:102,channelName:q,name:Y,arg:Q};let J=null;const pe=new S.Emitter({onWillAddFirstListener:()=>{J=(0,t.createCancelablePromise)(De=>this.t()),J.then(()=>{J=null,this.d.add(pe),this.o(de)})},onDidRemoveLastListener:()=>{J?(J.cancel(),J=null):(this.d.delete(pe),this.o({id:ce,type:103}))}}),ve=De=>pe.fire(De.data);return this.f.set(ce,ve),pe.event}o(q){switch(q.type){case 100:case 102:{const Y=this.p([q.type,q.id,q.channelName,q.name],q.arg);this.j?.logOutgoing(Y,q.id,0,`${v(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const Y=this.p([q.type,q.id]);this.j?.logOutgoing(Y,q.id,0,v(q.type));return}}}p(q,Y=void 0){const Q=new m;return r(Q,q),r(Q,Y),this.q(Q.buffer)}q(q){try{return this.l.send(q),q.byteLength}catch{return 0}}r(q){const Y=new w(q),Q=l(Y),ce=l(Y),ie=Q[0];switch(ie){case 200:return this.j?.logIncoming(q.byteLength,0,0,g(ie)),this.s({type:Q[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(q.byteLength,Q[1],0,g(ie),ce),this.s({type:Q[0],id:Q[1],data:ce})}}s(q){if(q.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(q.id)?.(q)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}t(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,C.dispose)(this.d.values()),this.d.clear()}}Ve([D.memoize],p.prototype,"onDidInitializePromise",null),e.ChannelClient=p;class I{get connections(){const q=[];return this.f.forEach(Y=>q.push(Y)),q}constructor(q){this.a=new Map,this.f=new Set,this.g=new S.Emitter,this.onDidAddConnection=this.g.event,this.h=new S.Emitter,this.onDidRemoveConnection=this.h.event,q(({protocol:Y,onDidClientDisconnect:Q})=>{S.Event.once(Y.onMessage)(ie=>{const de=new w(ie),J=l(de),pe=new n(Y,J),ve=new p(Y);this.a.forEach((Re,$e)=>pe.registerChannel($e,Re));const De={channelServer:pe,channelClient:ve,ctx:J};this.f.add(De),this.g.fire(De),Q(()=>{pe.dispose(),ve.dispose(),this.f.delete(De),this.h.fire(De)})})})}getChannel(q,Y){const Q=this;return{call(ce,ie,de){let J;if((0,E.isFunction)(Y)){const ve=(0,a.getRandomElement)(Q.connections.filter(Y));J=ve?Promise.resolve(ve):S.Event.toPromise(S.Event.filter(Q.onDidAddConnection,Y))}else J=Y.routeCall(Q,ce,ie);const pe=J.then(ve=>ve.channelClient.getChannel(q));return U(pe).call(ce,ie,de)},listen(ce,ie){if((0,E.isFunction)(Y))return Q.j(q,Y,ce,ie);const de=Y.routeEvent(Q,ce,ie).then(J=>J.channelClient.getChannel(q));return U(de).listen(ce,ie)}}}j(q,Y,Q,ce){const ie=this;let de=new C.DisposableStore;const J=new S.Emitter({onWillAddFirstListener:()=>{de=new C.DisposableStore;const pe=new S.EventMultiplexer,ve=new Map,De=$e=>{const le=$e.channelClient.getChannel(q).listen(Q,ce),fe=pe.add(le);ve.set($e,fe)},Re=$e=>{const re=ve.get($e);!re||(re.dispose(),ve.delete($e))};ie.connections.filter(Y).forEach(De),S.Event.filter(ie.onDidAddConnection,Y)(De,void 0,de),ie.onDidRemoveConnection(Re,void 0,de),pe.event(J.fire,J,de),de.add(pe)},onDidRemoveLastListener:()=>{de.dispose()}});return J.event}registerChannel(q,Y){this.a.set(q,Y),this.f.forEach(Q=>{Q.channelServer.registerChannel(q,Y)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=I;class L{constructor(q,Y,Q=null){const ce=new m;r(ce,Y),q.send(ce.buffer),this.a=new p(q,Q),this.d=new n(q,Y,Q)}getChannel(q){return this.a.getChannel(q)}registerChannel(q,Y){this.d.registerChannel(q,Y)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=L;function U(K){return{call(q,Y,Q){return K.then(ce=>ce.call(q,Y,Q))},listen(q,Y){const Q=new S.Relay;return K.then(ce=>Q.input=ce.listen(q,Y)),Q.event}}}e.getDelayedChannel=U;function G(K){let q=!1;return{call(Y,Q,ce){return q?K.call(Y,Q,ce):(0,t.timeout)(0).then(()=>q=!0).then(()=>K.call(Y,Q,ce))},listen(Y,Q){if(q)return K.listen(Y,Q);const ce=new S.Relay;return(0,t.timeout)(0).then(()=>q=!0).then(()=>ce.input=K.listen(Y,Q)),ce.event}}}e.getNextTickChannel=G;class V{constructor(q){this.a=q}routeCall(q){return this.b(q)}routeEvent(q){return this.b(q)}async b(q){for(const Y of q.connections)if(await Promise.resolve(this.a(Y.ctx)))return Promise.resolve(Y);return await S.Event.toPromise(q.onDidAddConnection),await this.b(q)}}e.StaticRouter=V;var O;(function(K){function q(ie,de){const J=ie,pe=de&&de.disableMarshalling,ve=new Map;for(const De in J)Q(De)&&ve.set(De,S.Event.buffer(J[De],!0));return new class{listen(De,Re,$e){const re=ve.get(Re);if(re)return re;if(ce(Re)){const le=J[Re];if(typeof le=="function")return le.call(J,$e)}throw new Error(`Event not found: ${Re}`)}call(De,Re,$e){const re=J[Re];if(typeof re=="function"){if(!pe&&Array.isArray($e))for(let le=0;le<$e.length;le++)$e[le]=(0,R.revive)($e[le]);return re.apply(J,$e)}throw new Error(`Method not found: ${Re}`)}}}K.fromService=q;function Y(ie,de){const J=de&&de.disableMarshalling;return new Proxy({},{get(pe,ve){if(typeof ve=="string")return de?.properties?.has(ve)?de.properties.get(ve):ce(ve)?function(De){return ie.listen(ve,De)}:Q(ve)?ie.listen(ve):async function(...De){let Re;de&&!(0,E.isUndefinedOrNull)(de.context)?Re=[de.context,...De]:Re=De;const $e=await ie.call(ve,Re);return J?$e:(0,R.revive)($e)};throw new Error(`Property not found: ${String(ve)}`)}})}K.toService=Y;function Q(ie){return ie[0]==="o"&&ie[1]==="n"&&P.isUpperAsciiLetter(ie.charCodeAt(2))}function ce(ie){return/^onDynamic/.test(ie)&&P.isUpperAsciiLetter(ie.charCodeAt(9))}})(O=e.ProxyChannel||(e.ProxyChannel={}));const B=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(K){if(Array.isArray(K))return K;if(K&&typeof K=="object"&&typeof K.toString=="function"){const q=K.toString();if(q!=="[object Object]")return q}return K}function $(K){return Array.isArray(K)?K.map(F):F(K)}function M(K,q,Y,Q,ce,ie,de){de=$(de);const J=B[ce],pe=J[Q%J.length];let ve=[`%c[${K}]%c[${String(q).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(Q).padStart(5," ")} - ${ie}`,"color: darkgreen","color: grey","color: grey",`color: ${pe}`];/\($/.test(ie)?(ve=ve.concat(de),ve.push(")")):ve.push(de),console.log.apply(console,ve)}class H{constructor(q,Y){this.d=q,this.f=Y,this.a=0,this.b=0}logOutgoing(q,Y,Q,ce,ie){this.b+=q,M(this.d,this.b,q,Y,Q,ce,ie)}logIncoming(q,Y,Q,ce,ie){this.a+=q,M(this.f,this.a,q,Y,Q,ce,ie)}}e.IPCLogger=H}),define(Se[116],ye([1,0,22,4,6,115]),function(te,e,a,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(u){u.Created="created",u.Read="read",u.Write="write",u.Open="open",u.Error="error",u.Close="close",u.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",u.NodeEndReceived="nodeEndReceived",u.NodeEndSent="nodeEndSent",u.NodeDrainBegin="nodeDrainBegin",u.NodeDrainEnd="nodeDrainEnd",u.zlibInflateError="zlibInflateError",u.zlibInflateData="zlibInflateData",u.zlibInflateInitialWrite="zlibInflateInitialWrite",u.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",u.zlibInflateWrite="zlibInflateWrite",u.zlibInflateFlushFired="zlibInflateFlushFired",u.zlibDeflateError="zlibDeflateError",u.zlibDeflateData="zlibDeflateData",u.zlibDeflateWrite="zlibDeflateWrite",u.zlibDeflateFlushFired="zlibDeflateFlushFired",u.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",u.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",u.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",u.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",u.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",u.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",u.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",u.ProtocolHeaderRead="protocolHeaderRead",u.ProtocolMessageRead="protocolMessageRead",u.ProtocolHeaderWrite="protocolHeaderWrite",u.ProtocolMessageWrite="protocolMessageWrite",u.ProtocolWrite="protocolWrite"})(D=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var T;(function(u){u.enableDiagnostics=!1,u.records=[];const r=new WeakMap;let l=0;function n(p,I){if(!r.has(p)){const L=String(++l);r.set(p,L)}return r.get(p)}function i(p,I,L,U){if(!u.enableDiagnostics)return;const G=n(p,I);if(U instanceof a.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const V=a.VSBuffer.alloc(U.byteLength);V.set(U),u.records.push({timestamp:Date.now(),id:G,label:I,type:L,buff:V})}else u.records.push({timestamp:Date.now(),id:G,label:I,type:L,data:U})}u.traceSocketEvent=i})(T=e.SocketDiagnostics||(e.SocketDiagnostics={}));var S;(function(u){u[u.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",u[u.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let C=null;function R(){return C||(C=a.VSBuffer.alloc(0)),C}class P{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(r){this.a.push(r),this.b+=r.byteLength}read(r){return this.c(r,!0)}peek(r){return this.c(r,!1)}c(r,l){if(r===0)return R();if(r>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===r){const I=this.a[0];return l&&(this.a.shift(),this.b-=r),I}if(this.a[0].byteLength>r){const I=this.a[0].slice(0,r);return l&&(this.a[0]=this.a[0].slice(r),this.b-=r),I}const n=a.VSBuffer.alloc(r);let i=0,p=0;for(;r>0;){const I=this.a[p];if(I.byteLength>r){const L=I.slice(0,r);n.set(L,i),i+=r,l&&(this.a[p]=I.slice(r),this.b-=r),r-=r}else n.set(I,i),i+=I.byteLength,l?(this.a.shift(),this.b-=I.byteLength):p++,r-=I.byteLength}return n}}e.ChunkStream=P;var E;(function(u){u[u.None=0]="None",u[u.Regular=1]="Regular",u[u.Control=2]="Control",u[u.Ack=3]="Ack",u[u.Disconnect=5]="Disconnect",u[u.ReplayRequest=6]="ReplayRequest",u[u.Pause=7]="Pause",u[u.Resume=8]="Resume",u[u.KeepAlive=9]="KeepAlive"})(E||(E={}));function y(u){switch(u){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var v;(function(u){u[u.HeaderLength=13]="HeaderLength",u[u.AcknowledgeTime=2e3]="AcknowledgeTime",u[u.TimeoutTime=2e4]="TimeoutTime",u[u.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",u[u.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(v=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(r,l,n,i){this.type=r,this.id=l,this.ack=n,this.data=i,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends k.Disposable{constructor(r){super(),this.f=this.B(new t.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=r,this.b=!1,this.c=new P,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(r);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:y(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const n=this.g.messageType,i=this.g.id,p=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",l),this.f.fire(new d(n,i,p,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class h{constructor(r){this.k=null,this.a=!1,this.b=!1,this.c=r,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(r){if(this.a)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=a.VSBuffer.alloc(13);l.writeUInt8(r.type,0),l.writeUInt32BE(r.id,1),l.writeUInt32BE(r.ack,5),l.writeUInt32BE(r.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:y(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",r.data),this.j(l,r.data)}g(r,l){const n=this.f===0;return this.d.push(r,l),this.f+=r.byteLength+l.byteLength,n}h(){const r=a.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,r}j(r,l){this.g(r,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const r=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this.c.write(r)}}class w extends k.Disposable{constructor(r){super(),this.f=new t.Emitter,this.onMessage=this.f.event,this.g=new t.Emitter,this.onDidDispose=this.g.event,this.a=r,this.b=this.B(new h(this.a)),this.c=this.B(new g(this.a)),this.B(this.c.onMessage(l=>{l.type===1&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(r){this.b.write(new d(1,0,0,r))}}e.Protocol=w;class m extends A.IPCClient{static fromSocket(r,l){return new m(new w(r),l)}get onDidDispose(){return this.b.onDidDispose}constructor(r,l,n=null){super(r,l,n),this.b=r}dispose(){super.dispose();const r=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),r.end()}}e.Client=m;class f{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new t.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(r){this.b?this.d.length>0?this.d.push(r):this.a.fire(r):this.d.push(r)}flushBuffer(){this.d=[]}}e.BufferedEmitter=f;class b{constructor(r){this.data=r,this.next=null}}class s{constructor(){this.a=null,this.b=null}length(){let r=0,l=this.a;for(;l;)l=l.next,r++;return r}peek(){return this.a?this.a.data:null}toArray(){const r=[];let l=0,n=this.a;for(;n;)r[l++]=n.data,n=n.next;return r}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(r){const l=new b(r);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class o{static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const r=Date.now();for(let l=0;l<o.a;l++)this.c[l]=r-1e3*l;setInterval(()=>{for(let l=o.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const r=Date.now(),l=(1+o.a)*1e3;let n=0;for(let i=0;i<o.a;i++)r-this.c[i]<=l&&n++;return 1-n/o.a}hasHighLoad(){return this.d()>=.5}}o.a=10,o.b=null;class c{get unacknowledgedCount(){return this.c-this.d}constructor(r,l=null,n=o.getInstance()){this.t=new f,this.onControlMessage=this.t.event,this.u=new f,this.onMessage=this.u.event,this.v=new f,this.onDidDispose=this.v.event,this.w=new f,this.onSocketClose=this.w.event,this.x=new f,this.onSocketTimeout=this.x.event,this.s=n,this.a=!1,this.b=new s,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=[],this.o=r,this.p=new h(this.o),this.r.push(this.p),this.q=new g(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(i=>this.y(i))),this.r.push(this.o.onClose(i=>this.w.fire(i))),l&&this.q.acceptChunk(l),this.l=setInterval(()=>{this.D()},5e3)}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r=(0,k.dispose)(this.r)}drain(){return this.p.drain()}sendDisconnect(){const r=new d(5,0,0,R());this.p.write(r),this.p.flush()}sendPause(){const r=new d(7,0,0,R());this.p.write(r)}sendResume(){const r=new d(8,0,0,R());this.p.write(r)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(r,l){this.a=!0,this.r=(0,k.dispose)(this.r),this.t.flushBuffer(),this.w.flushBuffer(),this.x.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=r,this.p=new h(this.o),this.r.push(this.p),this.q=new g(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(n=>this.y(n))),this.r.push(this.o.onClose(n=>this.w.fire(n))),this.q.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.h=this.g;const r=new d(3,0,this.h,R());this.p.write(r);const l=this.b.toArray();for(let n=0,i=l.length;n<i;n++)this.p.write(l[n]);this.B()}acceptDisconnect(){this.v.fire()}y(r){if(r.ack>this.d){this.d=r.ack;do{const l=this.b.peek();if(l&&l.id<=r.ack)this.b.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this.g)if(r.id!==this.g+1){const l=Date.now();l-this.m>1e4&&(this.m=l,this.p.write(new d(6,0,0,R())))}else this.g=r.id,this.j=Date.now(),this.A(),this.u.fire(r.data);break}case 2:{this.t.fire(r.data);break}case 3:break;case 5:{this.v.fire();break}case 6:{const l=this.b.toArray();for(let n=0,i=l.length;n<i;n++)this.p.write(l[n]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(r){const l=++this.c;this.h=this.g;const n=new d(1,l,this.h,r);this.b.push(n),this.a||(this.p.write(n),this.B())}sendControl(r){const l=new d(2,0,0,r);this.p.write(l)}A(){if(this.g<=this.h||this.k)return;const r=Date.now()-this.j;if(r>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-r+5)}B(){if(this.c<=this.d||this.f||this.a)return;const r=this.b.peek(),l=Date.now()-r.writtenTime,n=Date.now()-this.q.lastReadTime,i=Date.now()-this.n;if(l>=2e4&&n>=2e4&&i>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.x.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:n});return}const p=Math.max(2e4-l,2e4-n,2e4-i,500);this.f=setTimeout(()=>{this.f=null,this.B()},p)}C(){if(this.g<=this.h)return;this.h=this.g;const r=new d(3,0,this.h,R());this.p.write(r)}D(){const r=new d(9,0,0,R());this.p.write(r)}}e.PersistentProtocol=c}),define(Se[117],ye([1,0,22,10,4,6,9,12,30,115,116]),function(te,e,a,t,k,A,D,T,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function P(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class E{traceSocketEvent(n,i){R.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,n,i)}constructor(n,i=""){this.f=!0,this.debugLabel=i,this.socket=n,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=p=>{if(this.traceSocketEvent("error",{code:p?.code,message:p?.message}),p){if(p.code==="EPIPE")return;(0,t.onUnexpectedError)(p)}},this.socket.on("error",this.a),this.b=p=>{this.traceSocketEvent("close",{hadError:p}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(n){const i=p=>{this.traceSocketEvent("read",p),n(a.VSBuffer.wrap(p))};return this.socket.on("data",i),{dispose:()=>this.socket.off("data",i)}}onClose(n){const i=p=>{n({type:0,hadError:p,error:void 0})};return this.socket.on("close",i),{dispose:()=>this.socket.off("close",i)}}onEnd(n){const i=()=>{n()};return this.socket.on("end",i),{dispose:()=>this.socket.off("end",i)}}write(n){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",n),this.socket.write(n.buffer,i=>{if(i){if(i.code==="EPIPE")return;(0,t.onUnexpectedError)(i)}})}catch(i){if(i.code==="EPIPE")return;(0,t.onUnexpectedError)(i)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((n,i)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),n();return}const p=()=>{this.socket.off("close",p),this.socket.off("end",p),this.socket.off("error",p),this.socket.off("timeout",p),this.socket.off("drain",p),this.traceSocketEvent("nodeDrainEnd"),n()};this.socket.on("close",p),this.socket.on("end",p),this.socket.on("error",p),this.socket.on("timeout",p),this.socket.on("drain",p)})}}e.NodeSocket=E;var y;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(y||(y={}));var v;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(v||(v={}));class d extends A.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(n,i){this.socket.traceSocketEvent(n,i)}constructor(n,i,p,I){super(),this.f=this.B(new k.Emitter),this.g=this.B(new k.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=n,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:i,inflateBytesLength:p?.byteLength||0,recordInflateBytes:I}),this.a=this.B(new g(this,i,p,I,this.f,(L,U)=>this.k(L,U))),this.B(this.a.onError(L=>{console.error(L),(0,t.onUnexpectedError)(L),this.g.fire({type:0,hadError:!0,error:L})})),this.b=new R.ChunkStream,this.B(this.socket.onData(L=>this.l(L))),this.B(this.socket.onClose(L=>this.g.fire(L)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(n){return this.f.event(n)}onClose(n){return this.g.event(n)}onEnd(n){return this.socket.onEnd(n)}write(n){this.a.writeMessage(n)}k(n,i){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",n);let p=2;n.byteLength<126?p+=0:n.byteLength<2**16?p+=2:p+=8;const I=a.VSBuffer.alloc(p);if(i?I.writeUInt8(194,0):I.writeUInt8(130,0),n.byteLength<126)I.writeUInt8(n.byteLength,1);else if(n.byteLength<2**16){I.writeUInt8(126,1);let L=1;I.writeUInt8(n.byteLength>>>8&255,++L),I.writeUInt8(n.byteLength>>>0&255,++L)}else{I.writeUInt8(127,1);let L=1;I.writeUInt8(0,++L),I.writeUInt8(0,++L),I.writeUInt8(0,++L),I.writeUInt8(0,++L),I.writeUInt8(n.byteLength>>>24&255,++L),I.writeUInt8(n.byteLength>>>16&255,++L),I.writeUInt8(n.byteLength>>>8&255,++L),I.writeUInt8(n.byteLength>>>0&255,++L)}this.socket.write(a.VSBuffer.concat([I,n]))}end(){this.h=!0,this.socket.end()}l(n){if(n.byteLength!==0){for(this.b.acceptChunk(n);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const i=this.b.peek(this.j.readLen),p=i.readUInt8(0),I=(p&128)>>>7,L=(p&64)>>>6,U=i.readUInt8(1),G=(U&128)>>>7,V=U&127;this.j.state=2,this.j.readLen=2+(G?4:0)+(V===126?2:0)+(V===127?8:0),this.j.fin=I,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(L)),this.j.firstFrameOfMessage=Boolean(I),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const i=this.b.read(this.j.readLen),p=i.readUInt8(1),I=(p&128)>>>7;let L=p&127,U=1;L===126?L=i.readUInt8(++U)*2**8+i.readUInt8(++U):L===127&&(L=i.readUInt8(++U)*0+i.readUInt8(++U)*0+i.readUInt8(++U)*0+i.readUInt8(++U)*0+i.readUInt8(++U)*2**24+i.readUInt8(++U)*2**16+i.readUInt8(++U)*2**8+i.readUInt8(++U));let G=0;I&&(G=i.readUInt8(++U)*2**24+i.readUInt8(++U)*2**16+i.readUInt8(++U)*2**8+i.readUInt8(++U)),this.j.state=3,this.j.readLen=L,this.j.mask=G,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const i=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",i),m(i,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",i),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(i,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=d;class g extends A.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:a.VSBuffer.alloc(0)}constructor(n,i,p,I,L,U){super(),this.k=n,this.l=L,this.m=U,this.a=this.B(new k.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new k.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,i?(this.b=this.B(new h(this.k,I,p,{windowBits:15})),this.f=this.B(new w(this.k,{windowBits:15})),this.B(this.b.onError(G=>this.a.fire(G))),this.B(this.f.onError(G=>this.a.fire(G)))):(this.b=null,this.f=null)}writeMessage(n){this.g.push(n),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const n=this.g.shift();if(this.f){const i=await this.r(this.f,n);this.m(i,!0)}else this.m(n,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(n,i){return new Promise((p,I)=>{n.write(i),n.flush(L=>p(L))})}acceptFrame(n,i,p){this.h.push({data:n,isCompressed:i,isLastFrameOfMessage:p}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const n=this.h.shift();if(this.b&&n.isCompressed){const i=await this.u(this.b,n.data,n.isLastFrameOfMessage);this.l.fire(i)}else this.l.fire(n.data)}this.s=!1}}u(n,i,p){return new Promise((I,L)=>{n.write(i),p&&n.write(a.VSBuffer.fromByteArray([0,0,255,255])),n.flush(U=>I(U))})}}class h extends A.Disposable{get recordedInflateBytes(){return this.j?a.VSBuffer.concat(this.f):a.VSBuffer.alloc(0)}constructor(n,i,p,I){super(),this.h=n,this.j=i,this.a=this.B(new k.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=P().zlib.createInflateRaw(I),this.b.on("error",L=>{this.h.traceSocketEvent("zlibInflateError",{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.h.traceSocketEvent("zlibInflateData",L),this.g.push(a.VSBuffer.wrap(L))}),p&&(this.h.traceSocketEvent("zlibInflateInitialWrite",p.buffer),this.b.write(p.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(n){this.j&&this.f.push(n.clone()),this.h.traceSocketEvent("zlibInflateWrite",n),this.b.write(n.buffer)}flush(n){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const i=a.VSBuffer.concat(this.g);this.g.length=0,n(i)})}}class w extends A.Disposable{constructor(n,i){super(),this.g=n,this.a=this.B(new k.Emitter),this.onError=this.a.event,this.f=[],this.b=P().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",p=>{this.g.traceSocketEvent("zlibDeflateError",{message:p?.message,code:p?.code}),this.a.fire(p)}),this.b.on("data",p=>{this.g.traceSocketEvent("zlibDeflateData",p),this.f.push(a.VSBuffer.wrap(p))})}write(n){this.g.traceSocketEvent("zlibDeflateWrite",n.buffer),this.b.write(n.buffer)}flush(n){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let i=a.VSBuffer.concat(this.f);this.f.length=0,i=i.slice(0,i.byteLength-4),n(i)})}}function m(l,n){if(n===0)return;const i=l.byteLength>>>2;for(let V=0;V<i;V++){const O=l.readUInt32BE(V*4);l.writeUInt32BE(O^n,V*4)}const p=i*4,I=l.byteLength-p,L=n>>>24&255,U=n>>>16&255,G=n>>>8&255;I>=1&&l.writeUInt8(l.readUInt8(p)^L,p),I>=2&&l.writeUInt8(l.readUInt8(p+1)^U,p+1),I>=3&&l.writeUInt8(l.readUInt8(p+2)^G,p+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const f={[2]:107,[1]:103};function b(){const l=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let n;return e.XDG_RUNTIME_DIR?n=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):n=(0,D.join)(P().os.tmpdir(),`vscode-ipc-${l}.sock`),o(n),n}e.createRandomIPCHandle=b;function s(l,n,i){const p=P().crypto.createHash("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${p}-${i}-${n}-sock`;let I;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?I=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${p.substr(0,8)}-${i}-${n}.sock`):I=(0,D.join)(l,`${i}-${n}.sock`),o(I),I}e.createStaticIPCHandle=s;function o(l){const n=f[T.platform];typeof n=="number"&&l.length>=n&&console.warn(`WARNING: IPC handle "${l}" is longer than ${n} chars, try a shorter --user-data-dir`)}class c extends C.IPCServer{static b(n){const i=k.Event.fromNodeEventEmitter(n,"connection");return k.Event.map(i,p=>({protocol:new R.Protocol(new E(p,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(p,"close"))}))}constructor(n){super(c.b(n)),this.d=n}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=c;function u(l){return new Promise((n,i)=>{const p=P().net.createServer();p.on("error",i),p.listen(l,()=>{p.removeListener("error",i),n(new c(p))})})}e.serve=u;function r(l,n){return new Promise((i,p)=>{const I=P().net.createConnection(l,()=>{I.removeListener("error",p),i(R.Client.fromSocket(new E(I,`ipc-client${n}`),n))});I.once("error",p)})}e.connect=r}),define(Se[161],ye([1,0,37,9]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function k(A,D,T,S,C,R){if(Array.isArray(A)){let P=0;for(const E of A){const y=k(E,D,T,S,C,R);if(y===10)return y;y>P&&(P=y)}return P}else{if(typeof A=="string")return S?A==="*"?5:A===T?10:0:0;if(A){const{language:P,pattern:E,scheme:y,hasAccessToAllModels:v,notebookType:d}=A;if(!S&&!v)return 0;d&&C&&(D=C);let g=0;if(y)if(y===D.scheme)g=10;else if(y==="*")g=5;else return 0;if(P)if(P===T)g=10;else if(P==="*")g=Math.max(g,5);else return 0;if(d)if(d===R)g=10;else if(d==="*"&&R!==void 0)g=Math.max(g,5);else return 0;if(E){let h;if(typeof E=="string"?h=E:h={...E,base:(0,t.normalize)(E.base)},h===D.fsPath||(0,a.match)(h,D.fsPath))g=10;else return 0}return g}else return 0}}e.score=k}),define(Se[162],ye([1,0,8,49,153]),function(te,e,a,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(T,S,C,R){this.c=T,this.d=S,this.f=C,this.g=R,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(T){T.eol&&T.eol!==this.f&&(this.f=T.eol,this.h=null);const S=T.changes;for(const C of S)this.n(C.range),this.o(new t.Position(C.range.startLineNumber,C.range.startColumn),C.text);this.g=T.versionId,this.j=null}k(){if(!this.h){const T=this.f.length,S=this.d.length,C=new Uint32Array(S);for(let R=0;R<S;R++)C[R]=this.d[R].length+T;this.h=new k.PrefixSumComputer(C)}}l(T,S){this.d[T]=S,this.h&&this.h.setValue(T,this.d[T].length+this.f.length)}n(T){if(T.startLineNumber===T.endLineNumber){if(T.startColumn===T.endColumn)return;this.l(T.startLineNumber-1,this.d[T.startLineNumber-1].substring(0,T.startColumn-1)+this.d[T.startLineNumber-1].substring(T.endColumn-1));return}this.l(T.startLineNumber-1,this.d[T.startLineNumber-1].substring(0,T.startColumn-1)+this.d[T.endLineNumber-1].substring(T.endColumn-1)),this.d.splice(T.startLineNumber,T.endLineNumber-T.startLineNumber),this.h&&this.h.removeValues(T.startLineNumber,T.endLineNumber-T.startLineNumber)}o(T,S){if(S.length===0)return;const C=(0,a.splitLines)(S);if(C.length===1){this.l(T.lineNumber-1,this.d[T.lineNumber-1].substring(0,T.column-1)+C[0]+this.d[T.lineNumber-1].substring(T.column-1));return}C[C.length-1]+=this.d[T.lineNumber-1].substring(T.column-1),this.l(T.lineNumber-1,this.d[T.lineNumber-1].substring(0,T.column-1)+C[0]);const R=new Uint32Array(C.length-1);for(let P=1;P<C.length;P++)this.d.splice(T.lineNumber+P-1,0,C[P]),R[P-1]=C[P].length+this.f.length;this.h&&this.h.insertValues(T.lineNumber,R)}}e.MirrorTextModel=A}),define(Se[163],ye([1,0,8,150,49,35,105]),function(te,e,a,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const T=999;class S{constructor(w,m,f,b){this.searchString=w,this.isRegex=m,this.matchCase=f,this.wordSeparators=b}parseSearchRequest(){if(this.searchString==="")return null;let w;this.isRegex?w=C(this.searchString):w=this.searchString.indexOf(`
`)>=0;let m=null;try{m=a.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:w,global:!0,unicode:!0})}catch{return null}if(!m)return null;let f=!this.isRegex&&!w;return f&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(f=this.matchCase),new D.SearchData(m,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,f?this.searchString:null)}}e.SearchParams=S;function C(h){if(!h||h.length===0)return!1;for(let w=0,m=h.length;w<m;w++){const f=h.charCodeAt(w);if(f===10)return!0;if(f===92){if(w++,w>=m)break;const b=h.charCodeAt(w);if(b===110||b===114||b===87)return!0}}return!1}e.isMultilineRegexSource=C;function R(h,w,m){if(!m)return new D.FindMatch(h,null);const f=[];for(let b=0,s=w.length;b<s;b++)f[b]=w[b];return new D.FindMatch(h,f)}e.createFindMatch=R;class P{constructor(w){const m=[];let f=0;for(let b=0,s=w.length;b<s;b++)w.charCodeAt(b)===10&&(m[f++]=b);this.a=m}findLineFeedCountBeforeOffset(w){const m=this.a;let f=0,b=m.length-1;if(b===-1||w<=m[0])return 0;for(;f<b;){const s=f+((b-f)/2>>0);m[s]>=w?b=s-1:m[s+1]>=w?(f=s,b=s):f=s+1}return f+1}}class E{static findMatches(w,m,f,b,s){const o=m.parseSearchRequest();return o?o.regex.multiline?this.b(w,f,new g(o.wordSeparators,o.regex),b,s):this.c(w,f,o,b,s):[]}static a(w,m,f,b,s,o){let c,u=0;b?(u=b.findLineFeedCountBeforeOffset(s),c=m+s+u):c=m+s;let r;if(b){const p=b.findLineFeedCountBeforeOffset(s+o.length)-u;r=c+o.length+p}else r=c+o.length;const l=w.getPositionAt(c),n=w.getPositionAt(r);return new A.Range(l.lineNumber,l.column,n.lineNumber,n.column)}static b(w,m,f,b,s){const o=w.getOffsetAt(m.getStartPosition()),c=w.getValueInRange(m,1),u=w.getEOL()===`\r
`?new P(c):null,r=[];let l=0,n;for(f.reset(0);n=f.next(c);)if(r[l++]=R(this.a(w,o,c,u,n.index,n[0]),n,b),l>=s)return r;return r}static c(w,m,f,b,s){const o=[];let c=0;if(m.startLineNumber===m.endLineNumber){const r=w.getLineContent(m.startLineNumber).substring(m.startColumn-1,m.endColumn-1);return c=this.d(f,r,m.startLineNumber,m.startColumn-1,c,o,b,s),o}const u=w.getLineContent(m.startLineNumber).substring(m.startColumn-1);c=this.d(f,u,m.startLineNumber,m.startColumn-1,c,o,b,s);for(let r=m.startLineNumber+1;r<m.endLineNumber&&c<s;r++)c=this.d(f,w.getLineContent(r),r,0,c,o,b,s);if(c<s){const r=w.getLineContent(m.endLineNumber).substring(0,m.endColumn-1);c=this.d(f,r,m.endLineNumber,0,c,o,b,s)}return o}static d(w,m,f,b,s,o,c,u){const r=w.wordSeparators;if(!c&&w.simpleSearch){const i=w.simpleSearch,p=i.length,I=m.length;let L=-p;for(;(L=m.indexOf(i,L+p))!==-1;)if((!r||d(r,m,I,L,p))&&(o[s++]=new D.FindMatch(new A.Range(f,L+1+b,f,L+1+p+b),null),s>=u))return s;return s}const l=new g(w.wordSeparators,w.regex);let n;l.reset(0);do if(n=l.next(m),n&&(o[s++]=R(new A.Range(f,n.index+1+b,f,n.index+1+n[0].length+b),n,c),s>=u))return s;while(n);return s}static findNextMatch(w,m,f,b){const s=m.parseSearchRequest();if(!s)return null;const o=new g(s.wordSeparators,s.regex);return s.regex.multiline?this.e(w,f,o,b):this.f(w,f,o,b)}static e(w,m,f,b){const s=new k.Position(m.lineNumber,1),o=w.getOffsetAt(s),c=w.getLineCount(),u=w.getValueInRange(new A.Range(s.lineNumber,s.column,c,w.getLineMaxColumn(c)),1),r=w.getEOL()===`\r
`?new P(u):null;f.reset(m.column-1);const l=f.next(u);return l?R(this.a(w,o,u,r,l.index,l[0]),l,b):m.lineNumber!==1||m.column!==1?this.e(w,new k.Position(1,1),f,b):null}static f(w,m,f,b){const s=w.getLineCount(),o=m.lineNumber,c=w.getLineContent(o),u=this.g(f,c,o,m.column,b);if(u)return u;for(let r=1;r<=s;r++){const l=(o+r-1)%s,n=w.getLineContent(l+1),i=this.g(f,n,l+1,1,b);if(i)return i}return null}static g(w,m,f,b,s){w.reset(b-1);const o=w.next(m);return o?R(new A.Range(f,o.index+1,f,o.index+1+o[0].length),o,s):null}static findPreviousMatch(w,m,f,b){const s=m.parseSearchRequest();if(!s)return null;const o=new g(s.wordSeparators,s.regex);return s.regex.multiline?this.h(w,f,o,b):this.j(w,f,o,b)}static h(w,m,f,b){const s=this.b(w,new A.Range(1,1,m.lineNumber,m.column),f,b,10*T);if(s.length>0)return s[s.length-1];const o=w.getLineCount();return m.lineNumber!==o||m.column!==w.getLineMaxColumn(o)?this.h(w,new k.Position(o,w.getLineMaxColumn(o)),f,b):null}static j(w,m,f,b){const s=w.getLineCount(),o=m.lineNumber,c=w.getLineContent(o).substring(0,m.column-1),u=this.k(f,c,o,b);if(u)return u;for(let r=1;r<=s;r++){const l=(s+o-r-1)%s,n=w.getLineContent(l+1),i=this.k(f,n,l+1,b);if(i)return i}return null}static k(w,m,f,b){let s=null,o;for(w.reset(0);o=w.next(m);)s=R(new A.Range(f,o.index+1,f,o.index+1+o[0].length),o,b);return s}}e.TextModelSearch=E;function y(h,w,m,f,b){if(f===0)return!0;const s=w.charCodeAt(f-1);if(h.get(s)!==0||s===13||s===10)return!0;if(b>0){const o=w.charCodeAt(f);if(h.get(o)!==0)return!0}return!1}function v(h,w,m,f,b){if(f+b===m)return!0;const s=w.charCodeAt(f+b);if(h.get(s)!==0||s===13||s===10)return!0;if(b>0){const o=w.charCodeAt(f+b-1);if(h.get(o)!==0)return!0}return!1}function d(h,w,m,f,b){return y(h,w,m,f,b)&&v(h,w,m,f,b)}e.isValidMatch=d;class g{constructor(w,m){this._wordSeparators=w,this.a=m,this.b=-1,this.c=0}reset(w){this.a.lastIndex=w,this.b=-1,this.c=0}next(w){const m=w.length;let f;do{if(this.b+this.c===m||(f=this.a.exec(w),!f))return null;const b=f.index,s=f[0].length;if(b===this.b&&s===this.c){if(s===0){a.getNextCodePoint(w,m,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=b,this.c=s,!this._wordSeparators||d(this._wordSeparators,w,m,b,s))return f}while(f);return null}}e.Searcher=g}),define(Se[118],ye([1,0,22,12]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var k;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(k||(k={}));function A(P){for(let E=0,y=P.length;E<y;E+=4){const v=P[E+0],d=P[E+1],g=P[E+2],h=P[E+3];P[E+0]=h,P[E+1]=g,P[E+2]=d,P[E+3]=v}}function D(P){const E=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return t.isLittleEndian()||A(E),a.VSBuffer.wrap(E)}function T(P){const E=P.buffer;if(t.isLittleEndian()||A(E),E.byteOffset%4===0)return new Uint32Array(E.buffer,E.byteOffset,E.length/4);{const y=new Uint8Array(E.byteLength);return y.set(E),new Uint32Array(y.buffer,y.byteOffset,y.length/4)}}function S(P){const E=new Uint32Array(C(P));let y=0;if(E[y++]=P.id,P.type==="full")E[y++]=1,E[y++]=P.data.length,E.set(P.data,y),y+=P.data.length;else{E[y++]=2,E[y++]=P.deltas.length;for(const v of P.deltas)E[y++]=v.start,E[y++]=v.deleteCount,v.data?(E[y++]=v.data.length,E.set(v.data,y),y+=v.data.length):E[y++]=0}return D(E)}e.encodeSemanticTokensDto=S;function C(P){let E=0;if(E+=1+1,P.type==="full")E+=1+P.data.length;else{E+=1,E+=(1+1+1)*P.deltas.length;for(const y of P.deltas)y.data&&(E+=y.data.length)}return E}function R(P){const E=T(P);let y=0;const v=E[y++];if(E[y++]===1){const w=E[y++],m=E.subarray(y,y+w);return y+=w,{id:v,type:"full",data:m}}const g=E[y++],h=[];for(let w=0;w<g;w++){const m=E[y++],f=E[y++],b=E[y++];let s;b>0&&(s=E.subarray(y,y+b),y+=b),h[w]={start:m,deleteCount:f,data:s}}return{id:v,type:"delta",deltas:h}}e.decodeSemanticTokensDto=R}),define(Se[164],ye([1,0,4,6]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class k{constructor(){this.a=new Map,this.b=new Map,this.c=new a.Emitter,this.onDidChange=this.c.event,this.d=null}fire(T){this.c.fire({changedLanguages:T,changedColorMap:!1})}register(T,S){return this.a.set(T,S),this.fire([T]),(0,t.toDisposable)(()=>{this.a.get(T)===S&&(this.a.delete(T),this.fire([T]))})}registerFactory(T,S){this.b.get(T)?.dispose();const C=new A(this,T,S);return this.b.set(T,C),(0,t.toDisposable)(()=>{const R=this.b.get(T);!R||R!==C||(this.b.delete(T),R.dispose())})}async getOrCreate(T){const S=this.get(T);if(S)return S;const C=this.b.get(T);return!C||C.isResolved?null:(await C.resolve(),this.get(T))}get(T){return this.a.get(T)||null}isResolved(T){if(this.get(T))return!0;const C=this.b.get(T);return!!(!C||C.isResolved)}setColorMap(T){this.d=T,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=k;class A extends t.Disposable{get isResolved(){return this.c}constructor(T,S,C){super(),this.f=T,this.g=S,this.h=C,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const T=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,T&&!this.a&&this.B(this.f.register(this.g,T))}}}),define(Se[66],ye([1,0,78,2,35,164]),function(te,e,a,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class D{constructor(p,I,L){this._tokenBrand=void 0,this.offset=p,this.type=I,this.language=L}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=D;class T{constructor(p,I){this._tokenizationResultBrand=void 0,this.tokens=p,this.endState=I}}e.TokenizationResult=T;class S{constructor(p,I){this._encodedTokenizationResultBrand=void 0,this.tokens=p,this.endState=I}}e.EncodedTokenizationResult=S;var C;(function(i){i[i.Method=0]="Method",i[i.Function=1]="Function",i[i.Constructor=2]="Constructor",i[i.Field=3]="Field",i[i.Variable=4]="Variable",i[i.Class=5]="Class",i[i.Struct=6]="Struct",i[i.Interface=7]="Interface",i[i.Module=8]="Module",i[i.Property=9]="Property",i[i.Event=10]="Event",i[i.Operator=11]="Operator",i[i.Unit=12]="Unit",i[i.Value=13]="Value",i[i.Constant=14]="Constant",i[i.Enum=15]="Enum",i[i.EnumMember=16]="EnumMember",i[i.Keyword=17]="Keyword",i[i.Text=18]="Text",i[i.Color=19]="Color",i[i.File=20]="File",i[i.Reference=21]="Reference",i[i.Customcolor=22]="Customcolor",i[i.Folder=23]="Folder",i[i.TypeParameter=24]="TypeParameter",i[i.User=25]="User",i[i.Issue=26]="Issue",i[i.Snippet=27]="Snippet"})(C=e.CompletionItemKind||(e.CompletionItemKind={}));var R;(function(i){const p=new Map;p.set(0,a.Codicon.symbolMethod),p.set(1,a.Codicon.symbolFunction),p.set(2,a.Codicon.symbolConstructor),p.set(3,a.Codicon.symbolField),p.set(4,a.Codicon.symbolVariable),p.set(5,a.Codicon.symbolClass),p.set(6,a.Codicon.symbolStruct),p.set(7,a.Codicon.symbolInterface),p.set(8,a.Codicon.symbolModule),p.set(9,a.Codicon.symbolProperty),p.set(10,a.Codicon.symbolEvent),p.set(11,a.Codicon.symbolOperator),p.set(12,a.Codicon.symbolUnit),p.set(13,a.Codicon.symbolValue),p.set(15,a.Codicon.symbolEnum),p.set(14,a.Codicon.symbolConstant),p.set(15,a.Codicon.symbolEnum),p.set(16,a.Codicon.symbolEnumMember),p.set(17,a.Codicon.symbolKeyword),p.set(27,a.Codicon.symbolSnippet),p.set(18,a.Codicon.symbolText),p.set(19,a.Codicon.symbolColor),p.set(20,a.Codicon.symbolFile),p.set(21,a.Codicon.symbolReference),p.set(22,a.Codicon.symbolCustomColor),p.set(23,a.Codicon.symbolFolder),p.set(24,a.Codicon.symbolTypeParameter),p.set(25,a.Codicon.account),p.set(26,a.Codicon.issues);function I(G){let V=p.get(G);return V||(console.info("No codicon found for CompletionItemKind "+G),V=a.Codicon.symbolProperty),V}i.toIcon=I;const L=new Map;L.set("method",0),L.set("function",1),L.set("constructor",2),L.set("field",3),L.set("variable",4),L.set("class",5),L.set("struct",6),L.set("interface",7),L.set("module",8),L.set("property",9),L.set("event",10),L.set("operator",11),L.set("unit",12),L.set("value",13),L.set("constant",14),L.set("enum",15),L.set("enum-member",16),L.set("enumMember",16),L.set("keyword",17),L.set("snippet",27),L.set("text",18),L.set("color",19),L.set("file",20),L.set("reference",21),L.set("customcolor",22),L.set("folder",23),L.set("type-parameter",24),L.set("typeParameter",24),L.set("account",25),L.set("issue",26);function U(G,V){let O=L.get(G);return typeof O>"u"&&!V&&(O=9),O}i.fromString=U})(R=e.CompletionItemKinds||(e.CompletionItemKinds={}));var P;(function(i){i[i.Deprecated=1]="Deprecated"})(P=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(i){i[i.KeepWhitespace=1]="KeepWhitespace",i[i.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var y;(function(i){i[i.Invoke=0]="Invoke",i[i.TriggerCharacter=1]="TriggerCharacter",i[i.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(y=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var v;(function(i){i[i.Automatic=0]="Automatic",i[i.Explicit=1]="Explicit"})(v=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var d;(function(i){i[i.Invoke=1]="Invoke",i[i.Auto=2]="Auto"})(d=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var g;(function(i){i[i.Invoke=1]="Invoke",i[i.TriggerCharacter=2]="TriggerCharacter",i[i.ContentChange=3]="ContentChange"})(g=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var h;(function(i){i[i.Text=0]="Text",i[i.Read=1]="Read",i[i.Write=2]="Write"})(h=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function w(i){return i&&t.URI.isUri(i.uri)&&k.Range.isIRange(i.range)&&(k.Range.isIRange(i.originSelectionRange)||k.Range.isIRange(i.targetSelectionRange))}e.isLocationLink=w;var m;(function(i){i[i.File=0]="File",i[i.Module=1]="Module",i[i.Namespace=2]="Namespace",i[i.Package=3]="Package",i[i.Class=4]="Class",i[i.Method=5]="Method",i[i.Property=6]="Property",i[i.Field=7]="Field",i[i.Constructor=8]="Constructor",i[i.Enum=9]="Enum",i[i.Interface=10]="Interface",i[i.Function=11]="Function",i[i.Variable=12]="Variable",i[i.Constant=13]="Constant",i[i.String=14]="String",i[i.Number=15]="Number",i[i.Boolean=16]="Boolean",i[i.Array=17]="Array",i[i.Object=18]="Object",i[i.Key=19]="Key",i[i.Null=20]="Null",i[i.EnumMember=21]="EnumMember",i[i.Struct=22]="Struct",i[i.Event=23]="Event",i[i.Operator=24]="Operator",i[i.TypeParameter=25]="TypeParameter"})(m=e.SymbolKind||(e.SymbolKind={}));var f;(function(i){i[i.Deprecated=1]="Deprecated"})(f=e.SymbolTag||(e.SymbolTag={}));var b;(function(i){const p=new Map;p.set(0,a.Codicon.symbolFile),p.set(1,a.Codicon.symbolModule),p.set(2,a.Codicon.symbolNamespace),p.set(3,a.Codicon.symbolPackage),p.set(4,a.Codicon.symbolClass),p.set(5,a.Codicon.symbolMethod),p.set(6,a.Codicon.symbolProperty),p.set(7,a.Codicon.symbolField),p.set(8,a.Codicon.symbolConstructor),p.set(9,a.Codicon.symbolEnum),p.set(10,a.Codicon.symbolInterface),p.set(11,a.Codicon.symbolFunction),p.set(12,a.Codicon.symbolVariable),p.set(13,a.Codicon.symbolConstant),p.set(14,a.Codicon.symbolString),p.set(15,a.Codicon.symbolNumber),p.set(16,a.Codicon.symbolBoolean),p.set(17,a.Codicon.symbolArray),p.set(18,a.Codicon.symbolObject),p.set(19,a.Codicon.symbolKey),p.set(20,a.Codicon.symbolNull),p.set(21,a.Codicon.symbolEnumMember),p.set(22,a.Codicon.symbolStruct),p.set(23,a.Codicon.symbolEvent),p.set(24,a.Codicon.symbolOperator),p.set(25,a.Codicon.symbolTypeParameter);function I(L){let U=p.get(L);return U||(console.info("No codicon found for SymbolKind "+L),U=a.Codicon.symbolProperty),U}i.toIcon=I})(b=e.SymbolKinds||(e.SymbolKinds={}));class s{constructor(p){this.value=p}}e.FoldingRangeKind=s,s.Comment=new s("comment"),s.Imports=new s("imports"),s.Region=new s("region");var o;(function(i){function p(I){return!I||typeof I!="object"?!1:typeof I.id=="string"&&typeof I.title=="string"}i.is=p})(o=e.Command||(e.Command={}));var c;(function(i){i[i.Collapsed=0]="Collapsed",i[i.Expanded=1]="Expanded"})(c=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var u;(function(i){i[i.Unresolved=0]="Unresolved",i[i.Resolved=1]="Resolved"})(u=e.CommentThreadState||(e.CommentThreadState={}));var r;(function(i){i[i.Editing=0]="Editing",i[i.Preview=1]="Preview"})(r=e.CommentMode||(e.CommentMode={}));var l;(function(i){i[i.Type=1]="Type",i[i.Parameter=2]="Parameter"})(l=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new A.TokenizationRegistry;var n;(function(i){i[i.None=0]="None",i[i.Option=1]="Option",i[i.Default=2]="Default",i[i.Preferred=3]="Preferred"})(n=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(Se[165],ye([19,20]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(Se[119],ye([1,0,165,12,104,17,23,149]),function(te,e,a,t,k,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontFamily=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(oe){oe[oe.None=0]="None",oe[oe.Keep=1]="Keep",oe[oe.Brackets=2]="Brackets",oe[oe.Advanced=3]="Advanced",oe[oe.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class C{constructor(W){this.c=W}hasChanged(W){return this.c[W]}}e.ConfigurationChangedEvent=C;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class P{constructor(W,ae,Ce,Le){this.id=W,this.name=ae,this.defaultValue=Ce,this.schema=Le}applyUpdate(W,ae){return y(W,ae)}compute(W,ae,Ce){return Ce}}class E{constructor(W,ae){this.newValue=W,this.didChange=ae}}e.ApplyUpdateResult=E;function y(oe,W){if(typeof oe!="object"||typeof W!="object"||!oe||!W)return new E(W,oe!==W);if(Array.isArray(oe)||Array.isArray(W)){const Ce=Array.isArray(oe)&&Array.isArray(W)&&A.equals(oe,W);return new E(W,!Ce)}let ae=!1;for(const Ce in W)if(W.hasOwnProperty(Ce)){const Le=y(oe[Ce],W[Ce]);Le.didChange&&(oe[Ce]=Le.newValue,ae=!0)}return new E(oe,ae)}class v{constructor(W){this.schema=void 0,this.id=W,this.name="_never_",this.defaultValue=void 0}applyUpdate(W,ae){return y(W,ae)}validate(W){return this.defaultValue}}class d{constructor(W,ae,Ce,Le){this.id=W,this.name=ae,this.defaultValue=Ce,this.schema=Le}applyUpdate(W,ae){return y(W,ae)}validate(W){return typeof W>"u"?this.defaultValue:W}compute(W,ae,Ce){return Ce}}function g(oe,W){return typeof oe>"u"?W:oe==="false"?!1:Boolean(oe)}e.boolean=g;class h extends d{constructor(W,ae,Ce,Le=void 0){typeof Le<"u"&&(Le.type="boolean",Le.default=Ce),super(W,ae,Ce,Le)}validate(W){return g(W,this.defaultValue)}}function w(oe,W,ae,Ce){if(typeof oe>"u")return W;let Le=parseInt(oe,10);return isNaN(Le)?W:(Le=Math.max(ae,Le),Le=Math.min(Ce,Le),Le|0)}e.clampedInt=w;class m extends d{static clampedInt(W,ae,Ce,Le){return w(W,ae,Ce,Le)}constructor(W,ae,Ce,Le,Be,Xe=void 0){typeof Xe<"u"&&(Xe.type="integer",Xe.default=Ce,Xe.minimum=Le,Xe.maximum=Be),super(W,ae,Ce,Xe),this.minimum=Le,this.maximum=Be}validate(W){return m.clampedInt(W,this.defaultValue,this.minimum,this.maximum)}}class f extends d{static clamp(W,ae,Ce){return W<ae?ae:W>Ce?Ce:W}static float(W,ae){if(typeof W=="number")return W;if(typeof W>"u")return ae;const Ce=parseFloat(W);return isNaN(Ce)?ae:Ce}constructor(W,ae,Ce,Le,Be){typeof Be<"u"&&(Be.type="number",Be.default=Ce),super(W,ae,Ce,Be),this.validationFn=Le}validate(W){return this.validationFn(f.float(W,this.defaultValue))}}class b extends d{static string(W,ae){return typeof W!="string"?ae:W}constructor(W,ae,Ce,Le=void 0){typeof Le<"u"&&(Le.type="string",Le.default=Ce),super(W,ae,Ce,Le)}validate(W){return b.string(W,this.defaultValue)}}function s(oe,W,ae){return typeof oe!="string"||ae.indexOf(oe)===-1?W:oe}e.stringSet=s;class o extends d{constructor(W,ae,Ce,Le,Be=void 0){typeof Be<"u"&&(Be.type="string",Be.enum=Le,Be.default=Ce),super(W,ae,Ce,Be),this.c=Le}validate(W){return s(W,this.defaultValue,this.c)}}class c extends P{constructor(W,ae,Ce,Le,Be,Xe,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=Be,Ze.default=Le),super(W,ae,Ce,Ze),this.c=Be,this.d=Xe}validate(W){return typeof W!="string"?this.defaultValue:this.c.indexOf(W)===-1?this.defaultValue:this.d(W)}}function u(oe){switch(oe){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class r extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(0,null),a.localize(1,null),a.localize(2,null)],default:"auto",tags:["accessibility"],description:a.localize(3,null)})}validate(W){switch(W){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(W,ae,Ce){return Ce===0?W.accessibilitySupport:Ce}}class l extends P{constructor(){const W={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",W,{"editor.comments.insertSpace":{type:"boolean",default:W.insertSpace,description:a.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:W.ignoreEmptyLines,description:a.localize(5,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ae=W;return{insertSpace:g(ae.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:g(ae.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(oe){oe[oe.Hidden=0]="Hidden",oe[oe.Blink=1]="Blink",oe[oe.Smooth=2]="Smooth",oe[oe.Phase=3]="Phase",oe[oe.Expand=4]="Expand",oe[oe.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function i(oe){switch(oe){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var p;(function(oe){oe[oe.Line=1]="Line",oe[oe.Block=2]="Block",oe[oe.Underline=3]="Underline",oe[oe.LineThin=4]="LineThin",oe[oe.BlockOutline=5]="BlockOutline",oe[oe.UnderlineThin=6]="UnderlineThin"})(p=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function I(oe){switch(oe){case p.Line:return"line";case p.Block:return"block";case p.Underline:return"underline";case p.LineThin:return"line-thin";case p.BlockOutline:return"block-outline";case p.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=I;function L(oe){switch(oe){case"line":return p.Line;case"block":return p.Block;case"underline":return p.Underline;case"line-thin":return p.LineThin;case"block-outline":return p.BlockOutline;case"underline-thin":return p.UnderlineThin}}class U extends v{constructor(){super(133)}compute(W,ae,Ce){const Le=["monaco-editor"];return ae.get(34)&&Le.push(ae.get(34)),W.extraEditorClassName&&Le.push(W.extraEditorClassName),ae.get(68)==="default"?Le.push("mouse-default"):ae.get(68)==="copy"&&Le.push("mouse-copy"),ae.get(103)&&Le.push("showUnused"),ae.get(131)&&Le.push("showDeprecated"),Le.join(" ")}}class G extends h{constructor(){super(33,"emptySelectionClipboard",!0,{description:a.localize(6,null)})}compute(W,ae,Ce){return Ce&&W.emptySelectionClipboard}}class V extends P{constructor(){const W={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",W,{"editor.find.cursorMoveOnType":{type:"boolean",default:W.cursorMoveOnType,description:a.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:W.seedSearchStringFromSelection,enumDescriptions:[a.localize(8,null),a.localize(9,null),a.localize(10,null)],description:a.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:W.autoFindInSelection,enumDescriptions:[a.localize(12,null),a.localize(13,null),a.localize(14,null)],description:a.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:W.globalFindClipboard,description:a.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:W.addExtraSpaceOnTop,description:a.localize(17,null)},"editor.find.loop":{type:"boolean",default:W.loop,description:a.localize(18,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ae=W;return{cursorMoveOnType:g(ae.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof W.seedSearchStringFromSelection=="boolean"?W.seedSearchStringFromSelection?"always":"never":s(ae.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof W.autoFindInSelection=="boolean"?W.autoFindInSelection?"always":"never":s(ae.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:g(ae.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:g(ae.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:g(ae.loop,this.defaultValue.loop)}}}class O extends P{constructor(){super(46,"fontLigatures",O.OFF,{anyOf:[{type:"boolean",description:a.localize(19,null)},{type:"string",description:a.localize(20,null)}],description:a.localize(21,null),default:!1})}validate(W){return typeof W>"u"?this.defaultValue:typeof W=="string"?W==="false"?O.OFF:W==="true"?O.ON:W:Boolean(W)?O.ON:O.OFF}}e.EditorFontLigatures=O,O.OFF='"liga" off, "calt" off',O.ON='"liga" on, "calt" on';class B extends P{constructor(){super(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{anyOf:[{type:"string"},{type:"array",items:{type:"string"}}],description:a.localize(22,null),default:e.EDITOR_FONT_DEFAULTS.fontFamily})}validate(W){return typeof W=="string"?W:Array.isArray(W)&&W.length>0?W.map(ae=>JSON.stringify(ae)).join(","):this.defaultValue}}e.EditorFontFamily=B;class F extends P{constructor(){super(49,"fontVariations",F.OFF,{anyOf:[{type:"boolean",description:a.localize(23,null)},{type:"string",description:a.localize(24,null)}],description:a.localize(25,null),default:!1})}validate(W){return typeof W>"u"?this.defaultValue:typeof W=="string"?W==="false"?F.OFF:W==="true"?F.TRANSLATE:W:Boolean(W)?F.TRANSLATE:F.OFF}compute(W,ae,Ce){return W.fontInfo.fontVariationSettings}}e.EditorFontVariations=F,F.OFF="normal",F.TRANSLATE="translate";class $ extends v{constructor(){super(45)}compute(W,ae,Ce){return W.fontInfo}}class M extends d{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(26,null)})}validate(W){const ae=f.float(W,this.defaultValue);return ae===0?e.EDITOR_FONT_DEFAULTS.fontSize:f.clamp(ae,6,100)}compute(W,ae,Ce){return W.fontInfo.fontSize}}class H extends P{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:H.d,maximum:H.e,errorMessage:a.localize(27,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:H.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(28,null)})}validate(W){return W==="normal"||W==="bold"?W:String(m.clampedInt(W,e.EDITOR_FONT_DEFAULTS.fontWeight,H.d,H.e))}}H.c=["normal","bold","100","200","300","400","500","600","700","800","900"],H.d=1,H.e=1e3;class K extends P{constructor(){const W={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ae={type:"string",enum:["peek","gotoAndPeek","goto"],default:W.multiple,enumDescriptions:[a.localize(29,null),a.localize(30,null),a.localize(31,null)]},Ce=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(53,"gotoLocation",W,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(32,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(33,null),...ae},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(34,null),...ae},"editor.gotoLocation.multipleDeclarations":{description:a.localize(35,null),...ae},"editor.gotoLocation.multipleImplementations":{description:a.localize(36,null),...ae},"editor.gotoLocation.multipleReferences":{description:a.localize(37,null),...ae},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:W.alternativeDefinitionCommand,enum:Ce,description:a.localize(38,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:W.alternativeTypeDefinitionCommand,enum:Ce,description:a.localize(39,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:W.alternativeDeclarationCommand,enum:Ce,description:a.localize(40,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:W.alternativeImplementationCommand,enum:Ce,description:a.localize(41,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:W.alternativeReferenceCommand,enum:Ce,description:a.localize(42,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ae=W;return{multiple:s(ae.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ae.multipleDefinitions??s(ae.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ae.multipleTypeDefinitions??s(ae.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ae.multipleDeclarations??s(ae.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ae.multipleImplementations??s(ae.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ae.multipleReferences??s(ae.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:b.string(ae.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:b.string(ae.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:b.string(ae.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:b.string(ae.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:b.string(ae.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class q extends P{constructor(){const W={enabled:!0,delay:300,sticky:!0,above:!0};super(55,"hover",W,{"editor.hover.enabled":{type:"boolean",default:W.enabled,description:a.localize(43,null)},"editor.hover.delay":{type:"number",default:W.delay,minimum:0,maximum:1e4,description:a.localize(44,null)},"editor.hover.sticky":{type:"boolean",default:W.sticky,description:a.localize(45,null)},"editor.hover.above":{type:"boolean",default:W.above,description:a.localize(46,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ae=W;return{enabled:g(ae.enabled,this.defaultValue.enabled),delay:m.clampedInt(ae.delay,this.defaultValue.delay,0,1e4),sticky:g(ae.sticky,this.defaultValue.sticky),above:g(ae.above,this.defaultValue.above)}}}var Y;(function(oe){oe[oe.None=0]="None",oe[oe.Text=1]="Text",oe[oe.Blocks=2]="Blocks"})(Y=e.RenderMinimap||(e.RenderMinimap={}));class Q extends v{constructor(){super(136)}compute(W,ae,Ce){return Q.computeLayout(ae,{memory:W.memory,outerWidth:W.outerWidth,outerHeight:W.outerHeight,isDominatedByLongLines:W.isDominatedByLongLines,lineHeight:W.fontInfo.lineHeight,viewLineCount:W.viewLineCount,lineNumbersDigitCount:W.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:W.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:W.fontInfo.maxDigitWidth,pixelRatio:W.pixelRatio})}static computeContainedMinimapLineCount(W){const ae=W.height/W.lineHeight,Ce=W.scrollBeyondLastLine?ae-1:0,Le=(W.viewLineCount+Ce)/(W.pixelRatio*W.height),Be=Math.floor(W.viewLineCount/Le);return{typicalViewportLineCount:ae,extraLinesBeyondLastLine:Ce,desiredRatio:Le,minimapLineCount:Be}}static c(W,ae){const Ce=W.outerWidth,Le=W.outerHeight,Be=W.pixelRatio;if(!W.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Be*Le),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Le};const Xe=ae.stableMinimapLayoutInput,Ze=Xe&&W.outerHeight===Xe.outerHeight&&W.lineHeight===Xe.lineHeight&&W.typicalHalfwidthCharacterWidth===Xe.typicalHalfwidthCharacterWidth&&W.pixelRatio===Xe.pixelRatio&&W.scrollBeyondLastLine===Xe.scrollBeyondLastLine&&W.minimap.enabled===Xe.minimap.enabled&&W.minimap.side===Xe.minimap.side&&W.minimap.size===Xe.minimap.size&&W.minimap.showSlider===Xe.minimap.showSlider&&W.minimap.renderCharacters===Xe.minimap.renderCharacters&&W.minimap.maxColumn===Xe.minimap.maxColumn&&W.minimap.scale===Xe.minimap.scale&&W.verticalScrollbarWidth===Xe.verticalScrollbarWidth&&W.isViewportWrapping===Xe.isViewportWrapping,ft=W.lineHeight,mt=W.typicalHalfwidthCharacterWidth,lt=W.scrollBeyondLastLine,ot=W.minimap.renderCharacters;let rt=Be>=2?Math.round(W.minimap.scale*2):W.minimap.scale;const Tt=W.minimap.maxColumn,kt=W.minimap.size,Mt=W.minimap.side,pt=W.verticalScrollbarWidth,Ct=W.viewLineCount,Rt=W.remainingWidth,Ut=W.isViewportWrapping,xe=ot?2:3;let Ot=Math.floor(Be*Le);const jt=Ot/Be;let qt=!1,bt=!1,Pt=xe*rt,Ae=rt/Be,Oe=1;if(kt==="fill"||kt==="fit"){const{typicalViewportLineCount:tt,extraLinesBeyondLastLine:Dt,desiredRatio:vt,minimapLineCount:Lt}=Q.computeContainedMinimapLineCount({viewLineCount:Ct,scrollBeyondLastLine:lt,height:Le,lineHeight:ft,pixelRatio:Be});if(Ct/Lt>1)qt=!0,bt=!0,rt=1,Pt=1,Ae=rt/Be;else{let yt=!1,gt=rt+1;if(kt==="fit"){const $t=Math.ceil((Ct+Dt)*Pt);Ut&&Ze&&Rt<=ae.stableFitRemainingWidth?(yt=!0,gt=ae.stableFitMaxMinimapScale):yt=$t>Ot}if(kt==="fill"||yt){qt=!0;const $t=rt;Pt=Math.min(ft*Be,Math.max(1,Math.floor(1/vt))),Ut&&Ze&&Rt<=ae.stableFitRemainingWidth&&(gt=ae.stableFitMaxMinimapScale),rt=Math.min(gt,Math.max(1,Math.floor(Pt/xe))),rt>$t&&(Oe=Math.min(2,rt/$t)),Ae=rt/Be/Oe,Ot=Math.ceil(Math.max(tt,Ct+Dt)*Pt),Ut?(ae.stableMinimapLayoutInput=W,ae.stableFitRemainingWidth=Rt,ae.stableFitMaxMinimapScale=rt):(ae.stableMinimapLayoutInput=null,ae.stableFitRemainingWidth=0)}}}const Ee=Math.floor(Tt*Ae),ee=Math.min(Ee,Math.max(0,Math.floor((Rt-pt-2)*Ae/(mt+Ae)))+e.MINIMAP_GUTTER_WIDTH);let Ne=Math.floor(Be*ee);const ze=Ne/Be;Ne=Math.floor(Ne*Oe);const Qe=ot?1:2,Ge=Mt==="left"?0:Ce-ee-pt;return{renderMinimap:Qe,minimapLeft:Ge,minimapWidth:ee,minimapHeightIsEditorHeight:qt,minimapIsSampling:bt,minimapScale:rt,minimapLineHeight:Pt,minimapCanvasInnerWidth:Ne,minimapCanvasInnerHeight:Ot,minimapCanvasOuterWidth:ze,minimapCanvasOuterHeight:jt}}static computeLayout(W,ae){const Ce=ae.outerWidth|0,Le=ae.outerHeight|0,Be=ae.lineHeight|0,Xe=ae.lineNumbersDigitCount|0,Ze=ae.typicalHalfwidthCharacterWidth,ft=ae.maxDigitWidth,mt=ae.pixelRatio,lt=ae.viewLineCount,ot=W.get(128),rt=ot==="inherit"?W.get(127):ot,Tt=rt==="inherit"?W.get(123):rt,kt=W.get(126),Mt=ae.isDominatedByLongLines,pt=W.get(52),Ct=W.get(62).renderType!==0,Rt=W.get(63),Ut=W.get(97),xe=W.get(67),Ot=W.get(95),jt=Ot.verticalScrollbarSize,qt=Ot.verticalHasArrows,bt=Ot.arrowSize,Pt=Ot.horizontalScrollbarSize,Ae=W.get(60),Oe=W.get(38),Ee=W.get(102)!=="never";let ee;if(typeof Ae=="string"&&/^\d+(\.\d+)?ch$/.test(Ae)){const Xt=parseFloat(Ae.substr(0,Ae.length-2));ee=m.clampedInt(Xt*Ze,0,0,1e3)}else ee=m.clampedInt(Ae,0,0,1e3);Oe&&Ee&&(ee+=16);let Ne=0;if(Ct){const Xt=Math.max(Xe,Rt);Ne=Math.round(Xt*ft)}let ze=0;pt&&(ze=Be);let Qe=0,Ge=Qe+ze,tt=Ge+Ne,Dt=tt+ee;const vt=Ce-ze-Ne-ee;let Lt=!1,St=!1,yt=-1;rt==="inherit"&&Mt?(Lt=!0,St=!0):Tt==="on"||Tt==="bounded"?St=!0:Tt==="wordWrapColumn"&&(yt=kt);const gt=Q.c({outerWidth:Ce,outerHeight:Le,lineHeight:Be,typicalHalfwidthCharacterWidth:Ze,pixelRatio:mt,scrollBeyondLastLine:Ut,minimap:xe,verticalScrollbarWidth:jt,viewLineCount:lt,remainingWidth:vt,isViewportWrapping:St},ae.memory||new R);gt.renderMinimap!==0&&gt.minimapLeft===0&&(Qe+=gt.minimapWidth,Ge+=gt.minimapWidth,tt+=gt.minimapWidth,Dt+=gt.minimapWidth);const $t=vt-gt.minimapWidth,Jt=Math.max(1,Math.floor(($t-jt-2)/Ze)),Et=qt?bt:0;return St&&(yt=Math.max(1,Jt),Tt==="bounded"&&(yt=Math.min(yt,kt))),{width:Ce,height:Le,glyphMarginLeft:Qe,glyphMarginWidth:ze,lineNumbersLeft:Ge,lineNumbersWidth:Ne,decorationsLeft:tt,decorationsWidth:ee,contentLeft:Dt,contentWidth:$t,minimap:gt,viewportColumn:Jt,isWordWrapMinified:Lt,isViewportWrapping:St,wrappingColumn:yt,verticalScrollbarWidth:jt,horizontalScrollbarHeight:Pt,overviewRuler:{top:Et,width:jt,height:Le-2*Et,right:0}}}}e.EditorLayoutInfoComputer=Q;class ce extends P{constructor(){super(130,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[a.localize(47,null),a.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:a.localize(49,null)}})}validate(W){return s(W,"simple",["simple","advanced"])}compute(W,ae,Ce){return ae.get(2)===2?"advanced":Ce}}class ie extends P{constructor(){const W={enabled:!0};super(59,"lightbulb",W,{"editor.lightbulb.enabled":{type:"boolean",default:W.enabled,description:a.localize(50,null)}})}validate(W){return!W||typeof W!="object"?this.defaultValue:{enabled:g(W.enabled,this.defaultValue.enabled)}}}class de extends P{constructor(){const W={enabled:!1,maxLineCount:5};super(107,"stickyScroll",W,{"editor.stickyScroll.enabled":{type:"boolean",default:W.enabled,description:a.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:W.maxLineCount,minimum:1,maximum:10,description:a.localize(52,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ae=W;return{enabled:g(ae.enabled,this.defaultValue.enabled),maxLineCount:m.clampedInt(ae.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class J extends P{constructor(){const W={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(132,"inlayHints",W,{"editor.inlayHints.enabled":{type:"string",default:W.enabled,description:a.localize(53,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[a.localize(54,null),a.localize(55,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(56,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(57,null)]},"editor.inlayHints.fontSize":{type:"number",default:W.fontSize,markdownDescription:a.localize(58,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:W.fontFamily,markdownDescription:a.localize(59,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:W.padding,description:a.localize(60,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ae=W;return typeof ae.enabled=="boolean"&&(ae.enabled=ae.enabled?"on":"off"),{enabled:s(ae.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:m.clampedInt(ae.fontSize,this.defaultValue.fontSize,0,100),fontFamily:b.string(ae.fontFamily,this.defaultValue.fontFamily),padding:g(ae.padding,this.defaultValue.padding)}}}class pe extends f{constructor(){super(61,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,W=>f.clamp(W,0,150),{markdownDescription:a.localize(61,null)})}compute(W,ae,Ce){return W.fontInfo.lineHeight}}class ve extends P{constructor(){const W={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(67,"minimap",W,{"editor.minimap.enabled":{type:"boolean",default:W.enabled,description:a.localize(62,null)},"editor.minimap.autohide":{type:"boolean",default:W.autohide,description:a.localize(63,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(64,null),a.localize(65,null),a.localize(66,null)],default:W.size,description:a.localize(67,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:W.side,description:a.localize(68,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:W.showSlider,description:a.localize(69,null)},"editor.minimap.scale":{type:"number",default:W.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(70,null)},"editor.minimap.renderCharacters":{type:"boolean",default:W.renderCharacters,description:a.localize(71,null)},"editor.minimap.maxColumn":{type:"number",default:W.maxColumn,description:a.localize(72,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ae=W;return{enabled:g(ae.enabled,this.defaultValue.enabled),autohide:g(ae.autohide,this.defaultValue.autohide),size:s(ae.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(ae.side,this.defaultValue.side,["right","left"]),showSlider:s(ae.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:g(ae.renderCharacters,this.defaultValue.renderCharacters),scale:m.clampedInt(ae.scale,1,1,3),maxColumn:m.clampedInt(ae.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function De(oe){return oe==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Re extends P{constructor(){super(78,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(73,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(74,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ae=W;return{top:m.clampedInt(ae.top,0,0,1e3),bottom:m.clampedInt(ae.bottom,0,0,1e3)}}}class $e extends P{constructor(){const W={enabled:!0,cycle:!1};super(79,"parameterHints",W,{"editor.parameterHints.enabled":{type:"boolean",default:W.enabled,description:a.localize(75,null)},"editor.parameterHints.cycle":{type:"boolean",default:W.cycle,description:a.localize(76,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ae=W;return{enabled:g(ae.enabled,this.defaultValue.enabled),cycle:g(ae.cycle,this.defaultValue.cycle)}}}class re extends v{constructor(){super(134)}compute(W,ae,Ce){return W.pixelRatio}}class le extends P{constructor(){const W={other:"on",comments:"off",strings:"off"},ae=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[a.localize(77,null),a.localize(78,null),a.localize(79,null)]}];super(82,"quickSuggestions",W,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ae,default:W.strings,description:a.localize(80,null)},comments:{anyOf:ae,default:W.comments,description:a.localize(81,null)},other:{anyOf:ae,default:W.other,description:a.localize(82,null)}},default:W,markdownDescription:a.localize(83,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=W}validate(W){if(typeof W=="boolean"){const mt=W?"on":"off";return{comments:mt,strings:mt,other:mt}}if(!W||typeof W!="object")return this.defaultValue;const{other:ae,comments:Ce,strings:Le}=W,Be=["on","inline","off"];let Xe,Ze,ft;return typeof ae=="boolean"?Xe=ae?"on":"off":Xe=s(ae,this.defaultValue.other,Be),typeof Ce=="boolean"?Ze=Ce?"on":"off":Ze=s(Ce,this.defaultValue.comments,Be),typeof Le=="boolean"?ft=Le?"on":"off":ft=s(Le,this.defaultValue.strings,Be),{other:Xe,comments:Ze,strings:ft}}}var fe;(function(oe){oe[oe.Off=0]="Off",oe[oe.On=1]="On",oe[oe.Relative=2]="Relative",oe[oe.Interval=3]="Interval",oe[oe.Custom=4]="Custom"})(fe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Z extends P{constructor(){super(62,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(84,null),a.localize(85,null),a.localize(86,null),a.localize(87,null)],default:"on",description:a.localize(88,null)})}validate(W){let ae=this.defaultValue.renderType,Ce=this.defaultValue.renderFn;return typeof W<"u"&&(typeof W=="function"?(ae=4,Ce=W):W==="interval"?ae=3:W==="relative"?ae=2:W==="on"?ae=1:ae=0),{renderType:ae,renderFn:Ce}}}function se(oe){const W=oe.get(90);return W==="editable"?oe.get(84):W!=="on"}e.filterValidationDecorations=se;class ne extends P{constructor(){const W=[],ae={type:"number",description:a.localize(89,null)};super(94,"rulers",W,{type:"array",items:{anyOf:[ae,{type:["object"],properties:{column:ae,color:{type:"string",description:a.localize(90,null),format:"color-hex"}}}]},default:W,description:a.localize(91,null)})}validate(W){if(Array.isArray(W)){const ae=[];for(const Ce of W)if(typeof Ce=="number")ae.push({column:m.clampedInt(Ce,0,0,1e4),color:null});else if(Ce&&typeof Ce=="object"){const Le=Ce;ae.push({column:m.clampedInt(Le.column,0,0,1e4),color:Le.color})}return ae.sort((Ce,Le)=>Ce.column-Le.column),ae}return this.defaultValue}}function N(oe,W){if(typeof oe!="string")return W;switch(oe){case"hidden":return 2;case"visible":return 3;default:return 1}}class z extends P{constructor(){const W={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(95,"scrollbar",W,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(92,null),a.localize(93,null),a.localize(94,null)],default:"auto",description:a.localize(95,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(96,null),a.localize(97,null),a.localize(98,null)],default:"auto",description:a.localize(99,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:W.verticalScrollbarSize,description:a.localize(100,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:W.horizontalScrollbarSize,description:a.localize(101,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:W.scrollByPage,description:a.localize(102,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ae=W,Ce=m.clampedInt(ae.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Le=m.clampedInt(ae.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:m.clampedInt(ae.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:N(ae.vertical,this.defaultValue.vertical),horizontal:N(ae.horizontal,this.defaultValue.horizontal),useShadows:g(ae.useShadows,this.defaultValue.useShadows),verticalHasArrows:g(ae.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:g(ae.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:g(ae.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:g(ae.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ce,horizontalSliderSize:m.clampedInt(ae.horizontalSliderSize,Ce,0,1e3),verticalScrollbarSize:Le,verticalSliderSize:m.clampedInt(ae.verticalSliderSize,Le,0,1e3),scrollByPage:g(ae.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class X extends P{constructor(){const W={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(117,"unicodeHighlight",W,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:W.nonBasicASCII,description:a.localize(103,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:W.invisibleCharacters,description:a.localize(104,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:W.ambiguousCharacters,description:a.localize(105,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:W.includeComments,description:a.localize(106,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:W.includeStrings,description:a.localize(107,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:W.allowedCharacters,description:a.localize(108,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:W.allowedLocales,description:a.localize(109,null)}})}applyUpdate(W,ae){let Ce=!1;ae.allowedCharacters&&W&&(D.equals(W.allowedCharacters,ae.allowedCharacters)||(W={...W,allowedCharacters:ae.allowedCharacters},Ce=!0)),ae.allowedLocales&&W&&(D.equals(W.allowedLocales,ae.allowedLocales)||(W={...W,allowedLocales:ae.allowedLocales},Ce=!0));const Le=super.applyUpdate(W,ae);return Ce?new E(Le.newValue,!0):Le}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ae=W;return{nonBasicASCII:ke(ae.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:g(ae.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:g(ae.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ke(ae.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ke(ae.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(W.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(W.allowedLocales,this.defaultValue.allowedLocales)}}c(W,ae){if(typeof W!="object"||!W)return ae;const Ce={};for(const[Le,Be]of Object.entries(W))Be===!0&&(Ce[Le]=!0);return Ce}}class _ extends P{constructor(){const W={enabled:!0,mode:"subwordSmart"};super(57,"inlineSuggest",W,{"editor.inlineSuggest.enabled":{type:"boolean",default:W.enabled,description:a.localize(110,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ae=W;return{enabled:g(ae.enabled,this.defaultValue.enabled),mode:s(ae.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ue extends P{constructor(){const W={enabled:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",W,{"editor.bracketPairColorization.enabled":{type:"boolean",default:W.enabled,markdownDescription:a.localize(111,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:W.independentColorPoolPerBracketType,description:a.localize(112,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ae=W;return{enabled:g(ae.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:g(ae.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class be extends P{constructor(){const W={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",W,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(113,null),a.localize(114,null),a.localize(115,null)],default:W.bracketPairs,description:a.localize(116,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(117,null),a.localize(118,null),a.localize(119,null)],default:W.bracketPairsHorizontal,description:a.localize(120,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:W.highlightActiveBracketPair,description:a.localize(121,null)},"editor.guides.indentation":{type:"boolean",default:W.indentation,description:a.localize(122,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[a.localize(123,null),a.localize(124,null),a.localize(125,null)],default:W.highlightActiveIndentation,description:a.localize(126,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ae=W;return{bracketPairs:ke(ae.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ke(ae.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:g(ae.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:g(ae.indentation,this.defaultValue.indentation),highlightActiveIndentation:ke(ae.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ke(oe,W,ae){const Ce=ae.indexOf(oe);return Ce===-1?W:ae[Ce]}class ge extends P{constructor(){const W={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectQuickSuggestions:!0,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(110,"suggest",W,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(127,null),a.localize(128,null)],default:W.insertMode,description:a.localize(129,null)},"editor.suggest.filterGraceful":{type:"boolean",default:W.filterGraceful,description:a.localize(130,null)},"editor.suggest.localityBonus":{type:"boolean",default:W.localityBonus,description:a.localize(131,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:W.shareSuggestSelections,markdownDescription:a.localize(132,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:W.snippetsPreventQuickSuggestions,description:a.localize(133,null)},"editor.suggest.showIcons":{type:"boolean",default:W.showIcons,description:a.localize(134,null)},"editor.suggest.showStatusBar":{type:"boolean",default:W.showStatusBar,description:a.localize(135,null)},"editor.suggest.preview":{type:"boolean",default:W.preview,description:a.localize(136,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:W.showInlineDetails,description:a.localize(137,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(138,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(139,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(140,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(141,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(142,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(143,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:a.localize(144,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(145,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(146,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(147,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(148,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(149,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(150,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(151,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(152,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(153,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(154,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(155,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(156,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(157,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(158,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(159,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(160,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(161,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(162,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(163,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(164,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(165,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(166,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(167,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(168,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(169,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const ae=W;return{insertMode:s(ae.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:g(ae.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:g(ae.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:g(ae.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:g(ae.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectQuickSuggestions:g(ae.selectQuickSuggestions,this.defaultValue.selectQuickSuggestions),showIcons:g(ae.showIcons,this.defaultValue.showIcons),showStatusBar:g(ae.showStatusBar,this.defaultValue.showStatusBar),preview:g(ae.preview,this.defaultValue.preview),previewMode:s(ae.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:g(ae.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:g(ae.showMethods,this.defaultValue.showMethods),showFunctions:g(ae.showFunctions,this.defaultValue.showFunctions),showConstructors:g(ae.showConstructors,this.defaultValue.showConstructors),showDeprecated:g(ae.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:g(ae.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:g(ae.showFields,this.defaultValue.showFields),showVariables:g(ae.showVariables,this.defaultValue.showVariables),showClasses:g(ae.showClasses,this.defaultValue.showClasses),showStructs:g(ae.showStructs,this.defaultValue.showStructs),showInterfaces:g(ae.showInterfaces,this.defaultValue.showInterfaces),showModules:g(ae.showModules,this.defaultValue.showModules),showProperties:g(ae.showProperties,this.defaultValue.showProperties),showEvents:g(ae.showEvents,this.defaultValue.showEvents),showOperators:g(ae.showOperators,this.defaultValue.showOperators),showUnits:g(ae.showUnits,this.defaultValue.showUnits),showValues:g(ae.showValues,this.defaultValue.showValues),showConstants:g(ae.showConstants,this.defaultValue.showConstants),showEnums:g(ae.showEnums,this.defaultValue.showEnums),showEnumMembers:g(ae.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:g(ae.showKeywords,this.defaultValue.showKeywords),showWords:g(ae.showWords,this.defaultValue.showWords),showColors:g(ae.showColors,this.defaultValue.showColors),showFiles:g(ae.showFiles,this.defaultValue.showFiles),showReferences:g(ae.showReferences,this.defaultValue.showReferences),showFolders:g(ae.showFolders,this.defaultValue.showFolders),showTypeParameters:g(ae.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:g(ae.showSnippets,this.defaultValue.showSnippets),showUsers:g(ae.showUsers,this.defaultValue.showUsers),showIssues:g(ae.showIssues,this.defaultValue.showIssues)}}}class Pe extends P{constructor(){super(105,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(170,null),default:!0,type:"boolean"}})}validate(W){return!W||typeof W!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:g(W.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Ie extends v{constructor(){super(135)}compute(W,ae,Ce){return ae.get(84)?!0:W.tabFocusMode}}var je;(function(oe){oe[oe.None=0]="None",oe[oe.Same=1]="Same",oe[oe.Indent=2]="Indent",oe[oe.DeepIndent=3]="DeepIndent"})(je=e.WrappingIndent||(e.WrappingIndent={}));class qe extends P{constructor(){super(129,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[a.localize(171,null),a.localize(172,null),a.localize(173,null),a.localize(174,null)],description:a.localize(175,null),default:"same"}})}validate(W){switch(W){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(W,ae,Ce){return ae.get(2)===2?0:Ce}}class et extends v{constructor(){super(137)}compute(W,ae,Ce){const Le=ae.get(136);return{isDominatedByLongLines:W.isDominatedByLongLines,isWordWrapMinified:Le.isWordWrapMinified,isViewportWrapping:Le.isViewportWrapping,wrappingColumn:Le.wrappingColumn}}}class _e extends P{constructor(){const W={enabled:!0};super(32,"dropIntoEditor",W,{"editor.dropIntoEditor.enabled":{type:"boolean",default:W.enabled,markdownDescription:a.localize(176,null)}})}validate(W){return!W||typeof W!="object"?this.defaultValue:{enabled:g(W.enabled,this.defaultValue.enabled)}}}const nt="Consolas, 'Courier New', monospace",st="Menlo, Monaco, 'Courier New', monospace",ht="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?st:t.isLinux?ht:nt,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(oe){return e.editorOptionsRegistry[oe.id]=oe,oe}var it;(function(oe){oe[oe.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",oe[oe.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",oe[oe.accessibilitySupport=2]="accessibilitySupport",oe[oe.accessibilityPageSize=3]="accessibilityPageSize",oe[oe.ariaLabel=4]="ariaLabel",oe[oe.autoClosingBrackets=5]="autoClosingBrackets",oe[oe.autoClosingDelete=6]="autoClosingDelete",oe[oe.autoClosingOvertype=7]="autoClosingOvertype",oe[oe.autoClosingQuotes=8]="autoClosingQuotes",oe[oe.autoIndent=9]="autoIndent",oe[oe.automaticLayout=10]="automaticLayout",oe[oe.autoSurround=11]="autoSurround",oe[oe.bracketPairColorization=12]="bracketPairColorization",oe[oe.guides=13]="guides",oe[oe.codeLens=14]="codeLens",oe[oe.codeLensFontFamily=15]="codeLensFontFamily",oe[oe.codeLensFontSize=16]="codeLensFontSize",oe[oe.colorDecorators=17]="colorDecorators",oe[oe.columnSelection=18]="columnSelection",oe[oe.comments=19]="comments",oe[oe.contextmenu=20]="contextmenu",oe[oe.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",oe[oe.cursorBlinking=22]="cursorBlinking",oe[oe.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",oe[oe.cursorStyle=24]="cursorStyle",oe[oe.cursorSurroundingLines=25]="cursorSurroundingLines",oe[oe.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",oe[oe.cursorWidth=27]="cursorWidth",oe[oe.disableLayerHinting=28]="disableLayerHinting",oe[oe.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",oe[oe.domReadOnly=30]="domReadOnly",oe[oe.dragAndDrop=31]="dragAndDrop",oe[oe.dropIntoEditor=32]="dropIntoEditor",oe[oe.emptySelectionClipboard=33]="emptySelectionClipboard",oe[oe.extraEditorClassName=34]="extraEditorClassName",oe[oe.fastScrollSensitivity=35]="fastScrollSensitivity",oe[oe.find=36]="find",oe[oe.fixedOverflowWidgets=37]="fixedOverflowWidgets",oe[oe.folding=38]="folding",oe[oe.foldingStrategy=39]="foldingStrategy",oe[oe.foldingHighlight=40]="foldingHighlight",oe[oe.foldingImportsByDefault=41]="foldingImportsByDefault",oe[oe.foldingMaximumRegions=42]="foldingMaximumRegions",oe[oe.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",oe[oe.fontFamily=44]="fontFamily",oe[oe.fontInfo=45]="fontInfo",oe[oe.fontLigatures=46]="fontLigatures",oe[oe.fontSize=47]="fontSize",oe[oe.fontWeight=48]="fontWeight",oe[oe.fontVariations=49]="fontVariations",oe[oe.formatOnPaste=50]="formatOnPaste",oe[oe.formatOnType=51]="formatOnType",oe[oe.glyphMargin=52]="glyphMargin",oe[oe.gotoLocation=53]="gotoLocation",oe[oe.hideCursorInOverviewRuler=54]="hideCursorInOverviewRuler",oe[oe.hover=55]="hover",oe[oe.inDiffEditor=56]="inDiffEditor",oe[oe.inlineSuggest=57]="inlineSuggest",oe[oe.letterSpacing=58]="letterSpacing",oe[oe.lightbulb=59]="lightbulb",oe[oe.lineDecorationsWidth=60]="lineDecorationsWidth",oe[oe.lineHeight=61]="lineHeight",oe[oe.lineNumbers=62]="lineNumbers",oe[oe.lineNumbersMinChars=63]="lineNumbersMinChars",oe[oe.linkedEditing=64]="linkedEditing",oe[oe.links=65]="links",oe[oe.matchBrackets=66]="matchBrackets",oe[oe.minimap=67]="minimap",oe[oe.mouseStyle=68]="mouseStyle",oe[oe.mouseWheelScrollSensitivity=69]="mouseWheelScrollSensitivity",oe[oe.mouseWheelZoom=70]="mouseWheelZoom",oe[oe.multiCursorMergeOverlapping=71]="multiCursorMergeOverlapping",oe[oe.multiCursorModifier=72]="multiCursorModifier",oe[oe.multiCursorPaste=73]="multiCursorPaste",oe[oe.multiCursorLimit=74]="multiCursorLimit",oe[oe.occurrencesHighlight=75]="occurrencesHighlight",oe[oe.overviewRulerBorder=76]="overviewRulerBorder",oe[oe.overviewRulerLanes=77]="overviewRulerLanes",oe[oe.padding=78]="padding",oe[oe.parameterHints=79]="parameterHints",oe[oe.peekWidgetDefaultFocus=80]="peekWidgetDefaultFocus",oe[oe.definitionLinkOpensInPeek=81]="definitionLinkOpensInPeek",oe[oe.quickSuggestions=82]="quickSuggestions",oe[oe.quickSuggestionsDelay=83]="quickSuggestionsDelay",oe[oe.readOnly=84]="readOnly",oe[oe.renameOnType=85]="renameOnType",oe[oe.renderControlCharacters=86]="renderControlCharacters",oe[oe.renderFinalNewline=87]="renderFinalNewline",oe[oe.renderLineHighlight=88]="renderLineHighlight",oe[oe.renderLineHighlightOnlyWhenFocus=89]="renderLineHighlightOnlyWhenFocus",oe[oe.renderValidationDecorations=90]="renderValidationDecorations",oe[oe.renderWhitespace=91]="renderWhitespace",oe[oe.revealHorizontalRightPadding=92]="revealHorizontalRightPadding",oe[oe.roundedSelection=93]="roundedSelection",oe[oe.rulers=94]="rulers",oe[oe.scrollbar=95]="scrollbar",oe[oe.scrollBeyondLastColumn=96]="scrollBeyondLastColumn",oe[oe.scrollBeyondLastLine=97]="scrollBeyondLastLine",oe[oe.scrollPredominantAxis=98]="scrollPredominantAxis",oe[oe.selectionClipboard=99]="selectionClipboard",oe[oe.selectionHighlight=100]="selectionHighlight",oe[oe.selectOnLineNumbers=101]="selectOnLineNumbers",oe[oe.showFoldingControls=102]="showFoldingControls",oe[oe.showUnused=103]="showUnused",oe[oe.snippetSuggestions=104]="snippetSuggestions",oe[oe.smartSelect=105]="smartSelect",oe[oe.smoothScrolling=106]="smoothScrolling",oe[oe.stickyScroll=107]="stickyScroll",oe[oe.stickyTabStops=108]="stickyTabStops",oe[oe.stopRenderingLineAfter=109]="stopRenderingLineAfter",oe[oe.suggest=110]="suggest",oe[oe.suggestFontSize=111]="suggestFontSize",oe[oe.suggestLineHeight=112]="suggestLineHeight",oe[oe.suggestOnTriggerCharacters=113]="suggestOnTriggerCharacters",oe[oe.suggestSelection=114]="suggestSelection",oe[oe.tabCompletion=115]="tabCompletion",oe[oe.tabIndex=116]="tabIndex",oe[oe.unicodeHighlighting=117]="unicodeHighlighting",oe[oe.unusualLineTerminators=118]="unusualLineTerminators",oe[oe.useShadowDOM=119]="useShadowDOM",oe[oe.useTabStops=120]="useTabStops",oe[oe.wordBreak=121]="wordBreak",oe[oe.wordSeparators=122]="wordSeparators",oe[oe.wordWrap=123]="wordWrap",oe[oe.wordWrapBreakAfterCharacters=124]="wordWrapBreakAfterCharacters",oe[oe.wordWrapBreakBeforeCharacters=125]="wordWrapBreakBeforeCharacters",oe[oe.wordWrapColumn=126]="wordWrapColumn",oe[oe.wordWrapOverride1=127]="wordWrapOverride1",oe[oe.wordWrapOverride2=128]="wordWrapOverride2",oe[oe.wrappingIndent=129]="wrappingIndent",oe[oe.wrappingStrategy=130]="wrappingStrategy",oe[oe.showDeprecated=131]="showDeprecated",oe[oe.inlayHints=132]="inlayHints",oe[oe.editorClassName=133]="editorClassName",oe[oe.pixelRatio=134]="pixelRatio",oe[oe.tabFocusMode=135]="tabFocusMode",oe[oe.layoutInfo=136]="layoutInfo",oe[oe.wrappingInfo=137]="wrappingInfo"})(it=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(177,null)})),acceptSuggestionOnEnter:Ue(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(178,null),""],markdownDescription:a.localize(179,null)})),accessibilitySupport:Ue(new r),accessibilityPageSize:Ue(new m(3,"accessibilityPageSize",10,1,1073741824,{description:a.localize(180,null),tags:["accessibility"]})),ariaLabel:Ue(new b(4,"ariaLabel",a.localize(181,null))),autoClosingBrackets:Ue(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(182,null),a.localize(183,null),""],description:a.localize(184,null)})),autoClosingDelete:Ue(new o(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(185,null),""],description:a.localize(186,null)})),autoClosingOvertype:Ue(new o(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(187,null),""],description:a.localize(188,null)})),autoClosingQuotes:Ue(new o(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(189,null),a.localize(190,null),""],description:a.localize(191,null)})),autoIndent:Ue(new c(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[a.localize(192,null),a.localize(193,null),a.localize(194,null),a.localize(195,null),a.localize(196,null)],description:a.localize(197,null)})),automaticLayout:Ue(new h(10,"automaticLayout",!1)),autoSurround:Ue(new o(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(198,null),a.localize(199,null),a.localize(200,null),""],description:a.localize(201,null)})),bracketPairColorization:Ue(new ue),bracketPairGuides:Ue(new be),stickyTabStops:Ue(new h(108,"stickyTabStops",!1,{description:a.localize(202,null)})),codeLens:Ue(new h(14,"codeLens",!0,{description:a.localize(203,null)})),codeLensFontFamily:Ue(new b(15,"codeLensFontFamily","",{description:a.localize(204,null)})),codeLensFontSize:Ue(new m(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(205,null)})),colorDecorators:Ue(new h(17,"colorDecorators",!0,{description:a.localize(206,null)})),columnSelection:Ue(new h(18,"columnSelection",!1,{description:a.localize(207,null)})),comments:Ue(new l),contextmenu:Ue(new h(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new h(21,"copyWithSyntaxHighlighting",!0,{description:a.localize(208,null)})),cursorBlinking:Ue(new c(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],i,{description:a.localize(209,null)})),cursorSmoothCaretAnimation:Ue(new h(23,"cursorSmoothCaretAnimation",!1,{description:a.localize(210,null)})),cursorStyle:Ue(new c(24,"cursorStyle",p.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:a.localize(211,null)})),cursorSurroundingLines:Ue(new m(25,"cursorSurroundingLines",0,0,1073741824,{description:a.localize(212,null)})),cursorSurroundingLinesStyle:Ue(new o(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(213,null),a.localize(214,null)],description:a.localize(215,null)})),cursorWidth:Ue(new m(27,"cursorWidth",0,0,1073741824,{markdownDescription:a.localize(216,null)})),disableLayerHinting:Ue(new h(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new h(29,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new h(30,"domReadOnly",!1)),dragAndDrop:Ue(new h(31,"dragAndDrop",!0,{description:a.localize(217,null)})),emptySelectionClipboard:Ue(new G),dropIntoEditor:Ue(new _e),stickyScroll:Ue(new de),extraEditorClassName:Ue(new b(34,"extraEditorClassName","")),fastScrollSensitivity:Ue(new f(35,"fastScrollSensitivity",5,oe=>oe<=0?5:oe,{markdownDescription:a.localize(218,null)})),find:Ue(new V),fixedOverflowWidgets:Ue(new h(37,"fixedOverflowWidgets",!1)),folding:Ue(new h(38,"folding",!0,{description:a.localize(219,null)})),foldingStrategy:Ue(new o(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(220,null),a.localize(221,null)],description:a.localize(222,null)})),foldingHighlight:Ue(new h(40,"foldingHighlight",!0,{description:a.localize(223,null)})),foldingImportsByDefault:Ue(new h(41,"foldingImportsByDefault",!1,{description:a.localize(224,null)})),foldingMaximumRegions:Ue(new m(42,"foldingMaximumRegions",5e3,10,65e3,{description:a.localize(225,null)})),unfoldOnClickAfterEndOfLine:Ue(new h(43,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(226,null)})),fontFamily:Ue(new B),fontInfo:Ue(new $),fontLigatures2:Ue(new O),fontSize:Ue(new M),fontWeight:Ue(new H),fontVariations:Ue(new F),formatOnPaste:Ue(new h(50,"formatOnPaste",!1,{description:a.localize(227,null)})),formatOnType:Ue(new h(51,"formatOnType",!1,{description:a.localize(228,null)})),glyphMargin:Ue(new h(52,"glyphMargin",!0,{description:a.localize(229,null)})),gotoLocation:Ue(new K),hideCursorInOverviewRuler:Ue(new h(54,"hideCursorInOverviewRuler",!1,{description:a.localize(230,null)})),hover:Ue(new q),inDiffEditor:Ue(new h(56,"inDiffEditor",!1)),letterSpacing:Ue(new f(58,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,oe=>f.clamp(oe,-5,20),{description:a.localize(231,null)})),lightbulb:Ue(new ie),lineDecorationsWidth:Ue(new d(60,"lineDecorationsWidth",10)),lineHeight:Ue(new pe),lineNumbers:Ue(new Z),lineNumbersMinChars:Ue(new m(63,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new h(64,"linkedEditing",!1,{description:a.localize(232,null)})),links:Ue(new h(65,"links",!0,{description:a.localize(233,null)})),matchBrackets:Ue(new o(66,"matchBrackets","always",["always","near","never"],{description:a.localize(234,null)})),minimap:Ue(new ve),mouseStyle:Ue(new o(68,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new f(69,"mouseWheelScrollSensitivity",1,oe=>oe===0?1:oe,{markdownDescription:a.localize(235,null)})),mouseWheelZoom:Ue(new h(70,"mouseWheelZoom",!1,{markdownDescription:a.localize(236,null)})),multiCursorMergeOverlapping:Ue(new h(71,"multiCursorMergeOverlapping",!0,{description:a.localize(237,null)})),multiCursorModifier:Ue(new c(72,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],De,{markdownEnumDescriptions:[a.localize(238,null),a.localize(239,null)],markdownDescription:a.localize(240,null)})),multiCursorPaste:Ue(new o(73,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(241,null),a.localize(242,null)],markdownDescription:a.localize(243,null)})),multiCursorLimit:Ue(new m(74,"multiCursorLimit",1e4,1,1e5,{markdownDescription:a.localize(244,null)})),occurrencesHighlight:Ue(new h(75,"occurrencesHighlight",!0,{description:a.localize(245,null)})),overviewRulerBorder:Ue(new h(76,"overviewRulerBorder",!0,{description:a.localize(246,null)})),overviewRulerLanes:Ue(new m(77,"overviewRulerLanes",3,0,3)),padding:Ue(new Re),parameterHints:Ue(new $e),peekWidgetDefaultFocus:Ue(new o(80,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(247,null),a.localize(248,null)],description:a.localize(249,null)})),definitionLinkOpensInPeek:Ue(new h(81,"definitionLinkOpensInPeek",!1,{description:a.localize(250,null)})),quickSuggestions:Ue(new le),quickSuggestionsDelay:Ue(new m(83,"quickSuggestionsDelay",10,0,1073741824,{description:a.localize(251,null)})),readOnly:Ue(new h(84,"readOnly",!1)),renameOnType:Ue(new h(85,"renameOnType",!1,{description:a.localize(252,null),markdownDeprecationMessage:a.localize(253,null)})),renderControlCharacters:Ue(new h(86,"renderControlCharacters",!0,{description:a.localize(254,null),restricted:!0})),renderFinalNewline:Ue(new h(87,"renderFinalNewline",!0,{description:a.localize(255,null)})),renderLineHighlight:Ue(new o(88,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(256,null)],description:a.localize(257,null)})),renderLineHighlightOnlyWhenFocus:Ue(new h(89,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(258,null)})),renderValidationDecorations:Ue(new o(90,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new o(91,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(259,null),a.localize(260,null),a.localize(261,null),""],description:a.localize(262,null)})),revealHorizontalRightPadding:Ue(new m(92,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new h(93,"roundedSelection",!0,{description:a.localize(263,null)})),rulers:Ue(new ne),scrollbar:Ue(new z),scrollBeyondLastColumn:Ue(new m(96,"scrollBeyondLastColumn",4,0,1073741824,{description:a.localize(264,null)})),scrollBeyondLastLine:Ue(new h(97,"scrollBeyondLastLine",!0,{description:a.localize(265,null)})),scrollPredominantAxis:Ue(new h(98,"scrollPredominantAxis",!0,{description:a.localize(266,null)})),selectionClipboard:Ue(new h(99,"selectionClipboard",!0,{description:a.localize(267,null),included:t.isLinux})),selectionHighlight:Ue(new h(100,"selectionHighlight",!0,{description:a.localize(268,null)})),selectOnLineNumbers:Ue(new h(101,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new o(102,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[a.localize(269,null),a.localize(270,null),a.localize(271,null)],description:a.localize(272,null)})),showUnused:Ue(new h(103,"showUnused",!0,{description:a.localize(273,null)})),showDeprecated:Ue(new h(131,"showDeprecated",!0,{description:a.localize(274,null)})),inlayHints:Ue(new J),snippetSuggestions:Ue(new o(104,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(275,null),a.localize(276,null),a.localize(277,null),a.localize(278,null)],description:a.localize(279,null)})),smartSelect:Ue(new Pe),smoothScrolling:Ue(new h(106,"smoothScrolling",!1,{description:a.localize(280,null)})),stopRenderingLineAfter:Ue(new m(109,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new ge),inlineSuggest:Ue(new _),suggestFontSize:Ue(new m(111,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(281,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new m(112,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(282,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new h(113,"suggestOnTriggerCharacters",!0,{description:a.localize(283,null)})),suggestSelection:Ue(new o(114,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(284,null),a.localize(285,null),a.localize(286,null)],description:a.localize(287,null)})),tabCompletion:Ue(new o(115,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(288,null),a.localize(289,null),a.localize(290,null)],description:a.localize(291,null)})),tabIndex:Ue(new m(116,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new X),unusualLineTerminators:Ue(new o(118,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(292,null),a.localize(293,null),a.localize(294,null)],description:a.localize(295,null)})),useShadowDOM:Ue(new h(119,"useShadowDOM",!0)),useTabStops:Ue(new h(120,"useTabStops",!0,{description:a.localize(296,null)})),wordBreak:Ue(new o(121,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[a.localize(297,null),a.localize(298,null)],description:a.localize(299,null)})),wordSeparators:Ue(new b(122,"wordSeparators",k.USUAL_WORD_SEPARATORS,{description:a.localize(300,null)})),wordWrap:Ue(new o(123,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(301,null),a.localize(302,null),a.localize(303,null),a.localize(304,null)],description:a.localize(305,null)})),wordWrapBreakAfterCharacters:Ue(new b(124,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new b(125,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new m(126,"wordWrapColumn",80,1,1073741824,{markdownDescription:a.localize(306,null)})),wordWrapOverride1:Ue(new o(127,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new o(128,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new U),pixelRatio:Ue(new re),tabFocusMode:Ue(new Ie),layoutInfo:Ue(new Q),wrappingInfo:Ue(new et),wrappingIndent:Ue(new qe),wrappingStrategy:Ue(new ce)}}),define(Se[166],ye([19,20]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[167],ye([19,20]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[168],ye([19,20]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[169],ye([19,20]),function(te,e){return te.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Se[170],ye([19,20]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(Se[171],ye([19,20]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(Se[172],ye([19,20]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(Se[173],ye([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[174],ye([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[175],ye([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(Se[176],ye([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[177],ye([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[178],ye([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[179],ye([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[180],ye([19,20]),function(te,e){return te.create("vs/workbench/api/node/extHostDebugService",e)}),define(Se[181],ye([19,20]),function(te,e){return te.create("vs/workbench/api/node/extHostTunnelService",e)}),define(Se[182],ye([19,20]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(Se[183],ye([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[184],ye([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[185],ye([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Se[186],ye([19,20]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[187],ye([19,20]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[188],ye([19,20]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[189],ye([19,20]),function(te,e){return te.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[190],ye([19,20]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[191],ye([1,0,10]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class t{constructor(){this.a=new Map}register(A,D){this.a.set(A,D)}updateManifest(A){if(!(!Array.isArray(A.activationEvents)||!A.contributes)&&!(typeof A.main>"u"&&typeof A.browser>"u"))for(const D in A.contributes){const T=this.a.get(D);if(!T)continue;const S=A.contributes[D],C=Array.isArray(S)?S:[S];try{T(C,A.activationEvents)}catch(R){(0,a.onUnexpectedError)(R)}}}}e.ImplicitActivationEventsImpl=t,e.ImplicitActivationEvents=new t}),define(Se[192],ye([1,0,24,42,168,311]),function(te,e,a,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,T=/^-(\d{4})(\d{2})(\d{2})$/;function S(h){return h=h.trim(),h==="*"||D.test(h)}e.isValidVersionStr=S;function C(h){if(!S(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const w=h.match(D);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}e.parseVersion=C;function R(h){if(!h)return null;const w=h.majorBase,m=h.majorMustEqual,f=h.minorBase;let b=h.minorMustEqual;const s=h.patchBase;let o=h.patchMustEqual;h.hasCaret&&(w===0||(b=!1),o=!1);let c=0;if(h.preRelease){const u=T.exec(h.preRelease);if(u){const[,r,l,n]=u;c=Date.UTC(Number(r),Number(l)-1,Number(n))}}return{majorBase:w,majorMustEqual:m,minorBase:f,minorMustEqual:b,patchBase:s,patchMustEqual:o,isMinimum:h.hasGreaterEquals,notBefore:c}}e.normalizeVersion=R;function P(h,w,m){let f;typeof h=="string"?f=R(C(h)):f=h;let b;w instanceof Date?b=w.getTime():typeof w=="string"&&(b=new Date(w).getTime());let s;if(typeof m=="string"?s=R(C(m)):s=m,!f||!s)return!1;const o=f.majorBase,c=f.minorBase,u=f.patchBase;let r=s.majorBase,l=s.minorBase,n=s.patchBase;const i=s.notBefore;let p=s.majorMustEqual,I=s.minorMustEqual,L=s.patchMustEqual;return s.isMinimum?o>r?!0:o<r?!1:c>l?!0:c<l||b&&b<i?!1:u>=n:(o===1&&r===0&&(!p||!I||!L)&&(r=1,l=0,n=0,p=!0,I=!1,L=!1),o<r?!1:o>r?!p:c<l?!1:c>l?!I:u<n?!1:u>n?!L:!(b&&b<i))}e.isValidVersion=P;function E(h,w,m,f,b){const s=[];if(typeof f.publisher<"u"&&typeof f.publisher!="string")return s.push([t.default.Error,k.localize(0,null)]),s;if(typeof f.name!="string")return s.push([t.default.Error,k.localize(1,null,"name")]),s;if(typeof f.version!="string")return s.push([t.default.Error,k.localize(2,null,"version")]),s;if(!f.engines)return s.push([t.default.Error,k.localize(3,null,"engines")]),s;if(typeof f.engines.vscode!="string")return s.push([t.default.Error,k.localize(4,null,"engines.vscode")]),s;if(typeof f.extensionDependencies<"u"&&!g(f.extensionDependencies))return s.push([t.default.Error,k.localize(5,null,"extensionDependencies")]),s;if(typeof f.activationEvents<"u"){if(!g(f.activationEvents))return s.push([t.default.Error,k.localize(6,null,"activationEvents")]),s;if(typeof f.main>"u"&&typeof f.browser>"u")return s.push([t.default.Error,k.localize(7,null,"activationEvents","main")]),s}if(typeof f.extensionKind<"u"&&typeof f.main>"u"&&s.push([t.default.Warning,k.localize(8,null,"extensionKind")]),typeof f.main<"u"){if(typeof f.main!="string")return s.push([t.default.Error,k.localize(9,null,"main")]),s;{const u=(0,a.joinPath)(m,f.main);(0,a.isEqualOrParent)(u,m)||s.push([t.default.Warning,k.localize(10,null,u.path,m.path)])}if(typeof f.activationEvents>"u")return s.push([t.default.Error,k.localize(11,null,"activationEvents","main")]),s}if(typeof f.browser<"u"){if(typeof f.browser!="string")return s.push([t.default.Error,k.localize(12,null,"browser")]),s;{const u=(0,a.joinPath)(m,f.browser);(0,a.isEqualOrParent)(u,m)||s.push([t.default.Warning,k.localize(13,null,u.path,m.path)])}if(typeof f.activationEvents>"u")return s.push([t.default.Error,k.localize(14,null,"activationEvents","browser")]),s}if(!A.valid(f.version))return s.push([t.default.Error,k.localize(15,null)]),s;const o=[];if(!y(h,w,f,b,o))for(const u of o)s.push([t.default.Error,u]);return s}e.validateExtensionManifest=E;function y(h,w,m,f,b){return f||typeof m.main>"u"&&typeof m.browser>"u"?!0:d(h,w,m.engines.vscode,b)}e.isValidExtensionVersion=y;function v(h,w,m){return h==="*"||d(w,m,h)}e.isEngineValid=v;function d(h,w,m,f=[]){const b=R(C(m));if(!b)return f.push(k.localize(16,null,m)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return f.push(k.localize(17,null,m)),!1}else if(!b.majorMustEqual)return f.push(k.localize(18,null,m)),!1;return P(h,w,b)?!0:(f.push(k.localize(19,null,h,m)),!1)}function g(h){if(!Array.isArray(h))return!1;for(let w=0,m=h.length;w<m;w++)if(typeof h[w]!="string")return!1;return!0}}),define(Se[120],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class a{constructor(k,A=[],D=!1){this.ctor=k,this.staticArguments=A,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=a}),define(Se[86],ye([1,0,120]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var k;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function A(T,S,C){S instanceof a.SyncDescriptor||(S=new a.SyncDescriptor(S,[],Boolean(C))),t.push([T,S])}e.registerSingleton=A;function D(){return t}e.getSingletonServiceDescriptors=D}),define(Se[193],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class a{constructor(A,D){this.key=A,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.Node=a;class t{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const D of this.a.values())D.outgoing.size===0&&A.push(D);return A}insertEdge(A,D){const T=this.lookupOrInsertNode(A),S=this.lookupOrInsertNode(D);T.outgoing.set(S.key,S),S.incoming.set(T.key,T)}removeNode(A){const D=this.b(A);this.a.delete(D);for(const T of this.a.values())T.outgoing.delete(D),T.incoming.delete(D)}lookupOrInsertNode(A){const D=this.b(A);let T=this.a.get(D);return T||(T=new a(D,A),this.a.set(D,T)),T}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[D,T]of this.a)A.push(`${D}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,D]of this.a){const T=new Set([A]),S=this.c(D,T);if(S)return S}}c(A,D){for(const[T,S]of A.outgoing){if(D.has(T))return[...D,T].join(" -> ");D.add(T);const C=this.c(S,D);if(C)return C;D.delete(T)}}}e.Graph=t}),define(Se[3],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var a;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function T(S){return S[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=T})(a=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function t(D,T,S){T[a.DI_TARGET]===T?T[a.DI_DEPENDENCIES].push({id:D,index:S}):(T[a.DI_DEPENDENCIES]=[{id:D,index:S}],T[a.DI_TARGET]=T)}function k(D){if(a.serviceIds.has(D))return a.serviceIds.get(D);const T=function(S,C,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(T,S,R)};return T.toString=()=>D,a.serviceIds.set(D,T),T}e.createDecorator=k;function A(D){return D}e.refineServiceDecorator=A}),define(Se[52],ye([1,0,11,2,3]),function(te,e,a,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function A(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof t.URI)}e.isConfigurationOverrides=A;function D(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=D;var T;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=S;function C(h,w){const m=Object.create(null);for(const f in h)R(m,f,h[f],w);return m}e.toValuesTree=C;function R(h,w,m,f){const b=w.split("."),s=b.pop();let o=h;for(let c=0;c<b.length;c++){const u=b[c];let r=o[u];switch(typeof r){case"undefined":r=o[u]=Object.create(null);break;case"object":break;default:f(`Ignoring ${w} as ${b.slice(0,c+1).join(".")} is ${JSON.stringify(r)}`);return}o=r}if(typeof o=="object"&&o!==null)try{o[s]=m}catch{f(`Ignoring ${w} as ${b.join(".")} is ${JSON.stringify(o)}`)}else f(`Ignoring ${w} as ${b.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=R;function P(h,w){const m=w.split(".");E(h,m)}e.removeFromValueTree=P;function E(h,w){const m=w.shift();if(w.length===0){delete h[m];return}if(Object.keys(h).indexOf(m)!==-1){const f=h[m];typeof f=="object"&&!Array.isArray(f)&&(E(f,w),Object.keys(f).length===0&&delete h[m])}}function y(h,w,m){function f(o,c){let u=o;for(const r of c){if(typeof u!="object"||u===null)return;u=u[r]}return u}const b=w.split("."),s=f(h,b);return typeof s>"u"?m:s}e.getConfigurationValue=y;function v(h,w,m){Object.keys(w).forEach(f=>{f!=="__proto__"&&(f in h?a.isObject(h[f])&&a.isObject(w[f])?v(h[f],w[f],m):m&&(h[f]=w[f]):h[f]=w[f])})}e.merge=v;function d(h,w,m){const f=h.inspect(w),b=h.inspect(m);return typeof f.userValue<"u"||typeof f.workspaceValue<"u"||typeof f.workspaceFolderValue<"u"?f.value:typeof b.userValue<"u"||typeof b.workspaceValue<"u"||typeof b.workspaceFolderValue<"u"?b.value:f.defaultValue}e.getMigratedSettingValue=d;function g(h){return h.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=g}),define(Se[53],ye([1,0,12,8,3]),function(te,e,a,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",a.isMacintosh),A.set("isLinux",a.isLinux),A.set("isWindows",a.isWindows),A.set("isWeb",a.isWeb),A.set("isMacNative",a.isMacintosh&&!a.isWeb),A.set("isEdge",a.isEdge),A.set("isFirefox",a.isFirefox),A.set("isChrome",a.isChrome),A.set("isSafari",a.isSafari);const D=Object.prototype.hasOwnProperty;var T;(function(V){V[V.False=0]="False",V[V.True=1]="True",V[V.Defined=2]="Defined",V[V.Not=3]="Not",V[V.Equals=4]="Equals",V[V.NotEquals=5]="NotEquals",V[V.And=6]="And",V[V.Regex=7]="Regex",V[V.NotRegex=8]="NotRegex",V[V.Or=9]="Or",V[V.In=10]="In",V[V.NotIn=11]="NotIn",V[V.Greater=12]="Greater",V[V.GreaterEquals=13]="GreaterEquals",V[V.Smaller=14]="Smaller",V[V.SmallerEquals=15]="SmallerEquals"})(T=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return P.INSTANCE}static true(){return E.INSTANCE}static has(O){return y.create(O)}static equals(O,B){return v.create(O,B)}static notEquals(O,B){return h.create(O,B)}static regex(O,B){return c.create(O,B)}static in(O,B){return d.create(O,B)}static notIn(O,B){return g.create(O,B)}static not(O){return w.create(O)}static and(...O){return l.create(O,null,!0)}static or(...O){return n.create(O,null,!0)}static greater(O,B){return f.create(O,B)}static greaterEquals(O,B){return b.create(O,B)}static smaller(O,B){return s.create(O,B)}static smallerEquals(O,B){return o.create(O,B)}static deserialize(O,B=!1){if(!!O)return this.c(O,B)}static c(O,B){const F=O.split("||");return n.create(F.map($=>this.d($,B)),null,!0)}static d(O,B){const F=O.split("&&");return l.create(F.map($=>this.f($,B)),null,!0)}static f(O,B){if(O=O.trim(),O.indexOf("!=")>=0){const F=O.split("!=");return h.create(F[0].trim(),this.g(F[1],B))}if(O.indexOf("==")>=0){const F=O.split("==");return v.create(F[0].trim(),this.g(F[1],B))}if(O.indexOf("=~")>=0){const F=O.split("=~");return c.create(F[0].trim(),this.h(F[1],B))}if(O.indexOf(" not in ")>=0){const F=O.split(" not in ");return g.create(F[0].trim(),this.g(F[1],B))}if(O.indexOf(" in ")>=0){const F=O.split(" in ");return d.create(F[0].trim(),this.g(F[1],B))}if(/^[^<=>]+>=[^<=>]+$/.test(O)){const F=O.split(">=");return b.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(O)){const F=O.split(">");return f.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(O)){const F=O.split("<=");return o.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(O)){const F=O.split("<");return s.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(O)?w.create(O.substr(1).trim()):y.create(O)}static g(O,B){if(O=O.trim(),O==="true")return!0;if(O==="false")return!1;const F=/^'([^']*)'$/.exec(O);return F?F[1].trim():O}static h(O,B){if((0,t.isFalsyOrWhitespace)(O)){if(B)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const F=O.indexOf("/"),$=O.lastIndexOf("/");if(F===$||F<0){if(B)throw new Error(`bad regexp-value '${O}', missing /-enclosure`);return console.warn(`bad regexp-value '${O}', missing /-enclosure`),null}const M=O.slice(F+1,$),H=O[$+1]==="i"?"i":"";try{return new RegExp(M,H)}catch(K){if(B)throw new Error(`bad regexp-value '${O}', parse error: ${K}`);return console.warn(`bad regexp-value '${O}', parse error: ${K}`),null}}}e.ContextKeyExpr=S;function C(V,O){const B=V?V.substituteConstants():void 0,F=O?O.substituteConstants():void 0;return!B&&!F?!0:!B||!F?!1:B.equals(F)}e.expressionsAreEqualWithConstantSubstitution=C;function R(V,O){return V.cmp(O)}class P{constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return E.INSTANCE}}e.ContextKeyFalseExpr=P,P.INSTANCE=new P;class E{constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return P.INSTANCE}}e.ContextKeyTrueExpr=E,E.INSTANCE=new E;class y{static create(O,B=null){const F=A.get(O);return typeof F=="boolean"?F?E.INSTANCE:P.INSTANCE:new y(O,B)}constructor(O,B){this.key=O,this.c=B,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:p(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=A.get(this.key);return typeof O=="boolean"?O?E.INSTANCE:P.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=w.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=y;class v{static create(O,B,F=null){if(typeof B=="boolean")return B?y.create(O,F):w.create(O,F);const $=A.get(O);return typeof $=="boolean"?B===($?"true":"false")?E.INSTANCE:P.INSTANCE:new v(O,B,F)}constructor(O,B,F){this.c=O,this.d=B,this.f=F,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:I(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=A.get(this.c);if(typeof O=="boolean"){const B=O?"true":"false";return this.d===B?E.INSTANCE:P.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=v;class d{static create(O,B){return new d(O,B)}constructor(O,B){this.d=O,this.f=B,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:I(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const B=O.getValue(this.f),F=O.getValue(this.d);return Array.isArray(B)?B.includes(F):typeof F=="string"&&typeof B=="object"&&B!==null?D.call(B,F):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=g.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=d;class g{static create(O,B){return new g(O,B)}constructor(O,B){this.d=O,this.f=B,this.type=11,this.c=d.create(O,B)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=g;class h{static create(O,B,F=null){if(typeof B=="boolean")return B?w.create(O,F):y.create(O,F);const $=A.get(O);return typeof $=="boolean"?B===($?"true":"false")?P.INSTANCE:E.INSTANCE:new h(O,B,F)}constructor(O,B,F){this.c=O,this.d=B,this.f=F,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:I(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=A.get(this.c);if(typeof O=="boolean"){const B=O?"true":"false";return this.d===B?P.INSTANCE:E.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=h;class w{static create(O,B=null){const F=A.get(O);return typeof F=="boolean"?F?P.INSTANCE:E.INSTANCE:new w(O,B)}constructor(O,B){this.c=O,this.d=B,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:p(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=A.get(this.c);return typeof O=="boolean"?O?P.INSTANCE:E.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.ContextKeyNotExpr=w;function m(V,O){if(typeof V=="string"){const B=parseFloat(V);isNaN(B)||(V=B)}return typeof V=="string"||typeof V=="number"?O(V):P.INSTANCE}class f{static create(O,B,F=null){return m(B,$=>new f(O,$,F))}constructor(O,B,F){this.c=O,this.d=B,this.f=F,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:I(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=o.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=f;class b{static create(O,B,F=null){return m(B,$=>new b(O,$,F))}constructor(O,B,F){this.c=O,this.d=B,this.f=F,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:I(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=s.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=b;class s{static create(O,B,F=null){return m(B,$=>new s(O,$,F))}constructor(O,B,F){this.c=O,this.d=B,this.f=F,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:I(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=s;class o{static create(O,B,F=null){return m(B,$=>new o(O,$,F))}constructor(O,B,F){this.c=O,this.d=B,this.f=F,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:I(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=o;class c{static create(O,B){return new c(O,B)}constructor(O,B){this.d=O,this.f=B,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const B=this.f?this.f.source:"",F=O.f?O.f.source:"";return B<F?-1:B>F?1:0}equals(O){if(O.type===this.type){const B=this.f?this.f.source:"",F=O.f?O.f.source:"";return this.d===O.d&&B===F}return!1}substituteConstants(){return this}evaluate(O){const B=O.getValue(this.d);return this.f?this.f.test(B):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=u.create(this)),this.c}}e.ContextKeyRegexExpr=c;class u{static create(O){return new u(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(O){return new u(this.c.map(O))}negate(){return this.c}}e.ContextKeyNotRegexExpr=u;function r(V){let O=null;for(let B=0,F=V.length;B<F;B++){const $=V[B].substituteConstants();if(V[B]!==$&&O===null){O=[];for(let M=0;M<B;M++)O[M]=V[M]}O!==null&&(O[B]=$)}return O===null?V:O}class l{static create(O,B,F){return l.d(O,B,F)}constructor(O,B){this.expr=O,this.c=B,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let B=0,F=this.expr.length;B<F;B++){const $=R(this.expr[B],O.expr[B]);if($!==0)return $}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let B=0,F=this.expr.length;B<F;B++)if(!this.expr[B].equals(O.expr[B]))return!1;return!0}return!1}substituteConstants(){const O=r(this.expr);return O===this.expr?this:l.create(O,this.c,!1)}evaluate(O){for(let B=0,F=this.expr.length;B<F;B++)if(!this.expr[B].evaluate(O))return!1;return!0}static d(O,B,F){const $=[];let M=!1;for(const H of O)if(!!H){if(H.type===1){M=!0;continue}if(H.type===0)return P.INSTANCE;if(H.type===6){$.push(...H.expr);continue}$.push(H)}if($.length===0&&M)return E.INSTANCE;if($.length!==0){if($.length===1)return $[0];$.sort(R);for(let H=1;H<$.length;H++)$[H-1].equals($[H])&&($.splice(H,1),H--);if($.length===1)return $[0];for(;$.length>1;){const H=$[$.length-1];if(H.type!==9)break;$.pop();const K=$.pop(),q=$.length===0,Y=n.create(H.expr.map(Q=>l.create([Q,K],null,F)),null,q);Y&&($.push(Y),$.sort(R))}if($.length===1)return $[0];if(F){for(let H=0;H<$.length;H++)for(let K=H+1;K<$.length;K++)if($[H].negate().equals($[K]))return P.INSTANCE;if($.length===1)return $[0]}return new l($,B)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const B of this.expr)O.push(...B.keys());return O}map(O){return new l(this.expr.map(B=>B.map(O)),null)}negate(){if(!this.c){const O=[];for(const B of this.expr)O.push(B.negate());this.c=n.create(O,this,!0)}return this.c}}class n{static create(O,B,F){return n.d(O,B,F)}constructor(O,B){this.expr=O,this.c=B,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let B=0,F=this.expr.length;B<F;B++){const $=R(this.expr[B],O.expr[B]);if($!==0)return $}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let B=0,F=this.expr.length;B<F;B++)if(!this.expr[B].equals(O.expr[B]))return!1;return!0}return!1}substituteConstants(){const O=r(this.expr);return O===this.expr?this:n.create(O,this.c,!1)}evaluate(O){for(let B=0,F=this.expr.length;B<F;B++)if(this.expr[B].evaluate(O))return!0;return!1}static d(O,B,F){let $=[],M=!1;if(O){for(let H=0,K=O.length;H<K;H++){const q=O[H];if(!!q){if(q.type===0){M=!0;continue}if(q.type===1)return E.INSTANCE;if(q.type===9){$=$.concat(q.expr);continue}$.push(q)}}if($.length===0&&M)return P.INSTANCE;$.sort(R)}if($.length!==0){if($.length===1)return $[0];for(let H=1;H<$.length;H++)$[H-1].equals($[H])&&($.splice(H,1),H--);if($.length===1)return $[0];if(F){for(let H=0;H<$.length;H++)for(let K=H+1;K<$.length;K++)if($[H].negate().equals($[K]))return E.INSTANCE;if($.length===1)return $[0]}return new n($,B)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const B of this.expr)O.push(...B.keys());return O}map(O){return new n(this.expr.map(B=>B.map(O)),null)}negate(){if(!this.c){const O=[];for(const B of this.expr)O.push(B.negate());for(;O.length>1;){const B=O.shift(),F=O.shift(),$=[];for(const M of G(B))for(const H of G(F))$.push(l.create([M,H],null,!1));O.unshift(n.create($,null,!1))}this.c=n.create(O,this,!0)}return this.c}}class i extends y{static all(){return i.d.values()}constructor(O,B,F){super(O,null),this.f=B,typeof F=="object"?i.d.push({...F,key:O}):F!==!0&&i.d.push({key:O,description:F,type:B!=null?typeof B:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return v.create(this.key,O)}notEqualsTo(O){return h.create(this.key,O)}}e.RawContextKey=i,i.d=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(V,O){return V<O?-1:V>O?1:0}function I(V,O,B,F){return V<B?-1:V>B?1:O<F?-1:O>F?1:0}function L(V,O){if(V.type===0||O.type===1)return!0;if(V.type===9)return O.type===9?U(V.expr,O.expr):!1;if(O.type===9){for(const B of O.expr)if(L(V,B))return!0;return!1}if(V.type===6){if(O.type===6)return U(O.expr,V.expr);for(const B of V.expr)if(L(B,O))return!0;return!1}return V.equals(O)}e.implies=L;function U(V,O){let B=0,F=0;for(;B<V.length&&F<O.length;){const $=V[B].cmp(O[F]);if($<0)return!1;$===0&&B++,F++}return B===V.length}function G(V){return V.type===9?V.expr:[V]}}),define(Se[194],ye([1,0,3]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,a.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,a.refineServiceDecorator)(e.IEnvironmentService)}),define(Se[121],ye([1,0,167,3]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function A(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function D(h,w){switch(h){case 3:return w==="x64"?"win32-x64":w==="ia32"?"win32-ia32":w==="arm64"?"win32-arm64":"unknown";case 2:return w==="x64"?"linux-x64":w==="arm64"?"linux-arm64":w==="arm"?"linux-armhf":"unknown";case"alpine":return w==="x64"?"alpine-x64":w==="arm64"?"alpine-arm64":"unknown";case 1:return w==="x64"?"darwin-x64":w==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function T(h,w){return w==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=T;function S(h,w,m){return T(w,m)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===m?!0:C(m).includes(h)}e.isTargetPlatformCompatible=S;function C(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=C;function R(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=R;var P;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(P=e.SortBy||(e.SortBy={}));var E;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(E=e.SortOrder||(e.SortOrder={}));var y;(function(h){h.Install="install",h.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var v;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var d;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Internal="Internal",h.Signature="Signature"})(d=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class g extends Error{constructor(w,m){super(w),this.code=m,this.name=m}}e.ExtensionManagementError=g,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,a.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,a.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Se[195],ye([1,0,3]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,a.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,a.createDecorator)("externalTerminal")}),define(Se[196],ye([1,0,44,15,9,12,106,29,114,169,195]),function(te,e,a,t,k,A,D,T,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=C.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await d.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends E{openTerminal(f,b){return this.spawnTerminal(a,f,S.getWindowsShell(),b)}spawnTerminal(f,b,s,o){const c=b.windowsExec||y.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const u=k.basename(c).toLowerCase();if(u==="cmder"||u==="cmder.exe")return f.spawn(c,o?[o]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return c.indexOf(" ")>=0&&r.push('""'),r.push(c),(u==="wt"||u==="wt.exe")&&r.push("-d ."),new Promise((l,n)=>{const i=g(process),p=f.spawn(s,r,{cwd:o,env:i});p.on("error",n),p.on("exit",()=>l())})}runInTerminal(f,b,s,o,c){const u="windowsExec"in c&&c.windowsExec?c.windowsExec:y.getDefaultTerminalWindows();return new Promise((r,l)=>{const n=`"${b} - ${P}"`,i=`""${s.join('" "')}" & pause"`,p=["/c","start",n,"/wait",u,"/c",i],I=Object.assign({},g(process),o);Object.keys(I).filter(G=>I[G]===null).forEach(G=>delete I[G]);const L={cwd:b,env:I,windowsVerbatimArguments:!0};a.spawn(y.b,p,L).on("error",G=>{l(h(G))}),r(void 0)})}static getDefaultTerminalWindows(){if(!y.d){const f=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${f?"Sysnative":"System32"}\\cmd.exe`}return y.d}}e.WindowsExternalTerminalService=y,y.b="cmd.exe";class v extends E{openTerminal(f,b){return this.spawnTerminal(a,f,b)}runInTerminal(f,b,s,o,c){const u=c.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((r,l)=>{if(u===R.DEFAULT_TERMINAL_OSX||u==="iTerm.app"){const n=u===R.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",p=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${n}.scpt`).fsPath,"-t",f||P,"-w",b];for(const U of s)p.push("-a"),p.push(U);if(o){const U=Object.assign({},g(process),o);for(const G in U){const V=U[G];V===null?(p.push("-u"),p.push(G)):(p.push("-e"),p.push(`${G}=${V}`))}}let I="";const L=a.spawn(v.b,p);L.on("error",U=>{l(h(U))}),L.stderr.on("data",U=>{I+=U.toString()}),L.on("exit",U=>{if(U===0)r(void 0);else if(I){const G=I.split(`
`,1);l(new Error(G[0]))}else l(new Error(C.localize(1,null,n,U)))})}else l(new Error(C.localize(2,null,u)))})}spawnTerminal(f,b,s){const o=b.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((c,u)=>{const r=["-a",o];s&&r.push(s);const l=g(process),n=f.spawn("/usr/bin/open",r,{cwd:s,env:l});n.on("error",u),n.on("exit",()=>c())})}}e.MacExternalTerminalService=v,v.b="/usr/bin/osascript";class d extends E{openTerminal(f,b){return this.spawnTerminal(a,f,b)}runInTerminal(f,b,s,o,c){const u=c.linuxExec?Promise.resolve(c.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((r,l)=>{const n=[];u.then(i=>{i.indexOf("gnome-terminal")>=0?n.push("-x"):n.push("-e"),n.push("bash"),n.push("-c");const p=`${w(s)}; echo; read -p "${d.b}" -n1;`;n.push(`''${p}''`);const I=Object.assign({},g(process),o);Object.keys(I).filter(V=>I[V]===null).forEach(V=>delete I[V]);const L={cwd:b,env:I};let U="";const G=a.spawn(i,n,L);G.on("error",V=>{l(h(V))}),G.stderr.on("data",V=>{U+=V.toString()}),G.on("exit",V=>{if(V===0)r(void 0);else if(U){const O=U.split(`
`,1);l(new Error(O[0]))}else l(new Error(C.localize(4,null,i,V)))})})})}static async getDefaultTerminalLinuxReady(){if(!d.d)if(!A.isLinux)d.d=Promise.resolve("xterm");else{const f=await T.Promises.exists("/etc/debian_version");d.d=new Promise(b=>{f?b("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?b("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?b("konsole"):process.env.COLORTERM?b(process.env.COLORTERM):process.env.TERM?b(process.env.TERM):b("xterm")})}return d.d}spawnTerminal(f,b,s){const o=b.linuxExec?Promise.resolve(b.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((c,u)=>{o.then(r=>{const l=g(process),n=f.spawn(r,[],{cwd:s,env:l});n.on("error",u),n.on("exit",()=>c())})})}}e.LinuxExternalTerminalService=d,d.b=C.localize(3,null);function g(m){const f={...m.env};return(0,D.sanitizeProcessEnvironment)(f),f}function h(m){return"errno"in m&&m.errno==="ENOENT"&&"path"in m&&typeof m.path=="string"?new Error(C.localize(5,null,m.path)):m}function w(m){let f="";for(const b of m)b.indexOf(" ")>=0?f+='"'+b+'"':f+=b,f+=" ";return f}}),define(Se[38],ye([1,0,64,9,8,11,2,170,3]),function(te,e,a,t,k,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function C(M){return M.create===!0}e.isFileOpenForWriteOptions=C;var R;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var P;(function(M){M[M.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var E;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock",M[M.FileAtomicRead=16384]="FileAtomicRead",M[M.FileClone=32768]="FileClone"})(E=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=y;function v(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=v;function d(M){return!!(M.capabilities&32768)}e.hasFileCloneCapability=d;function g(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function h(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=h;function w(M){return y(M)?!!(M.capabilities&16384):!1}e.hasFileAtomicReadCapability=w;var m;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(m=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class f extends Error{constructor(H,K){super(H),this.code=K}}e.FileSystemProviderError=f;function b(M,H){const K=new f(M.toString(),H);return o(K,H),K}e.createFileSystemProviderError=b;function s(M){return M||b((0,T.localize)(0,null),m.Unknown)}e.ensureFileSystemProviderError=s;function o(M,H){return M.name=H?`${H} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=o;function c(M){if(!M)return m.Unknown;if(M instanceof f)return M.code;const H=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!H)return m.Unknown;switch(H[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileExceedsMemoryLimit:return m.FileExceedsMemoryLimit;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.toFileSystemProviderErrorCode=c;function u(M){if(M instanceof I)return M.fileOperationResult;switch(c(M)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 10;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileExceedsMemoryLimit:return 9;case m.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=u;var r;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY",M[M.WRITE=4]="WRITE"})(r=e.FileOperation||(e.FileOperation={}));class l{constructor(H,K,q){this.resource=H,this.operation=K,this.target=q}isOperation(H){return this.operation===H}}e.FileOperationEvent=l;var n;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(n=e.FileChangeType||(e.FileChangeType={}));class i{constructor(H,K){this.a=void 0,this.b=void 0,this.c=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=H;const q=new Map;for(const Y of H){const Q=q.get(Y.type);switch(Q?Q.push([Y.resource,Y]):q.set(Y.type,[[Y.resource,Y]]),Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}}for(const[Y,Q]of q)switch(Y){case 1:this.a=a.TernarySearchTree.forUris(()=>K),this.a.fill(Q);break;case 0:this.b=a.TernarySearchTree.forUris(()=>K),this.b.fill(Q);break;case 2:this.c=a.TernarySearchTree.forUris(()=>K),this.c.fill(Q);break}}contains(H,...K){return this.d(H,{includeChildren:!1},...K)}affects(H,...K){return this.d(H,{includeChildren:!0},...K)}d(H,K,...q){if(!H)return!1;const Y=q.length>0;return!!((!Y||q.includes(1))&&(this.a?.get(H)||K.includeChildren&&this.a?.findSuperstr(H))||(!Y||q.includes(0))&&(this.b?.get(H)||K.includeChildren&&this.b?.findSuperstr(H))||(!Y||q.includes(2))&&(this.c?.findSubstr(H)||K.includeChildren&&this.c?.findSuperstr(H)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=i;function p(M,H,K){return!M||!H||M===H||H.length>M.length?!1:(H.charAt(H.length-1)!==t.sep&&(H+=t.sep),K?(0,k.startsWithIgnoreCase)(M,H):M.indexOf(H)===0)}e.isParent=p;class I extends Error{constructor(H,K,q){super(H),this.fileOperationResult=K,this.options=q}}e.FileOperationError=I;class L extends I{constructor(H,K,q){super(H,2,q),this.stat=K}}e.NotModifiedSinceFileOperationError=L;var U;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(U=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var G;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(G=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function V(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=V;async function O(M,H){if(!H.hasProvider(D.URI.from({scheme:M.scheme})))return new Promise(K=>{const q=H.onDidChangeFileSystemProviderRegistrations(Y=>{Y.scheme===M.scheme&&Y.added&&(q.dispose(),K())})})}e.whenProviderRegistered=O,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class B{static formatSize(H){return(0,A.isNumber)(H)||(H=0),H<B.KB?(0,T.localize)(1,null,H.toFixed(0)):H<B.MB?(0,T.localize)(2,null,(H/B.KB).toFixed(2)):H<B.GB?(0,T.localize)(3,null,(H/B.MB).toFixed(2)):H<B.TB?(0,T.localize)(4,null,(H/B.GB).toFixed(2)):(0,T.localize)(5,null,(H/B.TB).toFixed(2))}}e.ByteSize=B,B.KB=1024,B.MB=B.KB*B.KB,B.GB=B.MB*B.KB,B.TB=B.GB*B.KB;var F;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function $(M){return{maxFileSize:M===0?300*B.MB:16*B.GB,maxHeapSize:M===0?700*B.MB:2*700*B.MB}}e.getPlatformLimits=$}),define(Se[87],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class a{constructor(...k){this.a=new Map;for(const[A,D]of k)this.set(A,D)}set(k,A){const D=this.a.get(k);return this.a.set(k,A),D}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.ServiceCollection=a}),define(Se[197],ye([1,0,18,10,6,120,193,3,87,63]),function(te,e,a,t,k,A,D,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const R=!1;class P extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class E{constructor(g=new S.ServiceCollection,h=!1,w,m=R){this.f=g,this.g=h,this.h=w,this.i=m,this.o=new Set,this.f.set(T.IInstantiationService,this),this._globalGraph=m?w?._globalGraph??new D.Graph(f=>f):void 0}createChild(g){return new E(g,this.g,this,this.i)}invokeFunction(g,...h){const w=v.traceInvocation(this.i,g);let m=!1;try{return g({get:b=>{if(m)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const s=this.m(b,w);if(!s)throw new Error(`[invokeFunction] unknown service '${b}'`);return s}},...h)}finally{m=!0,w.stop()}}createInstance(g,...h){let w,m;return g instanceof A.SyncDescriptor?(w=v.traceCreation(this.i,g.ctor),m=this.j(g.ctor,g.staticArguments.concat(h),w)):(w=v.traceCreation(this.i,g),m=this.j(g,h,w)),w.stop(),m}j(g,h=[],w){const m=T._util.getServiceDependencies(g).sort((s,o)=>s.index-o.index),f=[];for(const s of m){const o=this.m(s.id,w);o||this.u(`[createInstance] ${g.name} depends on UNKNOWN service ${s.id}.`,!1),f.push(o)}const b=m.length>0?m[0].index:h.length;if(h.length!==b){console.trace(`[createInstance] First service dependency of ${g.name} at position ${b+1} conflicts with ${h.length} static arguments`);const s=b-h.length;s>0?h=h.concat(new Array(s)):h=h.slice(0,b)}return Reflect.construct(g,h.concat(f))}k(g,h){if(this.f.get(g)instanceof A.SyncDescriptor)this.f.set(g,h);else if(this.h)this.h.k(g,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(g){const h=this.f.get(g);return!h&&this.h?this.h.l(g):h}m(g,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const w=this.l(g);return w instanceof A.SyncDescriptor?this.q(g,w,h.branch(g,!0)):(h.branch(g,!1),w)}q(g,h,w){if(this.o.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.o.add(g);try{return this.r(g,h,w)}finally{this.o.delete(g)}}r(g,h,w){const m=new D.Graph(s=>s.id.toString());let f=0;const b=[{id:g,desc:h,_trace:w}];for(;b.length;){const s=b.pop();if(m.lookupOrInsertNode(s),f++>1e3)throw new P(m);for(const o of T._util.getServiceDependencies(s.desc.ctor)){const c=this.l(o.id);if(c||this.u(`[createInstance] ${g} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(o.id)),c instanceof A.SyncDescriptor){const u={id:o.id,desc:c,_trace:s._trace.branch(o.id,!0)};m.insertEdge(s,u),b.push(u)}}}for(;;){const s=m.roots();if(s.length===0){if(!m.isEmpty())throw new P(m);break}for(const{data:o}of s){if(this.l(o.id)instanceof A.SyncDescriptor){const u=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,u)}m.removeNode(o)}}return this.l(g)}s(g,h,w=[],m,f){if(this.f.get(g)instanceof A.SyncDescriptor)return this.t(g,h,w,m,f);if(this.h)return this.h.s(g,h,w,m,f);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(g,h,w=[],m,f){if(m){const b=new E(void 0,this.g,this,this.i);b.c=String(g);const s=new Map,o=new a.IdleValue(()=>{const c=b.j(h,w,f);for(const[u,r]of s){const l=c[u];if(typeof l=="function")for(const n of r)l.apply(c,n)}return s.clear(),c});return new Proxy(Object.create(null),{get(c,u){if(!o.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let n=s.get(u);return n||(n=new C.LinkedList,s.set(u,n)),(p,I,L)=>{const U=n.push([p,I,L]);return(0,k.toDisposable)(U)}}if(u in c)return c[u];const r=o.value;let l=r[u];return typeof l!="function"||(l=l.bind(r),c[u]=l),l},set(c,u,r){return o.value[u]=r,!0}})}else return this.j(h,w,f)}u(g,h){if(h&&console.warn(g),this.g)throw new Error(g)}}e.InstantiationService=E;var y;(function(d){d[d.Creation=0]="Creation",d[d.Invocation=1]="Invocation",d[d.Branch=2]="Branch"})(y||(y={}));class v{static traceInvocation(g,h){return g?new v(1,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(g,h){return g?new v(0,h.name):v.c}constructor(g,h){this.type=g,this.name=h,this.g=Date.now(),this.h=[]}branch(g,h){const w=new v(2,g.toString());return this.h.push([g,h,w]),w}stop(){const g=Date.now()-this.g;v.f+=g;let h=!1;function w(f,b){const s=[],o=new Array(f+1).join("	");for(const[c,u,r]of b.h)if(u&&r){h=!0,s.push(`${o}CREATES -> ${c}`);const l=w(f+1,r);l&&s.push(l)}else s.push(`${o}uses -> ${c}`);return s.join(`
`)}const m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(g>2||h)&&v.all.add(m.join(`
`))}}e.Trace=v,v.all=new Set,v.c=new class extends v{constructor(){super(-1,null)}stop(){}branch(){return this}},v.f=0}),define(Se[13],ye([1,0,50,4,6,28,12,2,3]),function(te,e,a,t,k,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function C(){return new Date().toISOString()}var R;(function(l){l[l.Off=0]="Off",l[l.Trace=1]="Trace",l[l.Debug=2]="Debug",l[l.Info=3]="Info",l[l.Warning=4]="Warning",l[l.Error=5]="Error"})(R=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=R.Info;function P(l,n,i){switch(n){case R.Trace:l.trace(i);break;case R.Debug:l.debug(i);break;case R.Info:l.info(i);break;case R.Warning:l.warn(i);break;case R.Error:l.error(i);break;default:throw new Error("Invalid log level")}}e.log=P;function E(l){let n="";for(let i=0;i<l.length;i++){let p=l[i];if(typeof p=="object")try{p=JSON.stringify(p)}catch{}n+=(i>0?" ":"")+p}return n}e.format=E;class y extends k.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new t.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(n){this.b!==n&&(this.b=n,this.c.fire(this.b))}getLevel(){return this.b}}e.AbstractLogger=y;class v extends y{constructor(n){super(),this.g=n}h(n){return this.g||this.getLevel()<=n}trace(n,...i){this.h(R.Trace)&&this.f(R.Trace,E([n,...i]))}debug(n,...i){this.h(R.Debug)&&this.f(R.Debug,E([n,...i]))}info(n,...i){this.h(R.Info)&&this.f(R.Info,E([n,...i]))}warn(n,...i){this.h(R.Warning)&&this.f(R.Warning,E([n,...i]))}error(n,...i){if(this.h(R.Error))if(n instanceof Error){const p=Array.prototype.slice.call(arguments);p[0]=n.stack,this.f(R.Error,E(p))}else this.f(R.Error,E([n,...i]))}flush(){}}e.AbstractMessageLogger=v;class d extends y{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n),this.f=!D.isWindows}trace(n,...i){this.getLevel()<=R.Trace&&(this.f?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,n,...i):console.log(`[main ${C()}]`,n,...i))}debug(n,...i){this.getLevel()<=R.Debug&&(this.f?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,n,...i):console.log(`[main ${C()}]`,n,...i))}info(n,...i){this.getLevel()<=R.Info&&(this.f?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,n,...i):console.log(`[main ${C()}]`,n,...i))}warn(n,...i){this.getLevel()<=R.Warning&&(this.f?console.warn(`\x1B[93m[main ${C()}]\x1B[0m`,n,...i):console.warn(`[main ${C()}]`,n,...i))}error(n,...i){this.getLevel()<=R.Error&&(this.f?console.error(`\x1B[91m[main ${C()}]\x1B[0m`,n,...i):console.error(`[main ${C()}]`,n,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=d;class g extends y{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n)}trace(n,...i){this.getLevel()<=R.Trace&&console.log("%cTRACE","color: #888",n,...i)}debug(n,...i){this.getLevel()<=R.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...i)}info(n,...i){this.getLevel()<=R.Info&&console.log("%c INFO","color: #33f",n,...i)}warn(n,...i){this.getLevel()<=R.Warning&&console.log("%c WARN","color: #993",n,...i)}error(n,...i){this.getLevel()<=R.Error&&console.log("%c  ERR","color: #f33",n,...i)}dispose(){}flush(){}}e.ConsoleLogger=g;class h extends y{constructor(n,i=e.DEFAULT_LOG_LEVEL){super(),this.f=n,this.setLevel(i)}trace(n,...i){this.getLevel()<=R.Trace&&this.f.log(R.Trace,[this.g(n),...i])}debug(n,...i){this.getLevel()<=R.Debug&&this.f.log(R.Debug,[this.g(n),...i])}info(n,...i){this.getLevel()<=R.Info&&this.f.log(R.Info,[this.g(n),...i])}warn(n,...i){this.getLevel()<=R.Warning&&this.f.log(R.Warning,[this.g(n),...i])}error(n,...i){this.getLevel()<=R.Error&&this.f.log(R.Error,[this.g(n),...i])}g(n){return typeof n=="string"?n:(0,a.toErrorMessage)(n,this.getLevel()<=R.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class w extends y{constructor(n){super(),this.f=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const i of this.f)i.setLevel(n);super.setLevel(n)}trace(n,...i){for(const p of this.f)p.trace(n,...i)}debug(n,...i){for(const p of this.f)p.debug(n,...i)}info(n,...i){for(const p of this.f)p.info(n,...i)}warn(n,...i){for(const p of this.f)p.warn(n,...i)}error(n,...i){for(const p of this.f)p.error(n,...i)}flush(){for(const n of this.f)n.flush()}dispose(){for(const n of this.f)n.dispose()}}e.MultiplexLogService=w;class m extends k.Disposable{constructor(n){super(),this.b=n,this.B(n)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(n){this.b.setLevel(n)}getLevel(){return this.b.getLevel()}trace(n,...i){this.b.trace(n,...i)}debug(n,...i){this.b.debug(n,...i)}info(n,...i){this.b.info(n,...i)}warn(n,...i){this.b.warn(n,...i)}error(n,...i){this.b.error(n,...i)}flush(){this.b.flush()}}e.LogService=m;class f extends k.Disposable{constructor(n,i){super(),this.c=n,this.b=new A.ResourceMap,this.B(i(p=>this.setLevel(p)))}getLoggers(){return[...this.b.values()].map(({logger:n})=>n)}getLogger(n){return this.b.get(n)?.logger}createLogger(n,i,p){let I=this.b.get(n)?.logger;return I||(p=i?.always?R.Trace:p,I=this.f(n,p??this.c,i),this.b.set(n,{logger:I,logLevel:p})),I}setLevel(n,i){const p=T.URI.isUri(n)?n:void 0,I=p?i:n;if(p){const L=this.b.get(p);L&&L.logLevel!==I&&(L.logLevel=I,L.logger.setLevel(I))}else this.c=I,this.b.forEach(({logLevel:L,logger:U})=>{L===void 0&&U.setLevel(this.c)})}getLogLevel(n){return this.b.get(n)?.logLevel}dispose(){this.b.forEach(({logger:n})=>n.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=f;class b{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(n){}getLevel(){return R.Info}trace(n,...i){}debug(n,...i){}info(n,...i){}warn(n,...i){}error(n,...i){}critical(n,...i){}dispose(){}flush(){}}e.NullLogger=b;class s extends b{}e.NullLogService=s;class o extends f{constructor(){super(R.Info,t.Event.None)}f(n,i,p){return new b}}e.NullLoggerService=o;function c(l){if(l.verbose)return R.Trace;if(typeof l.logLevel=="string"){const n=r(l.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function u(l){switch(l){case R.Trace:return"trace";case R.Debug:return"debug";case R.Info:return"info";case R.Warning:return"warn";case R.Error:return"error";case R.Off:return"off"}}e.LogLevelToString=u;function r(l){switch(l){case"trace":return R.Trace;case"debug":return R.Debug;case"info":return R.Info;case"warn":return R.Warning;case"error":return R.Error;case"critical":return R.Error;case"off":return R.Off}}e.parseLogLevel=r}),define(Se[198],ye([1,0,38,13]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var k;(function(C){C[C.Trace=0]="Trace",C[C.Debug=1]="Debug",C[C.Info=2]="Info",C[C.Warning=3]="Warning",C[C.Error=4]="Error",C[C.Critical=5]="Critical",C[C.Off=6]="Off"})(k||(k={}));async function A(C,R,P,E,y){try{const v=await new Promise((g,h)=>{te(["spdlog"],g,h)});v.setFlushOn(t.LogLevel.Trace);const d=await v.createAsyncRotatingLogger(C,R,P,E);return y?d.clearFormatters():d.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),d}catch(v){console.error(v)}return null}function D(C,R,P){switch(R){case t.LogLevel.Trace:C.trace(P);break;case t.LogLevel.Debug:C.debug(P);break;case t.LogLevel.Info:C.info(P);break;case t.LogLevel.Warning:C.warn(P);break;case t.LogLevel.Error:C.error(P);break;default:throw new Error("Invalid log level")}}function T(C,R){switch(R){case t.LogLevel.Trace:C.setLevel(k.Trace);break;case t.LogLevel.Debug:C.setLevel(k.Debug);break;case t.LogLevel.Info:C.setLevel(k.Info);break;case t.LogLevel.Warning:C.setLevel(k.Warning);break;case t.LogLevel.Error:C.setLevel(k.Error);break;case t.LogLevel.Off:C.setLevel(k.Off);break;default:throw new Error("Invalid log level")}}class S extends t.AbstractMessageLogger{constructor(R,P,E,y,v){super(),this.j=[],this.setLevel(v),this.k=this.m(R,P,E,y),this.B(this.onDidChangeLogLevel(d=>{this.l&&T(this.l,d)}))}async m(R,P,E,y){const v=E?6:1,d=30/v*a.ByteSize.MB,g=await A(R,P,d,v,y);if(g){this.l=g,T(this.l,this.getLevel());for(const{level:h,message:w}of this.j)D(this.l,h,w);this.j=[]}}f(R,P){this.l?D(this.l,R,P):this.getLevel()<=R&&this.j.push({level:R,message:P})}flush(){this.l?this.l.flush():this.k.then(()=>this.flush())}dispose(){this.l?this.p():this.k.then(()=>this.p())}p(){this.l&&(this.l.drop(),this.l=void 0)}}e.SpdLogLogger=S}),define(Se[122],ye([1,0,42,171,3]),function(te,e,a,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var D;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(D=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function C(v,d){return d-v}S.compare=C;const R=Object.create(null);R[S.Error]=(0,t.localize)(0,null),R[S.Warning]=(0,t.localize)(1,null),R[S.Info]=(0,t.localize)(2,null);function P(v){return R[v]||""}S.toString=P;function E(v){switch(v){case a.default.Error:return S.Error;case a.default.Warning:return S.Warning;case a.default.Info:return S.Info;case a.default.Ignore:return S.Hint}}S.fromSeverity=E;function y(v){switch(v){case S.Error:return a.default.Error;case S.Warning:return a.default.Warning;case S.Info:return a.default.Info;case S.Hint:return a.default.Ignore}}S.toSeverity=y}(D=e.MarkerSeverity||(e.MarkerSeverity={}));var T;(function(S){const C="";function R(E){return P(E,!0)}S.makeKey=R;function P(E,y){const v=[C];return E.source?v.push(E.source.replace("\xA6","\\\xA6")):v.push(C),E.code?typeof E.code=="string"?v.push(E.code.replace("\xA6","\\\xA6")):v.push(E.code.value.replace("\xA6","\\\xA6")):v.push(C),E.severity!==void 0&&E.severity!==null?v.push(D.toString(E.severity)):v.push(C),E.message&&y?v.push(E.message.replace("\xA6","\\\xA6")):v.push(C),E.startLineNumber!==void 0&&E.startLineNumber!==null?v.push(E.startLineNumber.toString()):v.push(C),E.startColumn!==void 0&&E.startColumn!==null?v.push(E.startColumn.toString()):v.push(C),E.endLineNumber!==void 0&&E.endLineNumber!==null?v.push(E.endLineNumber.toString()):v.push(C),E.endColumn!==void 0&&E.endColumn!==null?v.push(E.endColumn.toString()):v.push(C),v.push(C),v.join("\xA6")}S.makeKeyOptionalMessage=P})(T=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,k.createDecorator)("markerService")}),define(Se[199],ye([1,0,4,42,3]),function(te,e,a,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,k.createDecorator)("notificationService");var A;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.PROFILE=1]="PROFILE",C[C.APPLICATION=2]="APPLICATION"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var D;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})(D=e.NotificationsFilter||(e.NotificationsFilter={}));class T{constructor(){this.progress=new S,this.onDidClose=a.Event.None,this.onDidChangeVisibility=a.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=T;class S{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=S}),define(Se[123],ye([1,0,8,2,3]),function(te,e,a,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,k.createDecorator)("openerService");function A(C,R){return t.URI.isUri(C)?(0,a.equalsIgnoreCase)(C.scheme,R):(0,a.startsWithIgnoreCase)(C,R+":")}e.matchesScheme=A;function D(C,...R){return R.some(P=>A(C,P))}e.matchesSomeScheme=D;function T(C,R){return C.with({fragment:`${R.startLineNumber},${R.startColumn}${R.endLineNumber?`-${R.endLineNumber}${R.endColumn?`,${R.endColumn}`:""}`:""}`})}e.withSelection=T;function S(C){let R;const P=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(C.fragment);return P&&(R={startLineNumber:parseInt(P[1]),startColumn:P[2]?parseInt(P[2]):1,endLineNumber:P[4]?parseInt(P[4]):void 0,endColumn:P[4]?P[5]?parseInt(P[5]):1:void 0},C=C.with({fragment:""})),{selection:R,uri:C}}e.extractSelection=S}),define(Se[200],ye([1,0,12,36]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof a.globals.vscode<"u"&&typeof a.globals.vscode.context<"u"){const A=a.globals.vscode.context.configuration();if(A)k=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(k=globalThis._VSCODE_PRODUCT_JSON,t.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`,serverDataFolderName:k.serverDataFolderName?`${k.serverDataFolderName}-dev`:void 0}),!k.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(k,{version:A.version})}}else k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=k}),define(Se[201],ye([1,0,3]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,a.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var We=this&&this.__param||function(te,e){return function(a,t){e(a,t,te)}};define(Se[124],ye([1,0,18,21,6,3]),function(te,e,a,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var D;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(D=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class T{get value(){return this.a}constructor(P){this.b=P}report(P){this.a=P,this.b(this.a)}}e.Progress=T,T.None=Object.freeze({report(){}});let S=class extends k.Disposable{constructor(P,E){super(),this.a=new a.DeferredPromise,E.withProgress(P,y=>(this.b=y,this.c&&y.report(this.c),this.a.p)),this.B((0,k.toDisposable)(()=>this.a.complete()))}report(P){this.b?this.b.report(P):this.c=P}};S=Ve([We(1,e.IProgressService)],S),e.UnmanagedProgress=S;class C extends k.Disposable{constructor(P){super(),this.g=P,this.a=0,this.b=this.B(new k.DisposableStore)}start(P){this.stop();const E=++this.a,y=new t.CancellationTokenSource;return this.f=setTimeout(()=>{E===this.a&&(this.c=this.g.show(!0))},P),this.b.add((0,k.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,k.toDisposable)(()=>y.cancel())),this.b.add((0,k.toDisposable)(()=>this.c?this.c.done():void 0)),{id:E,token:y.token,stop:()=>this.h(E),isCurrent:()=>this.a===E}}stop(){this.h(this.a)}h(P){this.a===P&&this.b.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(Se[43],ye([1,0,48,11]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.a=new Map}add(D,T){a.ok(t.isString(D)),a.ok(t.isObject(T)),a.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,T)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.Registry=new k}),define(Se[125],ye([1,0,4,43]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class A{constructor(){this.b=new a.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,C){this.a[k(S)]=C,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const D=new A;t.Registry.add(e.Extensions.JSONContribution,D)}),define(Se[126],ye([1,0,17,4,11,166,52,125,43]),function(te,e,a,t,k,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=S.Registry.as(T.Extensions.JSONContribution);class E{constructor(){this.h=new Set,this.i=new t.Emitter,this.onDidSchemaChange=this.i.event,this.j=new t.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(s,o=!0){this.registerConfigurations([s],o)}registerConfigurations(s,o=!0){const c=this.k(s,o);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:c})}deregisterConfigurations(s){const o=this.l(s);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:s,remove:o}){const c=[];c.push(...this.l(o)),c.push(...this.k(s,!1)),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,a.distinct)(c)})}registerDefaultConfigurations(s){const o=[],c=[];for(const{overrides:u,source:r}of s)for(const l in u)if(o.push(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const n=this.a.get(l),i=n?.valuesSources??new Map;if(r)for(const U of Object.keys(u[l]))i.set(U,r);const p={...n?.value||{},...u[l]};this.a.set(l,{source:r,value:p,valuesSources:i});const I=(0,D.getLanguageTagSettingPlainKey)(l),L={type:"object",default:p,description:A.localize(1,null,I),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:p,source:k.isString(r)?void 0:r,defaultValueSource:r};c.push(...d(l)),this.d[l]=L,this.b.properties[l]=L}else{this.a.set(l,{value:u[l],source:r});const n=this.d[l];n&&(this.s(l,n),this.o(l,n))}this.registerOverrideIdentifiers(c),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(s){const o=[];for(const{overrides:c,source:u}of s)for(const r in c){const l=this.a.get(r),n=k.isString(u)?u:u?.id,i=k.isString(l?.source)?l?.source:l?.source?.id;if(n===i)if(o.push(r),this.a.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.d[r],delete this.b.properties[r];else{const p=this.d[r];p&&(this.s(r,p),this.o(r,p))}}this.q(),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){for(const o of s)this.h.add(o);this.q()}k(s,o){const c=[];return s.forEach(u=>{c.push(...this.m(u,o,u.extensionInfo,u.restrictedProperties)),this.c.push(u),this.n(u)}),c}l(s){const o=[],c=u=>{if(u.properties)for(const r in u.properties){o.push(r);const l=this.d[r];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[r],this.p(r,u.properties[r])}u.allOf?.forEach(r=>c(r))};for(const u of s){c(u);const r=this.c.indexOf(u);r!==-1&&this.c.splice(r,1)}return o}m(s,o=!0,c,u,r=3){r=k.isUndefinedOrNull(s.scope)?r:s.scope;const l=[],n=s.properties;if(n)for(const p in n){const I=n[p];if(o&&m(p,I)){delete n[p];continue}if(I.source=c,I.defaultDefaultValue=n[p].default,this.s(p,I),e.OVERRIDE_PROPERTY_REGEX.test(p)?I.scope=void 0:(I.scope=k.isUndefinedOrNull(I.scope)?r:I.scope,I.restricted=k.isUndefinedOrNull(I.restricted)?!!u?.includes(p):I.restricted),n[p].hasOwnProperty("included")&&!n[p].included){this.f[p]=n[p],delete n[p];continue}else this.d[p]=n[p],n[p].policy?.name&&this.e.set(n[p].policy.name,p);!n[p].deprecationMessage&&n[p].markdownDeprecationMessage&&(n[p].deprecationMessage=n[p].markdownDeprecationMessage),l.push(p)}const i=s.allOf;if(i)for(const p of i)l.push(...this.m(p,o,c,u,r));return l}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(s){const o=c=>{const u=c.properties;if(u)for(const l in u)this.o(l,u[l]);c.allOf?.forEach(o)};o(s)}o(s,o){switch(e.allSettings.properties[s]=o,o.scope){case 1:e.applicationSettings.properties[s]=o;break;case 2:e.machineSettings.properties[s]=o;break;case 6:e.machineOverridableSettings.properties[s]=o;break;case 3:e.windowSettings.properties[s]=o;break;case 4:e.resourceSettings.properties[s]=o;break;case 5:e.resourceSettings.properties[s]=o,this.g.properties[s]=o;break}}p(s,o){switch(delete e.allSettings.properties[s],o.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s],delete this.g.properties[s];break}}q(){for(const s of this.h.values()){const o=`[${s}]`,c={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(o,c),e.allSettings.properties[o]=c,e.applicationSettings.properties[o]=c,e.machineSettings.properties[o]=c,e.machineOverridableSettings.properties[o]=c,e.windowSettings.properties[o]=c,e.resourceSettings.properties[o]=c}this.i.fire()}r(){const s={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,this.i.fire()}s(s,o){const c=this.a.get(s);let u=c?.value,r=c?.source;k.isUndefined(u)&&(u=o.defaultDefaultValue,r=void 0),k.isUndefined(u)&&(u=h(o.type)),o.default=u,o.defaultValueSource=r}}const y="\\[([^\\]]+)\\]",v=new RegExp(y,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${y})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function d(b){const s=[];if(e.OVERRIDE_PROPERTY_REGEX.test(b)){let o=v.exec(b);for(;o?.length;){const c=o[1].trim();c&&s.push(c),o=v.exec(b)}}return(0,a.distinct)(s)}e.overrideIdentifiersFromKey=d;function g(b){return b.reduce((s,o)=>`${s}[${o}]`,"")}e.keyFromOverrideIdentifiers=g;function h(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const w=new E;S.Registry.add(e.Extensions.Configuration,w);function m(b,s){return b.trim()?e.OVERRIDE_PROPERTY_REGEX.test(b)?A.localize(7,null,b):w.getConfigurationProperties()[b]!==void 0?A.localize(8,null,b):s.policy?.name&&w.getPolicyConfigurations().get(s.policy?.name)!==void 0?A.localize(9,null,b,s.policy?.name,w.getPolicyConfigurations().get(s.policy?.name)):null:A.localize(6,null)}e.validateProperty=m;function f(){const b=[],s=w.getConfigurationProperties();for(const o of Object.keys(s))b.push([o,s[o].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=f}),define(Se[202],ye([1,0,17,4,145,6,28,23,11,2,52,126,43]),function(te,e,a,t,k,A,D,T,S,C,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class y{constructor(o={},c=[],u=[],r){this.c=o,this.d=c,this.f=u,this.raw=r,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const o=this.raw.map(c=>{if(c instanceof y)return c;const u=new v("");return u.parseRaw(c),u.configurationModel});this.g=o.reduce((c,u)=>u===c?u:c.merge(u),o[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(o){return o?(0,R.getConfigurationValue)(this.contents,o):this.contents}inspect(o,c){const u=this.rawConfiguration.getValue(o),r=c?this.rawConfiguration.getOverrideValue(o,c):void 0,l=c?this.rawConfiguration.override(c).getValue(o):u;return{value:u,override:r,merged:l}}getOverrideValue(o,c){const u=this.l(c);return u?o?(0,R.getConfigurationValue)(u,o):u:void 0}getKeysForOverrideIdentifier(o){const c=[];for(const u of this.overrides)u.identifiers.includes(o)&&c.push(...u.keys);return a.distinct(c)}getAllOverrideIdentifiers(){const o=[];for(const c of this.overrides)o.push(...c.identifiers);return a.distinct(o)}override(o){let c=this.b.get(o);return c||(c=this.h(o),this.b.set(o,c)),c}merge(...o){const c=T.deepClone(this.contents),u=T.deepClone(this.overrides),r=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const n of o)if(l.push(...n.raw?.length?n.raw:[n]),!n.isEmpty()){this.j(c,n.contents);for(const i of n.overrides){const[p]=u.filter(I=>a.equals(I.identifiers,i.identifiers));p?(this.j(p.contents,i.contents),p.keys.push(...i.keys),p.keys=a.distinct(p.keys)):u.push(T.deepClone(i))}for(const i of n.keys)r.indexOf(i)===-1&&r.push(i)}return new y(c,r,u,l.every(n=>n instanceof y)?void 0:l)}freeze(){return this.a=!0,this}clone(){return new y(T.deepClone(this.contents),[...this.keys],T.deepClone(this.overrides))}h(o){const c=this.l(o);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const u={};for(const r of a.distinct([...Object.keys(this.contents),...Object.keys(c)])){let l=this.contents[r];const n=c[r];n&&(typeof l=="object"&&typeof n=="object"?(l=T.deepClone(l),this.j(l,n)):l=n),u[r]=l}return new y(u,this.keys,this.overrides)}j(o,c){for(const u of Object.keys(c)){if(u in o&&S.isObject(o[u])&&S.isObject(c[u])){this.j(o[u],c[u]);continue}o[u]=T.deepClone(c[u])}}k(o){return this.a&&!Object.isFrozen(o)?T.deepFreeze(o):o}l(o){let c=null,u=null;const r=l=>{l&&(u?this.j(u,l):u=T.deepClone(l))};for(const l of this.overrides)a.equals(l.identifiers,[o])?c=l.contents:l.identifiers.includes(o)&&r(l.contents);return r(c),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(o,c){this.m(o),(0,R.addToValueTree)(this.contents,o,c,u=>{throw new Error(u)})}removeValue(o){this.n(o)&&(0,R.removeFromValueTree)(this.contents,o)}m(o){let c=this.keys.length;for(let u=0;u<c;u++)o.indexOf(this.keys[u])===0&&(c=u);this.keys.splice(c,1,o)}n(o){const c=this.keys.indexOf(o);return c!==-1?(this.keys.splice(c,1),!0):!1}}e.ConfigurationModel=y;class v{constructor(o){this.f=o,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(o,c){if(!S.isUndefinedOrNull(o)){const u=this.g(o);this.parseRaw(u,c)}}reparse(o){this.a&&this.parseRaw(this.a,o)}parseRaw(o,c){this.a=o;const{contents:u,keys:r,overrides:l,restricted:n,hasExcludedProperties:i}=this.h(o,c);this.b=new y(u,r,l,i?[o]:void 0),this.c=n||[]}g(o){let c={},u=null,r=[];const l=[],n=[];function i(I){Array.isArray(r)?r.push(I):u!==null&&(r[u]=I)}const p={onObjectBegin:()=>{const I={};i(I),l.push(r),r=I,u=null},onObjectProperty:I=>{u=I},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{const I=[];i(I),l.push(r),r=I,u=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:i,onError:(I,L,U)=>{n.push({error:I,offset:L,length:U})}};if(o)try{k.visit(o,p),c=r[0]||{}}catch(I){console.error(`Error while parsing settings file ${this.f}: ${I}`),this.d=[I]}return c}h(o,c){const u=E.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),r=this.j(o,u,!0,c);o=r.raw;const l=(0,R.toValuesTree)(o,p=>console.error(`Conflict in settings file ${this.f}: ${p}`)),n=Object.keys(o),i=this.l(o,p=>console.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:l,keys:n,overrides:i,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}j(o,c,u,r){let l=!1;if(!r?.scopes&&!r?.skipRestricted)return{raw:o,restricted:[],hasExcludedProperties:l};const n={},i=[];for(const p in o)if(P.OVERRIDE_PROPERTY_REGEX.test(p)&&u){const I=this.j(o[p],c,!1,r);n[p]=I.raw,l=l||I.hasExcludedProperties,i.push(...I.restricted)}else{const I=c[p],L=I?typeof I.scope<"u"?I.scope:3:void 0;I?.restricted&&i.push(p),(L===void 0||r.scopes===void 0||r.scopes.includes(L))&&!(r.skipRestricted&&I?.restricted)?n[p]=o[p]:l=!0}return{raw:n,restricted:i,hasExcludedProperties:l}}l(o,c){const u=[];for(const r of Object.keys(o))if(P.OVERRIDE_PROPERTY_REGEX.test(r)){const l={};for(const n in o[r])l[n]=o[r][n];u.push({identifiers:(0,P.overrideIdentifiersFromKey)(r),keys:Object.keys(l),contents:(0,R.toValuesTree)(l,c)})}return u}}e.ConfigurationModelParser=v;class d extends A.Disposable{constructor(o,c,u,r){super(),this.f=o,this.g=c,this.h=r,this.c=this.B(new t.Emitter),this.onDidChange=this.c.event,this.a=new v(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(u.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(t.Event.any(t.Event.filter(this.h.onDidFilesChange,l=>l.contains(this.f)),t.Event.filter(this.h.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&u.isEqual(l.resource,o)))(()=>this.c.fire()))}async loadConfiguration(){try{const o=await this.h.readFile(this.f);return this.a.parse(o.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new y}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=d;class g{constructor(o,c,u,r,l,n,i,p,I,L,U,G,V){this.a=o,this.b=c,this.value=u,this.overrideIdentifiers=r,this.c=l,this.d=n,this.f=i,this.g=p,this.h=I,this.j=L,this.k=U,this.l=G,this.m=V}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get A(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class h{constructor(o,c,u,r,l=new y,n=new y,i=new D.ResourceMap,p=new y,I=new D.ResourceMap,L=!0){this.c=o,this.d=c,this.f=u,this.g=r,this.h=l,this.j=n,this.l=i,this.m=p,this.n=I,this.p=L,this.a=null,this.b=new D.ResourceMap,this.q=null}getValue(o,c,u){return this.s(o,c,u).getValue(o)}updateValue(o,c,u={}){let r;u.resource?(r=this.n.get(u.resource),r||(r=new y,this.n.set(u.resource,r))):r=this.m,c===void 0?r.removeValue(o):r.setValue(o,c),u.resource||(this.a=null)}inspect(o,c,u){const r=this.s(o,c,u),l=a.distinct(r.overrides.map(p=>p.identifiers).flat()).filter(p=>r.getOverrideValue(o,p)!==void 0),n=this.w(c.resource,u),i=c.resource?this.n.get(c.resource)||this.m:this.m;return new g(o,c,r.getValue(o),l.length?l:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),u?this.j.freeze():void 0,n?n.freeze():void 0,i.inspect(o,c.overrideIdentifier))}keys(o){const c=this.w(void 0,o);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:c?c.freeze().keys:[]}}updateDefaultConfiguration(o){this.c=o,this.a=null,this.b.clear()}updatePolicyConfiguration(o){this.d=o}updateApplicationConfiguration(o){this.f=o,this.a=null,this.b.clear()}updateLocalUserConfiguration(o){this.g=o,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(o){this.h=o,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(o){this.j=o,this.a=null,this.b.clear()}updateFolderConfiguration(o,c){this.l.set(o,c),this.b.delete(o)}deleteFolderConfiguration(o){this.r.delete(o),this.b.delete(o)}compareAndUpdateDefaultConfiguration(o,c){const u=[];if(!c){const{added:r,updated:l,removed:n}=f(this.c,o);c=[...r,...l,...n]}for(const r of c)for(const l of(0,P.overrideIdentifiersFromKey)(r)){const n=this.c.getKeysForOverrideIdentifier(l),i=o.getKeysForOverrideIdentifier(l),p=[...i.filter(I=>n.indexOf(I)===-1),...n.filter(I=>i.indexOf(I)===-1),...n.filter(I=>!T.equals(this.c.override(l).getValue(I),o.override(l).getValue(I)))];u.push([l,p])}return this.updateDefaultConfiguration(o),{keys:c,overrides:u}}compareAndUpdatePolicyConfiguration(o){const{added:c,updated:u,removed:r}=f(this.d,o),l=[...c,...u,...r];return l.length&&this.updatePolicyConfiguration(o),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:c,updated:u,removed:r,overrides:l}=f(this.applicationConfiguration,o),n=[...c,...u,...r];return n.length&&this.updateApplicationConfiguration(o),{keys:n,overrides:l}}compareAndUpdateLocalUserConfiguration(o){const{added:c,updated:u,removed:r,overrides:l}=f(this.localUserConfiguration,o),n=[...c,...u,...r];return n.length&&this.updateLocalUserConfiguration(o),{keys:n,overrides:l}}compareAndUpdateRemoteUserConfiguration(o){const{added:c,updated:u,removed:r,overrides:l}=f(this.remoteUserConfiguration,o),n=[...c,...u,...r];return n.length&&this.updateRemoteUserConfiguration(o),{keys:n,overrides:l}}compareAndUpdateWorkspaceConfiguration(o){const{added:c,updated:u,removed:r,overrides:l}=f(this.workspaceConfiguration,o),n=[...c,...u,...r];return n.length&&this.updateWorkspaceConfiguration(o),{keys:n,overrides:l}}compareAndUpdateFolderConfiguration(o,c){const u=this.r.get(o),{added:r,updated:l,removed:n,overrides:i}=f(u,c),p=[...r,...l,...n];return(p.length||!u)&&this.updateFolderConfiguration(o,c),{keys:p,overrides:i}}compareAndDeleteFolderConfiguration(o){const c=this.r.get(o);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:u,updated:r,removed:l,overrides:n}=f(c,void 0);return{keys:[...u,...r,...l],overrides:n}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(o,c,u){let r=this.t(c,u);return c.overrideIdentifier&&(r=r.override(c.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(o)!==void 0&&(r=r.merge(this.d)),r}t({resource:o},c){let u=this.u();if(c&&o){const r=c.getFolder(o);r&&(u=this.v(r.uri)||u);const l=this.n.get(o);l&&(u=u.merge(l))}return u}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(o){let c=this.b.get(o);if(!c){const u=this.u(),r=this.l.get(o);r?(c=u.merge(r),this.p&&(c=c.freeze()),this.b.set(o,c)):c=u}return c}w(o,c){if(c&&o){const u=c.getFolder(o);if(u)return this.l.get(u.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((o,c)=>{const{contents:u,overrides:r,keys:l}=this.l.get(c);return o.push([c,{contents:u,overrides:r,keys:l}]),o},[])}}allKeys(){const o=new Set;return this.c.freeze().keys.forEach(c=>o.add(c)),this.userConfiguration.freeze().keys.forEach(c=>o.add(c)),this.j.freeze().keys.forEach(c=>o.add(c)),this.l.forEach(c=>c.freeze().keys.forEach(u=>o.add(u))),[...o.values()]}x(){const o=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(c=>o.add(c)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(c=>o.add(c)),this.j.freeze().getAllOverrideIdentifiers().forEach(c=>o.add(c)),this.l.forEach(c=>c.freeze().getAllOverrideIdentifiers().forEach(u=>o.add(u))),[...o.values()]}y(o){const c=new Set;return this.c.getKeysForOverrideIdentifier(o).forEach(u=>c.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(u=>c.add(u)),this.j.getKeysForOverrideIdentifier(o).forEach(u=>c.add(u)),this.l.forEach(u=>u.getKeysForOverrideIdentifier(o).forEach(r=>c.add(r))),[...c.values()]}static parse(o){const c=this.A(o.defaults),u=this.A(o.policy),r=this.A(o.application),l=this.A(o.user),n=this.A(o.workspace),i=o.folders.reduce((p,I)=>(p.set(C.URI.revive(I[0]),this.A(I[1])),p),new D.ResourceMap);return new h(c,u,r,l,new y,n,i,new y,new D.ResourceMap,!1)}static A(o){return new y(o.contents,o.keys,o.overrides).freeze()}}e.Configuration=h;function w(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const o=new Set,c=new Map;for(const r of s)r.keys.forEach(l=>o.add(l)),r.overrides.forEach(([l,n])=>{const i=(0,D.getOrSet)(c,l,new Set);n.forEach(p=>i.add(p))});const u=[];return c.forEach((r,l)=>u.push([l,[...r.values()]])),{keys:[...o.values()],overrides:u}}e.mergeChanges=w;class m{constructor(o,c,u,r){this.change=o,this.b=c,this.c=u,this.d=r,this.f=void 0;const l=new Set;o.keys.forEach(i=>l.add(i)),o.overrides.forEach(([,i])=>i.forEach(p=>l.add(p))),this.affectedKeys=[...l.values()];const n=new y;this.affectedKeys.forEach(i=>n.setValue(i,{})),this.a=n.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=h.parse(this.b.data)),this.f}affectsConfiguration(o,c){if(this.g(this.a,o)){if(c){const u=this.previousConfiguration?this.previousConfiguration.getValue(o,c,this.b?.workspace):void 0,r=this.c.getValue(o,c,this.d);return!T.equals(u,r)}return!0}return!1}g(o,c){let u=(0,R.toValuesTree)({[c]:!0},()=>{}),r;for(;typeof u=="object"&&(r=Object.keys(u)[0]);){if(o=o[r],!o)return!1;u=u[r]}return!0}}e.ConfigurationChangeEvent=m;function f(s,o){const{added:c,removed:u,updated:r}=b(o?.rawConfiguration,s?.rawConfiguration),l=[],n=s?.getAllOverrideIdentifiers()||[],i=o?.getAllOverrideIdentifiers()||[];if(o){const p=i.filter(I=>!n.includes(I));for(const I of p)l.push([I,o.getKeysForOverrideIdentifier(I)])}if(s){const p=n.filter(I=>!i.includes(I));for(const I of p)l.push([I,s.getKeysForOverrideIdentifier(I)])}if(o&&s){for(const p of n)if(i.includes(p)){const I=b({contents:s.getOverrideValue(void 0,p)||{},keys:s.getKeysForOverrideIdentifier(p)},{contents:o.getOverrideValue(void 0,p)||{},keys:o.getKeysForOverrideIdentifier(p)});l.push([p,[...I.added,...I.removed,...I.updated]])}}return{added:c,removed:u,updated:r,overrides:l}}function b(s,o){const c=s?o?s.keys.filter(l=>o.keys.indexOf(l)===-1):[...s.keys]:[],u=o?s?o.keys.filter(l=>s.keys.indexOf(l)===-1):[...o.keys]:[],r=[];if(s&&o){for(const l of o.keys)if(s.keys.indexOf(l)!==-1){const n=(0,R.getConfigurationValue)(o.contents,l),i=(0,R.getConfigurationValue)(s.contents,l);T.equals(n,i)||r.push(l)}}return{added:c,removed:u,updated:r}}}),define(Se[127],ye([1,0,10,3]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var k;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends a.ErrorNoTelemetry{static isNotAvailable(T){return T instanceof A&&T._code===k.NotAvailable}static isTemporarilyNotAvailable(T){return T instanceof A&&T._code===k.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof A&&T._code===k.NoResolverFound}static isHandled(T){return T instanceof A&&T.isHandled}constructor(T,S=k.Unknown,C){super(T),this._message=T,this._code=S,this._detail=C,this.isHandled=S===k.NotAvailable&&C===!0,Object.setPrototypeOf(this,A.prototype)}}e.RemoteAuthorityResolverError=A}),define(Se[88],ye([1,0,15]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(C){return C.scheme===a.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=t;function k(C){if(!C)return;const R=C.indexOf("+");return R<0?C:C.substr(0,R)}e.getRemoteName=k;function A(C){return`/${C.quality??"oss"}-${C.commit??"dev"}`}e.getRemoteServerRootPath=A;function D(C){const{host:R,port:P}=S(C);if(typeof P>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:P}}e.parseAuthorityWithPort=D;function T(C,R){let{host:P,port:E}=S(C);return typeof E>"u"&&(E=R),{host:P,port:E}}e.parseAuthorityWithOptionalPort=T;function S(C){const R=C.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const P=C.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const E=C.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:C,port:void 0}}}),define(Se[27],ye([1,0,8,3,88]),function(te,e,a,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.getWorkspaceSupportTypeMessage=A;function D(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));var S;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(S=e.TargetPlatform||(e.TargetPlatform={}));class C{constructor(d){this.value=d,this.c=d.toLowerCase()}static equals(d,g){if(typeof d>"u"||d===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof d=="string"||typeof g=="string"){const h=typeof d=="string"?d:d.value,w=typeof g=="string"?g:g.value;return a.equalsIgnoreCase(h,w)}return d.c===g.c}static toKey(d){return typeof d=="string"?d.toLowerCase():d.c}}e.ExtensionIdentifier=C;function R(v){return P(v)}e.isApplicationScopedExtension=R;function P(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function E(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=E;function y(v,d){if(d){const g=`onResolveRemoteAuthority:${(0,k.getRemoteName)(d)}`;return v.activationEvents?.indexOf(g)!==-1}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(Se[203],ye([1,0,8,121,27,12,2,10,36]),function(te,e,a,t,k,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function C(o,c){return o.uuid&&c.uuid?o.uuid===c.uuid:o.id===c.id?!0:(0,a.compareIgnoreCase)(o.id,c.id)===0}e.areSameExtensions=C;const R=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class P{static create(c){const u=c.manifest?c.manifest.version:c.version,r=c.manifest?c.targetPlatform:c.properties.targetPlatform;return new P(c.identifier,u,r)}static parse(c){const u=R.exec(c);return u&&u[1]&&u[2]?new P({id:u[1]},u[2],u[4]||void 0):null}constructor(c,u,r="undefined"){this.version=u,this.targetPlatform=r,this.id=c.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(c){return c instanceof P?C(this,c)&&this.version===c.version&&this.targetPlatform===c.targetPlatform:!1}}e.ExtensionKey=P;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(o){const c=E.exec(o);return c&&c[1]?[d(c[1]),c[2]]:[d(o),void 0]}e.getIdAndVersion=y;function v(o,c){return`${o}.${c}`}e.getExtensionId=v;function d(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=d;function g(o,c){return d(v(o,c))}e.getGalleryExtensionId=g;function h(o,c){const u=[],r=l=>{for(const n of u)if(n.some(i=>C(c(i),c(l))))return n;return null};for(const l of o){const n=r(l);n?n.push(l):u.push([l])}return u}e.groupByExtension=h;function w(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=w;function m(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.getGalleryExtensionTelemetryData=m,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function f(o,c){const u=[],r=c.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const l=r.shift();if(l&&u.every(n=>!C(n.identifier,{id:l}))){const n=o.filter(i=>C(i.identifier,{id:l}));n.length===1&&(u.push(n[0]),r.push(...n[0].manifest.extensionDependencies?.slice(0)??[]))}}return u}e.getExtensionDependencies=f;async function b(o,c){if(!A.isLinux)return!1;let u;try{u=(await o.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{u=(await o.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){c.debug("Error while getting the os-release file.",(0,T.getErrorMessage)(l))}}return!!u&&(u.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=b;async function s(o,c){const u=await b(o,c),r=(0,t.getTargetPlatform)(u?"alpine":A.platform,S.arch);return c.debug("ComputeTargetPlatform:",r),r}e.computeTargetPlatform=s}),define(Se[204],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class a{constructor(){this.b=new Map}c(){return new Promise((k,A)=>te(["vsda"],k,A))}async createNewMessage(k){try{const A=await this.c(),D=new A.validator;if(D){const T=String(a.a++);return this.b.set(T,D),{id:T,data:D.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,A){if(!k.id)return!0;const D=this.b.get(k.id);if(!D)return!1;this.b.delete(k.id);try{return D.validate(A)==="ok"}catch{return!1}}async sign(k){try{const A=await this.c(),D=new A.signer;if(D)return D.sign(k)}catch{}return k}}e.SignService=a,a.a=1}),define(Se[205],ye([1,0,12,36,2,30]),function(te,e,a,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(C){if(a.platform===2&&/^penguin(\.|$)/i.test(C))return"chromebook"}async function T(C,R,P,E,y,v,d,g,h,w){const m=Object.create(null);m["common.machineId"]=d,m.sessionID=(0,A.generateUuid)()+Date.now(),m.commitHash=y,m.version=v,m["common.platformVersion"]=(R||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,a.PlatformToString)(a.platform),m["common.nodePlatform"]=t.platform,m["common.nodeArch"]=E,m["common.product"]=w||"desktop",g&&(m["common.msftInternal"]=g);let f=0;const b=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-b,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),a.isLinuxSnap&&(m["common.snap"]="true");const s=D(P);s&&(m["common.platformDetail"]=s);try{const o=await C.readFile(k.URI.file(h));m["common.source"]=o.value.toString().slice(0,30)}catch{}return m}e.resolveCommonProperties=T;function S(C){const R=t.env.USERDNSDOMAIN;if(!R)return!1;const P=R.toLowerCase();return C.some(E=>P===E)}e.verifyMicrosoftInternalDomain=S}),define(Se[206],ye([1,0,3]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,a.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,a.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Se[128],ye([1,0,23,159,11,52,205,206]),function(te,e,a,t,k,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class S{constructor(l){this.value=l}}e.TrustedTelemetryValue=S;class C{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(l,n){return Promise.resolve(void 0)}publicLog2(l,n){return this.publicLog(l,n)}publicLogError(l,n){return Promise.resolve(void 0)}publicLogError2(l,n){return this.publicLogError(l,n)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=C,e.NullTelemetryService=new C;class R{async publicLog(l,n,i){}async publicLogError(l,n,i){}}e.NullEndpointTelemetryService=R,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function P(r,l){return l.onDidChangeConfiguration(n=>{n.source!==7&&r.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(n.source),configurationKeys:m(n.sourceConfig)})})}e.configurationTelemetry=P;function E(r,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!r.enableTelemetry||l.extensionTestsLocationURI)}e.supportsTelemetry=E;function y(r,l){return!(l.isBuilt||l.disableTelemetry||r.enableTelemetry&&r.aiConfig?.ariaKey)}e.isLoggingOnly=y;function v(r){const l=r.getValue(T.TELEMETRY_SETTING_ID),n=r.getValue("telemetry.enableCrashReporter");if(r.getValue(T.TELEMETRY_OLD_SETTING_ID)===!1||n===!1)return 0;switch(l??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=v;function d(r){const l={},n={},i={};w(r,i);for(let p in i){p=p.length>150?p.substr(p.length-149):p;const I=i[p];typeof I=="number"?n[p]=I:typeof I=="boolean"?n[p]=I?1:0:typeof I=="string"?(I.length>8192&&console.warn(`Telemetry property: ${p} has been trimmed to 8192, the original length is ${I.length}`),l[p]=I.substring(0,8191)):typeof I<"u"&&I!==null&&(l[p]=I)}return{properties:l,measurements:n}}e.validateTelemetryData=d;const g=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function h(r){if(!r)return"none";for(const l of g)if(r.startsWith(`${l}+`))return l;return"other"}e.cleanRemoteAuthority=h;function w(r,l,n=0,i){if(!!r)for(const p of Object.getOwnPropertyNames(r)){const I=r[p],L=i?i+p:p;Array.isArray(I)?l[L]=(0,a.safeStringify)(I):I instanceof Date?l[L]=I.toISOString():(0,k.isObject)(I)?n<2?w(I,l,n+1,L+"."):l[L]=(0,a.safeStringify)(I):l[L]=I}}function m(r){if(!r)return[];const l=[];return f(l,"",r),l}function f(r,l,n){n&&typeof n=="object"&&!Array.isArray(n)?Object.keys(n).forEach(i=>f(r,l?`${l}.${i}`:i,n[i])):r.push(l)}function b(r,l){const n=r.msftInternalDomains||[],i=l.getValue("telemetry.internalTesting");return(0,D.verifyMicrosoftInternalDomain)(n)||i}e.isInternalTelemetry=b;function s(r){return[r.appRoot,r.extensionsPath,r.userHome.fsPath,r.tmpDir.fsPath,r.userDataPath]}e.getPiiPathsFromEnvironment=s;function o(r,l){if(!r||!r.includes("/")&&!r.includes("\\"))return r;let n=r;const i=[];for(const U of l)for(;;){const G=U.exec(r);if(!G)break;i.push([G.index,U.lastIndex])}const p=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,I=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let L=0;for(n="";;){const U=I.exec(r);if(!U)break;const G=i.some(([V,O])=>U.index<O&&V<I.lastIndex);!p.test(U[0])&&!G&&(n+=r.substring(L,U.index)+"<REDACTED: user-file-path>",L=I.lastIndex)}return L<r.length&&(n+=r.substr(L)),n}function c(r){if(!r)return r;const l=r.toLowerCase(),n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const i of n)if(i.regex.test(l))return`<REDACTED: ${i.label}>`;return r}function u(r,l){return(0,a.cloneAndChange)(r,n=>{if(n instanceof S)return n.value;if(typeof n=="string"){let i=n.replaceAll("%20"," ");i=o(i,l);for(const p of l)i=i.replace(p,"");return i=c(i),i}})}e.cleanData=u}),define(Se[207],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class a{constructor(k){this.b=k,this.a=new Map}dispose(){for(const k of this.a.values())k.dispose()}startBuffering(k,A,D=5){const T=A(S=>{const C=typeof S=="string"?S:S.data;let R=this.a.get(k);if(R){R.data.push(C);return}const P=setTimeout(()=>this.flushBuffer(k),D);R={data:[C],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(k),T.dispose()}},this.a.set(k,R)});return T}stopBuffering(k){this.a.get(k)?.dispose()}flushBuffer(k){const A=this.a.get(k);A&&(this.a.delete(k),this.b(k,A.data.join("")))}}e.TerminalDataBufferer=a}),define(Se[208],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var a;(function(A){A.DARK="dark",A.LIGHT="light",A.HIGH_CONTRAST_DARK="hcDark",A.HIGH_CONTRAST_LIGHT="hcLight"})(a=e.ColorScheme||(e.ColorScheme={}));function t(A){return A===a.HIGH_CONTRAST_DARK||A===a.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function k(A){return A===a.DARK||A===a.HIGH_CONTRAST_DARK}e.isDark=k}),define(Se[89],ye([1,0,78,4,6,3,43,208]),function(te,e,a,t,k,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var S;(function(g){function h(w){return w&&typeof w=="object"&&typeof w.id=="string"}g.isThemeColor=h})(S=e.ThemeColor||(e.ThemeColor={}));function C(g){return{id:g}}e.themeColorFromId=C;var R;(function(g){function h(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||S.isThemeColor(u.color))}g.isThemeIcon=h;const w=new RegExp(`^\\$\\((${a.CSSIcon.iconNameExpression}(?:${a.CSSIcon.iconModifierExpression})?)\\)$`);function m(u){const r=w.exec(u);if(!r)return;const[,l]=r;return{id:l}}g.fromString=m;function f(u){return{id:u}}g.fromId=f;function b(u,r){let l=u.id;const n=l.lastIndexOf("~");return n!==-1&&(l=l.substring(0,n)),r&&(l=`${l}~${r}`),{id:l}}g.modify=b;function s(u){const r=u.id.lastIndexOf("~");if(r!==-1)return u.id.substring(r+1)}g.getModifier=s;function o(u,r){return u.id===r.id&&u.color?.id===r.color?.id}g.isEqual=o;function c(u,r){return{id:u.id,color:r?C(r):void 0}}g.asThemeIcon=c,g.asClassNameArray=a.CSSIcon.asClassNameArray,g.asClassName=a.CSSIcon.asClassName,g.asCSSSelector=a.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=a.Codicon.file,e.FolderThemeIcon=a.Codicon.folder;function P(g){switch(g){case T.ColorScheme.DARK:return"vs-dark";case T.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case T.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.a=[],this.a=[],this.b=new t.Emitter}onColorThemeChange(h){return this.a.push(h),this.b.fire(h),(0,k.toDisposable)(()=>{const w=this.a.indexOf(h);this.a.splice(w,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const y=new E;D.Registry.add(e.Extensions.ThemingContribution,y);function v(g){return y.onColorThemeChange(g)}e.registerThemingParticipant=v;class d extends k.Disposable{constructor(h){super(),this.k=h,this.h=h.getColorTheme(),this.B(this.k.onDidColorThemeChange(w=>this.n(w)))}n(h){this.h=h,this.updateStyles()}updateStyles(){}w(h,w){let m=this.h.getColor(h);return m&&w&&(m=w(m,this.h)),m?m.toString():null}}e.Themable=d}),define(Se[129],ye([1,0,4,52,3,13]),function(te,e,a,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var D;(function(d){d.Http="http",d.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var T;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(T=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function C(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(!!g)return{address:g[1],port:+g[2]}}e.extractLocalHostUriMetaDataForPortMapping=C,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(d){return e.LOCALHOST_ADDRESSES.indexOf(d)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function P(d){return e.ALL_INTERFACES_ADDRESSES.indexOf(d)>=0}e.isAllInterfaces=P;function E(d,g,h,w){if(h===1)return!1;if(h===2&&P(g)){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(w);if(m?.length===4&&parseInt(m[1])>=18)return!1}return d<1024}e.isPortPrivileged=E;class y{constructor(g,h,w){this.remoteAddress=g,this.localAddress=h,this.b=w,this.a=new a.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=y;let v=class{constructor(g,h){this.i=g,this.j=h,this.a=new a.Emitter,this.onTunnelOpened=this.a.event,this.b=new a.Emitter,this.onTunnelClosed=this.b.event,this.c=new a.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const g=this.j.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(g){return this.e=g,g?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(g){this.f=g.elevation,this.g=g.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const g=[],h=Array.from(this.d.values());for(const w of h){const m=Array.from(w.values());for(const f of m){const b=await f.value;b&&g.push(b)}}return g}async dispose(){for(const g of this.d.values()){for(const{value:h}of g.values())await h.then(w=>w?.dispose());g.clear()}this.d.clear()}setEnvironmentTunnel(g,h,w,m,f){this.o(g,h,Promise.resolve({tunnelRemoteHost:g,tunnelRemotePort:h,localAddress:w,privacy:m,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(g,h){(P(g)||R(g))&&(g=e.LOCALHOST_ADDRESSES[0]);const w=this.q(g,h);if(w)return++w.refcount,w.value}openTunnel(g,h,w,m,f=!1,b,s){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${w} on local port ${m}.`),!g)return;if(h||(h="localhost"),this.e&&this.h.has(w)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const o=this.r(g,h,w,m,f,b,s);return o?o.then(c=>{if(!c){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(h,w);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const u=this.m(c);return(c.tunnelRemoteHost!==h||c.tunnelRemotePort!==w)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(u),u}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}m(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const h=this.d.get(g.tunnelRemoteHost);if(h){const w=h.get(g.tunnelRemotePort);w&&(w.refcount--,await this.n(g.tunnelRemoteHost,g.tunnelRemotePort,w))}}}}async n(g,h,w){if(w.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${h}.`);const m=w.value.then(async f=>{f&&(await f.dispose(!0),this.b.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this.d.has(g)&&this.d.get(g).delete(h),m}}async closeTunnel(g,h){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${h} `);const w=this.d.get(g);if(w&&w.has(h)){const m=w.get(h);m.refcount=0,await this.n(g,h,m)}}o(g,h,w){this.d.has(g)||this.d.set(g,new Map),this.d.get(g).set(h,{refcount:1,value:w})}async p(g,h){const w=this.d.get(g);w&&(await w.get(h)||w.delete(h),w.size===0&&this.d.delete(g))}q(g,h){const w=[g];R(g)?(w.push(...e.LOCALHOST_ADDRESSES),w.push(...e.ALL_INTERFACES_ADDRESSES)):P(g)&&w.push(...e.ALL_INTERFACES_ADDRESSES);const m=w.map(f=>this.d.get(f));for(const f of m){const b=f?.get(h);if(b)return b}}canTunnel(g){return!!C(g)}s(g,h,w,m,f,b,s){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${w} on local port ${m}.`);const o=w;this.h.add(o);const c=m===void 0?w:m,u={elevationRequired:f?this.isPortPrivileged(c):!1},r={remoteAddress:{host:h,port:w},localAddressPort:m,privacy:b,public:b?b!==T.Private:void 0,protocol:s},l=g.forwardPort(r,u);return l?(this.o(h,w,l),l.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(o)})):this.h.delete(o),l}};v=Ve([We(0,A.ILogService),We(1,t.IConfigurationService)],v),e.AbstractTunnelService=v}),define(Se[209],ye([1,0,3]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,a.createDecorator)("editSessionIdentityService");var t;(function(k){k[k.Complete=100]="Complete",k[k.Partial=50]="Partial",k[k.None=0]="None"})(t=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(Se[210],ye([1,0,15]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(S){return S.scheme!==a.Schemas.file&&S.scheme!==a.Schemas.vscodeRemote}e.isVirtualResource=t;function k(S){if(S.folders.length)return S.folders.every(C=>t(C.uri))?S.folders[0].uri:void 0;if(S.configuration&&t(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=k;function A(S){return k(S)?.scheme}e.getVirtualWorkspaceScheme=A;function D(S){return k(S)?.authority}e.getVirtualWorkspaceAuthority=D;function T(S){return k(S)!==void 0}e.isVirtualWorkspace=T}),define(Se[45],ye([1,0,172,9,64,24,2,3,15]),function(te,e,a,t,k,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");function C(o){const c=o;return typeof c?.id=="string"&&D.URI.isUri(c.uri)}e.isSingleFolderWorkspaceIdentifier=C,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function R(o,c){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,t.basename)(o)}:c?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const u=o;if(u.configuration)return{id:u.id,configPath:u.configuration};if(u.folders.length===1)return{id:u.id,uri:u.folders[0].uri}}e.toWorkspaceIdentifier=R;function P(o){const c=o;return typeof c?.id=="string"&&D.URI.isUri(c.configPath)}e.isWorkspaceIdentifier=P;function E(o){const c=o;if(c?.uri)return{id:c.id,uri:D.URI.revive(c.uri)};const u=o;if(u?.configPath)return{id:u.id,configPath:D.URI.revive(u.configPath)};if(o?.id)return{id:o.id}}e.reviveIdentifier=E;var y;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function v(o){const c=o;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}e.isWorkspace=v;function d(o){const c=o;return!!(c&&typeof c=="object"&&D.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}e.isWorkspaceFolder=d;class g{constructor(c,u,r,l,n){this.h=c,this.j=r,this.k=l,this.l=n,this.c=k.TernarySearchTree.forUris(this.l,()=>!0),this.folders=u}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=k.TernarySearchTree.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=g;class h{constructor(c,u){this.raw=u,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,A.joinPath)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=h;function w(o){return new h({uri:o,index:0,name:(0,A.basenameOrAuthority)(o)},{uri:o.toString()})}e.toWorkspaceFolder=w,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,a.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function m(o,c){return A.extUriBiasedIgnorePathCase.isEqualOrParent(o,c.untitledWorkspacesHome)}e.isUntitledWorkspace=m;function f(o){let c;return D.URI.isUri(o)?c=o:c=o.configuration,c?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=f;function b(o,c){return!m(o,c)&&!f(o)}e.isSavedWorkspace=b;function s(o){return(typeof o=="string"?(0,t.extname)(o):(0,A.extname)(o))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(Se[67],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class a{constructor(k){this.d=k,this.b=new Map,this.c=1}add(k){const A=this.c++;return this.b.set(A,k),this.e(),A}get(k,A){return this.b.has(k)?this.b.get(k)[A]:void 0}delete(k){this.b.delete(k),this.e()}e(){!a.a||console.log(`${this.d} cache size - ${this.b.size}`)}}e.Cache=a,a.a=!1}),define(Se[46],ye([1,0,15,24,3]),function(te,e,a,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this.a=new Set(Object.keys(a.Schemas)),this.b=new Map,this.extUri=new t.ExtUri(T=>{const S=this.b.get(T.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(T,S){S===null?this.b.delete(T.scheme):this.b.set(T.scheme,S)}isFreeScheme(T){return!this.b.has(T)&&!this.a.has(T)}getCapabilities(T){return this.b.get(T)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,k.createDecorator)("IExtHostFileSystemInfo")}),define(Se[25],ye([1,0,3]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,a.createDecorator)("IExtHostInitDataService")}),define(Se[211],ye([1,0,18]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(D,T,S){this.h=new Map,this.a=D,this.b=T,this.c=S,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(C=>(this.f=C,this)),this.g=this.c.onDidChangeStorage(C=>{C.shared===this.b&&C.key===this.a&&(this.f=C.value)}),this.i=new a.RunOnceScheduler(()=>{const C=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of C.values())R.complete()}catch(R){for(const P of C.values())P.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,D])=>D!==void 0).map(([D])=>D)}get whenReady(){return this.d}get(D,T){let S=this.f[D];return typeof S>"u"&&(S=T),S}update(D,T){this.f[D]=T;const S=this.h.get(D);if(S!==void 0)return S.p;const C=new a.DeferredPromise;return this.h.set(D,C),this.i.isScheduled()||this.i.schedule(),C.p}dispose(){this.g.dispose()}}e.ExtensionMemento=t;class k extends t{setKeysForSync(D){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},D)}constructor(D,T){super(D.identifier.value,!0,T),this.j=D}}e.ExtensionGlobalMemento=k}),define(Se[212],ye([1,0,4,2]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class k{constructor(D){this.c=D,this.a=new a.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new a.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(D,T,S,C){const P=this.c.getNotebookDocument(t.URI.revive(D)).acceptModelChanged(T.value,S,C);this.b.fire(P)}$acceptDirtyStateChanged(D,T){this.c.getNotebookDocument(t.URI.revive(D)).acceptDirty(T)}$acceptModelSaved(D){const T=this.c.getNotebookDocument(t.URI.revive(D));this.a.fire(T.apiNotebook)}}e.ExtHostNotebookDocuments=k}),define(Se[16],ye([1,0,3]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,a.createDecorator)("IExtHostRpcService");class t{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=t});var Je=this&&this.__classPrivateFieldSet||function(te,e,a,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,a):k?k.value=a:e.set(te,a),a},Fe=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)};define(Se[213],ye([1,0,27,4]),function(te,e,a,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(T,S){k.set(this,void 0),this.b=new t.Emitter,this.onDidChange=this.b.event,this.a=a.ExtensionIdentifier.toKey(T.identifier),Je(this,k,S,"f"),Fe(this,k,"f").onDidChangePassword(C=>{C.extensionId===this.a&&this.b.fire({key:C.key})})}get(T){return Fe(this,k,"f").get(this.a,T)}store(T,S){return Fe(this,k,"f").store(this.a,T,S)}delete(T){return Fe(this,k,"f").delete(this.a,T)}}e.ExtensionSecrets=A,k=new WeakMap}),define(Se[54],ye([1,0,3,129,4,16]),function(te,e,a,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var D;(function(S){function C(P){return{remoteAddress:P.remoteAddress,localAddress:P.localAddress,public:!!P.public,privacy:P.privacy??(P.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:P.protocol}}S.fromApiTunnel=C;function R(P){return{remoteAddress:{host:P.tunnelRemoteHost,port:P.tunnelRemotePort},localAddress:P.localAddress,public:P.privacy!==t.TunnelPrivacyId.ConstantPrivate&&P.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:P.privacy,protocol:P.protocol}}S.fromServiceTunnel=R})(D=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,a.createDecorator)("IExtHostTunnelService");let T=class{constructor(C){this.onDidChangeTunnels=new k.Emitter().event}async $applyCandidateFilter(C){return C}async openTunnel(C,R){}async getTunnels(){return[]}async setTunnelFactory(C){return{dispose:()=>{}}}registerPortsAttributesProvider(C,R){return{dispose:()=>{}}}async $providePortAttributes(C,R,P,E,y){return[]}async $forwardPort(C,R){}async $closeTunnel(C){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=Ve([We(0,A.IExtHostRpcService)],T),e.ExtHostTunnelService=T}),define(Se[55],ye([1,0,3]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,a.createDecorator)("IURITransformerService");class t{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=D=>D,this.transformOutgoing=D=>D,this.transformOutgoingURI=D=>D,this.transformOutgoingScheme=D=>D)}}e.URITransformerService=t}),define(Se[214],ye([1,0,22]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(S){let C=this.buffers.indexOf(S);return C<0&&(C=this.buffers.length,this.buffers.push(S)),C}}function k(T,S){if(S.serializeBuffersForPostMessage){const C=new t,R=(y,v)=>{if(v instanceof ArrayBuffer){const d=C.add(v);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(v)){const d=A(v);if(d){const g=C.add(v.buffer);return{$$vscode_array_buffer_reference$$:!0,index:g,view:{type:d,byteLength:v.byteLength,byteOffset:v.byteOffset}}}}return v},P=JSON.stringify(T,R),E=C.buffers.map(y=>{const v=new Uint8Array(y);return a.VSBuffer.wrap(v)});return{message:P,buffers:E}}else return{message:JSON.stringify(T),buffers:[]}}e.serializeWebviewMessage=k;function A(T){switch(T.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function D(T,S){const C=S.map(E=>{const y=new ArrayBuffer(E.byteLength);return new Uint8Array(y).set(E.buffer),y}),R=S.length?(E,y)=>{if(y&&typeof y=="object"&&y.$$vscode_array_buffer_reference$$){const v=y,{index:d}=v,g=C[d];if(v.view)switch(v.view.type){case 1:return new Int8Array(g,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(g,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(g,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(g,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(g,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(g,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(g,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(g,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(g,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(g,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(g,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return g}return y}:void 0;return{message:JSON.parse(T,R),arrayBuffers:C}}e.deserializeWebviewMessage=D}),define(Se[215],ye([1,0,112]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(A){return{transformIncoming:D=>D.scheme==="vscode-remote"?{scheme:"file",path:D.path,query:D.query,fragment:D.fragment}:D.scheme==="file"?{scheme:"vscode-local",path:D.path,query:D.query,fragment:D.fragment}:D,transformOutgoing:D=>D.scheme==="file"?{scheme:"vscode-remote",authority:A,path:D.path,query:D.query,fragment:D.fragment}:D.scheme==="vscode-local"?{scheme:"file",path:D.path,query:D.query,fragment:D.fragment}:D,transformOutgoingScheme:D=>D==="file"?"vscode-remote":D==="vscode-local"?"file":D}}function k(A){return new a.URITransformer(t(A))}e.createURITransformer=k}),define(Se[130],ye([1,0,182,11,2,6,3,43,38,15]),function(te,e,a,t,k,A,D,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,a.localize)(0,null),providerDisplayName:(0,a.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var R;(function(K){K[K.PROGRAMMATIC=1]="PROGRAMMATIC",K[K.USER=2]="USER",K[K.EDIT=3]="EDIT",K[K.NAVIGATION=4]="NAVIGATION",K[K.JUMP=5]="JUMP"})(R=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var P;(function(K){K[K.IDENTICAL=1]="IDENTICAL",K[K.SIMILAR=2]="SIMILAR",K[K.DIFFERENT=3]="DIFFERENT"})(P=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function E(K){const q=K;return!!q&&typeof q.getSelection=="function"&&!!q.onDidChangeSelection}e.isEditorPaneWithSelection=E;function y(K,q,Y){for(const Q of Y.visibleEditorPanes)if(Q.group.id===q&&K.matches(Q.input))return Q.getViewState()}e.findViewStateForEditor=y;function v(K){if(r(K))return!1;const q=K;return k.URI.isUri(q?.resource)}e.isResourceEditorInput=v;function d(K){if(r(K))return!1;const q=K;return q?.original!==void 0&&q.modified!==void 0}e.isResourceDiffEditorInput=d;function g(K){if(r(K)||d(K))return!1;const q=K;return q?.primary!==void 0&&q.secondary!==void 0}e.isResourceSideBySideEditorInput=g;function h(K){if(r(K))return!1;const q=K;return q?q.resource===void 0||q.resource.scheme===C.Schemas.untitled||q.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=h;const w=/Untitled-\d+/;function m(K){return K.scheme===C.Schemas.untitled&&K.path.length>1&&!w.test(K.path)}e.isUntitledWithAssociatedResource=m;function f(K){if(r(K))return!1;const q=K;return k.URI.isUri(q?.base?.resource)&&k.URI.isUri(q?.input1?.resource)&&k.URI.isUri(q?.input2?.resource)&&k.URI.isUri(q?.result?.resource)}e.isResourceMergeEditorInput=f;var b;(function(K){K[K.SHORT=0]="SHORT",K[K.MEDIUM=1]="MEDIUM",K[K.LONG=2]="LONG"})(b=e.Verbosity||(e.Verbosity={}));var s;(function(K){K[K.EXPLICIT=1]="EXPLICIT",K[K.AUTO=2]="AUTO",K[K.FOCUS_CHANGE=3]="FOCUS_CHANGE",K[K.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s=e.SaveReason||(e.SaveReason={}));class o{constructor(){this.a=new Map}registerSource(q,Y){let Q=this.a.get(q);return Q||(Q={source:q,label:Y},this.a.set(q,Q)),Q.source}getSourceLabel(q){return this.a.get(q)?.label??q}}e.SaveSourceRegistry=new o;var c;(function(K){K[K.None=0]="None",K[K.Readonly=2]="Readonly",K[K.Untitled=4]="Untitled",K[K.Singleton=8]="Singleton",K[K.RequiresTrust=16]="RequiresTrust",K[K.CanSplitInGroup=32]="CanSplitInGroup",K[K.ForceDescription=64]="ForceDescription",K[K.CanDropIntoEditor=128]="CanDropIntoEditor",K[K.MultipleEditors=256]="MultipleEditors"})(c=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class u extends A.Disposable{}e.AbstractEditorInput=u;function r(K){return K instanceof u}e.isEditorInput=r;function l(K){const q=K;return k.URI.isUri(q?.preferredResource)}function n(K){const q=K;return r(q?.primary)&&r(q?.secondary)}e.isSideBySideEditorInput=n;function i(K){const q=K;return r(q?.modified)&&r(q?.original)}e.isDiffEditorInput=i;function p(K){return r(K?.editor)}e.isEditorInputWithOptions=p;function I(K){const q=K;return p(K)&&q?.group!==void 0}e.isEditorInputWithOptionsAndGroup=I;function L(K){const q=K;return typeof q?.groupId=="number"&&r(q.editor)}e.isEditorIdentifier=L;var U;(function(K){K[K.UNKNOWN=0]="UNKNOWN",K[K.REPLACE=1]="REPLACE",K[K.MOVE=2]="MOVE",K[K.UNPIN=3]="UNPIN"})(U=e.EditorCloseContext||(e.EditorCloseContext={}));var G;(function(K){K[K.GROUP_ACTIVE=0]="GROUP_ACTIVE",K[K.GROUP_INDEX=1]="GROUP_INDEX",K[K.GROUP_LOCKED=2]="GROUP_LOCKED",K[K.EDITOR_OPEN=3]="EDITOR_OPEN",K[K.EDITOR_CLOSE=4]="EDITOR_CLOSE",K[K.EDITOR_MOVE=5]="EDITOR_MOVE",K[K.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",K[K.EDITOR_LABEL=7]="EDITOR_LABEL",K[K.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",K[K.EDITOR_PIN=9]="EDITOR_PIN",K[K.EDITOR_STICKY=10]="EDITOR_STICKY",K[K.EDITOR_DIRTY=11]="EDITOR_DIRTY",K[K.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(G=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var V;(function(K){K[K.PRIMARY=1]="PRIMARY",K[K.SECONDARY=2]="SECONDARY",K[K.BOTH=3]="BOTH",K[K.ANY=4]="ANY"})(V=e.SideBySideEditor||(e.SideBySideEditor={}));class O{getOriginalUri(q,Y){if(!q)return;if(f(q))return e.EditorResourceAccessor.getOriginalUri(q.result,Y);if(Y?.supportSideBySide){const{primary:ce,secondary:ie}=this.a(q);if(ce&&ie){if(Y?.supportSideBySide===V.BOTH)return{primary:this.getOriginalUri(ce,{filterByScheme:Y.filterByScheme}),secondary:this.getOriginalUri(ie,{filterByScheme:Y.filterByScheme})};if(Y?.supportSideBySide===V.ANY)return this.getOriginalUri(ce,{filterByScheme:Y.filterByScheme})??this.getOriginalUri(ie,{filterByScheme:Y.filterByScheme});q=Y.supportSideBySide===V.PRIMARY?ce:ie}}if(d(q)||g(q)||f(q))return;const Q=l(q)?q.preferredResource:q.resource;return!Q||!Y||!Y.filterByScheme?Q:this.b(Q,Y.filterByScheme)}a(q){return n(q)||g(q)?{primary:q.primary,secondary:q.secondary}:i(q)||d(q)?{primary:q.modified,secondary:q.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(q,Y){if(!q)return;if(f(q))return e.EditorResourceAccessor.getCanonicalUri(q.result,Y);if(Y?.supportSideBySide){const{primary:ce,secondary:ie}=this.a(q);if(ce&&ie){if(Y?.supportSideBySide===V.BOTH)return{primary:this.getCanonicalUri(ce,{filterByScheme:Y.filterByScheme}),secondary:this.getCanonicalUri(ie,{filterByScheme:Y.filterByScheme})};if(Y?.supportSideBySide===V.ANY)return this.getCanonicalUri(ce,{filterByScheme:Y.filterByScheme})??this.getCanonicalUri(ie,{filterByScheme:Y.filterByScheme});q=Y.supportSideBySide===V.PRIMARY?ce:ie}}if(d(q)||g(q)||f(q))return;const Q=q.resource;return!Q||!Y||!Y.filterByScheme?Q:this.b(Q,Y.filterByScheme)}b(q,Y){if(Array.isArray(Y)){if(Y.some(Q=>q.scheme===Q))return q}else if(Y===q.scheme)return q}}e.EditorResourceAccessor=new O;var B;(function(K){K[K.LEFT=0]="LEFT",K[K.RIGHT=1]="RIGHT"})(B=e.CloseDirection||(e.CloseDirection={}));class F{constructor(){this.c=new Map,this.d=new Map}start(q){const Y=this.a=q.get(D.IInstantiationService);for(const[Q,ce]of this.c)this.e(Q,ce,Y);this.c.clear()}e(q,Y,Q){const ce=Q.createInstance(Y);this.d.set(q,ce)}registerFileEditorFactory(q){if(this.b)throw new Error("Can only register one file editor factory.");this.b=q}getFileEditorFactory(){return(0,t.assertIsDefined)(this.b)}registerEditorSerializer(q,Y){if(this.c.has(q)||this.d.has(q))throw new Error(`A editor serializer with type ID '${q}' was already registered.`);return this.a?this.e(q,Y,this.a):this.c.set(q,Y),(0,A.toDisposable)(()=>{this.c.delete(q),this.d.delete(q)})}getEditorSerializer(q){return this.d.get(typeof q=="string"?q:q.typeId)}}T.Registry.add(e.EditorExtensions.EditorFactory,new F);async function $(K,q,Y){return!K||!K.length?[]:await Promise.all(K.map(async Q=>{const ce=k.URI.revive(Q.fileUri);if(!ce){Y.info("Cannot resolve the path because it is not valid.",Q);return}if(!await q.canHandleResource(ce)){Y.info("Cannot resolve the path because it cannot be handled",Q);return}let de=Q.exists,J=Q.type;if(typeof de!="boolean"||typeof J!="number")try{J=(await q.stat(ce)).isDirectory?S.FileType.Directory:S.FileType.Unknown,de=!0}catch(ve){Y.error(ve),de=!1}if(!de&&Q.openOnlyIfExists){Y.info("Cannot resolve the path because it does not exist",Q);return}if(J===S.FileType.Directory){Y.info("Cannot resolve the path because it is a directory",Q);return}const pe={...Q.options,pinned:!0};return de?{resource:ce,options:pe}:{resource:ce,options:pe,forceUntitled:!0}}))}e.pathsToEditors=$;var M;(function(K){K[K.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",K[K.SEQUENTIAL=1]="SEQUENTIAL"})(M=e.EditorsOrder||(e.EditorsOrder={}));function H(K){const q=K;if(!q)return!1;const Y=q;if(Y.modified)return H(Y.modified);const Q=q;return!!(Q.contributionsState&&Q.viewState&&Array.isArray(Q.cursorState))}e.isTextEditorViewState=H}),define(Se[131],ye([1,0,4,18,183]),function(te,e,a,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.f=new Map,this.k=[],this.m=new a.Emitter,this.n=new a.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(T){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=T}onEvent(T){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=T}onRequest(T){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=T}sendResponse(T){T.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.s("response",T)}sendRequest(T,S,C,R){const P={command:T};if(S&&Object.keys(S).length>0&&(P.arguments=S),this.s("request",P),typeof R=="number"){const E=setTimeout(()=>{clearTimeout(E);const y=this.f.get(P.seq);if(y){this.f.delete(P.seq);const v={type:"response",seq:0,request_seq:P.seq,success:!1,command:T,message:(0,k.localize)(0,null,R,T)};y(v)}},R)}return C&&this.f.set(P.seq,C),P.seq}acceptMessage(T){this.j?this.j(T):(this.k.push(T),this.k.length===1&&this.q())}o(T,S){return T.type!=="event"||S.type!=="event"}async q(){let T;for(;this.k.length;){if((!T||this.o(this.k[0],T))&&await(0,t.timeout)(0),T=this.k.shift(),!T)return;switch(T.type){case"event":this.i?.(T);break;case"request":this.g?.(T);break;case"response":{const S=T,C=this.f.get(S.request_seq);C&&(this.f.delete(S.request_seq),C(S));break}}}}s(T,S){S.type=T,S.seq=this.d++,this.sendMessage(S)}async u(){if(this.f.size===0)return Promise.resolve();const T=new Map;this.f.forEach((S,C)=>T.set(C,S)),await(0,t.timeout)(500),T.forEach((S,C)=>{S({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.f.delete(C)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=A}),define(Se[216],ye([1,0,184,53,3]),function(te,e,a,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new t.RawContextKey("debugType",void 0,{type:"string",description:a.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new t.RawContextKey("debugConfigurationType",void 0,{type:"string",description:a.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new t.RawContextKey("debugState","inactive",{type:"string",description:a.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new t.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:a.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new t.RawContextKey("inDebugMode",!1,{type:"boolean",description:a.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new t.RawContextKey("inDebugRepl",!1,{type:"boolean",description:a.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new t.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:a.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new t.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:a.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new t.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:a.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new t.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:a.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new t.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:a.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new t.RawContextKey("variablesFocused",!0,{type:"boolean",description:a.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new t.RawContextKey("expressionSelected",!1,{type:"boolean",description:a.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new t.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:a.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new t.RawContextKey("callStackItemType",void 0,{type:"string",description:a.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new t.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:a.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new t.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:a.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new t.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:a.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new t.RawContextKey("watchItemType",void 0,{type:"string",description:a.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new t.RawContextKey("canViewMemory",void 0,{type:"boolean",description:a.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new t.RawContextKey("breakpointItemType",void 0,{type:"string",description:a.localize(20,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new t.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:a.localize(21,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new t.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:a.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new t.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:a.localize(23,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new t.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:a.localize(24,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new t.RawContextKey("stepBackSupported",!1,{type:"boolean",description:a.localize(25,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new t.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:a.localize(26,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new t.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:a.localize(27,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new t.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:a.localize(28,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new t.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:a.localize(29,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new t.RawContextKey("breakpointsExist",!1,{type:"boolean",description:a.localize(30,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new t.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:a.localize(31,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new t.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:a.localize(32,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new t.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:a.localize(33,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new t.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:a.localize(34,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new t.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:a.localize(35,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new t.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:a.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new t.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:a.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new t.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:a.localize(38,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new t.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:a.localize(39,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new t.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:a.localize(40,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new t.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:a.localize(41,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new t.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:a.localize(42,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new t.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:a.localize(43,null)}),e.CONTEXT_MULTI_SESSION_REPL=new t.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:a.localize(44,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new t.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:a.localize(45,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new t.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:a.localize(46,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new t.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:a.localize(47,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new t.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:a.localize(48,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new t.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:a.localize(49,null)});const A=E=>a.localize(50,null,E);e.debuggerDisabledMessage=A,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:a.localize(51,null)};var D;(function(E){E[E.Inactive=0]="Inactive",E[E.Initializing=1]="Initializing",E[E.Stopped=2]="Stopped",E[E.Running=3]="Running"})(D=e.State||(e.State={}));function T(E){switch(E){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=T;var S;(function(E){E[E.Valid=0]="Valid",E[E.Unreadable=1]="Unreadable",E[E.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var C;(function(E){E[E.Initial=1]="Initial",E[E.Dynamic=2]="Dynamic"})(C=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var R;(function(E){E.UnverifiedBreakpoints="unverifiedBreakpoints"})(R=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,k.createDecorator)("debugService");var P;(function(E){E[E.CONDITION=0]="CONDITION",E[E.HIT_COUNT=1]="HIT_COUNT",E[E.LOG_MESSAGE=2]="LOG_MESSAGE"})(P=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Se[217],ye([1,0,8,2,9,23,15]),function(te,e,a,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const T=/{([^}]+)}/g;function S(c,u,r){return c.replace(T,function(l,n){return u&&n.length>0&&n[0]!=="_"?l:r&&r.hasOwnProperty(n)?r[n]:l})}e.formatPII=S;function C(c){const u={};for(const r of Object.keys(c))r.startsWith("!")||(u[r]=c[r]);return u}e.filterExceptionsFromTelemetry=C;function R(c){return c.configuration.request==="attach"&&!P(c)&&(!c.parentSession||R(c.parentSession))}e.isSessionAttach=R;function P(c){let u=c.configuration.type;if(!!u)return u==="vslsShare"&&(u=c.configuration.adapterProxy.configuration.type),(0,a.equalsIgnoreCase)(u,"extensionhost")||(0,a.equalsIgnoreCase)(u,"pwa-extensionhost")?c:c.parentSession?P(c.parentSession):void 0}e.getExtensionHostDebugSession=P;function E(c){return c.type&&(c.label||c.program||c.runtime)}e.isDebuggerMainContribution=E;function y(c,u,r){let l,n=0;const i=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let p=null;for(;p=i.exec(c);){const I=p.index+1,L=I+p[0].length;if(I<=u&&L>=r){l=p[0],n=I;break}}if(l){const I=/\w+/g;let L=null;for(;(L=I.exec(l))&&!(L.index+1+n+L[0].length>=r););L&&(l=l.substring(0,I.lastIndex))}return l?{start:n,end:n+l.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=y;const v=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(c){return!!(c&&c.match(v))}e.isUri=d;function g(c){if(typeof c.path=="string"&&!(typeof c.sourceReference=="number"&&c.sourceReference>0)){if(d(c.path))return t.URI.parse(c.path);if((0,k.isAbsolute)(c.path))return t.URI.file(c.path)}return c.path}function h(c){if(typeof c.path=="object"){const u=t.URI.revive(c.path);if(u)return u.scheme===D.Schemas.file?u.fsPath:u.toString()}return c.path}function w(c,u){const r=u?g:h,l=(0,A.deepClone)(c);return f(l,(n,i)=>{n&&i&&(i.path=r(i))}),l}e.convertToDAPaths=w;function m(c,u){const r=u?g:h,l=(0,A.deepClone)(c);return f(l,(n,i)=>{!n&&i&&(i.path=r(i))}),l}e.convertToVSCPaths=m;function f(c,u){switch(c.type){case"event":{const r=c;switch(r.event){case"output":u(!1,r.body.source);break;case"loadedSource":u(!1,r.body.source);break;case"breakpoint":u(!1,r.body.breakpoint.source);break;default:break}break}case"request":{const r=c;switch(r.command){case"setBreakpoints":u(!0,r.arguments.source);break;case"breakpointLocations":u(!0,r.arguments.source);break;case"source":u(!0,r.arguments.source);break;case"gotoTargets":u(!0,r.arguments.source);break;case"launchVSCode":r.arguments.args.forEach(l=>u(!1,l));break;default:break}break}case"response":{const r=c;if(r.success&&r.body)switch(r.command){case"stackTrace":r.body.stackFrames.forEach(l=>u(!1,l.source));break;case"loadedSources":r.body.sources.forEach(l=>u(!1,l));break;case"scopes":r.body.scopes.forEach(l=>u(!1,l.source));break;case"setFunctionBreakpoints":r.body.breakpoints.forEach(l=>u(!1,l.source));break;case"setBreakpoints":r.body.breakpoints.forEach(l=>u(!1,l.source));break;case"disassemble":r.body?.instructions.forEach(n=>u(!1,n.location));break;default:break}break}}}function b(c){return c.filter(u=>!u.presentation?.hidden).sort((u,r)=>u.presentation?r.presentation?u.presentation.group?r.presentation.group?u.presentation.group!==r.presentation.group?u.presentation.group.localeCompare(r.presentation.group):s(u.presentation.order,r.presentation.order):-1:r.presentation.group?1:s(u.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=b;function s(c,u){return typeof c!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:c-u}async function o(c,u){const r=c.getValue("debug.saveBeforeStart",{overrideIdentifier:u.activeTextEditorLanguageId});if(r!=="none"&&(await u.saveAll(),r==="allEditorsInActiveGroup")){const l=u.activeEditorPane;l&&l.input.resource?.scheme===D.Schemas.untitled&&await u.save({editor:l.input,groupId:l.group.id})}await c.reloadConfiguration()}e.saveAllBeforeDebugStart=o}),define(Se[218],ye([1,0,44,219,23,9,12,8,29,185,131]),function(te,e,a,t,k,A,D,T,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class P extends R.AbstractDebugAdapter{constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(h,w){this.p=w,this.r=Buffer.allocUnsafe(0),this.t=-1,h.on("data",m=>this.w(m))}sendMessage(h){if(this.p){const w=JSON.stringify(h);this.p.write(`Content-Length: ${Buffer.byteLength(w,"utf8")}${P.a}${w}`,"utf8")}}w(h){for(this.r=Buffer.concat([this.r,h]);;){if(this.t>=0){if(this.r.length>=this.t){const w=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,w.length>0)try{this.acceptMessage(JSON.parse(w))}catch(m){this.m.fire(new Error((m.message||m)+`
`+w))}continue}}else{const w=this.r.indexOf(P.a);if(w!==-1){const f=this.r.toString("utf8",0,w).split(P.b);for(const b of f){const s=b.split(P.l);s[0]==="Content-Length"&&(this.t=Number(s[1]))}this.r=this.r.slice(w+P.a.length);continue}}break}}}e.StreamDebugAdapter=P,P.a=`\r
\r
`,P.b=/\r?\n/,P.l=/: */;class E extends P{startSession(){return new Promise((h,w)=>{let m=!1;this.x=this.y(()=>{this.v(this.x,this.x),h(),m=!0}),this.x.on("close",()=>{m?this.m.fire(new Error("connection closed")):w(new Error("connection closed"))}),this.x.on("error",f=>{m?this.m.fire(f):w(f)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.NetworkDebugAdapter=E;class y extends E{constructor(h){super(),this.A=h}y(h){return t.createConnection(this.A.port,this.A.host||"127.0.0.1",h)}}e.SocketDebugAdapter=y;class v extends E{constructor(h){super(),this.A=h}y(h){return t.createConnection(this.A.path,h)}}e.NamedPipeDebugAdapter=v;class d extends P{constructor(h,w){super(),this.y=h,this.A=w}async startSession(){const h=this.y.command,w=this.y.args,m=this.y.options||{};try{if(h)if(A.isAbsolute(h)){if(!await S.Promises.exists(h))throw new Error(C.localize(0,null,h))}else h.indexOf("/")<0&&h.indexOf("\\")<0;else throw new Error(C.localize(1,null,this.A));let f=process.env;if(m.env&&Object.keys(m.env).length>0&&(f=k.mixin(k.deepClone(process.env),m.env)),h==="node")if(Array.isArray(w)&&w.length>0){const b=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:f,execArgv:b?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};m.cwd&&(s.cwd=m.cwd);const o=a.fork(w[0],w.slice(1),s);if(!o.pid)throw new Error(C.localize(2,null,w[0]));this.x=o}else throw new Error(C.localize(3,null));else{const b={env:f};m.cwd&&(b.cwd=m.cwd),this.x=a.spawn(h,w,b)}this.x.on("error",b=>{this.m.fire(b)}),this.x.on("exit",(b,s)=>{this.n.fire(b)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",b=>{this.m.fire(b)}),this.x.stdin.on("error",b=>{this.m.fire(b)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(f){this.m.fire(f)}}async stopSession(){return this.x?(await this.u(),D.isWindows?new Promise((h,w)=>{const m=a.exec(`taskkill /F /T /PID ${this.x.pid}`,function(f,b,s){if(f)return w(f)});m.on("exit",h),m.on("error",w)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static B(h,w){if(!h)return;const m=Object.create(null);h.runtime&&(h.runtime.indexOf("./")===0?m.runtime=A.join(w,h.runtime):m.runtime=h.runtime),h.runtimeArgs&&(m.runtimeArgs=h.runtimeArgs),h.program&&(A.isAbsolute(h.program)?m.program=h.program:m.program=A.join(w,h.program)),h.args&&(m.args=h.args);const f=h;return f.win&&(m.win=d.B(f.win,w)),f.winx86&&(m.winx86=d.B(f.winx86,w)),f.windows&&(m.windows=d.B(f.windows,w)),f.osx&&(m.osx=d.B(f.osx,w)),f.linux&&(m.linux=d.B(f.linux,w)),m}static platformAdapterExecutable(h,w){let m=Object.create(null);w=w.toLowerCase();for(const u of h)if(u.contributes){const r=u.contributes.debuggers;r&&r.length>0&&r.filter(l=>typeof l.type=="string"&&T.equalsIgnoreCase(l.type,w)).forEach(l=>{const n=d.B(l,u.extensionLocation.fsPath);m=k.mixin(m,n,u.isBuiltin)})}let f;D.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?f=m.winx86||m.win||m.windows:D.isWindows?f=m.win||m.windows:D.isMacintosh?f=m.osx:D.isLinux&&(f=m.linux),f=f||m;const b=f.program||m.program,s=f.args||m.args,o=f.runtime||m.runtime,c=f.runtimeArgs||m.runtimeArgs;if(o)return{type:"executable",command:o,args:(c||[]).concat(typeof b=="string"?[b]:[]).concat(s||[])};if(b)return{type:"executable",command:b,args:s||[]}}}e.ExecutableDebugAdapter=d}),define(Se[220],ye([1,0,44,32,12]),function(te,e,a,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function A(C,R){return new Promise((P,E)=>{let y="";const v=a.spawn(C,R);v.pid&&v.stdout.on("data",d=>{y+=d.toString()}),v.on("error",d=>{E(d)}),v.on("close",d=>{P(y)})})}async function D(C){if(C)if(k.isWindows){const R=await new Promise((P,E)=>{te(["windows-process-tree"],P,E)});return new Promise(P=>{R.getProcessTree(C,E=>{P(!!E&&E.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(C)]).then(R=>{const P=R.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}e.hasChildProcesses=D;var T;(function(C){C[C.cmd=0]="cmd",C[C.powershell=1]="powershell",C[C.bash=2]="bash"})(T||(T={}));function S(C,R,P,E,y){C=C.trim().toLowerCase();let v;C.indexOf("powershell")>=0||C.indexOf("pwsh")>=0?v=1:C.indexOf("cmd.exe")>=0?v=0:C.indexOf("bash")>=0?v=2:k.isWindows?v=0:v=2;let d,g=" ";switch(v){case 1:if(d=h=>(h=h.replace(/\'/g,"''"),h.length>0&&h.charAt(h.length-1)==="\\"?`'${h}\\'`:`'${h}'`),E){const h=(0,t.getDriveLetter)(E);h&&(g+=`${h}:; `),g+=`cd ${d(E)}; `}if(y)for(const h in y){const w=y[h];w===null?g+=`Remove-Item env:${h}; `:g+=`\${env:${h}}='${w}'; `}if(R.length>0){const h=R.shift(),w=P?h:d(h);g+=w[0]==="'"?`& ${w} `:`${w} `;for(const m of R)g+=m==="<"||m===">"||P?m:d(m),g+=" "}break;case 0:if(d=h=>(h=h.replace(/\"/g,'""'),h=h.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(w=>h.includes(w))||h.length===0?`"${h}"`:h),E){const h=(0,t.getDriveLetter)(E);h&&(g+=`${h}: && `),g+=`cd ${d(E)} && `}if(y){g+='cmd /C "';for(const h in y){let w=y[h];w===null?g+=`set "${h}=" && `:(w=w.replace(/[&^|<>]/g,m=>`^${m}`),g+=`set "${h}=${w}" && `)}}for(const h of R)g+=h==="<"||h===">"||P?h:d(h),g+=" ";y&&(g+='"');break;case 2:{d=w=>(w=w.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),w.length===0?'""':w);const h=w=>/[^\w@%\/+=,.:^-]/.test(w)?`'${w.replace(/'/g,"'\\''")}'`:w;if(E&&(g+=`cd ${d(E)} ; `),y){g+="/usr/bin/env";for(const w in y){const m=y[w];m===null?g+=` -u ${h(w)}`:g+=` ${h(`${w}=${m}`)}`}g+=" "}for(const w of R)g+=w==="<"||w===">"||P?w:d(w),g+=" ";break}}return g}e.prepareCommand=S}),define(Se[90],ye([1,0,22,37,62,82,15,9,12,53]),function(te,e,a,t,k,A,D,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var R;(function($){$[$.Markup=1]="Markup",$[$.Code=2]="Code"})(R=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",A.Mimes.latex,A.Mimes.markdown,"image/png","image/jpeg",A.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[A.Mimes.latex,A.Mimes.markdown,"application/json",A.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function($){$[$.Running=1]="Running",$[$.Idle=2]="Idle"})(P=e.NotebookRunState||(e.NotebookRunState={}));var E;(function($){$[$.Unconfirmed=1]="Unconfirmed",$[$.Pending=2]="Pending",$[$.Executing=3]="Executing"})(E=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var y;(function($){$[$.WithHardKernelDependency=0]="WithHardKernelDependency",$[$.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",$[$.Pure=2]="Pure",$[$.Never=3]="Never"})(y=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var v;(function($){$.Always="always",$.Never="never",$.Optional="optional"})(v=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var d;(function($){$[$.ModelChange=1]="ModelChange",$[$.Move=2]="Move",$[$.ChangeCellLanguage=5]="ChangeCellLanguage",$[$.Initialize=6]="Initialize",$[$.ChangeCellMetadata=7]="ChangeCellMetadata",$[$.Output=8]="Output",$[$.OutputItem=9]="OutputItem",$[$.ChangeCellContent=10]="ChangeCellContent",$[$.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",$[$.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",$[$.ChangeCellMime=13]="ChangeCellMime",$[$.Unknown=100]="Unknown"})(d=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var g;(function($){$[$.Handle=0]="Handle",$[$.Index=1]="Index"})(g=e.SelectionStateType||(e.SelectionStateType={}));var h;(function($){$[$.Replace=1]="Replace",$[$.Output=2]="Output",$[$.Metadata=3]="Metadata",$[$.CellLanguage=4]="CellLanguage",$[$.DocumentMetadata=5]="DocumentMetadata",$[$.Move=6]="Move",$[$.OutputItems=7]="OutputItems",$[$.PartialMetadata=8]="PartialMetadata",$[$.PartialInternalMetadata=9]="PartialInternalMetadata"})(h=e.CellEditType||(e.CellEditType={}));var w;(function($){$.scheme=D.Schemas.vscodeNotebookCell;const M=["W","X","Y","Z","a","b","c","d","e","f"],H=new RegExp(`^[${M.join("")}]+`),K=7;function q(J,pe){const ve=pe.toString(K),Re=`${ve.length<M.length?M[ve.length-1]:"z"}${ve}s${(0,a.encodeBase64)(a.VSBuffer.fromString(J.scheme),!0,!0)}`;return J.with({scheme:$.scheme,fragment:Re})}$.generate=q;function Y(J){if(J.scheme!==$.scheme)return;const pe=J.fragment.indexOf("s");if(pe<0)return;const ve=parseInt(J.fragment.substring(0,pe).replace(H,""),K),De=(0,a.decodeBase64)(J.fragment.substring(pe+1)).toString();if(!isNaN(ve))return{handle:ve,notebook:J.with({scheme:De,fragment:null})}}$.parse=Y;function Q(J,pe){return J.with({scheme:D.Schemas.vscodeNotebookCellOutput,fragment:`op${pe??""},${J.scheme!==D.Schemas.file?J.scheme:""}`})}$.generateCellOutputUri=Q;function ce(J){if(J.scheme!==D.Schemas.vscodeNotebookCellOutput)return;const pe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(J.fragment);if(!pe)return;const ve=pe[1]&&pe[1]!==""?pe[1]:void 0,De=pe[2];return{outputId:ve,notebook:J.with({scheme:De||D.Schemas.file,fragment:null})}}$.parseCellOutputUri=ce;function ie(J,pe,ve){return $.generate(J,pe).with({scheme:ve})}$.generateCellPropertyUri=ie;function de(J,pe){if(J.scheme===pe)return $.parse(J.with({scheme:$.scheme}))}$.parseCellPropertyUri=de})(w=e.CellUri||(e.CellUri={}));const m=$=>S.isWindows?$.replace(/\//g,"\\"):$;class f{constructor(M=[],H=e.NOTEBOOK_DISPLAY_ORDER){this.e=H,this.d=[...new Set(M)].map(K=>({pattern:K,matches:t.parse(m(K))}))}sort(M){const H=new Map(k.Iterable.map(M,q=>[q,m(q)]));let K=[];for(const{matches:q}of this.d)for(const[Y,Q]of H)if(q(Q)){K.push(Y),H.delete(Y);break}return H.size&&(K=K.concat([...H.keys()].sort((q,Y)=>this.e.indexOf(q)-this.e.indexOf(Y)))),K}prioritize(M,H){const K=this.f(M);if(K===-1){this.d.unshift({pattern:M,matches:t.parse(m(M))});return}const q=new Set(H.map(Q=>this.f(Q,K)));q.delete(-1);const Y=Array.from(q).sort();this.d.splice(K+1,0,...Y.map(Q=>this.d[Q]));for(let Q=Y.length-1;Q>=0;Q--)this.d.splice(Y[Q],1)}toArray(){return this.d.map(M=>M.pattern)}f(M,H=this.d.length){const K=m(M);for(let q=0;q<H;q++)if(this.d[q].matches(K))return q;return-1}}e.MimeTypeDisplayOrder=f;function b($,M,H,K=(q,Y)=>q===Y){const q=[];function Y(ie,de,J){if(de===0&&J.length===0)return;const pe=q[q.length-1];pe&&pe.start+pe.deleteCount===ie?(pe.deleteCount+=de,pe.toInsert.push(...J)):q.push({start:ie,deleteCount:de,toInsert:J})}let Q=0,ce=0;for(;;){if(Q===$.length){Y(Q,0,M.slice(ce));break}if(ce===M.length){Y(Q,$.length-Q,[]);break}const ie=$[Q],de=M[ce];if(K(ie,de)){Q+=1,ce+=1;continue}H(de)?(Y(Q,1,[]),Q+=1):(Y(Q,0,[de]),ce+=1)}return q}e.diff=b,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function($){$.default="default",$.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o($){const M=$;return!!((typeof M.include=="string"||t.isRelativePattern(M.include))&&(typeof M.exclude=="string"||t.isRelativePattern(M.exclude)))}e.isDocumentExcludePattern=o;function c($,M,H){if(Array.isArray($.viewType)&&$.viewType.indexOf(M)>=0||$.viewType===M)return!0;if($.filenamePattern){const K=o($.filenamePattern)?$.filenamePattern.include:$.filenamePattern,q=o($.filenamePattern)?$.filenamePattern.exclude:void 0;if(t.match(K,(0,T.basename)(H.fsPath).toLowerCase()))return!(q&&t.match(q,(0,T.basename)(H.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=c,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling"};var u;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(u=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class r{static create(M){return`${r.d}${M}`}static parse(M){if(M.startsWith(r.d))return M.substring(r.d.length)}}e.NotebookWorkingCopyTypeIdentifier=r,r.d="notebook/";function l($){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes($)}e.isTextStreamMime=l;const n=new TextDecoder;function i($){const M=[];let H=!1;for(const K of $)(M.length===0||H)&&(M.push(K),H=!0);return U(M),F(a.VSBuffer.concat(M.map(K=>a.VSBuffer.wrap(K))))}e.compressOutputItemStreams=i;const p=`${String.fromCharCode(27)}[A`,I=p.split("").map($=>$.charCodeAt(0)),L=10;function U($){$.forEach((M,H)=>{if(H===0||M.length<p.length)return;const K=$[H-1],q=M.subarray(0,p.length);if(q[0]===I[0]&&q[1]===I[1]&&q[2]===I[2]){const Y=K.lastIndexOf(L);if(Y===-1)return;$[H-1]=K.subarray(0,Y),$[H]=M.subarray(p.length)}})}function G($){let M=$;do $=M,M=$.replace(/[^\n]\x08/gm,"");while(M.length<$.length);return $}function V($){for($=$.replace(/\r+\n/gm,`
`);$.search(/\r[^$]/g)>-1;){const M=$.match(/^(.*)\r+/m)[1];let H=$.match(/\r+(.*)$/m)[1];H=H+M.slice(H.length,M.length),$=$.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,H)}return $}const O="\b".charCodeAt(0),B="\r".charCodeAt(0);function F($){return!$.buffer.includes(O)&&!$.buffer.includes(B)?$:a.VSBuffer.fromString(V(G(n.decode($.buffer))))}}),define(Se[221],ye([1,0,3]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(k){k[k.Output=1]="Output",k[k.OutputItems=2]="OutputItems",k[k.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,a.createDecorator)("INotebookExecutionService")}),define(Se[222],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function a(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=a;function t(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=t;function k(D){return Array.from(D.entries()).map(T=>[T[0],a(T[1].map)])}e.serializeEnvironmentVariableCollections=k;function A(D){return new Map(D.map(T=>[T[0],{map:t(T[1])}]))}e.deserializeEnvironmentVariableCollections=A}),define(Se[56],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var a;(function(A){A.Delimiter="\0"})(a=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class k{static fromExtHostTestItem(D,T,S=D.parent){if(D._isRoot)return new k([T]);const C=[D.id];for(let R=S;R&&R.id!==T;R=R.parent)C.push(R.id);return C.push(T),new k(C.reverse())}static isRoot(D){return!D.includes("\0")}static root(D){const T=D.indexOf("\0");return T===-1?D:D.slice(0,T)}static fromString(D){return new k(D.split("\0"))}static join(D,T){return new k([...D.path,T])}static joinToString(D,T){return D.toString()+"\0"+T}static parentId(D){const T=D.lastIndexOf("\0");return T===-1?void 0:D.slice(0,T)}static compare(D,T){return D===T?0:T.startsWith(D+"\0")?2:D.startsWith(T+"\0")?3:1}constructor(D,T=D.length){if(this.path=D,this.d=T,D.length===0||T<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new k(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let D=1;D<=this.d;D++)yield new k(this.path,D)}*idsToRoot(){for(let D=this.d;D>0;D--)yield new k(this.path,D)}compare(D){if(typeof D=="string")return k.compare(this.toString(),D);for(let T=0;T<D.d&&T<this.d;T++)if(D.path[T]!==this.path[T])return 1;return D.d>this.d?2:D.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let D=1;D<this.d;D++)this.c+="\0",this.c+=this.path[D]}return this.c}}e.TestId=k}),define(Se[68],ye([1,0,2,35,56]),function(te,e,a,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var A;(function(n){n[n.Unset=0]="Unset",n[n.Queued=1]="Queued",n[n.Running=2]="Running",n[n.Passed=3]="Passed",n[n.Failed=4]="Failed",n[n.Skipped=5]="Skipped",n[n.Errored=6]="Errored"})(A=e.TestResultState||(e.TestResultState={}));var D;(function(n){n[n.Run=2]="Run",n[n.Debug=4]="Debug",n[n.Coverage=8]="Coverage",n[n.HasNonDefaultProfile=16]="HasNonDefaultProfile",n[n.HasConfigurable=32]="HasConfigurable"})(D=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var T;(function(n){n.serialize=i=>({range:i.range.toJSON(),uri:i.uri.toJSON()}),n.deserialize=i=>({range:t.Range.lift(i.range),uri:a.URI.revive(i.uri)})})(T=e.IRichLocation||(e.IRichLocation={}));var S;(function(n){n[n.Error=0]="Error",n[n.Output=1]="Output"})(S=e.TestMessageType||(e.TestMessageType={}));var C;(function(n){n.serialize=i=>({message:i.message,type:0,expected:i.expected,actual:i.actual,location:i.location&&T.serialize(i.location)}),n.deserialize=i=>({message:i.message,type:0,expected:i.expected,actual:i.actual,location:i.location&&T.deserialize(i.location)})})(C=e.ITestErrorMessage||(e.ITestErrorMessage={}));const R=(n,i)=>`${i?"s":"e"}${n}`;e.getMarkId=R;var P;(function(n){n.serialize=i=>({message:i.message,type:1,offset:i.offset,length:i.length,location:i.location&&T.serialize(i.location)}),n.deserialize=i=>({message:i.message,type:1,offset:i.offset,length:i.length,location:i.location&&T.deserialize(i.location)})})(P=e.ITestOutputMessage||(e.ITestOutputMessage={}));var E;(function(n){n.serialize=i=>i.type===0?C.serialize(i):P.serialize(i),n.deserialize=i=>i.type===0?C.deserialize(i):P.deserialize(i)})(E=e.ITestMessage||(e.ITestMessage={}));var y;(function(n){n.serializeWithoutMessages=i=>({state:i.state,duration:i.duration,messages:[]}),n.serialize=i=>({state:i.state,duration:i.duration,messages:i.messages.map(E.serialize)}),n.deserialize=i=>({state:i.state,duration:i.duration,messages:i.messages.map(E.deserialize)})})(y=e.ITestTaskState||(e.ITestTaskState={}));const v="\0",d=(n,i)=>n+v+i;e.namespaceTestTag=d;const g=n=>{const i=n.indexOf(v);return{ctrlId:n.slice(0,i),tagId:n.slice(i+1)}};e.denamespaceTestTag=g;var h;(function(n){n.serialize=i=>({extId:i.extId,label:i.label,tags:i.tags,busy:i.busy,children:void 0,uri:i.uri?.toJSON(),range:i.range?.toJSON()||null,description:i.description,error:i.error,sortText:i.sortText}),n.deserialize=i=>({extId:i.extId,label:i.label,tags:i.tags,busy:i.busy,children:void 0,uri:i.uri?a.URI.revive(i.uri):void 0,range:i.range?t.Range.lift(i.range):null,description:i.description,error:i.error,sortText:i.sortText})})(h=e.ITestItem||(e.ITestItem={}));var w;(function(n){n[n.NotExpandable=0]="NotExpandable",n[n.Expandable=1]="Expandable",n[n.BusyExpanding=2]="BusyExpanding",n[n.Expanded=3]="Expanded"})(w=e.TestItemExpandState||(e.TestItemExpandState={}));var m;(function(n){n.serialize=i=>({expand:i.expand,item:h.serialize(i.item)}),n.deserialize=i=>({controllerId:k.TestId.root(i.item.extId),expand:i.expand,item:h.deserialize(i.item)})})(m=e.InternalTestItem||(e.InternalTestItem={}));var f;(function(n){n.serialize=i=>{let p;return i.item&&(p={},i.item.label!==void 0&&(p.label=i.item.label),i.item.tags!==void 0&&(p.tags=i.item.tags),i.item.busy!==void 0&&(p.busy=i.item.busy),i.item.uri!==void 0&&(p.uri=i.item.uri?.toJSON()),i.item.range!==void 0&&(p.range=i.item.range?.toJSON()),i.item.description!==void 0&&(p.description=i.item.description),i.item.error!==void 0&&(p.error=i.item.error),i.item.sortText!==void 0&&(p.sortText=i.item.sortText)),{extId:i.extId,expand:i.expand,item:p}},n.deserialize=i=>{let p;return i.item&&(p={},i.item.label!==void 0&&(p.label=i.item.label),i.item.tags!==void 0&&(p.tags=i.item.tags),i.item.busy!==void 0&&(p.busy=i.item.busy),i.item.range!==void 0&&(p.range=i.item.range?t.Range.lift(i.item.range):null),i.item.description!==void 0&&(p.description=i.item.description),i.item.error!==void 0&&(p.error=i.item.error),i.item.sortText!==void 0&&(p.sortText=i.item.sortText)),{extId:i.extId,expand:i.expand,item:p}}})(f=e.ITestItemUpdate||(e.ITestItemUpdate={}));const b=(n,i)=>{i.expand!==void 0&&(n.expand=i.expand),i.item!==void 0&&(n.item=n.item?Object.assign(n.item,i.item):i.item)};e.applyTestItemUpdate=b;var s;(function(n){n.serializeWithoutMessages=i=>({...m.serialize(i),ownComputedState:i.ownComputedState,computedState:i.computedState,tasks:i.tasks.map(y.serializeWithoutMessages),retired:i.retired}),n.serialize=i=>({...m.serialize(i),ownComputedState:i.ownComputedState,computedState:i.computedState,tasks:i.tasks.map(y.serialize),retired:i.retired}),n.deserialize=i=>({...m.deserialize(i),ownComputedState:i.ownComputedState,computedState:i.computedState,tasks:i.tasks.map(y.deserialize),retired:!0})})(s=e.TestResultItem||(e.TestResultItem={}));var o;(function(n){n[n.Function=0]="Function",n[n.Statement=1]="Statement"})(o=e.DetailType||(e.DetailType={}));var c;(function(n){n[n.Add=0]="Add",n[n.Update=1]="Update",n[n.DocumentSynced=2]="DocumentSynced",n[n.Remove=3]="Remove",n[n.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",n[n.Retire=5]="Retire",n[n.AddTag=6]="AddTag",n[n.RemoveTag=7]="RemoveTag"})(c=e.TestDiffOpType||(e.TestDiffOpType={}));var u;(function(n){n.deserialize=i=>i.op===0?{op:i.op,item:m.deserialize(i.item)}:i.op===1?{op:i.op,item:f.deserialize(i.item)}:i.op===2?{op:i.op,uri:a.URI.revive(i.uri),docv:i.docv}:i,n.serialize=i=>i.op===0?{op:i.op,item:m.serialize(i.item)}:i.op===1?{op:i.op,item:f.serialize(i.item)}:i})(u=e.TestsDiffOp||(e.TestsDiffOp={}));class r{add(i){}update(i){}remove(i,p){}complete(){}}e.IncrementalChangeCollector=r;class l{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(i){const p=this.k();for(const I of i)switch(I.op){case 0:{const L=m.deserialize(I.item),U=k.TestId.parentId(L.item.extId)?.toString();if(U){if(this.d.has(U)){const G=this.d.get(U);G.children.add(L.item.extId);const V=this.l(L,G);this.d.set(L.item.extId,V),p.add(V)}}else{const G=this.l(L);this.f.add(G),this.d.set(L.item.extId,G),p.add(G)}L.expand===2&&this.g++;break}case 1:{const L=f.deserialize(I.item),U=this.d.get(L.extId);if(!U)break;L.expand!==void 0&&(U.expand===2&&this.g--,L.expand===2&&this.g++),(0,e.applyTestItemUpdate)(U,L),p.update(U);break}case 3:{const L=this.d.get(I.itemId);if(!L)break;const U=k.TestId.parentId(L.item.extId)?.toString();U?this.d.get(U).children.delete(L.item.extId):this.f.delete(L);const G=[[I.itemId]];for(;G.length;)for(const V of G.pop()){const O=this.d.get(V);O&&(G.push(O.children),this.d.delete(V),p.remove(O,O!==L),O.expand===2&&this.g--)}break}case 5:this.j(I.itemId);break;case 4:this.updatePendingRoots(I.amount);break;case 6:this.c.set(I.tag.id,I.tag);break;case 7:this.c.delete(I.id);break}p.complete()}j(i){}updatePendingRoots(i){this.h+=i}k(){return new r}}e.AbstractIncrementalTestCollection=l}),define(Se[91],ye([1,0,18,4,6,48,68,56]),function(te,e,a,t,k,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(h){h[h.Upsert=0]="Upsert",h[h.SetTags=1]="SetTags",h[h.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",h[h.RemoveChild=3]="RemoveChild",h[h.SetProp=4]="SetProp",h[h.Bulk=5]="Bulk",h[h.DocumentSynced=6]="DocumentSynced"})(S=e.TestItemEventOp||(e.TestItemEventOp={}));const C=(h,w)=>h===w,R={range:(h,w)=>h===w?!0:!h||!w?!1:h.equalsRange(w),busy:C,label:C,description:C,error:C,tags:(h,w)=>!(h.length!==w.length||h.some(m=>!w.includes(m)))},P=(h,w)=>{let m;for(const[f,b]of Object.entries(R))b(h[f],w[f])||(m?m[f]=w[f]:m={[f]:w[f]});return m};class E extends k.Disposable{get root(){return this.m.root}constructor(w){super(),this.m=w,this.f=this.B(new a.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new t.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(w){this.h=w;for(const m of this.tree.values())this.H(m)}collectDiff(){const w=this.k;return this.k=[],w}pushDiff(w){switch(w.op){case 2:{for(const m of this.k)if(m.op===2&&m.uri===w.uri){m.docv=w.docv;return}break}case 1:{const m=this.k[this.k.length-1];if(m){if(m.op===1&&m.item.extId===w.item.extId){(0,D.applyTestItemUpdate)(m.item,w.item);return}if(m.op===0&&m.item.item.extId===w.item.extId){(0,D.applyTestItemUpdate)(m.item,w.item);return}}break}}this.k.push(w),this.f.isScheduled()||this.f.schedule()}expand(w,m){const f=this.tree.get(w);if(!!f){if((f.expandLevels===void 0||m>f.expandLevels)&&(f.expandLevels=m),f.expand===1){const b=this.J(f);return b.isOpen()?this.I(f,m-1):b.wait().then(()=>this.I(f,m-1))}else if(f.expand===3)return f.resolveBarrier?.isOpen()===!1?f.resolveBarrier.wait().then(()=>this.I(f,m-1)):this.I(f,m-1)}}dispose(){for(const w of this.tree.values())this.m.getApiFor(w.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(w,m){switch(m.op){case 3:this.M(T.TestId.joinToString(w.fullId,m.id));break;case 0:this.u(m.item,w);break;case 5:for(const f of m.ops)this.p(w,f);break;case 1:this.w(m.new,m.old,w.fullId.toString());break;case 2:this.H(w);break;case 4:this.pushDiff({op:1,item:{extId:w.fullId.toString(),item:m.update}});break;case 6:this.s(w.actual.uri);break;default:(0,A.assertNever)(m)}}s(w){w&&this.pushDiff({op:2,uri:w,docv:this.m.getDocumentVersion(w)})}u(w,m){const f=T.TestId.fromExtHostTestItem(w,this.root.id,m?.actual),b=this.m.getApiFor(w);b.parent&&b.parent!==m?.actual&&this.m.getChildren(b.parent).delete(w.id);let s=this.tree.get(f.toString());if(!s){s={fullId:f,actual:w,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},w.tags.forEach(this.y,this),this.tree.set(s.fullId.toString(),s),this.D(w,m),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:s.expand,item:this.m.toITestItem(w)}}),this.G(w,s,m);return}if(s.actual===w){this.F(w,s,m);return}const o=this.m.getChildren(s.actual),c=s.actual,u=P(this.m.toITestItem(c),this.m.toITestItem(w));this.m.getApiFor(c).listener=void 0,s.actual=w,s.expand=0,u&&(u.hasOwnProperty("tags")&&(this.w(w.tags,c.tags,f.toString()),delete u.tags),this.p(s,{op:4,update:u})),this.G(w,s,m);for(const[r,l]of o)this.m.getChildren(w).get(l.id)||this.M(T.TestId.joinToString(f,l.id));this.s(s.actual.uri)}w(w,m,f){const b=new Set(m.map(s=>s.id));for(const s of w)b.delete(s.id)||this.y(s);this.pushDiff({op:1,item:{extId:f,item:{tags:w.map(s=>(0,D.namespaceTestTag)(this.m.controllerId,s.id))}}}),b.forEach(this.C,this)}y(w){const m=this.j.get(w.id);m?m.refCount++:(this.j.set(w.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,D.namespaceTestTag)(this.m.controllerId,w.id)}}))}C(w){const m=this.j.get(w);m&&!--m.refCount&&(this.j.delete(w),this.pushDiff({op:7,id:(0,D.namespaceTestTag)(this.m.controllerId,w)}))}D(w,m){this.m.getApiFor(w).parent=m&&m.actual!==this.root?m.actual:void 0}F(w,m,f){this.D(w,f);const b=this.m.getApiFor(w);b.parent=f?.actual,b.listener=s=>this.p(m,s),this.H(m)}G(w,m,f){this.F(w,m,f);for(const[b,s]of this.m.getChildren(w))this.u(s,m)}H(w){let m;this.h?w.resolveBarrier?m=w.resolveBarrier.isOpen()?3:2:m=w.actual.canResolveChildren?1:0:m=0,m!==w.expand&&(w.expand=m,this.pushDiff({op:1,item:{extId:w.fullId.toString(),expand:m}}),m===1&&w.expandLevels!==void 0&&this.J(w))}I(w,m){if(m<0)return;const f=[];for(const[b,s]of this.m.getChildren(w.actual)){const o=this.expand(T.TestId.joinToString(w.fullId,s.id),m);(0,a.isThenable)(o)&&f.push(o)}if(f.length)return Promise.all(f).then(()=>{})}J(w){if(w.resolveBarrier)return w.resolveBarrier;if(!this.h){const s=new a.Barrier;return s.open(),s}w.expand=2,this.L(w);const m=w.resolveBarrier=new a.Barrier,f=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,s)};let b;try{b=this.h(w.actual===this.root?void 0:w.actual)}catch(s){f(s)}return(0,a.isThenable)(b)?b.catch(f).then(()=>{m.open(),this.H(w)}):(m.open(),this.H(w)),w.resolveBarrier}L(w){this.pushDiff({op:1,item:{extId:w.fullId.toString(),expand:w.expand}})}M(w){const m=this.tree.get(w);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:w});const f=[m];for(;f.length;){const b=f.pop();if(!!b){this.m.getApiFor(b.actual).listener=void 0;for(const s of b.actual.tags)this.C(s.id);this.tree.delete(b.fullId.toString());for(const[s,o]of this.m.getChildren(b.actual))f.push(this.tree.get(T.TestId.joinToString(b.fullId,o.id)))}}}flushDiff(){const w=this.collectDiff();w.length&&this.g.fire(w)}}e.TestItemCollection=E;class y extends Error{constructor(w){super(`Attempted to insert a duplicate test item ID ${w}`)}}e.DuplicateTestItemError=y;class v extends Error{constructor(w){super(`TestItem with ID "${w}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=v;class d extends Error{constructor(w,m,f){super(`TestItem with ID "${w}" is from controller "${m}" and cannot be added as a child of an item from controller "${f}".`)}}e.MixedTestItemController=d;const g=(h,w,m)=>{let f=new Map;return{get size(){return f.size},forEach(b,s){for(const o of f.values())b.call(s,o,this)},[Symbol.iterator](){return f.entries()},replace(b){const s=new Map,o=new Set(f.keys()),c={op:5,ops:[]};for(const u of b){if(!(u instanceof m))throw new v(u.id);const r=w(u).controllerId;if(r!==h.controllerId)throw new d(u.id,r,h.controllerId);if(s.has(u.id))throw new y(u.id);s.set(u.id,u),o.delete(u.id),c.ops.push({op:0,item:u})}for(const u of o.keys())c.ops.push({op:3,id:u});h.listener?.(c),f=s},add(b){if(!(b instanceof m))throw new v(b.id);f.set(b.id,b),h.listener?.({op:0,item:b})},delete(b){f.delete(b)&&h.listener?.({op:3,id:b})},get(b){return f.get(b)},toJSON(){return Array.from(f.values())}}};e.createTestItemChildren=g}),define(Se[132],ye([1,0,91]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,k=(D,T)=>{const S={controllerId:T};return t.set(D,S),S};e.createPrivateApiFor=k;const A=D=>{const T=t.get(D);if(!T)throw new a.InvalidTestItemError(D?.id||"<unknown>");return T};e.getPrivateApiFor=A}),define(Se[92],ye([1,0,15,2]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function k(T,S){return T.scheme===a.Schemas.http||T.scheme===a.Schemas.https?T:(S&&S.authority&&S.isRemote&&T.scheme===a.Schemas.file&&(T=t.URI.from({scheme:a.Schemas.vscodeRemote,authority:S.authority,path:T.path})),t.URI.from({scheme:a.Schemas.https,authority:`${T.scheme}+${A(T.authority)}.${e.webviewRootResourceAuthority}`,path:T.path,fragment:T.fragment,query:T.query}))}e.asWebviewUri=k;function A(T){return T.replace(/./g,S=>{const C=S.charCodeAt(0);return C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57?S:"-"+C.toString(16).padStart(4,"0")})}function D(T){return T.replace(/-([0-9a-f]{4})/g,(S,C)=>String.fromCharCode(parseInt(C,16)))}e.decodeAuthority=D}),define(Se[223],ye([1,0,4,6,92]),function(te,e,a,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(T,S,C){this.d=T,this.e=S,this.f=C,this.a=0,this.b=new t.DisposableStore,this.c=new Map,this.b.add(S.onDidChangeVisibleTextEditors(()=>{const R=S.getVisibleTextEditors();for(const P of this.c.values())R.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this.c.forEach(T=>T.inset.dispose()),this.b.dispose()}createWebviewEditorInset(T,S,C,R,P){let E;for(const m of this.e.getVisibleTextEditors(!0))if(m.value===T){E=m;break}if(!E)throw new Error("not a visible editor");const y=this,v=this.a++,d=new a.Emitter,g=new a.Emitter,h=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(m){return(0,k.asWebviewUri)(m,y.f)}get cspSource(){return k.webviewGenericCspSource}set options(m){this.b=m,y.d.$setOptions(v,m)}get options(){return this.b}set html(m){this.a=m,y.d.$setHtml(v,m)}get html(){return this.a}get onDidReceiveMessage(){return d.event}postMessage(m){return y.d.$postMessage(v,m)}},w=new class{constructor(){this.editor=T,this.line=S,this.height=C,this.webview=h,this.onDidDispose=g.event}dispose(){y.c.has(v)&&(y.c.delete(v),y.d.$disposeEditorInset(v),g.fire(),g.dispose(),d.dispose())}};return this.d.$createEditorInset(v,E.id,E.value.document.uri,S+1,C,R||{},P.identifier,P.extensionLocation),this.c.set(v,{editor:T,inset:w,onDidReceiveMessage:d}),w}$onDidDispose(T){const S=this.c.get(T);S&&S.inset.dispose()}$onDidReceiveMessage(T,S){this.c.get(T)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=A}),define(Se[224],ye([1,0,3]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,a.createDecorator)("configurationResolverService");var t;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class k extends Error{constructor(D,T){super(T),this.variable=D}}e.VariableError=k}),define(Se[225],ye([1,0,9,36,11,23,12,111,188,224,8]),function(te,e,a,t,k,A,D,T,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(y,v,d,g){this.g=new Map,this.a=y,this.b=v,this.d=d,g&&(this.c=g.then(h=>this.h(h)))}h(y){if(D.isWindows){const v=Object.create(null);return Object.keys(y).forEach(d=>{v[d.toLowerCase()]=y[d]}),v}return y}resolveWithEnvironment(y,v,d){return this.j({env:this.h(y),userHome:void 0},v?v.uri:void 0,d)}async resolveAsync(y,v){const d={env:await this.c,userHome:await this.d};return this.j(d,y?y.uri:void 0,v)}async i(y,v,d,g){const h=A.deepClone(v);D.isWindows&&h.windows?Object.keys(h.windows).forEach(m=>h[m]=h.windows[m]):D.isMacintosh&&h.osx?Object.keys(h.osx).forEach(m=>h[m]=h.osx[m]):D.isLinux&&h.linux&&Object.keys(h.linux).forEach(m=>h[m]=h.linux[m]),delete h.windows,delete h.osx,delete h.linux;const w={env:await this.c,userHome:await this.d};return this.j(w,y?y.uri:void 0,h,d,g)}async resolveAnyAsync(y,v,d){return this.i(y,v,d)}async resolveAnyMap(y,v,d){const g=new Map;return{newConfig:await this.i(y,v,d,g),resolvedVariables:g}}resolveWithInteractionReplace(y,v,d,g){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,v,d,g){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,v){if(this.g.has(y))throw new Error("Variable "+y+" is contributed twice.");this.g.set(y,v)}async j(y,v,d,g,h){if(k.isString(d))return this.l(y,v,d,g,h);if(Array.isArray(d))return Promise.all(d.map(w=>this.j(y,v,w,g,h)));if(k.isObject(d)){const w=Object.create(null),m=await Promise.all(Object.keys(d).map(async f=>[await this.l(y,v,f,g,h),await this.j(y,v,d[f],g,h)]));for(const[f,b]of m)w[f]=b;return w}return d}l(y,v,d,g,h){return(0,R.replaceAsync)(d,P.VARIABLE_REGEXP,async(w,m)=>{if(m.includes(P.VARIABLE_LHS))return w;let f=await this.n(y,w,m,v,g);return h?.set(m,f),f!==w&&k.isString(f)&&f.match(P.VARIABLE_REGEXP)&&(f=await this.l(y,v,f,g,h)),f})}m(y){return this.b?this.b.getUriLabel(y,{noPrefix:!0}):y.fsPath}async n(y,v,d,g,h){let w;const m=d.split(":");m.length>1&&(d=m[0],w=m[1]);const f=o=>{const c=this.a.getFilePath();if(c)return c;throw new C.VariableError(o,(0,S.localize)(0,null,v))},b=o=>{const c=f(o);if(this.a.getWorkspaceFolderPathForFile){const u=this.a.getWorkspaceFolderPathForFile();if(u)return u}throw new C.VariableError(o,(0,S.localize)(1,null,v,a.basename(c)))},s=o=>{if(w){const c=this.a.getFolderUri(w);if(c)return c;throw new C.VariableError(o,(0,S.localize)(2,null,v,w))}if(g)return g;throw this.a.getWorkspaceFolderCount()>1?new C.VariableError(o,(0,S.localize)(3,null,v)):new C.VariableError(o,(0,S.localize)(4,null,v))};switch(d){case"env":if(w){if(y.env){const o=y.env[D.isWindows?w.toLowerCase():w];if(k.isString(o))return o}return""}throw new C.VariableError(C.VariableKind.Env,(0,S.localize)(5,null,v));case"config":if(w){const o=this.a.getConfigurationValue(g,w);if(k.isUndefinedOrNull(o))throw new C.VariableError(C.VariableKind.Config,(0,S.localize)(6,null,v,w));if(k.isObject(o))throw new C.VariableError(C.VariableKind.Config,(0,S.localize)(7,null,v,w));return o}throw new C.VariableError(C.VariableKind.Config,(0,S.localize)(8,null,v));case"command":return this.o(C.VariableKind.Command,v,w,h,"command");case"input":return this.o(C.VariableKind.Input,v,w,h,"input");case"extensionInstallFolder":if(w){const o=await this.a.getExtension(w);if(!o)throw new C.VariableError(C.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,v,w));return this.m(o.extensionLocation)}throw new C.VariableError(C.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,v));default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,T.normalizeDriveLetter)(this.m(s(C.VariableKind.WorkspaceFolder)));case"cwd":return g||w?(0,T.normalizeDriveLetter)(this.m(s(C.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return a.basename(this.m(s(C.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(y.userHome)return y.userHome;throw new C.VariableError(C.VariableKind.UserHome,(0,S.localize)(11,null,v))}case"lineNumber":{const o=this.a.getLineNumber();if(o)return o;throw new C.VariableError(C.VariableKind.LineNumber,(0,S.localize)(12,null,v))}case"selectedText":{const o=this.a.getSelectedText();if(o)return o;throw new C.VariableError(C.VariableKind.SelectedText,(0,S.localize)(13,null,v))}case"file":return f(C.VariableKind.File);case"fileWorkspaceFolder":return b(C.VariableKind.FileWorkspaceFolder);case"relativeFile":return g||w?a.relative(this.m(s(C.VariableKind.RelativeFile)),f(C.VariableKind.RelativeFile)):f(C.VariableKind.RelativeFile);case"relativeFileDirname":{const o=a.dirname(f(C.VariableKind.RelativeFileDirname));if(g||w){const c=a.relative(this.m(s(C.VariableKind.RelativeFileDirname)),o);return c.length===0?".":c}return o}case"fileDirname":return a.dirname(f(C.VariableKind.FileDirname));case"fileExtname":return a.extname(f(C.VariableKind.FileExtname));case"fileBasename":return a.basename(f(C.VariableKind.FileBasename));case"fileBasenameNoExtension":{const o=a.basename(f(C.VariableKind.FileBasenameNoExtension));return o.slice(0,o.length-a.extname(o).length)}case"fileDirnameBasename":return a.basename(a.dirname(f(C.VariableKind.FileDirnameBasename)));case"execPath":{const o=this.a.getExecPath();return o||v}case"execInstallFolder":{const o=this.a.getAppRoot();return o||v}case"pathSeparator":return a.sep;default:try{const o=w?`${d}:${w}`:d;return this.o(C.VariableKind.Unknown,v,o,h,void 0)}catch{return v}}}}o(y,v,d,g,h){if(d&&g){const w=h===void 0?g[d]:g[h+":"+d];if(typeof w=="string")return w;throw new C.VariableError(y,(0,S.localize)(14,null,v))}return v}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Se[133],ye([1,0,3,130]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,a.createDecorator)("editorGroupsService");var k;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(k=e.GroupDirection||(e.GroupDirection={}));var A;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var D;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(D=e.GroupLocation||(e.GroupLocation={}));var T;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EVEN=1]="EVEN",v[v.TOGGLE=2]="TOGGLE"})(T=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function C(v){const d=v;return(0,t.isEditorInput)(d?.editor)&&(0,t.isEditorInput)(d?.replacement)}e.isEditorReplacement=C;var R;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var P;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(P=e.OpenEditorContext||(e.OpenEditorContext={}));function E(v){const d=v;return!!d&&typeof d.id=="number"&&Array.isArray(d.editors)}e.isEditorGroup=E;function y(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=y}),define(Se[226],ye([1,0,3,133]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,a.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function k(A){const D=A;return typeof A=="number"||(0,t.isEditorGroup)(D)}e.isPreferredGroup=k}),define(Se[227],ye([1,0,3,194]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,a.refineServiceDecorator)(t.IEnvironmentService)}),define(Se[228],ye([1,0,27,4,9]),function(te,e,a,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(P){this.removedDueToLooping=P}}e.DeltaExtensionsResult=A;class D{constructor(P){this.c=new t.Emitter,this.onDidChange=this.c.event,this.d=P,this.h()}h(){this.d.sort(S),this.e=new Map,this.f=[],this.g=new Map;for(const P of this.d){if(this.e.has(a.ExtensionIdentifier.toKey(P.identifier))){console.error("Extension `"+P.identifier.value+"` is already registered");continue}if(this.e.set(a.ExtensionIdentifier.toKey(P.identifier),P),this.f.push(P),Array.isArray(P.activationEvents))for(let E of P.activationEvents)E==="onUri"&&(E=`onUri:${a.ExtensionIdentifier.toKey(P.identifier)}`),this.g.has(E)||this.g.set(E,[]),this.g.get(E).push(P)}}set(P){this.d=P,this.h(),this.c.fire(void 0)}deltaExtensions(P,E){this.d=C(this.d,E),this.d=this.d.concat(P);const y=D.j(this.d);return this.d=C(this.d,y.map(v=>v.identifier)),this.h(),this.c.fire(void 0),new A(y)}static j(P){const E=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(h){this.d.has(h)||(this.d.add(h),this.e.push(h))}addArc(h,w){this.addNode(h),this.addNode(w),this.c.has(h)?this.c.get(h).push(w):this.c.set(h,[w])}getArcs(h){return this.c.has(h)?this.c.get(h):[]}hasOnlyGoodArcs(h,w){const m=E.getArcs(h);for(let f=0;f<m.length;f++)if(!w.has(m[f]))return!1;return!0}getNodes(){return this.e}},y=new Map;for(const h of P){const w=a.ExtensionIdentifier.toKey(h.identifier);if(y.set(w,h),h.extensionDependencies)for(const m of h.extensionDependencies){const f=a.ExtensionIdentifier.toKey(m);E.addArc(w,f)}}const v=new Set;E.getNodes().filter(h=>E.getArcs(h).length===0).forEach(h=>v.add(h));const d=E.getNodes().filter(h=>!v.has(h));let g;do{g=!1;for(let h=0;h<d.length;h++){const w=d[h];E.hasOnlyGoodArcs(w,v)&&(d.splice(h,1),h--,v.add(w),g=!0)}}while(g);return d.map(h=>y.get(h))}containsActivationEvent(P){return this.g.has(P)}containsExtension(P){return this.e.has(a.ExtensionIdentifier.toKey(P))}getExtensionDescriptionsForActivationEvent(P){const E=this.g.get(P);return E?E.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(P){const E=this.e.get(a.ExtensionIdentifier.toKey(P));return E||void 0}getExtensionDescriptionByUUID(P){for(const E of this.f)if(E.uuid===P)return E}getExtensionDescriptionByIdOrUUID(P,E){return this.getExtensionDescription(P)??(E?this.getExtensionDescriptionByUUID(E):void 0)}}e.ExtensionDescriptionRegistry=D;var T;(function(R){R[R.Builtin=0]="Builtin",R[R.User=1]="User",R[R.Dev=2]="Dev"})(T||(T={}));function S(R,P){const E=R.isBuiltin?0:R.isUnderDevelopment?2:1,y=P.isBuiltin?0:P.isUnderDevelopment?2:1;if(E!==y)return E-y;const v=k.posix.basename(R.extensionLocation.path),d=k.posix.basename(P.extensionLocation.path);return v<d?-1:v>d?1:0}function C(R,P){const E=new Set;return P.forEach(y=>E.add(a.ExtensionIdentifier.toKey(y))),R.filter(y=>!E.has(a.ExtensionIdentifier.toKey(y.identifier)))}}),define(Se[229],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var a;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(a=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(P){this.pipeName=P,this.type=1}serialize(P){P[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class k{constructor(){this.type=2}serialize(P){P[k.ENV_KEY]="1"}}e.SocketExtHostConnection=k,k.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class A{constructor(){this.type=3}serialize(P){P[A.ENV_KEY]="1"}}e.MessagePortExtHostConnection=A,A.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function D(R){delete R[t.ENV_KEY],delete R[k.ENV_KEY],delete R[A.ENV_KEY]}function T(R,P){D(P),R.serialize(P)}e.writeExtHostConnection=T;function S(R){if(R[t.ENV_KEY])return C(R,new t(R[t.ENV_KEY]));if(R[k.ENV_KEY])return C(R,new k);if(R[A.ENV_KEY])return C(R,new A);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=S;function C(R,P){return D(R),P}}),define(Se[93],ye([1,0,22]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var t;(function(C){C[C.Desktop=1]="Desktop",C[C.Web=2]="Web"})(t=e.UIKind||(e.UIKind={}));var k;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(k=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var A;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(A=e.MessageType||(e.MessageType={}));function D(C){const R=a.VSBuffer.alloc(1);switch(C){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=D;function T(C,R){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=T;var S;(function(C){C.Start="START_NATIVE_LOG",C.End="END_NATIVE_LOG"})(S=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Se[94],ye([1,0,3,4,13,25,93,88,128,23,2]),function(te,e,a,t,k,A,D,T,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let P=class{constructor(d,g){this.i=d,this.a=new t.Emitter,this.onDidChangeTelemetryEnabled=this.a.event,this.b=new t.Emitter,this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.d=0,this.f=!1,this.h=new Map,this.g=g.createLogger(R.URI.revive(this.i.environment.extensionTelemetryLogResource)),this.g.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.g.info("===========================================================")}getTelemetryConfiguration(){return this.d===3}getTelemetryDetails(){return{isCrashEnabled:this.d>=1,isErrorsEnabled:this.c.error?this.d>=2:!1,isUsageEnabled:this.c.usage?this.d>=3:!1}}instantiateLogger(d,g){const h=this.getTelemetryDetails(),w=new E(g,d,this.g,this.f,this.getBuiltInCommonProperties(d),{isUsageEnabled:h.isUsageEnabled,isErrorsEnabled:h.isErrorsEnabled});return this.h.set(d.identifier.value,w),w.apiTelemetryLogger}$initializeTelemetryLevel(d,g,h){this.d=d,this.f=g,this.c=h??{usage:!0,error:!0}}getBuiltInCommonProperties(d){const g={};switch(g["common.extname"]=d.name,g["common.extversion"]=d.version,g["common.vscodemachineid"]=this.i.telemetryInfo.machineId,g["common.vscodesessionid"]=this.i.telemetryInfo.sessionId,g["common.vscodeversion"]=this.i.version,g["common.isnewappinstall"]=y(this.i.telemetryInfo.firstSessionDate),g["common.product"]=this.i.environment.appHost,this.i.uiKind){case D.UIKind.Web:g["common.uikind"]="web";break;case D.UIKind.Desktop:g["common.uikind"]="desktop";break;default:g["common.uikind"]="unknown"}return g["common.remotename"]=(0,T.getRemoteName)((0,S.cleanRemoteAuthority)(this.i.remote.authority)),g}$onDidChangeTelemetryLevel(d){this.e=this.getTelemetryConfiguration(),this.d=d;const g=this.getTelemetryDetails();this.h.forEach(h=>{h.updateTelemetryEnablements(g.isUsageEnabled,g.isErrorsEnabled)}),this.e!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails())}onExtensionError(d,g){const h=this.h.get(d.value);return h?(h.logError(g),!0):!1}};P=Ve([We(0,A.IExtHostInitDataService),We(1,k.ILoggerService)],P),e.ExtHostTelemetry=P;class E{constructor(d,g,h,w,m,f){this.e=g,this.f=h,this.g=w,this.h=m,this.b=new t.Emitter,this.a=d,this.c={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(d,g){this.d&&(this.c={isUsageEnabled:d,isErrorsEnabled:g},this.b.fire(this.d))}mixInCommonPropsAndCleanData(d){let g=d.properties??d;return g=(0,S.cleanData)(g,[]),this.a.additionalCommonProperties&&(g=(0,C.mixin)(g,this.a.additionalCommonProperties)),this.a.ignoreBuiltInCommonProperties||(g=(0,C.mixin)(g,this.h)),d.properties?d.properties=g:d=g,d}i(d,g){this.e.publisher==="vscode"?d=this.e.name+"/"+d:d=this.e.identifier.value+"/"+d,g=this.mixInCommonPropsAndCleanData(g||{}),this.g||this.a.logEvent(d,g),this.f.trace(d,g)}logUsage(d,g){!this.c.isUsageEnabled||this.i(d,g)}logError(d,g){!this.c.isErrorsEnabled||(typeof d=="string"?this.i(d,g):this.a.logException(d,g))}get apiTelemetryLogger(){if(!this.d){const d=this,g={logUsage:d.logUsage.bind(d),get isUsageEnabled(){return d.c.isUsageEnabled},get isErrorsEnabled(){return d.c.isErrorsEnabled},logError:d.logError.bind(d),dispose:d.dispose.bind(d),onDidChangeEnableStates:d.b.event.bind(d)};this.d=Object.freeze(g)}return this.d}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=E;function y(v){const d=Date.now()-new Date(v).getTime();return isNaN(d)?!1:d<1e3*60*60*24}e.isNewAppInstall=y,e.IExtHostTelemetry=(0,a.createDecorator)("IExtHostTelemetry")}),define(Se[26],ye([1,0,4,2,3,27,203]),function(te,e,a,t,k,A,D){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,k.createDecorator)("extensionService");class S{constructor(l){this.affinity=l,this.kind=1}equals(l){return this.kind===l.kind&&this.affinity===l.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=S;class C{constructor(l){this.affinity=l,this.kind=2}equals(l){return this.kind===l.kind&&this.affinity===l.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=C;class R{constructor(){this.kind=3,this.affinity=0}equals(l){return this.kind===l.kind}asString(){return"Remote"}}e.RemoteRunningLocation=R;class P{constructor(l){this.dependency=l}}e.MissingExtensionDependency=P;var E;(function(r){r[r.LocalProcess=1]="LocalProcess",r[r.LocalWebWorker=2]="LocalWebWorker",r[r.Remote=3]="Remote"})(E=e.ExtensionHostKind||(e.ExtensionHostKind={}));function y(r){if(r===null)return"None";switch(r){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=y;class v{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(l,n){const i=[],p=[],I=[],L=[],U=h(this.c),G=h(l),V=($,M)=>$.extensionLocation.toString()===M.extensionLocation.toString()||$.isBuiltin===M.isBuiltin||$.isUserBuiltin===M.isUserBuiltin||$.isUnderDevelopment===M.isUnderDevelopment;for(const $ of this.c){const M=G.get(A.ExtensionIdentifier.toKey($.identifier));if(!M){i.push($.identifier),U.delete(A.ExtensionIdentifier.toKey($.identifier));continue}if(!V($,M)){i.push($.identifier),U.delete(A.ExtensionIdentifier.toKey($.identifier));continue}}for(const $ of l){const M=U.get(A.ExtensionIdentifier.toKey($.identifier));if(!M){p.push($);continue}if(!V(M,$)){i.push(M.identifier),U.delete(A.ExtensionIdentifier.toKey(M.identifier));continue}}const O=g(this.d),B=g(n);for(const $ of this.d)B.has(A.ExtensionIdentifier.toKey($))||I.push($);for(const $ of n)O.has(A.ExtensionIdentifier.toKey($))||L.push($);const F={toRemove:i,toAdd:p,myToRemove:I,myToAdd:L};return this.delta(F),F}delta(l){const{toRemove:n,toAdd:i,myToRemove:p,myToAdd:I}=l,L=g(n),U=g(p);for(let G=0;G<this.c.length;G++)L.has(A.ExtensionIdentifier.toKey(this.c[G].identifier))&&(this.c.splice(G,1),G--);for(let G=0;G<this.d.length;G++)U.has(A.ExtensionIdentifier.toKey(this.d[G]))&&(this.d.splice(G,1),G--);for(const G of i)this.c.push(G);for(const G of I)this.d.push(G)}containsExtension(l){for(const n of this.d)if(A.ExtensionIdentifier.equals(n,l))return!0;return!1}}e.ExtensionHostExtensions=v;class d{constructor(l){if(this[T]="ExtensionIdentifierSet",this.c=new Map,this.d=A.ExtensionIdentifier.toKey,l)for(const n of l)this.add(n)}get size(){return this.c.size}add(l){return this.c.set(this.d(l),l),this}clear(){this.c.clear()}delete(l){return this.c.delete(this.d(l))}has(l){return this.c.has(this.d(l))}forEach(l,n){this.c.forEach(i=>l.call(n,i,i,this))}*entries(){for(const[l,n]of this.c)yield[n,n]}keys(){return this.c.values()}values(){return this.c.values()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=d;function g(r){const l=new Set;for(const n of r)l.add(A.ExtensionIdentifier.toKey(n));return l}e.extensionIdentifiersArrayToSet=g;function h(r){const l=new Map;for(const n of r)l.set(A.ExtensionIdentifier.toKey(n.identifier),n);return l}function w(r,l){return r.enabledApiProposals?r.enabledApiProposals.includes(l):!1}e.isProposedApiEnabled=w;function m(r,l){if(!w(r,l))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${l}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${l}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.checkProposedApiEnabled=m;class f{constructor(l,n,i,p){this.codeLoadingTime=l,this.activateCallTime=n,this.activateResolvedTime=i,this.activationReason=p}}e.ActivationTimes=f;class b{constructor(l,n){this.description=l,this.value=n}}e.ExtensionPointContribution=b,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var s;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(s=e.ActivationKind||(e.ActivationKind={}));function o(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,D.getGalleryExtensionId)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}e.toExtension=o;function c(r,l){return{identifier:new A.ExtensionIdentifier((0,D.getExtensionId)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!l,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform,browserNlsBundleUris:r.browserNlsBundleUris}}e.toExtensionDescription=c;class u{constructor(){this.onDidRegisterExtensions=a.Event.None,this.onDidChangeExtensionsStatus=a.Event.None,this.onDidChangeExtensions=a.Event.None,this.onWillActivateByEvent=a.Event.None,this.onDidChangeResponsiveChange=a.Event.None,this.extensions=[]}activateByEvent(l){return Promise.resolve(void 0)}activationEventIsDone(l){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(l,n){return Promise.resolve(0)}getInspectPorts(l,n){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=u}),define(Se[230],ye([1,0,10,27,26,13,18]),function(te,e,a,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class T{constructor(g,h,w,m){this.startup=g,this.codeLoadingTime=h,this.activateCallTime=w,this.activateResolvedTime=m}}e.ExtensionActivationTimes=T,T.NONE=new T(!1,-1,-1,-1);class S{constructor(g){this.a=g,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(g,h){return g===-1||h===-1?-1:h-g}build(){return new T(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=S;class C{constructor(g,h,w,m,f,b){this.activationFailed=g,this.activationFailedError=h,this.activationTimes=w,this.module=m,this.exports=f,this.subscriptions=b}}e.ActivatedExtension=C;class R extends C{constructor(g){super(!1,null,g,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class P extends C{constructor(){super(!1,null,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=P;class E extends C{constructor(g){super(!0,g,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let y=class{constructor(g,h,w,m,f){this.h=f,this.a=g,this.b=new Set,h.forEach(b=>this.b.add(t.ExtensionIdentifier.toKey(b))),this.c=new Map,w.forEach(b=>this.c.set(t.ExtensionIdentifier.toKey(b),b)),this.d=m,this.f=new Map,this.g=Object.create(null)}dispose(){for(const[g,h]of this.f)h.dispose()}isActivated(g){const h=this.f.get(t.ExtensionIdentifier.toKey(g));return Boolean(h&&h.value)}getActivatedExtension(g){const h=this.f.get(t.ExtensionIdentifier.toKey(g));if(!h||!h.value)throw new Error(`Extension '${g.value}' is not known or not activated`);return h.value}async activateByEvent(g,h){if(this.g[g])return;const w=this.a.getExtensionDescriptionsForActivationEvent(g);await this.j(w.map(m=>({id:m.identifier,reason:{startup:h,extensionId:m.identifier,activationEvent:g}}))),this.g[g]=!0}activateById(g,h){const w=this.a.getExtensionDescription(g);if(!w)throw new Error(`Extension '${g}' is not known`);return this.j([{id:w.identifier,reason:h}])}async j(g){const h=g.filter(w=>!this.isActivated(w.id)).map(w=>this.k(w));await Promise.all(h.map(w=>w.wait()))}k(g){if(this.f.has(t.ExtensionIdentifier.toKey(g.id)))return this.f.get(t.ExtensionIdentifier.toKey(g.id));if(this.c.has(t.ExtensionIdentifier.toKey(g.id)))return this.l(g,null,[],null);const h=this.a.getExtensionDescription(g.id);if(!h){const f=new Error(`Cannot activate unknown extension '${g.id.value}'`),b=this.l(g,null,[],new E(f));return this.d.onExtensionActivationError(g.id,f,new k.MissingExtensionDependency(g.id.value)),b}const w=[],m=typeof h.extensionDependencies>"u"?[]:h.extensionDependencies;for(const f of m){if(this.b.has(t.ExtensionIdentifier.toKey(f)))continue;const b=this.f.get(t.ExtensionIdentifier.toKey(f));if(b){w.push(b);continue}if(this.c.has(t.ExtensionIdentifier.toKey(f))){w.push(this.k({id:this.c.get(t.ExtensionIdentifier.toKey(f)),reason:g.reason}));continue}const s=this.a.getExtensionDescription(f);if(s){if(!s.main&&!s.browser)continue;w.push(this.k({id:s.identifier,reason:g.reason}));continue}const o=h.displayName||h.identifier.value,c=new Error(`Cannot activate the '${o}' extension because it depends on unknown extension '${f}'`),u=this.l(g,h.displayName,[],new E(c));return this.d.onExtensionActivationError(h.identifier,c,new k.MissingExtensionDependency(f)),u}return this.l(g,h.displayName,w,null)}l(g,h,w,m){const f=new v(g.id,h,g.reason,w,m,this.d,this.h);return this.f.set(t.ExtensionIdentifier.toKey(g.id),f),f}};y=Ve([We(4,A.ILogService)],y),e.ExtensionsActivator=y;let v=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(g,h,w,m,f,b,s){this.c=g,this.d=h,this.f=w,this.g=m,this.h=f,this.j=b,this.k=s,this.a=new D.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let g=0;g<this.g.length;g++){const h=this.g[g];if(h.value&&!h.value.activationFailed){this.g.splice(g,1),g--;continue}if(h.value&&h.value.activationFailed){const w=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${h.friendlyName}' failed to activate`);w.detail=h.value.activationFailedError,this.h=new E(w),this.j.onExtensionActivationError(this.c,w,null);return}}this.g.length>0&&await Promise.race(this.g.map(g=>g.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(g){const h=new Error;if(g&&g.name&&(h.name=g.name),g&&g.message?h.message=`Activating extension '${this.c.value}' failed: ${g.message}.`:h.message=`Activating extension '${this.c.value}' failed: ${g}.`,g&&g.stack&&(h.stack=g.stack),this.h=new E(h),this.b&&a.isCancellationError(g))return;this.j.onExtensionActivationError(this.c,h,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(g)}}};v=Ve([We(6,A.ILogService)],v)}),define(Se[231],ye([1,0,13,25,26]),function(te,e,a,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends a.LogService{constructor(T,S){super(T.createLogger(S.logFile,{name:k.ExtensionHostLogFileName}))}};A=Ve([We(0,a.ILoggerService),We(1,t.IExtHostInitDataService)],A),e.ExtHostLogService=A});var Je=this&&this.__classPrivateFieldSet||function(te,e,a,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,a):k?k.value=a:e.set(te,a),a},Fe=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)};define(Se[7],ye([1,0,17,10,110,28,82,8,11,2,30,38,127,90,26]),function(te,e,a,t,k,A,D,T,S,C,R,P,E,y,v){"use strict";var d,g,h,w,m,f,b,s,o,c,u,r,l,n,i,p,I,L,U,G,V,O,B;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function F(x){return Object.assign(x,{apply:function(){const he=arguments.length===1?[]:arguments[1];return Reflect.construct(x,he,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(x,[]);{const[he,...Te]=arguments;return Reflect.construct(x,Te,he.constructor)}}})}let $=f=class{static from(...j){let he=j;return new f(function(){if(he){for(const Te of he)Te&&typeof Te.dispose=="function"&&Te.dispose();he=void 0}})}constructor(j){d.set(this,void 0),Je(this,d,j,"f")}dispose(){typeof Fe(this,d,"f")=="function"&&(Fe(this,d,"f").call(this),Je(this,d,void 0,"f"))}};d=new WeakMap,$=f=Ve([F],$),e.Disposable=$;let M=b=class{static Min(...j){if(j.length===0)throw new TypeError;let he=j[0];for(let Te=1;Te<j.length;Te++){const Ke=j[Te];Ke.isBefore(he)&&(he=Ke)}return he}static Max(...j){if(j.length===0)throw new TypeError;let he=j[0];for(let Te=1;Te<j.length;Te++){const Ke=j[Te];Ke.isAfter(he)&&(he=Ke)}return he}static isPosition(j){if(!j)return!1;if(j instanceof b)return!0;const{line:he,character:Te}=j;return typeof he=="number"&&typeof Te=="number"}static of(j){if(j instanceof b)return j;if(this.isPosition(j))return new b(j.line,j.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(j,he){if(j<0)throw(0,t.illegalArgument)("line must be non-negative");if(he<0)throw(0,t.illegalArgument)("character must be non-negative");this.c=j,this.e=he}isBefore(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<j.e}isBeforeOrEqual(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<=j.e}isAfter(j){return!this.isBeforeOrEqual(j)}isAfterOrEqual(j){return!this.isBefore(j)}isEqual(j){return this.c===j.c&&this.e===j.e}compareTo(j){return this.c<j.c?-1:this.c>j.line?1:this.e<j.e?-1:this.e>j.e?1:0}translate(j,he=0){if(j===null||he===null)throw(0,t.illegalArgument)();let Te;return typeof j>"u"?Te=0:typeof j=="number"?Te=j:(Te=typeof j.lineDelta=="number"?j.lineDelta:0,he=typeof j.characterDelta=="number"?j.characterDelta:0),Te===0&&he===0?this:new b(this.line+Te,this.character+he)}with(j,he=this.character){if(j===null||he===null)throw(0,t.illegalArgument)();let Te;return typeof j>"u"?Te=this.line:typeof j=="number"?Te=j:(Te=typeof j.line=="number"?j.line:this.line,he=typeof j.character=="number"?j.character:this.character),Te===this.line&&he===this.character?this:new b(Te,he)}toJSON(){return{line:this.line,character:this.character}}};M=b=Ve([F],M),e.Position=M;let H=s=class{static isRange(j){return j instanceof s?!0:j?M.isPosition(j.start)&&M.isPosition(j.end):!1}static of(j){if(j instanceof s)return j;if(this.isRange(j))return new s(j.start,j.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(j,he,Te,Ke){let Ye,ct;if(typeof j=="number"&&typeof he=="number"&&typeof Te=="number"&&typeof Ke=="number"?(Ye=new M(j,he),ct=new M(Te,Ke)):M.isPosition(j)&&M.isPosition(he)&&(Ye=M.of(j),ct=M.of(he)),!Ye||!ct)throw new Error("Invalid arguments");Ye.isBefore(ct)?(this.c=Ye,this.e=ct):(this.c=ct,this.e=Ye)}contains(j){return s.isRange(j)?this.contains(j.start)&&this.contains(j.end):M.isPosition(j)?!(M.of(j).isBefore(this.c)||this.e.isBefore(j)):!1}isEqual(j){return this.c.isEqual(j.c)&&this.e.isEqual(j.e)}intersection(j){const he=M.Max(j.start,this.c),Te=M.Min(j.end,this.e);if(!he.isAfter(Te))return new s(he,Te)}union(j){if(this.contains(j))return this;if(j.contains(this))return j;const he=M.Min(j.start,this.c),Te=M.Max(j.end,this.end);return new s(he,Te)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(j,he=this.end){if(j===null||he===null)throw(0,t.illegalArgument)();let Te;return j?M.isPosition(j)?Te=j:(Te=j.start||this.start,he=j.end||this.end):Te=this.start,Te.isEqual(this.c)&&he.isEqual(this.end)?this:new s(Te,he)}toJSON(){return[this.start,this.end]}};H=s=Ve([F],H),e.Range=H;let K=o=class extends H{static isSelection(j){return j instanceof o?!0:j?H.isRange(j)&&M.isPosition(j.anchor)&&M.isPosition(j.active)&&typeof j.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(j,he,Te,Ke){let Ye,ct;if(typeof j=="number"&&typeof he=="number"&&typeof Te=="number"&&typeof Ke=="number"?(Ye=new M(j,he),ct=new M(Te,Ke)):M.isPosition(j)&&M.isPosition(he)&&(Ye=M.of(j),ct=M.of(he)),!Ye||!ct)throw new Error("Invalid arguments");super(Ye,ct),this.f=Ye,this.g=ct}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};K=o=Ve([F],K),e.Selection=K;class q{constructor(j,he,Te){if(typeof j!="string"||j.length===0)throw(0,t.illegalArgument)("host");if(typeof he!="number"||he===0||Math.round(he)!==he)throw(0,t.illegalArgument)("port");if(typeof Te<"u"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z\-]+$/.test(Te)))throw(0,t.illegalArgument)("connectionToken");this.host=j,this.port=Math.round(he),this.connectionToken=Te}}e.ResolvedAuthority=q;class Y extends Error{static NotAvailable(j,he){return new Y(j,E.RemoteAuthorityResolverErrorCode.NotAvailable,he)}static TemporarilyNotAvailable(j){return new Y(j,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(j,he=E.RemoteAuthorityResolverErrorCode.Unknown,Te){super(j),this._message=j,this._code=he,this._detail=Te,Object.setPrototypeOf(this,Y.prototype)}}e.RemoteAuthorityResolverError=Y;var Q;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(Q=e.EndOfLine||(e.EndOfLine={}));var ce;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(ce=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ie=c=class{static isTextEdit(j){return j instanceof c?!0:j?H.isRange(j)&&typeof j.newText=="string":!1}static replace(j,he){return new c(j,he)}static insert(j,he){return c.replace(new H(j,j),he)}static delete(j){return c.replace(j,"")}static setEndOfLine(j){const he=new c(new H(new M(0,0),new M(0,0)),"");return he.newEol=j,he}get range(){return this.c}set range(j){if(j&&!H.isRange(j))throw(0,t.illegalArgument)("range");this.c=j}get newText(){return this.e||""}set newText(j){if(j&&typeof j!="string")throw(0,t.illegalArgument)("newText");this.e=j}get newEol(){return this.f}set newEol(j){if(j&&typeof j!="number")throw(0,t.illegalArgument)("newEol");this.f=j}constructor(j,he){this.c=j,this.e=he}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};ie=c=Ve([F],ie),e.TextEdit=ie;let de=u=class{static isNotebookCellEdit(j){return j instanceof u?!0:j?Wt.isNotebookRange(j)&&Array.isArray(j.newCells):!1}static replaceCells(j,he){return new u(j,he)}static insertCells(j,he){return new u(new Wt(j,j),he)}static deleteCells(j){return new u(j,[])}static updateCellMetadata(j,he){const Te=new u(new Wt(j,j),[]);return Te.newCellMetadata=he,Te}static updateNotebookMetadata(j){const he=new u(new Wt(0,0),[]);return he.newNotebookMetadata=j,he}constructor(j,he){this.range=j,this.newCells=he}};de=u=Ve([F],de),e.NotebookEdit=de;class J{static isSnippetTextEdit(j){return j instanceof J?!0:j?H.isRange(j.range)&&De.isSnippetString(j.snippet):!1}static replace(j,he){return new J(j,he)}static insert(j,he){return J.replace(new H(j,j),he)}constructor(j,he){this.range=j,this.snippet=he}}e.SnippetTextEdit=J;var pe;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace",x[x.Snippet=6]="Snippet"})(pe=e.FileEditType||(e.FileEditType={}));let ve=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(j,he,Te,Ke){this.c.push({_type:1,from:j,to:he,options:Te,metadata:Ke})}createFile(j,he,Te){this.c.push({_type:1,from:void 0,to:j,options:he,metadata:Te})}deleteFile(j,he,Te){this.c.push({_type:1,from:j,to:void 0,options:he,metadata:Te})}e(j,he,Te){this.c.push({_type:3,metadata:Te,uri:j,edit:{editType:5,metadata:he},notebookMetadata:he})}f(j,he,Te,Ke){const Ye=he.start,ct=he.end;(Ye!==ct||Te.length>0)&&this.c.push({_type:5,uri:j,index:Ye,count:ct-Ye,cells:Te,metadata:Ke})}g(j,he,Te,Ke){this.c.push({_type:3,metadata:Ke,uri:j,edit:{editType:8,index:he,metadata:Te}})}replace(j,he,Te,Ke){this.c.push({_type:2,uri:j,edit:new ie(he,Te),metadata:Ke})}insert(j,he,Te,Ke){this.replace(j,new H(he,he),Te,Ke)}delete(j,he,Te){this.replace(j,he,"",Te)}has(j){return this.c.some(he=>he._type===2&&he.uri.toString()===j.toString())}set(j,he){if(he)for(const Te of he){if(!Te)continue;let Ke,Ye;Array.isArray(Te)?(Ke=Te[0],Ye=Te[1]):Ke=Te,de.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(j,Ke.range.start,Ke.newCellMetadata,Ye):Ke.newNotebookMetadata?this.e(j,Ke.newNotebookMetadata,Ye):this.f(j,Ke.range,Ke.newCells,Ye):J.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:j,range:Ke.range,edit:Ke.snippet,metadata:Ye}):this.c.push({_type:2,uri:j,edit:Ke,metadata:Ye})}else{for(let Te=0;Te<this.c.length;Te++){const Ke=this.c[Te];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===j.toString()&&(this.c[Te]=void 0);break}}(0,a.coalesceInPlace)(this.c)}}get(j){const he=[];for(const Te of this.c)Te._type===2&&Te.uri.toString()===j.toString()&&he.push(Te.edit);return he}entries(){const j=new A.ResourceMap;for(const he of this.c)if(he._type===2){let Te=j.get(he.uri);Te||(Te=[he.uri,[]],j.set(he.uri,Te)),Te[1].push(he.edit)}return[...j.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};ve=Ve([F],ve),e.WorkspaceEdit=ve;let De=r=class{static isSnippetString(j){return j instanceof r?!0:j?typeof j.value=="string":!1}static c(j){return j.replace(/\$|}|\\/g,"\\$&")}constructor(j){this.e=1,this.value=j||""}appendText(j){return this.value+=r.c(j),this}appendTabstop(j=this.e++){return this.value+="$",this.value+=j,this}appendPlaceholder(j,he=this.e++){if(typeof j=="function"){const Te=new r;Te.e=this.e,j(Te),this.e=Te.e,j=Te.value}else j=r.c(j);return this.value+="${",this.value+=he,this.value+=":",this.value+=j,this.value+="}",this}appendChoice(j,he=this.e++){const Te=j.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=he,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(j,he){if(typeof he=="function"){const Te=new r;Te.e=this.e,he(Te),this.e=Te.e,he=Te.value}else typeof he=="string"&&(he=he.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=j,he&&(this.value+=":",this.value+=he),this.value+="}",this}};De=r=Ve([F],De),e.SnippetString=De;var Re;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(Re=e.DiagnosticTag||(e.DiagnosticTag={}));var $e;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})($e=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let re=l=class{static isLocation(j){return j instanceof l?!0:j?H.isRange(j.range)&&C.URI.isUri(j.uri):!1}constructor(j,he){if(this.uri=j,he)if(H.isRange(he))this.range=H.of(he);else if(M.isPosition(he))this.range=new H(he,he);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};re=l=Ve([F],re),e.Location=re;let le=class{static is(j){return j?typeof j.message=="string"&&j.location&&H.isRange(j.location.range)&&C.URI.isUri(j.location.uri):!1}constructor(j,he){this.location=j,this.message=he}static isEqual(j,he){return j===he?!0:!j||!he?!1:j.message===he.message&&j.location.range.isEqual(he.location.range)&&j.location.uri.toString()===he.location.uri.toString()}};le=Ve([F],le),e.DiagnosticRelatedInformation=le;let fe=class{constructor(j,he,Te=$e.Error){if(!H.isRange(j))throw new TypeError("range must be set");if(!he)throw new TypeError("message must be set");this.range=j,this.message=he,this.severity=Te}toJSON(){return{severity:$e[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(j,he){return j===he?!0:!j||!he?!1:j.message===he.message&&j.severity===he.severity&&j.code===he.code&&j.severity===he.severity&&j.source===he.source&&j.range.isEqual(he.range)&&(0,a.equals)(j.tags,he.tags)&&(0,a.equals)(j.relatedInformation,he.relatedInformation,le.isEqual)}};fe=Ve([F],fe),e.Diagnostic=fe;let Z=class{constructor(j,he){if(!j)throw new Error("Illegal argument, contents must be defined");Array.isArray(j)?this.contents=j:this.contents=[j],this.range=he}};Z=Ve([F],Z),e.Hover=Z;var se;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(se=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ne=class{constructor(j,he=se.Text){this.range=j,this.kind=he}toJSON(){return{range:this.range,kind:se[this.kind]}}};ne=Ve([F],ne),e.DocumentHighlight=ne;var N;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(N=e.SymbolKind||(e.SymbolKind={}));var z;(function(x){x[x.Deprecated=1]="Deprecated"})(z=e.SymbolTag||(e.SymbolTag={}));let X=n=class{static validate(j){if(!j.name)throw new Error("name must not be falsy")}constructor(j,he,Te,Ke,Ye){this.name=j,this.kind=he,this.containerName=Ye,typeof Te=="string"&&(this.containerName=Te),Ke instanceof re?this.location=Ke:Te instanceof H&&(this.location=new re(Ke,Te)),n.validate(this)}toJSON(){return{name:this.name,kind:N[this.kind],location:this.location,containerName:this.containerName}}};X=n=Ve([F],X),e.SymbolInformation=X;let _=i=class{static validate(j){if(!j.name)throw new Error("name must not be falsy");if(!j.range.contains(j.selectionRange))throw new Error("selectionRange must be contained in fullRange");j.children?.forEach(i.validate)}constructor(j,he,Te,Ke,Ye){this.name=j,this.detail=he,this.kind=Te,this.range=Ke,this.selectionRange=Ye,this.children=[],i.validate(this)}};_=i=Ve([F],_),e.DocumentSymbol=_;var ue;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(ue=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let be=class{constructor(j,he){this.title=j,this.kind=he}};be=Ve([F],be),e.CodeAction=be;let ke=p=class{constructor(j){this.value=j}append(j){return new p(this.value?this.value+p.c+j:j)}intersects(j){return this.contains(j)||j.contains(this)}contains(j){return this.value===j.value||j.value.startsWith(this.value+p.c)}};ke.c=".",ke=p=Ve([F],ke),e.CodeActionKind=ke,ke.Empty=new ke(""),ke.QuickFix=ke.Empty.append("quickfix"),ke.Refactor=ke.Empty.append("refactor"),ke.RefactorExtract=ke.Refactor.append("extract"),ke.RefactorInline=ke.Refactor.append("inline"),ke.RefactorMove=ke.Refactor.append("move"),ke.RefactorRewrite=ke.Refactor.append("rewrite"),ke.Source=ke.Empty.append("source"),ke.SourceOrganizeImports=ke.Source.append("organizeImports"),ke.SourceFixAll=ke.Source.append("fixAll");let ge=class{constructor(j,he){if(this.range=j,this.parent=he,he&&!he.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ge=Ve([F],ge),e.SelectionRange=ge;class Pe{constructor(j,he,Te,Ke,Ye,ct){this.kind=j,this.name=he,this.detail=Te,this.uri=Ke,this.range=Ye,this.selectionRange=ct}}e.CallHierarchyItem=Pe;class Ie{constructor(j,he){this.fromRanges=he,this.from=j}}e.CallHierarchyIncomingCall=Ie;class je{constructor(j,he){this.fromRanges=he,this.to=j}}e.CallHierarchyOutgoingCall=je;var qe;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})(qe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(j,he){this.range=j,this.command=he}get isResolved(){return!!this.command}};et=Ve([F],et),e.CodeLens=et;let _e=I=class{static isMarkdownString(j){return j instanceof I?!0:j&&j.appendCodeblock&&j.appendMarkdown&&j.appendText&&j.value!==void 0}constructor(j,he=!1){g.set(this,void 0),Je(this,g,new k.MarkdownString(j,{supportThemeIcons:he}),"f")}get value(){return Fe(this,g,"f").value}set value(j){Fe(this,g,"f").value=j}get isTrusted(){return Fe(this,g,"f").isTrusted}set isTrusted(j){Fe(this,g,"f").isTrusted=j}get supportThemeIcons(){return Fe(this,g,"f").supportThemeIcons}set supportThemeIcons(j){Fe(this,g,"f").supportThemeIcons=j}get supportHtml(){return Fe(this,g,"f").supportHtml}set supportHtml(j){Fe(this,g,"f").supportHtml=j}get baseUri(){return Fe(this,g,"f").baseUri}set baseUri(j){Fe(this,g,"f").baseUri=j}appendText(j){return Fe(this,g,"f").appendText(j),this}appendMarkdown(j){return Fe(this,g,"f").appendMarkdown(j),this}appendCodeblock(j,he){return Fe(this,g,"f").appendCodeblock(he??"",j),this}};g=new WeakMap,_e=I=Ve([F],_e),e.MarkdownString=_e;let nt=class{constructor(j,he){this.label=j,this.documentation=he}};nt=Ve([F],nt),e.ParameterInformation=nt;let st=class{constructor(j,he){this.label=j,this.documentation=he,this.parameters=[]}};st=Ve([F],st),e.SignatureInformation=st;let ht=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ht=Ve([F],ht),e.SignatureHelp=ht;var Ue;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(Ue=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var it;(function(x){x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(it=e.InlayHintKind||(e.InlayHintKind={}));let oe=class{constructor(j){this.value=j}};oe=Ve([F],oe),e.InlayHintLabelPart=oe;let W=class{constructor(j,he,Te){this.position=j,this.label=he,this.kind=Te}};W=Ve([F],W),e.InlayHint=W;var ae;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ae=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ce;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(Ce=e.CompletionItemKind||(e.CompletionItemKind={}));var Le;(function(x){x[x.Deprecated=1]="Deprecated"})(Le=e.CompletionItemTag||(e.CompletionItemTag={}));let Be=class{constructor(j,he){this.label=j,this.kind=he}toJSON(){return{label:this.label,kind:this.kind&&Ce[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Be=Ve([F],Be),e.CompletionItem=Be;let Xe=class{constructor(j=[],he=!1){this.items=j,this.isIncomplete=he}};Xe=Ve([F],Xe),e.CompletionList=Xe;let Ze=class{constructor(j,he,Te){this.insertText=j,this.range=he,this.command=Te}};Ze=Ve([F],Ze),e.InlineSuggestion=Ze;let ft=class{constructor(j){this.commands=void 0,this.items=j}};ft=Ve([F],ft),e.InlineSuggestionList=ft;var mt;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(mt=e.ViewColumn||(e.ViewColumn={}));var lt;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(lt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ot;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(ot=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var rt;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(rt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Tt;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Tt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var kt;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(kt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Mt;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(Mt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var pt;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(pt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function j(he){switch(he){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=j}(kt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ct=class{constructor(j,he){if(he&&!C.URI.isUri(he))throw(0,t.illegalArgument)("target");if(!H.isRange(j)||j.isEmpty)throw(0,t.illegalArgument)("range");this.range=j,this.target=he}};Ct=Ve([F],Ct),e.DocumentLink=Ct;let Rt=class{constructor(j,he,Te,Ke){this.red=j,this.green=he,this.blue=Te,this.alpha=Ke}};Rt=Ve([F],Rt),e.Color=Rt;let Ut=class{constructor(j,he){if(he&&!(he instanceof Rt))throw(0,t.illegalArgument)("color");if(!H.isRange(j)||j.isEmpty)throw(0,t.illegalArgument)("range");this.range=j,this.color=he}};Ut=Ve([F],Ut),e.ColorInformation=Ut;let xe=class{constructor(j){if(!j||typeof j!="string")throw(0,t.illegalArgument)("label");this.label=j}};xe=Ve([F],xe),e.ColorPresentation=xe;var Ot;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(Ot=e.ColorFormat||(e.ColorFormat={}));var jt;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(jt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var qt;(function(x){x[x.Unknown=0]="Unknown",x[x.Shutdown=1]="Shutdown",x[x.Process=2]="Process",x[x.User=3]="User",x[x.Extension=4]="Extension"})(qt=e.TerminalExitReason||(e.TerminalExitReason={}));class bt{constructor(j,he,Te){if(this.startIndex=j,this.length=he,this.tooltip=Te,typeof j!="number"||j<0)throw(0,t.illegalArgument)("startIndex");if(typeof he!="number"||he<1)throw(0,t.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=bt;var Pt;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(Pt=e.TerminalLocation||(e.TerminalLocation={}));class Ae{constructor(j){if(this.options=j,typeof j!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=Ae;var Oe;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(Oe=e.TaskRevealKind||(e.TaskRevealKind={}));var Ee;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(Ee=e.TaskPanelKind||(e.TaskPanelKind={}));let ee=L=class{static from(j){switch(j){case"clean":return L.Clean;case"build":return L.Build;case"rebuild":return L.Rebuild;case"test":return L.Test;default:return}}constructor(j,he){if(this.label=he,typeof j!="string"||typeof he!="string")throw(0,t.illegalArgument)("name");this.c=j}get id(){return this.c}};ee.Clean=new L("clean","Clean"),ee.Build=new L("build","Build"),ee.Rebuild=new L("rebuild","Rebuild"),ee.Test=new L("test","Test"),ee=L=Ve([F],ee),e.TaskGroup=ee;function Ne(x){let j="";for(let he=0;he<x.length;he++)j+=x[he].replace(/,/g,",,")+",";return j}let ze=class{constructor(j,he,Te){if(typeof j!="string")throw(0,t.illegalArgument)("process");this.e=[],this.c=j,he!==void 0&&(Array.isArray(he)?(this.e=he,this.f=Te):this.f=he)}get process(){return this.c}set process(j){if(typeof j!="string")throw(0,t.illegalArgument)("process");this.c=j}get args(){return this.e}set args(j){Array.isArray(j)||(j=[]),this.e=j}get options(){return this.f}set options(j){this.f=j}computeId(){const j=[];if(j.push("process"),this.c!==void 0&&j.push(this.c),this.e&&this.e.length>0)for(const he of this.e)j.push(he);return Ne(j)}};ze=Ve([F],ze),e.ProcessExecution=ze;let Qe=class{constructor(j,he,Te){if(this.f=[],Array.isArray(he)){if(!j)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof j!="string"&&typeof j.value!="string")throw(0,t.illegalArgument)("command");this.e=j,this.f=he,this.g=Te}else{if(typeof j!="string")throw(0,t.illegalArgument)("commandLine");this.c=j,this.g=he}}get commandLine(){return this.c}set commandLine(j){if(typeof j!="string")throw(0,t.illegalArgument)("commandLine");this.c=j}get command(){return this.e?this.e:""}set command(j){if(typeof j!="string"&&typeof j.value!="string")throw(0,t.illegalArgument)("command");this.e=j}get args(){return this.f}set args(j){this.f=j||[]}get options(){return this.g}set options(j){this.g=j}computeId(){const j=[];if(j.push("shell"),this.c!==void 0&&j.push(this.c),this.e!==void 0&&j.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const he of this.f)j.push(typeof he=="string"?he:he.value);return Ne(j)}};Qe=Ve([F],Qe),e.ShellExecution=Qe;var Ge;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(Ge=e.ShellQuoting||(e.ShellQuoting={}));var tt;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(tt=e.TaskScope||(e.TaskScope={}));class Dt{constructor(j){this.c=j}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(j){this.c=j}get callback(){return this.c}}e.CustomExecution=Dt;let vt=U=class{constructor(j,he,Te,Ke,Ye,ct){this.j=!1,this.k=this.definition=j;let dt;typeof he=="string"?(this.m=this.name=he,this.t=this.source=Te,this.execution=Ke,dt=Ye,this.j=!0):he===tt.Global||he===tt.Workspace?(this.target=he,this.m=this.name=Te,this.t=this.source=Ke,this.execution=Ye,dt=ct):(this.target=he,this.m=this.name=Te,this.t=this.source=Ke,this.execution=Ye,dt=ct),typeof dt=="string"?(this.o=[dt],this.q=!0):Array.isArray(dt)?(this.o=dt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(j){this.h=j}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof ze?this.k={type:U.e,id:this.n.computeId()}:this.n instanceof Qe?this.k={type:U.f,id:this.n.computeId()}:this.n instanceof Dt?this.k={type:U.c,id:this.n.computeId()}:this.k={type:U.g,id:(0,R.generateUuid)()}}get definition(){return this.k}set definition(j){if(j==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=j}get scope(){return this.l}set target(j){this.y(),this.l=j}get name(){return this.m}set name(j){if(typeof j!="string")throw(0,t.illegalArgument)("name");this.y(),this.m=j}get execution(){return this.n}set execution(j){j===null&&(j=void 0),this.y(),this.n=j;const he=this.k.type;(U.g===he||U.e===he||U.f===he||U.c===he)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(j){if(Array.isArray(j))this.y(),this.o=j,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(j){j!==!0&&j!==!1&&(j=!1),this.y(),this.r=j}get source(){return this.t}set source(j){if(typeof j!="string"||j.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.y(),this.t=j}get group(){return this.u}set group(j){j===null&&(j=void 0),this.y(),this.u=j}get detail(){return this.x}set detail(j){j===null&&(j=void 0),this.x=j}get presentationOptions(){return this.v}set presentationOptions(j){j==null&&(j=Object.create(null)),this.y(),this.v=j}get runOptions(){return this.w}set runOptions(j){j==null&&(j=Object.create(null)),this.y(),this.w=j}};vt.c="customExecution",vt.e="process",vt.f="shell",vt.g="$empty",vt=U=Ve([F],vt),e.Task=vt;var Lt;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(Lt=e.ProgressLocation||(e.ProgressLocation={}));var St;(function(x){function j(he){const Te=he;return(0,S.isNumber)(Te.value)?Te.tooltip&&!(0,S.isString)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}x.isViewBadge=j})(St=e.ViewBadge||(e.ViewBadge={}));let yt=G=class{static isTreeItem(j,he){if(j instanceof G)return!0;const Te=j;if(Te.label!==void 0&&!(0,S.isString)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,S.isString)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,S.isString)(Te.iconPath)&&!C.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,S.isString)(Te.iconPath.id))){const Ke=Te.iconPath;if(!Ke||!(0,S.isString)(Ke.light)&&!C.URI.isUri(Ke.light)&&!(0,S.isString)(Ke.dark)&&!C.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}if(Te.description!==void 0&&!(0,S.isString)(Te.description)&&typeof Te.description!="boolean")return console.log("INVALID tree item, invalid description",Te.description),!1;if(Te.resourceUri!==void 0&&!C.URI.isUri(Te.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1;if(Te.tooltip!==void 0&&!(0,S.isString)(Te.tooltip)&&!(Te.tooltip instanceof _e))return console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1;if(Te.command!==void 0&&!Te.command.command)return console.log("INVALID tree item, invalid command",Te.command),!1;if(Te.collapsibleState!==void 0&&Te.collapsibleState<gt.None&&Te.collapsibleState>gt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1;if(Te.contextValue!==void 0&&!(0,S.isString)(Te.contextValue))return console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1;if(Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1;if(Te.checkboxState!==void 0){(0,v.checkProposedApiEnabled)(he,"treeItemCheckbox");const Ke=(0,S.isNumber)(Te.checkboxState)?Te.checkboxState:(0,S.isObject)(Te.checkboxState)&&(0,S.isNumber)(Te.checkboxState.state)?Te.checkboxState.state:void 0,Ye=!(0,S.isNumber)(Te.checkboxState)&&(0,S.isObject)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==$t.Checked&&Ke!==$t.Unchecked||Ye!==void 0&&!(0,S.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}return!0}constructor(j,he=gt.None){this.collapsibleState=he,C.URI.isUri(j)?this.resourceUri=j:this.label=j}};yt=G=Ve([F],yt),e.TreeItem=yt;var gt;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(gt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var $t;(function(x){x[x.Unchecked=0]="Unchecked",x[x.Checked=1]="Checked"})($t=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let Jt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(j,he){this.value=j,this.id=he??(0,R.generateUuid)()}};Jt=Ve([F],Jt),e.DataTransferItem=Jt;let Et=class{constructor(j){h.set(this,new Map);for(const[he,Te]of j??[]){const Ke=Fe(this,h,"f").get(he);Ke?Ke.push(Te):Fe(this,h,"f").set(he,[Te])}}get(j){return Fe(this,h,"f").get(j)?.[0]}set(j,he){Fe(this,h,"f").set(j,[he])}forEach(j,he){for(const[Te,Ke]of Fe(this,h,"f"))for(const Ye of Ke)j.call(he,Ye,Te,this)}*[(h=new WeakMap,Symbol.iterator)](){for(const[j,he]of Fe(this,h,"f"))for(const Te of he)yield[j,Te]}};Et=Ve([F],Et),e.DataTransfer=Et;let Xt=class{constructor(j){this.insertText=j}};Xt=Ve([F],Xt),e.DocumentDropEdit=Xt;let cn=class{constructor(j){this.insertText=j}};cn=Ve([F],cn),e.DocumentPasteEdit=cn;let Bt=class{constructor(j,he){this.id=j,this.color=he}static isThemeIcon(j){return typeof j.id!="string"?(console.log("INVALID ThemeIcon, invalid id",j.id),!1):!0}};Bt=Ve([F],Bt),e.ThemeIcon=Bt,Bt.File=new Bt("file"),Bt.Folder=new Bt("folder");let pn=class{constructor(j){this.id=j}};pn=Ve([F],pn),e.ThemeColor=pn;var Nt;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(Nt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ln=class{get base(){return this.c}set base(j){this.c=j,this.e=C.URI.file(j)}get baseUri(){return this.e}set baseUri(j){this.e=j,this.c=j.fsPath}constructor(j,he){if(typeof j!="string"&&(!j||!C.URI.isUri(j)&&!C.URI.isUri(j.uri)))throw(0,t.illegalArgument)("base");if(typeof he!="string")throw(0,t.illegalArgument)("pattern");typeof j=="string"?this.baseUri=C.URI.file(j):C.URI.isUri(j)?this.baseUri=j:this.baseUri=j.uri,this.pattern=he}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ln=Ve([F],ln),e.RelativePattern=ln;let Zt=class{constructor(j,he,Te,Ke){this.enabled=typeof j=="boolean"?j:!0,typeof he=="string"&&(this.condition=he),typeof Te=="string"&&(this.hitCondition=Te),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=(0,R.generateUuid)()),this.c}};Zt=Ve([F],Zt),e.Breakpoint=Zt;let en=class extends Zt{constructor(j,he,Te,Ke,Ye){if(super(he,Te,Ke,Ye),j===null)throw(0,t.illegalArgument)("location");this.location=j}};en=Ve([F],en),e.SourceBreakpoint=en;let tn=class extends Zt{constructor(j,he,Te,Ke,Ye){super(he,Te,Ke,Ye),this.functionName=j}};tn=Ve([F],tn),e.FunctionBreakpoint=tn;let ut=class extends Zt{constructor(j,he,Te,Ke,Ye,ct,dt){if(super(Ke,Ye,ct,dt),!he)throw(0,t.illegalArgument)("dataId");this.label=j,this.dataId=he,this.canPersist=Te}};ut=Ve([F],ut),e.DataBreakpoint=ut;let bn=class{constructor(j,he,Te){this.command=j,this.args=he||[],this.options=Te}};bn=Ve([F],bn),e.DebugAdapterExecutable=bn;let Gt=class{constructor(j,he){this.port=j,this.host=he}};Gt=Ve([F],Gt),e.DebugAdapterServer=Gt;let _t=class{constructor(j){this.path=j}};_t=Ve([F],_t),e.DebugAdapterNamedPipeServer=_t;let un=class{constructor(j){this.implementation=j}};un=Ve([F],un),e.DebugAdapterInlineImplementation=un;let wn=class{constructor(j,he){this.range=j,this.expression=he}};wn=Ve([F],wn),e.EvaluatableExpression=wn;var kn;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})(kn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let vn=class{constructor(j,he){this.range=j,this.text=he}};vn=Ve([F],vn),e.InlineValueText=vn;let dn=class{constructor(j,he,Te=!0){this.range=j,this.variableName=he,this.caseSensitiveLookup=Te}};dn=Ve([F],dn),e.InlineValueVariableLookup=dn;let nn=class{constructor(j,he){this.range=j,this.expression=he}};nn=Ve([F],nn),e.InlineValueEvaluatableExpression=nn;let En=class{constructor(j,he){this.frameId=j,this.stoppedLocation=he}};En=Ve([F],En),e.InlineValueContext=En;var Sn;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(Sn=e.FileChangeType||(e.FileChangeType={}));let rn=V=class extends Error{static FileExists(j){return new V(j,P.FileSystemProviderErrorCode.FileExists,V.FileExists)}static FileNotFound(j){return new V(j,P.FileSystemProviderErrorCode.FileNotFound,V.FileNotFound)}static FileNotADirectory(j){return new V(j,P.FileSystemProviderErrorCode.FileNotADirectory,V.FileNotADirectory)}static FileIsADirectory(j){return new V(j,P.FileSystemProviderErrorCode.FileIsADirectory,V.FileIsADirectory)}static NoPermissions(j){return new V(j,P.FileSystemProviderErrorCode.NoPermissions,V.NoPermissions)}static Unavailable(j){return new V(j,P.FileSystemProviderErrorCode.Unavailable,V.Unavailable)}constructor(j,he=P.FileSystemProviderErrorCode.Unknown,Te){super(C.URI.isUri(j)?j.toString(!0):j),this.code=Te?.name??"Unknown",(0,P.markAsFileSystemProviderError)(this,he),Object.setPrototypeOf(this,V.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};rn=V=Ve([F],rn),e.FileSystemError=rn;let yn=class{constructor(j,he,Te){this.start=j,this.end=he,this.kind=Te}};yn=Ve([F],yn),e.FoldingRange=yn;var On;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(On=e.FoldingRangeKind||(e.FoldingRangeKind={}));var sn;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(sn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Nn;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(Nn=e.CommentMode||(e.CommentMode={}));var Fn;(function(x){x[x.Unresolved=0]="Unresolved",x[x.Resolved=1]="Resolved"})(Fn=e.CommentThreadState||(e.CommentThreadState={}));class Mn{constructor(j,he=[]){this.tokenTypes=j,this.tokenModifiers=he}}e.SemanticTokensLegend=Mn;function Un(x){return typeof x>"u"||(0,S.isStringArray)(x)}class Cn{constructor(j){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,j){this.l=!0;for(let he=0,Te=j.tokenTypes.length;he<Te;he++)this.j.set(j.tokenTypes[he],he);for(let he=0,Te=j.tokenModifiers.length;he<Te;he++)this.k.set(j.tokenModifiers[he],he)}}push(j,he,Te,Ke,Ye){if(typeof j=="number"&&typeof he=="number"&&typeof Te=="number"&&typeof Ke=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.n(j,he,Te,Ke,Ye);if(H.isRange(j)&&typeof he=="string"&&Un(Te))return this.m(j,he,Te);throw(0,t.illegalArgument)()}m(j,he,Te){if(!this.l)throw new Error("Legend must be provided in constructor");if(j.start.line!==j.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(he))throw new Error("`tokenType` is not in the provided legend");const Ke=j.start.line,Ye=j.start.character,ct=j.end.character-j.start.character,dt=this.j.get(he);let Ft=0;if(Te)for(const Vt of Te){if(!this.k.has(Vt))throw new Error("`tokenModifier` is not in the provided legend");const Kt=this.k.get(Vt);Ft|=1<<Kt>>>0}this.n(Ke,Ye,ct,dt,Ft)}n(j,he,Te,Ke,Ye){if(this.f&&(j<this.c||j===this.c&&he<this.e)){this.f=!1;const Ft=this.g.length/5|0;let Vt=0,Kt=0;for(let xt=0;xt<Ft;xt++){let Qt=this.g[5*xt],Dn=this.g[5*xt+1];Qt===0?(Qt=Vt,Dn+=Kt):Qt+=Vt,this.g[5*xt]=Qt,this.g[5*xt+1]=Dn,Vt=Qt,Kt=Dn}}let ct=j,dt=he;this.f&&this.h>0&&(ct-=this.c,ct===0&&(dt-=this.e)),this.g[this.h++]=ct,this.g[this.h++]=dt,this.g[this.h++]=Te,this.g[this.h++]=Ke,this.g[this.h++]=Ye,this.c=j,this.e=he}static o(j){const he=[],Te=j.length/5|0;for(let dt=0;dt<Te;dt++)he[dt]=dt;he.sort((dt,Ft)=>{const Vt=j[5*dt],Kt=j[5*Ft];if(Vt===Kt){const xt=j[5*dt+1],Qt=j[5*Ft+1];return xt-Qt}return Vt-Kt});const Ke=new Uint32Array(j.length);let Ye=0,ct=0;for(let dt=0;dt<Te;dt++){const Ft=5*he[dt],Vt=j[Ft+0],Kt=j[Ft+1],xt=j[Ft+2],Qt=j[Ft+3],Dn=j[Ft+4],ti=Vt-Ye,Ci=ti===0?Kt-ct:Kt,In=5*dt;Ke[In+0]=ti,Ke[In+1]=Ci,Ke[In+2]=xt,Ke[In+3]=Qt,Ke[In+4]=Dn,Ye=Vt,ct=Kt}return Ke}build(j){return this.f?new on(new Uint32Array(this.g),j):new on(Cn.o(this.g),j)}}e.SemanticTokensBuilder=Cn;class on{constructor(j,he){this.resultId=he,this.data=j}}e.SemanticTokens=on;class Tn{constructor(j,he,Te){this.start=j,this.deleteCount=he,this.data=Te}}e.SemanticTokensEdit=Tn;class Pn{constructor(j,he){this.resultId=he,this.edits=j}}e.SemanticTokensEdits=Pn;var He;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(He=e.DebugConsoleMode||(e.DebugConsoleMode={}));let zt=class{constructor(){}};zt.Back={iconPath:new Bt("arrow-left")},zt=Ve([F],zt),e.QuickInputButtons=zt;var An;(function(x){x[x.Separator=-1]="Separator",x[x.Default=0]="Default"})(An=e.QuickPickItemKind||(e.QuickPickItemKind={}));var wt;(function(x){x[x.Info=1]="Info",x[x.Warning=2]="Warning",x[x.Error=3]="Error"})(wt=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Bn;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(Bn=e.ExtensionKind||(e.ExtensionKind={}));class $n{static validate(j){if(typeof j.badge=="string"){let he=(0,T.nextCharLength)(j.badge,0);if(he<j.badge.length&&(he+=(0,T.nextCharLength)(j.badge,he)),j.badge.length>he)throw new Error("The 'badge'-property must be undefined or a short character")}else if(j.badge&&!Bt.isThemeIcon(j.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!j.color&&!j.badge&&!j.tooltip)throw new Error("The decoration is empty");return!0}constructor(j,he,Te){this.badge=j,this.tooltip=he,this.color=Te}}e.FileDecoration=$n;let hn=class{constructor(j){this.kind=j}};hn=Ve([F],hn),e.ColorTheme=hn;var zn;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast",x[x.HighContrastLight=4]="HighContrastLight"})(zn=e.ColorThemeKind||(e.ColorThemeKind={}));class Wt{static isNotebookRange(j){return j instanceof Wt?!0:j?typeof j.start=="number"&&typeof j.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(j,he){if(j<0)throw(0,t.illegalArgument)("start must be positive");if(he<0)throw(0,t.illegalArgument)("end must be positive");j<=he?(this.c=j,this.e=he):(this.c=he,this.e=j)}with(j){let he=this.c,Te=this.e;return j.start!==void 0&&(he=j.start),j.end!==void 0&&(Te=j.end),he===this.c&&Te===this.e?this:new Wt(he,Te)}}e.NotebookRange=Wt;class fn{static validate(j){if(typeof j.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof j.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof j.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(j){return Array.isArray(j)&&j.every(he=>fn.isNotebookCellData(he))}static isNotebookCellData(j){return!0}constructor(j,he,Te,Ke,Ye,ct,dt){this.kind=j,this.value=he,this.languageId=Te,this.mime=Ke,this.outputs=Ye??[],this.metadata=ct,this.executionSummary=dt,fn.validate(this)}}e.NotebookCellData=fn;class Wn{constructor(j){this.cells=j}}e.NotebookData=Wn;class Ht{static isNotebookCellOutputItem(j){return j instanceof Ht?!0:j?typeof j.mime=="string"&&j.data instanceof Uint8Array:!1}static error(j){const he={name:j.name,message:j.message,stack:j.stack};return Ht.json(he,"application/vnd.code.notebook.error")}static stdout(j){return Ht.text(j,"application/vnd.code.notebook.stdout")}static stderr(j){return Ht.text(j,"application/vnd.code.notebook.stderr")}static bytes(j,he="application/octet-stream"){return new Ht(j,he)}static text(j,he=D.Mimes.text){const Te=Fe(Ht,w,"f",m).encode(String(j));return new Ht(Te,he)}static json(j,he="text/x-json"){const Te=JSON.stringify(j,void 0,"	");return Ht.text(Te,he)}constructor(j,he){this.data=j,this.mime=he;const Te=(0,D.normalizeMimeType)(he,!0);if(!Te)throw new Error(`INVALID mime type: ${he}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}e.NotebookCellOutputItem=Ht,w=Ht,m={value:new TextEncoder};class an{static isNotebookCellOutput(j){return j instanceof an?!0:!j||typeof j!="object"?!1:typeof j.id=="string"&&Array.isArray(j.items)}static ensureUniqueMimeTypes(j,he=!1){const Te=new Set,Ke=new Set;for(let Ye=0;Ye<j.length;Ye++){const ct=j[Ye],dt=(0,D.normalizeMimeType)(ct.mime);if(!Te.has(dt)||(0,y.isTextStreamMime)(dt)){Te.add(dt);continue}Ke.add(Ye),he&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ke.size===0?j:j.filter((Ye,ct)=>!Ke.has(ct))}constructor(j,he,Te){this.items=an.ensureUniqueMimeTypes(j,!0),typeof he=="string"?(this.id=he,this.metadata=Te):(this.id=(0,R.generateUuid)(),this.metadata=he??Te)}}e.NotebookCellOutput=an;var Hn;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(Hn=e.NotebookCellKind||(e.NotebookCellKind={}));var jn;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(jn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Vn;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(Vn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var qn;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(qn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Gn{constructor(j,he){this.text=j,this.alignment=he}}e.NotebookCellStatusBarItem=Gn;var Kn;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(Kn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var me;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred",x[x.Hidden=-1]="Hidden"})(me=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class we{constructor(j,he=[]){this.uri=j,this.provides=(0,a.asArray)(he)}}e.NotebookRendererScript=we;class Me{constructor(j){this.label=j}}e.NotebookKernelSourceAction=Me;let at=class{constructor(j,he){this.label=j,this.timestamp=he}};at=Ve([F],at),e.TimelineItem=at;var It;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(It=e.ExtensionMode||(e.ExtensionMode={}));var At;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(At=e.ExtensionRuntime||(e.ExtensionRuntime={}));var si;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=3]="RegEx"})(si=e.StandardTokenType||(e.StandardTokenType={}));class oi{constructor(j,he){this.ranges=j,this.wordPattern=he}}e.LinkedEditingRanges=oi;class ai{constructor(j,he){this.c=j,this.e=he}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=ai;var ci;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(ci=e.TestResultState||(e.TestResultState={}));var li;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(li=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Xn=class{constructor(j=void 0,he=void 0,Te=void 0){this.include=j,this.exclude=he,this.profile=Te}};Xn=Ve([F],Xn),e.TestRunRequest=Xn;let xn=O=class{static diff(j,he,Te){const Ke=new O(j);return Ke.expectedOutput=he,Ke.actualOutput=Te,Ke}constructor(j){this.message=j}};xn=O=Ve([F],xn),e.TestMessage=xn;let _n=class{constructor(j){this.id=j}};_n=Ve([F],_n),e.TestTag=_n;let mn=class{constructor(j,he){this.covered=j,this.total=he}};mn=Ve([F],mn),e.CoveredCount=mn;let Qn=B=class{static fromDetails(j,he){const Te=new mn(0,0),Ke=new mn(0,0),Ye=new mn(0,0);for(const dt of he)if("branches"in dt){Te.total+=1,Te.covered+=dt.executionCount>0?1:0;for(const Ft of dt.branches)Ke.total+=1,Ke.covered+=Ft.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=dt.executionCount>0?1:0;const ct=new B(j,Te,Ke.total>0?Ke:void 0,Ye.total>0?Ye:void 0);return ct.detailedCoverage=he,ct}constructor(j,he,Te,Ke){this.uri=j,this.statementCoverage=he,this.branchCoverage=Te,this.functionCoverage=Ke}};Qn=B=Ve([F],Qn),e.FileCoverage=Qn;let Yn=class{constructor(j,he,Te=[]){this.executionCount=j,this.location=he,this.branches=Te}};Yn=Ve([F],Yn),e.StatementCoverage=Yn;let Jn=class{constructor(j,he){this.executionCount=j,this.location=he}};Jn=Ve([F],Jn),e.BranchCoverage=Jn;let Zn=class{constructor(j,he){this.executionCount=j,this.location=he}};Zn=Ve([F],Zn),e.FunctionCoverage=Zn;var ui;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(ui=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var di;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(di=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var hi;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(hi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class fi{constructor(j,he,Te,Ke,Ye,ct){this.kind=j,this.name=he,this.detail=Te,this.uri=Ke,this.range=Ye,this.selectionRange=ct}}e.TypeHierarchyItem=fi;class mi{constructor(j){this.uri=j}}e.TextTabInput=mi;class gi{constructor(j,he){this.original=j,this.modified=he}}e.TextDiffTabInput=gi;class pi{constructor(j,he,Te,Ke){this.base=j,this.input1=he,this.input2=Te,this.result=Ke}}e.TextMergeTabInput=pi;class bi{constructor(j,he){this.uri=j,this.viewType=he}}e.CustomEditorTabInput=bi;class wi{constructor(j){this.viewType=j}}e.WebviewEditorTabInput=wi;class vi{constructor(j,he){this.uri=j,this.notebookType=he}}e.NotebookEditorTabInput=vi;class Ei{constructor(j,he,Te){this.original=j,this.modified=he,this.notebookType=Te}}e.NotebookDiffEditorTabInput=Ei;class Si{constructor(){}}e.TerminalEditorTabInput=Si;class yi{constructor(j,he){this.uri=j,this.inputBoxUri=he}}e.InteractiveWindowInput=yi}),define(Se[134],ye([1,0,48,15,8,162,104,7,17]),function(te,e,a,t,k,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const C=new Map;function R(v,d){d?C.set(v,d):C.delete(v)}e.setWordDefinitionFor=R;function P(v){return C.get(v)}class E extends A.MirrorTextModel{constructor(d,g,h,w,m,f,b,s){super(g,h,w,m),this.m=d,this.p=f,this.q=b,this.notebook=s,this.b=!1}dispose(){(0,a.ok)(!this.b),this.b=!0,this.q=!1}equalLines(d){return(0,S.equals)(this.d,d)}get document(){if(!this.a){const d=this;this.a={get uri(){return d.c},get fileName(){return d.c.fsPath},get isUntitled(){return d.c.scheme===t.Schemas.untitled},get languageId(){return d.p},get version(){return d.g},get isClosed(){return d.b},get isDirty(){return d.q},save(){return d.r()},getText(g){return g?d.s(g):d.getText()},get eol(){return d.f===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return d.d.length},lineAt(g){return d.t(g)},offsetAt(g){return d.u(g)},positionAt(g){return d.v(g)},validateRange(g){return d.w(g)},validatePosition(g){return d.x(g)},getWordRangeAtPosition(g,h){return d.y(g,h)}}}return Object.freeze(this.a)}_acceptLanguageId(d){(0,a.ok)(!this.b),this.p=d}_acceptIsDirty(d){(0,a.ok)(!this.b),this.q=d}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(d){const g=this.w(d);if(g.isEmpty)return"";if(g.isSingleLine)return this.d[g.start.line].substring(g.start.character,g.end.character);const h=this.f,w=g.start.line,m=g.end.line,f=[];f.push(this.d[w].substring(g.start.character));for(let b=w+1;b<m;b++)f.push(this.d[b]);return f.push(this.d[m].substring(0,g.end.character)),f.join(h)}t(d){let g;if(d instanceof T.Position?g=d.line:typeof d=="number"&&(g=d),typeof g!="number"||g<0||g>=this.d.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new y(g,this.d[g],g===this.d.length-1)}u(d){return d=this.x(d),this.k(),this.h.getPrefixSum(d.line-1)+d.character}v(d){d=Math.floor(d),d=Math.max(0,d),this.k();const g=this.h.getIndexOf(d),h=this.d[g.index].length;return new T.Position(g.index,Math.min(g.remainder,h))}w(d){if(!(d instanceof T.Range))throw new Error("Invalid argument");const g=this.x(d.start),h=this.x(d.end);return g===d.start&&h===d.end?d:new T.Range(g.line,g.character,h.line,h.character)}x(d){if(!(d instanceof T.Position))throw new Error("Invalid argument");if(this.d.length===0)return d.with(0,0);let{line:g,character:h}=d,w=!1;if(g<0)g=0,h=0,w=!0;else if(g>=this.d.length)g=this.d.length-1,h=this.d[g].length,w=!0;else{const m=this.d[g].length;h<0?(h=0,w=!0):h>m&&(h=m,w=!0)}return w?new T.Position(g,h):d}y(d,g){const h=this.x(d);if(!g)g=P(this.p);else if((0,k.regExpLeadsToEndlessLoop)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const w=(0,D.getWordAtText)(h.character+1,(0,D.ensureValidWordDefinition)(g),this.d[h.line],0);if(w)return new T.Range(h.line,w.startColumn-1,h.line,w.endColumn-1)}}e.ExtHostDocumentData=E;class y{constructor(d,g,h){this.a=d,this.b=g,this.c=h}get lineNumber(){return this.a}get text(){return this.b}get range(){return new T.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new T.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=y}),define(Se[232],ye([1,0,7,16,4]),function(te,e,a,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(T){this.a=new a.ColorTheme(a.ColorThemeKind.Dark),this.b=new k.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(T){let S;switch(T){case"light":S=a.ColorThemeKind.Light;break;case"hcDark":S=a.ColorThemeKind.HighContrast;break;case"hcLight":S=a.ColorThemeKind.HighContrastLight;break;default:S=a.ColorThemeKind.Dark}this.a=new a.ColorTheme(S),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};A=Ve([We(0,t.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(Se[14],ye([1,0,17,22,147,61,110,28,146,84,82,23,11,2,35,66,122,132,130,90,56,68,226,7]),function(te,e,a,t,k,A,D,T,S,C,R,P,E,y,v,d,g,h,w,m,f,b,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var c;(function(Ae){function Oe(ee){const{selectionStartLineNumber:Ne,selectionStartColumn:ze,positionLineNumber:Qe,positionColumn:Ge}=ee,tt=new o.Position(Ne-1,ze-1),Dt=new o.Position(Qe-1,Ge-1);return new o.Selection(tt,Dt)}Ae.to=Oe;function Ee(ee){const{anchor:Ne,active:ze}=ee;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:ze.line+1,positionColumn:ze.character+1}}Ae.from=Ee})(c=e.Selection||(e.Selection={}));var u;(function(Ae){function Oe(ee){if(!ee)return;const{start:Ne,end:ze}=ee;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:ze.line+1,endColumn:ze.character+1}}Ae.from=Oe;function Ee(ee){if(!ee)return;const{startLineNumber:Ne,startColumn:ze,endLineNumber:Qe,endColumn:Ge}=ee;return new o.Range(Ne-1,ze-1,Qe-1,Ge-1)}Ae.to=Ee})(u=e.Range||(e.Range={}));var r;(function(Ae){function Oe(Ee){switch(Ee){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 3:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}Ae.to=Oe})(r=e.TokenType||(e.TokenType={}));var l;(function(Ae){function Oe(ee){return new o.Position(ee.lineNumber-1,ee.column-1)}Ae.to=Oe;function Ee(ee){return{lineNumber:ee.line+1,column:ee.character+1}}Ae.from=Ee})(l=e.Position||(e.Position={}));var n;(function(Ae){function Oe(Ne,ze){return(0,a.coalesce)((0,a.asArray)(Ne).map(Qe=>Ee(Qe,ze)))}Ae.from=Oe;function Ee(Ne,ze){if(typeof Ne=="string")return{$serialized:!0,language:Ne};if(Ne)return{$serialized:!0,language:Ne.language,scheme:ee(Ne.scheme,ze),pattern:W.from(Ne.pattern)??void 0,exclusive:Ne.exclusive,notebookType:Ne.notebookType}}function ee(Ne,ze){return ze&&typeof Ne=="string"?ze.transformOutgoingScheme(Ne):Ne}})(n=e.DocumentSelector||(e.DocumentSelector={}));var i;(function(Ae){function Oe(ee){switch(ee){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}Ae.from=Oe;function Ee(ee){switch(ee){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}Ae.to=Ee})(i=e.DiagnosticTag||(e.DiagnosticTag={}));var p;(function(Ae){function Oe(ee){let Ne;return ee.code&&((0,E.isString)(ee.code)||(0,E.isNumber)(ee.code)?Ne=String(ee.code):Ne={value:String(ee.code.value),target:ee.code.target}),{...u.from(ee.range),message:ee.message,source:ee.source,code:Ne,severity:L.from(ee.severity),relatedInformation:ee.relatedInformation&&ee.relatedInformation.map(I.from),tags:Array.isArray(ee.tags)?(0,a.coalesce)(ee.tags.map(i.from)):void 0}}Ae.from=Oe;function Ee(ee){const Ne=new o.Diagnostic(u.to(ee),ee.message,L.to(ee.severity));return Ne.source=ee.source,Ne.code=(0,E.isString)(ee.code)?ee.code:ee.code?.value,Ne.relatedInformation=ee.relatedInformation&&ee.relatedInformation.map(I.to),Ne.tags=ee.tags&&(0,a.coalesce)(ee.tags.map(i.to)),Ne}Ae.to=Ee})(p=e.Diagnostic||(e.Diagnostic={}));var I;(function(Ae){function Oe(ee){return{...u.from(ee.location.range),message:ee.message,resource:ee.location.uri}}Ae.from=Oe;function Ee(ee){return new o.DiagnosticRelatedInformation(new o.Location(ee.resource,u.to(ee)),ee.message)}Ae.to=Ee})(I=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var L;(function(Ae){function Oe(ee){switch(ee){case o.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}Ae.from=Oe;function Ee(ee){switch(ee){case g.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}Ae.to=Ee})(L=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var U;(function(Ae){function Oe(ee){return typeof ee=="number"&&ee>=o.ViewColumn.One?ee-1:ee===o.ViewColumn.Beside?s.SIDE_GROUP:s.ACTIVE_GROUP}Ae.from=Oe;function Ee(ee){if(typeof ee=="number"&&ee>=0)return ee+1;throw new Error("invalid 'EditorGroupColumn'")}Ae.to=Ee})(U=e.ViewColumn||(e.ViewColumn={}));function G(Ae){return typeof Ae.range<"u"}function V(Ae){return Ae.length===0?!0:!!G(Ae[0])}e.isDecorationOptionsArr=V;var O;(function(Ae){function Oe(Ge){return Ge.map(Ae.from)}Ae.fromMany=Oe;function Ee(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function ee(Ge){let tt;if(Ee(Ge)){const{language:St,value:yt}=Ge;tt={value:"```"+St+`
`+yt+"\n```\n"}}else o.MarkdownString.isMarkdownString(Ge)?tt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?tt={value:Ge}:tt={value:""};const Dt=Object.create(null);tt.uris=Dt;const vt=St=>{try{let yt=y.URI.parse(St,!0);yt=yt.with({query:Ne(yt.query,Dt)}),Dt[St]=yt}catch{}return""},Lt=new S.marked.Renderer;return Lt.link=vt,Lt.image=St=>typeof St=="string"?vt(D.parseHrefAndDimensions(St).href):"",(0,S.marked)(tt.value,{renderer:Lt}),tt}Ae.from=ee;function Ne(Ge,tt){if(!Ge)return Ge;let Dt;try{Dt=(0,C.parse)(Ge)}catch{}if(!Dt)return Ge;let vt=!1;return Dt=(0,P.cloneAndChange)(Dt,Lt=>{if(y.URI.isUri(Lt)){const St=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[St]=Lt,vt=!0,St}else return}),vt?JSON.stringify(Dt):Ge}function ze(Ge){const tt=new o.MarkdownString(Ge.value,Ge.supportThemeIcons);return tt.isTrusted=Ge.isTrusted,tt.supportHtml=Ge.supportHtml,tt.baseUri=Ge.baseUri?y.URI.from(Ge.baseUri):void 0,tt}Ae.to=ze;function Qe(Ge){if(!!Ge)return typeof Ge=="string"?Ge:Ae.from(Ge)}Ae.fromStrict=Qe})(O=e.MarkdownString||(e.MarkdownString={}));function B(Ae){return V(Ae)?Ae.map(Oe=>({range:u.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?O.fromMany(Oe.hoverMessage):Oe.hoverMessage?O.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Ae.map(Oe=>({range:u.from(Oe)}))}e.fromRangeOrRangeWithMessage=B;function F(Ae){return typeof Ae>"u"?Ae:typeof Ae=="string"?y.URI.file(Ae):Ae}e.pathOrURIToURI=F;var $;(function(Ae){function Oe(Ee){return typeof Ee>"u"?Ee:{contentText:Ee.contentText,contentIconPath:Ee.contentIconPath?F(Ee.contentIconPath):void 0,border:Ee.border,borderColor:Ee.borderColor,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,color:Ee.color,backgroundColor:Ee.backgroundColor,margin:Ee.margin,width:Ee.width,height:Ee.height}}Ae.from=Oe})($=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var M;(function(Ae){function Oe(Ee){return typeof Ee>"u"?Ee:{backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?F(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?$.from(Ee.before):void 0,after:Ee.after?$.from(Ee.after):void 0}}Ae.from=Oe})(M=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var H;(function(Ae){function Oe(Ee){if(typeof Ee>"u")return Ee;switch(Ee){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}Ae.from=Oe})(H=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var K;(function(Ae){function Oe(Ee){return{isWholeLine:Ee.isWholeLine,rangeBehavior:Ee.rangeBehavior?H.from(Ee.rangeBehavior):void 0,overviewRulerLane:Ee.overviewRulerLane,light:Ee.light?M.from(Ee.light):void 0,dark:Ee.dark?M.from(Ee.dark):void 0,backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?F(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?$.from(Ee.before):void 0,after:Ee.after?$.from(Ee.after):void 0}}Ae.from=Oe})(K=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var q;(function(Ae){function Oe(ee){return{text:ee.newText,eol:ee.newEol&&st.from(ee.newEol),range:u.from(ee.range)}}Ae.from=Oe;function Ee(ee){const Ne=new o.TextEdit(u.to(ee.range),ee.text);return Ne.newEol=typeof ee.eol>"u"?void 0:st.to(ee.eol),Ne}Ae.to=Ee})(q=e.TextEdit||(e.TextEdit={}));var Y;(function(Ae){function Oe(ee,Ne){const ze={edits:[]};if(ee instanceof o.WorkspaceEdit){const Qe=new T.ResourceSet;for(const Ge of ee._allEntries())Ge._type===1&&y.URI.isUri(Ge.to)&&Ge.from===void 0&&Qe.add(Ge.to);for(const Ge of ee._allEntries())Ge._type===1?ze.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contentsBase64:Ge.options?.contents&&(0,t.encodeBase64)(t.VSBuffer.wrap(Ge.options.contents))},metadata:Ge.metadata}):Ge._type===2?ze.edits.push({resource:Ge.uri,textEdit:q.from(Ge.edit),versionId:Qe.has(Ge.uri)?void 0:Ne?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===6?ze.edits.push({resource:Ge.uri,textEdit:{range:u.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:Qe.has(Ge.uri)?void 0:Ne?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===3?ze.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Ne?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===5&&ze.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Ne?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(ft.from)}})}return ze}Ae.from=Oe;function Ee(ee){const Ne=new o.WorkspaceEdit;for(const ze of ee.edits)ze.textEdit?Ne.replace(y.URI.revive(ze.resource),u.to(ze.textEdit.range),ze.textEdit.text):Ne.renameFile(y.URI.revive(ze.oldResource),y.URI.revive(ze.newResource),ze.options);return Ne}Ae.to=Ee})(Y=e.WorkspaceEdit||(e.WorkspaceEdit={}));var Q;(function(Ae){const Oe=Object.create(null);Oe[o.SymbolKind.File]=0,Oe[o.SymbolKind.Module]=1,Oe[o.SymbolKind.Namespace]=2,Oe[o.SymbolKind.Package]=3,Oe[o.SymbolKind.Class]=4,Oe[o.SymbolKind.Method]=5,Oe[o.SymbolKind.Property]=6,Oe[o.SymbolKind.Field]=7,Oe[o.SymbolKind.Constructor]=8,Oe[o.SymbolKind.Enum]=9,Oe[o.SymbolKind.Interface]=10,Oe[o.SymbolKind.Function]=11,Oe[o.SymbolKind.Variable]=12,Oe[o.SymbolKind.Constant]=13,Oe[o.SymbolKind.String]=14,Oe[o.SymbolKind.Number]=15,Oe[o.SymbolKind.Boolean]=16,Oe[o.SymbolKind.Array]=17,Oe[o.SymbolKind.Object]=18,Oe[o.SymbolKind.Key]=19,Oe[o.SymbolKind.Null]=20,Oe[o.SymbolKind.EnumMember]=21,Oe[o.SymbolKind.Struct]=22,Oe[o.SymbolKind.Event]=23,Oe[o.SymbolKind.Operator]=24,Oe[o.SymbolKind.TypeParameter]=25;function Ee(Ne){return typeof Oe[Ne]=="number"?Oe[Ne]:6}Ae.from=Ee;function ee(Ne){for(const ze in Oe)if(Oe[ze]===Ne)return Number(ze);return o.SymbolKind.Property}Ae.to=ee})(Q=e.SymbolKind||(e.SymbolKind={}));var ce;(function(Ae){function Oe(ee){switch(ee){case o.SymbolTag.Deprecated:return 1}}Ae.from=Oe;function Ee(ee){switch(ee){case 1:return o.SymbolTag.Deprecated}}Ae.to=Ee})(ce=e.SymbolTag||(e.SymbolTag={}));var ie;(function(Ae){function Oe(ee){return{name:ee.name,kind:Q.from(ee.kind),tags:ee.tags&&ee.tags.map(ce.from),containerName:ee.containerName,location:De.from(ee.location)}}Ae.from=Oe;function Ee(ee){const Ne=new o.SymbolInformation(ee.name,Q.to(ee.kind),ee.containerName,De.to(ee.location));return Ne.tags=ee.tags&&ee.tags.map(ce.to),Ne}Ae.to=Ee})(ie=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var de;(function(Ae){function Oe(ee){const Ne={name:ee.name||"!!MISSING: name!!",detail:ee.detail,range:u.from(ee.range),selectionRange:u.from(ee.selectionRange),kind:Q.from(ee.kind),tags:ee.tags?.map(ce.from)??[]};return ee.children&&(Ne.children=ee.children.map(Oe)),Ne}Ae.from=Oe;function Ee(ee){const Ne=new o.DocumentSymbol(ee.name,ee.detail,Q.to(ee.kind),u.to(ee.range),u.to(ee.selectionRange));return(0,a.isNonEmptyArray)(ee.tags)&&(Ne.tags=ee.tags.map(ce.to)),ee.children&&(Ne.children=ee.children.map(Ee)),Ne}Ae.to=Ee})(de=e.DocumentSymbol||(e.DocumentSymbol={}));var J;(function(Ae){function Oe(ee){const Ne=new o.CallHierarchyItem(Q.to(ee.kind),ee.name,ee.detail||"",y.URI.revive(ee.uri),u.to(ee.range),u.to(ee.selectionRange));return Ne._sessionId=ee._sessionId,Ne._itemId=ee._itemId,Ne}Ae.to=Oe;function Ee(ee,Ne,ze){if(Ne=Ne??ee._sessionId,ze=ze??ee._itemId,Ne===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:ze,name:ee.name,detail:ee.detail,kind:Q.from(ee.kind),uri:ee.uri,range:u.from(ee.range),selectionRange:u.from(ee.selectionRange),tags:ee.tags?.map(ce.from)}}Ae.from=Ee})(J=e.CallHierarchyItem||(e.CallHierarchyItem={}));var pe;(function(Ae){function Oe(Ee){return new o.CallHierarchyIncomingCall(J.to(Ee.from),Ee.fromRanges.map(ee=>u.to(ee)))}Ae.to=Oe})(pe=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ve;(function(Ae){function Oe(Ee){return new o.CallHierarchyOutgoingCall(J.to(Ee.to),Ee.fromRanges.map(ee=>u.to(ee)))}Ae.to=Oe})(ve=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var De;(function(Ae){function Oe(ee){return{range:ee.range&&u.from(ee.range),uri:ee.uri}}Ae.from=Oe;function Ee(ee){return new o.Location(y.URI.revive(ee.uri),u.to(ee.range))}Ae.to=Ee})(De=e.location||(e.location={}));var Re;(function(Ae){function Oe(ee){const Ne=ee,ze=ee;return{originSelectionRange:Ne.originSelectionRange?u.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:ze.uri,range:u.from(Ne.targetRange?Ne.targetRange:ze.range),targetSelectionRange:Ne.targetSelectionRange?u.from(Ne.targetSelectionRange):void 0}}Ae.from=Oe;function Ee(ee){return{targetUri:y.URI.revive(ee.uri),targetRange:u.to(ee.range),targetSelectionRange:ee.targetSelectionRange?u.to(ee.targetSelectionRange):void 0,originSelectionRange:ee.originSelectionRange?u.to(ee.originSelectionRange):void 0}}Ae.to=Ee})(Re=e.DefinitionLink||(e.DefinitionLink={}));var $e;(function(Ae){function Oe(ee){return{range:u.from(ee.range),contents:O.fromMany(ee.contents)}}Ae.from=Oe;function Ee(ee){return new o.Hover(ee.contents.map(O.to),u.to(ee.range))}Ae.to=Ee})($e=e.Hover||(e.Hover={}));var re;(function(Ae){function Oe(ee){return{range:u.from(ee.range),expression:ee.expression}}Ae.from=Oe;function Ee(ee){return new o.EvaluatableExpression(u.to(ee.range),ee.expression)}Ae.to=Ee})(re=e.EvaluatableExpression||(e.EvaluatableExpression={}));var le;(function(Ae){function Oe(ee){if(ee instanceof o.InlineValueText)return{type:"text",range:u.from(ee.range),text:ee.text};if(ee instanceof o.InlineValueVariableLookup)return{type:"variable",range:u.from(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};if(ee instanceof o.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(ee.range),expression:ee.expression};throw new Error("Unknown 'InlineValue' type")}Ae.from=Oe;function Ee(ee){switch(ee.type){case"text":return{range:u.to(ee.range),text:ee.text};case"variable":return{range:u.to(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};case"expression":return{range:u.to(ee.range),expression:ee.expression}}}Ae.to=Ee})(le=e.InlineValue||(e.InlineValue={}));var fe;(function(Ae){function Oe(ee){return{frameId:ee.frameId,stoppedLocation:u.from(ee.stoppedLocation)}}Ae.from=Oe;function Ee(ee){return new o.InlineValueContext(ee.frameId,u.to(ee.stoppedLocation))}Ae.to=Ee})(fe=e.InlineValueContext||(e.InlineValueContext={}));var Z;(function(Ae){function Oe(ee){return{range:u.from(ee.range),kind:ee.kind}}Ae.from=Oe;function Ee(ee){return new o.DocumentHighlight(u.to(ee.range),ee.kind)}Ae.to=Ee})(Z=e.DocumentHighlight||(e.DocumentHighlight={}));var se;(function(Ae){function Oe(Ee){switch(Ee){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}Ae.to=Oe})(se=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ne;(function(Ae){function Oe(Ee){return{triggerKind:se.to(Ee.triggerKind),triggerCharacter:Ee.triggerCharacter}}Ae.to=Oe})(ne=e.CompletionContext||(e.CompletionContext={}));var N;(function(Ae){function Oe(ee){switch(ee){case o.CompletionItemTag.Deprecated:return 1}}Ae.from=Oe;function Ee(ee){switch(ee){case 1:return o.CompletionItemTag.Deprecated}}Ae.to=Ee})(N=e.CompletionItemTag||(e.CompletionItemTag={}));var z;(function(Ae){const Oe=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function Ee(ze){return Oe.get(ze)??9}Ae.from=Ee;const ee=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Ne(ze){return ee.get(ze)??o.CompletionItemKind.Property}Ae.to=Ne})(z=e.CompletionItemKind||(e.CompletionItemKind={}));var X;(function(Ae){function Oe(Ee,ee){const Ne=new o.CompletionItem(Ee.label);return Ne.insertText=Ee.insertText,Ne.kind=z.to(Ee.kind),Ne.tags=Ee.tags?.map(N.to),Ne.detail=Ee.detail,Ne.documentation=D.isMarkdownString(Ee.documentation)?O.to(Ee.documentation):Ee.documentation,Ne.sortText=Ee.sortText,Ne.filterText=Ee.filterText,Ne.preselect=Ee.preselect,Ne.commitCharacters=Ee.commitCharacters,v.Range.isIRange(Ee.range)?Ne.range=u.to(Ee.range):typeof Ee.range=="object"&&(Ne.range={inserting:u.to(Ee.range.insert),replacing:u.to(Ee.range.replace)}),Ne.keepWhitespace=typeof Ee.insertTextRules>"u"?!1:Boolean(Ee.insertTextRules&1),typeof Ee.insertTextRules<"u"&&Ee.insertTextRules&4?Ne.insertText=new o.SnippetString(Ee.insertText):(Ne.insertText=Ee.insertText,Ne.textEdit=Ne.range instanceof o.Range?new o.TextEdit(Ne.range,Ne.insertText):void 0),Ee.additionalTextEdits&&Ee.additionalTextEdits.length>0&&(Ne.additionalTextEdits=Ee.additionalTextEdits.map(ze=>q.to(ze))),Ne.command=ee&&Ee.command?ee.fromInternal(Ee.command):void 0,Ne}Ae.to=Oe})(X=e.CompletionItem||(e.CompletionItem={}));var _;(function(Ae){function Oe(ee){if(typeof ee.label!="string"&&!Array.isArray(ee.label))throw new TypeError("Invalid label");return{label:ee.label,documentation:O.fromStrict(ee.documentation)}}Ae.from=Oe;function Ee(ee){return{label:ee.label,documentation:D.isMarkdownString(ee.documentation)?O.to(ee.documentation):ee.documentation}}Ae.to=Ee})(_=e.ParameterInformation||(e.ParameterInformation={}));var ue;(function(Ae){function Oe(ee){return{label:ee.label,documentation:O.fromStrict(ee.documentation),parameters:Array.isArray(ee.parameters)?ee.parameters.map(_.from):[],activeParameter:ee.activeParameter}}Ae.from=Oe;function Ee(ee){return{label:ee.label,documentation:D.isMarkdownString(ee.documentation)?O.to(ee.documentation):ee.documentation,parameters:Array.isArray(ee.parameters)?ee.parameters.map(_.to):[],activeParameter:ee.activeParameter}}Ae.to=Ee})(ue=e.SignatureInformation||(e.SignatureInformation={}));var be;(function(Ae){function Oe(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(ue.from):[]}}Ae.from=Oe;function Ee(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(ue.to):[]}}Ae.to=Ee})(be=e.SignatureHelp||(e.SignatureHelp={}));var ke;(function(Ae){function Oe(Ee,ee){const Ne=new o.InlayHint(l.to(ee.position),typeof ee.label=="string"?ee.label:ee.label.map(ge.to.bind(void 0,Ee)),ee.kind&&Pe.to(ee.kind));return Ne.textEdits=ee.textEdits&&ee.textEdits.map(q.to),Ne.tooltip=D.isMarkdownString(ee.tooltip)?O.to(ee.tooltip):ee.tooltip,Ne.paddingLeft=ee.paddingLeft,Ne.paddingRight=ee.paddingRight,Ne}Ae.to=Oe})(ke=e.InlayHint||(e.InlayHint={}));var ge;(function(Ae){function Oe(Ee,ee){const Ne=new o.InlayHintLabelPart(ee.label);return Ne.tooltip=D.isMarkdownString(ee.tooltip)?O.to(ee.tooltip):ee.tooltip,d.Command.is(ee.command)&&(Ne.command=Ee.fromInternal(ee.command)),ee.location&&(Ne.location=De.to(ee.location)),Ne}Ae.to=Oe})(ge=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Pe;(function(Ae){function Oe(ee){return ee}Ae.from=Oe;function Ee(ee){return ee}Ae.to=Ee})(Pe=e.InlayHintKind||(e.InlayHintKind={}));var Ie;(function(Ae){function Oe(ee){return{range:u.from(ee.range),url:ee.target,tooltip:ee.tooltip}}Ae.from=Oe;function Ee(ee){let Ne;if(ee.url)try{Ne=typeof ee.url=="string"?y.URI.parse(ee.url,!0):y.URI.revive(ee.url)}catch{}return new o.DocumentLink(u.to(ee.range),Ne)}Ae.to=Ee})(Ie=e.DocumentLink||(e.DocumentLink={}));var je;(function(Ae){function Oe(ee){const Ne=new o.ColorPresentation(ee.label);return ee.textEdit&&(Ne.textEdit=q.to(ee.textEdit)),ee.additionalTextEdits&&(Ne.additionalTextEdits=ee.additionalTextEdits.map(ze=>q.to(ze))),Ne}Ae.to=Oe;function Ee(ee){return{label:ee.label,textEdit:ee.textEdit?q.from(ee.textEdit):void 0,additionalTextEdits:ee.additionalTextEdits?ee.additionalTextEdits.map(Ne=>q.from(Ne)):void 0}}Ae.from=Ee})(je=e.ColorPresentation||(e.ColorPresentation={}));var qe;(function(Ae){function Oe(ee){return new o.Color(ee[0],ee[1],ee[2],ee[3])}Ae.to=Oe;function Ee(ee){return[ee.red,ee.green,ee.blue,ee.alpha]}Ae.from=Ee})(qe=e.Color||(e.Color={}));var et;(function(Ae){function Oe(ee){return{range:u.from(ee.range)}}Ae.from=Oe;function Ee(ee){return new o.SelectionRange(u.to(ee.range))}Ae.to=Ee})(et=e.SelectionRange||(e.SelectionRange={}));var _e;(function(Ae){function Oe(Ee){switch(Ee){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}Ae.to=Oe})(_e=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(Ae){function Oe(ee){switch(ee){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.On:default:return 1}}Ae.from=Oe;function Ee(ee){switch(ee){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 1:default:return o.TextEditorLineNumbersStyle.On}}Ae.to=Ee})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var st;(function(Ae){function Oe(ee){if(ee===o.EndOfLine.CRLF)return 1;if(ee===o.EndOfLine.LF)return 0}Ae.from=Oe;function Ee(ee){if(ee===1)return o.EndOfLine.CRLF;if(ee===0)return o.EndOfLine.LF}Ae.to=Ee})(st=e.EndOfLine||(e.EndOfLine={}));var ht;(function(Ae){function Oe(Ee){if(typeof Ee=="object")return Ee.viewId;switch(Ee){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ae.from=Oe})(ht=e.ProgressLocation||(e.ProgressLocation={}));var Ue;(function(Ae){function Oe(Ee){const ee={start:Ee.start+1,end:Ee.end+1};return Ee.kind&&(ee.kind=it.from(Ee.kind)),ee}Ae.from=Oe})(Ue=e.FoldingRange||(e.FoldingRange={}));var it;(function(Ae){function Oe(Ee){if(Ee)switch(Ee){case o.FoldingRangeKind.Comment:return d.FoldingRangeKind.Comment;case o.FoldingRangeKind.Imports:return d.FoldingRangeKind.Imports;case o.FoldingRangeKind.Region:return d.FoldingRangeKind.Region}}Ae.from=Oe})(it=e.FoldingRangeKind||(e.FoldingRangeKind={}));var oe;(function(Ae){function Oe(Ee){if(Ee)return{pinned:typeof Ee.preview=="boolean"?!Ee.preview:void 0,inactive:Ee.background,preserveFocus:Ee.preserveFocus,selection:typeof Ee.selection=="object"?u.from(Ee.selection):void 0,override:typeof Ee.override=="boolean"?w.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Ae.from=Oe})(oe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var W;(function(Ae){function Oe(ze){return ze instanceof o.RelativePattern?ze.toJSON():typeof ze=="string"?ze:Ee(ze)||ee(ze)?new o.RelativePattern(ze.baseUri??ze.base,ze.pattern).toJSON():ze}Ae.from=Oe;function Ee(ze){const Qe=ze;return Qe?y.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function ee(ze){const Qe=ze;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Ne(ze){return typeof ze=="string"?ze:new o.RelativePattern(y.URI.revive(ze.baseUri),ze.pattern)}Ae.to=Ne})(W=e.GlobPattern||(e.GlobPattern={}));var ae;(function(Ae){function Oe(Ee){if(Ee){if(Array.isArray(Ee))return Ee.map(Oe);if(typeof Ee=="string")return Ee;{const ee=Ee;return{language:ee.language,scheme:ee.scheme,pattern:W.from(ee.pattern),exclusive:ee.exclusive,notebookType:ee.notebookType}}}else return}Ae.from=Oe})(ae=e.LanguageSelector||(e.LanguageSelector={}));var Ce;(function(Ae){function Oe(ee){return{start:ee.start,end:ee.end}}Ae.from=Oe;function Ee(ee){return new o.NotebookRange(ee.start,ee.end)}Ae.to=Ee})(Ce=e.NotebookRange||(e.NotebookRange={}));var Le;(function(Ae){function Oe(ee){return{timing:typeof ee.runStartTime=="number"&&typeof ee.runEndTime=="number"?{startTime:ee.runStartTime,endTime:ee.runEndTime}:void 0,executionOrder:ee.executionOrder,success:ee.lastRunSuccess}}Ae.to=Oe;function Ee(ee){return{lastRunSuccess:ee.success,runStartTime:ee.timing?.startTime,runEndTime:ee.timing?.endTime,executionOrder:ee.executionOrder}}Ae.from=Ee})(Le=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Be;(function(Ae){function Oe(Ee){if(Ee===m.NotebookCellExecutionState.Unconfirmed)return o.NotebookCellExecutionState.Pending;if(Ee===m.NotebookCellExecutionState.Pending)return;if(Ee===m.NotebookCellExecutionState.Executing)return o.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ee}`)}Ae.to=Oe})(Be=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Xe;(function(Ae){function Oe(ee){switch(ee){case o.NotebookCellKind.Markup:return m.CellKind.Markup;case o.NotebookCellKind.Code:default:return m.CellKind.Code}}Ae.from=Oe;function Ee(ee){switch(ee){case m.CellKind.Markup:return o.NotebookCellKind.Markup;case m.CellKind.Code:default:return o.NotebookCellKind.Code}}Ae.to=Ee})(Xe=e.NotebookCellKind||(e.NotebookCellKind={}));var Ze;(function(Ae){function Oe(ee){const Ne={metadata:ee.metadata??Object.create(null),cells:[]};for(const ze of ee.cells)o.NotebookCellData.validate(ze),Ne.cells.push(ft.from(ze));return Ne}Ae.from=Oe;function Ee(ee){const Ne=new o.NotebookData(ee.cells.map(ft.to));return(0,E.isEmptyObject)(ee.metadata)||(Ne.metadata=ee.metadata),Ne}Ae.to=Ee})(Ze=e.NotebookData||(e.NotebookData={}));var ft;(function(Ae){function Oe(ee){return{cellKind:Xe.from(ee.kind),language:ee.languageId,mime:ee.mime,source:ee.value,metadata:ee.metadata,internalMetadata:Le.from(ee.executionSummary??{}),outputs:ee.outputs?ee.outputs.map(lt.from):[]}}Ae.from=Oe;function Ee(ee){return new o.NotebookCellData(Xe.to(ee.cellKind),ee.source,ee.language,ee.mime,ee.outputs?ee.outputs.map(lt.to):void 0,ee.metadata,ee.internalMetadata?Le.to(ee.internalMetadata):void 0)}Ae.to=Ee})(ft=e.NotebookCellData||(e.NotebookCellData={}));var mt;(function(Ae){function Oe(ee){return{mime:ee.mime,valueBytes:t.VSBuffer.wrap(ee.data)}}Ae.from=Oe;function Ee(ee){return new o.NotebookCellOutputItem(ee.valueBytes.buffer,ee.mime)}Ae.to=Ee})(mt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var lt;(function(Ae){function Oe(ee){return{outputId:ee.id,items:ee.items.map(mt.from),metadata:ee.metadata}}Ae.from=Oe;function Ee(ee){const Ne=ee.items.map(mt.to);return new o.NotebookCellOutput(Ne,ee.outputId,ee.metadata)}Ae.to=Ee})(lt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ot;(function(Ae){function Oe(Ne){return ee(Ne)?{include:(0,E.withNullAsUndefined)(W.from(Ne.include)),exclude:(0,E.withNullAsUndefined)(W.from(Ne.exclude))}:(0,E.withNullAsUndefined)(W.from(Ne))}Ae.from=Oe;function Ee(Ne){return ee(Ne)?{include:W.to(Ne.include),exclude:W.to(Ne.exclude)}:W.to(Ne)}Ae.to=Ee;function ee(Ne){const ze=Ne;return ze?!(0,E.isUndefinedOrNull)(ze.include)&&!(0,E.isUndefinedOrNull)(ze.exclude):!1}})(ot=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var rt;(function(Ae){function Oe(Ee,ee,Ne){const ze=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{alignment:Ee.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:ee.toInternal(ze,Ne),text:Ee.text,tooltip:Ee.tooltip,accessibilityInformation:Ee.accessibilityInformation,priority:Ee.priority}}Ae.from=Oe})(rt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Tt;(function(Ae){function Oe(Ee,ee,Ne){const ze=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{command:ee.toInternal(ze,Ne),label:Ee.label,description:Ee.description,detail:Ee.detail}}Ae.from=Oe})(Tt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var kt;(function(Ae){function Oe(Ee){return{transientOutputs:Ee?.transientOutputs??!1,transientCellMetadata:Ee?.transientCellMetadata??{},transientDocumentMetadata:Ee?.transientDocumentMetadata??{},cellContentMetadata:Ee?.cellContentMetadata??{}}}Ae.from=Oe})(kt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Mt;(function(Ae){function Oe(ee){return{uri:ee.uri,provides:ee.provides}}Ae.from=Oe;function Ee(ee){return new o.NotebookRendererScript(y.URI.revive(ee.uri),ee.provides)}Ae.to=Ee})(Mt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var pt;(function(Ae){function Oe(ee){return{message:O.fromStrict(ee.message)||"",type:0,expected:ee.expectedOutput,actual:ee.actualOutput,location:ee.location&&{range:u.from(ee.location.range),uri:ee.location.uri}}}Ae.from=Oe;function Ee(ee){const Ne=new o.TestMessage(typeof ee.message=="string"?ee.message:O.to(ee.message));return Ne.actualOutput=ee.actual,Ne.expectedOutput=ee.expected,Ne.location=ee.location?De.to(ee.location):void 0,Ne}Ae.to=Ee})(pt=e.TestMessage||(e.TestMessage={}));var Ct;(function(Ae){Ae.namespace=b.namespaceTestTag,Ae.denamespace=b.denamespaceTestTag})(Ct=e.TestTag||(e.TestTag={}));var Rt;(function(Ae){function Oe(ee){const Ne=(0,h.getPrivateApiFor)(ee).controllerId;return{extId:f.TestId.fromExtHostTestItem(ee,Ne).toString(),label:ee.label,uri:y.URI.revive(ee.uri),busy:ee.busy,tags:ee.tags.map(ze=>Ct.namespace(Ne,ze.id)),range:v.Range.lift(u.from(ee.range)),description:ee.description||null,sortText:ee.sortText||null,error:ee.error&&O.fromStrict(ee.error)||null}}Ae.from=Oe;function Ee(ee){return{parent:void 0,error:void 0,id:f.TestId.fromString(ee.extId).localId,label:ee.label,uri:y.URI.revive(ee.uri),tags:(ee.tags||[]).map(Ne=>{const{tagId:ze}=Ct.denamespace(Ne);return new o.TestTag(ze)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(ee.range||void 0),canResolveChildren:!1,busy:ee.busy,description:ee.description||void 0,sortText:ee.sortText||void 0}}Ae.toPlain=Ee})(Rt=e.TestItem||(e.TestItem={})),function(Ae){function Oe(ee){return{id:ee.id}}Ae.from=Oe;function Ee(ee){return new o.TestTag(ee.id)}Ae.to=Ee}(Ct=e.TestTag||(e.TestTag={}));var Ut;(function(Ae){const Oe=(ee,Ne)=>{const ze=[];for(const[Ge,tt]of Ne)f.TestId.compare(tt.item.extId,Ge)===2&&(Ne.delete(Ge),ze.push(tt));const Qe={...Rt.toPlain(ee.item),parent:void 0,taskStates:ee.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(tt=>tt.type===0).map(pt.to)})),children:ze.map(Ge=>Oe(Ge,Ne))};for(const Ge of Qe.children)Ge.parent=Qe;return Qe};function Ee(ee){const Ne=[],ze=new Map;for(const Qe of ee.items){ze.set(Qe.item.extId,Qe);const Ge=f.TestId.root(Qe.item.extId);ee.request.targets.some(tt=>tt.controllerId===Ge&&tt.testIds.includes(Qe.item.extId))&&Ne.push(Qe)}return{completedAt:ee.completedAt,results:Ne.map(Qe=>Oe(Qe,ze))}}Ae.to=Ee})(Ut=e.TestResults||(e.TestResults={}));var xe;(function(Ae){function Oe(ze){return{covered:ze.covered,total:ze.covered}}function Ee(ze){return"line"in ze?l.from(ze):u.from(ze)}function ee(ze){return"branches"in ze?{count:ze.executionCount,location:Ee(ze.location),type:1,branches:ze.branches.length?ze.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&Ee(Qe.location)})):void 0}:{type:0,count:ze.executionCount,location:Ee(ze.location)}}Ae.fromDetailed=ee;function Ne(ze){return{uri:ze.uri,statement:Oe(ze.statementCoverage),branch:ze.branchCoverage&&Oe(ze.branchCoverage),function:ze.functionCoverage&&Oe(ze.functionCoverage),details:ze.detailedCoverage?.map(ee)}}Ae.fromFile=Ne})(xe=e.TestCoverage||(e.TestCoverage={}));var Ot;(function(Ae){function Oe(Ee){switch(Ee){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}Ae.to=Oe})(Ot=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var jt;(function(Ae){function Oe(ee){const Ne=new o.TypeHierarchyItem(Q.to(ee.kind),ee.name,ee.detail||"",y.URI.revive(ee.uri),u.to(ee.range),u.to(ee.selectionRange));return Ne._sessionId=ee._sessionId,Ne._itemId=ee._itemId,Ne}Ae.to=Oe;function Ee(ee,Ne,ze){if(Ne=Ne??ee._sessionId,ze=ze??ee._itemId,Ne===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:ze,kind:Q.from(ee.kind),name:ee.name,detail:ee.detail??"",uri:ee.uri,range:u.from(ee.range),selectionRange:u.from(ee.selectionRange),tags:ee.tags?.map(ce.from)}}Ae.from=Ee})(jt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var qt;(function(Ae){function Oe(Ee){if(!!Ee)return{value:Ee.value,tooltip:Ee.tooltip}}Ae.from=Oe})(qt=e.ViewBadge||(e.ViewBadge={}));var bt;(function(Ae){function Oe(ze,Qe,Ge){const tt=Qe.fileData;return tt?new class extends o.DataTransferItem{asFile(){return{name:tt.name,uri:y.URI.revive(tt.uri),data:(0,A.once)(()=>Ge())}}}("",Qe.id):ze===R.Mimes.uriList&&Qe.uriListData?new o.DataTransferItem(Ne(Qe.uriListData)):new o.DataTransferItem(Qe.asString)}Ae.to=Oe;async function Ee(ze,Qe){const Ge=await Qe.asString();if(ze===R.Mimes.uriList)return{id:Qe.id,asString:"",fileData:void 0,uriListData:ee(Ge)};const tt=Qe.asFile();return{id:Qe.id,asString:Ge,fileData:tt?{name:tt.name,uri:tt.uri}:void 0}}Ae.from=Ee;function ee(ze){return k.UriList.split(ze).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return y.URI.parse(Qe)}catch{}return Qe})}function Ne(ze){return k.UriList.create(ze.map(Qe=>typeof Qe=="string"?Qe:y.URI.revive(Qe)))}})(bt=e.DataTransferItem||(e.DataTransferItem={}));var Pt;(function(Ae){function Oe(ee,Ne){const ze=ee.items.map(([Qe,Ge])=>[Qe,bt.to(Qe,Ge,()=>Ne(Ge.id))]);return new o.DataTransfer(ze)}Ae.toDataTransfer=Oe;async function Ee(ee){const Ne={items:[]},ze=[];return ee.forEach((Qe,Ge)=>{ze.push((async()=>{Ne.items.push([Ge,await bt.from(Ge,Qe)])})())}),await Promise.all(ze),Ne}Ae.toDataTransferDTO=Ee})(Pt=e.DataTransfer||(e.DataTransfer={}))}),define(Se[233],ye([1,0,2,10,7,14,63]),function(te,e,a,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class T{constructor(C,R,P,E={timeout:1500,errors:3}){this.c=C,this.d=R,this.f=P,this.g=E,this.a=new D.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(C){return(R,P,E)=>{const v={dispose:this.a.push([R,P,C])};return Array.isArray(E)&&E.push(v),v}}async $participateInSave(C,R){const P=a.URI.revive(C);let E=!1;const y=setTimeout(()=>E=!0,this.g.timeout),v=[];try{for(const d of[...this.a]){if(E)break;const g=this.d.getDocument(P),h=await this.h(d,{document:g,reason:A.TextDocumentSaveReason.to(R)});v.push(h)}}finally{clearTimeout(y)}return v}h([C,R,P],E){const y=this.b.get(C);return typeof y=="number"&&y>this.g.errors?Promise.resolve(!1):this.i(P,C,R,E).then(()=>!0,v=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this.c.error(v),!(v instanceof Error)||v.message!=="concurrent_edits"){const d=this.b.get(C);this.b.set(C,d?d+1:1),typeof d=="number"&&d>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(C,R,P,E){const y=[],v=Date.now(),{document:d,reason:g}=E,{version:h}=d,w=Object.freeze({document:d,reason:g,waitUntil(m){if(Object.isFrozen(y))throw(0,t.illegalState)("waitUntil can not be called async");y.push(Promise.resolve(m))}});try{R.apply(P,[w])}catch(m){return Promise.reject(m)}return Object.freeze(y),new Promise((m,f)=>{const b=setTimeout(()=>f(new Error("timeout")),this.g.timeout);return Promise.all(y).then(s=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-v}ms`),clearTimeout(b),m(s)}).catch(s=>{clearTimeout(b),f(s)})}).then(m=>{const f={edits:[]};for(const b of m)if(Array.isArray(b)&&b.every(s=>s instanceof k.TextEdit))for(const{newText:s,newEol:o,range:c}of b)f.edits.push({resource:d.uri,versionId:void 0,textEdit:{range:c&&A.Range.from(c),text:s,eol:o&&A.EndOfLine.from(o)}});if(f.edits.length!==0)return h===d.version?this.f.$tryApplyWorkspaceEdit(f):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=T}),define(Se[234],ye([1,0,15,2,14,7,90]),function(te,e,a,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class T{constructor(P,E,y,v){this.start=P,this.deletedCount=E,this.deletedItems=y,this.items=v}asApiEvent(){return{range:new A.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(P,E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1,notebook:P}}constructor(P,E,y){this.notebook=P,this.h=E,this.j=y,this.handle=y.handle,this.uri=t.URI.revive(y.uri),this.cellKind=y.cellKind,this.a=y.outputs.map(k.NotebookCellOutput.to),this.e=y.internalMetadata??{},this.b=Object.freeze(y.metadata??{}),this.d=Object.freeze(k.NotebookCellExecutionSummary.to(y.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const P=this,E=this.h.getDocument(this.uri);if(!E)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const y={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:k.NotebookCellKind.to(this.j.cellKind),document:E.document,get mime(){return P.g},set mime(v){P.g=v},get outputs(){return P.a.slice(0)},get metadata(){return P.b},get executionSummary(){return P.d}};this.f=Object.freeze(y)}return this.f}setOutputs(P){this.a=P.map(k.NotebookCellOutput.to)}setOutputItems(P,E,y){const v=y.map(k.NotebookCellOutputItem.to),d=this.a.find(g=>g.id===P);if(d&&(E||(d.items.length=0),d.items.push(...v),d.items.length>1&&d.items.every(g=>D.isTextStreamMime(g.mime)))){const g=new Map,h=[];d.items.forEach(w=>{let m;g.has(w.mime)?m=g.get(w.mime):(m=[],g.set(w.mime,m),h.push(w.mime)),m.push(w.data)}),d.items.length=0,h.forEach(w=>{const m=D.compressOutputItemStreams(g.get(w));d.items.push({mime:w,data:m.buffer})})}}setMetadata(P){this.b=Object.freeze(P)}setInternalMetadata(P){this.e=P,this.d=Object.freeze(k.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.ExtHostCell=S;class C{constructor(P,E,y,v,d){this.k=P,this.l=E,this.m=y,this.uri=v,this.handle=C.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=d.viewType,this.f=Object.freeze(d.metadata??Object.create(null)),this.r([[0,0,d.cells]],!0,void 0),this.g=d.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const P=this,E={get uri(){return P.uri},get version(){return P.g},get notebookType(){return P.d},get isDirty(){return P.h},get isUntitled(){return P.uri.scheme===a.Schemas.untitled},get isClosed(){return P.j},get metadata(){return P.f},get cellCount(){return P.b.length},cellAt(y){return y=P.n(y),P.b[y].apiCell},getCells(y){return(y?P.p(y):P.b).map(d=>d.apiCell)},save(){return P.q()}};this.e=Object.freeze(E)}return this.e}acceptDocumentPropertiesChanged(P){P.metadata&&(this.f=Object.freeze({...this.f,...P.metadata}))}acceptDirty(P){this.h=P}acceptModelChanged(P,E,y){this.g=P.versionId,this.h=E,this.acceptDocumentPropertiesChanged({metadata:y});const v={notebook:this.apiNotebook,metadata:y,cellChanges:[],contentChanges:[]},d=[];for(const h of P.rawEvents)h.kind===D.NotebookCellsChangeType.ModelChange?this.r(h.changes,!1,v.contentChanges):h.kind===D.NotebookCellsChangeType.Move?this.s(h.index,h.length,h.newIdx,v.contentChanges):h.kind===D.NotebookCellsChangeType.Output?(this.t(h.index,h.outputs),d.push({cell:this.b[h.index].apiCell,outputs:this.b[h.index].apiCell.outputs})):h.kind===D.NotebookCellsChangeType.OutputItem?(this.u(h.index,h.outputId,h.append,h.outputItems),d.push({cell:this.b[h.index].apiCell,outputs:this.b[h.index].apiCell.outputs})):h.kind===D.NotebookCellsChangeType.ChangeCellLanguage?(this.v(h.index,h.language),d.push({cell:this.b[h.index].apiCell,document:this.b[h.index].apiCell.document})):h.kind===D.NotebookCellsChangeType.ChangeCellContent?d.push({cell:this.b[h.index].apiCell,document:this.b[h.index].apiCell.document}):h.kind===D.NotebookCellsChangeType.ChangeCellMime?this.w(h.index,h.mime):h.kind===D.NotebookCellsChangeType.ChangeCellMetadata?(this.x(h.index,h.metadata),d.push({cell:this.b[h.index].apiCell,metadata:this.b[h.index].apiCell.metadata})):h.kind===D.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(h.index,h.internalMetadata),d.push({cell:this.b[h.index].apiCell,executionSummary:this.b[h.index].apiCell.executionSummary}));const g=new Map;for(let h=0;h<d.length;h++){const w=d[h],m=g.get(w.cell);if(m===void 0){const f=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...w});g.set(w.cell,f-1)}else v.cellChanges[m]={...v.cellChanges[m],...w}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(P){return P=P|0,P<0?0:P>=this.b.length?this.b.length-1:P}o(P){let E=P.start|0,y=P.end|0;return E<0&&(E=0),y>this.b.length&&(y=this.b.length),P.with({start:E,end:y})}p(P){P=this.o(P);const E=[];for(let y=P.start;y<P.end;y++)E.push(this.b[y]);return E}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(P,E,y){if(this.j)return;const v=[],d=[],g=[];if(P.reverse().forEach(h=>{const m=h[2].map(s=>{const o=new S(this,this.l,s);return E||d.push(S.asModelAddData(this.apiNotebook,s)),o}),f=new T(h[0],h[1],[],m),b=this.b.splice(h[0],h[1],...m);for(const s of b)g.push(s.uri),f.deletedItems.push(s.apiCell);v.push(f)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:g}),y)for(const h of v)y.push(h.asApiEvent())}s(P,E,y,v){const d=this.b.splice(P,E);this.b.splice(y,0,...d);const g=[new T(P,E,d.map(h=>h.apiCell),[]),new T(y,0,[],d)];for(const h of g)v.push(h.asApiEvent())}t(P,E){this.b[P].setOutputs(E)}u(P,E,y,v){this.b[P].setOutputItems(E,y,v)}v(P,E){const y=this.b[P];y.apiCell.document.languageId!==E&&this.m.$acceptModelLanguageChanged(y.uri,E)}w(P,E){const y=this.b[P];y.apiCell.mime=E}x(P,E){this.b[P].setMetadata(E)}y(P,E){this.b[P].setInternalMetadata(E)}getCellFromApiCell(P){return this.b.find(E=>E.apiCell===P)}getCellFromIndex(P){return this.b[P]}getCell(P){return this.b.find(E=>E.handle===P)}getCellIndex(P){return this.b.indexOf(P)}}e.ExtHostNotebookDocument=C,C.a=0}),define(Se[135],ye([1,0,10,14,7]),function(te,e,a,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(T,S,C,R,P,E){this.id=T,this.f=S,this.notebookData=C,this.a=[],this.b=[],this.d=!1,this.a=P,this.b=R,this.c=E}get apiEditor(){if(!this.e){const T=this;this.e={get notebook(){return T.notebookData.apiNotebook},get selection(){return T.a[0]},set selection(S){this.selections=[S]},get selections(){return T.a},set selections(S){if(!Array.isArray(S)||!S.every(k.NotebookRange.isNotebookRange))throw(0,a.illegalArgument)("selections");T.a=S,T.g(S)},get visibleRanges(){return T.b},revealRange(S,C){T.f.$tryRevealRange(T.id,t.NotebookRange.from(S),C??k.NotebookEditorRevealType.Default)},get viewColumn(){return T.c}},A.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(T){this.d=T}_acceptVisibleRanges(T){this.b=T}_acceptSelections(T){this.a=T}g(T){this.f.$trySetSelections(this.id,T.map(t.NotebookRange.from))}_acceptViewColumn(T){this.c=T}}e.ExtHostNotebookEditor=A,A.apiEditorsToExtHost=new WeakMap}),define(Se[235],ye([1,0,4,13,14]),function(te,e,a,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let A=class{constructor(T,S){this.c=T,this.d=S,this.a=new a.Emitter,this.b=new a.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(T,S){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,S);const C=this.d.getEditorById(T);S.visibleRanges&&C._acceptVisibleRanges(S.visibleRanges.ranges.map(k.NotebookRange.to)),S.selections&&C._acceptSelections(S.selections.selections.map(k.NotebookRange.to)),S.visibleRanges&&this.b.fire({notebookEditor:C.apiEditor,visibleRanges:C.apiEditor.visibleRanges}),S.selections&&this.a.fire(Object.freeze({notebookEditor:C.apiEditor,selections:C.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const S in T)this.d.getEditorById(S)._acceptViewColumn(k.ViewColumn.to(T[S]))}};A=Ve([We(0,t.ILogService)],A),e.ExtHostNotebookEditors=A}),define(Se[236],ye([1,0,14,124,175,21,60,10]),function(te,e,a,t,k,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(E){this.b=0,this.c=new Map,this.a=E}async withProgress(E,y,v){const d=this.b++,{title:g,location:h,cancellable:w}=y,m={label:(0,k.localize)(0,null,E.displayName||E.name),id:E.identifier.value};return this.a.$startProgress(d,{location:a.ProgressLocation.from(h),title:g,source:m,cancellable:w},E.isUnderDevelopment?void 0:E.identifier.value).catch(T.onUnexpectedExternalError),this.d(d,v,!!w)}d(E,y,v){let d;v&&(d=new A.CancellationTokenSource,this.c.set(E,d));const g=w=>{this.a.$progressEnd(w),this.c.delete(w),d?.dispose()};let h;try{h=y(new R(this.a,E),v&&d?d.token:A.CancellationToken.None)}catch(w){throw g(E),w}return h.then(w=>g(E),w=>g(E)),h}$acceptProgressCanceled(E){const y=this.c.get(E);y&&(y.cancel(),this.c.delete(E))}}e.ExtHostProgress=S;function C(P,E){return P.message=E.message,typeof E.increment=="number"&&(typeof P.increment=="number"?P.increment+=E.increment:P.increment=E.increment),P}class R extends t.Progress{constructor(E,y){super(v=>this.throttledReport(v)),this.c=E,this.d=y}throttledReport(E){this.c.$progressReport(this.d,E)}}Ve([(0,D.throttle)(100,(P,E)=>C(P,E),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Se[136],ye([1,0,35,132,56,91,68,14,2]),function(te,e,a,t,k,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const C=(m,f,b,s)=>{let o=f;return{enumerable:!0,configurable:!1,get(){return o},set(c){if(!b(o,c)){const u=o;o=c,m.listener?.(s(c,u))}}}},R=(m,f)=>m===f,P={range:(m,f)=>m===f?!0:!m||!f?!1:m.isEqual(f),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(m,f)=>!(m.length!==f.length||m.some(b=>!f.find(s=>b.id===s.id)))},E=m=>f=>({op:4,update:m(f)}),y=(m,f)=>({range:(()=>{let b;const s=E(o=>({range:a.Range.lift(T.Range.from(o))}));return{enumerable:!0,configurable:!1,get(){return b},set(o){m.listener?.({op:6}),P.range(b,o)||(b=o,m.listener?.(s(o)))}}})(),label:C(m,f,P.label,E(b=>({label:b}))),description:C(m,void 0,P.description,E(b=>({description:b}))),sortText:C(m,void 0,P.sortText,E(b=>({sortText:b}))),canResolveChildren:C(m,!1,P.canResolveChildren,b=>({op:2,state:b})),busy:C(m,!1,P.busy,E(b=>({busy:b}))),error:C(m,void 0,P.error,E(b=>({error:T.MarkdownString.fromStrict(b)||null}))),tags:C(m,[],P.tags,(b,s)=>({op:1,new:b.map(T.TestTag.from),old:s.map(T.TestTag.from)}))}),v=m=>{const f=k.TestId.fromString(m.extId),b=new g(f.controllerId,f.localId,m.label,S.URI.revive(m.uri)||void 0);return b.range=T.Range.to(m.range||void 0),b.description=m.description||void 0,b.sortText=m.sortText||void 0,b.tags=m.tags.map(s=>T.TestTag.to({id:(0,D.denamespaceTestTag)(s).tagId})),b},d=m=>{let f;for(const b of m.tests){const s=v(b.item);(0,t.getPrivateApiFor)(s).parent=f,f=s}return f};e.toItemFromContext=d;class g{constructor(f,b,s,o){if(b.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(b)} symbol`);const c=(0,t.createPrivateApiFor)(this,f);Object.defineProperties(this,{id:{value:b,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return c.parent instanceof h?void 0:c.parent}},children:{value:(0,A.createTestItemChildren)(c,t.getPrivateApiFor,g),enumerable:!0,writable:!1},...y(c,s)})}}e.TestItemImpl=g;class h extends g{constructor(f,b){super(f,f,b,void 0),this._isRoot=!0}}e.TestItemRootImpl=h;class w extends A.TestItemCollection{constructor(f,b,s){super({controllerId:f,getDocumentVersion:o=>o&&s.getDocument(o)?.version,getApiFor:t.getPrivateApiFor,getChildren:o=>o.children,root:new h(f,b),toITestItem:T.TestItem.from})}}e.ExtHostTestItemCollection=w}),define(Se[137],ye([1,0,48,10,99,14,7]),function(te,e,a,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class T{constructor(E,y,v){const d=T.c.nextId();E.$registerTextEditorDecorationType(y.identifier,d,A.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:d,dispose(){E.$removeTextEditorDecorationType(d)}})}}e.TextEditorDecorationType=T,T.c=new k.IdGenerator("TextEditorDecorationType");class S{constructor(E,y){this.g=[],this.h=void 0,this.j=!1,this.c=E,this.d=E.version,this.e=y.undoStopBefore,this.f=y.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(E,y){this.k();let v=null;if(E instanceof D.Position)v=new D.Range(E,E);else if(E instanceof D.Range)v=E;else throw new Error("Unrecognized location");this.l(v,y,!1)}insert(E,y){this.k(),this.l(new D.Range(E,E),y,!0)}delete(E){this.k();let y=null;if(E instanceof D.Range)y=E;else throw new Error("Unrecognized location");this.l(y,null,!0)}l(E,y,v){const d=this.c.validateRange(E);this.g.push({range:d,text:y,forceMoveMarkers:v})}setEndOfLine(E){if(this.k(),E!==D.EndOfLine.LF&&E!==D.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this.h=E}}e.TextEditorEdit=S;class C{constructor(E,y,v,d){this.c=E,this.d=y,this._accept(v),this.e=d;const g=this;this.value={get tabSize(){return g.f},set tabSize(h){g.m(h)},get indentSize(){return g.g},set indentSize(h){g.o(h)},get insertSpaces(){return g.h},set insertSpaces(h){g.q(h)},get cursorStyle(){return g.j},set cursorStyle(h){g.s(h)},get lineNumbers(){return g.k},set lineNumbers(h){g.t(h)}}}_accept(E){this.f=E.tabSize,this.g=E.indentSize,this.h=E.insertSpaces,this.j=E.cursorStyle,this.k=A.TextEditorLineNumbersStyle.to(E.lineNumbers)}l(E){if(E==="auto")return"auto";if(typeof E=="number"){const y=Math.floor(E);return y>0?y:null}if(typeof E=="string"){const y=parseInt(E,10);return isNaN(y)?null:y>0?y:null}return null}m(E){const y=this.l(E);if(y!==null){if(typeof y=="number"){if(this.f===y)return;this.f=y}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:y}))}}n(E){if(E==="tabSize")return"tabSize";if(typeof E=="number"){const y=Math.floor(E);return y>0?y:null}if(typeof E=="string"){const y=parseInt(E,10);return isNaN(y)?null:y>0?y:null}return null}o(E){const y=this.n(E);if(y!==null){if(typeof y=="number"){if(this.g===y)return;this.g=y}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:y}))}}p(E){return E==="auto"?"auto":E==="false"?!1:Boolean(E)}q(E){const y=this.p(E);if(typeof y=="boolean"){if(this.h===y)return;this.h=y}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:y}))}s(E){this.j!==E&&(this.j=E,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:E})))}t(E){this.k!==E&&(this.k=E,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:A.TextEditorLineNumbersStyle.from(E)})))}assign(E){const y={};let v=!1;if(typeof E.tabSize<"u"){const d=this.l(E.tabSize);d==="auto"?(v=!0,y.tabSize=d):typeof d=="number"&&this.f!==d&&(this.f=d,v=!0,y.tabSize=d)}if(typeof E.indentSize<"u"){const d=this.n(E.indentSize);d==="tabSize"?(v=!0,y.indentSize=d):typeof d=="number"&&this.g!==d&&(this.g=d,v=!0,y.indentSize=d)}if(typeof E.insertSpaces<"u"){const d=this.p(E.insertSpaces);d==="auto"?(v=!0,y.insertSpaces=d):this.h!==d&&(this.h=d,v=!0,y.insertSpaces=d)}typeof E.cursorStyle<"u"&&this.j!==E.cursorStyle&&(this.j=E.cursorStyle,v=!0,y.cursorStyle=E.cursorStyle),typeof E.lineNumbers<"u"&&this.k!==E.lineNumbers&&(this.k=E.lineNumbers,v=!0,y.lineNumbers=A.TextEditorLineNumbersStyle.from(E.lineNumbers)),v&&this.u("setOptions",this.c.$trySetOptions(this.d,y))}u(E,y){y.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${E}' failed:'`),this.e.warn(v)})}}e.ExtHostTextEditorOptions=C;class R{constructor(E,y,v,d,g,h,w,m){this.id=E,this.j=y,this.k=v,this.g=!1,this.h=new Set,this.c=g,this.d=new C(this.j,this.id,h,v),this.e=w,this.f=m;const f=this;this.value=Object.freeze({get document(){return d.getValue()},set document(b){throw(0,t.readonly)("document")},get selection(){return f.c&&f.c[0]},set selection(b){if(!(b instanceof D.Selection))throw(0,t.illegalArgument)("selection");f.c=[b],f.l()},get selections(){return f.c},set selections(b){if(!Array.isArray(b)||b.some(s=>!(s instanceof D.Selection)))throw(0,t.illegalArgument)("selections");f.c=b,f.l()},get visibleRanges(){return f.e},set visibleRanges(b){throw(0,t.readonly)("visibleRanges")},get options(){return f.d.value},set options(b){f.g||f.d.assign(b)},get viewColumn(){return f.f},set viewColumn(b){throw(0,t.readonly)("viewColumn")},edit(b,s={undoStopBefore:!0,undoStopAfter:!0}){if(f.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const o=new S(d.getValue(),s);return b(o),f.m(o)},insertSnippet(b,s,o={undoStopBefore:!0,undoStopAfter:!0}){if(f.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!s||Array.isArray(s)&&s.length===0)c=f.c.map(u=>A.Range.from(u));else if(s instanceof D.Position){const{lineNumber:u,column:r}=A.Position.from(s);c=[{startLineNumber:u,startColumn:r,endLineNumber:u,endColumn:r}]}else if(s instanceof D.Range)c=[A.Range.from(s)];else{c=[];for(const u of s)if(u instanceof D.Range)c.push(A.Range.from(u));else{const{lineNumber:r,column:l}=A.Position.from(u);c.push({startLineNumber:r,startColumn:l,endLineNumber:r,endColumn:l})}}return y.$tryInsertSnippet(E,d.getValue().version,b.value,c,o)},setDecorations(b,s){const o=s.length===0;o&&!f.h.has(b.key)||(o?f.h.delete(b.key):f.h.add(b.key),f.n(()=>{if(A.isDecorationOptionsArr(s))return y.$trySetDecorations(E,b.key,A.fromRangeOrRangeWithMessage(s));{const c=new Array(4*s.length);for(let u=0,r=s.length;u<r;u++){const l=s[u];c[4*u]=l.start.line+1,c[4*u+1]=l.start.character+1,c[4*u+2]=l.end.line+1,c[4*u+3]=l.end.character+1}return y.$trySetDecorationsFast(E,b.key,c)}}))},revealRange(b,s){f.n(()=>y.$tryRevealRange(E,A.Range.from(b),s||D.TextEditorRevealType.Default))},show(b){y.$tryShowEditor(E,A.ViewColumn.from(b))},hide(){y.$tryHideEditor(E)}})}dispose(){(0,a.ok)(!this.g),this.g=!0}_acceptOptions(E){(0,a.ok)(!this.g),this.d._accept(E)}_acceptVisibleRanges(E){(0,a.ok)(!this.g),this.e=E}_acceptViewColumn(E){(0,a.ok)(!this.g),this.f=E}_acceptSelections(E){(0,a.ok)(!this.g),this.c=E}async l(){const E=this.c.map(A.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,E)),this.value}m(E){const y=E.finalize();if(y.edits.length===0&&!y.setEndOfLine)return Promise.resolve(!0);const v=y.edits.map(g=>g.range);v.sort((g,h)=>g.end.line===h.end.line?g.end.character===h.end.character?g.start.line===h.start.line?g.start.character-h.start.character:g.start.line-h.start.line:g.end.character-h.end.character:g.end.line-h.end.line);for(let g=0,h=v.length-1;g<h;g++){const w=v[g].end;if(v[g+1].start.isBefore(w))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=y.edits.map(g=>({range:A.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,y.documentVersionId,d,{setEndOfLine:typeof y.setEndOfLine=="number"?A.EndOfLine.from(y.setEndOfLine):void 0,undoStopBefore:y.undoStopBefore,undoStopAfter:y.undoStopAfter})}n(E){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):E().then(()=>this,y=>(y instanceof Error&&y.name==="DISPOSED"||this.k.warn(y),null))}}e.ExtHostTextEditor=R}),define(Se[237],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribTerminalQuickFixes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribTerminalQuickFixes.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[238],ye([1,0,189,10,42,121,125,43,27,237,201,191]),function(te,e,a,t,k,A,D,T,S,C,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const E=T.Registry.as(D.Extensions.JSONContribution);class y{constructor(b,s,o){this.a=b,this.b=s,this.c=o}d(b,s){this.a({type:b,message:s,extensionId:this.b.identifier,extensionPointId:this.c})}error(b){this.d(k.default.Error,b)}warn(b){this.d(k.default.Warning,b)}info(b){this.d(k.default.Info,b)}}e.ExtensionMessageCollector=y;class v{static a(b){const s=new Set;for(let o=0,c=b.length;o<c;o++)s.add(S.ExtensionIdentifier.toKey(b[o].description.identifier));return s}static compute(b,s){if(!b||!b.length)return new v(s,[]);if(!s||!s.length)return new v([],b);const o=this.a(b),c=this.a(s),u=s.filter(l=>!o.has(S.ExtensionIdentifier.toKey(l.description.identifier))),r=b.filter(l=>!c.has(S.ExtensionIdentifier.toKey(l.description.identifier)));return new v(u,r)}constructor(b,s){this.added=b,this.removed=s}}e.ExtensionPointUserDelta=v;class d{constructor(b,s){this.name=b,this.defaultExtensionKind=s,this.a=null,this.b=null,this.c=null}setHandler(b){if(this.a!==null)throw new Error("Handler already set!");this.a=b,this.d()}acceptUsers(b){this.c=v.compute(this.b,b),this.b=b,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(b){(0,t.onUnexpectedError)(b)}}}e.ExtensionPoint=d;const g={type:"string",enum:["ui","workspace"],enumDescriptions:[a.localize(0,null),a.localize(1,null)]},h="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:a.localize(2,null),properties:{vscode:{type:"string",description:a.localize(3,null),default:"^1.22.0"}}},publisher:{description:a.localize(4,null),type:"string"},displayName:{description:a.localize(5,null),type:"string"},categories:{description:a.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:a.localize(7,null)}]}},galleryBanner:{type:"object",description:a.localize(8,null),properties:{color:{description:a.localize(9,null),type:"string"},theme:{description:a.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:a.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:a.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:a.localize(13,null)},enabledApiProposals:{markdownDescription:a.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(C.allApiProposals),markdownEnumDescriptions:Object.values(C.allApiProposals)}},activationEvents:{description:a.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:a.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:a.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:a.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:a.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:a.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:a.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:a.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:a.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:a.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:a.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:a.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:a.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:a.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:a.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:a.localize(30,null)},{label:"onUri",body:"onUri",description:a.localize(31,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:a.localize(32,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:a.localize(33,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:a.localize(34,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:a.localize(35,null)},{label:"onRenderer",description:a.localize(36,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:a.localize(37,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:a.localize(38,null)},{label:"*",description:a.localize(39,null),body:"*"}]}},badges:{type:"array",description:a.localize(40,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:a.localize(41,null)},href:{type:"string",description:a.localize(42,null)},description:{type:"string",description:a.localize(43,null)}}}},markdown:{type:"string",description:a.localize(44,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:a.localize(45,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:a.localize(46,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:a.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:a.localize(48,null),type:"array",items:g,default:["workspace"],defaultSnippets:[{body:["ui"],description:a.localize(49,null)},{body:["workspace"],description:a.localize(50,null)},{body:["ui","workspace"],description:a.localize(51,null)},{body:["workspace","ui"],description:a.localize(52,null)},{body:[],description:a.localize(53,null)}]},capabilities:{description:a.localize(54,null),type:"object",properties:{virtualWorkspaces:{description:a.localize(55,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:a.localize(56,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(57,null),a.localize(58,null),a.localize(59,null)]},description:{type:"string",markdownDescription:a.localize(60,null)}}},untrustedWorkspaces:{description:a.localize(61,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:a.localize(62,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(63,null),a.localize(64,null),a.localize(65,null)]},restrictedConfigurations:{description:a.localize(66,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:a.localize(67,null)}}}}},sponsor:{description:a.localize(68,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:a.localize(69,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:a.localize(70,null),type:"string"},"vscode:uninstall":{description:a.localize(71,null),type:"string"}}},icon:{type:"string",description:a.localize(72,null)},l10n:{type:"string",description:a.localize(73,null)}}};class w{constructor(){this.a=new Map}registerExtensionPoint(b){if(this.a.has(b.extensionPoint))throw new Error("Duplicate extension point: "+b.extensionPoint);const s=new d(b.extensionPoint,b.defaultExtensionKind);return this.a.set(b.extensionPoint,s),b.activationEventsGenerator&&P.ImplicitActivationEvents.register(b.extensionPoint,b.activationEventsGenerator),e.schema.properties.contributes.properties[b.extensionPoint]=b.jsonSchema,E.registerSchema(h,e.schema),s}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=w;const m={ExtensionsRegistry:"ExtensionsRegistry"};T.Registry.add(m.ExtensionsRegistry,new w),e.ExtensionsRegistry=T.Registry.as(m.ExtensionsRegistry),E.registerSchema(h,e.schema),E.registerSchema(R.productSchemaId,{properties:{extensionEnabledApiProposals:{description:a.localize(74,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(C.allApiProposals),markdownEnumDescriptions:Object.values(C.allApiProposals)}}]}}}})}),define(Se[239],ye([1,0,186,11,23,238,53,4]),function(te,e,a,t,k,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:a.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:a.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:a.localize(2,null),default:""}}};var C;(function(E){function y(v,d,g){if(!v)return;const h=t.isString(v.type)?v.type:void 0;if(!h||h.length===0){g.error(a.localize(3,null));return}const w=[];if(Array.isArray(v.required))for(const m of v.required)t.isString(m)&&w.push(m);return{extensionId:d.value,taskType:h,required:w,properties:v.properties?k.deepClone(v.properties):{},when:v.when?D.ContextKeyExpr.deserialize(v.when):void 0}}E.from=y})(C||(C={}));const R=A.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:a.localize(4,null),type:"array",items:S}});class P{constructor(){this.d=new T.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((y,v)=>{R.setHandler((d,g)=>{this.c=void 0;try{for(const h of g.removed){const w=h.value;for(const m of w)this.a&&m.type&&this.a[m.type]&&delete this.a[m.type]}for(const h of g.added){const w=h.value;for(const m of w){const f=C.from(m,h.description.identifier,h.collector);f&&(this.a[f.taskType]=f)}}(g.removed.length>0||g.added.length>0)&&this.d.fire()}catch{}y(void 0)})})}onReady(){return this.b}get(y){return this.a[y]}all(){return Object.keys(this.a).map(y=>this.a[y])}getJsonSchema(){if(this.c===void 0){const y=[];for(const v of this.all()){const d={type:"object",additionalProperties:!1};v.required.length>0&&(d.required=v.required.slice(0)),v.properties!==void 0?d.properties=k.deepClone(v.properties):d.properties=Object.create(null),d.properties.type={type:"string",enum:[v.taskType]},y.push(d)}this.c={oneOf:y}}return this.c}}e.TaskDefinitionRegistry=new P}),define(Se[240],ye([1,0,187,11,24,23,53,239]),function(te,e,a,t,k,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new D.RawContextKey("taskRunning",!1,a.localize(0,null)),e.TASKS_CATEGORY={value:a.localize(1,null),original:"Tasks"};var S;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(S=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(F){function $(M){if(!M)return F.Strong;switch(M.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=$}(S=e.ShellQuoting||(e.ShellQuoting={}));var C;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(C=e.CommandOptions||(e.CommandOptions={}));var R;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(R=e.RevealKind||(e.RevealKind={})),function(F){function $(M){switch(M.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=$}(R=e.RevealKind||(e.RevealKind={}));var P;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(P=e.RevealProblemKind||(e.RevealProblemKind={})),function(F){function $(M){switch(M.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=$}(P=e.RevealProblemKind||(e.RevealProblemKind={}));var E;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(E=e.PanelKind||(e.PanelKind={})),function(F){function $(M){switch(M.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=$}(E=e.PanelKind||(e.PanelKind={}));var y;(function(F){F.defaults={echo:!0,reveal:R.Always,revealProblems:P.Never,focus:!1,panel:E.Shared,showReuseMessage:!0,clear:!1}})(y=e.PresentationOptions||(e.PresentationOptions={}));var v;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(v=e.RuntimeType||(e.RuntimeType={})),function(F){function $(H){switch(H.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=$;function M(H){switch(H){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=M}(v=e.RuntimeType||(e.RuntimeType={}));var d;(function(F){function $(M){return t.isString(M)?M:M.value}F.value=$})(d=e.CommandString||(e.CommandString={}));var g;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function $(H){return H===F.Clean._id||H===F.Build._id||H===F.Rebuild._id||H===F.Test._id}F.is=$;function M(H){if(H!==void 0)return t.isString(H)?$(H)?{_id:H,isDefault:!1}:void 0:H}F.from=M})(g=e.TaskGroup||(e.TaskGroup={}));var h;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(h=e.TaskScope||(e.TaskScope={}));var w;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function $(M){switch(M){case F.User:return 2;case F.WorkspaceFile:return 5;default:return 6}}F.toConfigurationTarget=$})(w=e.TaskSourceKind||(e.TaskSourceKind={}));var m;(function(F){F.parallel="parallel",F.sequence="sequence"})(m=e.DependsOrder||(e.DependsOrder={}));var f;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(f=e.RunOnOptions||(e.RunOnOptions={}));var b;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:f.default,instanceLimit:1}})(b=e.RunOptions||(e.RunOptions={}));class s{constructor($,M,H,K,q,Y){this._label="",this._id=$,M&&(this._label=M),H&&(this.type=H),this.runOptions=K,this.configurationProperties=q,this._source=Y}getDefinition($){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const $={folder:this.d(),id:this._id};return JSON.stringify($)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches($,M=!1){if($===void 0)return!1;if(t.isString($))return $===this._label||$===this.configurationProperties.identifier||M&&$===this._id;const H=this.getDefinition(!0);return H!==void 0&&H._key===$._key}getQualifiedLabel(){const $=this.getWorkspaceFolder();return $?`${this._label} (${$.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages($){this.c===void 0&&(this.c=[]),$&&(this.c=this.c.concat($))}get taskLoadMessages(){return this.c}}e.CommonTask=s;class o extends s{constructor($,M,H,K,q,Y,Q,ce){super($,H,void 0,Q,ce,M),this.command={},this._source=M,this.hasDefinedMatchers=Y,q&&(this.command=q)}clone(){return new o(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition($=!1){if($&&this._source.customizes!==void 0)return this._source.customizes;{let M;switch(this.command?this.command.runtime:void 0){case v.Shell:M="shell";break;case v.Process:M="process";break;case v.CustomExecution:M="customExecution";break;case void 0:M="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:M,_key:this._id,id:this._id}}}static is($){return $ instanceof o}getMapKey(){const $=this._source.config.workspaceFolder;return $?`${$.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===w.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const $=this.d();if(!$)return;let M=this.configurationProperties.identifier;this._source.kind!==w.Workspace&&(M+=this._source.kind);const H={type:e.CUSTOMIZED_TASK_TYPE,folder:$,id:M};return JSON.stringify(H)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?k.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f($){return new o($._id,$._source,$._label,$.type,$.command,$.hasDefinedMatchers,$.runOptions,$.configurationProperties)}}e.CustomTask=o;class c extends s{constructor($,M,H,K,q,Y,Q){super($,H,K,Y,Q,M),this._source=M,this.configures=q}static is($){return $ instanceof c}f($){return $}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?k.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===w.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const $=this.d();if(!$)return;let M=this.configurationProperties.identifier;this._source.kind!==w.Workspace&&(M+=this._source.kind);const H={type:e.CUSTOMIZED_TASK_TYPE,folder:$,id:M};return JSON.stringify(H)}}e.ConfiguringTask=c;class u extends s{constructor($,M,H,K,q,Y,Q,ce,ie){super($,H,K,ce,ie,M),this.defines=q,this.hasDefinedMatchers=Q,this.command=Y,this.icon=ie.icon,this.hide=ie.hide}clone(){return new u(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is($){return $ instanceof u}getMapKey(){const $=this._source.workspaceFolder;return $?`${this._source.scope.toString()}|${$.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const $={type:"contributed",scope:this._source.scope,id:this._id};return $.folder=this.d(),JSON.stringify($)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f($){return new u($._id,$._source,$._label,$.type,$.defines,$.command,$.hasDefinedMatchers,$.runOptions,$.configurationProperties)}}e.ContributedTask=u;class r extends s{constructor($,M,H,K,q,Y){super($,H,K,q,Y,M),this._source=M}clone(){return new r(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is($){return $ instanceof r}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f($){return new r($._id,$._source,$._label,$.type,$.runOptions,$.configurationProperties)}}e.InMemoryTask=r;var l;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(l=e.ExecutionEngine||(e.ExecutionEngine={})),function(F){F._default=F.Terminal}(l=e.ExecutionEngine||(e.ExecutionEngine={}));var n;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(n=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class i{constructor($){this.c=new Map;for(let M=0;M<$.length;M++)this.c.set($[M].uri.toString(),M)}compare($,M){const H=$.getWorkspaceFolder(),K=M.getWorkspaceFolder();if(H&&K){let q=this.c.get(H.uri.toString());q=q===void 0?0:q+1;let Y=this.c.get(K.uri.toString());return Y=Y===void 0?0:Y+1,q===Y?$._label.localeCompare(M._label):q-Y}else return!H&&K?-1:H&&!K?1:0}}e.TaskSorter=i;var p;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(p=e.TaskEventKind||(e.TaskEventKind={}));var I;(function(F){F.SingleRun="singleRun",F.Background="background"})(I=e.TaskRunType||(e.TaskRunType={}));var L;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(L=e.TaskRunSource||(e.TaskRunSource={}));var U;(function(F){function $(M,H,K,q){if(H){const Y={kind:M,taskId:H._id,taskName:H.configurationProperties.name,runType:H.configurationProperties.isBackground?"background":"singleRun",group:H.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:K,__task:H};return M==="start"?Y.resolvedVariables=q:M==="processStarted"?Y.processId=q:M==="processEnded"&&(Y.exitCode=q),Object.freeze(Y)}else return Object.freeze({kind:"changed"})}F.create=$})(U=e.TaskEvent||(e.TaskEvent={}));var G;(function(F){function $(H){const K=Object.keys(H).sort();let q="";for(const Y of K){let Q=H[Y];Q instanceof Object?Q=$(Q):typeof Q=="string"&&(Q=Q.replace(/,/g,",,")),q+=Y+","+Q+","}return q}function M(H){const q={_key:$(H),type:H.taskType};return Object.assign(q,H),q}F.create=M})(G=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var V;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection"})(V=e.TaskSettingId||(e.TaskSettingId={}));var O;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(O=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var B;(function(F){function $(M,H){const K=T.TaskDefinitionRegistry.get(M.type);if(K===void 0){const ce=A.deepClone(M);return delete ce._key,G.create(ce)}const q=Object.create(null);q.type=K.taskType;const Y=new Set;K.required.forEach(ce=>Y.add(ce));const Q=K.properties;for(const ce of Object.keys(Q)){const ie=M[ce];if(ie!=null)q[ce]=ie;else if(Y.has(ce)){const de=Q[ce];if(de.default!==void 0)q[ce]=A.deepClone(de.default);else switch(de.type){case"boolean":q[ce]=!1;break;case"number":case"integer":q[ce]=0;break;case"string":q[ce]="";break;default:H.error(a.localize(2,null,JSON.stringify(M,void 0,0),ce));return}}}return G.create(q)}F.createTaskIdentifier=$})(B=e.TaskDefinition||(e.TaskDefinition={}))}),define(Se[241],ye([1,0,10]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class t{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((D,T)=>{this.b=D,this.d=T,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(D){this.f||this.h||(this.f=!0,this.g=D,this.a&&this.b(D))}resolveErr(D){this.f||this.h||(this.h=!0,this.i=D,this.a?this.d(D):(0,a.onUnexpectedError)(D))}then(D,T){return this.j().then(D,T)}catch(D){return this.j().then(void 0,D)}finally(D){return this.j().finally(D)}}e.LazyPromise=t;class k extends t{constructor(){super(),this.h=!0,this.i=new a.CancellationError}}e.CanceledLazyPromise=k}),define(Se[57],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class a{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++a.count}}e.ProxyIdentifier=a,a.count=0;const t=[];function k(T){const S=new a(T);return t[S.nid]=S,S}e.createProxyIdentifier=k;function A(T){return t[T].sid}e.getStringIdentifierForProxy=A;class D{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=D}),define(Se[5],ye([1,0,57]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var t;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(d){d[d.UnknownInput=0]="UnknownInput",d[d.TextInput=1]="TextInput",d[d.TextDiffInput=2]="TextDiffInput",d[d.TextMergeInput=3]="TextMergeInput",d[d.NotebookInput=4]="NotebookInput",d[d.NotebookDiffInput=5]="NotebookDiffInput",d[d.CustomEditorInput=6]="CustomEditorInput",d[d.WebviewEditorInput=7]="WebviewEditorInput",d[d.TerminalEditorInput=8]="TerminalEditorInput",d[d.InteractiveEditorInput=9]="InteractiveEditorInput"})(k=e.TabInputKind||(e.TabInputKind={}));var A;(function(d){d[d.TAB_OPEN=0]="TAB_OPEN",d[d.TAB_CLOSE=1]="TAB_CLOSE",d[d.TAB_UPDATE=2]="TAB_UPDATE",d[d.TAB_MOVE=3]="TAB_MOVE"})(A=e.TabModelOperationKind||(e.TabModelOperationKind={}));var D;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var T;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(T=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var S;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(S=e.CellOutputKind||(e.CellOutputKind={}));var C;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(C=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var R;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(R=e.CandidatePortSource||(e.CandidatePortSource={}));class P{static mixin(g){return g._id=P.a++,g}}e.IdObject=P,P.a=0;var E;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.kindModifier="m",d.commandIdent="n",d.commandId="o",d.commandArguments="p"})(E=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var y;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(y=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var v;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(v=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,a.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,a.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,a.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,a.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,a.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,a.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,a.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,a.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,a.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,a.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,a.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,a.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,a.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,a.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,a.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,a.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,a.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,a.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,a.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,a.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,a.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,a.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,a.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,a.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,a.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,a.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,a.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,a.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,a.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,a.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,a.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,a.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,a.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,a.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,a.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,a.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,a.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,a.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,a.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,a.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,a.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,a.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,a.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,a.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,a.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,a.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,a.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,a.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,a.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,a.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,a.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,a.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,a.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,a.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,a.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,a.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,a.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,a.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,a.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,a.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,a.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,a.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,a.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,a.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,a.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,a.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,a.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,a.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,a.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,a.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,a.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,a.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,a.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,a.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,a.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,a.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,a.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,a.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,a.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,a.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,a.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,a.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,a.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,a.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,a.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,a.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,a.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,a.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,a.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,a.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,a.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,a.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,a.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,a.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,a.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,a.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,a.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,a.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,a.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,a.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,a.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,a.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,a.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,a.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,a.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,a.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,a.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,a.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,a.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,a.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,a.createProxyIdentifier)("ExtHostLocalization")}}),define(Se[69],ye([1,0,3,13,5,16]),function(te,e,a,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,a.createDecorator)("IExtHostApiDeprecationService");let D=class{constructor(S,C){this.c=C,this.a=new Set,this.b=S.getProxy(k.MainContext.MainThreadTelemetry)}report(S,C,R){const P=this.d(S,C);this.a.has(P)||(this.a.add(P),C.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${S}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:S}))}d(S,C){return`${S}-${C.identifier.value}`}};D=Ve([We(0,A.IExtHostRpcService),We(1,t.ILogService)],D),e.ExtHostApiDeprecationService=D,e.NullApiDeprecationService=Object.freeze(new class{report(T,S,C){}})}),define(Se[242],ye([1,0,4,5,7,27]),function(te,e,a,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class D{constructor(S){this.b=new Map,this.c=[],this.d=new a.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=S.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(S){return this.c=S,Promise.resolve()}async getSession(S,C,R,P={}){const E=A.ExtensionIdentifier.toKey(S.identifier),y=this.f.get(E)||[],v=[...R].sort().join(" ");let d=y.find(g=>g.providerId===C&&g.scopes===v);if(d)return d.result;{const g=this.g(S,E,C,R,P);d={providerId:C,scopes:v,result:g},y.push(d),this.f.set(E,y);try{await g}finally{const h=y.findIndex(w=>w.providerId===C&&w.scopes===v);h>-1&&(y.splice(h),this.f.set(E,y))}return g}}async g(S,C,R,P,E={}){await this.a.$ensureProvider(R);const y=S.displayName||S.name;return this.a.$getSession(R,P,C,y,E)}async removeSession(S,C){const R=this.b.get(S);return R?R.provider.removeSession(C):this.a.$removeSession(S,C)}registerAuthenticationProvider(S,C,R,P){if(this.b.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this.b.set(S,{label:C,provider:R,options:P??{supportsMultipleAccounts:!1}}),this.c.find(y=>y.id===S)||this.c.push({id:S,label:C});const E=R.onDidChangeSessions(y=>{this.a.$sendDidChangeSessions(S,{added:y.added??[],changed:y.changed??[],removed:y.removed??[]})});return this.a.$registerAuthenticationProvider(S,C,P?.supportsMultipleAccounts??!1),new k.Disposable(()=>{E.dispose(),this.b.delete(S);const y=this.c.findIndex(v=>v.id===S);y>-1&&this.c.splice(y),this.a.$unregisterAuthenticationProvider(S)})}$createSession(S,C){const R=this.b.get(S);if(R)return Promise.resolve(R.provider.createSession(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,C){const R=this.b.get(S);if(R)return Promise.resolve(R.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,C){const R=this.b.get(S);if(R)return Promise.resolve(R.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,C){return this.d.fire({provider:{id:S,label:C}}),Promise.resolve()}}e.ExtHostAuthentication=D}),define(Se[243],ye([1,0,5,16,14]),function(te,e,a,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(T,S){this.a=T.getProxy(a.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:C=>S.getDocument(C)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(T,S,C){const R=k.WorkspaceEdit.from(T,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,C?.isRefactoring??!1)}};A=Ve([We(0,t.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(Se[244],ye([1,0,5]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(A){const D=A.getProxy(a.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return D.$readText()},writeText(T){return D.$writeText(T)}})}}e.ExtHostClipboard=t});var Je=this&&this.__classPrivateFieldSet||function(te,e,a,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,a):k?k.value=a:e.set(te,a),a},Fe=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)};define(Se[39],ye([1,0,11,7,14,23,5,17,13,84,35,49,2,6,3,16,136,22,57,50]),function(te,e,a,t,k,A,D,T,S,C,R,P,E,y,v,d,g,h,w,m){"use strict";var f,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let s=class{constructor(n,i){f.set(this,void 0),this.b=new Map,this.c=new Map,b.set(this,void 0),Je(this,f,n.getProxy(D.MainContext.MainThreadCommands),"f"),this.d=i,Je(this,b,n.getProxy(D.MainContext.MainThreadTelemetry),"f"),this.converter=new o(this,p=>{const I=this.c.get(p);return I?.result===u.Void?I:void 0},i),this.f=[{processArgument(p){return(0,C.revive)(p)}},{processArgument(p){return(0,A.cloneAndChange)(p,function(I){if(R.Range.isIRange(I))return k.Range.to(I);if(P.Position.isIPosition(I))return k.Position.to(I);if(R.Range.isIRange(I.range)&&E.URI.isUri(I.uri))return k.location.to(I);if(I instanceof h.VSBuffer)return I.buffer.buffer;if(!Array.isArray(I))return I})}}]}registerArgumentProcessor(n){this.f.push(n)}registerApiCommand(n){const i=this.registerCommand(!1,n.id,async(...p)=>{const I=n.args.map((U,G)=>{if(!U.validate(p[G]))throw new Error(`Invalid argument '${U.name}' when running '${n.id}', received: ${p[G]}`);return U.convert(p[G])}),L=await this.executeCommand(n.internalId,...I);return n.result.convert(L,p,this.converter)},void 0,{description:n.description,args:n.args,returns:n.result.description});return this.c.set(n.id,n),new t.Disposable(()=>{i.dispose(),this.c.delete(n.id)})}registerCommand(n,i,p,I,L,U){if(this.d.trace("ExtHostCommands#registerCommand",i),!i.trim().length)throw new Error("invalid id");if(this.b.has(i))throw new Error(`command '${i}' already exists`);return this.b.set(i,{callback:p,thisArg:I,description:L,extension:U}),n&&Fe(this,f,"f").$registerCommand(i),new t.Disposable(()=>{this.b.delete(i)&&n&&Fe(this,f,"f").$unregisterCommand(i)})}executeCommand(n,...i){return this.d.trace("ExtHostCommands#executeCommand",n),this.g(n,i,!0)}async g(n,i,p){if(this.b.has(n))return Fe(this,f,"f").$fireCommandActivationEvent(n),this.h(n,i,!1);{let I=!1;const L=(0,A.cloneAndChange)(i,function(U){if(U instanceof t.Position)return k.Position.from(U);if(U instanceof t.Range)return k.Range.from(U);if(U instanceof t.Location)return k.location.from(U);if(t.NotebookRange.isNotebookRange(U))return k.NotebookRange.from(U);if(U instanceof ArrayBuffer)return I=!0,h.VSBuffer.wrap(new Uint8Array(U));if(U instanceof Uint8Array)return I=!0,h.VSBuffer.wrap(U);if(U instanceof h.VSBuffer)return I=!0,U;if(!Array.isArray(U))return U});try{const U=await Fe(this,f,"f").$executeCommand(n,I?new w.SerializableObjectWithBuffers(L):L,p);return(0,C.revive)(U)}catch(U){if(U instanceof Error&&U.message==="$executeCommand:retry")return this.g(n,i,!1);throw U}}}async h(n,i,p){const I=this.b.get(n);if(!I)throw new Error("Unknown command");const{callback:L,thisArg:U,description:G}=I;if(G)for(let O=0;O<G.args.length;O++)try{(0,a.validateConstraint)(i[O],G.args[O].constraint)}catch{throw new Error(`Running the contributed command: '${n}' failed. Illegal argument '${G.args[O].name}' - ${G.args[O].description}`)}const V=Date.now();try{return await L.apply(U,i)}catch(O){if(n===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...i);B&&(n=B.command)}throw this.d.error(O,n,I.extension?.identifier),p?new class extends Error{constructor(){super((0,m.toErrorMessage)(O)),this.id=n,this.source=I.extension?.displayName??I.extension?.name}}:O}finally{this.j(I,n,Date.now()-V)}}j(n,i,p){!n.extension||n.extension.isBuiltin||Fe(this,b,"f").$publicLog2("Extension:ActionExecuted",{extensionId:n.extension.identifier.value,id:i,duration:p})}$executeContributedCommand(n,...i){return this.d.trace("ExtHostCommands#$executeContributedCommand",n),this.b.has(n)?(i=i.map(p=>this.f.reduce((I,L)=>L.processArgument(I),p)),this.h(n,i,!0)):Promise.reject(new Error(`Contributed command '${n}' does not exist.`))}getCommands(n=!1){return this.d.trace("ExtHostCommands#getCommands",n),Fe(this,f,"f").$getCommands().then(i=>(n&&(i=i.filter(p=>p[0]!=="_")),i))}$getContributedCommandHandlerDescriptions(){const n=Object.create(null);for(const[i,p]of this.b){const{description:I}=p;I&&(n[i]=I)}return Promise.resolve(n)}};f=new WeakMap,b=new WeakMap,s=Ve([We(0,d.IExtHostRpcService),We(1,S.ILogService)],s),e.ExtHostCommands=s,e.IExtHostCommands=(0,v.createDecorator)("IExtHostCommands");class o{constructor(n,i,p){this.d=n,this.f=i,this.g=p,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(n,i){if(!n)return;const p={$ident:void 0,id:n.command,title:n.title,tooltip:n.tooltip};if(!n.command)return p;const I=this.f(n.command);if(I)p.id=I.internalId,p.arguments=I.args.map((L,U)=>L.convert(n.arguments&&n.arguments[U]));else if((0,T.isNonEmptyArray)(n.arguments)){const L=`${n.command}/${++this.c}`;this.b.set(L,n),i.add((0,y.toDisposable)(()=>{this.b.delete(L),this.g.trace("CommandsConverter#DISPOSE",L)})),p.$ident=L,p.id=this.delegatingCommandId,p.arguments=[L],this.g.trace("CommandsConverter#CREATE",n.command,L)}return p}fromInternal(n){return typeof n.$ident=="string"?this.b.get(n.$ident):{command:n.id,title:n.title,arguments:n.arguments}}getActualCommand(...n){return this.b.get(n[0])}h(...n){const i=this.getActualCommand(...n);return this.g.trace("CommandsConverter#EXECUTE",n[0],i?i.command:"MISSING"),i?this.d.executeCommand(i.command,...i.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${n[0]}`)}}e.CommandsConverter=o;class c{constructor(n,i,p,I){this.name=n,this.description=i,this.validate=p,this.convert=I}optional(){return new c(this.name,`(optional) ${this.description}`,n=>n==null||this.validate(n),n=>n===void 0?void 0:n===null?null:this.convert(n))}with(n,i){return new c(n??this.name,i??this.description,this.validate,this.convert)}}e.ApiCommandArgument=c,c.Uri=new c("uri","Uri of a text document",l=>E.URI.isUri(l),l=>l),c.Position=new c("position","A position in a text document",l=>t.Position.isPosition(l),k.Position.from),c.Range=new c("range","A range in a text document",l=>t.Range.isRange(l),k.Range.from),c.Selection=new c("selection","A selection in a text document",l=>t.Selection.isSelection(l),k.Selection.from),c.Number=new c("number","",l=>typeof l=="number",l=>l),c.String=new c("string","",l=>typeof l=="string",l=>l),c.CallHierarchyItem=new c("item","A call hierarchy item",l=>l instanceof t.CallHierarchyItem,k.CallHierarchyItem.from),c.TypeHierarchyItem=new c("item","A type hierarchy item",l=>l instanceof t.TypeHierarchyItem,k.TypeHierarchyItem.from),c.TestItem=new c("testItem","A VS Code TestItem",l=>l instanceof g.TestItemImpl,k.TestItem.from);class u{constructor(n,i){this.description=n,this.convert=i}}e.ApiCommandResult=u,u.Void=new u("no result",l=>l);class r{constructor(n,i,p,I,L){this.id=n,this.internalId=i,this.description=p,this.args=I,this.result=L}}e.ApiCommand=r}),define(Se[245],ye([1,0,2,14,7,66,39,17,118,123,15]),function(te,e,a,t,k,A,D,T,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const P=[new D.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",y(t.DocumentHighlight.to))),new D.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(d,g)=>{if((0,T.isFalsyOrEmpty)(d))return;class h extends k.SymbolInformation{static to(m){const f=new h(m.name,t.SymbolKind.to(m.kind),m.containerName||"",new k.Location(g[0],t.Range.to(m.range)));return f.detail=m.detail,f.range=f.location.range,f.selectionRange=t.Range.to(m.selectionRange),f.children=m.children?m.children.map(h.to):[],f}}return d.map(h.to)})),new D.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",y(t.TextEdit.to))),new D.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range,new D.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",y(t.TextEdit.to))),new D.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,new D.ApiCommandArgument("ch","Trigger character",d=>typeof d=="string",d=>d),new D.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",y(t.TextEdit.to))),new D.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new D.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new D.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new D.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new D.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location-instances.",y(t.location.to))),new D.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Hover-instances.",y(t.Hover.to))),new D.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("position","A position in a text document",d=>Array.isArray(d)&&d.every(g=>k.Position.isPosition(g)),d=>d.map(t.Position.from))],new D.ApiCommandResult("A promise that resolves to an array of ranges.",d=>d.map(g=>{let h;for(const w of g.reverse())h=new k.SelectionRange(t.Range.to(w),h);return h}))),new D.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[D.ApiCommandArgument.String.with("query","Search string")],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",d=>d.map(t.WorkspaceSymbol.to))),new D.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(t.CallHierarchyItem.to))),new D.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(t.CallHierarchyIncomingCall.to))),new D.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(t.CallHierarchyOutgoingCall.to))),new D.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to a range and placeholder text.",d=>{if(!!d)return{range:t.Range.to(d.range),placeholder:d.text}})),new D.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("newName","The new symbol name")],new D.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",d=>{if(!!d){if(d.rejectReason)throw new Error(d.rejectReason);return t.WorkspaceEdit.to(d)}})),new D.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new D.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",d=>d.map(t.DocumentLink.to))),new D.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new k.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const g=(0,S.decodeSemanticTokensDto)(d);if(g.type==="full")return new k.SemanticTokens(g.data,void 0)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range.optional()],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new k.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const g=(0,S.decodeSemanticTokensDto)(d);if(g.type==="full")return new k.SemanticTokens(g.data,void 0)})),new D.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new D.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(d,g,h)=>{if(!d)return new k.CompletionList([]);const w=d.suggestions.map(m=>t.CompletionItem.to(m,h));return new k.CompletionList(w,d.incomplete)})),new D.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new D.ApiCommandResult("A promise that resolves to SignatureHelp.",d=>{if(d)return t.SignatureHelp.to(d)})),new D.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new D.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(d,g,h)=>y(w=>new k.CodeLens(t.Range.to(w.range),w.command&&h.fromInternal(w.command)))(d))),new D.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",d=>k.Range.isRange(d),d=>k.Selection.isSelection(d)?t.Selection.from(d):t.Range.from(d)),D.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new D.ApiCommandResult("A promise that resolves to an array of Command-instances.",(d,g,h)=>y(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(w.command)}else{const m=new k.CodeAction(w.title,w.kind?new k.CodeActionKind(w.kind):void 0);return w.edit&&(m.edit=t.WorkspaceEdit.to(w.edit)),w.command&&(m.command=h.fromInternal(w.command)),m.isPreferred=w.isPreferred,m}})(d))),new D.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",d=>d?d.map(g=>new k.ColorInformation(t.Range.to(g.range),t.Color.to(g.color))):[])),new D.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new D.ApiCommandArgument("color","The color to show and insert",d=>d instanceof k.Color,t.Color.from),new D.ApiCommandArgument("context","Context object with uri and range",d=>!0,d=>({uri:d.uri,range:t.Range.from(d.range)}))],new D.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",d=>d?d.map(t.ColorPresentation.to):[])),new D.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of Inlay objects",(d,g,h)=>d.map(t.InlayHint.to.bind(void 0,h)))),new D.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new D.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",y(d=>({viewType:d.viewType,displayName:d.displayName,options:{transientOutputs:d.options.transientOutputs,transientCellMetadata:d.options.transientCellMetadata,transientDocumentMetadata:d.options.transientDocumentMetadata},filenamePattern:d.filenamePattern.map(g=>t.NotebookExclusiveDocumentPattern.to(g))})))),new D.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineValue objects",d=>d.map(t.InlineValue.to))),new D.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new D.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",d=>a.URI.isUri(d)||typeof d=="string"&&(0,C.matchesSomeScheme)(d,R.Schemas.http,R.Schemas.https),d=>d),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[t.ViewColumn.from(d),void 0]:[t.ViewColumn.from(d.viewColumn),t.TextEditorOpenOptions.from(d)])).optional(),D.ApiCommandArgument.String.with("label","").optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[D.ApiCommandArgument.Uri.with("resource","Resource to open"),D.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[t.ViewColumn.from(d),void 0]:[t.ViewColumn.from(d.viewColumn),t.TextEditorOpenOptions.from(d)])).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[D.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),D.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),D.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="object",d=>d&&[t.ViewColumn.from(d.viewColumn),t.TextEditorOpenOptions.from(d)]).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A TypeHierarchyItem or undefined",d=>d.map(t.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",d=>d.map(t.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",d=>d.map(t.TypeHierarchyItem.to))),new D.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[D.ApiCommandArgument.TestItem],D.ApiCommandResult.Void),new D.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[D.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],D.ApiCommandResult.Void)];class E{static register(g){P.forEach(g.registerApiCommand,g)}}e.ExtHostApiCommands=E;function y(d){return g=>{if(Array.isArray(g))return g.map(d)}}function v(d){if(!Array.isArray(d))return;const g=[];for(const h of d)A.isLocationLink(h)?g.push(t.DefinitionLink.to(h)):g.push(t.location.to(h));return g}}),define(Se[246],ye([1,0,18,60,4,6,2,66,27,14,7,26,5]),function(te,e,a,t,k,A,D,T,S,C,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function y(v,d,g){const h=v.getProxy(E.MainContext.MainThreadComments);class w{constructor(){this.b=new Map,this.c=new Map,d.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const n=this.b.get(l.handle);return n?n.value:l}else if(l&&l.$mid===7){const n=this.b.get(l.commentControlHandle);if(!n)return l;const i=n.getCommentThread(l.commentThreadHandle);return i?i.value:l}else if(l&&(l.$mid===9||l.$mid===8)){const n=this.b.get(l.thread.commentControlHandle);if(!n)return l;const i=n.getCommentThread(l.thread.commentThreadHandle);return i?l.$mid===8?i.value:{thread:i.value,text:l.text}:l}else if(l&&l.$mid===10){const n=this.b.get(l.thread.commentControlHandle);if(!n)return l;const i=n.getCommentThread(l.thread.commentThreadHandle);if(!i)return l;const p=l.commentUniqueId,I=i.getCommentByUniqueId(p);return I||l}else if(l&&l.$mid===11){const n=this.b.get(l.thread.commentControlHandle);if(!n)return l;const i=n.getCommentThread(l.thread.commentThreadHandle);if(!i)return l;const p=l.text,I=l.commentUniqueId,L=i.getCommentByUniqueId(I);return L?(typeof L.body=="string"?L.body=p:L.body.value=p,L):l}return l}})}createCommentController(l,n,i){const p=w.a++,I=new f(l,p,n,i);this.b.set(I.handle,I);const L=this.c.get(S.ExtensionIdentifier.toKey(l.identifier))||[];return L.push(I),this.c.set(S.ExtensionIdentifier.toKey(l.identifier),L),I.value}$createCommentThreadTemplate(l,n,i){const p=this.b.get(l);!p||p.$createCommentThreadTemplate(n,i)}async $updateCommentThreadTemplate(l,n,i){const p=this.b.get(l);!p||p.$updateCommentThreadTemplate(n,i)}$deleteCommentThread(l,n){this.b.get(l)?.$deleteCommentThread(n)}$provideCommentingRanges(l,n,i){const p=this.b.get(l);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const I=g.getDocument(D.URI.revive(n));return(0,a.asPromise)(()=>p.commentingRangeProvider.provideCommentingRanges(I,i)).then(L=>L?L.map(U=>C.Range.from(U)):void 0)}$toggleReaction(l,n,i,p,I){const L=this.b.get(l);return!L||!L.reactionHandler?Promise.resolve(void 0):(0,a.asPromise)(()=>{const U=L.getCommentThread(n);if(U){const G=U.getCommentByUniqueId(p.uniqueIdInThread);if(L!==void 0&&G&&L.reactionHandler)return L.reactionHandler(G,o(I))}return Promise.resolve(void 0)})}dispose(){}}w.a=0;class m{set threadId(l){this.n=l}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(l){l.isEqual(this.p)||(this.p=l,this.b.range=l,this.c.fire())}get range(){return this.p}set canReply(l){this.d!==l&&(this.d=l,this.b.canReply=l,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(l){this.e=l,this.b.label=l,this.c.fire()}get contextValue(){return this.f}set contextValue(l){this.f=l,this.b.contextValue=l,this.c.fire()}get comments(){return this.q}set comments(l){this.q=l,this.b.comments=l,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(l){this.g=l,this.b.collapsibleState=l,this.c.fire()}get state(){return(0,P.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h}set state(l){(0,P.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h=l,this.b.state=l,this.c.fire()}get isDisposed(){return this.j}constructor(l,n,i,p,I,L,U,G){this.m=n,this.n=i,this.o=p,this.p=I,this.q=L,this.extensionDescription=U,this.r=G,this.handle=m.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new k.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new A.MutableDisposable,this.l.value=new A.DisposableStore,this.n===void 0&&(this.n=`${l}.${this.handle}`),h.$createCommentThread(n,this.handle,this.n,this.o,C.Range.from(this.p),U.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=L,this.i.push({dispose:()=>{h.$deleteCommentThread(n,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(O){V.range=O},get comments(){return V.comments},set comments(O){V.comments=O},get collapsibleState(){return V.collapsibleState},set collapsibleState(O){V.collapsibleState=O},get canReply(){return V.canReply},set canReply(O){V.canReply=O},get contextValue(){return V.contextValue},set contextValue(O){V.contextValue=O},get label(){return V.label},set label(O){V.label=O},get state(){return V.state},set state(O){V.state=O},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new A.DisposableStore);const l=i=>Object.prototype.hasOwnProperty.call(this.b,i),n={};l("range")&&(n.range=C.Range.from(this.p)),l("label")&&(n.label=this.label),l("contextValue")&&(n.contextValue=this.contextValue??null),l("comments")&&(n.comments=this.q.map(i=>b(this,i,this.k))),l("collapsibleState")&&(n.collapseState=c(this.g)),l("canReply")&&(n.canReply=this.canReply),l("state")&&(n.state=u(this.h)),l("isTemplate")&&(n.isTemplate=this.r),this.b={},h.$updateCommentThread(this.m,this.handle,this.n,this.o,n)}getCommentByUniqueId(l){for(const n of this.k){const i=n[0],p=n[1];if(l===p)return i}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(l=>l.dispose())}}m.a=0,Ve([(0,t.debounce)(100)],m.prototype,"eventuallyUpdateCommentThread",null);class f{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(l){this.b=l,h.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(l){this.c=l,h.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this.d}set options(l){this.d=l,h.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(l,n,i,p){this.f=l,this.g=n,this.h=i,this.i=p,this.a=new Map,h.$registerCommentController(this.handle,i,p);const I=this;this.value=Object.freeze({id:I.id,label:I.label,get options(){return I.options},set options(L){I.options=L},get commentingRangeProvider(){return I.commentingRangeProvider},set commentingRangeProvider(L){I.commentingRangeProvider=L},get reactionHandler(){return I.reactionHandler},set reactionHandler(L){I.reactionHandler=L},createCommentThread(L,U,G){return I.createCommentThread(L,U,G).value},dispose:()=>{I.dispose()}}),this.e=[],this.e.push({dispose:()=>{h.$unregisterCommentController(this.handle)}})}createCommentThread(l,n,i,p){if(typeof l=="string"){const I=new m(this.id,this.handle,l,n,i,p,this.f,!1);return this.a.set(I.handle,I),I}else{const I=new m(this.id,this.handle,void 0,l,n,i,this.f,!1);return this.a.set(I.handle,I),I}}$createCommentThreadTemplate(l,n){const i=new m(this.id,this.handle,void 0,D.URI.revive(l),C.Range.to(n),[],this.f,!0);return i.collapsibleState=T.CommentThreadCollapsibleState.Expanded,this.a.set(i.handle,i),i}$updateCommentThreadTemplate(l,n){const i=this.a.get(l);i&&(i.range=C.Range.to(n))}$deleteCommentThread(l){this.a.get(l)?.dispose(),this.a.delete(l)}getCommentThread(l){return this.a.get(l)}dispose(){this.a.forEach(l=>{l.dispose()}),this.e.forEach(l=>l.dispose())}}function b(r,l,n){let i=n.get(l);i||(i=++r.commentHandle,n.set(l,i));const p=l.author&&l.author.iconPath?l.author.iconPath.toString():void 0;return{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:i,body:typeof l.body=="string"?l.body:C.MarkdownString.from(l.body),userName:l.author.name,userIconPath:p,label:l.label,commentReactions:l.reactions?l.reactions.map(I=>s(I)):void 0,timestamp:l.timestamp?.toJSON()}}function s(r){return{label:r.label,iconPath:r.iconPath?C.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function o(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?D.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function c(r){if(r!==void 0)switch(r){case R.CommentThreadCollapsibleState.Expanded:return T.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return T.CommentThreadCollapsibleState.Collapsed}return T.CommentThreadCollapsibleState.Collapsed}function u(r){if(r!==void 0)switch(r){case R.CommentThreadState.Unresolved:return T.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return T.CommentThreadState.Resolved}return T.CommentThreadState.Unresolved}return new w}e.createExtHostComments=y}),define(Se[247],ye([1,0,23,5,25,16]),function(te,e,a,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let D=class{constructor(R,P){this.a=R.getProxy(t.MainContext.MainThreadConsole),this.b=P.consoleForward.includeStack,this.c=P.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(R,P){const E=this,y=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){E.e(R,P,y,arguments)}})}e(R,P,E,y){this.a.$logExtensionHostMessage({type:"__$console",severity:P,arguments:S(y,this.b)}),this.c&&this.f(R,E,y)}};D=Ve([We(0,A.IExtHostRpcService),We(1,k.IExtHostInitDataService)],D),e.AbstractExtHostConsoleForwarder=D;const T=1e5;function S(C,R){const P=[];if(C.length)for(let E=0;E<C.length;E++){let y=C[E];if(typeof y>"u")y="undefined";else if(y instanceof Error){const v=y;v.stack?y=v.stack:y=v.toString()}P.push(y)}if(R){const E=new Error().stack;E&&P.push({__$stack:E.split(`
`).slice(3).join(`
`)})}try{const E=(0,a.safeStringify)(P);return E.length>T?"Output omitted for a large object that exceeds the limits":E}catch(E){return`Output omitted for an object that cannot be inspected ('${E.toString()}')`}}}),define(Se[138],ye([1,0,2,5,7,3,16,13,17,8,9,26]),function(te,e,a,t,k,A,D,T,S,C,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let E=class Rn{constructor(v,d){this.h=d,this.f=new Map,this.g=v.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(v,d){const g=Rn.c++;this.f.set(g,{provider:v,extensionDescription:d}),this.g.$registerDecorationProvider(g,d.identifier.value);const h=v.onDidChangeFileDecorations&&v.onDidChangeFileDecorations(w=>{if(!w){this.g.$onDidChange(g,null);return}const m=(0,S.asArray)(w);if(m.length<=Rn.d){this.g.$onDidChange(g,m);return}this.h.warn("[Decorations] CAPPING events from decorations provider",d.identifier.value,m.length);const f=m.map(o=>({uri:o,rank:(0,C.count)(o.path,"/")})),b=(0,S.groupBy)(f,(o,c)=>o.rank-c.rank||(0,C.compare)(o.uri.path,c.uri.path)),s=[];e:for(const o of b){let c;for(const u of o){const r=(0,R.dirname)(u.uri.path);if(c!==r&&(c=r,s.push(u.uri)>=Rn.d))break e}}this.g.$onDidChange(g,s)});return new k.Disposable(()=>{h?.dispose(),this.g.$unregisterDecorationProvider(g),this.f.delete(g)})}async $provideDecorations(v,d,g){if(!this.f.has(v))return Object.create(null);const h=Object.create(null),{provider:w,extensionDescription:m}=this.f.get(v);return await Promise.all(d.map(async f=>{try{const{uri:b,id:s}=f,o=await Promise.resolve(w.provideFileDecoration(a.URI.revive(b),g));if(!o)return;try{k.FileDecoration.validate(o),o.badge&&typeof o.badge!="string"&&(0,P.checkProposedApiEnabled)(m,"codiconDecoration"),h[s]=[o.propagate,o.tooltip,o.badge,o.color]}catch(c){this.h.warn(`INVALID decoration from extension '${m}': ${c}`)}}catch(b){this.h.error(b)}})),h}};E.c=0,E.d=250,E=Ve([We(0,D.IExtHostRpcService),We(1,T.ILogService)],E),e.ExtHostDecorations=E,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(te,e,a,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,a):k?k.value=a:e.set(te,a),a},Fe=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)};define(Se[248],ye([1,0,173,122,2,5,7,14,4,13,28,46]),function(te,e,a,t,k,A,D,T,S,C,R,P){"use strict";var E,y,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class d{constructor(w,m,f,b,s,o,c){this.d=w,this.e=m,this.f=f,this.g=b,E.set(this,void 0),y.set(this,void 0),v.set(this,void 0),this.c=!1,Je(this,v,new R.ResourceMap(u=>s.getComparisonKey(u)),"f"),Je(this,E,o,"f"),Je(this,y,c,"f")}dispose(){this.c||(Fe(this,y,"f").fire([...Fe(this,v,"f").keys()]),Fe(this,E,"f")?.$clear(this.e),Fe(this,v,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(w,m){if(!w){this.clear();return}this.h();let f=[];if(k.URI.isUri(w)){if(!m){this.delete(w);return}Fe(this,v,"f").set(w,m.slice()),f=[w]}else if(Array.isArray(w)){f=[];let s;w=[...w].sort(d.j);for(const o of w){const[c,u]=o;if((!s||c.toString()!==s.toString())&&(s&&Fe(this,v,"f").get(s).length===0&&Fe(this,v,"f").delete(s),s=c,f.push(c),Fe(this,v,"f").set(c,[])),u)Fe(this,v,"f").get(c)?.push(...u);else{const r=Fe(this,v,"f").get(c);r&&(r.length=0)}}}if(Fe(this,y,"f").fire(f),!Fe(this,E,"f"))return;const b=[];for(const s of f){let o=[];const c=Fe(this,v,"f").get(s);if(c)if(c.length>this.f){o=[];const u=[D.DiagnosticSeverity.Error,D.DiagnosticSeverity.Warning,D.DiagnosticSeverity.Information,D.DiagnosticSeverity.Hint];e:for(let r=0;r<4;r++)for(const l of c)if(l.severity===u[r]&&o.push({...T.Diagnostic.from(l),modelVersionId:this.g(s)})===this.f)break e;o.push({severity:t.MarkerSeverity.Info,message:(0,a.localize)(0,null,c.length-this.f),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=c.map(u=>({...T.Diagnostic.from(u),modelVersionId:this.g(s)}));b.push([s,o])}Fe(this,E,"f").$changeMany(this.e,b)}delete(w){this.h(),Fe(this,y,"f").fire([w]),Fe(this,v,"f").delete(w),Fe(this,E,"f")?.$changeMany(this.e,[[w,void 0]])}clear(){this.h(),Fe(this,y,"f").fire([...Fe(this,v,"f").keys()]),Fe(this,v,"f").clear(),Fe(this,E,"f")?.$clear(this.e)}forEach(w,m){this.h();for(const[f,b]of this)w.call(m,f,b,this)}*[(E=new WeakMap,y=new WeakMap,v=new WeakMap,Symbol.iterator)](){this.h();for(const w of Fe(this,v,"f").keys())yield[w,this.get(w)]}get(w){this.h();const m=Fe(this,v,"f").get(w);return Array.isArray(m)?Object.freeze(m.slice(0)):[]}has(w){return this.h(),Array.isArray(Fe(this,v,"f").get(w))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(w,m){return w[0].toString()<m[0].toString()?-1:w[0].toString()>m[0].toString()?1:0}}e.DiagnosticCollection=d;let g=class gn{static _mapper(w){const m=new R.ResourceMap;for(const f of w)m.set(f,f);return{uris:Object.freeze(Array.from(m.values()))}}constructor(w,m,f,b){this.h=m,this.j=f,this.k=b,this.f=new Map,this.g=new S.DebounceEmitter({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this.g.event,gn._mapper),this.e=w.getProxy(A.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(w,m){const{f,e:b,g:s,h:o,j:c,k:u}=this,r=new class{$changeMany(i,p){b.$changeMany(i,p),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",w.value,i,p.length===0?"CLEARING":p)}$clear(i){b.$clear(i),o.trace("[DiagnosticCollection] remove all (extension, owner)",w.value,i)}dispose(){b.dispose()}};let l;if(!m)m="_generated_diagnostic_collection_name_#"+gn.c++,l=m;else if(!f.has(m))l=m;else{this.h.warn(`DiagnosticCollection with name '${m}' does already exist.`);do l=m+gn.c++;while(f.has(l))}return new class extends d{constructor(){super(m,l,gn.d,i=>u.getDocument(i)?.version,c.extUri,r,s),f.set(l,this)}dispose(){super.dispose(),f.delete(l)}}}getDiagnostics(w){if(w)return this.l(w);{const m=new Map,f=[];for(const b of this.f.values())b.forEach((s,o)=>{let c=m.get(s.toString());typeof c>"u"&&(c=f.length,m.set(s.toString(),c),f.push([s,[]])),f[c][1]=f[c][1].concat(...o)});return f}}l(w){let m=[];for(const f of this.f.values())f.has(w)&&(m=m.concat(f.get(w)));return m}$acceptMarkersChange(w){if(!this.m){const m="_generated_mirror",f=new d(m,m,gn.d,b=>{},this.j.extUri,void 0,this.g);this.f.set(m,f),this.m=f}for(const[m,f]of w)this.m.set(k.URI.revive(m),f.map(T.Diagnostic.to))}};g.c=0,g.d=1e3,g=Ve([We(1,C.ILogService),We(2,P.IExtHostFileSystemInfo)],g),e.ExtHostDiagnostics=g}),define(Se[249],ye([1,0,2,5]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class k{constructor(D){this.a=D.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(D){return this.a.$showOpenDialog(D).then(T=>T?T.map(S=>a.URI.revive(S)):void 0)}showSaveDialog(D){return this.a.$showSaveDialog(D).then(T=>T?a.URI.revive(T):void 0)}}e.ExtHostDialogs=k}),define(Se[250],ye([1,0,10,2,7,5,15,21,8]),function(te,e,a,t,k,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{constructor(P,E,y){this.d=E,this.e=y,this.b=new Map,this.c=P.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,E){if(Object.keys(D.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const y=C.a++;this.b.set(y,E),this.c.$registerTextContentProvider(y,P);let v;return typeof E.onDidChange=="function"&&(v=E.onDidChange(d=>{if(d.scheme!==P){this.e.warn(`Provider for scheme '${P}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this.d.getDocument(d)&&this.$provideTextDocumentContent(y,d).then(g=>{if(!g&&typeof g!="string")return;const h=this.d.getDocument(d);if(!h)return;const w=(0,S.splitLines)(g);if(!h.equalLines(w))return this.c.$onVirtualDocumentChange(d,g)},a.onUnexpectedError)})),new k.Disposable(()=>{this.b.delete(y)&&this.c.$unregisterTextContentProvider(y),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(P,E){const y=this.b.get(P);return y?Promise.resolve(y.provideTextDocumentContent(t.URI.revive(E),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${E.scheme}`))}}e.ExtHostDocumentContentProvider=C,C.a=0}),define(Se[251],ye([1,0,4,6,2,5,134,14,11,23,7]),function(te,e,a,t,k,A,D,T,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class P{constructor(y,v){this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter,this.d=new a.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new t.DisposableStore,this.h=new Map,this.f=y.getProxy(A.MainContext.MainThreadDocuments),this.g=v,this.g.onDidRemoveDocuments(d=>{for(const g of d)this.b.fire(g.document)},void 0,this.e),this.g.onDidAddDocuments(d=>{for(const g of d)this.a.fire(g.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(y){if(!y)return;const v=this.g.getDocument(y);if(v)return v}getDocument(y){const v=this.getDocumentData(y);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${y}'`);return v.document}ensureDocumentData(y){const v=this.g.getDocument(y);if(v)return Promise.resolve(v);let d=this.h.get(y.toString());return d||(d=this.f.$tryOpenDocument(y).then(g=>{this.h.delete(y.toString());const h=k.URI.revive(g);return(0,S.assertIsDefined)(this.g.getDocument(h))},g=>(this.h.delete(y.toString()),Promise.reject(g))),this.h.set(y.toString(),d)),d}createDocumentData(y){return this.f.$tryCreateDocument(y).then(v=>k.URI.revive(v))}$acceptModelLanguageChanged(y,v){const d=k.URI.revive(y),g=this.g.getDocument(d);if(!g)throw new Error("unknown document");this.b.fire(g.document),g._acceptLanguageId(v),this.a.fire(g.document)}$acceptModelSaved(y){const v=k.URI.revive(y),d=this.g.getDocument(v);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(y,!1),this.d.fire(d.document)}$acceptDirtyStateChanged(y,v){const d=k.URI.revive(y),g=this.g.getDocument(d);if(!g)throw new Error("unknown document");g._acceptIsDirty(v),this.c.fire({document:g.document,contentChanges:[],reason:void 0})}$acceptModelChanged(y,v,d){const g=k.URI.revive(y),h=this.g.getDocument(g);if(!h)throw new Error("unknown document");h._acceptIsDirty(d),h.onEvents(v);let w;v.isUndoing?w=R.TextDocumentChangeReason.Undo:v.isRedoing&&(w=R.TextDocumentChangeReason.Redo),this.c.fire((0,C.deepFreeze)({document:h.document,contentChanges:v.changes.map(m=>({range:T.Range.to(m.range),rangeOffset:m.rangeOffset,rangeLength:m.rangeLength,text:m.text})),reason:w}))}setWordDefinitionFor(y,v){(0,D.setWordDefinitionFor)(y,v)}}e.ExtHostDocuments=P}),define(Se[58],ye([1,0,48,4,6,2,3,5,134,16,137,14,13,28,15,62,80]),function(te,e,a,t,k,A,D,T,S,C,R,P,E,y,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class h{constructor(f){this.value=f,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let w=class{constructor(f,b){this.h=f,this.i=b,this.a=null,this.b=new Map,this.c=new y.ResourceMap,this.d=new t.Emitter,this.e=new t.Emitter,this.f=new t.Emitter,this.g=new t.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(f){this.acceptDocumentsAndEditorsDelta(f)}acceptDocumentsAndEditorsDelta(f){const b=[],s=[],o=[];if(f.removedDocuments)for(const c of f.removedDocuments){const u=A.URI.revive(c),r=this.c.get(u);r?.unref()&&(this.c.delete(u),b.push(r.value))}if(f.addedDocuments)for(const c of f.addedDocuments){const u=A.URI.revive(c.uri);let r=this.c.get(u);if(r&&u.scheme!==v.Schemas.vscodeNotebookCell&&u.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${u} already exists!'`);r||(r=new h(new S.ExtHostDocumentData(this.h.getProxy(T.MainContext.MainThreadDocuments),u,c.lines,c.EOL,c.versionId,c.languageId,c.isDirty,c.notebook)),this.c.set(u,r),s.push(r.value)),r.ref()}if(f.removedEditors)for(const c of f.removedEditors){const u=this.b.get(c);this.b.delete(c),u&&o.push(u)}if(f.addedEditors)for(const c of f.addedEditors){const u=A.URI.revive(c.documentUri);a.ok(this.c.has(u),`document '${u}' does not exist`),a.ok(!this.b.has(c.id),`editor '${c.id}' already exists!`);const r=this.c.get(u).value,l=new R.ExtHostTextEditor(c.id,this.h.getProxy(T.MainContext.MainThreadTextEditors),this.i,new g.Lazy(()=>r.document),c.selections.map(P.Selection.to),c.options,c.visibleRanges.map(n=>P.Range.to(n)),typeof c.editorPosition=="number"?P.ViewColumn.to(c.editorPosition):void 0);this.b.set(c.id,l)}f.newActiveEditor!==void 0&&(a.ok(f.newActiveEditor===null||this.b.has(f.newActiveEditor),`active editor '${f.newActiveEditor}' does not exist`),this.a=f.newActiveEditor),(0,k.dispose)(b),(0,k.dispose)(o),f.removedDocuments&&this.e.fire(b),f.addedDocuments&&this.d.fire(s),(f.removedEditors||f.addedEditors)&&this.f.fire(this.allEditors().map(c=>c.value)),f.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(f){return this.c.get(f)?.value}allDocuments(){return d.Iterable.map(this.c.values(),f=>f.value)}getEditor(f){return this.b.get(f)}activeEditor(f){if(!this.a)return;const b=this.b.get(this.a);return f?b:b?.value}allEditors(){return[...this.b.values()]}};w=Ve([We(0,C.IExtHostRpcService),We(1,E.ILogService)],w),e.ExtHostDocumentsAndEditors=w,e.IExtHostDocumentsAndEditors=(0,D.createDecorator)("IExtHostDocumentsAndEditors")}),define(Se[59],ye([1,0,14,5,2,4,3,7,16,11,79]),function(te,e,a,t,k,A,D,T,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,D.createDecorator)("IExtHostEditorTabs");class P{constructor(g,h,w){this.e=w,this.d=h,this.acceptDtoUpdate(g)}get apiObject(){if(!this.a){const g=this,h={get isActive(){return g.b.id===g.e()},get label(){return g.b.label},get input(){return g.c},get isDirty(){return g.b.isDirty},get isPinned(){return g.b.isPinned},get isPreview(){return g.b.isPreview},get group(){return g.d.apiObject}};this.a=Object.freeze(h)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(g){this.b=g,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new T.TextTabInput(k.URI.revive(this.b.input.uri));case 2:return new T.TextDiffTabInput(k.URI.revive(this.b.input.original),k.URI.revive(this.b.input.modified));case 3:return new T.TextMergeTabInput(k.URI.revive(this.b.input.base),k.URI.revive(this.b.input.input1),k.URI.revive(this.b.input.input2),k.URI.revive(this.b.input.result));case 6:return new T.CustomEditorTabInput(k.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new T.WebviewEditorTabInput(this.b.input.viewType);case 4:return new T.NotebookEditorTabInput(k.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new T.NotebookDiffEditorTabInput(k.URI.revive(this.b.input.original),k.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new T.TerminalEditorTabInput;case 9:return new T.InteractiveWindowInput(k.URI.revive(this.b.input.uri),k.URI.revive(this.b.input.inputBoxUri));default:return}}}class E{constructor(g,h){this.c=[],this.d="",this.b=g,this.e=h;for(const w of g.tabs)w.isActive&&(this.d=w.id),this.c.push(new P(w,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const g=this,h={get isActive(){return g.b.groupId===g.e()},get viewColumn(){return a.ViewColumn.to(g.b.viewColumn)},get activeTab(){return g.c.find(w=>w.tabId===g.d)?.apiObject},get tabs(){return Object.freeze(g.c.map(w=>w.apiObject))}};this.a=Object.freeze(h)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(g){this.b=g}acceptTabOperation(g){if(g.kind===0){const w=new P(g.tabDto,this,()=>this.activeTabId());return this.c.splice(g.index,0,w),g.tabDto.isActive&&(this.d=w.tabId),w}else if(g.kind===1){const w=this.c.splice(g.index,1)[0];if(!w)throw new Error(`Tab close updated received for index ${g.index} which does not exist`);return w.tabId===this.d&&(this.d=""),w}else if(g.kind===3){if(g.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const w=this.c.splice(g.oldIndex,1)[0];if(!w)throw new Error(`Tab move updated received for index ${g.oldIndex} which does not exist`);return this.c.splice(g.index,0,w),w}const h=this.c.find(w=>w.tabId===g.tabDto.id);if(!h)throw new Error("INVALID tab");return g.tabDto.isActive?this.d=g.tabDto.id:this.d===g.tabDto.id&&!g.tabDto.isActive&&(this.d=""),h.acceptDtoUpdate(g.tabDto),h}activeTabId(){return this.d}}let y=class{constructor(g){this.b=new A.Emitter,this.c=new A.Emitter,this.e=[],this.a=g.getProxy(t.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const g=this,h={onDidChangeTabGroups:g.c.event,onDidChangeTabs:g.b.event,get all(){return Object.freeze(g.e.map(w=>w.apiObject))},get activeTabGroup(){const w=g.d;return(0,C.assertIsDefined)(g.e.find(f=>f.groupId===w)?.apiObject)},close:async(w,m)=>{const f=Array.isArray(w)?w:[w];return f.length?v(f[0])?this.j(f,m):this.i(f,m):!0}};this.f=Object.freeze(h)}return this.f}$acceptEditorTabModel(g){const h=new Set(this.e.map(c=>c.groupId)),w=new Set(g.map(c=>c.groupId)),m=(0,R.diffSets)(h,w),f=this.e.filter(c=>m.removed.includes(c.groupId)).map(c=>c.apiObject),b=[],s=[];this.e=g.map(c=>{const u=new E(c,()=>this.d);return m.added.includes(u.groupId)?b.push(u.apiObject):s.push(u.apiObject),u});const o=(0,C.assertIsDefined)(g.find(c=>c.isActive===!0)?.groupId);o!==void 0&&this.d!==o&&(this.d=o),this.c.fire(Object.freeze({opened:b,closed:f,changed:s}))}$acceptTabGroupUpdate(g){const h=this.e.find(w=>w.groupId===g.groupId);if(!h)throw new Error("Update Group IPC call received before group creation.");h.acceptGroupDtoUpdate(g),g.isActive&&(this.d=g.groupId),this.c.fire(Object.freeze({changed:[h.apiObject],opened:[],closed:[]}))}$acceptTabOperation(g){const h=this.e.find(m=>m.groupId===g.groupId);if(!h)throw new Error("Update Tabs IPC call received before group creation.");const w=h.acceptTabOperation(g);switch(g.kind){case 0:this.b.fire(Object.freeze({opened:[w.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[w.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[w.apiObject]}));return}}g(g){for(const h of this.e)for(const w of h.tabs)if(w.apiObject===g)return w}h(g){return this.e.find(h=>h.apiObject===g)}async i(g,h){const w=[];for(const m of g){const f=this.g(m);if(!f)throw new Error("Tab close: Invalid tab not found!");w.push(f.tabId)}return this.a.$closeTab(w,h)}async j(g,h){const w=[];for(const m of g){const f=this.h(m);if(!f)throw new Error("Group close: Invalid group not found!");w.push(f.groupId)}return this.a.$closeGroup(w,h)}};y=Ve([We(0,S.IExtHostRpcService)],y),e.ExtHostEditorTabs=y;function v(d){return d.tabs!==void 0}}),define(Se[252],ye([1,0,2,5,6,7,14,152,8,22,26]),function(te,e,a,t,k,A,D,T,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class P{constructor(){this.a=[]}add(v){this.b=void 0,this.a.push(v)}delete(v){const d=this.a.indexOf(v);d>=0&&(this.a.splice(d,1),this.b=void 0)}c(){if(!this.b){const v=this.a.sort(),d=[];let g,h,w=14,m=14;for(const f of v){let b=g?(0,S.commonPrefixLength)(g,f):0;for(b===0?h=1:h=m;b<f.length;b++)b+1===f.length?(w=m,m=9):m+=1,d.push([h,f.toUpperCase().charCodeAt(b),m]),d.push([h,f.toLowerCase().charCodeAt(b),m]),h=m;g=f,m=w}d.push([9,58,10]),d.push([10,47,12]),this.b=new T.StateMachine(d)}}provideDocumentLinks(v){this.c();const d=[],g=T.LinkComputer.computeLinks({getLineContent(h){return v.lineAt(h-1).text},getLineCount(){return v.lineCount}},this.b);for(const h of g){const w=D.DocumentLink.to(h);w.target&&d.push(w)}return d}}class E{constructor(v,d){this.i=d,this.b=new P,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=v.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(v,d,g,h={}){if(this.d.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(v,"*",this.b));const w=this.h++;this.b.add(d),this.d.add(d),this.c.set(w,g);let m=2;h.isCaseSensitive&&(m+=1024),h.isReadonly&&(m+=2048),typeof g.copy=="function"&&(m+=8),typeof g.open=="function"&&typeof g.close=="function"&&typeof g.read=="function"&&typeof g.write=="function"&&((0,R.checkProposedApiEnabled)(v,"fsChunks"),m+=4),this.a.$registerFileSystemProvider(w,d,m).catch(b=>{console.error(`FAILED to register filesystem provider of ${v.identifier.value}-extension for the scheme ${d}`),console.error(b)});const f=g.onDidChangeFile(b=>{const s=[];for(const o of b){const{uri:c,type:u}=o;if(c.scheme!==d)continue;let r;switch(u){case A.FileChangeType.Changed:r=0;break;case A.FileChangeType.Created:r=1;break;case A.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:c,type:r})}this.a.$onFileSystemChange(w,s)});return(0,k.toDisposable)(()=>{f.dispose(),this.b.delete(d),this.d.delete(d),this.c.delete(w),this.a.$unregisterProvider(w)})}static j(v){const{type:d,ctime:g,mtime:h,size:w,permissions:m}=v;return{type:d,ctime:g,mtime:h,size:w,permissions:m}}$stat(v,d){return Promise.resolve(this.k(v).stat(a.URI.revive(d))).then(g=>E.j(g))}$readdir(v,d){return Promise.resolve(this.k(v).readDirectory(a.URI.revive(d)))}$readFile(v,d){return Promise.resolve(this.k(v).readFile(a.URI.revive(d))).then(g=>C.VSBuffer.wrap(g))}$writeFile(v,d,g,h){return Promise.resolve(this.k(v).writeFile(a.URI.revive(d),g.buffer,h))}$delete(v,d,g){return Promise.resolve(this.k(v).delete(a.URI.revive(d),g))}$rename(v,d,g,h){return Promise.resolve(this.k(v).rename(a.URI.revive(d),a.URI.revive(g),h))}$copy(v,d,g,h){const w=this.k(v);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(a.URI.revive(d),a.URI.revive(g),h))}$mkdir(v,d){return Promise.resolve(this.k(v).createDirectory(a.URI.revive(d)))}$watch(v,d,g,h){const w=this.k(v).watch(a.URI.revive(g),h);this.f.set(d,w)}$unwatch(v,d){const g=this.f.get(d);g&&(g.dispose(),this.f.delete(d))}$open(v,d,g){const h=this.k(v);if(!h.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(h.open(a.URI.revive(d),g))}$close(v,d){const g=this.k(v);if(!g.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(g.close(d))}$read(v,d,g,h){const w=this.k(v);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const m=C.VSBuffer.alloc(h);return Promise.resolve(w.read(d,g,m.buffer,0,h)).then(f=>m.slice(0,f))}$write(v,d,g,h){const w=this.k(v);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(d,g,h.buffer,0,h.byteLength))}k(v){const d=this.c.get(v);if(!d){const g=new Error;throw g.name="ENOPRO",g.message="no provider",g}return d}}e.ExtHostFileSystem=E}),define(Se[70],ye([1,0,5,38,7,22,3,16,46,6]),function(te,e,a,t,k,A,D,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class Yt{constructor(E,y){this.b=new Map,this.a=E.getProxy(a.MainContext.MainThreadFileSystem);const v=this;this.value=Object.freeze({async stat(d){try{const g=v.b.get(d.scheme);if(!g)return await v.a.$stat(d);await v.a.$ensureActivation(d.scheme);const h=await g.stat(d);return{type:h.type,ctime:h.ctime,mtime:h.mtime,size:h.size,permissions:h.permissions}}catch(g){Yt.c(g)}},async readDirectory(d){try{const g=v.b.get(d.scheme);return g?(await v.a.$ensureActivation(d.scheme),(await g.readDirectory(d)).slice()):await v.a.$readdir(d)}catch(g){return Yt.c(g)}},async createDirectory(d){try{return await v.a.$mkdir(d)}catch(g){return Yt.c(g)}},async readFile(d){try{const g=v.b.get(d.scheme);return g?(await v.a.$ensureActivation(d.scheme),(await g.readFile(d)).slice()):(await v.a.$readFile(d)).buffer}catch(g){return Yt.c(g)}},async writeFile(d,g){try{return await v.a.$writeFile(d,A.VSBuffer.wrap(g))}catch(h){return Yt.c(h)}},async delete(d,g){try{const h=v.b.get(d.scheme);return h?(await v.a.$ensureActivation(d.scheme),await h.delete(d,{recursive:!1,...g})):await v.a.$delete(d,{recursive:!1,useTrash:!1,...g})}catch(h){return Yt.c(h)}},async rename(d,g,h){try{return await v.a.$rename(d,g,{overwrite:!1,...h})}catch(w){return Yt.c(w)}},async copy(d,g,h){try{return await v.a.$copy(d,g,{overwrite:!1,...h})}catch(w){return Yt.c(w)}},isWritableFileSystem(d){const g=y.getCapabilities(d);if(typeof g=="number")return!(g&2048)}})}static c(E){if(E instanceof k.FileSystemError)throw E;if(!(E instanceof Error))throw new k.FileSystemError(String(E));if(E.name==="ENOPRO")throw k.FileSystemError.Unavailable(E.message);switch(E.name){case t.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(E.message);case t.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(E.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(E.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(E.message);case t.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(E.message);case t.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(E.message);default:throw new k.FileSystemError(E.message,E.name)}}addFileSystemProvider(E,y){return this.b.set(E,y),(0,C.toDisposable)(()=>this.b.delete(E))}};R=Ve([We(0,T.IExtHostRpcService),We(1,S.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,D.createDecorator)("IExtHostConsumerFileSystem")}),define(Se[253],ye([1,0,4,37,2,5,14,7]),function(te,e,a,t,k,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(P,E,y,v,d,g,h,w){this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter;const m=this.h(P,y,d);this.g=0,g&&(this.g+=1),h&&(this.g+=2),w&&(this.g+=4);const f=(0,t.parse)(d),b=typeof d=="string",s=v(o=>{if(!g)for(const c of o.created){const u=k.URI.revive(c);f(u.fsPath)&&(!b||E.getWorkspaceFolder(u))&&this.a.fire(u)}if(!h)for(const c of o.changed){const u=k.URI.revive(c);f(u.fsPath)&&(!b||E.getWorkspaceFolder(u))&&this.b.fire(u)}if(!w)for(const c of o.deleted){const u=k.URI.revive(c);f(u.fsPath)&&(!b||E.getWorkspaceFolder(u))&&this.c.fire(u)}});this.d=T.Disposable.from(m,this.a,this.b,this.c,s)}h(P,E,y){const v=T.Disposable.from();if(typeof y=="string")return v;const d=P.getProxy(A.MainContext.MainThreadFileSystem);let g=!1;(y.pattern.includes(t.GLOBSTAR)||y.pattern.includes(t.GLOB_SPLIT))&&(g=!0);const h=Math.random();return d.$watch(E.identifier.value,h,y.baseUri,{recursive:g,excludes:[]}),T.Disposable.from({dispose:()=>d.$unwatch(h)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class C{constructor(P,E,y){this.j=P,this.k=E,this.l=y,this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter,this.d=new a.Emitter,this.g=new a.AsyncEmitter,this.h=new a.AsyncEmitter,this.i=new a.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(P,E,y,v,d,g){return new S(this.j,P,E,this.a.event,D.GlobPattern.from(y),v,d,g)}$onFileEvent(P){this.a.fire(P)}$onDidRunFileOperation(P,E){switch(P){case 2:this.b.fire(Object.freeze({files:E.map(y=>({oldUri:k.URI.revive(y.source),newUri:k.URI.revive(y.target)}))}));break;case 1:this.d.fire(Object.freeze({files:E.map(y=>k.URI.revive(y.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:E.map(y=>k.URI.revive(y.target))}));break;default:}}getOnWillRenameFileEvent(P){return this.m(P,this.g)}getOnWillCreateFileEvent(P){return this.m(P,this.h)}getOnWillDeleteFileEvent(P){return this.m(P,this.i)}m(P,E){return(y,v,d)=>{const g=function(w){y.call(v,w)};return g.extension=P,E.event(g,void 0,d)}}async $onWillRunFileOperation(P,E,y,v){switch(P){case 2:return await this.n(this.g,{files:E.map(d=>({oldUri:k.URI.revive(d.source),newUri:k.URI.revive(d.target)}))},y,v);case 1:return await this.n(this.i,{files:E.map(d=>k.URI.revive(d.target))},y,v);case 0:case 3:return await this.n(this.h,{files:E.map(d=>k.URI.revive(d.target))},y,v)}}async n(P,E,y,v){const d=new Set,g=[];if(await P.fireAsync(E,v,async(w,m)=>{const f=Date.now(),b=await Promise.resolve(w);b instanceof T.WorkspaceEdit&&(g.push([m.extension,b]),d.add(m.extension.displayName??m.extension.identifier.value)),Date.now()-f>y&&this.k.warn("SLOW file-participant",m.extension.identifier)}),v.isCancellationRequested||g.length===0)return;const h={edits:[]};for(const[,w]of g){const{edits:m}=D.WorkspaceEdit.from(w,{getTextDocumentVersion:f=>this.l.getDocument(f)?.version,getNotebookDocumentVersion:()=>{}});h.edits=h.edits.concat(m)}return{edit:h,extensionNames:Array.from(d)}}}e.ExtHostFileSystemEventService=C}),define(Se[254],ye([1,0,2,39]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class k{constructor(D,T,S,C,R){this.a=T,this.b=S,this.c=C;const P=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",E=>!0,E=>E),new t.ApiCommandArgument("resource","Interactive resource Uri",E=>!0,E=>E),new t.ApiCommandArgument("controllerId","Notebook controller Id",E=>!0,E=>E),new t.ApiCommandArgument("title","Interactive editor title",E=>!0,E=>E)],new t.ApiCommandResult("Notebook and input URI",E=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",E.notebookEditorId),E.notebookEditorId!==void 0){const y=this.a.getEditorById(E.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",y.id),{notebookUri:a.URI.revive(E.notebookUri),inputUri:a.URI.revive(E.inputUri),notebookEditor:y.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",E.notebookUri,E.inputUri),{notebookUri:a.URI.revive(E.notebookUri),inputUri:a.URI.revive(E.inputUri)}}));this.c.registerApiCommand(P)}$willAddInteractiveDocument(D,T,S,C){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:S,uri:D,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(a.URI.revive(C))?.apiNotebook}]})}$willRemoveInteractiveDocument(D,T){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[D]})}}e.ExtHostInteractive=k}),define(Se[255],ye([1,0,6,5]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class k{constructor(D){this.b=0,this.a=D.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(D){const T=this.b++;return this.a.$registerResourceLabelFormatter(T,D),(0,a.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(T)})}}e.ExtHostLabelService=k}),define(Se[256],ye([1,0,2,23,14,7,66,5,8,35,17,11,148,21,6,118,99,67,51,10,18,26]),function(te,e,a,t,k,A,D,T,S,C,R,P,E,y,v,d,g,h,w,m,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class s{constructor(N,z){this.d=N,this.e=z}async provideDocumentSymbols(N,z){const X=this.d.getDocument(N),_=await this.e.provideDocumentSymbols(X,z);if(!(0,R.isFalsyOrEmpty)(_))return _[0]instanceof A.DocumentSymbol?_.map(k.DocumentSymbol.from):s.f(_)}static f(N){N=N.slice(0).sort((_,ue)=>{let be=_.location.range.start.compareTo(ue.location.range.start);return be===0&&(be=ue.location.range.end.compareTo(_.location.range.end)),be});const z=[],X=[];for(const _ of N){const ue={name:_.name||"!!MISSING: name!!",kind:k.SymbolKind.from(_.kind),tags:_.tags?.map(k.SymbolTag.from)||[],detail:"",containerName:_.containerName,range:k.Range.from(_.location.range),selectionRange:k.Range.from(_.location.range),children:[]};for(;;){if(X.length===0){X.push(ue),z.push(ue);break}const be=X[X.length-1];if(C.Range.containsRange(be.range,ue.range)&&!C.Range.equalsRange(be.range,ue.range)){be.children?.push(ue),X.push(ue);break}X.pop()}}return z}}class o{constructor(N,z,X){this.g=N,this.h=z,this.j=X,this.e=new h.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(N,z){const X=this.g.getDocument(N),_=await this.j.provideCodeLenses(X,z);if(!_||z.isCancellationRequested)return;const ue=this.e.add(_),be=new v.DisposableStore;this.f.set(ue,be);const ke={cacheId:ue,lenses:[]};for(let ge=0;ge<_.length;ge++)ke.lenses.push({cacheId:[ue,ge],range:k.Range.from(_[ge].range),command:this.h.toInternal(_[ge].command,be)});return ke}async resolveCodeLens(N,z){const X=N.cacheId&&this.e.get(...N.cacheId);if(!X)return;let _;if(typeof this.j.resolveCodeLens!="function"||X.isResolved?_=X:_=await this.j.resolveCodeLens(X,z),_||(_=X),z.isCancellationRequested)return;const ue=N.cacheId&&this.f.get(N.cacheId[0]);if(!!ue)return N.command=this.h.toInternal(_.command??o.d,ue),N}releaseCodeLenses(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}}o.d={command:"missing",title:"!!MISSING: command!!"};function c(ne){return Array.isArray(ne)?ne.map(k.DefinitionLink.from):ne?[k.DefinitionLink.from(ne)]:[]}class u{constructor(N,z){this.d=N,this.e=z}async provideDefinition(N,z,X){const _=this.d.getDocument(N),ue=k.Position.to(z),be=await this.e.provideDefinition(_,ue,X);return c(be)}}class r{constructor(N,z){this.d=N,this.e=z}async provideDeclaration(N,z,X){const _=this.d.getDocument(N),ue=k.Position.to(z),be=await this.e.provideDeclaration(_,ue,X);return c(be)}}class l{constructor(N,z){this.d=N,this.e=z}async provideImplementation(N,z,X){const _=this.d.getDocument(N),ue=k.Position.to(z),be=await this.e.provideImplementation(_,ue,X);return c(be)}}class n{constructor(N,z){this.d=N,this.e=z}async provideTypeDefinition(N,z,X){const _=this.d.getDocument(N),ue=k.Position.to(z),be=await this.e.provideTypeDefinition(_,ue,X);return c(be)}}class i{constructor(N,z){this.d=N,this.e=z}async provideHover(N,z,X){const _=this.d.getDocument(N),ue=k.Position.to(z),be=await this.e.provideHover(_,ue,X);if(!(!be||(0,R.isFalsyOrEmpty)(be.contents)))return be.range||(be.range=_.getWordRangeAtPosition(ue)),be.range||(be.range=new A.Range(ue,ue)),k.Hover.from(be)}}class p{constructor(N,z){this.d=N,this.e=z}async provideEvaluatableExpression(N,z,X){const _=this.d.getDocument(N),ue=k.Position.to(z),be=await this.e.provideEvaluatableExpression(_,ue,X);if(be)return k.EvaluatableExpression.from(be)}}class I{constructor(N,z){this.d=N,this.e=z}async provideInlineValues(N,z,X,_){const ue=this.d.getDocument(N),be=await this.e.provideInlineValues(ue,k.Range.to(z),k.InlineValueContext.to(X),_);if(Array.isArray(be))return be.map(ke=>k.InlineValue.from(ke))}}class L{constructor(N,z){this.d=N,this.e=z}async provideDocumentHighlights(N,z,X){const _=this.d.getDocument(N),ue=k.Position.to(z),be=await this.e.provideDocumentHighlights(_,ue,X);if(Array.isArray(be))return be.map(k.DocumentHighlight.from)}}class U{constructor(N,z){this.d=N,this.e=z}async provideLinkedEditingRanges(N,z,X){const _=this.d.getDocument(N),ue=k.Position.to(z),be=await this.e.provideLinkedEditingRanges(_,ue,X);if(be&&Array.isArray(be.ranges))return{ranges:(0,R.coalesce)(be.ranges.map(k.Range.from)),wordPattern:be.wordPattern}}}class G{constructor(N,z){this.d=N,this.e=z}async provideReferences(N,z,X,_){const ue=this.d.getDocument(N),be=k.Position.to(z),ke=await this.e.provideReferences(ue,be,X,_);if(Array.isArray(ke))return ke.map(k.location.from)}}class V{constructor(N,z,X,_,ue,be,ke){this.g=N,this.h=z,this.j=X,this.k=_,this.l=ue,this.m=be,this.n=ke,this.e=new h.Cache("CodeAction"),this.f=new Map}async provideCodeActions(N,z,X,_){const ue=this.g.getDocument(N),be=E.Selection.isISelection(z)?k.Selection.to(z):k.Range.to(z),ke=[];for(const et of this.j.getDiagnostics(N))if(be.intersection(et.range)&&ke.push(et)>V.d)break;const ge={diagnostics:ke,only:X.only?new A.CodeActionKind(X.only):void 0,triggerKind:k.CodeActionTriggerKind.to(X.trigger)},Pe=await this.k.provideCodeActions(ue,be,ge,_);if(!(0,R.isNonEmptyArray)(Pe)||_.isCancellationRequested)return;const Ie=this.e.add(Pe),je=new v.DisposableStore;this.f.set(Ie,je);const qe=[];for(let et=0;et<Pe.length;et++){const _e=Pe[et];!_e||(V.o(_e)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),qe.push({_isSynthetic:!0,title:_e.title,command:this.h.toInternal(_e,je)})):(ge.only&&(_e.kind?ge.only.contains(_e.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action is of kind '${_e.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),qe.push({cacheId:[Ie,et],title:_e.title,command:_e.command&&this.h.toInternal(_e.command,je),diagnostics:_e.diagnostics&&_e.diagnostics.map(k.Diagnostic.from),edit:_e.edit&&k.WorkspaceEdit.from(_e.edit,void 0),kind:_e.kind&&_e.kind.value,isPreferred:_e.isPreferred,disabled:_e.disabled?.reason})))}return{cacheId:Ie,actions:qe}}async resolveCodeAction(N,z){const[X,_]=N,ue=this.e.get(X,_);if(!ue||V.o(ue)||!this.k.resolveCodeAction)return;const be=await this.k.resolveCodeAction(ue,z)??ue;return be?.edit?k.WorkspaceEdit.from(be.edit,void 0):void 0}releaseCodeActions(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}static o(N){return typeof N.command=="string"&&typeof N.title=="string"}}V.d=1e3;class O{constructor(N,z,X,_){this.d=N,this.e=z,this.f=X,this.g=_}async prepareDocumentPaste(N,z,X,_){if(!this.f.prepareDocumentPaste)return;const ue=this.e.getDocument(N),be=z.map(ge=>k.Range.to(ge)),ke=k.DataTransfer.toDataTransfer(X,()=>{throw new m.NotImplementedError});return await this.f.prepareDocumentPaste(ue,be,ke,_),k.DataTransfer.toDataTransferDTO(ke)}async providePasteEdits(N,z,X,_,ue){const be=this.e.getDocument(z),ke=X.map(Ie=>k.Range.to(Ie)),ge=k.DataTransfer.toDataTransfer(_,async Ie=>(await this.d.$resolvePasteFileData(this.g,N,Ie)).buffer),Pe=await this.f.provideDocumentPasteEdits(be,ke,ge,ue);if(!!Pe)return{insertText:typeof Pe.insertText=="string"?Pe.insertText:{snippet:Pe.insertText.value},additionalEdit:Pe.additionalEdit?k.WorkspaceEdit.from(Pe.additionalEdit,void 0):void 0}}}class B{constructor(N,z){this.d=N,this.e=z}async provideDocumentFormattingEdits(N,z,X){const _=this.d.getDocument(N),ue=await this.e.provideDocumentFormattingEdits(_,z,X);if(Array.isArray(ue))return ue.map(k.TextEdit.from)}}class F{constructor(N,z){this.d=N,this.e=z}async provideDocumentRangeFormattingEdits(N,z,X,_){const ue=this.d.getDocument(N),be=k.Range.to(z),ke=await this.e.provideDocumentRangeFormattingEdits(ue,be,X,_);if(Array.isArray(ke))return ke.map(k.TextEdit.from)}}class ${constructor(N,z){this.d=N,this.e=z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(N,z,X,_,ue){const be=this.d.getDocument(N),ke=k.Position.to(z),ge=await this.e.provideOnTypeFormattingEdits(be,ke,X,_,ue);if(Array.isArray(ge))return ge.map(k.TextEdit.from)}}class M{constructor(N,z){this.e=N,this.f=z,this.d=new h.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(N,z){const X=await this.e.provideWorkspaceSymbols(N,z);if(!(0,R.isNonEmptyArray)(X))return{symbols:[]};const _=this.d.add(X),ue={cacheId:_,symbols:[]};for(let be=0;be<X.length;be++){const ke=X[be];if(!ke||!ke.name){this.f.warn("INVALID SymbolInformation",ke);continue}ue.symbols.push({...k.WorkspaceSymbol.from(ke),cacheId:[_,be]})}return ue}async resolveWorkspaceSymbol(N,z){if(typeof this.e.resolveWorkspaceSymbol!="function"||!N.cacheId)return N;const X=this.d.get(...N.cacheId);if(X){const _=await this.e.resolveWorkspaceSymbol(X,z);return _&&(0,t.mixin)(N,k.WorkspaceSymbol.from(_),!0)}}releaseWorkspaceSymbols(N){this.d.delete(N)}}class H{static supportsResolving(N){return typeof N.prepareRename=="function"}constructor(N,z,X){this.d=N,this.e=z,this.f=X}async provideRenameEdits(N,z,X,_){const ue=this.d.getDocument(N),be=k.Position.to(z);try{const ke=await this.e.provideRenameEdits(ue,be,X,_);return ke?k.WorkspaceEdit.from(ke):void 0}catch(ke){const ge=H.g(ke);return ge?{rejectReason:ge,edits:void 0}:Promise.reject(ke)}}async resolveRenameLocation(N,z,X){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const _=this.d.getDocument(N),ue=k.Position.to(z);try{const be=await this.e.prepareRename(_,ue,X);let ke,ge;if(A.Range.isRange(be)?(ke=be,ge=_.getText(be)):(0,P.isObject)(be)&&(ke=be.range,ge=be.placeholder),!ke||!ge)return;if(ke.start.line>ue.line||ke.end.line<ue.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:k.Range.from(ke),text:ge}}catch(be){const ke=H.g(be);return ke?{rejectReason:ke,range:void 0,text:void 0}:Promise.reject(be)}}static g(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class K{constructor(N,z){this.resultId=N,this.tokens=z}}class q{constructor(N,z){this.f=N,this.g=z,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(N,z,X){const _=this.f.getDocument(N),ue=z!==0?this.d.get(z):null;let be=typeof ue?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(_,ue.resultId,X):await this.g.provideDocumentSemanticTokens(_,X);return ue&&this.d.delete(z),be?(be=q.h(be),this.o(q.n(ue,be),be)):null}async releaseDocumentSemanticColoring(N){this.d.delete(N)}static h(N){return q.j(N)?q.k(N)?N:new A.SemanticTokens(new Uint32Array(N.data),N.resultId):q.l(N)?q.m(N)?N:new A.SemanticTokensEdits(N.edits.map(z=>new A.SemanticTokensEdit(z.start,z.deleteCount,z.data?new Uint32Array(z.data):z.data)),N.resultId):N}static j(N){return N&&!!N.data}static k(N){return N.data instanceof Uint32Array}static l(N){return N&&Array.isArray(N.edits)}static m(N){for(const z of N.edits)if(!(z.data instanceof Uint32Array))return!1;return!0}static n(N,z){if(!q.j(z)||!N||!N.tokens)return z;const X=N.tokens,_=X.length,ue=z.data,be=ue.length;let ke=0;const ge=Math.min(_,be);for(;ke<ge&&X[ke]===ue[ke];)ke++;if(ke===_&&ke===be)return new A.SemanticTokensEdits([],z.resultId);let Pe=0;const Ie=ge-ke;for(;Pe<Ie&&X[_-Pe-1]===ue[be-Pe-1];)Pe++;return new A.SemanticTokensEdits([{start:ke,deleteCount:_-ke-Pe,data:ue.subarray(ke,be-Pe)}],z.resultId)}o(N,z){if(q.j(N)){const X=this.e++;return this.d.set(X,new K(N.resultId,N.data)),(0,d.encodeSemanticTokensDto)({id:X,type:"full",data:N.data})}if(q.l(N)){const X=this.e++;return q.j(z)?this.d.set(X,new K(z.resultId,z.data)):this.d.set(X,new K(N.resultId)),(0,d.encodeSemanticTokensDto)({id:X,type:"delta",deltas:(N.edits||[]).map(_=>({start:_.start,deleteCount:_.deleteCount,data:_.data}))})}return null}}class Y{constructor(N,z){this.d=N,this.e=z}async provideDocumentRangeSemanticTokens(N,z,X){const _=this.d.getDocument(N),ue=await this.e.provideDocumentRangeSemanticTokens(_,k.Range.to(z),X);return ue?this.f(ue):null}f(N){return(0,d.encodeSemanticTokensDto)({id:0,type:"full",data:N.data})}}class Q{static supportsResolving(N){return typeof N.resolveCompletionItem=="function"}constructor(N,z,X,_,ue){this.f=N,this.g=z,this.h=X,this.j=_,this.k=ue,this.d=new h.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(N,z,X,_){const ue=this.f.getDocument(N),be=k.Position.to(z),ke=ue.getWordRangeAtPosition(be)||new A.Range(be,be),ge=ke.with({end:be}),Pe=new w.StopWatch(!0),Ie=await this.h.provideCompletionItems(ue,be,_,k.CompletionContext.to(X));if(!Ie||_.isCancellationRequested)return;const je=Array.isArray(Ie)?new A.CompletionList(Ie):Ie,qe=Q.supportsResolving(this.h)?this.d.add(je.items):this.d.add([]),et=new v.DisposableStore;this.e.set(qe,et);const _e=[],nt={x:qe,b:_e,a:{replace:k.Range.from(ke),insert:k.Range.from(ge)},c:je.isIncomplete||void 0,d:Pe.elapsed()};for(let st=0;st<je.items.length;st++){const ht=je.items[st],Ue=this.l(ht,[qe,st],ge,ke);_e.push(Ue)}return nt}async resolveCompletionItem(N,z){if(typeof this.h.resolveCompletionItem!="function")return;const X=this.d.get(...N);if(!X)return;const _=await this.h.resolveCompletionItem(X,z);if(!!_)return this.l(_,N)}releaseCompletionItems(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,z,X,_){const ue=this.e.get(z[0]);if(!ue)throw Error("DisposableStore is missing...");const be=this.g.toInternal(N.command,ue),ke={x:z,a:N.label,b:N.kind!==void 0?k.CompletionItemKind.from(N.kind):void 0,m:N.tags&&N.tags.map(k.CompletionItemTag.from),c:N.detail,d:typeof N.documentation>"u"?void 0:k.MarkdownString.fromStrict(N.documentation),e:N.sortText!==N.label?N.sortText:void 0,f:N.filterText!==N.label?N.filterText:void 0,g:N.preselect||void 0,i:N.keepWhitespace?1:0,k:N.commitCharacters?.join(""),l:N.additionalTextEdits&&N.additionalTextEdits.map(k.TextEdit.from),n:be?.$ident,o:be?.id,p:be?.$ident?void 0:be?.arguments};N.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ke.h=N.textEdit.newText):typeof N.insertText=="string"?ke.h=N.insertText:N.insertText instanceof A.SnippetString&&(ke.h=N.insertText.value,ke.i|=4);let ge;return N.textEdit?ge=N.textEdit.range:N.range&&(ge=N.range),A.Range.isRange(ge)?ke.j=k.Range.from(ge):ge&&(!X?.isEqual(ge.inserting)||!_?.isEqual(ge.replacing))&&(ke.j={insert:k.Range.from(ge.inserting),replace:k.Range.from(ge.replacing)}),ke}}class ce{async provideInlineCompletions(N,z,X,_){}disposeCompletions(N){}handleDidShowCompletionItem(N,z){}}class ie extends ce{constructor(N,z,X,_){super(),this.f=N,this.g=z,this.h=X,this.j=_,this.d=new de,this.e=(0,b.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[D.InlineCompletionTriggerKind.Automatic]:A.InlineCompletionTriggerKind.Automatic,[D.InlineCompletionTriggerKind.Explicit]:A.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,b.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&typeof this.h.handleDidShowCompletionItem=="function"}async provideInlineCompletions(N,z,X,_){const ue=this.g.getDocument(N),be=k.Position.to(z),ke=await this.h.provideInlineCompletionItems(ue,be,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:k.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[X.triggerKind]},_);if(!ke||_.isCancellationRequested)return;const ge=Array.isArray(ke)?ke:ke.items,Pe=this.e?Array.isArray(ke)?[]:ke.commands||[]:[];let Ie;return{pid:this.d.createReferenceId({dispose(){Ie?.dispose()},items:ge}),items:ge.map((qe,et)=>{let _e;qe.command&&(Ie||(Ie=new v.DisposableStore),_e=this.j.toInternal(qe.command,Ie));const nt=qe.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:qe.filterText,range:qe.range?k.Range.from(qe.range):void 0,command:_e,idx:et,completeBracketPairs:this.e?qe.completeBracketPairs:!1}}),commands:Pe.map(qe=>(Ie||(Ie=new v.DisposableStore),this.j.toInternal(qe,Ie)))}}disposeCompletions(N){this.d.disposeReferenceId(N)?.dispose()}handleDidShowCompletionItem(N,z){const X=this.d.get(N)?.items[z];X&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(X)}}class de{constructor(){this.d=new Map,this.e=1}createReferenceId(N){const z=this.e++;return this.d.set(z,N),z}disposeReferenceId(N){const z=this.d.get(N);return this.d.delete(N),z}get(N){return this.d.get(N)}}class J{constructor(N,z){this.e=N,this.f=z,this.d=new h.Cache("SignatureHelp")}async provideSignatureHelp(N,z,X,_){const ue=this.e.getDocument(N),be=k.Position.to(z),ke=this.g(X),ge=await this.f.provideSignatureHelp(ue,be,_,ke);if(ge){const Pe=this.d.add([ge]);return{...k.SignatureHelp.from(ge),id:Pe}}}g(N){let z;if(N.activeSignatureHelp){const X=k.SignatureHelp.to(N.activeSignatureHelp),_=this.d.get(N.activeSignatureHelp.id,0);_?(z=_,z.activeSignature=X.activeSignature,z.activeParameter=X.activeParameter):z=X}return{...N,activeSignatureHelp:z}}releaseSignatureHelp(N){this.d.delete(N)}}class pe{constructor(N,z,X,_,ue){this.f=N,this.g=z,this.h=X,this.j=_,this.k=ue,this.d=new h.Cache("InlayHints"),this.e=new Map}async provideInlayHints(N,z,X){const _=this.f.getDocument(N),ue=k.Range.to(z),be=await this.h.provideInlayHints(_,ue,X);if(!Array.isArray(be)||be.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${z}`);return}if(X.isCancellationRequested)return;const ke=this.d.add(be);this.e.set(ke,new v.DisposableStore);const ge={hints:[],cacheId:ke};for(let Pe=0;Pe<be.length;Pe++)this.l(be[Pe],ue)&&ge.hints.push(this.m(be[Pe],[ke,Pe]));return this.j.trace(`[InlayHints] ${ge.hints.length} inlay hints from '${this.k.identifier.value}' for ${z}`),ge}async resolveInlayHint(N,z){if(typeof this.h.resolveInlayHint!="function")return;const X=this.d.get(...N);if(!X)return;const _=await this.h.resolveInlayHint(X,z);if(!!_&&!!this.l(_))return this.m(_,N)}releaseHints(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,z){return N.label.length===0||Array.isArray(N.label)&&N.label.every(X=>X.value.length===0)?(console.log("INVALID inlay hint, empty label",N),!1):!(z&&!z.contains(N.position))}m(N,z){const X=this.e.get(z[0]);if(!X)throw Error("DisposableStore is missing...");const _={label:"",cacheId:z,tooltip:k.MarkdownString.fromStrict(N.tooltip),position:k.Position.from(N.position),textEdits:N.textEdits&&N.textEdits.map(k.TextEdit.from),kind:N.kind&&k.InlayHintKind.from(N.kind),paddingLeft:N.paddingLeft,paddingRight:N.paddingRight};return typeof N.label=="string"?_.label=N.label:_.label=N.label.map(ue=>{const be={label:ue.value};return be.tooltip=k.MarkdownString.fromStrict(ue.tooltip),A.Location.isLocation(ue.location)&&(be.location=k.location.from(ue.location)),ue.command&&(be.command=this.g.toInternal(ue.command,X)),be}),_}}class ve{constructor(N,z){this.e=N,this.f=z,this.d=new h.Cache("DocumentLink")}async provideLinks(N,z){const X=this.e.getDocument(N),_=await this.f.provideDocumentLinks(X,z);if(!(!Array.isArray(_)||_.length===0)&&!z.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:_.filter(ve.g).map(k.DocumentLink.from)};{const ue=this.d.add(_),be={links:[],cacheId:ue};for(let ke=0;ke<_.length;ke++){if(!ve.g(_[ke]))continue;const ge=k.DocumentLink.from(_[ke]);ge.cacheId=[ue,ke],be.links.push(ge)}return be}}}static g(N){return N.target&&N.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(N,z){if(typeof this.f.resolveDocumentLink!="function")return;const X=this.d.get(...N);if(!X)return;const _=await this.f.resolveDocumentLink(X,z);if(!(!_||!ve.g(_)))return k.DocumentLink.from(_)}releaseLinks(N){this.d.delete(N)}}class De{constructor(N,z){this.d=N,this.e=z}async provideColors(N,z){const X=this.d.getDocument(N),_=await this.e.provideDocumentColors(X,z);return Array.isArray(_)?_.map(be=>({color:k.Color.from(be.color),range:k.Range.from(be.range)})):[]}async provideColorPresentations(N,z,X){const _=this.d.getDocument(N),ue=k.Range.to(z.range),be=k.Color.to(z.color),ke=await this.e.provideColorPresentations(be,{document:_,range:ue},X);if(!!Array.isArray(ke))return ke.map(k.ColorPresentation.from)}}class Re{constructor(N,z){this.d=N,this.e=z}async provideFoldingRanges(N,z,X){const _=this.d.getDocument(N),ue=await this.e.provideFoldingRanges(_,z,X);if(!!Array.isArray(ue))return ue.map(k.FoldingRange.from)}}class $e{constructor(N,z,X){this.d=N,this.e=z,this.f=X}async provideSelectionRanges(N,z,X){const _=this.d.getDocument(N),ue=z.map(k.Position.to),be=await this.e.provideSelectionRanges(_,ue,X);if(!(0,R.isNonEmptyArray)(be))return[];if(be.length!==ue.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ke=[];for(let ge=0;ge<ue.length;ge++){const Pe=[];ke.push(Pe);let Ie=ue[ge],je=be[ge];for(;;){if(!je.range.contains(Ie))throw new Error("INVALID selection range, must contain the previous range");if(Pe.push(k.SelectionRange.from(je)),!je.parent)break;Ie=je.range,je=je.parent}}return ke}}class re{constructor(N,z){this.f=N,this.g=z,this.d=new g.IdGenerator(""),this.e=new Map}async prepareSession(N,z,X){const _=this.f.getDocument(N),ue=k.Position.to(z),be=await this.g.prepareCallHierarchy(_,ue,X);if(!be)return;const ke=this.d.nextId();return this.e.set(ke,new Map),Array.isArray(be)?be.map(ge=>this.h(ke,ge)):[this.h(ke,be)]}async provideCallsTo(N,z,X){const _=this.j(N,z);if(!_)throw new Error("missing call hierarchy item");const ue=await this.g.provideCallHierarchyIncomingCalls(_,X);if(!!ue)return ue.map(be=>({from:this.h(N,be.from),fromRanges:be.fromRanges.map(ke=>k.Range.from(ke))}))}async provideCallsFrom(N,z,X){const _=this.j(N,z);if(!_)throw new Error("missing call hierarchy item");const ue=await this.g.provideCallHierarchyOutgoingCalls(_,X);if(!!ue)return ue.map(be=>({to:this.h(N,be.to),fromRanges:be.fromRanges.map(ke=>k.Range.from(ke))}))}releaseSession(N){this.e.delete(N)}h(N,z){const X=this.e.get(N),_=k.CallHierarchyItem.from(z,N,X.size.toString(36));return X.set(_._itemId,z),_}j(N,z){return this.e.get(N)?.get(z)}}class le{constructor(N,z){this.f=N,this.g=z,this.d=new g.IdGenerator(""),this.e=new Map}async prepareSession(N,z,X){const _=this.f.getDocument(N),ue=k.Position.to(z),be=await this.g.prepareTypeHierarchy(_,ue,X);if(!be)return;const ke=this.d.nextId();return this.e.set(ke,new Map),Array.isArray(be)?be.map(ge=>this.h(ke,ge)):[this.h(ke,be)]}async provideSupertypes(N,z,X){const _=this.j(N,z);if(!_)throw new Error("missing type hierarchy item");const ue=await this.g.provideTypeHierarchySupertypes(_,X);if(!!ue)return ue.map(be=>this.h(N,be))}async provideSubtypes(N,z,X){const _=this.j(N,z);if(!_)throw new Error("missing type hierarchy item");const ue=await this.g.provideTypeHierarchySubtypes(_,X);if(!!ue)return ue.map(be=>this.h(N,be))}releaseSession(N){this.e.delete(N)}h(N,z){const X=this.e.get(N),_=k.TypeHierarchyItem.from(z,N,X.size.toString(36));return X.set(_._itemId,z),_}j(N,z){return this.e.get(N)?.get(z)}}class fe{constructor(N,z,X,_){this.d=N,this.e=z,this.f=X,this.g=_}async provideDocumentOnDropEdits(N,z,X,_,ue){const be=this.e.getDocument(z),ke=k.Position.to(X),ge=k.DataTransfer.toDataTransfer(_,async Ie=>(await this.d.$resolveDocumentOnDropFileData(this.g,N,Ie)).buffer),Pe=await this.f.provideDocumentDropEdits(be,ke,ge,ue);if(!!Pe)return{insertText:typeof Pe.insertText=="string"?Pe.insertText:{snippet:Pe.insertText.value},additionalEdit:Pe.additionalEdit?k.WorkspaceEdit.from(Pe.additionalEdit,void 0):void 0}}}class Z{constructor(N,z){this.adapter=N,this.extension=z}}class se{constructor(N,z,X,_,ue,be,ke,ge){this.g=z,this.h=X,this.j=_,this.k=ue,this.l=be,this.m=ke,this.n=ge,this.f=new Map,this.e=N.getProxy(T.MainContext.MainThreadLanguageFeatures)}o(N){return k.DocumentSelector.from(N,this.g)}p(N){return new A.Disposable(()=>{this.f.delete(N),this.e.$unregister(N)})}q(){return se.d++}async s(N,z,X,_,ue,be=!1){const ke=this.f.get(N);if(!ke||!(ke.adapter instanceof z))return _;const ge=Date.now();be||this.l.trace(`[${ke.extension.identifier.value}] INVOKE provider '${X.toString().replace(/[\r\n]/g,"")}'`);const Pe=X(ke.adapter,ke.extension);return Promise.resolve(Pe).catch(Ie=>{(0,m.isCancellationError)(Ie)||(this.l.error(`[${ke.extension.identifier.value}] provider FAILED`),this.l.error(Ie),this.n.onExtensionError(ke.extension.identifier,Ie))}).finally(()=>{be||this.l.trace(`[${ke.extension.identifier.value}] provider DONE after ${Date.now()-ge}ms`)}),y.CancellationToken.isCancellationToken(ue)?(0,f.raceCancellationError)(Pe,ue):Pe}t(N,z){const X=this.q();return this.f.set(X,new Z(N,z)),X}static u(N){return N.displayName||N.name}registerDocumentSymbolProvider(N,z,X,_){const ue=this.t(new s(this.h,X),N),be=_&&_.label||se.u(N);return this.e.$registerDocumentSymbolProvider(ue,this.o(z),be),this.p(ue)}$provideDocumentSymbols(N,z,X){return this.s(N,s,_=>_.provideDocumentSymbols(a.URI.revive(z),X),void 0,X)}registerCodeLensProvider(N,z,X){const _=this.q(),ue=typeof X.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(_,new Z(new o(this.h,this.j.converter,X),N)),this.e.$registerCodeLensSupport(_,this.o(z),ue);let be=this.p(_);if(ue!==void 0){const ke=X.onDidChangeCodeLenses(ge=>this.e.$emitCodeLensEvent(ue));be=A.Disposable.from(be,ke)}return be}$provideCodeLenses(N,z,X){return this.s(N,o,_=>_.provideCodeLenses(a.URI.revive(z),X),void 0,X)}$resolveCodeLens(N,z,X){return this.s(N,o,_=>_.resolveCodeLens(z,X),void 0,void 0)}$releaseCodeLenses(N,z){this.s(N,o,X=>Promise.resolve(X.releaseCodeLenses(z)),void 0,void 0)}registerDefinitionProvider(N,z,X){const _=this.t(new u(this.h,X),N);return this.e.$registerDefinitionSupport(_,this.o(z)),this.p(_)}$provideDefinition(N,z,X,_){return this.s(N,u,ue=>ue.provideDefinition(a.URI.revive(z),X,_),[],_)}registerDeclarationProvider(N,z,X){const _=this.t(new r(this.h,X),N);return this.e.$registerDeclarationSupport(_,this.o(z)),this.p(_)}$provideDeclaration(N,z,X,_){return this.s(N,r,ue=>ue.provideDeclaration(a.URI.revive(z),X,_),[],_)}registerImplementationProvider(N,z,X){const _=this.t(new l(this.h,X),N);return this.e.$registerImplementationSupport(_,this.o(z)),this.p(_)}$provideImplementation(N,z,X,_){return this.s(N,l,ue=>ue.provideImplementation(a.URI.revive(z),X,_),[],_)}registerTypeDefinitionProvider(N,z,X){const _=this.t(new n(this.h,X),N);return this.e.$registerTypeDefinitionSupport(_,this.o(z)),this.p(_)}$provideTypeDefinition(N,z,X,_){return this.s(N,n,ue=>ue.provideTypeDefinition(a.URI.revive(z),X,_),[],_)}registerHoverProvider(N,z,X,_){const ue=this.t(new i(this.h,X),N);return this.e.$registerHoverProvider(ue,this.o(z)),this.p(ue)}$provideHover(N,z,X,_){return this.s(N,i,ue=>ue.provideHover(a.URI.revive(z),X,_),void 0,_)}registerEvaluatableExpressionProvider(N,z,X,_){const ue=this.t(new p(this.h,X),N);return this.e.$registerEvaluatableExpressionProvider(ue,this.o(z)),this.p(ue)}$provideEvaluatableExpression(N,z,X,_){return this.s(N,p,ue=>ue.provideEvaluatableExpression(a.URI.revive(z),X,_),void 0,_)}registerInlineValuesProvider(N,z,X,_){const ue=typeof X.onDidChangeInlineValues=="function"?this.q():void 0,be=this.t(new I(this.h,X),N);this.e.$registerInlineValuesProvider(be,this.o(z),ue);let ke=this.p(be);if(ue!==void 0){const ge=X.onDidChangeInlineValues(Pe=>this.e.$emitInlineValuesEvent(ue));ke=A.Disposable.from(ke,ge)}return ke}$provideInlineValues(N,z,X,_,ue){return this.s(N,I,be=>be.provideInlineValues(a.URI.revive(z),X,_,ue),void 0,ue)}registerDocumentHighlightProvider(N,z,X){const _=this.t(new L(this.h,X),N);return this.e.$registerDocumentHighlightProvider(_,this.o(z)),this.p(_)}$provideDocumentHighlights(N,z,X,_){return this.s(N,L,ue=>ue.provideDocumentHighlights(a.URI.revive(z),X,_),void 0,_)}registerLinkedEditingRangeProvider(N,z,X){const _=this.t(new U(this.h,X),N);return this.e.$registerLinkedEditingRangeProvider(_,this.o(z)),this.p(_)}$provideLinkedEditingRanges(N,z,X,_){return this.s(N,U,async ue=>{const be=await ue.provideLinkedEditingRanges(a.URI.revive(z),X,_);if(be)return{ranges:be.ranges,wordPattern:be.wordPattern?se.w(be.wordPattern):void 0}},void 0,_)}registerReferenceProvider(N,z,X){const _=this.t(new G(this.h,X),N);return this.e.$registerReferenceSupport(_,this.o(z)),this.p(_)}$provideReferences(N,z,X,_,ue){return this.s(N,G,be=>be.provideReferences(a.URI.revive(z),X,_,ue),void 0,ue)}registerCodeActionProvider(N,z,X,_){const ue=new v.DisposableStore,be=this.t(new V(this.h,this.j.converter,this.k,X,this.l,N,this.m),N);return this.e.$registerQuickFixSupport(be,this.o(z),{providedKinds:_?.providedCodeActionKinds?.map(ke=>ke.value),documentation:_?.documentation?.map(ke=>({kind:ke.kind.value,command:this.j.converter.toInternal(ke.command,ue)}))},se.u(N),Boolean(X.resolveCodeAction)),ue.add(this.p(be)),ue}$provideCodeActions(N,z,X,_,ue){return this.s(N,V,be=>be.provideCodeActions(a.URI.revive(z),X,_,ue),void 0,ue)}$resolveCodeAction(N,z,X){return this.s(N,V,_=>_.resolveCodeAction(z,X),void 0,void 0)}$releaseCodeActions(N,z){this.s(N,V,X=>Promise.resolve(X.releaseCodeActions(z)),void 0,void 0)}registerDocumentFormattingEditProvider(N,z,X){const _=this.t(new B(this.h,X),N);return this.e.$registerDocumentFormattingSupport(_,this.o(z),N.identifier,N.displayName||N.name),this.p(_)}$provideDocumentFormattingEdits(N,z,X,_){return this.s(N,B,ue=>ue.provideDocumentFormattingEdits(a.URI.revive(z),X,_),void 0,_)}registerDocumentRangeFormattingEditProvider(N,z,X){const _=this.t(new F(this.h,X),N);return this.e.$registerRangeFormattingSupport(_,this.o(z),N.identifier,N.displayName||N.name),this.p(_)}$provideDocumentRangeFormattingEdits(N,z,X,_,ue){return this.s(N,F,be=>be.provideDocumentRangeFormattingEdits(a.URI.revive(z),X,_,ue),void 0,ue)}registerOnTypeFormattingEditProvider(N,z,X,_){const ue=this.t(new $(this.h,X),N);return this.e.$registerOnTypeFormattingSupport(ue,this.o(z),_,N.identifier),this.p(ue)}$provideOnTypeFormattingEdits(N,z,X,_,ue,be){return this.s(N,$,ke=>ke.provideOnTypeFormattingEdits(a.URI.revive(z),X,_,ue,be),void 0,be)}registerWorkspaceSymbolProvider(N,z){const X=this.t(new M(z,this.l),N);return this.e.$registerNavigateTypeSupport(X,typeof z.resolveWorkspaceSymbol=="function"),this.p(X)}$provideWorkspaceSymbols(N,z,X){return this.s(N,M,_=>_.provideWorkspaceSymbols(z,X),{symbols:[]},X)}$resolveWorkspaceSymbol(N,z,X){return this.s(N,M,_=>_.resolveWorkspaceSymbol(z,X),void 0,void 0)}$releaseWorkspaceSymbols(N,z){this.s(N,M,X=>X.releaseWorkspaceSymbols(z),void 0,void 0)}registerRenameProvider(N,z,X){const _=this.t(new H(this.h,X,this.l),N);return this.e.$registerRenameSupport(_,this.o(z),H.supportsResolving(X)),this.p(_)}$provideRenameEdits(N,z,X,_,ue){return this.s(N,H,be=>be.provideRenameEdits(a.URI.revive(z),X,_,ue),void 0,ue)}$resolveRenameLocation(N,z,X,_){return this.s(N,H,ue=>ue.resolveRenameLocation(a.URI.revive(z),X,_),void 0,_)}registerDocumentSemanticTokensProvider(N,z,X,_){const ue=this.t(new q(this.h,X),N),be=typeof X.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ue,this.o(z),_,be);let ke=this.p(ue);if(be){const ge=X.onDidChangeSemanticTokens(Pe=>this.e.$emitDocumentSemanticTokensEvent(be));ke=A.Disposable.from(ke,ge)}return ke}$provideDocumentSemanticTokens(N,z,X,_){return this.s(N,q,ue=>ue.provideDocumentSemanticTokens(a.URI.revive(z),X,_),null,_)}$releaseDocumentSemanticTokens(N,z){this.s(N,q,X=>X.releaseDocumentSemanticColoring(z),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(N,z,X,_){const ue=this.t(new Y(this.h,X),N);return this.e.$registerDocumentRangeSemanticTokensProvider(ue,this.o(z),_),this.p(ue)}$provideDocumentRangeSemanticTokens(N,z,X,_){return this.s(N,Y,ue=>ue.provideDocumentRangeSemanticTokens(a.URI.revive(z),X,_),null,_)}registerCompletionItemProvider(N,z,X,_){const ue=this.t(new Q(this.h,this.j.converter,X,this.m,N),N);return this.e.$registerCompletionsProvider(ue,this.o(z),_,Q.supportsResolving(X),`${N.identifier.value}(${_.join("")})`),this.p(ue)}$provideCompletionItems(N,z,X,_,ue){return this.s(N,Q,be=>be.provideCompletionItems(a.URI.revive(z),X,_,ue),void 0,ue)}$resolveCompletionItem(N,z,X){return this.s(N,Q,_=>_.resolveCompletionItem(z,X),void 0,X)}$releaseCompletionItems(N,z){this.s(N,Q,X=>X.releaseCompletionItems(z),void 0,void 0)}registerInlineCompletionsProvider(N,z,X){const _=new ie(N,this.h,X,this.j.converter),ue=this.t(_,N);return this.e.$registerInlineCompletionsSupport(ue,this.o(z),_.supportsHandleDidShowCompletionItem),this.p(ue)}$provideInlineCompletions(N,z,X,_,ue){return this.s(N,ce,be=>be.provideInlineCompletions(a.URI.revive(z),X,_,ue),void 0,ue)}$handleInlineCompletionDidShow(N,z,X){this.s(N,ce,async _=>{_.handleDidShowCompletionItem(z,X)},void 0,void 0)}$freeInlineCompletionsList(N,z){this.s(N,ce,async X=>{X.disposeCompletions(z)},void 0,void 0)}registerSignatureHelpProvider(N,z,X,_){const ue=Array.isArray(_)?{triggerCharacters:_,retriggerCharacters:[]}:_,be=this.t(new J(this.h,X),N);return this.e.$registerSignatureHelpProvider(be,this.o(z),ue),this.p(be)}$provideSignatureHelp(N,z,X,_,ue){return this.s(N,J,be=>be.provideSignatureHelp(a.URI.revive(z),X,_,ue),void 0,ue)}$releaseSignatureHelp(N,z){this.s(N,J,X=>X.releaseSignatureHelp(z),void 0,void 0)}registerInlayHintsProvider(N,z,X){const _=typeof X.onDidChangeInlayHints=="function"?this.q():void 0,ue=this.t(new pe(this.h,this.j.converter,X,this.l,N),N);this.e.$registerInlayHintsProvider(ue,this.o(z),typeof X.resolveInlayHint=="function",_,se.u(N));let be=this.p(ue);if(_!==void 0){const ke=X.onDidChangeInlayHints(ge=>this.e.$emitInlayHintsEvent(_));be=A.Disposable.from(be,ke)}return be}$provideInlayHints(N,z,X,_){return this.s(N,pe,ue=>ue.provideInlayHints(a.URI.revive(z),X,_),void 0,_)}$resolveInlayHint(N,z,X){return this.s(N,pe,_=>_.resolveInlayHint(z,X),void 0,X)}$releaseInlayHints(N,z){this.s(N,pe,X=>X.releaseHints(z),void 0,void 0)}registerDocumentLinkProvider(N,z,X){const _=this.t(new ve(this.h,X),N);return this.e.$registerDocumentLinkProvider(_,this.o(z),typeof X.resolveDocumentLink=="function"),this.p(_)}$provideDocumentLinks(N,z,X){return this.s(N,ve,_=>_.provideLinks(a.URI.revive(z),X),void 0,X,z.scheme==="output")}$resolveDocumentLink(N,z,X){return this.s(N,ve,_=>_.resolveLink(z,X),void 0,void 0,!0)}$releaseDocumentLinks(N,z){this.s(N,ve,X=>X.releaseLinks(z),void 0,void 0,!0)}registerColorProvider(N,z,X){const _=this.t(new De(this.h,X),N);return this.e.$registerDocumentColorProvider(_,this.o(z)),this.p(_)}$provideDocumentColors(N,z,X){return this.s(N,De,_=>_.provideColors(a.URI.revive(z),X),[],X)}$provideColorPresentations(N,z,X,_){return this.s(N,De,ue=>ue.provideColorPresentations(a.URI.revive(z),X,_),void 0,_)}registerFoldingRangeProvider(N,z,X){const _=this.q(),ue=typeof X.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(_,new Z(new Re(this.h,X),N)),this.e.$registerFoldingRangeProvider(_,this.o(z),N.identifier,ue);let be=this.p(_);if(ue!==void 0){const ke=X.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ue));be=A.Disposable.from(be,ke)}return be}$provideFoldingRanges(N,z,X,_){return this.s(N,Re,ue=>ue.provideFoldingRanges(a.URI.revive(z),X,_),void 0,_)}registerSelectionRangeProvider(N,z,X){const _=this.t(new $e(this.h,X,this.l),N);return this.e.$registerSelectionRangeProvider(_,this.o(z)),this.p(_)}$provideSelectionRanges(N,z,X,_){return this.s(N,$e,ue=>ue.provideSelectionRanges(a.URI.revive(z),X,_),[],_)}registerCallHierarchyProvider(N,z,X){const _=this.t(new re(this.h,X),N);return this.e.$registerCallHierarchyProvider(_,this.o(z)),this.p(_)}$prepareCallHierarchy(N,z,X,_){return this.s(N,re,ue=>Promise.resolve(ue.prepareSession(a.URI.revive(z),X,_)),void 0,_)}$provideCallHierarchyIncomingCalls(N,z,X,_){return this.s(N,re,ue=>ue.provideCallsTo(z,X,_),void 0,_)}$provideCallHierarchyOutgoingCalls(N,z,X,_){return this.s(N,re,ue=>ue.provideCallsFrom(z,X,_),void 0,_)}$releaseCallHierarchy(N,z){this.s(N,re,X=>Promise.resolve(X.releaseSession(z)),void 0,void 0)}registerTypeHierarchyProvider(N,z,X){const _=this.t(new le(this.h,X),N);return this.e.$registerTypeHierarchyProvider(_,this.o(z)),this.p(_)}$prepareTypeHierarchy(N,z,X,_){return this.s(N,le,ue=>Promise.resolve(ue.prepareSession(a.URI.revive(z),X,_)),void 0,_)}$provideTypeHierarchySupertypes(N,z,X,_){return this.s(N,le,ue=>ue.provideSupertypes(z,X,_),void 0,_)}$provideTypeHierarchySubtypes(N,z,X,_){return this.s(N,le,ue=>ue.provideSubtypes(z,X,_),void 0,_)}$releaseTypeHierarchy(N,z){this.s(N,le,X=>Promise.resolve(X.releaseSession(z)),void 0,void 0)}registerDocumentOnDropEditProvider(N,z,X){const _=this.q();return this.f.set(_,new Z(new fe(this.e,this.h,X,_),N)),this.e.$registerDocumentOnDropEditProvider(_,this.o(z)),this.p(_)}$provideDocumentOnDropEdits(N,z,X,_,ue,be){return this.s(N,fe,ke=>Promise.resolve(ke.provideDocumentOnDropEdits(z,a.URI.revive(X),_,ue,be)),void 0,void 0)}registerDocumentPasteEditProvider(N,z,X,_){const ue=this.q();return this.f.set(ue,new Z(new O(this.e,this.h,X,ue),N)),this.e.$registerPasteEditProvider(ue,this.o(z),!!X.prepareDocumentPaste,_.pasteMimeTypes),this.p(ue)}$prepareDocumentPaste(N,z,X,_,ue){return this.s(N,O,be=>be.prepareDocumentPaste(a.URI.revive(z),X,_,ue),void 0,ue)}$providePasteEdits(N,z,X,_,ue,be){return this.s(N,O,ke=>ke.providePasteEdits(z,a.URI.revive(X),_,ue,be),void 0,be)}static w(N){return{pattern:N.source,flags:(0,S.regExpFlags)(N)}}static y(N){return{decreaseIndentPattern:se.w(N.decreaseIndentPattern),increaseIndentPattern:se.w(N.increaseIndentPattern),indentNextLinePattern:N.indentNextLinePattern?se.w(N.indentNextLinePattern):void 0,unIndentedLinePattern:N.unIndentedLinePattern?se.w(N.unIndentedLinePattern):void 0}}static B(N){return{beforeText:se.w(N.beforeText),afterText:N.afterText?se.w(N.afterText):void 0,previousLineText:N.previousLineText?se.w(N.previousLineText):void 0,action:N.action}}static C(N){return N.map(se.B)}setLanguageConfiguration(N,z,X){const{wordPattern:_}=X;if(_&&(0,S.regExpLeadsToEndlessLoop)(_))throw new Error(`Invalid language configuration: wordPattern '${_}' is not allowed to match the empty string.`);_?this.h.setWordDefinitionFor(z,_):this.h.setWordDefinitionFor(z,void 0),X.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",N,"Do not use."),X.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",N,"Do not use.");const ue=this.q(),be={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?se.w(X.wordPattern):void 0,indentationRules:X.indentationRules?se.y(X.indentationRules):void 0,onEnterRules:X.onEnterRules?se.C(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport};return this.e.$setLanguageConfiguration(ue,z,be),this.p(ue)}$setWordDefinitions(N){for(const z of N)this.h.setWordDefinitionFor(z.languageId,new RegExp(z.regexSource,z.regexFlags))}}e.ExtHostLanguageFeatures=se,se.d=0}),define(Se[257],ye([1,0,5,14,7,42,18,6]),function(te,e,a,t,k,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(R,P,E,y){this.c=P,this.d=E,this.e=y,this.b=[],this.f=0,this.g=new Set,this.a=R.getProxy(a.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this.b=R}async getLanguages(){return this.b.slice(0)}async changeLanguage(R,P){await this.a.$changeLanguage(R,P);const E=this.c.getDocumentData(R);if(!E)throw new Error(`document '${R.toString()}' NOT found`);return E.document}async tokenAtPosition(R,P){const E=R.version,y=t.Position.from(P),v=await this.a.$tokensAtPosition(R.uri,y),d={type:k.StandardTokenType.Other,range:R.getWordRangeAtPosition(P)??new k.Range(P.line,P.character,P.line,P.character)};if(!v)return d;const g={range:t.Range.to(v.range),type:t.TokenType.to(v.type)};return!g.range.contains(P)||E!==R.version?d:g}createLanguageStatusItem(R,P,E){const y=this.f++,v=this.a,d=this.g,g=`${R.identifier.value}/${P}`;if(d.has(g))throw new Error(`LanguageStatusItem with id '${P}' ALREADY exists`);d.add(g);const h={selector:E,id:P,name:R.displayName??R.name,severity:k.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let w;const m=new T.DisposableStore,f=()=>{w?.dispose(),w=(0,D.disposableTimeout)(()=>{m.clear(),this.a.$setLanguageStatus(y,{id:g,name:h.name??R.displayName??R.name,source:R.displayName??R.name,selector:t.DocumentSelector.from(h.selector,this.e),label:h.text,detail:h.detail??"",severity:h.severity===k.LanguageStatusSeverity.Error?A.default.Error:h.severity===k.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:h.command&&this.d.toInternal(h.command,m),accessibilityInfo:h.accessibilityInformation,busy:h.busy})},0)},b={dispose(){m.dispose(),w?.dispose(),v.$removeLanguageStatus(y),d.delete(g)},get id(){return h.id},get name(){return h.name},set name(s){h.name=s,f()},get selector(){return h.selector},set selector(s){h.selector=s,f()},get text(){return h.text},set text(s){h.text=s,f()},get detail(){return h.detail},set detail(s){h.detail=s,f()},get severity(){return h.severity},set severity(s){h.severity=s,f()},get accessibilityInformation(){return h.accessibilityInformation},set accessibilityInformation(s){h.accessibilityInformation=s,f()},get command(){return h.command},set command(s){h.command=s,f()},get busy(){return h.busy},set busy(s){h.busy=s,f()}};return f(),b}}e.ExtHostLanguages=S}),define(Se[95],ye([1,0,12,8,2,3,13,5,25,16]),function(te,e,a,t,k,A,D,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let R=class{constructor(E,y,v){this.f=v,this.d=new Map,this.a=y.getProxy(T.MainContext.MainThreadLocalization),this.b=E.environment.appLanguage,this.c=this.b===a.LANGUAGE_DEFAULT}getMessage(E,y){const{message:v,args:d,comment:g}=y;if(this.c)return(0,t.format2)(v,d??{});let h=v;g&&g.length>0&&(h+=`/${Array.isArray(g)?g.join():g}`);const w=this.d.get(E)?.contents[h];return w||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${h}`),(0,t.format2)(w??v,d??{})}getBundle(E){return this.d.get(E)?.contents}getBundleUri(E){return this.d.get(E)?.uri}async initializeLocalizedMessages(E){if(this.c||!E.l10n&&!E.isBuiltin||this.d.has(E.identifier.value))return;let y;const v=await this.g(E);if(!v){this.f.error(`No bundle location found for extension ${E.identifier.value}`);return}try{const d=await this.a.$fetchBundleContents(v),g=JSON.parse(d);y=E.isBuiltin?g.contents?.bundle:g}catch(d){this.f.error(`Failed to load translations for ${E.identifier.value} from ${v}: ${d.message}`);return}y&&this.d.set(E.identifier.value,{contents:y,uri:v})}async g(E){if(E.isBuiltin){const y=await this.a.$fetchBuiltInBundleUri(E.identifier.value);return k.URI.revive(y)}return E.l10n?k.URI.joinPath(E.extensionLocation,E.l10n,`bundle.l10n.${this.b}.json`):void 0}};R=Ve([We(0,S.IExtHostInitDataService),We(1,C.IExtHostRpcService),We(2,D.ILogService)],R),e.ExtHostLocalizationService=R,e.IExtHostLocalizationService=(0,A.createDecorator)("IExtHostLocalizationService")}),define(Se[139],ye([1,0,13,5,25,16,2,4,11]),function(te,e,a,t,k,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let C=class extends a.AbstractLoggerService{constructor(E,y){super(y.logLevel,T.Event.None),this.g=E.getProxy(t.MainContext.MainThreadLogger)}$setLevel(E,y){y?this.setLevel(D.URI.revive(y),E):(0,S.isUndefined)(E)||this.setLevel(E)}f(E,y,v){return new R(this.g,E,y,v)}};C=Ve([We(0,A.IExtHostRpcService),We(1,k.IExtHostInitDataService)],C),e.ExtHostLoggerService=C;class R extends a.AbstractMessageLogger{constructor(E,y,v,d){super(d?.always),this.l=E,this.m=y,this.j=!1,this.k=[],this.setLevel(v),this.l.$createLogger(y,d).then(()=>{this.p(this.k),this.j=!0})}f(E,y){const v=[[E,y]];this.j?this.p(v):this.k.push(...v)}p(E){this.l.$log(this.m,E)}}}),define(Se[258],ye([1,0,5,13,26]),function(te,e,a,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(T){return T&&T.title}let D=class{constructor(S,C){this.b=C,this.a=S.getProxy(a.MainContext.MainThreadMessageService)}showMessage(S,C,R,P,E){const y={source:{identifier:S.identifier,label:S.displayName||S.name}};let v;typeof P=="string"||A(P)?v=[P,...E]:(y.modal=P?.modal,y.useCustom=P?.useCustom,y.detail=P?.detail,v=E),y.useCustom&&(0,k.checkProposedApiEnabled)(S,"resolvers");const d=[];for(let g=0;g<v.length;g++){const h=v[g];if(typeof h=="string")d.push({title:h,handle:g,isCloseAffordance:!1});else if(typeof h=="object"){const{title:w,isCloseAffordance:m}=h;d.push({title:w,isCloseAffordance:!!m,handle:g})}else this.b.warn("Invalid message item:",h)}return this.a.$showMessage(C,R,y,d).then(g=>{if(typeof g=="number")return v[g]})}};D=Ve([We(1,t.ILogService)],D),e.ExtHostMessageService=D}),define(Se[259],ye([1,0,22,4,6,28,8,11,2,67,5,39,14,7,57,234,135]),function(te,e,a,t,k,A,D,T,S,C,R,P,E,y,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class h{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(m=>m.apiEditor)}constructor(m,f,b,s){this.q=b,this.r=s,this.f=new Map,this.g=new A.ResourceMap,this.h=new Map,this.j=new t.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new t.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new t.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=m.getProxy(R.MainContext.MainThreadNotebook),this.c=m.getProxy(R.MainContext.MainThreadNotebookDocuments),this.d=m.getProxy(R.MainContext.MainThreadNotebookEditors),this.i=f.converter,f.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===13){const c=o.notebookEditor?.notebookUri,u=o.cell.handle,l=this.g.get(c)?.getCell(u);if(l)return l.apiCell}if(o&&o.$mid===14){const c=o.uri,u=this.g.get(c);if(u)return u.apiNotebook}return o}}),h.x(f)}getEditorById(m){const f=this.h.get(m);if(!f)throw new Error(`unknown text editor: ${m}. known editors: ${[...this.h.keys()]} `);return f}getIdByEditor(m){for(const[f,b]of this.h)if(b.apiEditor===m)return f}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(m,f){const b=this.g.get(m);if(!b&&!f)throw new Error(`NO notebook document for '${m}'`);return b}static s(m,f){if(!f)return;const b=f.filenamePattern.map(s=>E.NotebookExclusiveDocumentPattern.from(s)).filter(s=>s!==void 0);if(f.filenamePattern&&!b){console.warn(`Notebook content provider view options file name pattern is invalid ${f.filenamePattern}`);return}return{extension:m.identifier,providerDisplayName:m.displayName||m.name,displayName:f.displayName,filenamePattern:b,exclusive:f.exclusive||!1}}registerNotebookCellStatusBarItemProvider(m,f,b){const s=h.a++,o=typeof b.onDidChangeCellStatusBarItems=="function"?h.a++:void 0;this.f.set(s,b),this.b.$registerNotebookCellStatusBarItemProvider(s,o,f);let c;return o!==void 0&&(c=b.onDidChangeCellStatusBarItems(u=>this.b.$emitCellStatusBarEvent(o))),new y.Disposable(()=>{this.f.delete(s),this.b.$unregisterNotebookCellStatusBarItemProvider(s,o),c?.dispose()})}async createNotebookDocument(m){const f=await this.c.$tryCreateNotebook({viewType:m.viewType,content:m.content&&E.NotebookData.from(m.content)});return S.URI.revive(f)}async openNotebookDocument(m){const f=this.g.get(m);if(f)return f.apiNotebook;const b=await this.c.$tryOpenNotebook(m),s=this.g.get(S.URI.revive(b));return(0,T.assertIsDefined)(s?.apiNotebook)}async showNotebookDocument(m,f){S.URI.isUri(m)&&(m=await this.openNotebookDocument(m));let b;typeof f=="object"?b={position:E.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus,selections:f.selections&&f.selections.map(E.NotebookRange.from),pinned:typeof f.preview=="boolean"?!f.preview:void 0}:b={preserveFocus:!1};const s=await this.d.$tryShowNotebookDocument(m.uri,m.notebookType,b),o=s&&this.h.get(s)?.apiEditor;if(o)return o;throw s?new Error(`Could NOT open editor for "${m.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${m.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(m,f,b,s){const o=this.f.get(m),c=S.URI.revive(f),u=this.g.get(c);if(!u||!o)return;const r=u.getCellFromIndex(b);if(!r)return;const l=await o.provideCellStatusBarItems(r.apiCell,s);if(!l)return;const n=new k.DisposableStore,i=this.p.add([n]),I=(Array.isArray(l)?l:[l]).map(L=>E.NotebookStatusBarItem.from(L,this.i,n));return{cacheId:i,items:I}}$releaseNotebookCellStatusBarItems(m){this.p.delete(m)}registerNotebookSerializer(m,f,b,s,o){if((0,D.isFalsyOrWhitespace)(f))throw new Error("viewType cannot be empty or just whitespace");const c=this.t++;return this.u.set(c,b),this.b.$registerNotebookSerializer(c,{id:m.identifier,location:m.extensionLocation},f,E.NotebookDocumentContentOptions.from(s),h.s(m,o)),(0,k.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(c)})}async $dataToNotebook(m,f,b){const s=this.u.get(m);if(!s)throw new Error("NO serializer found");const o=await s.deserializeNotebook(f.buffer,b);return new v.SerializableObjectWithBuffers(E.NotebookData.from(o))}async $notebookToData(m,f,b){const s=this.u.get(m);if(!s)throw new Error("NO serializer found");const o=await s.serializeNotebook(E.NotebookData.to(f.value),b);return a.VSBuffer.wrap(o)}w(m,f,b){if(this.h.has(f))throw new Error(`editor with id ALREADY EXSIST: ${f}`);const s=new g.ExtHostNotebookEditor(f,this.d,m,b.visibleRanges.map(E.NotebookRange.to),b.selections.map(E.NotebookRange.to),typeof b.viewColumn=="number"?E.ViewColumn.to(b.viewColumn):void 0);this.h.set(f,s)}$acceptDocumentAndEditorsDelta(m){if(m.value.removedDocuments)for(const b of m.value.removedDocuments){const s=S.URI.revive(b),o=this.g.get(s);o&&(o.dispose(),this.g.delete(s),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:o.apiNotebook.getCells().map(c=>c.document.uri)}),this.n.fire(o.apiNotebook));for(const c of this.h.values())c.notebookData.uri.toString()===s.toString()&&this.h.delete(c.id)}if(m.value.addedDocuments){const b=[];for(const s of m.value.addedDocuments){const o=S.URI.revive(s.uri);if(this.g.has(o))throw new Error(`adding EXISTING notebook ${o} `);const c=new d.ExtHostNotebookDocument(this.c,this.q,this.r,o,s);b.push(...s.cells.map(u=>d.ExtHostCell.asModelAddData(c.apiNotebook,u))),this.g.get(o)?.dispose(),this.g.set(o,c),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:b}),this.m.fire(c.apiNotebook)}}if(m.value.addedEditors)for(const b of m.value.addedEditors){if(this.h.has(b.id))return;const s=S.URI.revive(b.documentUri),o=this.g.get(s);o&&this.w(o,b.id,b)}const f=[];if(m.value.removedEditors)for(const b of m.value.removedEditors){const s=this.h.get(b);s&&(this.h.delete(b),this.k?.id===s.id&&(this.k=void 0),f.push(s))}if(m.value.visibleEditors){this.l=m.value.visibleEditors.map(s=>this.h.get(s)).filter(s=>!!s);const b=new Set;this.l.forEach(s=>b.add(s.id));for(const s of this.h.values()){const o=b.has(s.id);s._acceptVisibility(o)}this.l=[...this.h.values()].map(s=>s).filter(s=>s.visible),this.o.fire(this.visibleNotebookEditors)}m.value.newActiveEditor===null?this.k=void 0:m.value.newActiveEditor&&(this.k=this.h.get(m.value.newActiveEditor)),m.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(m){const f=P.ApiCommandArgument.String.with("notebookType","A notebook type"),b=new P.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[f,new P.ApiCommandArgument("data","Bytes to convert to data",o=>o instanceof Uint8Array,o=>a.VSBuffer.wrap(o))],new P.ApiCommandResult("Notebook Data",o=>E.NotebookData.to(o.value))),s=new P.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[f,new P.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",o=>!0,o=>new v.SerializableObjectWithBuffers(E.NotebookData.from(o)))],new P.ApiCommandResult("Bytes",o=>o.buffer));m.registerApiCommand(b),m.registerApiCommand(s)}}e.ExtHostNotebookController=h,h.a=0}),define(Se[260],ye([1,0,17,18,21,4,6,28,2,27,13,67,5,39,14,7,92,221,26,57]),function(te,e,a,t,k,A,D,T,S,C,R,P,E,y,v,d,g,h,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let f=class{constructor(r,l,n,i,p){this.k=l,this.l=n,this.m=i,this.n=p,this.b=new T.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new P.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new A.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=r.getProxy(E.MainContext.MainThreadNotebookKernels);const I=new y.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new y.ApiCommandArgument("options","Select kernel options",L=>!0,L=>{if(L&&"notebookEditor"in L&&"id"in L){const U=this.l.getIdByEditor(L.notebookEditor);return{id:L.id,extension:L.extension,notebookEditorId:U}}else if(L&&"notebookEditor"in L){const U=this.l.getIdByEditor(L.notebookEditor);if(U===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${L.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:U}}return L})],y.ApiCommandResult.Void);this.m.registerApiCommand(I)}createNotebookController(r,l,n,i,p,I){for(const ce of this.h.values())if(ce.controller.id===l&&C.ExtensionIdentifier.equals(r.identifier,ce.extensionId))throw new Error(`notebook controller with id '${l}' ALREADY exist`);const L=this.i++,U=this;this.n.trace(`NotebookController[${L}], CREATED by ${r.identifier.value}, ${l}`);const G=()=>console.warn(`NO execute handler from notebook controller '${$.id}' of extension: '${r.identifier}'`);let V=!1;const O=new D.DisposableStore,B=new A.Emitter,F=new A.Emitter,$={id:c(r.identifier,l),notebookType:n,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:i||r.identifier.value,preloads:I?I.map(v.NotebookRendererScript.from):[]};let M=p??G,H;this.a.$addKernel(L,$).catch(ce=>{console.log(ce),V=!0});let K=0;const q=()=>{if(V)return;const ce=++K;Promise.resolve().then(()=>{ce===K&&this.a.$updateKernel(L,$)})},Y=new T.ResourceMap,Q={get id(){return l},get notebookType(){return $.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return $.label},set label(ce){$.label=ce??r.displayName??r.name,q()},get detail(){return $.detail??""},set detail(ce){$.detail=ce,q()},get description(){return $.description??""},set description(ce){$.description=ce,q()},get kind(){return(0,w.checkProposedApiEnabled)(r,"notebookControllerKind"),$.kind??""},set kind(ce){(0,w.checkProposedApiEnabled)(r,"notebookControllerKind"),$.kind=ce,q()},get supportedLanguages(){return $.supportedLanguages},set supportedLanguages(ce){$.supportedLanguages=ce,q()},get supportsExecutionOrder(){return $.supportsExecutionOrder??!1},set supportsExecutionOrder(ce){$.supportsExecutionOrder=ce,q()},get rendererScripts(){return $.preloads?$.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return M},set executeHandler(ce){M=ce??G},get interruptHandler(){return H},set interruptHandler(ce){H=ce,$.supportsInterrupt=Boolean(ce),q()},createNotebookCellExecution(ce){if(V)throw new Error("notebook controller is DISPOSED");if(!Y.has(ce.notebook.uri))throw U.n.trace(`NotebookController[${L}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Y.keys()).map(ie=>ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${ce.notebook.uri.toString()}`);return U._createNotebookCellExecution(ce,c(r.identifier,this.id))},dispose:()=>{V||(this.n.trace(`NotebookController[${L}], DISPOSED`),V=!0,this.h.delete(L),O.dispose(),B.dispose(),F.dispose(),this.a.$removeKernel(L))},updateNotebookAffinity(ce,ie){ie===d.NotebookControllerAffinity2.Hidden&&(0,w.checkProposedApiEnabled)(r,"notebookControllerAffinityHidden"),U.a.$updateNotebookPriority(L,ce.uri,ie)},onDidReceiveMessage:F.event,postMessage(ce,ie){return(0,w.checkProposedApiEnabled)(r,"notebookMessaging"),U.a.$postMessage(L,ie&&U.l.getIdByEditor(ie),ce)},asWebviewUri(ce){return(0,w.checkProposedApiEnabled)(r,"notebookMessaging"),(0,g.asWebviewUri)(ce,U.k.remote)}};return this.h.set(L,{extensionId:r.identifier,controller:Q,onDidReceiveMessage:F,onDidChangeSelection:B,associatedNotebooks:Y}),Q}getIdByController(r){for(const[l,n]of this.h)if(n.controller===r)return c(n.extensionId,r.id);return null}createNotebookControllerDetectionTask(r,l){const n=this.d++,i=this;this.n.trace(`NotebookControllerDetectionTask[${n}], CREATED by ${r.identifier.value}`),this.a.$addKernelDetectionTask(n,l);const p={dispose:()=>{this.c.delete(n),i.a.$removeKernelDetectionTask(n)}};return this.c.set(n,p),p}registerKernelSourceActionProvider(r,l,n){const i=this.f++,p=this;return this.e.set(i,n),this.n.trace(`NotebookKernelSourceActionProvider[${i}], CREATED by ${r.identifier.value}`),this.a.$addKernelSourceActionProvider(i,l),{dispose:()=>{this.e.delete(i),p.a.$removeKernelSourceActionProvider(i)}}}async $provideKernelSourceActions(r,l){const n=this.e.get(r);if(n){const i=new D.DisposableStore;return this.g.add([i]),(await n.provideNotebookKernelSourceActions(l)??[]).map(I=>v.NotebookKernelSourceAction.from(I,this.m.converter,i))}return[]}$acceptNotebookAssociation(r,l,n){const i=this.h.get(r);if(i){const p=this.l.getNotebookDocument(S.URI.revive(l));n?i.associatedNotebooks.set(p.uri,!0):i.associatedNotebooks.delete(p.uri),this.n.trace(`NotebookController[${r}] ASSOCIATE notebook`,p.uri.toString(),n),i.onDidChangeSelection.fire({selected:n,notebook:p.apiNotebook})}}async $executeCells(r,l,n){const i=this.h.get(r);if(!i)return;const p=this.l.getNotebookDocument(S.URI.revive(l)),I=[];for(const L of n){const U=p.getCell(L);U&&I.push(U.apiCell)}try{this.n.trace(`NotebookController[${r}] EXECUTE cells`,p.uri.toString(),I.length),await i.controller.executeHandler.call(i.controller,I,p.apiNotebook,i.controller)}catch(L){this.n.error(`NotebookController[${r}] execute cells FAILED`,L),console.error(L)}}async $cancelCells(r,l,n){const i=this.h.get(r);if(!i)return;const p=this.l.getNotebookDocument(S.URI.revive(l));if(i.controller.interruptHandler)await i.controller.interruptHandler.call(i.controller,p.apiNotebook);else for(const I of n){const L=p.getCell(I);L&&this.b.get(L.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,l,n){const i=this.h.get(r);if(!i)return;const p=this.l.getEditorById(l);i.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:n}))}$cellExecutionChanged(r,l,n){const p=this.l.getNotebookDocument(S.URI.revive(r)).getCell(l);if(p){const I=n?v.NotebookCellExecutionState.to(n):d.NotebookCellExecutionState.Idle;I!==void 0&&this.j.fire({cell:p.apiCell,state:I})}}_createNotebookCellExecution(r,l){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const i=this.l.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!i)throw new Error("invalid cell");if(this.b.has(i.uri))throw new Error(`duplicate execution for ${i.uri}`);const p=new s(l,i,this.a);this.b.set(i.uri,p);const I=p.onDidChangeState(()=>{p.state===b.Resolved&&(p.dispose(),I.dispose(),this.b.delete(i.uri))});return p.asApiObject()}};f=Ve([We(4,R.ILogService)],f),e.ExtHostNotebookKernels=f;var b;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(b||(b={}));class s extends D.Disposable{get state(){return this.f}constructor(r,l,n){super(),this.j=l,this.k=n,this.b=s.a++,this.c=new A.Emitter,this.onDidChangeState=this.c.event,this.f=b.Init,this.g=this.B(new k.CancellationTokenSource),this.h=new o(10,i=>this.m(i)),this.i=l.internalMetadata.executionOrder,this.k.$createExecution(this.b,r,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(r){await this.h.addItem(r)}async m(r){const l=Array.isArray(r)?r:[r];return this.k.$updateExecution(this.b,new m.SerializableObjectWithBuffers(l))}n(){if(this.f===b.Init)throw new Error("Must call start before modifying cell output");if(this.f===b.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(r){let l=this.j;if(r&&(l=this.j.notebook.getCellFromApiCell(r)),!l)throw new Error("INVALID cell");return l.handle}s(r){return r.map(l=>{const n=d.NotebookCellOutput.ensureUniqueMimeTypes(l.items,!0);return n===l.items?v.NotebookCellOutput.from(l):v.NotebookCellOutput.from({items:n,id:l.id,metadata:l.metadata})})}async t(r,l,n){const i=this.r(l),p=this.s((0,a.asArray)(r));return this.l({editType:h.CellExecutionUpdateType.Output,cellHandle:i,append:n,outputs:p})}async w(r,l,n){return r=d.NotebookCellOutput.ensureUniqueMimeTypes((0,a.asArray)(r),!0),this.l({editType:h.CellExecutionUpdateType.OutputItems,items:r.map(v.NotebookCellOutputItem.from),outputId:l.id,append:n})}asApiObject(){const r=this;return Object.freeze({get token(){return r.g.token},get cell(){return r.j.apiCell},get executionOrder(){return r.i},set executionOrder(n){r.i=n,r.m([{editType:h.CellExecutionUpdateType.ExecutionState,executionOrder:r.i}])},start(n){if(r.f===b.Resolved||r.f===b.Started)throw new Error("Cannot call start again");r.f=b.Started,r.c.fire(),r.m({editType:h.CellExecutionUpdateType.ExecutionState,runStartTime:n})},end(n,i){if(r.f===b.Resolved)throw new Error("Cannot call resolve twice");r.f=b.Resolved,r.c.fire(),r.h.flush(),r.k.$completeExecution(r.b,new m.SerializableObjectWithBuffers({runEndTime:i,lastRunSuccess:n}))},clearOutput(n){return r.n(),r.t([],n,!1)},appendOutput(n,i){return r.n(),r.t(n,i,!0)},replaceOutput(n,i){return r.n(),r.t(n,i,!1)},appendOutputItems(n,i){return r.n(),r.w(n,i,!0)},replaceOutputItems(n,i){return r.n(),r.w(n,i,!1)}})}}s.a=0;class o{constructor(r,l){this.d=r,this.e=l,this.a=[],this.b=Date.now()}addItem(r){return this.a.push(r),this.c||(this.c=new t.DeferredPromise,this.b=Date.now(),(0,t.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const r=this.c;this.c=void 0;const l=this.a;return this.a=[],this.e(l).finally(()=>r.complete())}}function c(u,r){return`${u.value}/${r}`}e.createKernelId=c}),define(Se[261],ye([1,0,4,5,135]),function(te,e,a,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(T,S){this.c=S,this.a=new Map,this.b=T.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(T,S,C){const R=this.c.getEditorById(T);this.a.get(S)?.fire({editor:R.apiEditor,message:C})}createRendererMessaging(T,S){if(!T.contributes?.notebookRenderer?.some(R=>R.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(R,P,E)=>this.d(S).event(R,P,E),postMessage:(R,P)=>{k.ExtHostNotebookEditor.apiEditorsToExtHost.has(R)&&([R,P]=[P,R]);const E=P&&k.ExtHostNotebookEditor.apiEditorsToExtHost.get(P);return this.b.$postMessage(E?.id,S,R)}}}d(T){let S=this.a.get(T);return S||(S=new a.Emitter({onDidRemoveLastListener:()=>{S?.dispose(),this.a.delete(T)}}),this.a.set(T,S),S)}}e.ExtHostNotebookRenderers=A}),define(Se[262],ye([1,0,6,2,26,5]),function(te,e,a,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class D{constructor(S){this.b=new Map,this.a=S.getProxy(A.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(S,C,R){if((0,k.checkProposedApiEnabled)(S,"profileContentHandlers"),this.b.has(C))throw new Error(`Handler with id '${C}' already registered`);return this.b.set(C,R),this.a.$registerProfileContentHandler(C,R.name,S.identifier.value),(0,a.toDisposable)(()=>{this.b.delete(C),this.a.$unregisterProfileContentHandler(C)})}async $saveProfile(S,C,R,P){const E=this.b.get(S);if(!E)throw new Error(`Unknown handler with id: ${S}`);return E.saveProfile(C,R,P)}async $readProfile(S,C,R){const P=this.b.get(S);if(!P)throw new Error(`Unknown handler with id: ${S}`);return P.readProfile(t.URI.revive(C),R)}}e.ExtHostProfileContentHandlers=D}),define(Se[263],ye([1,0,21,4,6,5,2,7,10,17,42,89]),function(te,e,a,t,k,A,D,T,S,C,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function E(y,v,d){const g=y.getProxy(A.MainContext.MainThreadQuickOpen);class h{constructor(r,l){this.e=new Map,this.f=0,this.a=r,this.b=l}showQuickPick(r,l,n=a.CancellationToken.None){this.c=void 0;const i=Promise.resolve(r),p=++this.f,I=g.$show(p,{title:l?.title,placeHolder:l?.placeHolder,matchOnDescription:l?.matchOnDescription,matchOnDetail:l?.matchOnDetail,ignoreFocusLost:l?.ignoreFocusOut,canPickMany:l?.canPickMany},n),L={},U=I.then(()=>L);return Promise.race([U,i]).then(G=>{if(G!==L)return i.then(V=>{const O=[];for(let B=0;B<V.length;B++){const F=V[B];typeof F=="string"?O.push({label:F,handle:B}):F.kind===T.QuickPickItemKind.Separator?O.push({type:"separator",label:F.label}):O.push({label:F.label,description:F.description,detail:F.detail,picked:F.picked,alwaysShow:F.alwaysShow,handle:B})}return l&&typeof l.onDidSelectItem=="function"&&(this.c=B=>{l.onDidSelectItem(V[B])}),g.$setItems(p,O),I.then(B=>{if(typeof B=="number")return V[B];if(Array.isArray(B))return B.map(F=>V[F])})})}).then(void 0,G=>{if(!(0,S.isCancellationError)(G))return g.$setError(p,G),Promise.reject(G)})}$onItemSelected(r){this.c?.(r)}showInput(r,l=a.CancellationToken.None){return this.d=r?.validateInput,g.$input(r,typeof this.d=="function",l).then(void 0,n=>{if(!(0,S.isCancellationError)(n))return Promise.reject(n)})}async $validateInput(r){if(!this.d)return;const l=await this.d(r);if(!l||typeof l=="string")return l;let n;switch(l.severity){case T.InputBoxValidationSeverity.Info:n=R.default.Info;break;case T.InputBoxValidationSeverity.Warning:n=R.default.Warning;break;case T.InputBoxValidationSeverity.Error:n=R.default.Error;break;default:n=l.message?R.default.Error:R.default.Ignore;break}return{content:l.message,severity:n}}async showWorkspaceFolderPick(r,l=a.CancellationToken.None){const n=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!n)return;const i=await this.a.getWorkspaceFolders2();if(!!i)return i.find(p=>p.uri.toString()===n.uri.toString())}createQuickPick(r){const l=new o(r,()=>this.e.delete(l._id));return this.e.set(l._id,l),l}createInputBox(r){const l=new c(r,()=>this.e.delete(l._id));return this.e.set(l._id,l),l}$onDidChangeValue(r,l){this.e.get(r)?._fireDidChangeValue(l)}$onDidAccept(r){this.e.get(r)?._fireDidAccept()}$onDidChangeActive(r,l){const n=this.e.get(r);n instanceof o&&n._fireDidChangeActive(l)}$onDidChangeSelection(r,l){const n=this.e.get(r);n instanceof o&&n._fireDidChangeSelection(l)}$onDidTriggerButton(r,l){this.e.get(r)?._fireDidTriggerButton(l)}$onDidTriggerItemButton(r,l,n){const i=this.e.get(r);i instanceof o&&i._fireDidTriggerItemButton(l,n)}$onDidHide(r){this.e.get(r)?._fireDidHide()}}class w{constructor(r,l){this.x=r,this.y=l,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new t.Emitter,this.q=new t.Emitter,this.r=new t.Emitter,this.s=new t.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(r){this.b=r,this.A({title:r})}get step(){return this.c}set step(r){this.c=r,this.A({step:r})}get totalSteps(){return this.d}set totalSteps(r){this.d=r,this.A({totalSteps:r})}get enabled(){return this.g}set enabled(r){this.g=r,this.A({enabled:r})}get busy(){return this.j}set busy(r){this.j=r,this.A({busy:r})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(r){this.k=r,this.A({ignoreFocusOut:r})}get value(){return this.l}set value(r){this.l=r,this.A({value:r})}get placeholder(){return this.m}set placeholder(r){this.m=r,this.A({placeholder:r})}get buttons(){return this.n}set buttons(r){this.n=r.slice(),this.o.clear(),r.forEach((l,n)=>{const i=l===T.QuickInputButtons.Back?-1:n;this.o.set(i,l)}),this.A({buttons:r.map((l,n)=>({...s(l),tooltip:l.tooltip,handle:l===T.QuickInputButtons.Back?-1:n}))})}show(){this.e=!0,this.f=!0,this.A({visible:!0})}hide(){this.e=!1,this.A({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(r){this.l=r,this.q.fire(r)}_fireDidTriggerButton(r){const l=this.o.get(r);l&&this.r.fire(l)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,k.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),g.$dispose(this._id))}A(r){if(!this.v){for(const l of Object.keys(r)){const n=r[l];this.u[l]=n===void 0?null:n}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.B()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.B()},0))}}B(){g.$createOrUpdate(this.u),this.u={id:this._id}}}w.a=1;function m(u){if(u instanceof T.ThemeIcon)return{id:u.id};const r=b(u),l=f(u);return{dark:typeof r=="string"?D.URI.file(r):r,light:typeof l=="string"?D.URI.file(l):l}}function f(u){return typeof u=="object"&&"light"in u?u.light:u}function b(u){return typeof u=="object"&&"dark"in u?u.dark:u}function s(u){const r=m(u.iconPath);let l,n;return"id"in r?n=P.ThemeIcon.asClassName(r):l=r,{iconPath:l,iconClass:n}}class o extends w{constructor(r,l){super(r.identifier,l),this.C=[],this.D=new Map,this.E=new Map,this.F=!1,this.G=!0,this.H=!0,this.I=!0,this.J=!1,this.K=[],this.L=new t.Emitter,this.M=[],this.N=new t.Emitter,this.O=new t.Emitter,this.onDidChangeActive=this.L.event,this.onDidChangeSelection=this.N.event,this.onDidTriggerItemButton=this.O.event,this.w.push(this.L,this.N,this.O),this.A({type:"quickPick"})}get items(){return this.C}set items(r){this.C=r.slice(),this.D.clear(),this.E.clear(),r.forEach((n,i)=>{this.D.set(i,n),this.E.set(n,i)});const l=[];for(let n=0;n<r.length;n++){const i=r[n];i.kind===T.QuickPickItemKind.Separator?l.push({type:"separator",label:i.label}):l.push({handle:n,label:i.label,description:i.description,detail:i.detail,picked:i.picked,alwaysShow:i.alwaysShow,buttons:i.buttons?.map((p,I)=>({...s(p),tooltip:p.tooltip,handle:I}))})}this.A({items:l})}get canSelectMany(){return this.F}set canSelectMany(r){this.F=r,this.A({canSelectMany:r})}get matchOnDescription(){return this.G}set matchOnDescription(r){this.G=r,this.A({matchOnDescription:r})}get matchOnDetail(){return this.H}set matchOnDetail(r){this.H=r,this.A({matchOnDetail:r})}get sortByLabel(){return this.I}set sortByLabel(r){this.I=r,this.A({sortByLabel:r})}get keepScrollPosition(){return this.J}set keepScrollPosition(r){this.J=r,this.A({keepScrollPosition:r})}get activeItems(){return this.K}set activeItems(r){this.K=r.filter(l=>this.E.has(l)),this.A({activeItems:this.K.map(l=>this.E.get(l))})}get selectedItems(){return this.M}set selectedItems(r){this.M=r.filter(l=>this.E.has(l)),this.A({selectedItems:this.M.map(l=>this.E.get(l))})}_fireDidChangeActive(r){const l=(0,C.coalesce)(r.map(n=>this.D.get(n)));this.K=l,this.L.fire(l)}_fireDidChangeSelection(r){const l=(0,C.coalesce)(r.map(n=>this.D.get(n)));this.M=l,this.N.fire(l)}_fireDidTriggerItemButton(r,l){const n=this.D.get(r);if(!n||!n.buttons||!n.buttons.length)return;const i=n.buttons[l];i&&this.O.fire({button:i,item:n})}}class c extends w{constructor(r,l){super(r.identifier,l),this.C=!1,this.A({type:"inputBox"})}get password(){return this.C}set password(r){this.C=r,this.A({password:r})}get prompt(){return this.D}set prompt(r){this.D=r,this.A({prompt:r})}get valueSelection(){return this.E}set valueSelection(r){this.E=r,this.A({valueSelection:r})}get validationMessage(){return this.F}set validationMessage(r){this.F=r,r?typeof r=="string"?this.A({validationMessage:r,severity:R.default.Error}):this.A({validationMessage:r.message,severity:r.severity??R.default.Error}):this.A({validationMessage:void 0,severity:R.default.Ignore})}}return new h(v,d)}e.createExtHostQuickOpen=E});var Fe=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,a,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,a):k?k.value=a:e.set(te,a),a};define(Se[264],ye([1,0,2,4,60,6,18,5,17,108,13,27,89,14,26]),function(te,e,a,t,k,A,D,T,S,C,R,P,E,y,v){"use strict";var d,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function h(i){if(i)return typeof i.iconPath=="string"?a.URI.file(i.iconPath):a.URI.isUri(i.iconPath)||E.ThemeIcon.isThemeIcon(i.iconPath)?i.iconPath:void 0}function w(i,p){if(!i.iconPath&&!p.iconPath)return 0;if(i.iconPath){if(!p.iconPath)return 1}else return-1;const I=typeof i.iconPath=="string"?i.iconPath:a.URI.isUri(i.iconPath)?i.iconPath.fsPath:i.iconPath.id,L=typeof p.iconPath=="string"?p.iconPath:a.URI.isUri(p.iconPath)?p.iconPath.fsPath:p.iconPath.id;return(0,C.comparePaths)(I,L)}function m(i,p){let I=0;if(i.strikeThrough!==p.strikeThrough)return i.strikeThrough?1:-1;if(i.faded!==p.faded)return i.faded?1:-1;if(i.tooltip!==p.tooltip)return(i.tooltip||"").localeCompare(p.tooltip||"");if(I=w(i,p),I!==0)return I;if(i.light&&p.light)I=w(i.light,p.light);else{if(i.light)return 1;if(p.light)return-1}if(I!==0)return I;if(i.dark&&p.dark)I=w(i.dark,p.dark);else{if(i.dark)return 1;if(p.dark)return-1}return I}function f(i,p){if(i.command!==p.command)return i.command<p.command?-1:1;if(i.title!==p.title)return i.title<p.title?-1:1;if(i.tooltip!==p.tooltip){if(i.tooltip!==void 0&&p.tooltip!==void 0)return i.tooltip<p.tooltip?-1:1;if(i.tooltip!==void 0)return 1;if(p.tooltip!==void 0)return-1}if(i.arguments===p.arguments)return 0;if(i.arguments)if(p.arguments){if(i.arguments.length!==p.arguments.length)return i.arguments.length-p.arguments.length}else return 1;else return-1;for(let I=0;I<i.arguments.length;I++){const L=i.arguments[I],U=p.arguments[I];if(L!==U)return L<U?-1:1}return 0}function b(i,p){let I=(0,C.comparePaths)(i.resourceUri.fsPath,p.resourceUri.fsPath,!0);if(I!==0)return I;if(i.command&&p.command)I=f(i.command,p.command);else{if(i.command)return 1;if(p.command)return-1}if(I!==0)return I;if(i.decorations&&p.decorations)I=m(i.decorations,p.decorations);else{if(i.decorations)return 1;if(p.decorations)return-1}return I}function s(i,p){for(let I=0;I<i.length;I++)if(i[I]!==p[I])return!1;return!0}function o(i,p){return i.command===p.command&&i.title===p.title&&i.tooltip===p.tooltip&&(i.arguments&&p.arguments?s(i.arguments,p.arguments):i.arguments===p.arguments)}function c(i,p){return(0,S.equals)(i,p,o)}class u{get value(){return this.d}set value(p){p=p??"",Fe(this,d,"f").$setInputBoxValue(this.l,p),this.m(p)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(p){Fe(this,d,"f").$setInputBoxPlaceholder(this.l,p),this.f=p}get validateInput(){return(0,v.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(p){if((0,v.checkProposedApiEnabled)(this.k,"scmValidation"),p&&typeof p!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=p,Fe(this,d,"f").$setValidationProviderIsEnabled(this.l,!!p)}get enabled(){return this.h}set enabled(p){p=!!p,this.h!==p&&(this.h=p,Fe(this,d,"f").$setInputBoxEnablement(this.l,p))}get visible(){return this.j}set visible(p){p=!!p,this.j!==p&&(this.j=p,Fe(this,d,"f").$setInputBoxVisibility(this.l,p))}constructor(p,I,L){this.k=p,this.l=L,d.set(this,void 0),this.d="",this.e=new t.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,d,I,"f")}showValidationMessage(p,I){(0,v.checkProposedApiEnabled)(this.k,"scmValidation"),Fe(this,d,"f").$showValidationMessage(this.l,p,I)}$onInputBoxValueChange(p){this.m(p)}m(p){this.d=p,this.e.fire(p)}}e.ExtHostSCMInputBox=u,d=new WeakMap;class r{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(p){this.v=p,this.q.$updateGroupLabel(this.t,this.handle,p)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(p){this.p=p,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(p){this.f=[...p],this.k.fire()}constructor(p,I,L,U,G){this.q=p,this.s=I,this.t=L,this.u=U,this.v=G,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new t.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new t.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=r.d++}getResourceState(p){return this.g.get(p)}$executeResourceCommand(p,I){const L=this.h.get(p);return L?(0,D.asPromise)(()=>this.s.executeCommand(L.command,...L.arguments||[],I)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const p=[...this.f].sort(b),L=(0,S.sortedDiff)(this.o,p,b).map(V=>{const O=V.toInsert.map(B=>{const F=this.e++;this.g.set(F,B);const $=B.resourceUri;let M;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const pe=new A.DisposableStore;M=this.s.converter.toInternal(B.command,pe),this.j.set(F,pe)}else this.h.set(F,B.command);const H=h(B.decorations),K=B.decorations&&h(B.decorations.light)||H,q=B.decorations&&h(B.decorations.dark)||H,Y=[K,q],Q=B.decorations&&B.decorations.tooltip||"",ce=B.decorations&&!!B.decorations.strikeThrough,ie=B.decorations&&!!B.decorations.faded,de=B.contextValue||"";return{rawResource:[F,$,Y,Q,ce,ie,de,M],handle:F}});return{start:V.start,deleteCount:V.deleteCount,toInsert:O}}),U=L.map(({start:V,deleteCount:O,toInsert:B})=>[V,O,B.map(F=>F.rawResource)]),G=L.reverse();for(const{start:V,deleteCount:O,toInsert:B}of G){const F=B.map(M=>M.handle),$=this.n.splice(V,O,...F);for(const M of $)this.g.delete(M),this.h.delete(M),this.j.get(M)?.dispose(),this.j.delete(M)}return this.o=p,U}dispose(){this.l=!0,this.m.fire()}}r.d=0;class l{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(p){this.g!==p&&(this.g=p,Fe(this,g,"f").$updateSourceControl(this.t,{count:p}))}get quickDiffProvider(){return this.h}set quickDiffProvider(p){this.h=p,Fe(this,g,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!p})}get commitTemplate(){return this.j}set commitTemplate(p){p!==this.j&&(this.j=p,Fe(this,g,"f").$updateSourceControl(this.t,{commitTemplate:p}))}get acceptInputCommand(){return this.l}set acceptInputCommand(p){this.k.value=new A.DisposableStore,this.l=p;const I=this.v.converter.toInternal(p,this.k.value);Fe(this,g,"f").$updateSourceControl(this.t,{acceptInputCommand:I})}get actionButton(){return(0,v.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(p){(0,v.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new A.DisposableStore,this.n=p;const I=p!==void 0?{command:this.v.converter.toInternal(p.command,this.m.value),secondaryCommands:p.secondaryCommands?.map(L=>L.map(U=>this.v.converter.toInternal(U,this.m.value))),description:p.description,enabled:p.enabled}:void 0;Fe(this,g,"f").$updateSourceControl(this.t,{actionButton:I??null})}get statusBarCommands(){return this.p}set statusBarCommands(p){if(this.p&&p&&c(this.p,p))return;this.o.value=new A.DisposableStore,this.p=p;const I=(p||[]).map(L=>this.v.converter.toInternal(L,this.o.value));Fe(this,g,"f").$updateSourceControl(this.t,{statusBarCommands:I})}get selected(){return this.q}constructor(p,I,L,U,G,V){this.u=p,this.v=L,this.w=U,this.x=G,this.y=V,g.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new A.MutableDisposable,this.l=void 0,this.m=new A.MutableDisposable,this.o=new A.MutableDisposable,this.p=void 0,this.q=!1,this.s=new t.Emitter,this.onDidChangeSelection=this.s.event,this.t=l.d++,this.A=new Map,this.B=new Set,Je(this,g,I,"f"),this.f=new u(p,Fe(this,g,"f"),this.t),Fe(this,g,"f").$registerSourceControl(this.t,U,G,V)}createResourceGroup(p,I){const L=new r(Fe(this,g,"f"),this.v,this.t,p,I),U=t.Event.once(L.onDidDispose)(()=>this.A.delete(L));return this.A.set(L,U),this.eventuallyAddResourceGroups(),L}eventuallyAddResourceGroups(){const p=[],I=[];for(const[L,U]of this.A){U.dispose();const G=L.onDidUpdateResourceStates(()=>{this.B.add(L),this.eventuallyUpdateResourceStates()});t.Event.once(L.onDidDispose)(()=>{this.B.delete(L),G.dispose(),this.e.delete(L.handle),Fe(this,g,"f").$unregisterGroup(this.t,L.handle)}),p.push([L.handle,L.id,L.label,L.features]);const V=L._takeResourceStateSnapshot();V.length>0&&I.push([L.handle,V]),this.e.set(L.handle,L)}Fe(this,g,"f").$registerGroups(this.t,p,I),this.A.clear()}eventuallyUpdateResourceStates(){const p=[];this.B.forEach(I=>{const L=I._takeResourceStateSnapshot();L.length!==0&&p.push([I.handle,L])}),p.length>0&&Fe(this,g,"f").$spliceResourceStates(this.t,p),this.B.clear()}getResourceGroup(p){return this.e.get(p)}setSelectionState(p){this.q=p,this.s.fire(p)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(p=>p.dispose()),Fe(this,g,"f").$unregisterSourceControl(this.t)}}g=new WeakMap,l.d=0,Ve([(0,k.debounce)(100)],l.prototype,"eventuallyAddResourceGroups",null),Ve([(0,k.debounce)(100)],l.prototype,"eventuallyUpdateResourceStates",null);let n=class ni{get onDidChangeActiveProvider(){return this.j.event}constructor(p,I,L){this.l=I,this.m=L,this.g=new Map,this.h=new Map,this.j=new t.Emitter,this.e=p.getProxy(T.MainContext.MainThreadSCM),this.f=p.getProxy(T.MainContext.MainThreadTelemetry),I.registerArgumentProcessor({processArgument:U=>{if(U&&U.$mid===3){const G=this.g.get(U.sourceControlHandle);if(!G)return U;const V=G.getResourceGroup(U.groupHandle);return V?V.getResourceState(U.handle):U}else if(U&&U.$mid===4){const G=this.g.get(U.sourceControlHandle);return G?G.getResourceGroup(U.groupHandle):U}else if(U&&U.$mid===5){const G=this.g.get(U.handle);return G||U}return U}})}createSourceControl(p,I,L,U){this.m.trace("ExtHostSCM#createSourceControl",p.identifier.value,I,L,U),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:p.identifier.value});const G=ni.d++,V=new l(p,this.e,this.l,I,L,U);this.g.set(G,V);const O=this.h.get(P.ExtensionIdentifier.toKey(p.identifier))||[];return O.push(V),this.h.set(P.ExtensionIdentifier.toKey(p.identifier),O),V}getLastInputBox(p){this.m.trace("ExtHostSCM#getLastInputBox",p.identifier.value);const I=this.h.get(P.ExtensionIdentifier.toKey(p.identifier)),L=I&&I[I.length-1];return L&&L.inputBox}$provideOriginalResource(p,I,L){const U=a.URI.revive(I);this.m.trace("ExtHostSCM#$provideOriginalResource",p,U.toString());const G=this.g.get(p);return!G||!G.quickDiffProvider||!G.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,D.asPromise)(()=>G.quickDiffProvider.provideOriginalResource(U,L)).then(V=>V||null)}$onInputBoxValueChange(p,I){this.m.trace("ExtHostSCM#$onInputBoxValueChange",p);const L=this.g.get(p);return L&&L.inputBox.$onInputBoxValueChange(I),Promise.resolve(void 0)}$executeResourceCommand(p,I,L,U){this.m.trace("ExtHostSCM#$executeResourceCommand",p,I,L);const G=this.g.get(p);if(!G)return Promise.resolve(void 0);const V=G.getResourceGroup(I);return V?V.$executeResourceCommand(L,U):Promise.resolve(void 0)}$validateInput(p,I,L){this.m.trace("ExtHostSCM#$validateInput",p);const U=this.g.get(p);return!U||!U.inputBox.validateInput?Promise.resolve(void 0):(0,D.asPromise)(()=>U.inputBox.validateInput(I,L)).then(G=>{if(!G)return Promise.resolve(void 0);const V=y.MarkdownString.fromStrict(G.message);return V?Promise.resolve([V,G.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(p){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",p),p!==void 0&&this.g.get(p)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=p,Promise.resolve(void 0)}};n.d=0,n=Ve([We(2,R.ILogService)],n),e.ExtHostSCM=n}),define(Se[96],ye([1,0,5,4,3]),function(te,e,a,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(T){this.b=new t.Emitter,this.onDidChangePassword=this.b.event,this.a=T.getProxy(a.MainContext.MainThreadSecretState)}async $onDidChangePassword(T){this.b.fire(T)}get(T,S){return this.a.$getPassword(T,S)}store(T,S,C){return this.a.$setPassword(T,S,C)}delete(T,S){return this.a.$deletePassword(T,S)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,k.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(te,e,a,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,a):k?k.value=a:e.set(te,a),a},Fe=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)};define(Se[265],ye([1,0,7,5,176,6,14,11]),function(te,e,a,t,k,A,D,T){"use strict";var S,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(v,d,g,h,w=a.StatusBarAlignment.Left,m){S.set(this,void 0),C.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.p=new A.DisposableStore,Je(this,S,v,"f"),Je(this,C,d,"f"),this.c=R.a++,this.e=g,this.f=h,this.g=w,this.h=this.t(m)}t(v){if(!!(0,T.isNumber)(v))return v===Number.POSITIVE_INFINITY?Number.MAX_VALUE:v===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:v}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.q?.fromApi}get accessibilityInformation(){return this.s}set text(v){this.k=v,this.u()}set name(v){this.m=v,this.u()}set tooltip(v){this.l=v,this.u()}set color(v){this.n=v,this.u()}set backgroundColor(v){v&&!R.b.has(v.id)&&(v=void 0),this.o=v,this.u()}set command(v){this.q?.fromApi!==v&&(this.p.clear(),typeof v=="string"?this.q={fromApi:v,internal:Fe(this,C,"f").toInternal({title:"",command:v},this.p)}:v?this.q={fromApi:v,internal:Fe(this,C,"f").toInternal(v,this.p)}:this.q=void 0,this.u())}set accessibilityInformation(v){this.s=v,this.u()}show(){this.j=!0,this.u()}hide(){clearTimeout(this.r),this.j=!1,Fe(this,S,"f").$dispose(this.c)}u(){this.i||!this.j||(clearTimeout(this.r),this.r=setTimeout(()=>{this.r=void 0;let v;this.e?this.f?v=`${this.e.identifier.value}.${this.f}`:v=this.e.identifier.value:v=this.f;let d;this.m?d=this.m:d=(0,k.localize)(0,null,this.e.displayName||this.e.name);let g=this.n;this.o&&(g=R.b.get(this.o.id));const h=D.MarkdownString.fromStrict(this.l);Fe(this,S,"f").$setEntry(this.c,v,d,this.k,h,this.q?.internal,g,this.o,this.g===a.StatusBarAlignment.Left,this.h,this.s)},0))}dispose(){this.hide(),this.i=!0}}e.ExtHostStatusBarEntry=R,S=new WeakMap,C=new WeakMap,R.a=0,R.b=new Map([["statusBarItem.errorBackground",new a.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new a.ThemeColor("statusBarItem.warningForeground")]]);class P{constructor(v){this.b=[],this.a=v.createStatusBarEntry(void 0,"status.extensionMessage",a.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,k.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(v){const d={message:v};return this.b.unshift(d),this.c(),new a.Disposable(()=>{const g=this.b.indexOf(d);g>=0&&(this.b.splice(g,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class E{constructor(v,d){this.a=v.getProxy(t.MainContext.MainThreadStatusBar),this.b=d,this.c=new P(this)}createStatusBarEntry(v,d,g,h){return new R(this.a,this.b,v,d,g,h)}setStatusBarMessage(v,d){const g=this.c.setMessage(v);let h;return typeof d=="number"?h=setTimeout(()=>g.dispose(),d):typeof d<"u"&&d.then(()=>g.dispose(),()=>g.dispose()),new a.Disposable(()=>{g.dispose(),clearTimeout(h)})}}e.ExtHostStatusBar=E}),define(Se[97],ye([1,0,5,4,3]),function(te,e,a,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(T,S){this.c=S,this.b=new t.Emitter,this.onDidChangeStorage=this.b.event,this.a=T.getProxy(a.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(T,S){this.a.$registerExtensionStorageKeysToSync(T,S)}async initializeExtensionStorage(T,S,C){const R=await this.a.$initializeExtensionStorage(T,S);let P;return R&&(P=this.d(T,S,R)),P||C}setValue(T,S,C){return this.a.$setValue(T,S,C)}$acceptValue(T,S,C){const R=this.d(T,S,C);R&&this.b.fire({shared:T,key:S,value:R})}d(T,S,C){try{return JSON.parse(C)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${T}): ${R}`)}}}e.ExtHostStorage=A,e.IExtHostStorage=(0,k.createDecorator)("IExtHostStorage")}),define(Se[71],ye([1,0,3,25,13,70,2]),function(te,e,a,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,a.createDecorator)("IExtensionStoragePaths");let T=class{constructor(C,R,P){this.d=R,this.f=P,this.a=C.workspace??void 0,this.b=C.environment,this.whenReady=this.h().then(E=>this.c=E)}async g(C){return D.URI.joinPath(this.b.workspaceStorageHome,C)}async h(){if(!this.a)return Promise.resolve(void 0);const C=this.a.id,R=await this.g(C);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(D.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:D.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(P){this.d.error("[ExtHostStorage]",P);return}}workspaceValue(C){if(this.c)return D.URI.joinPath(this.c,C.identifier.value)}globalValue(C){return D.URI.joinPath(this.b.globalStorageHome,C.identifier.value.toLowerCase())}onWillDeactivateAll(){}};T=Ve([We(0,t.IExtHostInitDataService),We(1,k.ILogService),We(2,A.IExtHostConsumerFileSystem)],T),e.ExtensionStoragePaths=T}),define(Se[40],ye([1,0,4,5,3,2,16,6,7,177,10,222,21,30,207,89,11,18,14]),function(te,e,a,t,k,A,D,T,S,C,R,P,E,y,v,d,g,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,k.createDecorator)("IExtHostTerminalService");class m{constructor(n,i,p,I){this.k=n,this._id=i,this.l=p,this.m=I,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(U=>this.f=U);const L=this;this.value={get name(){return L.m||""},get processId(){return L.b},get creationOptions(){return L.l},get exitStatus(){return L.h},get state(){return L.j},sendText(U,G=!0){L.o(),L.k.$sendText(L._id,U,G)},show(U){L.o(),L.k.$show(L._id,U)},hide(){L.o(),L.k.$hide(L._id)},dispose(){L.a||(L.a=!0,L.k.$dispose(L._id))},get dimensions(){if(!(L.d===void 0||L.g===void 0))return{columns:L.d,rows:L.g}}}}async create(n,i){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:n.name,shellPath:(0,g.withNullAsUndefined)(n.shellPath),shellArgs:(0,g.withNullAsUndefined)(n.shellArgs),cwd:(0,g.withNullAsUndefined)(n.cwd),env:(0,g.withNullAsUndefined)(n.env),icon:(0,g.withNullAsUndefined)(u(n.iconPath)),color:d.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,g.withNullAsUndefined)(n.message),strictEnv:(0,g.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,g.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,g.withNullAsUndefined)(i?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,g.withNullAsUndefined)(i?.useShellEnvironment),location:i?.location||this.n(n.location,i?.resolvedExtHostIdentifier),isTransient:(0,g.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,i,p,I){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:p,color:d.ThemeColor.isThemeColor(I)?I.id:void 0,location:this.n(n,i),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(n,i){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&i?{parentTerminal:i}:"viewColumn"in n?{viewColumn:w.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus}:void 0:n}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(n){this.m=n}setExitStatus(n,i){this.h=Object.freeze({code:n,reason:i})}setDimensions(n,i){return n===this.d&&i===this.g||n===0||i===0?!1:(this.d=n,this.g=i,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(n){this.f?(this.f(n),this.f=void 0):this.b.then(i=>{i!==n&&(this.b=Promise.resolve(n))})}}e.ExtHostTerminal=m;class f{get onProcessReady(){return this.b.event}constructor(n){this.g=n,this.id=0,this.shouldPersist=!1,this.a=new a.Emitter,this.onProcessData=this.a.event,this.b=new a.Emitter,this.d=new a.Emitter,this.onDidChangeProperty=this.d.event,this.f=new a.Emitter,this.onProcessExit=this.f.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,i){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${i}`)}async start(){}shutdown(){this.g.close()}input(n){this.g.handleInput?.(n)}resize(n,i){this.g.setDimensions?.({columns:n,rows:i})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this.g.onDidWrite(i=>this.a.fire(i)),this.g.onDidClose?.((i=void 0)=>{this.f.fire(i===void 0?void 0:i)}),this.g.onDidOverrideDimensions?.(i=>{i&&this.d.fire({type:"overrideDimensions",value:{cols:i.columns,rows:i.rows}})}),this.g.onDidChangeName?.(i=>{this.d.fire({type:"title",value:i})}),this.g.open(n||void 0),n&&this.g.setDimensions?.(n),this.b.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=f;let b=1,s=class extends T.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(n=>n.value)}get onDidWriteTerminalData(){return this.I.event}constructor(n,i){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.C=new a.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new a.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new a.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new a.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new a.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new a.Emitter,this.onDidChangeShell=this.J.event,this.a=i.getProxy(t.MainContext.MainThreadTerminalService),this.s=new v.TerminalDataBufferer(this.a.$sendProcessData),this.I=new a.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(n),this.B({dispose:()=>{for(const[p,I]of this.g)I.shutdown(!0)}})}getDefaultShell(n){return(n?this.n:this.m)?.path||""}getDefaultShellArgs(n){return(n?this.n:this.m)?.args||[]}createExtensionTerminal(n,i){const p=new m(this.a,(0,y.generateUuid)(),n,n.name),I=new f(n.pty);return p.createExtensionTerminal(n.location,this.L(n,i).resolvedExtHostIdentifier,u(n.iconPath),r(n.color)).then(L=>{const U=this.M(L,I);this.h[L]=U}),this.f.push(p),p.value}L(n,i){if(i=i||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const p=n.location.parentTerminal;if(p){const I=this.f.find(L=>L.value===p);I&&(i.resolvedExtHostIdentifier=I._id)}}else n.location&&typeof n.location!="object"?i.location=n.location:i.location&&typeof i.location=="object"&&"splitActiveTerminal"in i.location&&(i.location={splitActiveTerminal:!0});return i}attachPtyToTerminal(n,i){if(!this.O(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const I=new f(i),L=this.M(n,I);this.h[n]=L}async $acceptActiveTerminalChanged(n){const i=this.b;if(n===null){this.b=void 0,i!==this.b&&this.F.fire(this.b);return}const p=this.O(n);p&&(this.b=p,i!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(n,i){const p=this.O(n);p&&this.I.fire({terminal:p.value,data:i})}async $acceptTerminalDimensions(n,i,p){const I=this.O(n);I&&I.setDimensions(i,p)&&this.G.fire({terminal:I.value,dimensions:I.value.dimensions})}async $acceptTerminalMaximumDimensions(n,i,p){this.g.get(n)?.resize(i,p)}async $acceptTerminalTitleChange(n,i){const p=this.O(n);p&&(p.name=i)}async $acceptTerminalClosed(n,i,p){const I=this.Q(this.f,n);if(I!==null){const L=this.f.splice(I,1)[0];L.setExitStatus(i,p),this.C.fire(L.value)}}$acceptTerminalOpened(n,i,p,I){if(i){const G=this.Q(this.f,i);if(G!==null){this.f[G]._id=n,this.D.fire(this.terminals[G]),this.f[G].isOpen=!0;return}}const L={name:I.name,shellPath:I.executable,shellArgs:I.args,cwd:typeof I.cwd=="string"?I.cwd:A.URI.revive(I.cwd),env:I.env,hideFromUser:I.hideFromUser},U=new m(this.a,n,L,p);this.f.push(U),this.D.fire(U.value),U.isOpen=!0}async $acceptTerminalProcessId(n,i){this.O(n)?._setProcessId(i)}async $startExtensionTerminal(n,i){const p=this.O(n);if(!p)return{message:(0,C.localize)(0,null,n)};p.isOpen||await new Promise(L=>{const U=this.onDidOpenTerminal(async G=>{G===p.value&&(U.dispose(),L())})});const I=this.g.get(n);I?I.startSendingEvents(i):this.j[n]={initialDimensions:i}}M(n,i){const p=new T.DisposableStore;p.add(i.onProcessReady(L=>this.a.$sendProcessReady(n,L.pid,L.cwd))),p.add(i.onDidChangeProperty(L=>this.a.$sendProcessProperty(n,L))),this.s.startBuffering(n,i.onProcessData),p.add(i.onProcessExit(L=>this.N(n,L))),this.g.set(n,i);const I=this.j[n];return I&&i instanceof f&&(i.startSendingEvents(I.initialDimensions),delete this.j[n]),p}$acceptProcessAckDataEvent(n,i){this.g.get(n)?.acknowledgeDataEvent(i)}$acceptProcessInput(n,i){this.g.get(n)?.input(i)}$acceptTerminalInteraction(n){const i=this.O(n);i?.setInteractedWith()&&this.H.fire(i.value)}$acceptProcessResize(n,i,p){try{this.g.get(n)?.resize(i,p)}catch(I){if(I.code!=="EPIPE"&&I.code!=="ERR_IPC_CHANNEL_CLOSED")throw I}}$acceptProcessShutdown(n,i){this.g.get(n)?.shutdown(i)}$acceptProcessRequestInitialCwd(n){this.g.get(n)?.getInitialCwd().then(i=>this.a.$sendProcessProperty(n,{type:"initialCwd",value:i}))}$acceptProcessRequestCwd(n){this.g.get(n)?.getCwd().then(i=>this.a.$sendProcessProperty(n,{type:"cwd",value:i}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this.u.add(n),this.u.size===1&&this.a.$startLinkProvider(),new S.Disposable(()=>{this.u.delete(n),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(n,i,p){if(this.v.has(i))throw new Error(`Terminal profile provider "${i}" already registered`);return this.v.set(i,p),this.a.$registerProfileProvider(i,n.identifier.value),new S.Disposable(()=>{this.v.delete(i),this.a.$unregisterProfileProvider(i)})}async $createContributedProfileTerminal(n,i){const p=new E.CancellationTokenSource().token;let I=await this.v.get(n)?.provideTerminalProfile(p);if(!p.isCancellationRequested){if(I&&!("options"in I)&&(I={options:I}),!I||!("options"in I))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in I.options){this.createExtensionTerminal(I.options,i);return}this.createTerminalFromOptions(I.options,i)}}async $provideLinks(n,i){const p=this.O(n);if(!p)return[];this.w.delete(n),this.y.get(n)?.dispose(!0);const L=new E.CancellationTokenSource;this.y.set(n,L);const U=[],G={terminal:p.value,line:i},V=[];for(const F of this.u)V.push(h.Promises.withAsyncBody(async $=>{L.token.onCancellationRequested(()=>$({provider:F,links:[]}));const M=await F.provideTerminalLinks(G,L.token)||[];L.token.isCancellationRequested||$({provider:F,links:M})}));const O=await Promise.all(V);if(L.token.isCancellationRequested)return[];const B=new Map;for(const F of O)F&&F.links.length>0&&U.push(...F.links.map($=>{const M={id:b++,startIndex:$.startIndex,length:$.length,label:$.tooltip};return B.set(M.id,{provider:F.provider,link:$}),M}));return this.w.set(n,B),U}$activateLink(n,i){const p=this.w.get(n)?.get(i);!p||p.provider.handleTerminalLink(p.link)}N(n,i){this.s.stopBuffering(n),this.g.delete(n),delete this.j[n];const p=this.h[n];p&&(p.dispose(),delete this.h[n]),this.a.$sendProcessExit(n,i)}O(n){return this.P(this.f,n)}P(n,i){const p=this.Q(n,i);return p!==null?n[p]:null}Q(n,i){let p=null;return n.some((I,L)=>I._id===i?(p=L,!0):!1),p}getEnvironmentVariableCollection(n){let i=this.l.get(n.identifier.value);return i||(i=new o,this.S(n.identifier.value,i)),i}R(n,i){const p=(0,P.serializeEnvironmentVariableCollection)(i.map);this.a.$setEnvironmentVariableCollection(n,i.persistent,p.length===0?void 0:p)}$initEnvironmentVariableCollections(n){n.forEach(i=>{const p=i[0],I=new o(i[1]);this.S(p,I)})}$acceptDefaultProfile(n,i){const p=this.m;this.m=n,this.n=i,p?.path!==n.path&&this.J.fire(n.path)}S(n,i){this.l.set(n,i),i.onDidChangeCollection(()=>{this.R(n,i)})}};s=Ve([We(1,D.IExtHostRpcService)],s),e.BaseExtHostTerminalService=s;class o{get persistent(){return this.a}set persistent(n){this.a=n,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(n){this.map=new Map,this.a=!0,this.b=new a.Emitter,this.map=new Map(n)}get size(){return this.map.size}replace(n,i){this.d(n,{value:i,type:S.EnvironmentVariableMutatorType.Replace})}append(n,i){this.d(n,{value:i,type:S.EnvironmentVariableMutatorType.Append})}prepend(n,i){this.d(n,{value:i,type:S.EnvironmentVariableMutatorType.Prepend})}d(n,i){const p=this.map.get(n);(!p||p.value!==i.value||p.type!==i.type)&&(this.map.set(n,i),this.b.fire())}get(n){return this.map.get(n)}forEach(n,i){this.map.forEach((p,I)=>n.call(i,I,p,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}e.EnvironmentVariableCollection=o;let c=class extends s{constructor(n){super(!1,n)}createTerminal(n,i,p){throw new R.NotSupportedError}createTerminalFromOptions(n,i){throw new R.NotSupportedError}};c=Ve([We(0,D.IExtHostRpcService)],c),e.WorkerExtHostTerminalService=c;function u(l){if(!(!l||typeof l=="string"))return"id"in l?{id:l.id,color:l.color}:l}function r(l){return d.ThemeColor.isThemeColor(l)?l:void 0}});var Fe=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,a,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,a):k?k.value=a:e.set(te,a),a};define(Se[266],ye([1,0,17,22,21,4,61,83,6,23,11,30,5,16,136,14,7,56,91,68]),function(te,e,a,t,k,A,D,T,S,C,R,P,E,y,v,d,g,h,w,m){"use strict";var f,b;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=class{constructor(G,V,O){this.j=O,this.c=new A.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=G.getProxy(E.MainContext.MainThreadTesting),this.h=new p(this.f),this.g=new c(this.f),V.registerArgumentProcessor({processArgument:B=>{if(B?.$mid!==15)return B;const F=B,$=F.tests[F.tests.length-1].item.extId;return this.d.get(h.TestId.root($))?.collection.tree.get($)?.actual??(0,v.toItemFromContext)(B)}})}createTestController(G,V,O){if(this.d.has(G))throw new Error(`Attempt to insert a duplicate controller with ID "${G}"`);const B=new S.DisposableStore,F=B.add(new v.ExtHostTestItemCollection(G,V,this.j));F.root.label=V;const $=new Map,M=this.f,H={items:F.root.children,get label(){return V},set label(q){V=q,F.root.label=q,M.$updateController(G,{label:V})},get refreshHandler(){return O},set refreshHandler(q){O=q,M.$updateController(G,{canRefresh:!!q})},get id(){return G},createRunProfile:(q,Y,Q,ce,ie)=>{let de=(0,T.hash)(q);for(;$.has(de);)de++;return new I(this.f,$,G,de,q,Y,Q,ce,ie)},createTestItem(q,Y,Q){return new v.TestItemImpl(G,q,Y,Q)},createTestRun:(q,Y,Q=!0)=>this.g.createTestRun(G,F,q,Y,Q),set resolveHandler(q){F.resolveHandler=q},get resolveHandler(){return F.resolveHandler},dispose:()=>{B.dispose()}};M.$registerTestController(G,V,!!O),B.add((0,S.toDisposable)(()=>M.$unregisterTestController(G)));const K={controller:H,collection:F,profiles:$};return this.d.set(G,K),B.add((0,S.toDisposable)(()=>this.d.delete(G))),B.add(F.onDidGenerateDiff(q=>M.$publishDiff(G,q.map(m.TestsDiffOp.serialize)))),H}createTestObserver(){return this.h.checkout()}async runTests(G,V=k.CancellationToken.None){const O=u(G);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const B=this.d.get(O.controllerId);if(!B)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:G.include?.map(F=>h.TestId.fromExtHostTestItem(F,B.collection.root.id).toString())??[B.collection.root.id],profileGroup:L[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:G.exclude?.map(F=>F.id)},V)}$syncTests(){for(const{collection:G}of this.d.values())G.flushDiff();return Promise.resolve()}$provideFileCoverage(G,V,O){return(0,a.mapFind)(this.g.trackers,F=>F.id===G?F.getCoverage(V):void 0)?.provideFileCoverage(O)??Promise.resolve([])}$resolveFileCoverage(G,V,O,B){return(0,a.mapFind)(this.g.trackers,$=>$.id===G?$.getCoverage(V):void 0)?.resolveFileCoverage(O,B)??Promise.resolve([])}$configureRunProfile(G,V){this.d.get(G)?.profiles.get(V)?.configureHandler?.()}async $refreshTests(G,V){await this.d.get(G)?.controller.refreshHandler?.(V)}$publishTestResults(G){this.results=Object.freeze(G.map(V=>(0,C.deepFreeze)(d.TestResults.to(V))).concat(this.results).sort((V,O)=>O.completedAt-V.completedAt).slice(0,32)),this.c.fire()}async $expandTest(G,V){const O=this.d.get(h.TestId.fromString(G).controllerId)?.collection;O&&(await O.expand(G,V<0?1/0:V),O.flushDiff())}$acceptDiff(G){this.h.applyDiff(G.map(m.TestsDiffOp.deserialize))}async $runControllerTests(G,V){return Promise.all(G.map(O=>this.runControllerTestRequest(O,V)))}async runControllerTestRequest(G,V){const O=this.d.get(G.controllerId);if(!O)return{};const{collection:B,profiles:F}=O,$=F.get(G.profileId);if(!$)return{};const M=G.testIds.map(Y=>B.tree.get(Y)).filter(R.isDefined),H=G.excludeExtIds.map(Y=>O.collection.tree.get(Y)).filter(R.isDefined).filter(Y=>M.some(Q=>Q.fullId.compare(Y.fullId)===2));if(!M.length)return{};const K=new g.TestRunRequest(M.some(Y=>Y.actual instanceof v.TestItemRootImpl)?void 0:M.map(Y=>Y.actual),H.map(Y=>Y.actual),$),q=this.g.prepareForMainThreadTestRun(K,r.fromInternal(G,O.collection),V);try{return await $.runHandler(K,V),{}}catch(Y){return{error:String(Y)}}finally{q.isRunning&&!V.isCancellationRequested&&await A.Event.toPromise(q.onEnd),q.dispose()}}$cancelExtensionTestRun(G){G===void 0?this.g.cancelAllRuns():this.g.cancelRunById(G)}};s=Ve([We(0,y.IExtHostRpcService)],s),e.ExtHostTesting=s;class o extends S.Disposable{get isRunning(){return this.c.size>0}get id(){return this.k.id}constructor(G,V,O){super(),this.k=G,this.l=V,this.c=new Map,this.f=new Set,this.h=this.B(new A.Emitter),this.j=!1,this.onEnd=this.h.event,this.g=this.B(new k.CancellationTokenSource(O)),this.B(this.g.token.onCancellationRequested(()=>{for(const{run:B}of this.c.values())B.end()}))}getCoverage(G){return this.c.get(G)?.coverage}createRun(G){const V=this.k.id,O=this.k.controllerId,B=(0,P.generateUuid)(),F=new l(this.l,V,B),$=q=>(Y,...Q)=>{if(H){console.warn(`Setting the state of test "${Y.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(Y)||(this.m(Y),q(Y,...Q))},M=(q,Y)=>{const Q=Y instanceof Array?Y.map(d.TestMessage.from):[d.TestMessage.from(Y)];if(q.uri&&q.range){const ce={range:d.Range.from(q.range),uri:q.uri};for(const ie of Q)ie.location=ie.location||ce}this.l.$appendTestMessagesInRun(V,B,h.TestId.fromExtHostTestItem(q,O).toString(),Q)};let H=!1;const K={isPersisted:this.k.isPersisted,token:this.g.token,name:G,get coverageProvider(){return F.coverageProvider},set coverageProvider(q){F.coverageProvider=q},enqueued:$(q=>{this.l.$updateTestStateInRun(V,B,h.TestId.fromExtHostTestItem(q,O).toString(),1)}),skipped:$(q=>{this.l.$updateTestStateInRun(V,B,h.TestId.fromExtHostTestItem(q,O).toString(),5)}),started:$(q=>{this.l.$updateTestStateInRun(V,B,h.TestId.fromExtHostTestItem(q,O).toString(),2)}),errored:$((q,Y,Q)=>{M(q,Y),this.l.$updateTestStateInRun(V,B,h.TestId.fromExtHostTestItem(q,O).toString(),6,Q)}),failed:$((q,Y,Q)=>{M(q,Y),this.l.$updateTestStateInRun(V,B,h.TestId.fromExtHostTestItem(q,O).toString(),4,Q)}),passed:$((q,Y)=>{this.l.$updateTestStateInRun(V,B,h.TestId.fromExtHostTestItem(q,this.k.controllerId).toString(),3,Y)}),appendOutput:(q,Y,Q)=>{H||(Q&&(this.k.isIncluded(Q)?this.m(Q):Q=void 0),this.l.$appendOutputToRun(V,B,t.VSBuffer.fromString(q),Y&&d.location.from(Y),Q&&h.TestId.fromExtHostTestItem(Q,O).toString()))},end:()=>{H||(H=!0,this.l.$finishedTestRunTask(V,B),this.c.delete(B),this.isRunning||this.dispose())}};return this.c.set(B,{run:K,coverage:F}),this.l.$startedTestRunTask(V,{id:B,name:G,running:!0}),K}dispose(){this.j||(this.j=!0,this.h.fire(),this.g.cancel(),super.dispose())}m(G){if(!(G instanceof v.TestItemImpl))throw new w.InvalidTestItemError(G.id);if(this.f.has(h.TestId.fromExtHostTestItem(G,this.k.controllerId).toString()))return;const V=[],O=this.k.colllection.root;for(;;){const B=d.TestItem.from(G);if(V.unshift(B),this.f.has(B.extId)||(this.f.add(B.extId),G===O))break;G=G.parent||O}this.l.$addTestsToRun(this.k.controllerId,this.k.id,V)}}class c{get trackers(){return this.c.values()}constructor(G){this.d=G,this.c=new Map}prepareForMainThreadTestRun(G,V,O){return this.f(G,V,O)}cancelRunById(G){for(const V of this.c.values())if(V.id===G){V.dispose();return}}cancelAllRuns(){for(const G of this.c.values())G.dispose()}createTestRun(G,V,O,B,F){const $=this.c.get(O);if($)return $.createRun(B);const M=r.fromPublic(G,V,O,F),H=u(O);this.d.$startedExtensionTestRun({controllerId:G,profile:H&&{group:L[H.kind],id:H.profileId},exclude:O.exclude?.map(q=>h.TestId.fromExtHostTestItem(q,V.root.id).toString())??[],id:M.id,include:O.include?.map(q=>h.TestId.fromExtHostTestItem(q,V.root.id).toString())??[V.root.id],persist:F});const K=this.f(O,M);return K.onEnd(()=>this.d.$finishedExtensionTestRun(M.id)),K.createRun(B)}f(G,V,O){const B=new o(V,this.d,O);return this.c.set(G,B),B.onEnd(()=>this.c.delete(G)),B}}e.TestRunCoordinator=c;const u=U=>{if(!!U.profile){if(!(U.profile instanceof I))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return U.profile}};class r{static fromPublic(G,V,O,B){return new r(G,(0,P.generateUuid)(),O.include?.map(F=>h.TestId.fromExtHostTestItem(F,G).toString())??[G],O.exclude?.map(F=>h.TestId.fromExtHostTestItem(F,G).toString())??[],B,V)}static fromInternal(G,V){return new r(G.controllerId,G.runId,G.testIds,G.excludeExtIds,!0,V)}constructor(G,V,O,B,F,$){this.controllerId=G,this.id=V,this.isPersisted=F,this.colllection=$,this.c=O.map(M=>M+"\0"),this.d=B.map(M=>M+"\0")}isIncluded(G){const V=h.TestId.fromExtHostTestItem(G,this.controllerId).toString()+"\0";for(const O of this.d)if(V===O||V.startsWith(O))return!1;for(const O of this.c)if(V===O||V.startsWith(O))return!0;return!1}}e.TestRunDto=r;class l{set coverageProvider(G){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!G||(this.c=G,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(G,V,O){this.f=G,this.g=V,this.h=O}async provideFileCoverage(G){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(G))());try{return(await this.d)?.map(d.TestCoverage.fromFile)??[]}catch(V){throw this.d=void 0,V}}async resolveFileCoverage(G,V){const O=await this.d;let B=O?.[G];return!this.c||!O||!B?[]:(B.detailedCoverage||(B=O[G]=await this.c.resolveFileCoverage?.(B,V)??B),B.detailedCoverage?.map(d.TestCoverage.fromDetailed)??[])}}class n extends m.IncrementalChangeCollector{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(G){super(),this.h=G,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(G){this.c.add(G)}update(G){Object.assign(G.revived,d.TestItem.toPlain(G.item)),this.c.has(G)||this.d.add(G)}remove(G){if(this.c.has(G)){this.c.delete(G);return}this.d.delete(G);const V=h.TestId.parentId(G.item.extId);if(V&&this.g.has(V.toString())){this.g.add(G.item.extId);return}this.f.add(G)}getChangeEvent(){const{c:G,d:V,f:O}=this;return{get added(){return[...G].map(B=>B.revived)},get updated(){return[...V].map(B=>B.revived)},get removed(){return[...O].map(B=>B.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class i extends m.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.m=new A.Emitter,this.onDidChangeTests=this.m.event}get rootTests(){return super.f}getMirroredTestDataById(G){return this.d.get(G)}getMirroredTestDataByReference(G){return this.d.get(G.id)}l(G,V){return{...G,revived:d.TestItem.toPlain(G.item),depth:V?V.depth+1:0,children:new Set}}k(){return new n(this.m)}}e.MirroredTestCollection=i;class p{constructor(G){this.d=G}checkout(){this.c||(this.c=this.f());const G=this.c;return G.observers++,{onDidChangeTest:G.tests.onDidChangeTests,get tests(){return[...G.tests.rootTests].map(V=>V.revived)},dispose:(0,D.once)(()=>{--G.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(G){return this.c?.tests.getMirroredTestDataByReference(G)}applyDiff(G){this.c?.tests.apply(G)}f(){const G=new i;return this.d.$subscribeToDiffs(),{observers:0,tests:G}}}class I{get label(){return this.d}set label(G){G!==this.d&&(this.d=G,Fe(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:G}))}get isDefault(){return this.f}set isDefault(G){G!==this.f&&(this.f=G,Fe(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:G}))}get tag(){return this._tag}set tag(G){G?.id!==this._tag?.id&&(this._tag=G,Fe(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:G?d.TestTag.namespace(this.controllerId,G.id):null}))}get configureHandler(){return this.c}set configureHandler(G){G!==this.c&&(this.c=G,Fe(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!G}))}constructor(G,V,O,B,F,$,M,H=!1,K=void 0){this.controllerId=O,this.profileId=B,this.d=F,this.kind=$,this.runHandler=M,this.f=H,this._tag=K,f.set(this,void 0),b.set(this,void 0),Je(this,f,G,"f"),Je(this,b,V,"f"),V.set(B,this);const q=L[$];if(typeof q!="number")throw new Error(`Unknown TestRunProfile.group ${$}`);Fe(this,f,"f").$publishTestRunProfile({profileId:B,controllerId:O,tag:K?d.TestTag.namespace(this.controllerId,K.id):null,label:F,group:q,isDefault:H,hasConfigurationHandler:!1})}dispose(){Fe(this,b,"f")?.delete(this.profileId)&&(Je(this,b,void 0,"f"),Fe(this,f,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=I,f=new WeakMap,b=new WeakMap;const L={[g.TestRunProfileKind.Coverage]:8,[g.TestRunProfileKind.Debug]:4,[g.TestRunProfileKind.Run]:2}}),define(Se[267],ye([1,0,17,4,5,137,14,7]),function(te,e,a,t,k,A,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(R,P){this.i=P,this.a=new t.Emitter,this.b=new t.Emitter,this.c=new t.Emitter,this.d=new t.Emitter,this.f=new t.Emitter,this.g=new t.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=R.getProxy(k.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(E=>this.g.fire(E)),this.i.onDidChangeActiveTextEditor(E=>this.f.fire(E))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(R){const P=this.i.allEditors();return R?P:P.map(E=>E.value)}async showTextDocument(R,P,E){let y;typeof P=="number"?y={position:D.ViewColumn.from(P),preserveFocus:E}:typeof P=="object"?y={position:D.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?D.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:y={preserveFocus:!1};const v=await this.h.$tryShowTextDocument(R.uri,y),d=v&&this.i.getEditor(v);if(d)return d.value;throw v?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,P){return new A.TextEditorDecorationType(this.h,R,P).value}$acceptEditorPropertiesChanged(R,P){const E=this.i.getEditor(R);if(!E)throw new Error("unknown text editor");if(P.options&&E._acceptOptions(P.options),P.selections){const y=P.selections.selections.map(D.Selection.to);E._acceptSelections(y)}if(P.visibleRanges){const y=a.coalesce(P.visibleRanges.map(D.Range.to));E._acceptVisibleRanges(y)}if(P.options&&this.b.fire({textEditor:E.value,options:{...P.options,lineNumbers:D.TextEditorLineNumbersStyle.to(P.options.lineNumbers)}}),P.selections){const y=T.TextEditorSelectionChangeKind.fromValue(P.selections.source),v=P.selections.selections.map(D.Selection.to);this.a.fire({textEditor:E.value,selections:v,kind:y})}if(P.visibleRanges){const y=a.coalesce(P.visibleRanges.map(D.Range.to));this.c.fire({textEditor:E.value,visibleRanges:y})}}$acceptEditorPositionData(R){for(const P in R){const E=this.i.getEditor(P);if(!E)throw new Error("Unknown text editor");const y=D.ViewColumn.to(R[P]);E.value.viewColumn!==y&&(E._acceptViewColumn(y),this.d.fire({textEditor:E.value,viewColumn:y}))}}getDiffInformation(R){return Promise.resolve(this.h.$getDiffInformation(R))}}e.ExtHostEditors=S}),define(Se[268],ye([1,0,2,3,5,6,7,14,11]),function(te,e,a,t,k,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class C{constructor(E,y){this.b=new Map,this.c=new Map,this.a=E.getProxy(k.MainContext.MainThreadTimeline),y.registerArgumentProcessor({processArgument:v=>{if(v&&v.$mid===12){const d=v.uri===void 0?void 0:a.URI.revive(v.uri);return this.c.get(v.source)?.get(R(d))?.get(v.handle)}return v}})}async $getTimeline(E,y,v,d){return this.b.get(E)?.provideTimeline(a.URI.revive(y),v,d)}registerTimelineProvider(E,y,v,d){const g=new A.DisposableStore,h=this.d(y.id,d,g).bind(this);let w;y.onDidChange&&(w=y.onDidChange(f=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...f,id:y.id}),this));const m=this.c;return this.f({...y,scheme:E,onDidChange:void 0,async provideTimeline(f,b,s){b?.resetCache&&(g.clear(),m.get(y.id)?.clear());const o=await y.provideTimeline(f,b,s);if(o==null)return;const c=h(f,b);return{...o,source:y.id,items:o.items.map(c)}},dispose(){for(const f of m.values())f.get(y.id)?.clear();w?.dispose(),g.dispose()}})}d(E,y,v){return(d,g)=>{let h;if(g?.cacheResults){let w=this.c.get(E);w===void 0&&(w=new Map,this.c.set(E,w));const m=R(d);h=w.get(m),h===void 0&&(h=new Map,w.set(m,h))}return w=>{const{iconPath:m,...f}=w,b=`${E}|${w.id??w.timestamp}`;h?.set(b,w);let s,o,c;w.iconPath&&(m instanceof D.ThemeIcon?c={id:m.id,color:m.color}:a.URI.isUri(m)?(s=m,o=m):{light:s,dark:o}=m);let u;return D.MarkdownString.isMarkdownString(f.tooltip)?u=T.MarkdownString.from(f.tooltip):(0,S.isString)(f.tooltip)?u=f.tooltip:D.MarkdownString.isMarkdownString(f.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=T.MarkdownString.from(f.detail)):(0,S.isString)(f.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=f.detail),{...f,id:f.id??void 0,handle:b,source:E,command:w.command?y.toInternal(w.command,v):void 0,icon:s,iconDark:o,themeIcon:c,tooltip:u,accessibilityInformation:w.accessibilityInformation}}}}f(E){if(this.b.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this.a.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this.b.set(E.id,E),(0,A.toDisposable)(()=>{for(const v of this.c.values())v.get(E.id)?.clear();this.b.delete(E.id),this.a.$unregisterTimelineProvider(E.id),E.dispose()})}}e.ExtHostTimeline=C;function R(P){return P?.toString()}}),define(Se[269],ye([1,0,6,15,2,5]),function(te,e,a,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class D{constructor(S){this.c=new Map,this.b=S.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,C,R,P){if(this.c.has(C))throw new Error(`Opener with id '${C}' already registered`);const E=P.schemes.find(y=>!D.a.has(y));if(E)throw new Error(`Scheme '${E}' is not supported. Only http and https are currently supported.`);return this.c.set(C,R),this.b.$registerUriOpener(C,P.schemes,S,P.label),(0,a.toDisposable)(()=>{this.c.delete(C),this.b.$unregisterUriOpener(C)})}async $canOpenUri(S,C,R){const P=this.c.get(S);if(!P)throw new Error(`Unknown opener with id: ${S}`);const E=k.URI.revive(C);return P.canOpenExternalUri(E,R)}async $openUri(S,C,R){const P=this.c.get(S);if(!P)throw new Error(`Unknown opener id: '${S}'`);return P.openExternalUri(k.URI.revive(C.resolvedUri),{sourceUri:k.URI.revive(C.sourceUri)},R)}}e.ExtHostUriOpeners=D,D.a=new Set([t.Schemas.http,t.Schemas.https])}),define(Se[270],ye([1,0,5,2,6,10,27]),function(te,e,a,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class T{constructor(C){this.c=new Set,this.d=new Map,this.b=C.getProxy(a.MainContext.MainThreadUrls)}registerUriHandler(C,R){if(this.c.has(D.ExtensionIdentifier.toKey(C)))throw new Error(`Protocol handler already registered for extension ${C}`);const P=T.a++;return this.c.add(D.ExtensionIdentifier.toKey(C)),this.d.set(P,R),this.b.$registerUriHandler(P,C),(0,k.toDisposable)(()=>{this.c.delete(D.ExtensionIdentifier.toKey(C)),this.d.delete(P),this.b.$unregisterUriHandler(P)})}$handleExternalUri(C,R){const P=this.d.get(C);if(!P)return Promise.resolve(void 0);try{P.handleUri(t.URI.revive(R))}catch(E){(0,A.onUnexpectedError)(E)}return Promise.resolve(void 0)}async createAppUri(C){return t.URI.revive(await this.b.$createAppUri(C))}}e.ExtHostUrls=T,T.a=0});var Je=this&&this.__classPrivateFieldSet||function(te,e,a,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,a):k?k.value=a:e.set(te,a),a},Fe=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)};define(Se[72],ye([1,0,4,15,23,2,192,214,92,5]),function(te,e,a,t,k,A,D,T,S,C){"use strict";var R,P,E,y,v,d,g,h,w,m,f,b,s;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class o{constructor(L,U,G,V,O,B,F){R.set(this,void 0),P.set(this,void 0),E.set(this,void 0),y.set(this,void 0),v.set(this,void 0),d.set(this,void 0),g.set(this,""),h.set(this,void 0),w.set(this,!1),m.set(this,!1),f.set(this,void 0),b.set(this,void 0),this._onMessageEmitter=new a.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,s.set(this,new a.Emitter),this._onDidDispose=Fe(this,s,"f").event,Je(this,R,L,"f"),Je(this,P,U,"f"),Je(this,h,G,"f"),Je(this,y,V,"f"),Je(this,v,O,"f"),Je(this,d,B,"f"),Je(this,f,c(B),"f"),Je(this,b,u(B),"f"),Je(this,E,F,"f")}dispose(){Je(this,w,!0,"f"),Fe(this,s,"f").fire(),Fe(this,s,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(L){return Je(this,m,!0,"f"),(0,S.asWebviewUri)(L,Fe(this,y,"f"))}get cspSource(){const L=Fe(this,d,"f").extensionLocation;if(L.scheme===t.Schemas.https||L.scheme===t.Schemas.http){let U=L.toString();return U.endsWith("/")||(U+="/"),U+" "+S.webviewGenericCspSource}return S.webviewGenericCspSource}get html(){return this.a(),Fe(this,g,"f")}set html(L){this.a(),Fe(this,g,"f")!==L&&(Je(this,g,L,"f"),Fe(this,b,"f")&&!Fe(this,m,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(L)&&(Je(this,m,!0,"f"),Fe(this,E,"f").report("Webview vscode-resource: uris",Fe(this,d,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Fe(this,P,"f").$setHtml(Fe(this,R,"f"),this.b(L)))}get options(){return this.a(),Fe(this,h,"f")}set options(L){this.a(),k.equals(Fe(this,h,"f"),L)||Fe(this,P,"f").$setOptions(Fe(this,R,"f"),n(Fe(this,d,"f"),Fe(this,v,"f"),L)),Je(this,h,L,"f")}async postMessage(L){if(Fe(this,w,"f"))return!1;const U=(0,T.serializeWebviewMessage)(L,{serializeBuffersForPostMessage:Fe(this,f,"f")});return Fe(this,P,"f").$postMessage(Fe(this,R,"f"),U.message,...U.buffers)}a(){if(Fe(this,w,"f"))throw new Error("Webview is disposed")}b(L){if(!Fe(this,b,"f"))return L;const U=Fe(this,d,"f").extensionLocation?.scheme===t.Schemas.vscodeRemote,G=Fe(this,d,"f").extensionLocation.scheme===t.Schemas.vscodeRemote?Fe(this,d,"f").extensionLocation.authority:void 0;return L.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(V,O,B,F,$,M)=>{const H=A.URI.from({scheme:F||"file",path:decodeURIComponent($)}),K=(0,S.asWebviewUri)(H,{isRemote:U,authority:G}).toString();return`${O}${K}${M}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(V,O,B,F,$,M)=>{const H=A.URI.from({scheme:F||"file",path:decodeURIComponent($)}),K=(0,S.asWebviewUri)(H,{isRemote:U,authority:G}).toString();return`${O}${K}${M}`})}}e.ExtHostWebview=o,R=new WeakMap,P=new WeakMap,E=new WeakMap,y=new WeakMap,v=new WeakMap,d=new WeakMap,g=new WeakMap,h=new WeakMap,w=new WeakMap,m=new WeakMap,f=new WeakMap,b=new WeakMap,s=new WeakMap;function c(I){try{const L=(0,D.normalizeVersion)((0,D.parseVersion)(I.engines.vscode));return!!L&&L.majorBase>=1&&L.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=c;function u(I){try{const L=(0,D.normalizeVersion)((0,D.parseVersion)(I.engines.vscode));return L?L.majorBase<1||L.majorBase===1&&L.minorBase<60:!1}catch{return!1}}class r{constructor(L,U,G,V,O){this.c=U,this.d=G,this.e=V,this.f=O,this.b=new Map,this.a=L.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(L,U,G){const V=this.g(L);if(V){const{message:O}=(0,T.deserializeWebviewMessage)(U,G.value);V._onMessageEmitter.fire(O)}}$onMissingCsp(L,U){this.e.warn(`${U} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(L,U,G){const V=new o(L,this.a,i(U),this.c,this.d,G,this.f);return this.b.set(L,V),V._onDidDispose(()=>{this.b.delete(L)}),V}deleteWebview(L){this.b.delete(L)}g(L){return this.b.get(L)}}e.ExtHostWebviews=r;function l(I){return{id:I.identifier,location:I.extensionLocation}}e.toExtensionData=l;function n(I,L,U){return{enableCommandUris:U.enableCommandUris,enableScripts:U.enableScripts,enableForms:U.enableForms,portMapping:U.portMapping,localResourceRoots:U.localResourceRoots||p(I,L)}}e.serializeWebviewOptions=n;function i(I){return{enableCommandUris:I.enableCommandUris,enableScripts:I.enableScripts,enableForms:I.enableForms,portMapping:I.portMapping,localResourceRoots:I.localResourceRoots?.map(L=>A.URI.from(L))}}function p(I,L){return[...(L?.getWorkspaceFolders()||[]).map(U=>U.uri),I.extensionLocation]}}),define(Se[271],ye([1,0,21,83,6,15,24,2,14,72,67,5,7]),function(te,e,a,t,k,A,D,T,S,C,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class y{constructor(o,c){this.document=o,this.b=c,this.a=1,this.c=new R.Cache("custom documents")}addEdit(o){return this.c.add([o])}async undo(o,c){await this.f(o).undo(),c||this.disposeBackup()}async redo(o,c){await this.f(o).redo(),c||this.disposeBackup()}disposeEdits(o){for(const c of o)this.c.delete(c)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const o=b(this.document.uri)+this.a++;return(0,D.joinPath)(this.b,o)}updateBackup(o){this.d?.delete(),this.d=o}disposeBackup(){this.d?.delete(),this.d=void 0}f(o){const c=this.c.get(o,0);if(!c)throw new Error("No edit found");return c}}class v{constructor(){this.a=new Map}get(o,c){return this.a.get(this.b(o,c))}add(o,c,u){const r=this.b(o,c.uri);if(this.a.has(r))throw new Error(`Document already exists for viewType:${o} resource:${c.uri}`);const l=new y(c,u);return this.a.set(r,l),l}delete(o,c){const u=this.b(o,c.uri);this.a.delete(u)}b(o,c){return`${o}@@@${c}`}}var d;(function(s){s[s.Text=0]="Text",s[s.Custom=1]="Custom"})(d||(d={}));class g{constructor(){this.a=new Map}addTextProvider(o,c,u){return this.b(0,o,c,u)}addCustomProvider(o,c,u){return this.b(1,o,c,u)}get(o){return this.a.get(o)}b(o,c,u,r){if(this.a.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this.a.set(c,{type:o,extension:u,provider:r}),new E.Disposable(()=>this.a.delete(c))}}class h{constructor(o,c,u,r,l){this.d=c,this.f=u,this.g=r,this.h=l,this.b=new g,this.c=new v,this.a=o.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(o,c,u,r){const l=new k.DisposableStore;return m(u)?(l.add(this.b.addTextProvider(c,o,u)),this.a.$registerTextEditorProvider((0,C.toExtensionData)(o),c,r.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,C.shouldSerializeBuffersForPostMessage)(o))):(l.add(this.b.addCustomProvider(c,o,u)),w(u)&&l.add(u.onDidChangeCustomDocument(n=>{const i=this.i(c,n.document.uri);if(f(n)){const p=i.addEdit(n);this.a.$onDidEdit(n.document.uri,c,p,n.label)}else this.a.$onContentChange(n.document.uri,c)})),this.a.$registerCustomEditorProvider((0,C.toExtensionData)(o),c,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,C.shouldSerializeBuffersForPostMessage)(o))),E.Disposable.from(l,new E.Disposable(()=>{this.a.$unregisterEditorProvider(c)}))}async $createCustomDocument(o,c,u,r,l){const n=this.b.get(c);if(!n)throw new Error(`No provider found for '${c}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${c}'`);const i=T.URI.revive(o),p=await n.provider.openCustomDocument(i,{backupId:u,untitledDocumentData:r?.buffer},l);let I;return w(n.provider)&&this.f&&(I=this.f.workspaceValue(n.extension)??this.f.globalValue(n.extension)),this.c.add(c,p,I),{editable:w(n.provider)}}async $disposeCustomDocument(o,c){const u=this.b.get(c);if(!u)throw new Error(`No provider found for '${c}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${c}'`);const r=T.URI.revive(o),{document:l}=this.i(c,r);this.c.delete(c,l),l.dispose()}async $resolveWebviewEditor(o,c,u,r,l,n){const i=this.b.get(u);if(!i)throw new Error(`No provider found for '${u}'`);const p=S.ViewColumn.to(l),I=this.g.createNewWebview(c,r.contentOptions,i.extension),L=this.h.createNewWebviewPanel(c,u,r.title,p,r.options,I,!0),U=T.URI.revive(o);switch(i.type){case 1:{const{document:G}=this.i(u,U);return i.provider.resolveCustomEditor(G,L,n)}case 0:{const G=this.d.getDocument(U);return i.provider.resolveCustomTextEditor(G,L,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(o,c,u){this.i(c,o).disposeEdits(u)}async $onMoveCustomEditor(o,c,u){const r=this.b.get(u);if(!r)throw new Error(`No provider found for '${u}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const l=this.h.getWebviewPanel(o);if(!l)throw new Error("No webview found");const n=T.URI.revive(c),i=this.d.getDocument(n);await r.provider.moveCustomTextEditor(i,l,a.CancellationToken.None)}async $undo(o,c,u,r){return this.i(c,o).undo(u,r)}async $redo(o,c,u,r){return this.i(c,o).redo(u,r)}async $revert(o,c,u){const r=this.i(c,o);await this.j(c).revertCustomDocument(r.document,u),r.disposeBackup()}async $onSave(o,c,u){const r=this.i(c,o);await this.j(c).saveCustomDocument(r.document,u),r.disposeBackup()}async $onSaveAs(o,c,u,r){const l=this.i(c,o);return this.j(c).saveCustomDocumentAs(l.document,T.URI.revive(u),r)}async $backup(o,c,u){const r=this.i(c,o),n=await this.j(c).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},u);return r.updateBackup(n),n.id}i(o,c){const u=this.c.get(o,T.URI.revive(c));if(!u)throw new Error("No custom document found");return u}j(o){const u=this.b.get(o)?.provider;if(!u||!w(u))throw new Error("Custom document is not editable");return u}}e.ExtHostCustomEditors=h;function w(s){return!!s.onDidChangeCustomDocument}function m(s){return typeof s.resolveCustomTextEditor=="function"}function f(s){return typeof s.undo=="function"&&typeof s.redo=="function"}function b(s){const o=s.scheme===A.Schemas.file||s.scheme===A.Schemas.untitled?s.fsPath:s.toString();return(0,t.hash)(o)+""}});var Je=this&&this.__classPrivateFieldSet||function(te,e,a,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,a):k?k.value=a:e.set(te,a),a},Fe=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)};define(Se[272],ye([1,0,4,6,2,30,14,72,5,7]),function(te,e,a,t,k,A,D,T,S,C){"use strict";var R,P,E,y,v,d,g,h,w,m,f,b,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class o extends t.Disposable{constructor(l,n,i,p){super(),R.set(this,void 0),P.set(this,void 0),E.set(this,void 0),y.set(this,void 0),v.set(this,void 0),d.set(this,void 0),g.set(this,void 0),h.set(this,void 0),w.set(this,!0),m.set(this,void 0),f.set(this,!1),b.set(this,this.B(new a.Emitter)),this.onDidDispose=Fe(this,b,"f").event,s.set(this,this.B(new a.Emitter)),this.onDidChangeViewState=Fe(this,s,"f").event,Je(this,R,l,"f"),Je(this,P,n,"f"),Je(this,y,i,"f"),Je(this,E,p.viewType,"f"),Je(this,v,p.panelOptions,"f"),Je(this,h,p.viewColumn,"f"),Je(this,d,p.title,"f"),Je(this,m,p.active,"f")}dispose(){Fe(this,f,"f")||(Je(this,f,!0,"f"),Fe(this,b,"f").fire(),Fe(this,P,"f").$disposeWebview(Fe(this,R,"f")),Fe(this,y,"f").dispose(),super.dispose())}get webview(){return this.c(),Fe(this,y,"f")}get viewType(){return this.c(),Fe(this,E,"f")}get title(){return this.c(),Fe(this,d,"f")}set title(l){this.c(),Fe(this,d,"f")!==l&&(Je(this,d,l,"f"),Fe(this,P,"f").$setTitle(Fe(this,R,"f"),l))}get iconPath(){return this.c(),Fe(this,g,"f")}set iconPath(l){this.c(),Fe(this,g,"f")!==l&&(Je(this,g,l,"f"),Fe(this,P,"f").$setIconPath(Fe(this,R,"f"),k.URI.isUri(l)?{light:l,dark:l}:l))}get options(){return Fe(this,v,"f")}get viewColumn(){if(this.c(),!(typeof Fe(this,h,"f")=="number"&&Fe(this,h,"f")<0))return Fe(this,h,"f")}get active(){return this.c(),Fe(this,m,"f")}get visible(){return this.c(),Fe(this,w,"f")}_updateViewState(l){Fe(this,f,"f")||(this.active!==l.active||this.visible!==l.visible||this.viewColumn!==l.viewColumn)&&(Je(this,m,l.active,"f"),Je(this,w,l.visible,"f"),Je(this,h,l.viewColumn,"f"),Fe(this,s,"f").fire({webviewPanel:this}))}reveal(l,n){this.c(),Fe(this,P,"f").$reveal(Fe(this,R,"f"),{viewColumn:typeof l>"u"?void 0:D.ViewColumn.from(l),preserveFocus:!!n})}c(){if(Fe(this,f,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,P=new WeakMap,E=new WeakMap,y=new WeakMap,v=new WeakMap,d=new WeakMap,g=new WeakMap,h=new WeakMap,w=new WeakMap,m=new WeakMap,f=new WeakMap,b=new WeakMap,s=new WeakMap;class c{static c(){return(0,A.generateUuid)()}constructor(l,n,i){this.g=n,this.h=i,this.e=new Map,this.f=new Map,this.d=l.getProxy(S.MainContext.MainThreadWebviewPanels)}createWebviewPanel(l,n,i,p,I={}){const L=typeof p=="object"?p.viewColumn:p,U={viewColumn:D.ViewColumn.from(L),preserveFocus:typeof p=="object"&&!!p.preserveFocus},G=(0,T.shouldSerializeBuffersForPostMessage)(l),V=c.c();this.d.$createWebviewPanel((0,T.toExtensionData)(l),V,n,{title:i,panelOptions:u(I),webviewOptions:(0,T.serializeWebviewOptions)(l,this.h,I),serializeBuffersForPostMessage:G},U);const O=this.g.createNewWebview(V,I,l);return this.createNewWebviewPanel(V,n,i,L,I,O,!0)}$onDidChangeWebviewPanelViewStates(l){const n=Object.keys(l);n.sort((i,p)=>{const I=l[i],L=l[p];return I.active?1:L.active?-1:+I.visible-+L.visible});for(const i of n){const p=this.getWebviewPanel(i);if(!p)continue;const I=l[i];p._updateViewState({active:I.active,visible:I.visible,viewColumn:D.ViewColumn.to(I.position)})}}async $onDidDisposeWebviewPanel(l){this.getWebviewPanel(l)?.dispose(),this.e.delete(l),this.g.deleteWebview(l)}registerWebviewPanelSerializer(l,n,i){if(this.f.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.f.set(n,{serializer:i,extension:l}),this.d.$registerSerializer(n,{serializeBuffersForPostMessage:(0,T.shouldSerializeBuffersForPostMessage)(l)}),new C.Disposable(()=>{this.f.delete(n),this.d.$unregisterSerializer(n)})}async $deserializeWebviewPanel(l,n,i,p){const I=this.f.get(n);if(!I)throw new Error(`No serializer found for '${n}'`);const{serializer:L,extension:U}=I,G=this.g.createNewWebview(l,i.webviewOptions,U),V=this.createNewWebviewPanel(l,n,i.title,p,i.panelOptions,G,i.active);await L.deserializeWebviewPanel(V,i.state)}createNewWebviewPanel(l,n,i,p,I,L,U){const G=new o(l,this.d,L,{viewType:n,title:i,viewColumn:p,panelOptions:I,active:U});return this.e.set(l,G),G}getWebviewPanel(l){return this.e.get(l)}}e.ExtHostWebviewPanels=c;function u(r){return{enableFindWidget:r.enableFindWidget,retainContextWhenHidden:r.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(te,e,a,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,a):k?k.value=a:e.set(te,a),a},Fe=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)};define(Se[273],ye([1,0,4,6,72,14,5,7]),function(te,e,a,t,k,A,D,T){"use strict";var S,C,R,P,E,y,v,d,g,h,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class m extends t.Disposable{constructor(s,o,c,u,r,l){super(),S.set(this,void 0),C.set(this,void 0),R.set(this,void 0),P.set(this,void 0),E.set(this,!1),y.set(this,void 0),v.set(this,void 0),d.set(this,void 0),g.set(this,void 0),h.set(this,this.B(new a.Emitter)),this.onDidChangeVisibility=Fe(this,h,"f").event,w.set(this,this.B(new a.Emitter)),this.onDidDispose=Fe(this,w,"f").event,Je(this,R,c,"f"),Je(this,v,u,"f"),Je(this,S,s,"f"),Je(this,C,o,"f"),Je(this,P,r,"f"),Je(this,y,l,"f")}dispose(){Fe(this,E,"f")||(Je(this,E,!0,"f"),Fe(this,w,"f").fire(),Fe(this,P,"f").dispose(),super.dispose())}get title(){return this.a(),Fe(this,v,"f")}set title(s){this.a(),Fe(this,v,"f")!==s&&(Je(this,v,s,"f"),Fe(this,C,"f").$setWebviewViewTitle(Fe(this,S,"f"),s))}get description(){return this.a(),Fe(this,d,"f")}set description(s){this.a(),Fe(this,d,"f")!==s&&(Je(this,d,s,"f"),Fe(this,C,"f").$setWebviewViewDescription(Fe(this,S,"f"),s))}get visible(){return Fe(this,y,"f")}get webview(){return Fe(this,P,"f")}get viewType(){return Fe(this,R,"f")}_setVisible(s){s===Fe(this,y,"f")||Fe(this,E,"f")||(Je(this,y,s,"f"),Fe(this,h,"f").fire())}get badge(){return this.a(),Fe(this,g,"f")}set badge(s){this.a(),!(s?.value===Fe(this,g,"f")?.value&&s?.tooltip===Fe(this,g,"f")?.tooltip)&&(Je(this,g,A.ViewBadge.from(s),"f"),Fe(this,C,"f").$setWebviewViewBadge(Fe(this,S,"f"),s))}show(s){this.a(),Fe(this,C,"f").$show(Fe(this,S,"f"),!!s)}a(){if(Fe(this,E,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,C=new WeakMap,R=new WeakMap,P=new WeakMap,E=new WeakMap,y=new WeakMap,v=new WeakMap,d=new WeakMap,g=new WeakMap,h=new WeakMap,w=new WeakMap;class f{constructor(s,o){this.d=o,this.b=new Map,this.c=new Map,this.a=s.getProxy(D.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(s,o,c,u){if(this.b.has(o))throw new Error(`View provider for '${o}' already registered`);return this.b.set(o,{provider:c,extension:s}),this.a.$registerWebviewViewProvider((0,k.toExtensionData)(s),o,{retainContextWhenHidden:u?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(s)}),new T.Disposable(()=>{this.b.delete(o),this.a.$unregisterWebviewViewProvider(o)})}async $resolveWebviewView(s,o,c,u,r){const l=this.b.get(o);if(!l)throw new Error(`No view provider found for '${o}'`);const{provider:n,extension:i}=l,p=this.d.createNewWebview(s,{},i),I=new m(s,this.a,o,c,p,!0);this.c.set(s,I),await n.resolveWebviewView(I,{state:u},r)}async $onDidChangeWebviewViewVisibility(s,o){this.e(s)._setVisible(o)}async $disposeWebviewView(s){const o=this.e(s);this.c.delete(s),o.dispose(),this.d.deleteWebview(s)}e(s){const o=this.c.get(s);if(!o)throw new Error("No webview found");return o}}e.ExtHostWebviewViews=f}),define(Se[140],ye([1,0,4,5,2,15,8,3,16]),function(te,e,a,t,k,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class ii{get state(){return this.d}constructor(P){this.c=new a.Emitter,this.onDidChangeWindowState=this.c.event,this.d=ii.a,this.b=P.getProxy(t.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(E=>this.$onDidChangeWindowFocus(E))}$onDidChangeWindowFocus(P){P!==this.d.focused&&(this.d={...this.d,focused:P},this.c.fire(this.d))}openUri(P,E){let y;if(typeof P=="string"){y=P;try{P=k.URI.parse(P)}catch{return Promise.reject(`Invalid uri - '${P}'`)}}return(0,D.isFalsyOrWhitespace)(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this.b.$openUri(P,y,E)}async asExternalUri(P,E){if((0,D.isFalsyOrWhitespace)(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");const y=await this.b.$asExternalUri(P,E);return k.URI.from(y)}};C.a={focused:!0},C=Ve([We(0,S.IExtHostRpcService)],C),e.ExtHostWindow=C,e.IExtHostWindow=(0,T.createDecorator)("IExtHostWindow")}),define(Se[274],ye([1,0,117,275,65,39,2,13,45]),function(te,e,a,t,k,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class C{constructor(E,y,v){this.b=E,this.c=y,this.f=v,this.a=t.createServer((d,g)=>this.h(d,g)),this.g().catch(d=>(y.error(d),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",E=>this.c.error(E))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(E,y){const v=(g,h)=>{y.writeHead(g,{"content-type":"application/json"}),y.end(JSON.stringify(h||null),w=>w&&this.c.error(w))},d=[];E.setEncoding("utf8"),E.on("data",g=>d.push(g)),E.on("end",async()=>{try{const g=JSON.parse(d.join(""));let h;switch(g.type){case"open":h=await this.i(g);break;case"openExternal":h=await this.j(g);break;case"status":h=await this.l(g);break;case"extensionManagement":h=await this.k(g);break;default:v(404,`Unknown message type: ${g.type}`);break}v(200,h)}catch(g){const h=g instanceof Error?g.message:JSON.stringify(g);v(500,h),this.c.error("Error while processing pipe request",g)}})}async i(E){const{fileURIs:y,folderURIs:v,forceNewWindow:d,diffMode:g,mergeMode:h,addMode:w,forceReuseWindow:m,gotoLineMode:f,waitMarkerFilePath:b,remoteAuthority:s}=E,o=[];if(Array.isArray(v))for(const l of v)try{o.push({folderUri:D.URI.parse(l)})}catch{}if(Array.isArray(y))for(const l of y)try{(0,S.hasWorkspaceFileExtension)(l)?o.push({workspaceUri:D.URI.parse(l)}):o.push({fileUri:D.URI.parse(l)})}catch{}const c=b?D.URI.file(b):void 0,r={forceNewWindow:d,diffMode:g,mergeMode:h,addMode:w,gotoLineMode:f,forceReuseWindow:m,preferNewWindow:!m&&!c&&!w,waitMarkerFileURI:c,remoteAuthority:s};return this.b.executeCommand("_remoteCLI.windowOpen",o,r),""}async j(E){for(const y of E.uris){const v=D.URI.parse(y),d=v.scheme==="file"?v:y;await this.b.executeCommand("_remoteCLI.openExternal",d)}}async k(E){const y=d=>d?.map(g=>/\.vsix$/i.test(g)?D.URI.parse(g):g),v={list:E.list,install:y(E.install),uninstall:y(E.uninstall),force:E.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",v)}async l(E){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&k.existsSync(this.f)&&k.unlinkSync(this.f)}}e.CLIServerBase=C;let R=class extends C{constructor(E,y){super(E,y,(0,a.createRandomIPCHandle)())}};R=Ve([We(0,A.IExtHostCommands),We(1,T.ILogService)],R),e.CLIServer=R}),define(Se[276],ye([1,0,247,25,16]),function(te,e,a,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const A=1024*1024;let D=class extends a.AbstractExtHostConsoleForwarder{constructor(S,C){super(S,C),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(S,C,R){const P=S==="error"||S==="warn"?process.stderr:process.stdout;this.g=!0,P.write(`
START_NATIVE_LOG
`),C.apply(console,R),P.write(`
END_NATIVE_LOG
`),this.g=!1}j(S,C){const R=process[S],P=R.write;let E="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(y,v,d)=>{if(!this.g){E+=y.toString(v);const g=E.length>A?E.length:E.lastIndexOf(`
`);g!==-1&&(console[C](E.slice(0,g)),E=E.slice(g+1))}P.call(R,y,v,d)}})}};D=Ve([We(0,k.IExtHostRpcService),We(1,t.IExtHostInitDataService)],D),e.ExtHostConsoleForwarder=D}),define(Se[277],ye([1,0,9,85,30,39,6,5,2,16]),function(te,e,a,t,k,A,D,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let R=class extends D.Disposable{constructor(E,y){super();const v=E.getProxy(T.MainContext.MainThreadDownloadService);y.registerCommand(!1,"_workbench.downloadResource",async d=>{const g=S.URI.file((0,a.join)((0,t.tmpdir)(),(0,k.generateUuid)()));return await v.$download(d,g),g})}};R=Ve([We(0,C.IExtHostRpcService),We(1,A.IExtHostCommands)],R),e.ExtHostDownloadService=R}),define(Se[278],ye([1,0,139,15,198,30]),function(te,e,a,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class D extends a.ExtHostLoggerService{f(S,C,R){return S.scheme===t.Schemas.file?new k.SpdLogLogger(R?.name||(0,A.generateUuid)(),S.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,C):super.f(S,C,R)}}e.ExtHostLoggerService=D}),define(Se[279],ye([1,0,65,9,2,71,6,15,18,29]),function(te,e,a,t,k,A,D,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class R extends A.ExtensionStoragePaths{constructor(){super(...arguments),this.i=null}async g(s){const o=await super.g(s);if(o.scheme!==T.Schemas.file)return o;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${o.fsPath}.`),o;const c=o.fsPath;let u=0;do{let r;u===0?r=c:r=/[/\\]$/.test(c)?`${c.substr(0,c.length-1)}-${u}`:`${c}-${u}`,await P(r);const l=t.join(r,"vscode.lock"),n=await d(this.d,l,!1);if(n)return this.i=n,process.on("exit",()=>{n.dispose()}),k.URI.file(r);u++}while(u<10);return o}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.ExtensionStoragePaths=R;async function P(b){try{await C.Promises.stat(b);return}catch{}try{await C.Promises.mkdir(b,{recursive:!0})}catch{}}const E=1e3,y=10*60*1e3;class v extends D.Disposable{constructor(s,o){super(),this.b=s,this.c=o,this.a=this.B(new S.IntervalTimer),this.a.cancelAndSet(async()=>{const c=await g(s,o);(!c||c.pid!==process.pid)&&(s.info(`Lock '${o}': The lock was lost unexpectedly.`),this.a.cancel());try{await C.Promises.utimes(o,new Date,new Date)}catch(u){s.error(u),s.info(`Lock '${o}': Could not update mtime.`)}},E)}dispose(){super.dispose();try{a.unlinkSync(this.c)}catch{}}async setWillRelease(s){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${s} ms.`);try{const o={pid:process.pid,willReleaseAt:Date.now()+s};await C.Promises.writeFile(this.c,JSON.stringify(o),{flag:"w"})}catch(o){this.b.error(o)}}}async function d(b,s,o){try{const u={pid:process.pid,willReleaseAt:0};await C.Promises.writeFile(s,JSON.stringify(u),{flag:"wx"})}catch(u){b.error(u)}const c=await g(b,s);return!c||c.pid!==process.pid?o?(b.info(`Lock '${s}': Could not acquire lock, giving up.`),null):(b.info(`Lock '${s}': Could not acquire lock, checking if the file is stale.`),m(b,s)):(b.info(`Lock '${s}': Lock acquired.`),new v(b,s))}async function g(b,s){let o;try{o=await C.Promises.readFile(s)}catch(c){return b.error(c),null}try{return JSON.parse(String(o))}catch(c){return b.error(c),null}}async function h(b,s){let o;try{o=await C.Promises.stat(s)}catch(c){return b.error(c),0}return o.mtime.getTime()}function w(b){try{return process.kill(b,0),!0}catch{return!1}}async function m(b,s){const o=await g(b,s);if(!o)return b.info(`Lock '${s}': Could not read pid of lock holder.`),f(b,s);if(o.willReleaseAt){let n=o.willReleaseAt-Date.now();if(n<5e3){for(n>0?b.info(`Lock '${s}': The lockfile is scheduled to be released in ${n} ms.`):b.info(`Lock '${s}': The lockfile is scheduled to have been released.`);n>0;){if(await(0,S.timeout)(Math.min(100,n)),await h(b,s)===0)return f(b,s);n=o.willReleaseAt-Date.now()}return f(b,s)}}if(!w(o.pid))return b.info(`Lock '${s}': The pid ${o.pid} appears to be gone.`),f(b,s);const c=await h(b,s),u=Date.now()-c;if(u<=y)return b.info(`Lock '${s}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null;b.info(`Lock '${s}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const r=await h(b,s),l=Date.now()-r;return l<=y?(b.info(`Lock '${s}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null):(b.info(`Lock '${s}': The lock looks stale even after waiting for 2s.`),f(b,s))}async function f(b,s){b.info(`Lock '${s}': Deleting a stale lock.`);try{await C.Promises.unlink(s)}catch{}return d(b,s,!0)}}),define(Se[280],ye([1,0,30,16,40]),function(te,e,a,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let A=class extends k.BaseExtHostTerminalService{constructor(T){super(!0,T)}createTerminal(T,S,C){return this.createTerminalFromOptions({name:T,shellPath:S,shellArgs:C})}createTerminalFromOptions(T,S){const C=new k.ExtHostTerminal(this.a,(0,a.generateUuid)(),T,T.name);return this.f.push(C),C.create(T,this.L(T,S)),C.value}};A=Ve([We(0,t.IExtHostRpcService)],A),e.ExtHostTerminalService=A}),define(Se[281],ye([1,0,5,16,181,6,25,2,44,24,29,7,12,54,4,129,100,13]),function(te,e,a,t,k,A,D,T,S,C,R,P,E,y,v,d,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.loadListeningPorts=e.getSockets=void 0;class w extends d.DisposableTunnel{}function m(n){const i=n.trim().split(`
`),p=[];return i.forEach(L=>{const U=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(L);U&&U.length>=3&&p.push({pid:parseInt(U[1],10),socket:parseInt(U[2],10)})}),p.reduce((L,U)=>(L[U.socket]=U,L),{})}e.getSockets=m;function f(...n){const i=[].concat(...n.map(s));return[...new Map(i.filter(p=>p.st==="0A").map(p=>{const I=p.local_address.split(":");return{socket:parseInt(p.inode,10),ip:b(I[0]),port:parseInt(I[1],16)}}).map(p=>[p.ip+":"+p.port,p])).values()]}e.loadListeningPorts=f;function b(n){let i="";if(n.length===8)for(let p=n.length-2;p>=0;p-=2)i+=parseInt(n.substr(p,2),16),p!==0&&(i+=".");else for(let p=n.length-4;p>=0;p-=4)i+=parseInt(n.substr(p,4),16).toString(16),p!==0&&(i+=":");return i}function s(n){const i=n.trim().split(`
`),p=i.shift().trim().split(/\s+/).filter(L=>L!=="rx_queue"&&L!=="tm->when");return i.map(L=>L.trim().split(/\s+/).reduce((U,G,V)=>(U[p[V]||V]=G,U),{}))}e.loadConnectionTable=s;function o(n){return!!n.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||n.indexOf("out/server-main.js")!==-1||n.indexOf("_productName=VSCode")!==-1}function c(n){const i=n.trim().split(`
`),p=[];return i.forEach(I=>{const L=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(I);L&&L.length>=4&&p.push({pid:parseInt(L[1],10),ppid:parseInt(L[2]),cmd:L[3]})}),p}e.getRootProcesses=c;async function u(n,i,p){const I=p.reduce((U,G)=>(U[G.pid]=G,U),{}),L=[];return n.forEach(({socket:U,ip:G,port:V})=>{const O=i[U]?i[U].pid:void 0,B=O?I[O]?.cmd:void 0;O&&B&&!o(B)&&L.push({host:G,port:V,detail:B,pid:O})}),L}e.findPorts=u;function r(n,i,p){const I=new Map,L=c(i);for(const U of n){const G=p.get(U.port);if(G){I.set(U.port,G);continue}const V=L.find(O=>O.cmd.includes(`${U.port}`));if(V){let O=V,B;do B=L.find(F=>F.ppid===O.pid),B&&(O=B);while(B);I.set(U.port,{host:U.ip,port:U.port,pid:O.pid,detail:O.cmd,ppid:O.ppid})}else I.set(U.port,{host:U.ip,port:U.port,ppid:Number.MAX_VALUE})}return I}e.tryFindRootPorts=r;let l=class extends A.Disposable{constructor(i,p,I){super(),this.n=I,this.c=()=>Promise.resolve(!0),this.f=new Map,this.g=new v.Emitter,this.onDidChangeTunnels=this.g.event,this.h=!1,this.j=new Map,this.k=0,this.l=new Map,this.a=i.getProxy(a.MainContext.MainThreadTunnelService),E.isLinux&&p.remote.isRemote&&p.remote.authority&&this.a.$setRemoteTunnelService(process.pid)}async openTunnel(i,p){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${p.remoteAddress.host}:${p.remoteAddress.port}.`);const I=await this.a.$openTunnel(p,i.displayName);if(I){const L=new w(I.remoteAddress,I.localAddress,()=>this.a.$closeTunnel(I.remoteAddress));return this.B(L),L}}async getTunnels(){return this.a.$getTunnels()}p(i){return Math.max(i*20,2e3)}r(){return this.k++}registerPortsAttributesProvider(i,p){const I=this.r();return this.l.set(I,{selector:i,provider:p}),this.a.$registerPortsAttributesProvider(i,I),new P.Disposable(()=>{this.l.delete(I),this.a.$unregisterPortsAttributesProvider(I)})}async $providePortAttributes(i,p,I,L,U){const G=[];for(const O of i){const B=this.l.get(O);if(!B)return[];G.push(...await Promise.all(p.map(async F=>B.provider.providePortAttributes(F,I,L,U))))}const V=G.filter(O=>!!O);return V.length>0?V.map(O=>({autoForwardAction:O.autoForwardAction,port:O.port})):[]}async $registerCandidateFinder(i){if(i&&this.h)return;this.h=i;const p=new g.MovingAverage;let I;for(;this.h;){const L=new Date().getTime(),U=(await this.findCandidatePorts()).filter(V=>(0,d.isLocalhost)(V.host)||(0,d.isAllInterfaces)(V.host));this.n.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${U.map(V=>V.port).join(", ")}`);const G=new Date().getTime()-L;p.update(G),(!I||JSON.stringify(I)!==JSON.stringify(U))&&(I=U,await this.a.$onFoundNewCandidates(I)),await new Promise(V=>setTimeout(()=>V(),this.p(p.value)))}}async setTunnelFactory(i){if(i){if(i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.c=i.showCandidatePort,this.a.$setCandidateFilter()),i.tunnelFactory){this.b=i.tunnelFactory;let p=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&p.length===0&&(p=[{id:"private",label:k.localize(0,null),themeIcon:"lock"},{id:"public",label:k.localize(1,null),themeIcon:"eye"}]);const I=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:p}:void 0;this.a.$setTunnelProvider(I)}}else this.b=void 0;return(0,A.toDisposable)(()=>{this.b=void 0})}async $closeTunnel(i,p){if(this.f.has(i.host)){const I=this.f.get(i.host);I.has(i.port)&&(p&&I.get(i.port).disposeListener.dispose(),await I.get(i.port).tunnel.dispose(),I.delete(i.port))}}async $onDidTunnelsChange(){this.g.fire()}async $forwardPort(i,p){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const I=this.b(i,p);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),I!==void 0){const L=await I;this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this.f.has(i.remoteAddress.host)||this.f.set(i.remoteAddress.host,new Map);const U=this.B(L.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(L.remoteAddress))));return this.f.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:L,disposeListener:U}),y.TunnelDtoConverter.fromApiTunnel(L)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(i){const p=await Promise.all(i.map(L=>this.c(L.host,L.port,L.detail??""))),I=i.filter((L,U)=>p[U]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(L=>L.port).join(", ")} to ${I.map(L=>L.port).join(", ")}`),I}async findCandidatePorts(){let i="",p="";try{i=await R.Promises.readFile("/proc/net/tcp","utf8"),p=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const I=f(i,p),L=await new Promise(M=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(H,K,q)=>{M(K)})}),U=m(L),G=await R.Promises.readdir("/proc"),V=[];for(const M of G)try{const H=Number(M),K=C.joinPath(T.URI.file("/proc"),M);if((await R.Promises.stat(K.fsPath)).isDirectory()&&!isNaN(H)){const Y=await R.Promises.readlink(C.joinPath(K,"cwd").fsPath),Q=await R.Promises.readFile(C.joinPath(K,"cmdline").fsPath,"utf8");V.push({pid:H,cwd:Y,cmd:Q})}}catch{}const O=[],B=I.filter(M=>{const H=U[M.socket];return H||O.push(M),H}),F=u(B,U,V);let $;if(this.n.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${O.length}`),O.length>0){const M=await new Promise(H=>{(0,S.exec)("ps -F -A -l | grep root",(K,q,Y)=>{H(q)})});this.j=r(O,M,this.j),$=Array.from(this.j.values()),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${$.join(", ")}`)}return F.then(M=>$?M.concat($):M)}};l=Ve([We(0,t.IExtHostRpcService),We(1,D.IExtHostInitDataService),We(2,h.ILogService)],l),e.ExtHostTunnelService=l}),define(Se[282],ye([1,0,18,22,21,10,4,6,112,241,57]),function(te,e,a,t,k,A,D,T,S,C,R){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function E(I,L){try{return JSON.stringify(I,L)}catch{return"null"}}const y="$$ref$$",v={[y]:-1};class d{constructor(L,U){this.jsonString=L,this.referencedBuffers=U}}function g(I,L=null,U=!1){const G=[];return{jsonString:(U?E:JSON.stringify)(I,(O,B)=>{if(typeof B>"u")return v;if(typeof B=="object"){if(B instanceof t.VSBuffer){const F=G.push(B)-1;return{[y]:F}}if(L)return L(O,B)}return B}),referencedBuffers:G}}e.stringifyJsonWithBufferRefs=g;function h(I,L,U){return JSON.parse(I,(G,V)=>{if(V){const O=V[y];if(typeof O=="number")return L[O];if(U&&V.$mid===1)return U.transformIncoming(V)}return V})}e.parseJsonAndRestoreBufferRefs=h;function w(I,L){return JSON.stringify(I,L)}function m(I){return I?(L,U)=>U&&U.$mid===1?I.transformOutgoing(U):U:null}var f;(function(I){I[I.LocalSide=0]="LocalSide",I[I.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));var b;(function(I){I[I.Responsive=0]="Responsive",I[I.Unresponsive=1]="Unresponsive"})(b=e.ResponsiveState||(e.ResponsiveState={}));const s=()=>{},o=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class u extends T.Disposable{constructor(L,U=null,G=null){super(),this[P]=!0,this.b=this.B(new D.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=L,this.f=U,this.g=G,this.h=m(this.g),this.j=!1,this.k=[],this.l=[];for(let V=0,O=R.ProxyIdentifier.count;V<O;V++)this.k[V]=null,this.l[V]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new a.RunOnceScheduler(()=>this.D(),1e3)),this.c.onMessage(V=>this.H(V))}dispose(){this.j=!0,Object.keys(this.s).forEach(L=>{this.s[L].resolveErr(A.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(L){this.u===0&&(this.v=Date.now()+u.a),this.u++,this.w.isScheduled()||this.w.schedule()}C(L){this.v=Date.now()+u.a,this.u--,this.u===0&&this.w.cancel(),this.F(0)}D(){this.u!==0&&(Date.now()>this.v?this.F(1):this.w.schedule())}F(L){this.t!==L&&(this.t=L,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(L){return this.g?(0,S.transformIncomingURIs)(L,this.g):L}getProxy(L){const{nid:U,sid:G}=L;return this.l[U]||(this.l[U]=this.G(U,G)),this.l[U]}G(L,U){const G={get:(V,O)=>(typeof O=="string"&&!V[O]&&O.charCodeAt(0)===36&&(V[O]=(...B)=>this.P(L,O,B)),O===c?U:V[O])};return new Proxy(Object.create(null),G)}set(L,U){return this.k[L.nid]=U,U}assertRegistered(L){for(let U=0,G=L.length;U<G;U++){const V=L[U];if(!this.k[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}H(L){if(this.j)return;const U=L.byteLength,G=r.read(L,0),V=G.readUInt8(),O=G.readUInt32();switch(V){case 1:case 2:{let{rpcId:B,method:F,args:$}=n.deserializeRequestJSONArgs(G);this.g&&($=(0,S.transformIncomingURIs)($,this.g)),this.I(U,O,B,F,$,V===2);break}case 3:case 4:{let{rpcId:B,method:F,args:$}=n.deserializeRequestMixedArgs(G);this.g&&($=(0,S.transformIncomingURIs)($,this.g)),this.I(U,O,B,F,$,V===4);break}case 5:{this.f?.logIncoming(U,O,0,"ack"),this.C(O);break}case 6:{this.J(U,O);break}case 7:{this.L(U,O,void 0);break}case 9:{let B=n.deserializeReplyOKJSON(G);this.g&&(B=(0,S.transformIncomingURIs)(B,this.g)),this.L(U,O,B);break}case 10:{const B=n.deserializeReplyOKJSONWithBuffers(G,this.g);this.L(U,O,B);break}case 8:{const B=n.deserializeReplyOKVSBuffer(G);this.L(U,O,B);break}case 11:{let B=n.deserializeReplyErrError(G);this.g&&(B=(0,S.transformIncomingURIs)(B,this.g)),this.M(U,O,B);break}case 12:{this.M(U,O,void 0);break}default:console.error("received unexpected message"),console.error(L)}}I(L,U,G,V,O,B){this.f?.logIncoming(L,U,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(G)}.${V}(`,O);const F=String(U);let $,M;if(B){const K=new k.CancellationTokenSource;O.push(K.token),$=this.N(G,V,O),M=()=>K.cancel()}else $=this.N(G,V,O),M=s;this.p[F]=M;const H=n.serializeAcknowledged(U);this.f?.logOutgoing(H.byteLength,U,1,"ack"),this.c.send(H),$.then(K=>{delete this.p[F];const q=n.serializeReplyOK(U,K,this.h);this.f?.logOutgoing(q.byteLength,U,1,"reply:",K),this.c.send(q)},K=>{delete this.p[F];const q=n.serializeReplyErr(U,K);this.f?.logOutgoing(q.byteLength,U,1,"replyErr:",K),this.c.send(q)})}J(L,U){this.f?.logIncoming(L,U,1,"receiveCancel");const G=String(U);this.p[G]?.()}L(L,U,G){this.f?.logIncoming(L,U,0,"receiveReply:",G);const V=String(U);if(!this.s.hasOwnProperty(V))return;const O=this.s[V];delete this.s[V],O.resolveOk(G)}M(L,U,G){this.f?.logIncoming(L,U,0,"receiveReplyErr:",G);const V=String(U);if(!this.s.hasOwnProperty(V))return;const O=this.s[V];delete this.s[V];let B;G&&(G.$isError?(B=new Error,B.name=G.name,B.message=G.message,B.stack=G.stack):B=G),O.resolveErr(B)}N(L,U,G){try{return Promise.resolve(this.O(L,U,G))}catch(V){return Promise.reject(V)}}O(L,U,G){const V=this.k[L];if(!V)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(L));const O=V[U];if(typeof O!="function")throw new Error("Unknown method "+U+" on actor "+(0,R.getStringIdentifierForProxy)(L));return O.apply(V,G)}P(L,U,G){if(this.j)return new C.CanceledLazyPromise;let V=null;if(G.length>0&&k.CancellationToken.isCancellationToken(G[G.length-1])&&(V=G.pop()),V&&V.isCancellationRequested)return Promise.reject(A.canceled());const O=n.serializeRequestArguments(G,this.h),B=++this.m,F=String(B),$=new C.LazyPromise;V&&V.onCancellationRequested(()=>{const H=n.serializeCancel(B);this.f?.logOutgoing(H.byteLength,B,0,"cancel"),this.c.send(n.serializeCancel(B))}),this.s[F]=$,this.y(B);const M=n.serializeRequest(B,L,U,O,!!V);return this.f?.logOutgoing(M.byteLength,B,0,`request: ${(0,R.getStringIdentifierForProxy)(L)}.${U}(`,G),this.c.send(M),$}}e.RPCProtocol=u,P=o,u.a=3*1e3;class r{static alloc(L,U,G){const V=new r(t.VSBuffer.alloc(G+1+4),0);return V.writeUInt8(L),V.writeUInt32(U),V}static read(L,U){return new r(L,U)}get buffer(){return this.a}constructor(L,U){this.a=L,this.b=U}static sizeUInt8(){return 1}writeUInt8(L){this.a.writeUInt8(L,this.b),this.b+=1}readUInt8(){const L=this.a.readUInt8(this.b);return this.b+=1,L}writeUInt32(L){this.a.writeUInt32BE(L,this.b),this.b+=4}readUInt32(){const L=this.a.readUInt32BE(this.b);return this.b+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this.a.writeUInt8(L.byteLength,this.b),this.b+=1,this.a.set(L,this.b),this.b+=L.byteLength}readShortString(){const L=this.a.readUInt8(this.b);this.b+=1;const G=this.a.slice(this.b,this.b+L).toString();return this.b+=L,G}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readLongString(){const L=this.a.readUInt32BE(this.b);this.b+=4;const G=this.a.slice(this.b,this.b+L).toString();return this.b+=L,G}writeBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readVSBuffer(){const L=this.a.readUInt32BE(this.b);this.b+=4;const U=this.a.slice(this.b,this.b+L);return this.b+=L,U}static sizeMixedArray(L){let U=0;U+=1;for(let G=0,V=L.length;G<V;G++){const O=L[G];switch(U+=1,O.type){case 1:U+=this.sizeLongString(O.value);break;case 2:U+=this.sizeVSBuffer(O.value);break;case 3:U+=this.sizeUInt32,U+=this.sizeLongString(O.value);for(let B=0;B<O.buffers.length;++B)U+=this.sizeVSBuffer(O.buffers[B]);break;case 4:break}}return U}writeMixedArray(L){this.a.writeUInt8(L.length,this.b),this.b+=1;for(let U=0,G=L.length;U<G;U++){const V=L[U];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let O=0;O<V.buffers.length;++O)this.writeBuffer(V.buffers[O]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const L=this.a.readUInt8(this.b);this.b+=1;const U=new Array(L);for(let G=0;G<L;G++)switch(this.readUInt8()){case 1:U[G]=this.readLongString();break;case 2:U[G]=this.readVSBuffer();break;case 3:{const O=this.readUInt32(),B=this.readLongString(),F=[];for(let $=0;$<O;++$)F.push(this.readVSBuffer());U[G]=new R.SerializableObjectWithBuffers(h(B,F,null));break}case 4:U[G]=void 0;break}return U}}r.sizeUInt32=4;var l;(function(I){I[I.Simple=0]="Simple",I[I.Mixed=1]="Mixed"})(l||(l={}));class n{static a(L){for(let U=0,G=L.length;U<G;U++)if(L[U]instanceof t.VSBuffer||L[U]instanceof R.SerializableObjectWithBuffers||typeof L[U]>"u")return!0;return!1}static serializeRequestArguments(L,U){if(this.a(L)){const G=[];for(let V=0,O=L.length;V<O;V++){const B=L[V];if(B instanceof t.VSBuffer)G[V]={type:2,value:B};else if(typeof B>"u")G[V]={type:4};else if(B instanceof R.SerializableObjectWithBuffers){const{jsonString:F,referencedBuffers:$}=g(B.value,U);G[V]={type:3,value:t.VSBuffer.fromString(F),buffers:$}}else G[V]={type:1,value:t.VSBuffer.fromString(w(B,U))}}return{type:1,args:G}}return{type:0,args:w(L,U)}}static serializeRequest(L,U,G,V,O){switch(V.type){case 0:return this.b(L,U,G,V.args,O);case 1:return this.c(L,U,G,V.args,O)}}static b(L,U,G,V,O){const B=t.VSBuffer.fromString(G),F=t.VSBuffer.fromString(V);let $=0;$+=r.sizeUInt8(),$+=r.sizeShortString(B),$+=r.sizeLongString(F);const M=r.alloc(O?2:1,L,$);return M.writeUInt8(U),M.writeShortString(B),M.writeLongString(F),M.buffer}static deserializeRequestJSONArgs(L){const U=L.readUInt8(),G=L.readShortString(),V=L.readLongString();return{rpcId:U,method:G,args:JSON.parse(V)}}static c(L,U,G,V,O){const B=t.VSBuffer.fromString(G);let F=0;F+=r.sizeUInt8(),F+=r.sizeShortString(B),F+=r.sizeMixedArray(V);const $=r.alloc(O?4:3,L,F);return $.writeUInt8(U),$.writeShortString(B),$.writeMixedArray(V),$.buffer}static deserializeRequestMixedArgs(L){const U=L.readUInt8(),G=L.readShortString(),V=L.readMixedArray(),O=new Array(V.length);for(let B=0,F=V.length;B<F;B++){const $=V[B];typeof $=="string"?O[B]=JSON.parse($):O[B]=$}return{rpcId:U,method:G,args:O}}static serializeAcknowledged(L){return r.alloc(5,L,0).buffer}static serializeCancel(L){return r.alloc(6,L,0).buffer}static serializeReplyOK(L,U,G){if(typeof U>"u")return this.d(L);if(U instanceof t.VSBuffer)return this.e(L,U);if(U instanceof R.SerializableObjectWithBuffers){const{jsonString:V,referencedBuffers:O}=g(U.value,G,!0);return this.g(L,V,O)}else return this.f(L,E(U,G))}static d(L){return r.alloc(7,L,0).buffer}static e(L,U){let G=0;G+=r.sizeVSBuffer(U);const V=r.alloc(8,L,G);return V.writeVSBuffer(U),V.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static f(L,U){const G=t.VSBuffer.fromString(U);let V=0;V+=r.sizeLongString(G);const O=r.alloc(9,L,V);return O.writeLongString(G),O.buffer}static g(L,U,G){const V=t.VSBuffer.fromString(U);let O=0;O+=r.sizeUInt32,O+=r.sizeLongString(V);for(const F of G)O+=r.sizeVSBuffer(F);const B=r.alloc(10,L,O);B.writeUInt32(G.length),B.writeLongString(V);for(const F of G)B.writeBuffer(F);return B.buffer}static deserializeReplyOKJSON(L){const U=L.readLongString();return JSON.parse(U)}static deserializeReplyOKJSONWithBuffers(L,U){const G=L.readUInt32(),V=L.readLongString(),O=[];for(let B=0;B<G;++B)O.push(L.readVSBuffer());return new R.SerializableObjectWithBuffers(h(V,O,U))}static serializeReplyErr(L,U){const G=U?E(A.transformErrorForSerialization(U),null):void 0;if(typeof G!="string")return this.h(L);const V=t.VSBuffer.fromString(G);let O=0;O+=r.sizeLongString(V);const B=r.alloc(11,L,O);return B.writeLongString(V),B.buffer}static deserializeReplyErrError(L){const U=L.readLongString();return JSON.parse(U)}static h(L){return r.alloc(12,L,0).buffer}}var i;(function(I){I[I.RequestJSONArgs=1]="RequestJSONArgs",I[I.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",I[I.RequestMixedArgs=3]="RequestMixedArgs",I[I.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",I[I.Acknowledged=5]="Acknowledged",I[I.Cancel=6]="Cancel",I[I.ReplyOKEmpty=7]="ReplyOKEmpty",I[I.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",I[I.ReplyOKJSON=9]="ReplyOKJSON",I[I.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",I[I.ReplyErrError=11]="ReplyErrError",I[I.ReplyErrEmpty=12]="ReplyErrEmpty"})(i||(i={}));var p;(function(I){I[I.String=1]="String",I[I.VSBuffer=2]="VSBuffer",I[I.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",I[I.Undefined=4]="Undefined"})(p||(p={}))}),define(Se[283],ye([1,0,4,43,53,3,38,10,18]),function(te,e,a,t,k,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new k.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new k.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new k.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,A.createDecorator)(e.OUTPUT_SERVICE_ID);var C;(function(y){y[y.Append=1]="Append",y[y.Replace=2]="Replace",y[y.Clear=3]="Clear"})(C=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.a=new Map,this.b=new a.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new a.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(v){this.a.has(v.id)||(this.a.set(v.id,v),this.b.fire(v.id))}getChannels(){const v=[];return this.a.forEach(d=>v.push(d)),v}getChannel(v){return this.a.get(v)}removeChannel(v){this.a.delete(v),this.c.fire(v)}}t.Registry.add(e.Extensions.OutputChannels,new R);function P(y,v,d,g,h){return(0,S.createCancelablePromise)(async w=>{await(0,D.whenProviderRegistered)(d,g);const m=t.Registry.as(e.Extensions.OutputChannels);try{await E(d,1,g,h,w),m.registerChannel({id:y,label:v,file:d,log:!0})}catch(f){(0,T.isCancellationError)(f)||h.error("Error while registering log channel",d.toString(),(0,T.getErrorMessage)(f))}})}e.registerLogChannel=P;async function E(y,v,d,g,h){if(!await d.exists(y)){if(h.isCancellationRequested)throw new T.CancellationError;if(v>10)throw new Error("Timed out while waiting for file to be created");g.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",y.toString()),await(0,S.timeout)(1e3,h),await E(y,v+1,d,g,h)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new k.RawContextKey("activeOutputChannel","")}),define(Se[141],ye([1,0,5,3,16,27,13,283,70,25,46,155,22,11,38,4,6]),function(te,e,a,t,k,A,D,T,S,C,R,P,E,y,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class h extends D.AbstractMessageLogger{get disposed(){return this.k}constructor(b,s,o,c,u){super(),this.id=b,this.name=s,this.l=o,this.m=c,this.extension=u,this.j=0,this.k=!1,this.visible=!1,this.B(o.onDidChangeLogLevel(r=>this.setLevel(r)))}get logLevel(){return this.l.getLevel()}appendLine(b){this.append(b+`
`)}append(b){this.info(b)}clear(){const b=this.j;this.l.flush(),this.m.$update(this.id,T.OutputChannelUpdateMode.Clear,b)}replace(b){const s=this.j;this.info(b),this.m.$update(this.id,T.OutputChannelUpdateMode.Replace,s),this.visible&&this.l.flush()}show(b,s){this.l.flush(),this.m.$reveal(this.id,!!(typeof b=="boolean"?b:s))}hide(){this.m.$close(this.id)}f(b,s){this.j+=E.VSBuffer.fromString(s).byteLength,(0,D.log)(this.l,b,s),this.visible&&(this.l.flush(),this.m.$update(this.id,T.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.k||(this.m.$dispose(this.id),this.k=!0)}}class w extends h{appendLine(b){this.append(b)}}let m=class{constructor(b,s,o,c,u,r){this.i=s,this.j=o,this.k=c,this.l=u,this.m=r,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=b.getProxy(a.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(s.logsLocation,`output_logging_${(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(b){this.h=b;for(const[s,o]of this.g)o.visible=s===this.h}createOutputChannel(b,s,o){if(b=b.trim(),!b)throw new Error("illegal argument `name`. must not be falsy");const c=typeof s=="object"&&s.log,u=(0,y.isString)(s)?s:void 0;if((0,y.isString)(u)&&!u.trim())throw new Error("illegal argument `languageId`. must not be empty");let r;const l=this.i.environment.extensionLogLevel?.find(([i])=>A.ExtensionIdentifier.equals(o.identifier,i))?.[1];l&&(r=(0,D.parseLogLevel)(l));const n=c?this.o(b,r,o):this.n(b,u,o);return n.then(i=>{this.g.set(i.id,i),i.visible=i.id===this.h}),c?this.r(b,r??this.m.getLevel(),n):this.q(b,n)}async n(b,s,o){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const c=await this.c,u=this.k.extUri.joinPath(c,`${this.f++}-${b.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=this.l.createLogger(u,{always:!0,donotRotate:!0,donotUseFormatters:!0}),l=await this.a.$register(b,u,!1,s,o.identifier.value);return new h(l,b,r,this.a,o)}async o(b,s,o){const c=await this.p(o),u=this.k.extUri.joinPath(c,`${b.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=this.l.createLogger(u,{name:b},s),l=await this.a.$register(b,u,!0,void 0,o.identifier.value);return new w(l,b,r,this.a,o)}p(b){let s=this.d.get(b.identifier.value);if(!s){const o=this.k.extUri.joinPath(this.i.logsLocation,b.identifier.value);this.d.set(b.identifier.value,s=(async()=>{try{await this.j.value.createDirectory(o)}catch(c){if((0,v.toFileSystemProviderErrorCode)(c)!==v.FileSystemProviderErrorCode.FileExists)throw c}return o})())}return s}q(b,s){let o=!1;const c=()=>{if(o)throw new Error("Channel has been closed")};return{get name(){return b},append(u){c(),s.then(r=>r.append(u))},appendLine(u){c(),s.then(r=>r.appendLine(u))},clear(){c(),s.then(u=>u.clear())},replace(u){c(),s.then(r=>r.replace(u))},show(u,r){c(),s.then(l=>l.show(u,r))},hide(){c(),s.then(u=>u.hide())},dispose(){o=!0,s.then(u=>u.dispose())}}}r(b,s,o){const c=new g.DisposableStore,u=()=>{if(c.isDisposed)throw new Error("Channel has been closed")},r=c.add(new d.Emitter);return o.then(l=>{c.add(l),c.add(l.onDidChangeLogLevel(n=>{s=n,r.fire(n)}))}),{...this.q(b,o),get logLevel(){return s},onDidChangeLogLevel:r.event,trace(l,...n){u(),o.then(i=>i.trace(l,...n))},debug(l,...n){u(),o.then(i=>i.debug(l,...n))},info(l,...n){u(),o.then(i=>i.info(l,...n))},warn(l,...n){u(),o.then(i=>i.warn(l,...n))},error(l,...n){u(),o.then(i=>i.error(l,...n))},dispose(){c.dispose()}}}};m=Ve([We(0,k.IExtHostRpcService),We(1,C.IExtHostInitDataService),We(2,S.IExtHostConsumerFileSystem),We(3,R.IExtHostFileSystemInfo),We(4,D.ILoggerService),We(5,D.ILogService)],m),e.ExtHostOutputService=m,e.IExtHostOutputService=(0,t.createDecorator)("IExtHostOutputService")}),define(Se[284],ye([1,0,3]),function(te,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,a.createDecorator)("remoteAgentService")}),define(Se[285],ye([1,0,32,15,9,12,24,2,3,210,45,227,284]),function(te,e,a,t,k,A,D,T,S,C,R,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let y=class ri{constructor(d,g,h,w){this.d=d,this.e=g,this.f=h,this.g=w,this.a=(async()=>(await this.e.getEnvironment())?.os||A.OS)(),this.b=(async()=>{const m=await this.e.getEnvironment();return this.c=m?.userHome??d})()}hasValidBasename(d,g,h){return typeof g=="string"||typeof g>"u"?this.a.then(w=>this.h(d,w,g)):this.h(d,g,h)}h(d,g,h){return d.scheme===t.Schemas.file||d.scheme===t.Schemas.vscodeRemote?(0,a.isValidBasename)(h??(0,D.basename)(d),g===1):!0}get defaultUriScheme(){return ri.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(d,g){if(d.remoteAuthority)return t.Schemas.vscodeRemote;const h=(0,C.getVirtualWorkspaceScheme)(g.getWorkspace());if(h)return h;const w=g.getWorkspace().folders[0];if(w)return w.uri.scheme;const m=g.getWorkspace().configuration;return m?m.scheme:t.Schemas.file}userHome(d){return d?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(d=>d===1?k.win32:k.posix)}async fileURI(d){let g="";if(await this.a===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const w=d.indexOf("/",2);w===-1?(g=d.substring(2),d="/"):(g=d.substring(2,w),d=d.substring(w)||"/")}return T.URI.from({scheme:t.Schemas.file,authority:g,path:d,query:"",fragment:""})}};y=Ve([We(1,E.IRemoteAgentService),We(2,P.IWorkbenchEnvironmentService),We(3,R.IWorkspaceContextService)],y),e.AbstractPathService=y}),define(Se[73],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class a{constructor(D,T){this.line=D,this.character=T}isBefore(D){return!1}isBeforeOrEqual(D){return!1}isAfter(D){return!1}isAfterOrEqual(D){return!1}isEqual(D){return!1}compareTo(D){return 0}translate(D,T){return new a(0,0)}with(D){return new a(0,0)}}e.Position=a;class t{constructor(D,T,S,C){this.isEmpty=!1,this.isSingleLine=!1,this.start=new a(D,T),this.end=new a(S,C)}contains(D){return!1}isEqual(D){return!1}intersection(D){}union(D){return new t(0,0,0,0)}with(D){return new t(0,0,0,0)}}e.Range=t;var k;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(k=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Se[31],ye([1,0,17,37,23,32,8,3,9,10,73,18]),function(te,e,a,t,k,A,D,T,S,C,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const E="\u27EA ",y=" characters skipped \u27EB",v=(E.length+y.length+5)*2;e.ISearchService=(0,T.createDecorator)("searchService");var d;(function(Q){Q[Q.file=0]="file",Q[Q.text=1]="text"})(d=e.SearchProviderType||(e.SearchProviderType={}));var g;(function(Q){Q[Q.File=1]="File",Q[Q.Text=2]="Text"})(g=e.QueryType||(e.QueryType={}));function h(Q){return!!Q.preview}e.resultIsMatch=h;function w(Q){return!!Q.resource}e.isFileMatch=w;function m(Q){return!!Q.message}e.isProgressMessage=m;var f;(function(Q){Q[Q.Normal=0]="Normal",Q[Q.NewSearchStarted=1]="NewSearchStarted"})(f=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class b{constructor(ce){this.resource=ce,this.results=[]}}e.FileMatch=b;class s{constructor(ce,ie,de){this.ranges=ie;const J=Array.isArray(ie)?ie:[ie];if(de&&de.matchLines===1&&o(J)){ce=(0,D.getNLines)(ce,de.matchLines);let pe="",ve=0,De=0;const Re=Math.floor(de.charsPerLine/5),$e=[];for(const re of J){const le=Math.max(re.startColumn-Re,0),fe=re.startColumn+de.charsPerLine;if(le>De+Re+v){const Z=E+(le-De)+y;pe+=Z+ce.slice(le,fe),ve+=le-(De+Z.length)}else pe+=ce.slice(De,fe);$e.push(new u(0,re.startColumn-ve,re.endColumn-ve)),De=fe}this.preview={text:pe,matches:Array.isArray(this.ranges)?$e:$e[0]}}else{const pe=Array.isArray(ie)?ie[0].startLineNumber:ie.startLineNumber;this.preview={text:ce,matches:(0,a.mapArrayOrNot)(ie,ve=>new c(ve.startLineNumber-pe,ve.startColumn,ve.endLineNumber-pe,ve.endColumn))}}}}e.TextSearchMatch=s;function o(Q){const ce=Q[0].startLineNumber;for(const ie of Q)if(ie.startLineNumber!==ce||ie.endLineNumber!==ce)return!1;return!0}class c{constructor(ce,ie,de,J){this.startLineNumber=ce,this.startColumn=ie,this.endLineNumber=de,this.endColumn=J}}e.SearchRange=c;class u extends c{constructor(ce,ie,de){super(ce,ie,ce,de)}}e.OneLineRange=u;var r;(function(Q){Q.List="list",Q.Tree="tree"})(r=e.ViewMode||(e.ViewMode={}));var l;(function(Q){Q.Default="default",Q.FileNames="fileNames",Q.Type="type",Q.Modified="modified",Q.CountDescending="countDescending",Q.CountAscending="countAscending"})(l=e.SearchSortOrder||(e.SearchSortOrder={}));function n(Q,ce=!0){const ie=Q&&Q.files&&Q.files.exclude,de=ce&&Q&&Q.search&&Q.search.exclude;if(!ie&&!de)return;if(!ie||!de)return ie||de;let J=Object.create(null);return J=k.mixin(J,k.deepClone(ie)),J=k.mixin(J,k.deepClone(de),!0),J}e.getExcludes=n;function i(Q,ce){return Q.excludePattern&&t.match(Q.excludePattern,ce)?!1:Q.includePattern||Q.usingSearchPaths?Q.includePattern&&t.match(Q.includePattern,ce)?!0:Q.usingSearchPaths?!!Q.folderQueries&&Q.folderQueries.some(ie=>{const de=ie.folder.fsPath;if(A.isEqualOrParent(ce,de)){const J=S.relative(de,ce);return!ie.includePattern||!!t.match(ie.includePattern,J)}else return!1}):!1:!0}e.pathIncludedInQuery=i;var p;(function(Q){Q[Q.unknownEncoding=1]="unknownEncoding",Q[Q.regexParseError=2]="regexParseError",Q[Q.globParseError=3]="globParseError",Q[Q.invalidLiteral=4]="invalidLiteral",Q[Q.rgProcessError=5]="rgProcessError",Q[Q.other=6]="other",Q[Q.canceled=7]="canceled"})(p=e.SearchErrorCode||(e.SearchErrorCode={}));class I extends Error{constructor(ce,ie){super(ce),this.code=ie}}e.SearchError=I;function L(Q){const ce=Q.message;if((0,C.isCancellationError)(Q))return new I(ce,p.canceled);try{const ie=JSON.parse(ce);return new I(ie.message,ie.code)}catch{return new I(ce,p.other)}}e.deserializeSearchError=L;function U(Q){const ce={message:Q.message,code:Q.code};return new Error(JSON.stringify(ce))}e.serializeSearchError=U;function G(Q){return Q.type==="error"?!0:Q.type==="success"}e.isSerializedSearchComplete=G;function V(Q){return Q.type==="success"}e.isSerializedSearchSuccess=V;function O(Q){return!!Q.path}e.isSerializedFileMatch=O;function B(Q,ce){const ie=Q.searchPath?Q.searchPath:Q.relativePath;return(0,D.fuzzyContains)(ie,ce)}e.isFilePatternMatch=B;class F{constructor(ce){this.path=ce,this.results=[]}addMatch(ce){this.results.push(ce)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=F;function $(Q,ce){const ie={...Q||{},...ce||{}};return Object.keys(ie).filter(de=>{const J=ie[de];return typeof J=="boolean"&&J})}e.resolvePatternsForProvider=$;class M{constructor(ce,ie){this.c=null,this.a={...ce.excludePattern||{},...ie.excludePattern||{}},this.b=t.parse(this.a);let de=ce.includePattern;ie.includePattern&&(de?de={...de,...ie.includePattern}:de=ie.includePattern),de&&(this.c=t.parse(de))}matchesExcludesSync(ce,ie,de){return!!(this.b&&this.b(ce,ie,de))}includedInQuerySync(ce,ie,de){return!(this.b&&this.b(ce,ie,de)||this.c&&!this.c(ce,ie,de))}includedInQuery(ce,ie,de){const J=this.b(ce,ie,de),pe=()=>this.c?!!this.c(ce,ie,de):!0;return(0,P.isThenable)(J)?J.then(ve=>ve?!1:pe()):pe()}hasSiblingExcludeClauses(){return H(this.a)}}e.QueryGlobTester=M;function H(Q){for(const ce in Q)if(typeof Q[ce]!="boolean")return!0;return!1}function K(Q){if(!Q)return;let ce;return ie=>(ce||(ce=(Q()||Promise.resolve([])).then(de=>de?Y(de):{})),ce.then(de=>!!de[ie]))}e.hasSiblingPromiseFn=K;function q(Q){if(!Q)return;let ce;return ie=>{if(!ce){const de=Q();ce=de?Y(de):{}}return!!ce[ie]}}e.hasSiblingFn=q;function Y(Q){const ce={};for(const ie of Q)ce[ie]=!0;return ce}}),define(Se[33],ye([1,0,17,18,21,4,6,64,15,100,24,8,11,2,179,3,13,199,45,46,25,16,14,7,55,31,5]),function(te,e,a,t,k,A,D,T,S,C,R,P,E,y,v,d,g,h,w,m,f,b,s,o,c,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function l(V,O,B){return new R.ExtUri(F=>I(F,B)).isEqual(V,O)}function n(V,O,B){return l(V.uri,O.uri,B)?0:(0,P.compare)(V.uri.toString(),O.uri.toString())}function i(V,O,B){return V.index!==O.index?V.index<O.index?-1:1:l(V.uri,O.uri,B)?(0,P.compare)(V.name,O.name):(0,P.compare)(V.uri.toString(),O.uri.toString())}function p(V,O,B,F){const $=V.slice(0).sort((H,K)=>B(H,K,F)),M=O.slice(0).sort((H,K)=>B(H,K,F));return(0,a.delta)($,M,(H,K)=>B(H,K,F))}function I(V,O){const B=O.getCapabilities(V.scheme);return!(B&&B&1024)}class L extends w.Workspace{static toExtHostWorkspace(O,B,F,$){if(!O)return{workspace:null,added:[],removed:[]};const{id:M,name:H,folders:K,configuration:q,transient:Y,isUntitled:Q}=O,ce=[],ie=B;B?K.forEach((ve,De)=>{const Re=y.URI.revive(ve.uri),$e=L.e(F||B,Re,$);$e?($e.name=ve.name,$e.index=ve.index,ce.push($e)):ce.push({uri:Re,name:ve.name,index:De})}):ce.push(...K.map(({uri:ve,name:De,index:Re})=>({uri:y.URI.revive(ve),name:De,index:Re}))),ce.sort((ve,De)=>ve.index<De.index?-1:1);const de=new L(M,H,ce,!!Y,q?y.URI.revive(q):null,!!Q,ve=>I(ve,$)),{added:J,removed:pe}=p(ie?ie.workspaceFolders:[],de.workspaceFolders,n,$);return{workspace:de,added:J,removed:pe}}static e(O,B,F){for(let $=0;$<O.folders.length;$++){const M=O.workspaceFolders[$];if(l(M.uri,B,F))return M}}constructor(O,B,F,$,M,H,K){super(O,F.map(q=>new w.WorkspaceFolder(q)),$,M,K),this.s=B,this.t=H,this.o=[],this.q=T.TernarySearchTree.forUris(K),F.forEach(q=>{this.o.push(q),this.q.set(q.uri,q)})}get name(){return this.s}get isUntitled(){return this.t}get workspaceFolders(){return this.o.slice(0)}getWorkspaceFolder(O,B){return B&&this.q.get(O)&&(O=(0,R.dirname)(O)),this.q.findSubstr(O)}resolveWorkspaceFolder(O){return this.q.get(O)}}let U=class{constructor(O,B,F,$,M){this.c=new A.Emitter,this.onDidChangeWorkspace=this.c.event,this.e=new A.Emitter,this.onDidGrantWorkspaceTrust=this.e.event,this.t=[],this.u=!1,this.v=new Map,this.y=0,this.g=$,this.q=F,this.s=M,this.h=new C.Counter,this.j=new t.Barrier,this.n=O.getProxy(r.MainContext.MainThreadWorkspace),this.o=O.getProxy(r.MainContext.MainThreadMessageService);const H=B.workspace;this.k=H?new L(H.id,H.name,[],!!H.transient,H.configuration?y.URI.revive(H.configuration):null,!!H.isUntitled,K=>I(K,F)):void 0}$initializeWorkspace(O,B){this.u=B,this.$acceptWorkspaceData(O),this.j.open()}waitForInitializeCall(){return this.j.wait()}get workspace(){return this.w}get name(){return this.w?this.w.name:void 0}get workspaceFile(){if(this.w&&this.w.configuration)return this.w.isUntitled?y.URI.from({scheme:S.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this.w.configuration))}):this.w.configuration}get w(){return this.l||this.k}getWorkspaceFolders(){if(!!this.w)return this.w.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.j.wait(),!!this.w)return this.w.workspaceFolders.slice(0)}updateWorkspaceFolders(O,B,F,...$){const M=[];if(Array.isArray($)&&$.forEach(Q=>{y.URI.isUri(Q.uri)&&!M.some(ce=>l(ce.uri,Q.uri,this.q))&&M.push({uri:Q.uri,name:Q.name||(0,R.basenameOrAuthority)(Q.uri)})}),this.l||[B,F].some(Q=>typeof Q!="number"||Q<0)||F===0&&M.length===0)return!1;const H=this.w?this.w.workspaceFolders:[];if(B+F>H.length)return!1;const K=H.slice(0);K.splice(B,F,...M.map(Q=>({uri:Q.uri,name:Q.name||(0,R.basenameOrAuthority)(Q.uri),index:void 0})));for(let Q=0;Q<K.length;Q++){const ce=K[Q];if(K.some((ie,de)=>de!==Q&&l(ce.uri,ie.uri,this.q)))return!1}K.forEach((Q,ce)=>Q.index=ce);const{added:q,removed:Y}=p(H,K,i,this.q);if(q.length===0&&Y.length===0)return!1;if(this.n){const Q=O.displayName||O.name;this.n.$updateWorkspaceFolders(Q,B,F,M).then(void 0,ce=>{this.l=void 0;const ie={source:{identifier:O.identifier,label:O.displayName||O.name}};this.o.$showMessage(h.Severity.Error,(0,v.localize)(0,null,Q,ce.toString()),ie,[])})}return this.x(K),!0}getWorkspaceFolder(O,B){if(!!this.w)return this.w.getWorkspaceFolder(O,B)}async getWorkspaceFolder2(O,B){if(await this.j.wait(),!!this.w)return this.w.getWorkspaceFolder(O,B)}async resolveWorkspaceFolder(O){if(await this.j.wait(),!!this.w)return this.w.resolveWorkspaceFolder(O)}getPath(){if(!this.w)return;const{folders:O}=this.w;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,B){let F,$="";if(typeof O=="string"?(F=y.URI.file(O),$=O):typeof O<"u"&&(F=O,$=O.fsPath),!F)return $;const M=this.getWorkspaceFolder(F,!0);if(!M)return $;typeof B>"u"&&this.w&&(B=this.w.folders.length>1);let H=(0,R.relativePath)(M.uri,F);return B&&M.name&&(H=`${M.name}/${H}`),H}x(O){this.w&&(this.l=L.toExtHostWorkspace({id:this.w.id,name:this.w.name,configuration:this.w.configuration,folders:O,isUntitled:this.w.isUntitled},this.w,void 0,this.q).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:B,added:F,removed:$}=L.toExtHostWorkspace(O,this.k,this.l,this.q);this.k=B||void 0,this.l=void 0,this.c.fire(Object.freeze({added:F,removed:$}))}findFiles(O,B,F,$,M=k.CancellationToken.None){this.g.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${$.value}, entryPoint: findFiles`);let H;if(B===null?H=!1:B&&(typeof B=="string"?H=B:H=B.pattern),M&&M.isCancellationRequested)return Promise.resolve([]);const{includePattern:K,folder:q}=G(s.GlobPattern.from(O));return this.n.$startFileSearch((0,E.withUndefinedAsNull)(K),(0,E.withUndefinedAsNull)(q),(0,E.withUndefinedAsNull)(H),(0,E.withUndefinedAsNull)(F),M).then(Y=>Array.isArray(Y)?Y.map(Q=>y.URI.revive(Q)):[])}async findTextInFiles(O,B,F,$,M=k.CancellationToken.None){this.g.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${$.value}, entryPoint: findTextInFiles`);const H=this.h.getNext(),K=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:q,folder:Y}=G(s.GlobPattern.from(B.include)),Q=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,ce={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:K,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:q,excludePattern:Q},ie=!1;if(this.t[H]=de=>{if(ie)return;const J=y.URI.revive(de.resource);de.results.forEach(pe=>{(0,u.resultIsMatch)(pe)?F({uri:J,preview:{text:pe.preview.text,matches:(0,a.mapArrayOrNot)(pe.preview.matches,ve=>new o.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,a.mapArrayOrNot)(pe.ranges,ve=>new o.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):F({uri:J,text:pe.text,lineNumber:pe.lineNumber})})},M.isCancellationRequested)return{};try{const de=await this.n.$startTextSearch(O,(0,E.withUndefinedAsNull)(Y),ce,H,M);return delete this.t[H],de||{}}catch(de){throw delete this.t[H],de}}$handleTextSearchResult(O,B){this.t[B]?.(O)}saveAll(O){return this.n.$saveAll(O)}resolveProxy(O){return this.n.$resolveProxy(O)}get trusted(){return this.u}requestWorkspaceTrust(O){return this.n.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this.u||(this.u=!0,this.e.fire())}registerEditSessionIdentityProvider(O,B){if(this.v.has(O))throw new Error(`A provider has already been registered for scheme ${O}`);this.v.set(O,B);const F=this.s.transformOutgoingScheme(O),$=this.y++;return this.n.$registerEditSessionIdentityProvider($,F),(0,D.toDisposable)(()=>{this.v.delete(O),this.n.$unregisterEditSessionIdentityProvider($)})}async $getEditSessionIdentifier(O,B){this.g.info("Getting edit session identifier for workspaceFolder",O);const F=await this.resolveWorkspaceFolder(y.URI.revive(O));if(!F){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const $=this.v.get(F.uri.scheme);if(this.g.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!$),!$)return;const M=await $.provideEditSessionIdentity(F,B);if(this.g.info("Provider returned edit session identifier: ",M),!!M)return M}async $provideEditSessionIdentityMatch(O,B,F,$){this.g.info("Getting edit session identifier for workspaceFolder",O);const M=await this.resolveWorkspaceFolder(y.URI.revive(O));if(!M){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const H=this.v.get(M.uri.scheme);if(this.g.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!H),!H)return;const K=await H.provideEditSessionIdentityMatch?.(B,F,$);if(this.g.info("Provider returned edit session identifier match result: ",K),!!K)return K}};U=Ve([We(0,b.IExtHostRpcService),We(1,f.IExtHostInitDataService),We(2,m.IExtHostFileSystemInfo),We(3,g.ILogService),We(4,c.IURITransformerService)],U),e.ExtHostWorkspace=U,e.IExtHostWorkspace=(0,d.createDecorator)("IExtHostWorkspace");function G(V){let O,B;return V&&(typeof V=="string"?O=V:(O=V.pattern,B=y.URI.revive(V.baseUri))),{includePattern:O,folder:B}}}),define(Se[34],ye([1,0,23,4,33,5,7,202,126,11,18,3,16,13,2]),function(te,e,a,t,k,A,D,T,S,C,R,P,E,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(o,c){if(c){const u=c.split(".");let r=o;for(let l=0;r&&l<u.length;l++)r=r[u[l]];return r}}function g(o){return o instanceof v.URI}function h(o){return o&&o.uri instanceof v.URI&&o.languageId&&typeof o.languageId=="string"}function w(o){return o&&!o.uri&&o.languageId&&typeof o.languageId=="string"}function m(o){return o&&o.uri instanceof v.URI&&(!o.name||typeof o.name=="string")&&(!o.index||typeof o.index=="number")}function f(o){if(g(o))return{resource:o};if(h(o))return{resource:o.uri,overrideIdentifier:o.languageId};if(w(o))return{overrideIdentifier:o.languageId};if(m(o))return{resource:o.uri};if(o===null)return{resource:null}}let b=class{constructor(c,u,r){this.a=c.getProxy(A.MainContext.MainThreadConfiguration),this.c=u,this.b=r,this.d=new R.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(c=>this.e)}$initializeConfiguration(c){this.e=new s(this.a,this.c,c,this.b),this.d.open()}$acceptConfigurationChanged(c,u){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(c,u))}};b=Ve([We(0,E.IExtHostRpcService),We(1,k.IExtHostWorkspace),We(2,y.ILogService)],b),e.ExtHostConfiguration=b;class s{constructor(c,u,r,l){this.a=new t.Emitter,this.b=c,this.f=l,this.c=u,this.e=T.Configuration.parse(r),this.d=this.k(r.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(c,u){const r={data:this.e.toData(),workspace:this.c.workspace};this.e=T.Configuration.parse(c),this.d=this.k(c.configurationScopes),this.a.fire(this.j(u,r))}getConfiguration(c,u,r){const l=f(u)||{},n=this.g(c?d(this.e.getValue(void 0,l,this.c.workspace),c):this.e.getValue(void 0,l,this.c.workspace));c&&this.h(c,l,r?.identifier);function i(I){if(I==null)return null;if(typeof I=="boolean")return I?2:5;switch(I){case D.ConfigurationTarget.Global:return 2;case D.ConfigurationTarget.Workspace:return 5;case D.ConfigurationTarget.WorkspaceFolder:return 6}}const p={has(I){return typeof d(n,I)<"u"},get:(I,L)=>{this.h(c?`${c}.${I}`:I,l,r?.identifier);let U=d(n,I);if(typeof U>"u")U=L;else{let G;const V=(O,B)=>{let F;const $=()=>{G=G||(0,a.deepClone)(n),F=F||d(G,B)};return(0,C.isObject)(O)?new Proxy(O,{get:(M,H)=>{if(typeof H=="string"&&H.toLowerCase()==="tojson")return $(),()=>F;if(G)return F=F||d(G,B),F[H];const K=M[H];return typeof H=="string"?V(K,`${B}.${H}`):K},set:(M,H,K)=>($(),F&&(F[H]=K),!0),deleteProperty:(M,H)=>($(),F&&delete F[H],!0),defineProperty:(M,H,K)=>($(),F&&Object.defineProperty(F,H,K),!0)}):O};U=V(U,I)}return U},update:(I,L,U,G)=>{I=c?`${c}.${I}`:I;const V=i(U);return L!==void 0?this.b.$updateConfigurationOption(V,I,L,l,G):this.b.$removeConfigurationOption(V,I,l,G)},inspect:I=>{I=c?`${c}.${I}`:I;const L=this.e.inspect(I,l,this.c.workspace);if(L)return{key:I,defaultValue:(0,a.deepClone)(L.policy?.value??L.default?.value),globalValue:(0,a.deepClone)(L.user?.value??L.application?.value),workspaceValue:(0,a.deepClone)(L.workspace?.value),workspaceFolderValue:(0,a.deepClone)(L.workspaceFolder?.value),defaultLanguageValue:(0,a.deepClone)(L.default?.override),globalLanguageValue:(0,a.deepClone)(L.user?.override??L.application?.override),workspaceLanguageValue:(0,a.deepClone)(L.workspace?.override),workspaceFolderLanguageValue:(0,a.deepClone)(L.workspaceFolder?.override),languageIds:(0,a.deepClone)(L.overrideIdentifiers)}}};return typeof n=="object"&&(0,a.mixin)(p,n,!1),Object.freeze(p)}g(c){const u=r=>(0,C.isObject)(r)?new Proxy(r,{get:(l,n)=>u(l[n]),set:(l,n,i)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(n)}' of object`)},deleteProperty:(l,n)=>{throw new Error(`TypeError: Cannot delete read only property '${String(n)}' of object`)},defineProperty:(l,n)=>{throw new Error(`TypeError: Cannot define property '${String(n)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return u(c)}h(c,u,r){const l=S.OVERRIDE_PROPERTY_REGEX.test(c)?4:this.d.get(c),n=r?`[${r.value}] `:"";if(l===4){typeof u?.resource>"u"&&this.f.warn(`${n}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){u?.resource&&this.f.warn(`${n}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(c,u){const r=new T.ConfigurationChangeEvent(c,u,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(l,n)=>r.affectsConfiguration(l,f(n))})}k(c){return c.reduce((u,r)=>(u.set(r[0],r[1]),u),new Map)}}e.ExtHostConfigProvider=s,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(te,e,a,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,a):k?k.value=a:e.set(te,a),a},Fe=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)};define(Se[74],ye([1,0,2,18,4,5,7,33,58,34,21,40,16,25,3,15,12,13,69,240,10]),function(te,e,a,t,k,A,D,T,S,C,R,P,E,y,v,d,g,h,w,m,f){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var s;(function(O){function B($){if($!=null)return $}O.from=B;function F($){if($!=null)return $}O.to=F})(s||(s={}));var o;(function(O){function B($){if($!=null)return $}O.from=B;function F($){if($!=null)return $}O.to=F})(o||(o={}));var c;(function(O){function B($){if($!=null)return $}O.from=B;function F($){if($!=null)return $}O.to=F})(c||(c={}));var u;(function(O){function B(M){if(M){const H=M;return H&&!!H.process}else return!1}O.is=B;function F(M){if(M==null)return;const H={process:M.process,args:M.args};return M.options&&(H.options=c.from(M.options)),H}O.from=F;function $(M){if(M!=null)return new D.ProcessExecution(M.process,M.args,M.options)}O.to=$})(u||(u={}));var r;(function(O){function B($){if($!=null)return $}O.from=B;function F($){if($!=null)return $}O.to=F})(r||(r={}));var l;(function(O){function B(M){if(M){const H=M;return H&&(!!H.commandLine||!!H.command)}else return!1}O.is=B;function F(M){if(M==null)return;const H={};return M.commandLine!==void 0?H.commandLine=M.commandLine:(H.command=M.command,H.args=M.args),M.options&&(H.options=r.from(M.options)),H}O.from=F;function $(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new D.ShellExecution(M.commandLine,M.options):new D.ShellExecution(M.command,M.args?M.args:[],M.options)}O.to=$})(l||(l={}));var n;(function(O){function B(M){if(M){const H=M;return H&&H.customExecution==="customExecution"}else return!1}O.is=B;function F(M){return{customExecution:"customExecution"}}O.from=F;function $(M,H){return H.get(M)}O.to=$})(n=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var i;(function(O){function B(F,$){let M;return F.scope!==void 0&&typeof F.scope!="number"?M=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===D.TaskScope.Workspace&&$&&$.workspaceFile?M=$.workspaceFile:M=m.USER_TASKS_GROUP_KEY),{id:F._id,workspaceFolder:M}}O.from=B})(i=e.TaskHandleDTO||(e.TaskHandleDTO={}));var p;(function(O){function B(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}O.from=B})(p||(p={}));var I;(function(O){function B(M,H){if(M==null)return[];const K=[];for(const q of M){const Y=F(q,H);Y&&K.push(Y)}return K}O.fromMany=B;function F(M,H){if(M==null)return;let K;M.execution instanceof D.ProcessExecution?K=u.from(M.execution):M.execution instanceof D.ShellExecution?K=l.from(M.execution):M.execution&&M.execution instanceof D.CustomExecution&&(K=n.from(M.execution));const q=s.from(M.definition);let Y;return M.scope?typeof M.scope=="number"?Y=M.scope:Y=M.scope.uri:Y=D.TaskScope.Workspace,!q||!Y?void 0:{_id:M._id,definition:q,name:M.name,source:{extensionId:H.identifier.value,label:M.source,scope:Y},execution:K,isBackground:M.isBackground,group:p.from(M.group),presentationOptions:o.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}O.from=F;async function $(M,H,K){if(M==null)return;let q;u.is(M.execution)?q=u.to(M.execution):l.is(M.execution)?q=l.to(M.execution):n.is(M.execution)&&(q=n.to(M._id,K));const Y=s.to(M.definition);let Q;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?Q=M.source.scope:Q=await H.resolveWorkspaceFolder(a.URI.revive(M.source.scope)):Q=D.TaskScope.Workspace),!Y||!Q)return;const ce=new D.Task(Y,Q,M.name,M.source.label,q,M.problemMatchers);return M.isBackground!==void 0&&(ce.isBackground=M.isBackground),M.group!==void 0&&(ce.group=D.TaskGroup.from(M.group._id),ce.group&&M.group.isDefault&&(ce.group=new D.TaskGroup(ce.group.id,ce.group.label),M.group.isDefault===!0&&(ce.group.isDefault=M.group.isDefault))),M.presentationOptions&&(ce.presentationOptions=o.to(M.presentationOptions)),M._id&&(ce._id=M._id),M.detail&&(ce.detail=M.detail),ce}O.to=$})(I=e.TaskDTO||(e.TaskDTO={}));var L;(function(O){function B($){return $}O.from=B;function F($){if(!!$)return Object.assign(Object.create(null),$)}O.to=F})(L||(L={}));class U{constructor(B,F,$){this._id=F,this.a=$,b.set(this,void 0),Je(this,b,B,"f")}get task(){return this.a}terminate(){Fe(this,b,"f").terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}b=new WeakMap;let G=class{constructor(B,F,$,M,H,K,q,Y){this.q=new k.Emitter,this.r=new k.Emitter,this.s=new k.Emitter,this.t=new k.Emitter,this.a=B.getProxy(A.MainContext.MainThreadTask),this.b=$,this.c=M,this.d=H,this.e=K,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=q,this.g=Y,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(B,F,$){if(!$)return new D.Disposable(()=>{});const M=this.w();return this.j.set(M,{type:F,provider:$,extension:B}),this.a.$registerTaskProvider(M,F),new D.Disposable(()=>{this.j.delete(M),this.a.$unregisterTaskProvider(M)})}registerTaskSystem(B,F){this.a.$registerTaskSystem(B,F)}fetchTasks(B){return this.a.$fetchTasks(L.from(B)).then(async F=>{const $=[];for(const M of F){const H=await I.to(M,this.b,this.m);H&&$.push(H)}return $})}get taskExecutions(){const B=[];return this.k.forEach(F=>B.push(F)),B}terminateTask(B){if(!(B instanceof U))throw new Error("No valid task execution provided");return this.a.$terminateTask(B._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(B,F,$){const M=this.m.get(B.id);M&&(this.o.set(B.id,M),this.e.attachPtyToTerminal(F,await M.callback($))),this.p=B.id,this.q.fire({execution:await this.y(B)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(B){const F=await this.y(B);this.l.delete(B.id),this.k.delete(B.id),this.B(B),this.r.fire({execution:F})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(B){const F=await this.y(B.id);this.s.fire({execution:F,processId:B.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(B){const F=await this.y(B.id);this.t.fire({execution:F,exitCode:B.exitCode})}$provideTasks(B,F){const $=this.j.get(B);if(!$)return Promise.reject(new Error("no handler found"));const M=[],H=(0,t.asPromise)(()=>$.provider.provideTasks(R.CancellationToken.None)).then(K=>this.u(F,M,$,K));return new Promise(K=>{H.then(q=>{Promise.all(M).then(()=>{K(q)})})})}async $resolveTask(B,F){const $=this.j.get(B);if(!$)return Promise.reject(new Error("no handler found"));if(F.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${$.type}].`);const M=await I.to(F,this.b,this.m);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const H=await $.provider.resolveTask(M,R.CancellationToken.None);if(!H)return;this.A(H,$);const K=I.from(H,$.extension);if(!K)throw new Error("Unexpected: Task cannot be resolved.");if(H.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return n.is(K.execution)&&await this.x(K,H,!0),await this.v(K)}w(){return this.h++}async x(B,F,$){const M=await this.a.$createTaskId(B);!$&&!this.m.has(M)&&(this.n.add(M),this.o.set(M,F.execution)),this.m.set(M,F.execution)}async y(B,F){if(typeof B=="string"){const H=this.l.get(B);if(!H)throw new f.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return H}const $=this.l.get(B.id);if($)return $;const M=new Promise((H,K)=>{function q(Y,Q,ce){ce?H(new U(Y,Q.id,ce)):K("Unexpected: Task does not exist.")}F?q(this,B,F):I.to(B.task,this.b,this.m).then(Y=>q(this,B,Y))});return this.l.set(B.id,M),M.then(H=>(this.k.set(B.id,H),H),H=>Promise.reject(H))}A(B,F){B._deprecated&&this.g.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}B(B){this.o.get(B.id)&&this.o.delete(B.id),this.n.has(B.id)&&this.p!==B.id&&(this.m.delete(B.id),this.n.delete(B.id));const $=this.n.values();let M=$.next();for(;!M.done;)!this.o.has(M.value)&&this.p!==M.value&&(this.m.delete(M.value),this.n.delete(M.value)),M=$.next()}};G=Ve([We(0,E.IExtHostRpcService),We(1,y.IExtHostInitDataService),We(2,T.IExtHostWorkspace),We(3,S.IExtHostDocumentsAndEditors),We(4,C.IExtHostConfiguration),We(5,P.IExtHostTerminalService),We(6,h.ILogService),We(7,w.IExtHostApiDeprecationService)],G),e.ExtHostTaskBase=G;let V=class extends G{constructor(B,F,$,M,H,K,q,Y){super(B,F,$,M,H,K,q,Y),this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:g.PlatformToString(0)})}async executeTask(B,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const $=I.from(F,B);if($===void 0)throw new Error("Task is not valid");if(n.is($.execution))await this.x($,F,!1);else throw new f.NotSupportedError;const M=await this.y(await this.a.$getTaskExecution($),F);return this.a.$executeTask($).catch(H=>{throw new Error(H)}),M}u(B,F,$,M){const H=[];if(M)for(const K of M){this.A(K,$),(!K.definition||!B[K.definition.type])&&this.f.warn(`The task [${K.source}, ${K.name}] uses an undefined task type. The task will be ignored in the future.`);const q=I.from(K,$.extension);q&&n.is(q.execution)?(H.push(q),F.push(this.x(q,K,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:H,extension:$.extension}}async v(B){if(n.is(B.execution))return B;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(B,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(B,F,$){}};V=Ve([We(0,E.IExtHostRpcService),We(1,y.IExtHostInitDataService),We(2,T.IExtHostWorkspace),We(3,S.IExtHostDocumentsAndEditors),We(4,C.IExtHostConfiguration),We(5,P.IExtHostTerminalService),We(6,h.ILogService),We(7,w.IExtHostApiDeprecationService)],V),e.WorkerExtHostTask=V,e.IExtHostTask=(0,v.createDecorator)("IExtHostTask")}),define(Se[286],ye([1,0,9,21,50,37,24,51,31]),function(te,e,a,t,k,A,D,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(E,y,v){this.k=E,this.l=y,this.o=v,this.e=!1,this.f=0,this.g=!1,this.a=E.filePattern,this.b=E.includePattern&&A.parse(E.includePattern),this.c=E.maxResults||void 0,this.d=E.exists,this.h=new Set,this.j=E.excludePattern&&A.parse(E.excludePattern)}cancel(){this.g=!0,this.h.forEach(E=>E.cancel()),this.h=new Set}search(E){const y=this.k.folderQueries||[];return new Promise((v,d)=>{const g=h=>{this.f++,E(h)};if(this.g)return v({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(h=>{const w=h.toString(),m=a.basename(w);this.j&&this.j(w,m)||this.v(g,{base:h,basename:m})}),Promise.all(y.map(h=>this.p(h,g))).then(h=>{v({limitHit:this.e,stats:h[0]||void 0})},h=>{d(new Error((0,k.toErrorMessage)(h)))})})}async p(E,y){const v=new t.CancellationTokenSource,d=this.q(E),g=this.r(),h=new S.QueryGlobTester(this.k,E),w=!h.hasSiblingExcludeClauses();let m;try{this.h.add(v),m=T.StopWatch.create();const f=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},d,v.token),b=m.elapsed(),s=T.StopWatch.create();return this.g&&!this.e||(f&&f.forEach(o=>{const c=a.posix.relative(E.folder.path,o.path);if(w){const u=a.basename(o.path);this.v(y,{base:E.folder,relativePath:c,basename:u});return}this.s(g,E.folder,c,y)}),this.g&&!this.e)?null:(this.u(g,h,y),{providerTime:b,postProcessTime:s.elapsed()})}finally{v.dispose(),this.h.delete(v)}}q(E){const y=(0,S.resolvePatternsForProvider)(this.k.includePattern,E.includePattern),v=(0,S.resolvePatternsForProvider)(this.k.excludePattern,E.excludePattern);return{folder:E.folder,excludes:v,includes:y,useIgnoreFiles:!E.disregardIgnoreFiles,useGlobalIgnoreFiles:!E.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!E.disregardParentIgnoreFiles,followSymlinks:!E.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const E={rootEntries:[],pathToEntries:Object.create(null)};return E.pathToEntries["."]=E.rootEntries,E}s({pathToEntries:E},y,v,d){if(v===this.a){const h=a.basename(this.a);this.v(d,{base:y,relativePath:this.a,basename:h})}function g(h){const w=a.basename(h),m=a.dirname(h);let f=E[m];f||(f=E[m]=[],g(m)),f.push({base:y,relativePath:h,basename:w})}g(v)}u({rootEntries:E,pathToEntries:y},v,d){const g=this,h=this.a;function w(m){const f=(0,S.hasSiblingFn)(()=>m.map(b=>b.basename));for(let b=0,s=m.length;b<s;b++){const o=m[b],{relativePath:c,basename:u}=o;if(v.matchesExcludesSync(c,u,h!==u?f:void 0))continue;const r=y[c];if(r)w(r);else{if(c===h)continue;g.v(d,o)}if(g.e)break}}w(E)}v(E,y){(!this.b||y.relativePath&&this.b(y.relativePath,y.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||E(y))}}class R{constructor(){this.b=new Map}fileSearch(E,y,v,d){const g=this.c(E.cacheKey),h=new C(E,y,g&&g.token);let w=0;const m=f=>{w+=f.length,v(f.map(b=>this.d(b)))};return this.e(h,R.a,m,d).then(f=>({limitHit:f.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:w,detailStats:f.stats}}))}clearCache(E){this.c(E)?.cancel()}c(E){if(!!E)return this.b.has(E)||this.b.set(E,new t.CancellationTokenSource),this.b.get(E)}d(E){return E.relativePath?{resource:D.joinPath(E.base,E.relativePath)}:{resource:E.base}}e(E,y,v,d){d.onCancellationRequested(()=>{E.cancel()});const g=w=>{w&&(h.push(w),y>0&&h.length>=y&&(v(h),h=[]))};let h=[];return E.search(g).then(w=>(h.length&&v(h),w),w=>(h.length&&v(h),Promise.reject(w)))}}e.FileSearchManager=R,R.a=512}),define(Se[287],ye([1,0,17,79,37,111,28,15,9,24,8,11,2,163,190,52,13,45,133,285,31]),function(te,e,a,t,k,A,D,T,S,C,R,P,E,y,v,d,g,h,w,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let b=class{constructor(p,I,L,U,G){this.a=p,this.b=I,this.c=L,this.d=U,this.e=G}text(p,I,L={}){p=this.f(p,L);const U=this.a.getValue(),G=I&&I.some(O=>!this.a.getValue({resource:O}).search.useRipgrep);return{...this.h(I?.map(h.toWorkspaceFolder),L),type:2,contentPattern:p,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:U.search.usePCRE2||G||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}f(p,I){const L=this.a.getValue();p.isRegExp&&(p.pattern=p.pattern.replace(/\r?\n/g,"\\n"));const U={...p,wordSeparators:L.editor.wordSeparators};return this.j(p,I)&&(U.isCaseSensitive=!0),this.k(p)&&(U.isMultiline=!0),U}file(p,I={}){return{...this.h(p,I),type:1,filePattern:I.filePattern?I.filePattern.trim():I.filePattern,exists:I.exists,sortByScore:I.sortByScore,cacheKey:I.cacheKey}}g(p,I){return p?(p=Array.isArray(p)?p.map(r):r(p),I?this.parseSearchPaths(p):{pattern:o(...Array.isArray(p)?p:[p])}):{}}h(p=[],I={}){const L=this.g(I.includePattern,I.expandPatterns),U=this.g(I.excludePattern,I.expandPatterns),G=p.length>1,V=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(F=>this.q(F,I,U)):p.map(F=>this.r(F,I,U,G))).filter(F=>!!F),O={_reason:I._reason,folderQueries:V,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:I.extraFileResources,excludePattern:U.pattern,includePattern:L.pattern,onlyOpenEditors:I.onlyOpenEditors,maxResults:I.maxResults};if(I.onlyOpenEditors){const F=a.coalesce(a.flatten(this.c.groups.map(H=>H.editors.map(K=>K.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const $=F.filter(H=>(0,f.pathIncludedInQuery)(O,H.fsPath)),M=this.i($);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(M)),{...O,...M}}const B=I.extraFileResources&&I.extraFileResources.filter(F=>(0,f.pathIncludedInQuery)(O,F.fsPath));return O.extraFileResources=B&&B.length?B:void 0,O}i(p){const I=[],L=new D.ResourceMap,U={};let G=!1;return p.forEach(V=>{if(V.scheme===T.Schemas.walkThrough)return;if((0,C.isAbsolutePath)(V)){const B=this.b.getWorkspaceFolder(V)?.uri??V.with({path:S.dirname(V.fsPath)});let F=L.get(B);F||(G=!0,F={folder:B,includePattern:{}},I.push(F),L.set(B,F));const $=S.relative(B.fsPath,V.fsPath);(0,P.assertIsDefined)(F.includePattern)[$.replace(/\\/g,"/")]=!0}else V.fsPath&&(G=!0,U[V.fsPath]=!0)}),{folderQueries:I,includePattern:U,usingSearchPaths:!0,excludePattern:G?void 0:{"**/*":!0}}}j(p,I){if(I.isSmartCase){if(p.isRegExp){if(R.containsUppercaseCharacter(p.pattern,!0))return!0}else if(R.containsUppercaseCharacter(p.pattern))return!0}return!!p.isCaseSensitive}k(p){return p.isMultiline||p.isRegExp&&(0,y.isMultilineRegexSource)(p.pattern)||p.pattern.indexOf(`
`)>=0?!0:!!p.isMultiline}parseSearchPaths(p){const I=M=>S.isAbsolute(M)||/^\.\.?([\/\\]|$)/.test(M),U=(Array.isArray(p)?p:c(p)).map(M=>{const H=this.e.resolvedUserHome;return H?(0,A.untildify)(M,H.scheme===T.Schemas.file?H.fsPath:H.path):M}),G=t.groupBy(U,M=>I(M)?"searchPaths":"exprSegments"),V=(G.exprSegments||[]).map(M=>R.rtrim(M,"/")).map(M=>R.rtrim(M,"\\")).map(M=>(M[0]==="."&&(M="*"+M),u(M))),O={},B=this.m(G.searchPaths||[]);B&&B.length&&(O.searchPaths=B);const F=a.flatten(V),$=o(...F);return $&&(O.pattern=$),O}l(p,I){return I.disregardExcludeSettings?void 0:(0,f.getExcludes)(p,!I.disregardSearchExcludeSettings)}m(p){if(!p||!p.length)return[];const I=a.flatten(p.map(U=>{let{pathPortion:G,globPortion:V}=s(U);V&&(V=l(V));const O=this.n(G);return a.flatten(O.map(B=>this.o(B,V)))})),L=new Map;return I.forEach(U=>{const G=U.searchPath.toString(),V=L.get(G);V?U.pattern&&(V.pattern=V.pattern||{},V.pattern[U.pattern]=!0):L.set(G,{searchPath:U.searchPath,pattern:U.pattern?o(U.pattern):void 0})}),Array.from(L.values())}n(p){if(S.isAbsolute(p)){const I=this.b.getWorkspace().folders;return I[0]&&I[0].uri.scheme!==T.Schemas.file?[{searchPath:I[0].uri.with({path:p})}]:[{searchPath:E.URI.file(S.normalize(p))}]}if(this.b.getWorkbenchState()===2){const I=this.b.getWorkspace().folders[0].uri;if(p=r(p),p.startsWith("../")||p===".."){const U=S.posix.resolve(I.path,p);return[{searchPath:I.with({path:U})}]}const L=l(p);return[{searchPath:I,pattern:L}]}else{if(p==="./"||p===".\\")return[];{const I=p.replace(/^\.[\/\\]/,""),U=this.b.getWorkspace().folders.map(G=>{const V=I.match(new RegExp(`^${R.escapeRegExpCharacters(G.name)}(?:/(.*)|$)`));return V?{match:V,folder:G}:null}).filter(P.isDefined);if(U.length)return U.map(G=>{const V=G.match[1];return{searchPath:G.folder.uri,pattern:V&&l(V)}});{const G=p.match(/\.[\/\\](.+)[\/\\]?/),V=G?G[1]:p,O=v.localize(0,null,V);throw new Error(O)}}}}o(p,I){const L=p.pattern&&I?`${p.pattern}/${I}`:p.pattern||I,U=[{searchPath:p.searchPath,pattern:L}];return L&&!L.endsWith("**")&&U.push({searchPath:p.searchPath,pattern:L+"/**"}),U}q(p,I,L){const U=this.r((0,h.toWorkspaceFolder)(p.searchPath),I,L,!1);return U?{...U,includePattern:p.pattern}:null}r(p,I,L,U){let G;const V=E.URI.isUri(p)?p:p.uri;if(L.searchPaths){const M=L.searchPaths.filter(H=>(0,C.isEqual)(H.searchPath,V))[0];if(M&&!M.pattern)return null;M&&(G=M.pattern)}const O=this.a.getValue({resource:V}),F={...this.l(O,I)||{},...G||{}},$=E.URI.isUri(p)?(0,C.basename)(p):p.name;return{folder:V,folderName:U?$:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:O.files&&O.files.encoding,disregardIgnoreFiles:typeof I.disregardIgnoreFiles=="boolean"?I.disregardIgnoreFiles:!O.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof I.disregardGlobalIgnoreFiles=="boolean"?I.disregardGlobalIgnoreFiles:!O.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof I.disregardParentIgnoreFiles=="boolean"?I.disregardParentIgnoreFiles:!O.search.useParentIgnoreFiles,ignoreSymlinks:typeof I.ignoreSymlinks=="boolean"?I.ignoreSymlinks:!O.search.followSymlinks}}};b=Ve([We(0,d.IConfigurationService),We(1,h.IWorkspaceContextService),We(2,w.IEditorGroupsService),We(3,g.ILogService),We(4,m.IPathService)],b),e.QueryBuilder=b;function s(i){const p=i.match(/[\*\{\}\(\)\[\]\?]/);if(p){const I=p.index,L=i.substr(0,I).match(/[/|\\][^/\\]*$/);if(L){let U=i.substr(0,L.index);return U.match(/[/\\]/)||(U+="/"),{pathPortion:U,globPortion:i.substr((L.index||0)+1)}}}return{pathPortion:i}}function o(...i){return i.length?i.reduce((p,I)=>(p[I]=!0,p),Object.create(null)):void 0}function c(i){return k.splitGlobAware(i,",").map(p=>p.trim()).filter(p=>!!p.length)}function u(i){return[`**/${i}/**`,`**/${i}`].map(I=>I.replace(/\*\*\/\*\*/g,"**"))}function r(i){return i.replace(/\\/g,"/")}function l(i){return r(i).replace(/^\.\//,"").replace(/\/+$/g,"")}function n(i,p){i=a.distinct(i,U=>U.toString());const I=[],L=p.getWorkspace();return i&&i.forEach(U=>{let G;if(p.getWorkbenchState()===2)G=(0,C.relativePath)(L.folders[0].uri,U),G&&G!=="."&&(G="./"+G);else{const V=p.getWorkspaceFolder(U);if(V){const O=V.name;if(L.folders.filter(F=>F.name===O).length===1){const F=(0,C.relativePath)(V.uri,U);F===""?G=`./${V.name}`:G=`./${V.name}/${F}`}else G=U.fsPath}}G&&I.push(G)}),I}e.resolveResourcesForSearchIncludes=n}),define(Se[288],ye([1,0,24,2,21,10,3,287,31,45]),function(te,e,a,t,k,A,D,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function P(d,g){const h=g.activationEvents;if(!h)return Promise.resolve(void 0);const w=[],m=[];for(const u of h)if(/^workspaceContains:/.test(u)){const r=u.substr(18);r.indexOf("*")>=0||r.indexOf("?")>=0||d.forceUsingSearch?m.push(r):w.push(r)}if(w.length===0&&m.length===0)return Promise.resolve(void 0);let f;const b=new Promise((u,r)=>{f=u}),s=u=>f({activationEvent:u}),o=Promise.all(w.map(u=>E(d,u,s))).then(()=>{}),c=y(d,g.identifier,m,s);return Promise.all([o,c]).then(()=>{f(void 0)}),b}e.checkActivateWorkspaceContainsExtension=P;async function E(d,g,h){for(const w of d.folders)if(await d.exists(a.joinPath(t.URI.revive(w),g))){h(`workspaceContains:${g}`);return}}async function y(d,g,h,w){if(h.length===0)return Promise.resolve(void 0);const m=new k.CancellationTokenSource,f=d.checkExists(d.folders,h,m.token),b=setTimeout(async()=>{m.cancel(),d.logService.info(`Not activating extension '${g.value}': Timed out while searching for 'workspaceContains' pattern ${h.join(",")}`)},R);let s=!1;try{s=await f}catch(o){A.isCancellationError(o)||A.onUnexpectedError(o)}m.dispose(),clearTimeout(b),s&&w(`workspaceContains:${h.join(",")}`)}function v(d,g,h,w){const m=d.get(D.IInstantiationService),f=d.get(S.ISearchService),s=m.createInstance(T.QueryBuilder).file(g.map(o=>(0,C.toWorkspaceFolder)(t.URI.revive(o))),{_reason:"checkExists",includePattern:h,exists:!0});return f.fileSearch(s,w).then(o=>!!o.limitHit,o=>A.isCancellationError(o)?!1:Promise.reject(o))}e.checkGlobFileExists=v});var Je=this&&this.__classPrivateFieldSet||function(te,e,a,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!k:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(te,a):k?k.value=a:e.set(te,a),a},Fe=this&&this.__classPrivateFieldGet||function(te,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(te):t?t.value:e.get(te)};define(Se[41],ye([1,0,174,9,75,24,18,6,64,2,13,5,34,230,97,33,26,228,10,27,22,211,7,127,3,25,71,16,87,54,40,4,288,96,213,15,95]),function(te,e,a,t,k,A,D,T,S,C,R,P,E,y,v,d,g,h,w,m,f,b,s,o,c,u,r,l,n,i,p,I,L,U,G,V,O){"use strict";var B,F,$;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,c.createDecorator)("IHostUtils");let M=class Ln extends T.Disposable{constructor(ie,de,J,pe,ve,De,Re,$e,re,le,fe){super(),this.a=this.B(new I.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.P=!1,this.c=de,this.g=J,this.f=Re,this.j=pe,this.k=ve,this.l=De,this.m=re,this.p=le,this.s=fe,this.t=this.g.getProxy(P.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(P.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(P.MainContext.MainThreadExtensionService),this.w=new D.Barrier,this.y=new D.Barrier,this.C=new D.Barrier,this.D=new D.Barrier,this.G=new h.ExtensionDescriptionRegistry(this.f.allExtensions);const Z=(0,g.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.F=new h.ExtensionDescriptionRegistry(q(this.G,Z)),this.H=new v.ExtHostStorage(this.g,this.l),this.I=new U.ExtHostSecretState(this.g),this.J=$e,this.h=ie.createChild(new n.ServiceCollection([v.IExtHostStorage,this.H],[U.IExtHostSecretState,this.I]));let se=[],ne=[];this.f.remote.isRemote&&(se=this.f.allExtensions.filter(z=>!z.main&&!z.browser).map(z=>z.identifier),ne=this.f.allExtensions.filter(z=>!Z.has(m.ExtensionIdentifier.toKey(z.identifier.value))).filter(z=>(z.main||z.browser)&&z.api==="none").map(z=>z.identifier));const N=(0,g.extensionIdentifiersArrayToSet)(ne);this.L=this.B(new y.ExtensionsActivator(this.F,se,ne,{onExtensionActivationError:(z,X,_)=>{this.v.$onExtensionActivationError(z,w.transformErrorForSerialization(X),_)},actualActivateExtension:async(z,X)=>{if(N.has(m.ExtensionIdentifier.toKey(z)))return await this.v.$activateExtension(z,X),new y.HostExtension;const _=this.F.getExtensionDescription(z);return this.ab(_,X)}},this.l)),this.M=null,this.N=Object.create(null),this.O=!1,this.Q=this.f.remote.connectionData}getRemoteConnectionData(){return this.Q}async initialize(){try{await this.pb(),this.w.open(),await this.j.waitForInitializeCall(),k.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.mb()}catch(ie){w.onUnexpectedError(ie)}}async R(){this.J.onWillDeactivateAll();let ie=[];try{ie=this.F.getAllExtensionDescriptions().map(ve=>ve.identifier).filter(ve=>this.isActivated(ve)).map(ve=>this.Y(ve))}catch{}await Promise.all(ie)}terminate(ie,de=0){if(this.P)return;this.P=!0,this.l.info(`Extension host terminating: ${ie}`),this.l.flush(),this.p.dispose(),this.L.dispose(),w.setUnexpectedErrorHandler(pe=>{this.l.error(pe)}),this.g.dispose();const J=this.R();Promise.race([(0,D.timeout)(5e3),J]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${de}`):this.l.info(`Extension host exiting with code ${de}`),this.l.flush(),this.l.dispose(),this.c.exit(de)})}isActivated(ie){return this.C.isOpen()?this.L.isActivated(ie):!1}async getExtension(ie){const de=await this.v.$getExtension(ie);let J;if(de?.browserNlsBundleUris){J={};for(const pe of Object.keys(de.browserNlsBundleUris))J[pe]=C.URI.revive(de.browserNlsBundleUris[pe])}return de&&{...de,identifier:new m.ExtensionIdentifier(de.identifier.value),extensionLocation:C.URI.revive(de.extensionLocation),browserNlsBundleUris:J}}S(ie,de){return this.L.activateByEvent(ie,de)}U(ie,de){return this.L.activateById(ie,de)}activateByIdWithErrors(ie,de){return this.U(ie,de).then(()=>{const J=this.L.getActivatedExtension(ie);if(J.activationFailed)return Promise.reject(J.activationFailedError)})}getExtensionRegistry(){return this.C.wait().then(ie=>this.F)}getExtensionExports(ie){return this.C.isOpen()?this.L.getActivatedExtension(ie).exports:null}async W(ie){if(ie.scheme!==V.Schemas.file)return ie;const de=await this.c.realpath(ie.fsPath);return C.URI.file(de)}async getExtensionPathIndex(){return this.M||(this.M=this.X(this.F.getAllExtensionDescriptions()).then(ie=>new Q(ie))),this.M}async X(ie){const de=S.TernarySearchTree.forUris(J=>A.extUriBiasedIgnorePathCase.ignorePathCasing(J));return await Promise.all(ie.map(async J=>{if(this.qb(J)){const pe=await this.W(J.extensionLocation);de.set(pe,J)}})),de}Y(ie){let de=Promise.resolve(void 0);if(!this.C.isOpen()||!this.L.isActivated(ie))return de;const J=this.L.getActivatedExtension(ie);if(!J)return de;try{typeof J.module.deactivate=="function"&&(de=Promise.resolve(J.module.deactivate()).then(void 0,pe=>(this.l.error(pe),Promise.resolve(void 0))))}catch(pe){this.l.error(`An error occurred when deactivating the extension '${ie.value}':`),this.l.error(pe)}try{(0,T.dispose)(J.subscriptions)}catch(pe){this.l.error(`An error occurred when deactivating the subscriptions for extension '${ie.value}':`),this.l.error(pe)}return de}async ab(ie,de){return this.f.remote.isRemote?this.v.$onWillActivateExtension(ie.identifier):await this.v.$onWillActivateExtension(ie.identifier),this.cb(ie,de).then(J=>{const pe=J.activationTimes;return this.v.$onDidActivateExtension(ie.identifier,pe.codeLoadingTime,pe.activateCallTime,pe.activateResolvedTime,de),this.bb(ie,de,"success",pe),J},J=>{throw this.bb(ie,de,"failure"),J})}bb(ie,de,J,pe){const ve=H(ie,de);this.u.$publicLog2("extensionActivationTimes",{...ve,...pe||{},outcome:J})}cb(ie,de){const J=H(ie,de);this.u.$publicLog2("activatePlugin",J);const pe=this.qb(ie);if(!pe)return Promise.resolve(new y.EmptyExtension(y.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${ie.identifier.value}, startup: ${de.startup}, activationEvent: '${de.activationEvent}'${ie.identifier.value!==de.extensionId.value?`, root cause: ${de.extensionId.value}`:""}`),this.l.flush();const ve=new y.ExtensionActivationTimesBuilder(de.startup);return Promise.all([this.rb(ie,(0,A.joinPath)(ie.extensionLocation,pe),ve),this.db(ie)]).then(De=>(k.mark(`code/extHost/willActivateExtension/${ie.identifier.value}`),Ln.eb(this.l,ie.identifier,De[0],De[1],ve))).then(De=>(k.mark(`code/extHost/didActivateExtension/${ie.identifier.value}`),De))}db(ie){const de=new b.ExtensionGlobalMemento(ie,this.H),J=new b.ExtensionMemento(ie.identifier.value,!1,this.H),pe=new G.ExtensionSecrets(ie,this.I),ve=ie.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?s.ExtensionMode.Test:s.ExtensionMode.Development:s.ExtensionMode.Production,De=this.f.remote.isRemote?s.ExtensionKind.Workspace:s.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${ie.identifier.value}`),Promise.all([de.whenReady,J.whenReady,this.J.whenReady]).then(()=>{const Re=this;let $e,re;const le=(0,g.isProposedApiEnabled)(ie,"ipc")?this.f.messagePorts?.get(m.ExtensionIdentifier.toKey(ie.identifier)):void 0;return Object.freeze({globalState:de,workspaceState:J,secrets:pe,subscriptions:[],get extensionUri(){return ie.extensionLocation},get extensionPath(){return ie.extensionLocation.fsPath},asAbsolutePath(fe){return t.join(ie.extensionLocation.fsPath,fe)},get storagePath(){return Re.J.workspaceValue(ie)?.fsPath},get globalStoragePath(){return Re.J.globalValue(ie).fsPath},get logPath(){return t.join(Re.f.logsLocation.fsPath,ie.identifier.value)},get logUri(){return C.URI.joinPath(Re.f.logsLocation,ie.identifier.value)},get storageUri(){return Re.J.workspaceValue(ie)},get globalStorageUri(){return Re.J.globalValue(ie)},get extensionMode(){return ve},get extension(){return $e===void 0&&($e=new K(Re,ie.identifier,ie,De,!1)),$e},get extensionRuntime(){return(0,g.checkProposedApiEnabled)(ie,"extensionRuntime"),Re.extensionRuntime},get environmentVariableCollection(){return Re.p.getEnvironmentVariableCollection(ie)},get messagePassingProtocol(){if(!re){if(!le)return;const fe=I.Event.buffer(I.Event.fromDOMEventEmitter(le,"message",Z=>Z.data));le.start(),re={onDidReceiveMessage:fe,postMessage:le.postMessage.bind(le)}}return re}})})}static eb(ie,de,J,pe,ve){return J=J||{activate:void 0,deactivate:void 0},this.fb(ie,de,J,pe,ve).then(De=>new y.ActivatedExtension(!1,null,ve.build(),J,De,pe.subscriptions))}static fb(ie,de,J,pe,ve){if(typeof J.activate=="function")try{ve.activateCallStart(),ie.trace(`ExtensionService#_callActivateOptional ${de.value}`);const De=typeof global=="object"?global:self,Re=J.activate.apply(De,[pe]);return ve.activateCallStop(),ve.activateResolveStart(),Promise.resolve(Re).then($e=>(ve.activateResolveStop(),$e))}catch(De){return Promise.reject(De)}else return Promise.resolve(J)}gb(ie,de){this.U(ie.identifier,{startup:!1,extensionId:ie.identifier,activationEvent:de}).then(void 0,J=>{this.l.error(J)})}hb(){this.v.$setPerformanceMarks(k.getMarks());for(const ie of this.F.getAllExtensionDescriptions())if(ie.activationEvents)for(const de of ie.activationEvents)de==="onStartupFinished"&&this.gb(ie,de)}ib(){const ie=this.S("*",!0).then(void 0,ve=>{this.l.error(ve)});this.B(this.j.onDidChangeWorkspace(ve=>this.jb(ve.added)));const de=this.j.workspace?this.j.workspace.folders:[],J=this.jb(de),pe=Promise.all([ie,J]).then(()=>{});return Promise.race([pe,(0,D.timeout)(1e4)]).then(()=>{this.hb()}),pe}jb(ie){return ie.length===0?Promise.resolve(void 0):Promise.all(this.F.getAllExtensionDescriptions().map(de=>this.kb(ie,de))).then(()=>{})}async kb(ie,de){if(this.isActivated(de.identifier))return;const J=!this.f.remote.isRemote&&!!this.f.remote.authority,pe={logService:this.l,folders:ie.map(De=>De.uri),forceUsingSearch:J,exists:De=>this.c.exists(De.fsPath),checkExists:(De,Re,$e)=>this.t.$checkExists(De,Re,$e)},ve=await(0,L.checkActivateWorkspaceContainsExtension)(pe,de);if(!!ve)return this.U(de.identifier,{startup:!0,extensionId:de.identifier,activationEvent:ve.activationEvent}).then(void 0,De=>this.l.error(De))}async $extensionTestsExecute(){await this.D.wait();try{return await this.lb()}catch(ie){throw console.error(ie),ie}}async lb(){const{extensionDevelopmentLocationURI:ie,extensionTestsLocationURI:de}=this.f.environment;if(!ie||!de)throw new Error(a.localize(0,null));const J=await this.rb(null,de,new y.ExtensionActivationTimesBuilder(!1));if(!J||typeof J.run!="function")throw new Error(a.localize(1,null,de.toString()));return new Promise((pe,ve)=>{const De=(re,le)=>{re?ve(re):pe(typeof le=="number"&&le>0?1:0)},Re=(0,A.originalFSPath)(de),$e=J.run(Re,De);$e&&$e.then&&$e.then(()=>{pe(0)}).catch(re=>{ve(re instanceof Error&&re.stack?re.stack:String(re))})})}mb(){if(this.O)throw new Error("Extension host is already started!");return this.O=!0,this.y.wait().then(()=>this.C.open()).then(()=>this.ib()).then(()=>{this.D.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ie,de){return this.N[ie]=de,(0,T.toDisposable)(()=>{delete this.N[ie]})}async nb(ie){const de=ie.indexOf("+");if(de===-1)throw new Error("Not an authority that can be resolved!");const J=ie.substr(0,de);return await this.w.wait(),await this.S(`onResolveRemoteAuthority:${J}`,!1),{authorityPrefix:J,resolver:this.N[J]}}async $resolveAuthority(ie,de){this.l.info(`$resolveAuthority invoked for authority (${Y(ie)})`);const{authorityPrefix:J,resolver:pe}=await this.nb(ie);if(!pe)return{type:"error",error:{code:o.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${J}.`,detail:void 0}};try{this.B(await this.m.setTunnelFactory(pe)),k.mark(`code/extHost/willResolveAuthority/${J}`);const ve=await pe.resolve(ie,{resolveAttempt:de});k.mark(`code/extHost/didResolveAuthorityOK/${J}`);const De={authority:ie,host:ve.host,port:ve.port,connectionToken:ve.connectionToken},Re={extensionHostEnv:ve.extensionHostEnv,isTrusted:ve.isTrusted,authenticationSession:ve.authenticationSessionForInitializingExtensions?{id:ve.authenticationSessionForInitializingExtensions.id,providerId:ve.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:De,options:Re,tunnelInformation:{environmentTunnels:ve.environmentTunnels,features:ve.tunnelFeatures}}}}catch(ve){if(k.mark(`code/extHost/didResolveAuthorityError/${J}`),ve instanceof s.RemoteAuthorityResolverError)return{type:"error",error:{code:ve._code,message:ve._message,detail:ve._detail}};throw ve}}async $getCanonicalURI(ie,de){this.l.info(`$getCanonicalURI invoked for authority (${Y(ie)})`);const{resolver:J}=await this.nb(ie);if(!J)return null;const pe=C.URI.revive(de);if(typeof J.getCanonicalURI>"u")return pe;const ve=await(0,D.asPromise)(()=>J.getCanonicalURI(pe));return ve||pe}static ob(ie,de,J){const pe=new h.ExtensionDescriptionRegistry(ie.getAllExtensionDescriptions());pe.deltaExtensions(J.toAdd,J.toRemove);const ve=(0,g.extensionIdentifiersArrayToSet)(de.getAllExtensionDescriptions().map(Re=>Re.identifier));for(const Re of J.myToRemove)ve.delete(m.ExtensionIdentifier.toKey(Re));for(const Re of J.myToAdd)ve.add(m.ExtensionIdentifier.toKey(Re));const De=q(pe,ve);return{globalRegistry:pe,myExtensions:De}}$startExtensionHost(ie){ie.toAdd.forEach(pe=>pe.extensionLocation=C.URI.revive(pe.extensionLocation));const{globalRegistry:de,myExtensions:J}=Ln.ob(this.G,this.F,ie);return this.G.set(de.getAllExtensionDescriptions()),this.F.set(J),this.mb()}$activateByEvent(ie,de){return de===1?this.S(ie,!1):this.C.wait().then(J=>this.S(ie,!1))}async $activate(ie,de){return await this.C.wait(),this.F.getExtensionDescription(ie)?(await this.U(ie,de),!0):!1}async $deltaExtensions(ie){ie.toAdd.forEach(De=>De.extensionLocation=C.URI.revive(De.extensionLocation));const{globalRegistry:de,myExtensions:J}=Ln.ob(this.G,this.F,ie),pe=await this.X(J);return(await this.getExtensionPathIndex()).setSearchTree(pe),this.G.set(de.getAllExtensionDescriptions()),this.F.set(J),Promise.resolve(void 0)}async $test_latency(ie){return ie}async $test_up(ie){return ie.byteLength}async $test_down(ie){const de=f.VSBuffer.alloc(ie),J=Math.random()%256;for(let pe=0;pe<ie;pe++)de.writeUInt8(J,pe);return de}async $updateRemoteConnectionData(ie){this.Q=ie,this.a.fire()}};M=Ve([We(0,c.IInstantiationService),We(1,e.IHostUtils),We(2,l.IExtHostRpcService),We(3,d.IExtHostWorkspace),We(4,E.IExtHostConfiguration),We(5,R.ILogService),We(6,u.IExtHostInitDataService),We(7,r.IExtensionStoragePaths),We(8,i.IExtHostTunnelService),We(9,p.IExtHostTerminalService),We(10,O.IExtHostLocalizationService)],M),e.AbstractExtHostExtensionService=M;function H(ce,ie){return{id:ce.identifier.value,name:ce.name,extensionVersion:ce.version,publisherDisplayName:ce.publisher,activationEvents:ce.activationEvents?ce.activationEvents.join(","):null,isBuiltin:ce.isBuiltin,reason:ie.activationEvent,reasonId:ie.extensionId.value}}e.IExtHostExtensionService=(0,c.createDecorator)("IExtHostExtensionService");class K{constructor(ie,de,J,pe,ve){B.set(this,void 0),F.set(this,void 0),$.set(this,void 0),Je(this,B,ie,"f"),Je(this,F,de,"f"),Je(this,$,J.identifier,"f"),this.id=J.identifier.value,this.extensionUri=J.extensionLocation,this.extensionPath=t.normalize((0,A.originalFSPath)(J.extensionLocation)),this.packageJSON=J,this.extensionKind=pe,this.isFromDifferentExtensionHost=ve}get isActive(){return Fe(this,B,"f").isActivated(Fe(this,$,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Fe(this,B,"f").getExtensionExports(Fe(this,$,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Fe(this,B,"f").activateByIdWithErrors(Fe(this,$,"f"),{startup:!1,extensionId:Fe(this,F,"f"),activationEvent:"api"}),this.exports}}e.Extension=K,B=new WeakMap,F=new WeakMap,$=new WeakMap;function q(ce,ie){return ce.getAllExtensionDescriptions().filter(de=>ie.has(m.ExtensionIdentifier.toKey(de.identifier)))}function Y(ce){const ie=ce.indexOf("+");return ie===-1?ce:ce.substring(0,ie)}class Q{constructor(ie){this.a=ie}setSearchTree(ie){this.a=ie}findSubstr(ie){return this.a.findSubstr(ie)}forEach(ie){return this.a.forEach(ie)}}e.ExtensionPaths=Q}),define(Se[289],ye([1,0,75,2,5,34,26,27,16,25,3,41,36,13,8]),function(te,e,a,t,k,A,D,T,S,C,R,P,E,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let d=class{constructor(b,s,o,c,u,r,l){this.c=b,this.d=s,this.e=o,this.f=c,this.g=u,this.h=r,this.i=l,this.a=new Map,this.b=[]}async install(){this.j(),a.mark("code/extHost/willWaitForConfig");const b=await this.f.getConfigProvider();a.mark("code/extHost/didWaitForConfig");const s=await this.g.getExtensionPathIndex();this.register(new h(this.c,s,this.d,b,this.i)),this.register(this.e.createInstance(w,s)),this.register(this.e.createInstance(g)),this.h.remote.isRemote&&this.register(this.e.createInstance(m,s,this.h.environment.appUriScheme))}register(b){if("nodeModuleName"in b)if(Array.isArray(b.nodeModuleName))for(const s of b.nodeModuleName)this.a.set(s,b);else this.a.set(b.nodeModuleName,b);typeof b.alternativeModuleName=="function"&&this.b.push(s=>b.alternativeModuleName(s))}};d=Ve([We(2,R.IInstantiationService),We(3,A.IExtHostConfiguration),We(4,P.IExtHostExtensionService),We(5,C.IExtHostInitDataService),We(6,y.ILogService)],d),e.RequireInterceptor=d;let g=class ei{constructor(b){if(b.environment.appRoot&&ei.a.size){const s=(0,v.escapeRegExpCharacters)(this.c(b.environment.appRoot.fsPath)),o="[a-z0-9_.-]",c=`@${o}+\\/${o}+|${o}+`,u="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${s}/${u}\\/)(${c})(.*)$`,"i")}}alternativeModuleName(b){if(!this.b)return;const s=this.b.exec(this.c(b));if(!s)return;const[,o,c,u]=s,r=ei.a.get(c);if(r!==void 0)return console.warn(`${c} as been renamed to ${r}, please update your imports`),o+r+u}c(b){return b.replace(/\\/g,"/")}};g.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),g=Ve([We(0,C.IExtHostInitDataService)],g);class h{constructor(b,s,o,c,u){this.c=b,this.d=s,this.e=o,this.f=c,this.g=u,this.nodeModuleName="vscode",this.a=new Map}load(b,s){const o=this.d.findSubstr(s);if(o){let c=this.a.get(T.ExtensionIdentifier.toKey(o.identifier));return c||(c=this.c(o,this.e,this.f),this.a.set(T.ExtensionIdentifier.toKey(o.identifier),c)),c}if(!this.b){let c="";this.d.forEach((u,r)=>c+=`	${r} -> ${u.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${c}`),this.b=this.c(D.nullExtensionDescription,this.e,this.f)}return this.b}}let w=class{constructor(b,s,o){this.d=b,this.nodeModuleName="keytar",this.a=s.getProxy(k.MainContext.MainThreadTelemetry);const{environment:c}=o,u=s.getProxy(k.MainContext.MainThreadKeytar);if(c.appRoot){let r=c.appRoot.fsPath;E.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.b=new Set,this.b.add(`${r}/node_modules.asar/keytar`),this.b.add(`${r}/node_modules/keytar`)}this.c={getPassword:(r,l)=>u.$getPassword(r,l),setPassword:(r,l,n)=>u.$setPassword(r,l,n),deletePassword:(r,l)=>u.$deletePassword(r,l),findPassword:r=>u.$findPassword(r),findCredentials(r){return u.$findCredentials(r)}}}load(b,s){const o=this.d.findSubstr(s);return this.a.$publicLog2("shimming.keytar",{extension:o?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(b){const s=b.length;if(s<=7||!this.b)return;const o=s-7;if((b.charAt(o)==="/"||b.charAt(o)==="\\")&&b.endsWith("keytar")&&(b=b.replace(/\\/g,"/"),this.b.has(b)))return"keytar"}};w=Ve([We(1,S.IExtHostRpcService),We(2,C.IExtHostInitDataService)],w);let m=class{constructor(b,s,o){this.e=b,this.f=s,this.nodeModuleName=["open","opn"],this.d=o.getProxy(k.MainContext.MainThreadTelemetry);const c=o.getProxy(k.MainContext.MainThreadWindow);this.c=(u,r)=>{const l=t.URI.parse(u);return r?this.g(u,r):l.scheme==="http"||l.scheme==="https"?c.$openUri(l,u,{allowTunneling:!0}):l.scheme==="mailto"||l.scheme===this.f?c.$openUri(l,u,{}):this.g(u,r)}}load(b,s,o){const c=this.e.findSubstr(s);return c&&(this.a=c.identifier.value,this.h()),this.b=o(b),this.c}g(b,s){return this.i(),this.b(b,s)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};m=Ve([We(2,S.IExtHostRpcService)],m)}),define(Se[47],ye([1,0,80,6,9,36,3,58,59,41,7,33,225,34]),function(te,e,a,t,k,A,D,T,S,C,R,P,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,D.createDecorator)("IExtHostVariableResolverProvider");class v extends E.AbstractVariableResolverService{constructor(h,w,m,f,b,s,o){function c(){if(m){const u=m.activeEditor();if(u)return u.document.uri;const r=f.tabGroups.all.find(l=>l.isActive)?.activeTab;if(r!==void 0){if(r.input instanceof R.TextDiffTabInput||r.input instanceof R.NotebookDiffEditorTabInput)return r.input.modified;if(r.input instanceof R.TextTabInput||r.input instanceof R.NotebookEditorTabInput||r.input instanceof R.CustomEditorTabInput)return r.input.uri}}}super({getFolderUri:u=>{const r=s.folders.filter(l=>l.name===u);if(r&&r.length>0)return r[0].uri},getWorkspaceFolderCount:()=>s.folders.length,getConfigurationValue:(u,r)=>b.getConfiguration(void 0,u).get(r),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const u=c();if(u)return k.normalize(u.fsPath)},getWorkspaceFolderPathForFile:()=>{if(w){const u=c();if(u){const r=w.getWorkspaceFolder(u);if(r)return k.normalize(r.uri.fsPath)}}},getSelectedText:()=>{if(m){const u=m.activeEditor();if(u&&!u.selection.isEmpty)return u.document.getText(u.selection)}},getLineNumber:()=>{if(m){const u=m.activeEditor();if(u)return String(u.selection.end.line+1)}},getExtension:u=>h.getExtension(u)},void 0,o?Promise.resolve(o):void 0,Promise.resolve(A.env))}}let d=class extends t.Disposable{constructor(h,w,m,f,b){super(),this.b=h,this.c=w,this.g=m,this.h=f,this.i=b,this.a=new a.Lazy(async()=>{const s=await this.h.getConfigProvider(),c={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async u=>{c.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.i,s,c,this.j())})}getResolver(){return this.a.getValue()}j(){}};d=Ve([We(0,C.IExtHostExtensionService),We(1,P.IExtHostWorkspace),We(2,T.IExtHostDocumentsAndEditors),We(3,y.IExtHostConfiguration),We(4,S.IExtHostEditorTabs)],d),e.ExtHostVariableResolverProviderService=d}),define(Se[76],ye([1,0,18,4,11,2,3,5,59,41,16,7,33,131,217,34,47]),function(te,e,a,t,k,A,D,T,S,C,R,P,E,y,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,D.createDecorator)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(c,u,r,l,n,i){this.E=u,this.F=r,this.G=l,this.H=n,this.I=i,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new t.Emitter,this.n=new t.Emitter,this.o=new t.Emitter,this.u=new t.Emitter,this.k=c.getProxy(T.MainContext.MainThreadDebugService),this.A=new t.Emitter({onWillAddFirstListener:()=>{this.U()}}),this.v=new m(this.k),this.w=new Map,this.y=!1,this.F.getExtensionRegistry().then(p=>{p.onDidChange(I=>{this.J(p)}),this.J(p)})}asDebugSourceUri(c,u){const r=c;if(typeof r.sourceReference=="number"&&r.sourceReference>0){let l=`debug:${encodeURIComponent(r.path||"")}`,n="?";return u&&(l+=`${n}session=${encodeURIComponent(u.id)}`,n="&"),l+=`${n}ref=${r.sourceReference}`,A.URI.parse(l)}else{if(r.path)return A.URI.file(r.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(c){const u=[];for(const r of c.getAllExtensionDescriptions())if(r.contributes){const l=r.contributes.debuggers;if(l&&l.length>0)for(const n of l)(0,v.isDebuggerMainContribution)(n)&&u.push(n.type)}this.k.$registerDebugTypes(u)}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){this.U();const c=[];return this.w.forEach(u=>c.push(u)),c}addBreakpoints(c){this.U();const u=c.filter(n=>{const i=n.id;return this.w.has(i)?!1:(this.w.set(i,n),!0)});this.V(u,[],[]);const r=[],l=new Map;for(const n of u)if(n instanceof P.SourceBreakpoint){let i=l.get(n.location.uri.toString());i||(i={type:"sourceMulti",uri:n.location.uri,lines:[]},l.set(n.location.uri.toString(),i),r.push(i)),i.lines.push({id:n.id,enabled:n.enabled,condition:n.condition,hitCondition:n.hitCondition,logMessage:n.logMessage,line:n.location.range.start.line,character:n.location.range.start.character})}else n instanceof P.FunctionBreakpoint&&r.push({type:"function",id:n.id,enabled:n.enabled,hitCondition:n.hitCondition,logMessage:n.logMessage,condition:n.condition,functionName:n.functionName});return this.k.$registerBreakpoints(r)}removeBreakpoints(c){this.U();const u=c.filter(i=>this.w.delete(i.id));this.V([],u,[]);const r=u.filter(i=>i instanceof P.SourceBreakpoint).map(i=>i.id),l=u.filter(i=>i instanceof P.FunctionBreakpoint).map(i=>i.id),n=u.filter(i=>i instanceof P.DataBreakpoint).map(i=>i.id);return this.k.$unregisterBreakpoints(r,l,n)}startDebugging(c,u,r){return this.k.$startDebugging(c?c.uri:void 0,u,{parentSessionID:r.parentSession?r.parentSession.id:void 0,lifecycleManagedByParent:r.lifecycleManagedByParent,repl:r.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:r.noDebug,compact:r.compact,suppressSaveBeforeStart:r.suppressSaveBeforeStart,suppressDebugStatusbar:r.suppressDebugStatusbar??r.debugUI?.simple,suppressDebugToolbar:r.suppressDebugToolbar??r.debugUI?.simple,suppressDebugView:r.suppressDebugView??r.debugUI?.simple})}stopDebugging(c){return this.k.$stopDebugging(c?c.id:void 0)}registerDebugConfigurationProvider(c,u,r){if(!u)return new P.Disposable(()=>{});const l=this.d++;return this.f.push({type:c,handle:l,provider:u}),this.k.$registerDebugConfigurationProvider(c,r,!!u.provideDebugConfigurations,!!u.resolveDebugConfiguration,!!u.resolveDebugConfigurationWithSubstitutedVariables,l),new P.Disposable(()=>{this.f=this.f.filter(n=>n.provider!==u),this.k.$unregisterDebugConfigurationProvider(l)})}registerDebugAdapterDescriptorFactory(c,u,r){if(!r)return new P.Disposable(()=>{});if(!this.Q(c,u))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${u}' debugger.`);if(this.N(u))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const l=this.g++;return this.h.push({type:u,handle:l,factory:r}),this.k.$registerDebugAdapterDescriptorFactory(u,l),new P.Disposable(()=>{this.h=this.h.filter(n=>n.factory!==r),this.k.$unregisterDebugAdapterDescriptorFactory(l)})}registerDebugAdapterTrackerFactory(c,u){if(!u)return new P.Disposable(()=>{});const r=this.i++;return this.j.push({type:c,handle:r,factory:u}),new P.Disposable(()=>{this.j=this.j.filter(l=>l.factory!==u)})}async $runInTerminal(c,u){return Promise.resolve(void 0)}async $substituteVariables(c,u){let r;const l=await this.X(c);return l&&(r={uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(r,u)}K(c,u){if(c.type==="implementation")return new b(c.implementation)}L(){}async $startDASession(c,u){const r=this,l=await this.W(u);return this.S(this.N(l.type),l).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}' (extension might have failed to activate)`);const i=this.M(n),p=this.K(i,l);if(!p)throw new Error(`Couldn't create a debug adapter for type '${l.type}'.`);const I=p;return this.B.set(c,I),this.R(l).then(L=>(L&&this.C.set(c,L),I.onMessage(async U=>{if(U.type==="request"&&U.command==="handshake"){const G=U,V={type:"response",seq:0,command:G.command,request_seq:G.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const O=await this.D.sign(G.arguments.value);V.body={signature:O},I.sendResponse(V)}else throw new Error("no signer")}catch(O){V.success=!1,V.message=O.message,I.sendResponse(V)}}else L&&L.onDidSendMessage&&L.onDidSendMessage(U),U=(0,v.convertToVSCPaths)(U,!0),r.k.$acceptDAMessage(c,U)}),I.onError(U=>{L&&L.onError&&L.onError(U),this.k.$acceptDAError(c,U.name,U.message,U.stack)}),I.onExit(U=>{L&&L.onExit&&L.onExit((0,k.withNullAsUndefined)(U),void 0),this.k.$acceptDAExit(c,(0,k.withNullAsUndefined)(U),void 0)}),L&&L.onWillStartSession&&L.onWillStartSession(),I.startSession()))})}$sendDAMessage(c,u){u=(0,v.convertToDAPaths)(u,!1);const r=this.C.get(c);r&&r.onWillReceiveMessage&&r.onWillReceiveMessage(u),this.B.get(c)?.sendMessage(u)}$stopDASession(c){const u=this.C.get(c);this.C.delete(c),u&&u.onWillStopSession&&u.onWillStopSession();const r=this.B.get(c);return this.B.delete(c),r?r.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(c){const u=[],r=[],l=[];if(c.added)for(const n of c.added){const i=n.id;if(i&&!this.w.has(i)){let p;if(n.type==="function")p=new P.FunctionBreakpoint(n.functionName,n.enabled,n.condition,n.hitCondition,n.logMessage);else if(n.type==="data")p=new P.DataBreakpoint(n.label,n.dataId,n.canPersist,n.enabled,n.hitCondition,n.condition,n.logMessage);else{const I=A.URI.revive(n.uri);p=new P.SourceBreakpoint(new P.Location(I,new P.Position(n.line,n.character)),n.enabled,n.condition,n.hitCondition,n.logMessage)}p._id=i,this.w.set(i,p),u.push(p)}}if(c.removed)for(const n of c.removed){const i=this.w.get(n);i&&(this.w.delete(n),r.push(i))}if(c.changed){for(const n of c.changed)if(n.id){const i=this.w.get(n.id);if(i){if(i instanceof P.FunctionBreakpoint&&n.type==="function"){const p=i;p.enabled=n.enabled,p.condition=n.condition,p.hitCondition=n.hitCondition,p.logMessage=n.logMessage,p.functionName=n.functionName}else if(i instanceof P.SourceBreakpoint&&n.type==="source"){const p=i;p.enabled=n.enabled,p.condition=n.condition,p.hitCondition=n.hitCondition,p.logMessage=n.logMessage,p.location=new P.Location(A.URI.revive(n.uri),new P.Position(n.line,n.character))}l.push(i)}}}this.V(u,r,l)}$provideDebugConfigurations(c,u,r){return(0,a.asPromise)(async()=>{const l=this.P(c);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const n=await this.X(u);return l.provideDebugConfigurations(n,r)}).then(l=>{if(!l)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return l})}$resolveDebugConfiguration(c,u,r,l){return(0,a.asPromise)(async()=>{const n=this.P(c);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const i=await this.X(u);return n.resolveDebugConfiguration(i,r,l)})}$resolveDebugConfigurationWithSubstitutedVariables(c,u,r,l){return(0,a.asPromise)(async()=>{const n=this.P(c);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const i=await this.X(u);return n.resolveDebugConfigurationWithSubstitutedVariables(i,r,l)})}async $provideDebugAdapter(c,u){const r=this.O(c);if(!r)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const l=await this.W(u);return this.S(r,l).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}'`);return this.M(n)})}async $acceptDebugSessionStarted(c){const u=await this.W(c);this.m.fire(u)}async $acceptDebugSessionTerminated(c){const u=await this.W(c);u&&(this.n.fire(u),this.l.delete(u.id))}async $acceptDebugSessionActiveChanged(c){this.q=c?await this.W(c):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(c,u){(await this.W(c))?._acceptNameChanged(u)}async $acceptDebugSessionCustomEvent(c,u){const l={session:await this.W(c),event:u.event,body:u.body};this.u.fire(l)}M(c){if(c instanceof P.DebugAdapterExecutable)return{type:"executable",command:c.command,args:c.args,options:c.options};if(c instanceof P.DebugAdapterServer)return{type:"server",port:c.port,host:c.host};if(c instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:c.path};if(c instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:c.implementation};throw new Error("convertToDto unexpected type")}N(c){const u=this.h.filter(r=>r.type===c);if(u.length>0)return u[0].factory}O(c){const u=this.h.filter(r=>r.handle===c);if(u.length>0)return u[0].factory}P(c){const u=this.f.filter(r=>r.handle===c);if(u.length>0)return u[0].provider}Q(c,u){if(c.contributes){const r=c.contributes.debuggers;if(r&&r.length>0){for(const l of r)if(l.label&&l.type&&l.type===u)return!0}}return!1}R(c){const r=c.configuration.type,l=this.j.filter(n=>n.type===r||n.type==="*").map(n=>(0,a.asPromise)(()=>n.factory.createDebugAdapterTracker(c)).then(i=>i,i=>null));return Promise.race([Promise.all(l).then(n=>{const i=n.filter(p=>!!p);if(i.length>0)return new f(i)}),new Promise((n,i)=>{const p=setTimeout(()=>{clearTimeout(p),i(new Error("timeout"))},1e3)})]).catch(n=>{})}async S(c,u){const r=u.configuration.debugServer;if(typeof r=="number")return Promise.resolve(new P.DebugAdapterServer(r));if(c){const n=await this.F.getExtensionRegistry();return(0,a.asPromise)(()=>c.createDebugAdapterDescriptor(u,this.T(u,n))).then(i=>{if(i)return i})}const l=await this.F.getExtensionRegistry();return Promise.resolve(this.T(u,l))}T(c,u){}U(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}V(c,u,r){(c.length>0||u.length>0||r.length>0)&&this.A.fire(Object.freeze({added:c,removed:u,changed:r}))}async W(c){if(c)if(typeof c=="string"){const u=this.l.get(c);if(u)return u}else{let u=this.l.get(c.id);if(!u){const r=await this.X(c.folderUri),l=c.parent?this.l.get(c.parent):void 0;u=new w(this.k,c.id,c.type,c.name,r,c.configuration,l),this.l.set(u.id,u),this.k.$sessionCached(u.id)}return u}throw new Error("cannot find session")}X(c){if(c){const u=A.URI.revive(c);return this.E.resolveWorkspaceFolder(u)}return Promise.resolve(void 0)}};h=Ve([We(0,R.IExtHostRpcService),We(1,E.IExtHostWorkspace),We(2,C.IExtHostExtensionService),We(3,d.IExtHostConfiguration),We(4,S.IExtHostEditorTabs),We(5,g.IExtHostVariableResolverProvider)],h),e.ExtHostDebugServiceBase=h;class w{constructor(c,u,r,l,n,i,p){this.d=c,this.f=u,this.g=r,this.h=l,this.i=n,this.j=i,this.k=p}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(c){this.h=c,this.d.$setDebugSessionName(this.f,c)}get parentSession(){return this.k}_acceptNameChanged(c){this.h=c}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(c,u){return this.d.$customDebugAdapterRequest(this.f,c,u)}getDebugProtocolBreakpoint(c){return this.d.$getDebugProtocolBreakpoint(this.f,c.id)}}e.ExtHostDebugSession=w;class m{constructor(c){this.value=Object.freeze({append(u){c.$appendDebugConsole(u)},appendLine(u){this.append(u+`
`)}})}}e.ExtHostDebugConsole=m;class f{constructor(c){this.d=c}onWillStartSession(){this.d.forEach(c=>c.onWillStartSession?c.onWillStartSession():void 0)}onWillReceiveMessage(c){this.d.forEach(u=>u.onWillReceiveMessage?u.onWillReceiveMessage(c):void 0)}onDidSendMessage(c){this.d.forEach(u=>u.onDidSendMessage?u.onDidSendMessage(c):void 0)}onWillStopSession(){this.d.forEach(c=>c.onWillStopSession?c.onWillStopSession():void 0)}onError(c){this.d.forEach(u=>u.onError?u.onError(c):void 0)}onExit(c,u){this.d.forEach(r=>r.onExit?r.onExit(c,u):void 0)}}class b extends y.AbstractDebugAdapter{constructor(c){super(),this.h=c,c.onDidSendMessage(u=>{this.acceptMessage(u)})}startSession(){return Promise.resolve(void 0)}sendMessage(c){this.h.handleMessage(c)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let s=class extends h{constructor(c,u,r,l,n,i){super(c,u,r,l,n,i)}};s=Ve([We(0,R.IExtHostRpcService),We(1,E.IExtHostWorkspace),We(2,C.IExtHostExtensionService),We(3,d.IExtHostConfiguration),We(4,S.IExtHostEditorTabs),We(5,g.IExtHostVariableResolverProvider)],s),e.WorkerExtHostDebugService=s}),define(Se[290],ye([1,0,10,75,2,5,282,13,86,87,25,197,16,55,41,94]),function(te,e,a,t,k,A,D,T,S,C,R,P,E,y,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class g{static async installEarlyHandler(m){const f=m.get(T.ILogService),s=m.get(E.IExtHostRpcService).getProxy(A.MainContext.MainThreadErrors);a.setUnexpectedErrorHandler(o=>{f.error(o);const c=a.transformErrorForSerialization(o);s.$onUnexpectedError(c)})}static async installFullHandler(m){const f=m.get(T.ILogService),b=m.get(E.IExtHostRpcService),s=m.get(v.IExtHostExtensionService),o=m.get(d.IExtHostTelemetry),c=b.getProxy(A.MainContext.MainThreadExtensionService),u=b.getProxy(A.MainContext.MainThreadErrors),r=await s.getExtensionPathIndex(),l=new WeakMap;Error.prepareStackTrace=(n,i)=>{let p="",I,L;for(const U of i)p+=`
	at ${U.toString()}`,L=U.getFileName(),!I&&L&&(I=r.findSubstr(k.URI.file(L)));return l.set(n,I?.identifier),`${n.name||"Error"}: ${n.message||""}${p}`},a.setUnexpectedErrorHandler(n=>{f.error(n);const i=a.transformErrorForSerialization(n),p=l.get(n);if(!p){u.$onUnexpectedError(i);return}c.$onExtensionRuntimeError(p,i);const I=o.onExtensionError(p,n);f.trace("forwarded error to extension?",I,p)})}}Error.stackTraceLimit=100;class h{constructor(m,f,b,s,o){this.a=b,this.b=new D.RPCProtocol(m,null,s),f=h.e(f,this.b);const c=new C.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());c.set(R.IExtHostInitDataService,{_serviceBrand:void 0,...f,messagePorts:o}),c.set(E.IExtHostRpcService,new E.ExtHostRpcService(this.b)),c.set(y.IURITransformerService,new y.URITransformerService(s)),c.set(v.IHostUtils,b);const u=new P.InstantiationService(c,!0);u.invokeFunction(g.installEarlyHandler),this.d=u.invokeFunction(r=>r.get(T.ILogService)),t.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",f),this.c=u.invokeFunction(r=>r.get(v.IExtHostExtensionService)),this.c.initialize(),u.invokeFunction(g.installFullHandler)}async asBrowserUri(m){const f=this.b.getProxy(A.MainContext.MainThreadExtensionService);return k.URI.revive(await f.$asBrowserUri(m))}terminate(m){this.c.terminate(m)}static e(m,f){m.allExtensions.forEach(s=>{s.extensionLocation=k.URI.revive(f.transformIncomingURIs(s.extensionLocation));const o={};s.browserNlsBundleUris&&(Object.keys(s.browserNlsBundleUris).forEach(c=>o[c]=k.URI.revive(f.transformIncomingURIs(s.browserNlsBundleUris[c]))),s.browserNlsBundleUris=o)}),m.environment.appRoot=k.URI.revive(f.transformIncomingURIs(m.environment.appRoot));const b=m.environment.extensionDevelopmentLocationURI;return b&&(m.environment.extensionDevelopmentLocationURI=b.map(s=>k.URI.revive(f.transformIncomingURIs(s)))),m.environment.extensionTestsLocationURI=k.URI.revive(f.transformIncomingURIs(m.environment.extensionTestsLocationURI)),m.environment.globalStorageHome=k.URI.revive(f.transformIncomingURIs(m.environment.globalStorageHome)),m.environment.workspaceStorageHome=k.URI.revive(f.transformIncomingURIs(m.environment.workspaceStorageHome)),m.environment.extensionTelemetryLogResource=k.URI.revive(f.transformIncomingURIs(m.environment.extensionTelemetryLogResource)),m.nlsBaseUrl=k.URI.revive(f.transformIncomingURIs(m.nlsBaseUrl)),m.logsLocation=k.URI.revive(f.transformIncomingURIs(m.logsLocation)),m.logFile=k.URI.revive(f.transformIncomingURIs(m.logFile)),m.workspace=f.transformIncomingURIs(m.workspace),m}}e.ExtensionHostMain=h}),define(Se[291],ye([1,0,18,12,180,196,204,76,59,41,16,40,7,47,33,218,220,34]),function(te,e,a,t,k,A,D,T,S,C,R,P,E,y,v,d,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let w=class extends T.ExtHostDebugServiceBase{constructor(o,c,u,r,l,n,i){super(o,c,u,r,n,i),this.bb=l,this.Y=new b}K(o,c){switch(o.type){case"server":return new d.SocketDebugAdapter(o);case"pipeServer":return new d.NamedPipeDebugAdapter(o);case"executable":return new d.ExecutableDebugAdapter(o,c.type)}return super.K(o,c)}T(o,c){const u=d.ExecutableDebugAdapter.platformAdapterExecutable(c.getAllExtensionDescriptions(),o.type);if(u)return new E.DebugAdapterExecutable(u.command,u.args,u.options)}L(){return new D.SignService}async $runInTerminal(o,c){if(o.kind==="integrated"){this.ab||(this.ab=this.bb.onDidCloseTerminal(O=>{this.Y.onTerminalClosed(O)}));const u=await this.G.getConfigProvider(),r=this.bb.getDefaultShell(!0),l=this.bb.getDefaultShellArgs(!0),n=o.title||k.localize(0,null),i=JSON.stringify({shell:r,shellArgs:l});let p=await this.Y.checkout(i,n),I,L=!1;if(p)I=o.cwd;else{const O={shellPath:r,shellArgs:l,cwd:o.cwd,name:n,iconPath:new E.ThemeIcon("debug")};L=!0,p=this.bb.createTerminalFromOptions(O,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.Y.insert(p,i)}p.show(!0);const U=await p.processId;L?await new Promise(O=>setTimeout(O,1e3)):u.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(r.indexOf("powershell")>=0||r.indexOf("pwsh")>=0||r.indexOf("cmd.exe")>=0?p.sendText("cls"):r.indexOf("bash")>=0?p.sendText("clear"):t.isWindows?p.sendText("cls"):p.sendText("clear"));const G=(0,g.prepareCommand)(r,o.args,!!o.argsCanBeInterpretedByShell,I,o.env);p.sendText(G);const V=this.onDidTerminateDebugSession(O=>{O.id===c&&(this.Y.free(p),V.dispose())});return U}else if(o.kind==="external")return f(o,await this.G.getConfigProvider());return super.$runInTerminal(o,c)}};w=Ve([We(0,R.IExtHostRpcService),We(1,v.IExtHostWorkspace),We(2,C.IExtHostExtensionService),We(3,h.IExtHostConfiguration),We(4,P.IExtHostTerminalService),We(5,S.IExtHostEditorTabs),We(6,y.IExtHostVariableResolverProvider)],w),e.ExtHostDebugService=w;let m;function f(s,o){if(!m)if(t.isWindows)m=new A.WindowsExternalTerminalService;else if(t.isMacintosh)m=new A.MacExternalTerminalService;else if(t.isLinux)m=new A.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const c=o.getConfiguration("terminal");return m.runInTerminal(s.title,s.cwd,s.args,s.env||{},c.external||{})}class b{constructor(){this.b=new Map}async checkout(o,c){const r=[...this.b.entries()].map(([l,n])=>(0,a.createCancelablePromise)(async i=>{if(l.name!==c||n.lastUsedAt!==-1&&await(0,g.hasChildProcesses)(await l.processId))return null;const p=Date.now();return n.lastUsedAt+b.a>p||i.isCancellationRequested||n.config!==o?null:(n.lastUsedAt=p,l)}));return await(0,a.firstParallel)(r,l=>!!l)}insert(o,c){this.b.set(o,{lastUsedAt:Date.now(),config:c})}free(o){const c=this.b.get(o);c&&(c.lastUsedAt=-1)}onTerminalClosed(o){this.b.delete(o)}}b.a=1e3}),define(Se[292],ye([1,0,9,2,114,33,58,34,45,40,16,25,74,15,13,69,24,85,47]),function(te,e,a,t,k,A,D,T,S,C,R,P,E,y,v,d,g,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let m=class extends E.ExtHostTaskBase{constructor(b,s,o,c,u,r,l,n,i){super(b,s,o,c,u,r,l,n),this.C=o,this.D=i,s.remote.isRemote&&s.remote.authority?this.registerTaskSystem(y.Schemas.vscodeRemote,{scheme:y.Schemas.vscodeRemote,authority:s.remote.authority,platform:process.platform}):this.registerTaskSystem(y.Schemas.file,{scheme:y.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(b,s){const o=s;if(!s.execution&&o._id===void 0)throw new Error("Tasks to execute must include an execution");if(o._id!==void 0){const c=E.TaskHandleDTO.from(o,this.C),u=await this.a.$getTaskExecution(c);if(u.task===void 0)throw new Error("Task from execution DTO is undefined");const r=await this.y(u,s);return this.a.$executeTask(c).catch(()=>{}),r}else{const c=E.TaskDTO.from(s,b);if(c===void 0)return Promise.reject(new Error("Task is not valid"));E.CustomExecutionDTO.is(c.execution)&&await this.x(c,s,!1);const u=await this.y(await this.a.$getTaskExecution(c),s);return this.a.$executeTask(c).catch(()=>{}),u}}u(b,s,o,c){const u=[];if(c)for(const r of c){this.A(r,o),(!r.definition||!b[r.definition.type])&&this.f.warn(`The task [${r.source}, ${r.name}] uses an undefined task type. The task will be ignored in the future.`);const l=E.TaskDTO.from(r,o.extension);l&&(u.push(l),E.CustomExecutionDTO.is(l.execution)&&s.push(this.x(l,r,!0)))}return{tasks:u,extension:o.extension}}async v(b){return b}async G(b){let s=b&&b.length>0?b[0]:void 0;if(!s){const o=t.URI.file((0,h.homedir)());s=new S.WorkspaceFolder({uri:o,name:g.basename(o),index:0})}return{uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(b,s){const o=t.URI.revive(b),c={process:void 0,variables:Object.create(null)},u=await this.b.resolveWorkspaceFolder(o),r=await this.b.getWorkspaceFolders2()??[],l=await this.D.getResolver(),n=u?{uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(r);for(const i of s.variables)c.variables[i]=await l.resolveAsync(n,i);if(s.process!==void 0){let i;if(s.process.path!==void 0){i=s.process.path.split(a.delimiter);for(let p=0;p<i.length;p++)i[p]=await l.resolveAsync(n,i[p])}c.process=await k.win32.findExecutable(await l.resolveAsync(n,s.process.name),s.process.cwd!==void 0?await l.resolveAsync(n,s.process.cwd):void 0,i)}return c}async $jsonTasksSupported(){return!0}async $findExecutable(b,s,o){return k.win32.findExecutable(b,s,o)}};m=Ve([We(0,R.IExtHostRpcService),We(1,P.IExtHostInitDataService),We(2,A.IExtHostWorkspace),We(3,D.IExtHostDocumentsAndEditors),We(4,T.IExtHostConfiguration),We(5,C.IExtHostTerminalService),We(6,v.ILogService),We(7,d.IExtHostApiDeprecationService),We(8,w.IExtHostVariableResolverProvider)],m),e.ExtHostTask=m}),define(Se[293],ye([1,0,85,47]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class k extends t.ExtHostVariableResolverProviderService{j(){return(0,a.homedir)()}}e.NodeExtHostVariableResolverProviderService=k}),define(Se[142],ye([1,0,17,18,21,50,15,9,24,2,31]),function(te,e,a,t,k,A,D,T,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class P{constructor(w,m,f,b){this.d=w,this.e=m,this.f=f,this.g=b,this.a=null,this.b=!1,this.c=0}search(w,m){const f=this.d.folderQueries||[],b=new k.CancellationTokenSource;return m.onCancellationRequested(()=>b.cancel()),new Promise((s,o)=>{this.a=new y(w);let c=!1;const u=(r,l)=>{if(!c&&!this.b){const n=this.h(r);d(r)&&typeof this.d.maxResults=="number"&&this.c+n>this.d.maxResults&&(this.b=!0,c=!0,b.cancel(),r=this.j(r,this.d.maxResults-this.c));const i=this.h(r);this.c+=i,(i>0||!d(r))&&this.a.add(r,l)}};Promise.all(f.map((r,l)=>this.k(r,n=>u(n,l),b.token))).then(r=>{b.dispose(),this.a.flush();const l=r.some(n=>!!n&&!!n.limitHit);s({limitHit:this.b||l,messages:(0,a.flatten)(r.map(n=>n?.message?Array.isArray(n.message)?n.message:[n.message]:[])),stats:{type:this.g}})},r=>{b.dispose();const l=(0,A.toErrorMessage)(r);o(new Error(l))})})}h(w){return d(w)?Array.isArray(w.ranges)?w.ranges.length:1:0}j(w,m){const f=Array.isArray(w.ranges)?w.ranges:[w.ranges],b=Array.isArray(w.preview.matches)?w.preview.matches:[w.preview.matches];return{ranges:f.slice(0,m),preview:{matches:b.slice(0,m),text:w.preview.text},uri:w.uri}}async k(w,m,f){const b=new R.QueryGlobTester(this.d,w),s=[],o={report:r=>{if(!this.l(r))return;const l=w.folder.scheme===D.Schemas.file?(0,R.hasSiblingPromiseFn)(()=>this.f.readdir(S.dirname(r.uri))):void 0,n=S.relativePath(w.folder,r.uri);if(n){const i=b.includedInQuery(n,T.basename(n),l);(0,t.isThenable)(i)?s.push(i.then(p=>{p&&m(r)})):i&&m(r)}}},c=this.n(w),u=await this.e.provideTextSearchResults(E(this.d.contentPattern),c,o,f);return s.length&&await Promise.all(s),u}l(w){if(d(w)){if(Array.isArray(w.ranges)){if(!Array.isArray(w.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(w.preview.matches.length!==w.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(w.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(w){const m=(0,R.resolvePatternsForProvider)(this.d.includePattern,w.includePattern),f=(0,R.resolvePatternsForProvider)(this.d.excludePattern,w.excludePattern),b={folder:C.URI.from(w.folder),excludes:f,includes:m,useIgnoreFiles:!w.disregardIgnoreFiles,useGlobalIgnoreFiles:!w.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!w.disregardParentIgnoreFiles,followSymlinks:!w.ignoreSymlinks,encoding:w.fileEncoding&&this.f.toCanonicalName(w.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return b.usePCRE2=this.d.usePCRE2,b}}e.TextSearchManager=P;function E(h){return{isCaseSensitive:h.isCaseSensitive||!1,isRegExp:h.isRegExp||!1,isWordMatch:h.isWordMatch||!1,isMultiline:h.isMultiline||!1,pattern:h.pattern}}class y{constructor(w){this.e=w,this.b=-1,this.d=null,this.a=new g(512,m=>this.g(m))}add(w,m){this.d&&(this.b!==m||!S.isEqual(this.c,w.uri))&&(this.f(),this.d=null),this.d||(this.b=m,this.d={resource:w.uri,results:[]}),this.d.results.push(v(w))}f(){const w=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,w)}flush(){this.f(),this.a.flush()}g(w){this.e(w)}}e.TextSearchResultsCollector=y;function v(h){return d(h)?{preview:{matches:(0,a.mapArrayOrNot)(h.preview.matches,w=>({startLineNumber:w.start.line,startColumn:w.start.character,endLineNumber:w.end.line,endColumn:w.end.character})),text:h.preview.text},ranges:(0,a.mapArrayOrNot)(h.ranges,w=>({startLineNumber:w.start.line,startColumn:w.start.character,endLineNumber:w.end.line,endColumn:w.end.character}))}:{text:h.text,lineNumber:h.lineNumber}}function d(h){return!!h.preview}e.extensionResultIsMatch=d;class g{constructor(w,m){this.g=w,this.h=m,this.c=0,this.d=[],this.e=0}addItem(w,m){!w||this.j(w,m)}addItems(w,m){!w||this.k(w,m)}j(w,m){this.d.push(w),this.e+=m,this.l()}k(w,m){this.d=this.d.concat(w),this.e+=m,this.l()}l(){this.c<g.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},g.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.BatchedCollector=g,g.a=4e3,g.b=50}),define(Se[77],ye([1,0,6,5,3,286,16,55,13,2,142]),function(te,e,a,t,k,A,D,T,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,k.createDecorator)("IExtHostSearch");let P=class{constructor(d,g,h){this.k=d,this.l=g,this.n=h,this.c=this.k.getProxy(t.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new A.FileSearchManager}o(d){return this.l.transformOutgoingScheme(d)}registerTextSearchProvider(d,g){if(this.g.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this.g.add(d);const h=this.d++;return this.e.set(h,g),this.c.$registerTextSearchProvider(h,this.o(d)),(0,a.toDisposable)(()=>{this.g.delete(d),this.e.delete(h),this.c.$unregisterProvider(h)})}registerFileSearchProvider(d,g){if(this.i.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this.i.add(d);const h=this.d++;return this.h.set(h,g),this.c.$registerFileSearchProvider(h,this.o(d)),(0,a.toDisposable)(()=>{this.i.delete(d),this.h.delete(h),this.c.$unregisterProvider(h)})}$provideFileSearchResults(d,g,h,w){const m=E(h),f=this.h.get(d);if(f)return this.j.fileSearch(m,f,b=>{this.c.$handleFileMatch(d,g,b.map(s=>s.resource))},w);throw new Error("unknown provider: "+d)}$clearCache(d){return this.j.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,g,h,w){const m=this.e.get(d);if(!m||!m.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const f=E(h);return this.q(f,m).search(s=>this.c.$handleTextMatch(d,g,s),w)}$enableExtensionHostSearch(){}q(d,g){return new R.TextSearchManager(d,g,{readdir:h=>Promise.resolve([]),toCanonicalName:h=>h},"textSearchProvider")}};P=Ve([We(0,D.IExtHostRpcService),We(1,T.IURITransformerService),We(2,S.ILogService)],P),e.ExtHostSearch=P;function E(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(y),extraFileResources:v.extraFileResources&&v.extraFileResources.map(d=>C.URI.revive(d))}}e.reviveQuery=E;function y(v){return{...v,folder:C.URI.revive(v.folder)}}}),define(Se[294],ye([1,0,86,141,33,138,34,39,58,40,74,76,77,97,54,69,140,70,46,96,94,59,139,13,231,47,95]),function(te,e,a,t,k,A,D,T,S,C,R,P,E,y,v,d,g,h,w,m,f,b,s,o,c,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(r.IExtHostLocalizationService,r.ExtHostLocalizationService,1),(0,a.registerSingleton)(o.ILoggerService,s.ExtHostLoggerService,1),(0,a.registerSingleton)(o.ILogService,c.ExtHostLogService,1),(0,a.registerSingleton)(d.IExtHostApiDeprecationService,d.ExtHostApiDeprecationService,1),(0,a.registerSingleton)(T.IExtHostCommands,T.ExtHostCommands,0),(0,a.registerSingleton)(D.IExtHostConfiguration,D.ExtHostConfiguration,0),(0,a.registerSingleton)(h.IExtHostConsumerFileSystem,h.ExtHostConsumerFileSystem,0),(0,a.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService,0),(0,a.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations,0),(0,a.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors,0),(0,a.registerSingleton)(w.IExtHostFileSystemInfo,w.ExtHostFileSystemInfo,0),(0,a.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService,1),(0,a.registerSingleton)(E.IExtHostSearch,E.ExtHostSearch,0),(0,a.registerSingleton)(y.IExtHostStorage,y.ExtHostStorage,0),(0,a.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask,0),(0,a.registerSingleton)(C.IExtHostTerminalService,C.WorkerExtHostTerminalService,0),(0,a.registerSingleton)(v.IExtHostTunnelService,v.ExtHostTunnelService,0),(0,a.registerSingleton)(g.IExtHostWindow,g.ExtHostWindow,0),(0,a.registerSingleton)(k.IExtHostWorkspace,k.ExtHostWorkspace,0),(0,a.registerSingleton)(m.IExtHostSecretState,m.ExtHostSecretState,0),(0,a.registerSingleton)(f.IExtHostTelemetry,f.ExtHostTelemetry,0),(0,a.registerSingleton)(b.IExtHostEditorTabs,b.ExtHostEditorTabs,0),(0,a.registerSingleton)(u.IExtHostVariableResolverProvider,u.ExtHostVariableResolverProviderService,0)}),define(Se[98],ye([1,0,17,13,31,73]),function(te,e,a,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function D(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.anchorGlob=D;function T(P,E,y,v){const d=(0,a.mapArrayOrNot)(y,S),g=new k.TextSearchMatch(E,d,v),h=g.preview.matches;return{ranges:(0,a.mapArrayOrNot)(d,C),uri:P,preview:{text:g.preview.text,matches:(0,a.mapArrayOrNot)(h,C)}}}e.createTextSearchResult=T;function S(P){return new k.SearchRange(P.start.line,P.start.character,P.end.line,P.end.character)}function C(P){return new A.Range(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let R=class{constructor(E,y){this.a=E,this.b=y}appendLine(E){this.b.debug(`${this.a}#search`,E)}};R=Ve([We(1,t.ILogService)],R),e.OutputChannel=R}),define(Se[295],ye([1,0,44,9,81,32,12,8,98,296]),function(te,e,a,t,k,A,D,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const R=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(m,f,b,s){const o=E(m,f,b,s),c=f.folder.fsPath;return{cmd:a.spawn(R,o.args,{cwd:c}),rgDiskPath:R,siblingClauses:o.siblingClauses,rgArgs:o,cwd:c}}e.spawnRipgrepCmd=P;function E(m,f,b,s){const o=["--files","--hidden","--case-sensitive"];v([f],b,!1).forEach(u=>{const r=(0,S.anchorGlob)(u);if(o.push("-g",r),D.isMacintosh){const l=(0,k.normalizeNFD)(r);l!==r&&o.push("-g",l)}});const c=y([f],s,void 0,!1);return c.globArgs.forEach(u=>{const r=`!${(0,S.anchorGlob)(u)}`;if(o.push("-g",r),D.isMacintosh){const l=(0,k.normalizeNFD)(r);l!==r&&o.push("-g",l)}}),f.disregardIgnoreFiles!==!1?o.push("--no-ignore"):f.disregardParentIgnoreFiles!==!1&&o.push("--no-ignore-parent"),f.ignoreSymlinks||o.push("--follow"),m.exists&&o.push("--quiet"),o.push("--no-config"),f.disregardGlobalIgnoreFiles&&o.push("--no-ignore-global"),{args:o,siblingClauses:c.siblingClauses}}function y(m,f,b,s=!0){const o=[];let c={};return m.forEach(u=>{const r=Object.assign({},u.excludePattern||{},f||{}),l=d(r,s?u.folder.fsPath:void 0,b);o.push(...l.globArgs),l.siblingClauses&&(c=Object.assign(c,l.siblingClauses))}),{globArgs:o,siblingClauses:c}}e.foldersToRgExcludeGlobs=y;function v(m,f,b=!0){const s=[];return m.forEach(o=>{const c=Object.assign({},f||{},o.includePattern||{}),u=d(c,b?o.folder.fsPath:void 0);s.push(...u.globArgs)}),s}e.foldersToIncludeGlobs=v;function d(m,f,b){const s=[],o={};return Object.keys(m).forEach(c=>{if(b&&b.has(c)||!c)return;const u=m[c];c=h(f?g(f,c):c),c.startsWith("\\\\")?c="\\\\"+c.substr(2).replace(/\\/g,"/"):c=c.replace(/\\/g,"/"),typeof u=="boolean"&&u?(c.startsWith("\\\\")&&(c+="**"),s.push(w(c))):u&&u.when&&(o[c]=u)}),{globArgs:s,siblingClauses:o}}function g(m,f){return t.isAbsolute(f)?f:t.join(m,f)}e.getAbsoluteGlob=g;function h(m){return m=T.rtrim(m,"\\"),T.rtrim(m,"/")}function w(m){return A.getRoot(m).toLowerCase()==="c:/"?m.replace(/^c:[/\\]/i,"/"):m}e.fixDriveC=w}),define(Se[297],ye([1,0,44,65,9,298,17,50,37,81,32,12,51,8,11,29,31,295,109]),function(te,e,a,t,k,A,D,T,S,C,R,P,E,y,v,d,g,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const m=new Set;process.on("exit",()=>{m.forEach(c=>c())});class f{constructor(u){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=u,this.b=u.filePattern||"",this.d=u.includePattern&&S.parse(u.includePattern),this.f=u.maxResults||null,this.g=!!u.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,w.prepareQuery)(this.b).normalizedLowercase),this.u=u.excludePattern&&S.parse(u.excludePattern),this.t=new Map,u.folderQueries.forEach(r=>{const l=Object.assign({},r.excludePattern||{},this.a.excludePattern||{}),n=r.folder.fsPath;u.folderQueries.map(i=>i.folder.fsPath).filter(i=>i!==n).forEach(i=>{(0,R.isEqualOrParent)(i,n)&&(l[k.relative(n,i)]=!0)}),this.t.set(n,new s(l,n))})}cancel(){this.l=!0,m.forEach(u=>u())}walk(u,r,l,n,i){if(this.m=E.StopWatch.create(!1),this.l)return i(null,this.j);r.forEach(p=>{const I=k.basename(p.fsPath);this.u&&this.u(p.fsPath,I)||this.K(l,{relativePath:p.fsPath,searchPath:void 0})}),this.r=E.StopWatch.create(!1),this.w(u,(p,I)=>{this.x(this.y,this,p,l,n,L=>{if(L){const U=(0,T.toErrorMessage)(L);console.error(U),this.q.push(U),I(L,void 0)}else I(null,void 0)})},(p,I)=>{this.m.stop();const L=p?D.coalesce(p)[0]:null;i(L,this.j)})}w(u,r,l){const n=new Array(u.length),i=new Array(u.length);let p=!1,I=0;if(u.length===0)return l(null,[]);u.forEach((L,U)=>{r(L,(G,V)=>{if(G?(p=!0,n[U]=null,i[U]=G):(n[U]=V,i[U]=null),++I===u.length)return l(p?i:null,n)})})}x(u,r,...l){try{u.apply(r,l)}catch(n){l[l.length-1](n)}}y(u,r,l,n){const i=u.folder.fsPath,p=P.isMacintosh,I=()=>O&&O.kill();m.add(I);let L=M=>{m.delete(I),L=()=>{},n(M)},U="";const G=this.G(),V=(0,h.spawnRipgrepCmd)(this.a,u,this.a.includePattern,this.t.get(u.folder.fsPath).expression),O=V.cmd,B=!Object.keys(V.siblingClauses).length,F=V.rgArgs.args.map(M=>M.match(/^-/)?M:`'${M}'`).join(" ");let $=`${V.rgDiskPath} ${F}
 - cwd: ${V.cwd}`;V.rgArgs.siblingClauses&&($+=`
 - Sibling clauses: ${JSON.stringify(V.rgArgs.siblingClauses)}`),l({message:$}),this.s=0,this.A(O,"utf8",l,(M,H,K)=>{if(M){L(M);return}if(this.j){L();return}const Y=(U+(p?C.normalizeNFC(H||""):H)).split(`
`);if(K){const Q=Y.length;Y[Q-1]=Y[Q-1].trim(),Y[Q-1]||Y.pop()}else U=Y.pop()||"";if(Y.length&&Y[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.s+=Y.length,B){for(const Q of Y)if(this.K(r,{base:i,relativePath:Q,searchPath:this.O(u,Q)}),this.j){I();break}(K||this.j)&&L();return}this.H(u,G,i,Y,r),K&&(this.I(G,i,r),L())})}spawnFindCmd(u){const r=this.t.get(u.folder.fsPath),l=r.getBasenameTerms(),n=r.getPathTerms(),i=["-L","."];if(l.length||n.length){i.push("-not","(","(");for(const p of l)i.push("-name",p),i.push("-o");for(const p of n)i.push("-path",p),i.push("-o");i.pop(),i.push(")","-prune",")")}return i.push("-type","f"),a.spawn("find",i,{cwd:u.folder.fsPath})}readStdout(u,r,l){let n="";this.A(u,r,()=>{},(i,p,I)=>{if(i){l(i);return}n+=p,I&&l(null,n)})}A(u,r,l,n){let i=(L,U,G)=>{(L||G)&&(i=()=>{},this.r?.stop()),n(L,U,G)},p=!1;u.stdout?(this.B(u.stdout,r,i),u.stdout.once("data",()=>p=!0)):l({message:"stdout is null"});let I;u.stderr?I=this.C(u.stderr):l({message:"stderr is null"}),u.on("error",L=>{i(L)}),u.on("close",L=>{let U;!p&&(U=this.D(I,r))&&o(U)?i(new Error(`command failed with error code ${L}: ${this.D(I,r)}`)):(this.g&&L===0&&(this.j=!0),i(null,"",!0))})}B(u,r,l){const n=new A.StringDecoder(r);return u.on("data",i=>{l(null,n.write(i))}),n}C(u){const r=[];return u.on("data",l=>{r.push(l)}),r}D(u,r){const l=new A.StringDecoder(r);return u.map(n=>l.write(n)).join("")}G(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}H(u,{pathToEntries:r},l,n,i){n.indexOf(this.b)!==-1&&this.K(i,{base:l,relativePath:this.b,searchPath:this.O(u,this.b)});const p=I=>{const L=k.basename(I),U=k.dirname(I);let G=r[U];G||(G=r[U]=[],p(U)),G.push({base:l,relativePath:I,basename:L,searchPath:this.O(u,I)})};n.forEach(p)}I({rootEntries:u,pathToEntries:r},l,n){const i=this,p=this.t.get(l),I=this.b;function L(U){i.o++;const G=(0,g.hasSiblingFn)(()=>U.map(V=>V.basename));for(let V=0,O=U.length;V<O;V++){const B=U[V],{relativePath:F,basename:$}=B;if(p.test(F,$,I!==$?G:void 0))continue;const M=r[F];if(M)L(M);else{if(i.p++,F===I)continue;i.K(n,B)}if(i.j)break}}L(u)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}J(u,r,l,n,i){const p=u.folder,I=(0,g.hasSiblingFn)(()=>l);this.w(l,(L,U)=>{if(this.l||this.j)return U(null);const G=r?[r,L].join(k.sep):L;if(this.t.get(u.folder.fsPath).test(G,L,this.a.filePattern!==L?I:void 0))return U(null);const V=[p.fsPath,G].join(k.sep);t.lstat(V,(O,B)=>{if(O||this.l||this.j)return U(null);this.M(V,B,(F,$)=>F||this.l||this.j?U(null):$.isDirectory()?(this.o++,this.N(V,B,(M,H)=>M||this.l||this.j||(H=H||"",this.v[H])?U(null):(this.v[H]=!0,d.Promises.readdir(V).then(K=>{if(this.l||this.j)return U(null);this.J(u,G,K,n,q=>U(q||null))},K=>{U(null)})))):(this.p++,G===this.b||this.h&&v.isNumber($.size)&&$.size>this.h||this.K(n,{base:p.fsPath,relativePath:G,searchPath:this.O(u,G)}),U(null,void 0)))})},L=>{const U=L&&D.coalesce(L);return i(U&&U.length>0?U[0]:void 0)})}K(u,r){this.L(r)&&(!this.d||this.d(r.relativePath,k.basename(r.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||u(r))}L(u){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,g.isFilePatternMatch)(u,this.c)}return!0}M(u,r,l){return r.isSymbolicLink()?t.stat(u,l):l(null,r)}N(u,r,l){return r.isSymbolicLink()?t.realpath(u,(n,i)=>n?l(n):l(null,i)):l(null,u)}O(u,r){return u.folderName?k.join(u.folderName,r):r}}e.FileWalker=f;class b{constructor(u){this.a=u.folderQueries,this.b=u.extraFileResources||[],this.c=new f(u)}search(u,r,l){this.c.walk(this.a,this.b,u,r,(n,i)=>{l(n,{limitHit:i,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.Engine=b;class s{constructor(u,r){this.expression=u,this.c=r,this.d(u)}d(u){let r,l;Object.keys(u).filter(n=>u[n]).forEach(n=>{k.isAbsolute(n)?(r=r||S.getEmptyExpression(),r[n]=u[n]):(l=l||S.getEmptyExpression(),l[n]=u[n])}),this.a=r&&S.parse(r,{trimForExclusions:!0}),this.b=l&&S.parse(l,{trimForExclusions:!0})}test(u,r,l){return this.b&&this.b(u,r,l)||this.a&&this.a(k.join(this.c,u),r,l)}getBasenameTerms(){const u=[];return this.a&&u.push(...S.getBasenameTerms(this.a)),this.b&&u.push(...S.getBasenameTerms(this.b)),u}getPathTerms(){const u=[];return this.a&&u.push(...S.getPathTerms(this.a)),this.b&&u.push(...S.getPathTerms(this.b)),u}}function o(c){const u=c.trim().split(`
`),r=u[0].trim();if(r.startsWith("Error parsing regex"))return r;if(r.startsWith("regex parse error"))return y.uppercaseFirstLetter(u[u.length-1].trim());if(r.startsWith("error parsing glob")||r.startsWith("unsupported encoding"))return r.charAt(0).toUpperCase()+r.substr(1);if(r==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(r.startsWith("Literal "))return r}e.rgErrorMsgForDisplay=o}),define(Se[299],ye([1,0,101,22]),function(te,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function k(c){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(u=>u===c)}e.isUTFEncoding=k,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const A=512,D=512,T=512*8,S=512*128;var C;(function(c){c[c.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class R extends Error{constructor(u,r){super(u),this.decodeStreamErrorKind=r}}e.DecodeStreamError=R;class P{static async create(u){let r;if(u!==e.UTF8)r=(await new Promise((n,i)=>{te(["@vscode/iconv-lite-umd"],n,i)})).getDecoder(d(u));else{const l=new TextDecoder;r={write(n){return l.decode(n,{stream:!0})},end(){return l.decode()}}}return new P(r)}constructor(u){this.a=u}write(u){return this.a.write(u)}end(){return this.a.end()}}function E(c,u){const r=u.minBytesRequiredForDetection??u.guessEncoding?T:D;return new Promise((l,n)=>{const i=(0,a.newWriteableStream)(V=>V.join("")),p=[];let I=0,L,U;const G=async()=>{try{const V=await o({buffer:t.VSBuffer.concat(p),bytesRead:I},u.guessEncoding);if(V.seemsBinary&&u.acceptTextOnly)throw new R("Stream is binary but only text is accepted for decoding",1);V.encoding=await u.overwriteEncoding(V.encoding),L=await P.create(V.encoding);const O=L.write(t.VSBuffer.concat(p).buffer);i.write(O),p.length=0,I=0,l({stream:i,detected:V})}catch(V){U?.dispose(),i.destroy(),n(V)}};U=(0,a.listenStream)(c,{onData:async V=>{L?i.write(L.write(V.buffer)):(p.push(V),I+=V.byteLength,I>=r&&(c.pause(),await G(),setTimeout(()=>c.resume())))},onError:V=>i.error(V),onEnd:async()=>{L||await G(),i.end(L?.end())}})})}e.toDecodeStream=E;async function y(c,u,r){const n=(await new Promise((I,L)=>{te(["@vscode/iconv-lite-umd"],I,L)})).getEncoder(d(u),r);let i=!1,p=!1;return{read(){if(p)return null;const I=c.read();if(typeof I!="string"){if(p=!0,!i&&r?.addBOM)switch(u){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const L=n.end();return L&&L.length>0?(i=!0,t.VSBuffer.wrap(L)):null}return i=!0,t.VSBuffer.wrap(n.write(I))}}}e.toEncodeReadable=y;async function v(c){return(await new Promise((r,l)=>{te(["@vscode/iconv-lite-umd"],r,l)})).encodingExists(d(c))}e.encodingExists=v;function d(c){return c===e.UTF8_with_bom||c===null?e.UTF8:c}e.toNodeEncoding=d;function g(c,u){if(!c||u<e.UTF16be_BOM.length)return null;const r=c.readUInt8(0),l=c.readUInt8(1);if(r===e.UTF16be_BOM[0]&&l===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&l===e.UTF16le_BOM[1])return e.UTF16le;if(u<e.UTF8_BOM.length)return null;const n=c.readUInt8(2);return r===e.UTF8_BOM[0]&&l===e.UTF8_BOM[1]&&n===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=g;const h=["ascii","utf-16","utf-32"];async function w(c){const u=await new Promise((p,I)=>{te(["jschardet"],p,I)}),r=c.slice(0,S),l=b(r.buffer),n=u.detect(l);if(!n||!n.encoding)return null;const i=n.encoding.toLowerCase();return 0<=h.indexOf(i)?null:f(n.encoding)}const m={ibm866:"cp866",big5:"cp950"};function f(c){const u=c.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return m[u]||u}function b(c){let u="";for(let r=0;r<c.length;r++)u+=String.fromCharCode(c[r]);return u}function s(c){switch(c){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const u=c.match(/windows(\d+)/);return u?"windows-"+u[1]:c}}}e.toCanonicalName=s;function o({buffer:c,bytesRead:u},r){let l=g(c,u),n=!1;if(l!==e.UTF16be&&l!==e.UTF16le&&c){let i=!0,p=!0,I=!1;for(let L=0;L<u&&L<A;L++){const U=L%2===1,G=c.readUInt8(L)===0;if(G&&(I=!0),i&&(U&&!G||!U&&G)&&(i=!1),p&&(U&&G||!U&&!G)&&(p=!1),G&&!i&&!p)break}I&&(i?l=e.UTF16le:p?l=e.UTF16be:n=!0)}return r&&!n&&!l&&c?w(c.slice(0,u)).then(i=>({seemsBinary:!1,encoding:i})):{seemsBinary:n,encoding:l}}e.detectEncodingFromBuffer=o,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Se[143],ye([1,0,299,29,142]),function(te,e,a,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class A extends k.TextSearchManager{constructor(T,S,C=t,R="searchProcess"){super(T,S,{readdir:P=>C.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,a.toCanonicalName)(P)},R)}}e.NativeTextSearchManager=A}),define(Se[300],ye([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class a{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(k){if(k&&this.a.has(k)){const A=this.a.get(k);return this.a.delete(k),A}}addDragOperationTransfer(k,A){this.a.set(k,A)}getRenderedTreeElement(k){if(this.b.has(k))return this.b.get(k)}addRenderedTreeItemElement(k,A){this.b.set(k,A)}removeRenderedTreeItemElement(k){this.b.has(k)&&this.b.delete(k)}}e.TreeviewsService=a}),define(Se[301],ye([1,0,178,7,24,2,4,6,18,7,11,17,14,21,300,26]),function(te,e,a,t,k,A,D,T,S,C,R,P,E,y,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(m,f){if((0,R.isString)(m))return{label:m};if(m&&typeof m=="object"&&typeof m.label=="string"){let b;return Array.isArray(m.highlights)&&(b=m.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),b=b.length?b:void 0),{label:m.label,highlights:b}}}class h{constructor(f,b,s){this.d=f,this.e=b,this.f=s,this.a=new Map,this.b=new v.TreeviewsService;function o(c){return c&&c.$treeViewId&&(c.$treeItemHandle||c.$selectedTreeItems||c.$focusedTreeItem)}b.registerArgumentProcessor({processArgument:c=>o(c)?this.i(c):Array.isArray(c)&&c.length>0?c.map(u=>o(u)?this.i(u):u):c})}registerTreeDataProvider(f,b,s){const o=this.createTreeView(f,{treeDataProvider:b},s);return{dispose:()=>o.dispose()}}createTreeView(f,b,s){if(!b||!b.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const o=b.dragAndDropController?.dropMimeTypes??[],c=b.dragAndDropController?.dragMimeTypes??[],u=!!b.dragAndDropController?.handleDrag,r=!!b.dragAndDropController?.handleDrop,l=this.h(f,b,s),n=this.d.$registerTreeViewDataProvider(f,{showCollapseAll:!!b.showCollapseAll,canSelectMany:!!b.canSelectMany,dropMimeTypes:o,dragMimeTypes:c,hasHandleDrag:u,hasHandleDrop:r});return{get onDidCollapseElement(){return l.onDidCollapseElement},get onDidExpandElement(){return l.onDidExpandElement},get selection(){return l.selectedElements},get onDidChangeSelection(){return l.onDidChangeSelection},get visible(){return l.visible},get onDidChangeVisibility(){return l.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,d.checkProposedApiEnabled)(s,"treeItemCheckbox"),l.onDidChangeCheckboxState},get message(){return l.message},set message(i){l.message=i},get title(){return l.title},set title(i){l.title=i},get description(){return l.description},set description(i){l.description=i},get badge(){return l.badge},set badge(i){i!==void 0&&C.ViewBadge.isViewBadge(i)?l.badge={value:Math.floor(Math.abs(i.value)),tooltip:i.tooltip}:i===void 0&&(l.badge=void 0)},reveal:(i,p)=>l.reveal(i,p),dispose:async()=>{await n,this.a.delete(f),l.dispose()}}}$getChildren(f,b){const s=this.a.get(f);return s?s.getChildren(b):Promise.reject(new Error((0,a.localize)(0,null,f)))}async $handleDrop(f,b,s,o,c,u,r,l){const n=this.a.get(f);if(!n)return Promise.reject(new Error((0,a.localize)(1,null,f)));const i=E.DataTransfer.toDataTransfer(s,async p=>(await this.d.$resolveDropFileData(f,b,p)).buffer);return r===f&&l&&await this.g(i,n,l,c,u),n.onDrop(i,o,c)}async g(f,b,s,o,c){const u=this.b.removeDragOperationTransfer(c);if(u)(await u)?.forEach((r,l)=>{r&&f.set(l,r)});else if(c&&b.handleDrag){const r=b.handleDrag(s,f,o);this.b.addDragOperationTransfer(c,r),await r}return f}async $handleDrag(f,b,s,o){const c=this.a.get(f);if(!c)return Promise.reject(new Error((0,a.localize)(2,null,f)));const u=await this.g(new t.DataTransfer,c,b,o,s);if(!!u)return E.DataTransfer.toDataTransferDTO(u)}async $hasResolve(f){const b=this.a.get(f);if(!b)throw new Error((0,a.localize)(3,null,f));return b.hasResolve}$resolve(f,b,s){const o=this.a.get(f);if(!o)throw new Error((0,a.localize)(4,null,f));return o.resolveTreeItem(b,s)}$setExpanded(f,b,s){const o=this.a.get(f);if(!o)throw new Error((0,a.localize)(5,null,f));o.setExpanded(b,s)}$setSelection(f,b){const s=this.a.get(f);if(!s)throw new Error((0,a.localize)(6,null,f));s.setSelection(b)}$setFocus(f,b){const s=this.a.get(f);if(!s)throw new Error((0,a.localize)(7,null,f));s.setFocus(b)}$setVisible(f,b){const s=this.a.get(f);if(!s)throw new Error((0,a.localize)(8,null,f));s.setVisible(b)}$changeCheckboxState(f,b){const s=this.a.get(f);if(!s)throw new Error((0,a.localize)(9,null,f));s.setCheckboxState(b)}h(f,b,s){const o=new w(f,b,this.d,this.e.converter,this.f,s);return this.a.set(f,o),o}i(f){const b=this.a.get(f.$treeViewId);return b&&"$treeItemHandle"in f?b.getExtensionElement(f.$treeItemHandle):b&&"$focusedTreeItem"in f&&f.$focusedTreeItem?b.focusedElement:null}}e.ExtHostTreeViews=h;class w extends T.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(f=>this.getExtensionElement(f)).filter(f=>!(0,R.isUndefinedOrNull)(f))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(f,b,s,o,c,u){if(super(),this.D=f,this.F=s,this.G=o,this.H=c,this.I=u,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new D.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new D.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new D.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new D.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new D.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new D.Emitter),this.y=Promise.resolve(),this.C=Promise.resolve(),this.J="",this.L="",this.U=new y.CancellationTokenSource,u.contributes&&u.contributes.views)for(const n in u.contributes.views)for(const i of u.contributes.views[n])i.id===f&&(this.L=i.name);this.f=b.treeDataProvider,this.g=b.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(n=>this.w.fire({message:!1,element:n})));let r,l;this.B(D.Event.debounce(this.w.event,(n,i)=>(n||(n={message:!1,elements:[]}),i.element!==!1&&(r||(r=new Promise(p=>l=p),this.y=this.y.then(()=>r)),Array.isArray(i.element)?n.elements.push(...i.element):n.elements.push(i.element)),i.message&&(n.message=!0),n),200,!0)(({message:n,elements:i})=>{i.length&&(this.C=this.C.then(()=>{const p=l;return r=null,this.W(i).then(()=>p())})),n&&this.F.$setMessage(this.D,this.J)}))}async getChildren(f){const b=f?this.getExtensionElement(f):void 0;if(f&&!b)return this.H.error(`No tree item with id '${f}' found.`),Promise.resolve([]);let s=this.R(f);return s||(s=await this.S(b)),s?s.map(o=>o.item):void 0}getExtensionElement(f){return this.i.get(f)}reveal(f,b){b=b||{select:!0,focus:!1};const s=(0,R.isUndefinedOrNull)(b.select)?!0:b.select,o=(0,R.isUndefinedOrNull)(b.focus)?!1:b.focus,c=(0,R.isUndefinedOrNull)(b.expand)?!1:b.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):f?this.y.then(()=>this.O(f)).then(u=>this.Q(f,u[u.length-1]).then(r=>this.F.$reveal(this.D,{item:r.item,parentChain:u.map(l=>l.item)},{select:s,focus:o,expand:c})),u=>this.H.error(u)):this.F.$reveal(this.D,void 0,{select:s,focus:o,expand:c})}get message(){return this.J}set message(f){this.J=f,this.w.fire({message:!0,element:!1})}get title(){return this.L}set title(f){this.L=f,this.F.$setTitle(this.D,f,this.M)}get description(){return this.M}set description(f){this.M=f,this.F.$setTitle(this.D,this.L,f)}get badge(){return this.N}set badge(f){this.N?.value===f?.value&&this.N?.tooltip===f?.tooltip||(this.N=E.ViewBadge.from(f),this.F.$setBadge(this.D,f))}setExpanded(f,b){const s=this.getExtensionElement(f);s&&(b?this.r.fire(Object.freeze({element:s})):this.s.fire(Object.freeze({element:s})))}setSelection(f){(0,P.equals)(this.l,f)||(this.l=f,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(f){this.m=f}setVisible(f){f!==this.k&&(this.k=f,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(f){const b=(await Promise.all(f.map(async s=>{const o=this.getExtensionElement(s.treeItemHandle);return o?{extensionItem:o,treeItem:await this.f.getTreeItem(o),newState:s.newState?C.TreeItemCheckboxState.Checked:C.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);b.forEach(s=>{s.treeItem.checkboxState=s.newState?C.TreeItemCheckboxState.Checked:C.TreeItemCheckboxState.Unchecked}),this.v.fire({items:b.map(s=>[s.extensionItem,s.newState])})}async handleDrag(f,b,s){const o=[];for(const c of f){const u=this.getExtensionElement(c);u&&o.push(u)}if(!(!this.g?.handleDrag||o.length===0))return await this.g.handleDrag(o,b,s),b}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(f,b,s){const o=b?this.getExtensionElement(b):void 0;if(!(!o&&b||!this.g?.handleDrop))return(0,S.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(o,f,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(f,b){if(!this.f.resolveTreeItem)return;const s=this.i.get(f);if(s){const o=this.j.get(s);if(o){const c=await this.f.resolveTreeItem(o.extensionItem,s,b)??o.extensionItem;return this.fb(c),o.item.tooltip=this.cb(c.tooltip),o.item.command=this.db(o.disposableStore,c.command),o.item}}}O(f){return this.P(f).then(b=>b?this.O(b).then(s=>this.Q(b,s[s.length-1]).then(o=>(s.push(o),s))):Promise.resolve([]))}P(f){const b=this.j.get(f);return b?Promise.resolve(b.parent?this.i.get(b.parent.item.handle):void 0):(0,S.asPromise)(()=>this.f.getParent(f))}Q(f,b){const s=this.j.get(f);return s?Promise.resolve(s):(0,S.asPromise)(()=>this.f.getTreeItem(f)).then(o=>this.ib(f,o,b,!0)).then(o=>this.getChildren(b?b.item.handle:void 0).then(()=>{const c=this.getExtensionElement(o);if(c){const u=this.j.get(c);if(u)return Promise.resolve(u)}throw new Error(`Cannot resolve tree item for element ${o}`)}))}R(f){if(f){let b;if(typeof f=="string"){const s=this.getExtensionElement(f);b=s?this.j.get(s):void 0}else b=f;return b&&b.children||void 0}return this.h}async S(f){this.pb(f);const b=new y.CancellationTokenSource(this.U.token);try{const s=f?this.j.get(f):void 0,o=await this.f.getChildren(f);if(b.token.isCancellationRequested)return;const c=await Promise.all((0,P.coalesce)(o||[]).map(async u=>{const r=await this.f.getTreeItem(u);return r&&!b.token.isCancellationRequested?this.bb(u,r,s):null}));return b.token.isCancellationRequested?void 0:(0,P.coalesce)(c)}finally{b.dispose()}}W(f){if(f.some(s=>!s))return this.U.dispose(!0),this.U=new y.CancellationTokenSource,this.rb(),this.F.$refresh(this.D);{const s=this.X(f);if(s.length)return this.Y(s)}return Promise.resolve(void 0)}X(f){const b=new Set,s=f.map(c=>this.j.get(c));for(const c of s)if(c&&!b.has(c.item.handle)){let u=c;for(;u&&u.parent&&s.findIndex(r=>u&&u.parent&&r&&r.item.handle===u.parent.item.handle)===-1;){const r=this.i.get(u.parent.item.handle);u=r?this.j.get(r):void 0}u&&!u.parent&&b.add(c.item.handle)}const o=[];return b.forEach(c=>{const u=this.i.get(c);if(u){const r=this.j.get(u);r&&(!r.parent||!b.has(r.parent.item.handle))&&o.push(c)}}),o}Y(f){const b={};return Promise.all(f.map(s=>this.ab(s).then(o=>{o&&(b[s]=o.item)}))).then(()=>Object.keys(b).length?this.F.$refresh(this.D,b):void 0)}ab(f){const b=this.getExtensionElement(f);if(b){const s=this.j.get(b);if(s)return this.pb(b),(0,S.asPromise)(()=>this.f.getTreeItem(b)).then(o=>{if(o){const c=this.gb(b,o,s.parent);return this.nb(b,c,s,s.parent),s.dispose(),c}return null})}return Promise.resolve(null)}bb(f,b,s){const o=this.gb(f,b,s);if(b.id&&this.i.has(o.item.handle))throw new Error((0,a.localize)(10,null,b.id));return this.mb(f,o),this.ob(o,s),o}cb(f){return C.MarkdownString.isMarkdownString(f)?E.MarkdownString.from(f):f}db(f,b){return b?{...this.G.toInternal(b,f),originalId:b.command}:void 0}eb(f){if(!f.checkboxState)return;let b,s;return typeof f.checkboxState=="number"?b=f.checkboxState:(b=f.checkboxState.state,s=f.checkboxState.tooltip),{isChecked:b===C.TreeItemCheckboxState.Checked,tooltip:s}}fb(f){if(!C.TreeItem.isTreeItem(f,this.I))throw new Error(`Extension ${this.I.identifier.value} has provided an invalid tree item.`)}gb(f,b,s){this.fb(b);const o=new T.DisposableStore,c=this.ib(f,b,s),u=this.jb(b);return{item:{handle:c,parentHandle:s?s.item.handle:void 0,label:g(b.label,this.I),description:b.description,resourceUri:b.resourceUri,tooltip:this.cb(b.tooltip),command:this.db(o,b.command),contextValue:b.contextValue,icon:u,iconDark:this.kb(b)||u,themeIcon:this.hb(b),collapsibleState:(0,R.isUndefinedOrNull)(b.collapsibleState)?C.TreeItemCollapsibleState.None:b.collapsibleState,accessibilityInformation:b.accessibilityInformation,checkbox:this.eb(b)},extensionItem:b,parent:s,children:void 0,disposableStore:o,dispose(){o.dispose()}}}hb(f){return f.iconPath instanceof C.ThemeIcon?f.iconPath:void 0}ib(f,{id:b,label:s,resourceUri:o},c,u){if(b)return`${w.b}/${b}`;const r=g(s,this.I),l=c?c.item.handle:w.a;let n=r?r.label:o?(0,k.basename)(o):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const i=this.j.has(f)?this.j.get(f).item.handle:void 0,p=this.R(c)||[];let I,L=0;do{if(I=`${l}/${L}:${n}`,u||!this.i.has(I)||i===I)break;L++}while(L<=p.length);return I}jb(f){if(f.iconPath&&!(f.iconPath instanceof C.ThemeIcon))return typeof f.iconPath=="string"||A.URI.isUri(f.iconPath)?this.lb(f.iconPath):this.lb(f.iconPath.light)}kb(f){if(f.iconPath&&!(f.iconPath instanceof C.ThemeIcon)&&f.iconPath.dark)return this.lb(f.iconPath.dark)}lb(f){return A.URI.isUri(f)?f:A.URI.file(f)}mb(f,b){this.i.set(b.item.handle,f),this.j.set(f,b)}nb(f,b,s,o){this.i.delete(b.item.handle),this.j.delete(f),b.item.handle!==s.item.handle&&this.i.delete(s.item.handle),this.mb(f,b);const c=this.R(o)||[],u=c.filter(r=>r.item.handle===s.item.handle)[0];u&&c.splice(c.indexOf(u),1,b)}ob(f,b){b?(b.children||(b.children=[]),b.children.push(f)):(this.h||(this.h=[]),this.h.push(f))}pb(f){if(f){const b=this.j.get(f);if(b){if(b.children)for(const s of b.children){const o=this.i.get(s.item.handle);o&&this.qb(o)}b.children=void 0}}else this.rb()}qb(f){const b=this.j.get(f);if(b){if(b.children)for(const s of b.children){const o=this.i.get(s.item.handle);o&&this.qb(o)}this.j.delete(f),this.i.delete(b.item.handle),b.dispose()}}rb(){this.h=void 0,this.i.clear(),this.j.forEach(f=>f.dispose()),this.j.clear()}dispose(){this.U.dispose(),this.rb(),this.F.$disposeTree(this.D)}}w.a="0",w.b="1"}),define(Se[302],ye([1,0,21,10,4,42,2,119,105,151,161,38,5,93,245,244,39,246,34,248,249,250,233,251,58,41,252,253,256,257,258,141,236,263,264,265,97,40,267,301,14,7,128,270,72,140,33,223,255,88,138,74,76,77,13,55,16,25,259,232,54,69,242,268,71,70,273,271,272,243,46,266,269,96,59,94,260,73,261,15,123,235,212,254,6,26,216,95,209,262]),function(te,e,a,t,k,A,D,T,S,C,R,P,E,y,v,d,g,h,w,m,f,b,s,o,c,u,r,l,n,i,p,I,L,U,G,V,O,B,F,$,M,H,K,q,Y,Q,ce,ie,de,J,pe,ve,De,Re,$e,re,le,fe,Z,se,ne,N,z,X,_,ue,be,ke,ge,Pe,Ie,je,qe,et,_e,nt,st,ht,Ue,it,oe,W,ae,Ce,Le,Be,Xe,Ze,ft,mt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function lt(ot){const rt=ot.get(fe.IExtHostInitDataService),Tt=ot.get(Ie.IExtHostFileSystemInfo),kt=ot.get(ue.IExtHostConsumerFileSystem),Mt=ot.get(u.IExtHostExtensionService),pt=ot.get(ce.IExtHostWorkspace),Ct=ot.get(nt.IExtHostTelemetry),Rt=ot.get(w.IExtHostConfiguration),Ut=ot.get(re.IURITransformerService),xe=ot.get(le.IExtHostRpcService),Ot=ot.get(O.IExtHostStorage),jt=ot.get(_.IExtensionStoragePaths),qt=ot.get($e.ILoggerService),bt=ot.get($e.ILogService),Pt=ot.get(ne.IExtHostTunnelService),Ae=ot.get(N.IExtHostApiDeprecationService),Oe=ot.get(Q.IExtHostWindow),Ee=ot.get(et.IExtHostSecretState),ee=ot.get(_e.IExtHostEditorTabs);xe.set(E.ExtHostContext.ExtHostFileSystemInfo,Tt),xe.set(E.ExtHostContext.ExtHostLogLevelServiceShape,qt),xe.set(E.ExtHostContext.ExtHostWorkspace,pt),xe.set(E.ExtHostContext.ExtHostConfiguration,Rt),xe.set(E.ExtHostContext.ExtHostExtensionService,Mt),xe.set(E.ExtHostContext.ExtHostStorage,Ot),xe.set(E.ExtHostContext.ExtHostTunnelService,Pt),xe.set(E.ExtHostContext.ExtHostWindow,Oe),xe.set(E.ExtHostContext.ExtHostSecretState,Ee),xe.set(E.ExtHostContext.ExtHostTelemetry,Ct),xe.set(E.ExtHostContext.ExtHostEditorTabs,ee);const Ne=xe.set(E.ExtHostContext.ExtHostDecorations,ot.get(pe.IExtHostDecorations)),ze=xe.set(E.ExtHostContext.ExtHostDocumentsAndEditors,ot.get(c.IExtHostDocumentsAndEditors)),Qe=xe.set(E.ExtHostContext.ExtHostCommands,ot.get(g.IExtHostCommands)),Ge=xe.set(E.ExtHostContext.ExtHostTerminalService,ot.get(B.IExtHostTerminalService)),tt=xe.set(E.ExtHostContext.ExtHostDebugService,ot.get(De.IExtHostDebugService)),Dt=xe.set(E.ExtHostContext.ExtHostSearch,ot.get(Re.IExtHostSearch)),vt=xe.set(E.ExtHostContext.ExtHostTask,ot.get(ve.IExtHostTask)),Lt=xe.set(E.ExtHostContext.ExtHostOutputService,ot.get(I.IExtHostOutputService)),St=xe.set(E.ExtHostContext.ExtHostLocalization,ot.get(Ze.IExtHostLocalizationService)),yt=xe.set(E.ExtHostContext.ExtHostUrls,new q.ExtHostUrls(xe)),gt=xe.set(E.ExtHostContext.ExtHostDocuments,new o.ExtHostDocuments(xe,ze)),$t=xe.set(E.ExtHostContext.ExtHostDocumentContentProviders,new b.ExtHostDocumentContentProvider(xe,ze,bt)),Jt=xe.set(E.ExtHostContext.ExtHostDocumentSaveParticipant,new s.ExtHostDocumentSaveParticipant(bt,gt,xe.getProxy(E.MainContext.MainThreadBulkEdits))),Et=xe.set(E.ExtHostContext.ExtHostNotebook,new Z.ExtHostNotebookController(xe,Qe,ze,gt)),Xt=xe.set(E.ExtHostContext.ExtHostNotebookDocuments,new ae.ExtHostNotebookDocuments(Et)),cn=xe.set(E.ExtHostContext.ExtHostNotebookEditors,new W.ExtHostNotebookEditors(bt,Et)),Bt=xe.set(E.ExtHostContext.ExtHostNotebookKernels,new st.ExtHostNotebookKernels(xe,rt,Et,Qe,bt)),pn=xe.set(E.ExtHostContext.ExtHostNotebookRenderers,new Ue.ExtHostNotebookRenderers(xe,Et)),Nt=xe.set(E.ExtHostContext.ExtHostEditors,new F.ExtHostEditors(xe,ze)),ln=xe.set(E.ExtHostContext.ExtHostTreeViews,new $.ExtHostTreeViews(xe.getProxy(E.MainContext.MainThreadTreeViews),Qe,bt)),Zt=xe.set(E.ExtHostContext.ExtHostEditorInsets,new ie.ExtHostEditorInsets(xe.getProxy(E.MainContext.MainThreadEditorInsets),Nt,rt.remote)),en=xe.set(E.ExtHostContext.ExtHostDiagnostics,new m.ExtHostDiagnostics(xe,bt,Tt,ze)),tn=xe.set(E.ExtHostContext.ExtHostLanguages,new i.ExtHostLanguages(xe,gt,Qe.converter,Ut)),ut=xe.set(E.ExtHostContext.ExtHostLanguageFeatures,new n.ExtHostLanguageFeatures(xe,Ut,gt,Qe,en,bt,Ae,Ct)),bn=xe.set(E.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(xe,ut)),Gt=xe.set(E.ExtHostContext.ExtHostFileSystemEventService,new l.ExtHostFileSystemEventService(xe,bt,ze)),_t=xe.set(E.ExtHostContext.ExtHostQuickOpen,(0,U.createExtHostQuickOpen)(xe,pt,Qe)),un=xe.set(E.ExtHostContext.ExtHostSCM,new G.ExtHostSCM(xe,Qe,bt)),wn=xe.set(E.ExtHostContext.ExtHostComments,(0,h.createExtHostComments)(xe,Qe,gt)),kn=xe.set(E.ExtHostContext.ExtHostProgress,new L.ExtHostProgress(xe.getProxy(E.MainContext.MainThreadProgress))),vn=xe.set(E.ExtHostContext.ExtHosLabelService,new de.ExtHostLabelService(xe)),dn=xe.set(E.ExtHostContext.ExtHostTheming,new se.ExtHostTheming(xe)),nn=xe.set(E.ExtHostContext.ExtHostAuthentication,new z.ExtHostAuthentication(xe)),En=xe.set(E.ExtHostContext.ExtHostTimeline,new X.ExtHostTimeline(xe,Qe)),Sn=xe.set(E.ExtHostContext.ExtHostWebviews,new Y.ExtHostWebviews(xe,rt.remote,pt,bt,Ae)),rn=xe.set(E.ExtHostContext.ExtHostWebviewPanels,new ge.ExtHostWebviewPanels(xe,Sn,pt)),yn=xe.set(E.ExtHostContext.ExtHostCustomEditors,new ke.ExtHostCustomEditors(xe,gt,jt,Sn,rn)),On=xe.set(E.ExtHostContext.ExtHostWebviewViews,new be.ExtHostWebviewViews(xe,Sn)),sn=xe.set(E.ExtHostContext.ExtHostTesting,new je.ExtHostTesting(xe,Qe,ze)),Nn=xe.set(E.ExtHostContext.ExtHostUriOpeners,new qe.ExtHostUriOpeners(xe)),Fn=xe.set(E.ExtHostContext.ExtHostProfileContentHandlers,new mt.ExtHostProfileContentHandlers(xe));xe.set(E.ExtHostContext.ExtHostInteractive,new Ce.ExtHostInteractive(xe,Et,ze,Qe,bt));const Mn=Object.values(E.ExtHostContext);xe.assertRegistered(Mn);const Un=new Pe.ExtHostBulkEdits(xe,ze),Cn=new d.ExtHostClipboard(xe),on=new p.ExtHostMessageService(xe,bt),Tn=new f.ExtHostDialogs(xe),Pn=new V.ExtHostStatusBar(xe,Qe.converter);return v.ExtHostApiCommands.register(Qe),function(He,zt,An){const wt=function(){let me=!He.isUnderDevelopment;function we(){me||(bt.info(`Extension '${He.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),me=!0)}return function Me(at){if(Array.isArray(at))at.forEach(Me);else if(typeof at=="string")we();else{const It=at;typeof It.scheme>"u"&&we(),typeof It.exclusive=="boolean"&&(0,Be.checkProposedApiEnabled)(He,"documentFiltersExclusive")}return at}}(),Bn={getSession(me,we,Me){return nn.getSession(He,me,we,Me)},async hasSession(me,we){return(0,Be.checkProposedApiEnabled)(He,"authSession"),!!await nn.getSession(He,me,we,{silent:!0})},get onDidChangeSessions(){return nn.onDidChangeSessions},registerAuthenticationProvider(me,we,Me,at){return nn.registerAuthenticationProvider(me,we,Me,at)}},$n={registerCommand(me,we,Me){return Qe.registerCommand(!0,me,we,Me,void 0,He)},registerTextEditorCommand(me,we,Me){return Qe.registerCommand(!0,me,(...at)=>{const It=Nt.getActiveTextEditor();if(!It){bt.warn("Cannot execute "+me+" because there is no active text editor.");return}return It.edit(At=>{we.apply(Me,[It,At,...at])}).then(At=>{At||bt.warn("Edits from command "+me+" were not applied.")},At=>{bt.warn("An error occurred while running command "+me,At)})},void 0,void 0,He)},registerDiffInformationCommand:(me,we,Me)=>((0,Be.checkProposedApiEnabled)(He,"diffCommand"),Qe.registerCommand(!0,me,async(...at)=>{const It=ze.activeEditor(!0);if(!It){bt.warn("Cannot execute "+me+" because there is no active text editor.");return}const At=await Nt.getDiffInformation(It.id);we.apply(Me,[At,...at])},void 0,void 0,He)),executeCommand(me,...we){return Qe.executeCommand(me,...we)},getCommands(me=!1){return Qe.getCommands(me)}},hn={get machineId(){return rt.telemetryInfo.machineId},get sessionId(){return rt.telemetryInfo.sessionId},get language(){return rt.environment.appLanguage},get appName(){return rt.environment.appName},get appRoot(){return rt.environment.appRoot?.fsPath??""},get appHost(){return rt.environment.appHost},get uriScheme(){return rt.environment.appUriScheme},get clipboard(){return Cn.value},get shell(){return Ge.getDefaultShell(!1)},get onDidChangeShell(){return(0,Be.checkProposedApiEnabled)(He,"envShellEvent"),Ge.onDidChangeShell},get isTelemetryEnabled(){return Ct.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Ct.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Be.checkProposedApiEnabled)(He,"telemetry"),Ct.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Be.checkProposedApiEnabled)(He,"telemetry"),Ct.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,nt.isNewAppInstall)(rt.telemetryInfo.firstSessionDate)},createTelemetryLogger(me){return(0,Be.checkProposedApiEnabled)(He,"telemetryLogger"),Ct.instantiateLogger(He,me)},openExternal(me,we){return Oe.openUri(me,{allowTunneling:!!rt.remote.authority,allowContributedOpeners:we?.allowContributedOpeners})},async asExternalUri(me){if(me.scheme===rt.environment.appUriScheme)return yt.createAppUri(me);try{return await Oe.asExternalUri(me,{allowTunneling:!!rt.remote.authority})}catch(we){if((0,oe.matchesScheme)(me,it.Schemas.http)||(0,oe.matchesScheme)(me,it.Schemas.https))return me;throw we}},get remoteName(){return(0,J.getRemoteName)(rt.remote.authority)},get remoteAuthority(){return(0,Be.checkProposedApiEnabled)(He,"resolvers"),rt.remote.authority},get uiKind(){return rt.uiKind},get logLevel(){return bt.getLevel()},get onDidChangeLogLevel(){return bt.onDidChangeLogLevel}};rt.environment.extensionTestsLocationURI||Object.freeze(hn);const zn={createTestController(me,we,Me){return sn.createTestController(me,we,Me)},createTestObserver(){return(0,Be.checkProposedApiEnabled)(He,"testObserver"),sn.createTestObserver()},runTests(me){return(0,Be.checkProposedApiEnabled)(He,"testObserver"),sn.runTests(me)},get onDidChangeTestResults(){return(0,Be.checkProposedApiEnabled)(He,"testObserver"),sn.onResultsChanged},get testResults(){return(0,Be.checkProposedApiEnabled)(He,"testObserver"),sn.results}},Wt=rt.remote.isRemote?H.ExtensionKind.Workspace:H.ExtensionKind.UI,fn={getExtension(me,we){(0,Be.isProposedApiEnabled)(He,"extensionsAny")||(we=!1);const Me=zt.mine.getExtensionDescription(me);if(Me)return new u.Extension(Mt,He.identifier,Me,Wt,!1);if(we){const at=zt.all.getExtensionDescription(me);if(at)return new u.Extension(Mt,He.identifier,at,Wt,!0)}},get all(){const me=[];for(const we of zt.mine.getAllExtensionDescriptions())me.push(new u.Extension(Mt,He.identifier,we,Wt,!1));return me},get allAcrossExtensionHosts(){(0,Be.checkProposedApiEnabled)(He,"extensionsAny");const me=new Be.ExtensionIdentifierSet(zt.mine.getAllExtensionDescriptions().map(Me=>Me.identifier)),we=[];for(const Me of zt.all.getAllExtensionDescriptions()){const at=!me.has(Me.identifier);we.push(new u.Extension(Mt,He.identifier,Me,Wt,at))}return we},get onDidChange(){return(0,Be.isProposedApiEnabled)(He,"extensionsAny")?k.Event.any(zt.mine.onDidChange,zt.all.onDidChange):zt.mine.onDidChange}},Wn={createDiagnosticCollection(me){return en.createDiagnosticCollection(He.identifier,me)},get onDidChangeDiagnostics(){return en.onDidChangeDiagnostics},getDiagnostics:me=>en.getDiagnostics(me),getLanguages(){return tn.getLanguages()},setTextDocumentLanguage(me,we){return tn.changeLanguage(me.uri,we)},match(me,we){const Me=gt.getDocumentData(we.uri)?.notebook;return(0,R.score)(M.LanguageSelector.from(me),we.uri,we.languageId,!0,Me?.uri,Me?.notebookType)},registerCodeActionsProvider(me,we,Me){return ut.registerCodeActionProvider(He,wt(me),we,Me)},registerDocumentPasteEditProvider(me,we,Me){return(0,Be.checkProposedApiEnabled)(He,"documentPaste"),ut.registerDocumentPasteEditProvider(He,wt(me),we,Me)},registerCodeLensProvider(me,we){return ut.registerCodeLensProvider(He,wt(me),we)},registerDefinitionProvider(me,we){return ut.registerDefinitionProvider(He,wt(me),we)},registerDeclarationProvider(me,we){return ut.registerDeclarationProvider(He,wt(me),we)},registerImplementationProvider(me,we){return ut.registerImplementationProvider(He,wt(me),we)},registerTypeDefinitionProvider(me,we){return ut.registerTypeDefinitionProvider(He,wt(me),we)},registerHoverProvider(me,we){return ut.registerHoverProvider(He,wt(me),we,He.identifier)},registerEvaluatableExpressionProvider(me,we){return ut.registerEvaluatableExpressionProvider(He,wt(me),we,He.identifier)},registerInlineValuesProvider(me,we){return ut.registerInlineValuesProvider(He,wt(me),we,He.identifier)},registerDocumentHighlightProvider(me,we){return ut.registerDocumentHighlightProvider(He,wt(me),we)},registerLinkedEditingRangeProvider(me,we){return ut.registerLinkedEditingRangeProvider(He,wt(me),we)},registerReferenceProvider(me,we){return ut.registerReferenceProvider(He,wt(me),we)},registerRenameProvider(me,we){return ut.registerRenameProvider(He,wt(me),we)},registerDocumentSymbolProvider(me,we,Me){return ut.registerDocumentSymbolProvider(He,wt(me),we,Me)},registerWorkspaceSymbolProvider(me){return ut.registerWorkspaceSymbolProvider(He,me)},registerDocumentFormattingEditProvider(me,we){return ut.registerDocumentFormattingEditProvider(He,wt(me),we)},registerDocumentRangeFormattingEditProvider(me,we){return ut.registerDocumentRangeFormattingEditProvider(He,wt(me),we)},registerOnTypeFormattingEditProvider(me,we,Me,...at){return ut.registerOnTypeFormattingEditProvider(He,wt(me),we,[Me].concat(at))},registerDocumentSemanticTokensProvider(me,we,Me){return ut.registerDocumentSemanticTokensProvider(He,wt(me),we,Me)},registerDocumentRangeSemanticTokensProvider(me,we,Me){return ut.registerDocumentRangeSemanticTokensProvider(He,wt(me),we,Me)},registerSignatureHelpProvider(me,we,Me,...at){return typeof Me=="object"?ut.registerSignatureHelpProvider(He,wt(me),we,Me):ut.registerSignatureHelpProvider(He,wt(me),we,typeof Me>"u"?[]:[Me,...at])},registerCompletionItemProvider(me,we,...Me){return ut.registerCompletionItemProvider(He,wt(me),we,Me)},registerInlineCompletionItemProvider(me,we){return we.handleDidShowCompletionItem&&(0,Be.checkProposedApiEnabled)(He,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(He,wt(me),we)},registerDocumentLinkProvider(me,we){return ut.registerDocumentLinkProvider(He,wt(me),we)},registerColorProvider(me,we){return ut.registerColorProvider(He,wt(me),we)},registerFoldingRangeProvider(me,we){return ut.registerFoldingRangeProvider(He,wt(me),we)},registerSelectionRangeProvider(me,we){return ut.registerSelectionRangeProvider(He,me,we)},registerCallHierarchyProvider(me,we){return ut.registerCallHierarchyProvider(He,me,we)},registerTypeHierarchyProvider(me,we){return ut.registerTypeHierarchyProvider(He,me,we)},setLanguageConfiguration:(me,we)=>ut.setLanguageConfiguration(He,me,we),getTokenInformationAtPosition(me,we){return(0,Be.checkProposedApiEnabled)(He,"tokenInformation"),tn.tokenAtPosition(me,we)},registerInlayHintsProvider(me,we){return ut.registerInlayHintsProvider(He,me,we)},createLanguageStatusItem(me,we){return tn.createLanguageStatusItem(He,me,we)},registerDocumentDropEditProvider(me,we){return ut.registerDocumentOnDropEditProvider(He,me,we)}},Ht={get activeTextEditor(){return Nt.getActiveTextEditor()},get visibleTextEditors(){return Nt.getVisibleTextEditors()},get activeTerminal(){return Ge.activeTerminal},get terminals(){return Ge.terminals},async showTextDocument(me,we,Me){const at=await(D.URI.isUri(me)?Promise.resolve(an.openTextDocument(me)):Promise.resolve(me));return Nt.showTextDocument(at,we,Me)},createTextEditorDecorationType(me){return Nt.createTextEditorDecorationType(He,me)},onDidChangeActiveTextEditor(me,we,Me){return Nt.onDidChangeActiveTextEditor(me,we,Me)},onDidChangeVisibleTextEditors(me,we,Me){return Nt.onDidChangeVisibleTextEditors(me,we,Me)},onDidChangeTextEditorSelection(me,we,Me){return Nt.onDidChangeTextEditorSelection(me,we,Me)},onDidChangeTextEditorOptions(me,we,Me){return Nt.onDidChangeTextEditorOptions(me,we,Me)},onDidChangeTextEditorVisibleRanges(me,we,Me){return Nt.onDidChangeTextEditorVisibleRanges(me,we,Me)},onDidChangeTextEditorViewColumn(me,we,Me){return Nt.onDidChangeTextEditorViewColumn(me,we,Me)},onDidCloseTerminal(me,we,Me){return Ge.onDidCloseTerminal(me,we,Me)},onDidOpenTerminal(me,we,Me){return Ge.onDidOpenTerminal(me,we,Me)},onDidChangeActiveTerminal(me,we,Me){return Ge.onDidChangeActiveTerminal(me,we,Me)},onDidChangeTerminalDimensions(me,we,Me){return(0,Be.checkProposedApiEnabled)(He,"terminalDimensions"),Ge.onDidChangeTerminalDimensions(me,we,Me)},onDidChangeTerminalState(me,we,Me){return Ge.onDidChangeTerminalState(me,we,Me)},onDidWriteTerminalData(me,we,Me){return(0,Be.checkProposedApiEnabled)(He,"terminalDataWriteEvent"),Ge.onDidWriteTerminalData(me,we,Me)},get state(){return Oe.state},onDidChangeWindowState(me,we,Me){return Oe.onDidChangeWindowState(me,we,Me)},showInformationMessage(me,...we){return on.showMessage(He,A.default.Info,me,we[0],we.slice(1))},showWarningMessage(me,...we){return on.showMessage(He,A.default.Warning,me,we[0],we.slice(1))},showErrorMessage(me,...we){return on.showMessage(He,A.default.Error,me,we[0],we.slice(1))},showQuickPick(me,we,Me){return _t.showQuickPick(me,we,Me)},showWorkspaceFolderPick(me){return _t.showWorkspaceFolderPick(me)},showInputBox(me,we){return _t.showInput(me,we)},showOpenDialog(me){return Tn.showOpenDialog(me)},showSaveDialog(me){return Tn.showSaveDialog(me)},createStatusBarItem(me,we,Me){let at,It,At;return typeof me=="string"?(at=me,It=we,At=Me):(It=me,At=we),Pn.createStatusBarEntry(He,at,It,At)},setStatusBarMessage(me,we){return Pn.setStatusBarMessage(me,we)},withScmProgress(me){return Ae.report("window.withScmProgress",He,"Use 'withProgress' instead."),kn.withProgress(He,{location:H.ProgressLocation.SourceControl},(we,Me)=>me({report(at){}}))},withProgress(me,we){return kn.withProgress(He,me,we)},createOutputChannel(me,we){return Lt.createOutputChannel(me,we,He)},createWebviewPanel(me,we,Me,at){return rn.createWebviewPanel(He,me,we,Me,at)},createWebviewTextEditorInset(me,we,Me,at){return(0,Be.checkProposedApiEnabled)(He,"editorInsets"),Zt.createWebviewEditorInset(me,we,Me,at,He)},createTerminal(me,we,Me){return typeof me=="object"?"pty"in me?Ge.createExtensionTerminal(me):Ge.createTerminalFromOptions(me):Ge.createTerminal(me,we,Me)},registerTerminalLinkProvider(me){return Ge.registerLinkProvider(me)},registerTerminalProfileProvider(me,we){return Ge.registerProfileProvider(He,me,we)},registerTreeDataProvider(me,we){return ln.registerTreeDataProvider(me,we,He)},createTreeView(me,we){return ln.createTreeView(me,we,He)},registerWebviewPanelSerializer:(me,we)=>rn.registerWebviewPanelSerializer(He,me,we),registerCustomEditorProvider:(me,we,Me={})=>yn.registerCustomEditorProvider(He,me,we,Me),registerFileDecorationProvider(me){return Ne.registerFileDecorationProvider(me,He)},registerUriHandler(me){return yt.registerUriHandler(He.identifier,me)},createQuickPick(){return _t.createQuickPick(He)},createInputBox(){return _t.createInputBox(He)},get activeColorTheme(){return dn.activeColorTheme},onDidChangeActiveColorTheme(me,we,Me){return dn.onDidChangeActiveColorTheme(me,we,Me)},registerWebviewViewProvider(me,we,Me){return On.registerWebviewViewProvider(He,me,we,Me?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(me,we,Me){return Et.onDidChangeActiveNotebookEditor(me,we,Me)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(me,we,Me){return cn.onDidChangeNotebookEditorSelection(me,we,Me)},onDidChangeNotebookEditorVisibleRanges(me,we,Me){return cn.onDidChangeNotebookEditorVisibleRanges(me,we,Me)},showNotebookDocument(me,we){return Et.showNotebookDocument(me,we)},registerExternalUriOpener(me,we,Me){return(0,Be.checkProposedApiEnabled)(He,"externalUriOpener"),Nn.registerExternalUriOpener(He.identifier,me,we,Me)},registerProfileContentHandler(me,we){return(0,Be.checkProposedApiEnabled)(He,"profileContentHandlers"),Fn.registrProfileContentHandler(He,me,we)},get tabGroups(){return ee.tabGroups}},an={get rootPath(){return Ae.report("workspace.rootPath",He,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),pt.getPath()},set rootPath(me){throw t.readonly()},getWorkspaceFolder(me){return pt.getWorkspaceFolder(me)},get workspaceFolders(){return pt.getWorkspaceFolders()},get name(){return pt.name},set name(me){throw t.readonly()},get workspaceFile(){return pt.workspaceFile},set workspaceFile(me){throw t.readonly()},updateWorkspaceFolders:(me,we,...Me)=>pt.updateWorkspaceFolders(He,me,we||0,...Me),onDidChangeWorkspaceFolders:function(me,we,Me){return pt.onDidChangeWorkspace(me,we,Me)},asRelativePath:(me,we)=>pt.getRelativePath(me,we),findFiles:(me,we,Me,at)=>pt.findFiles(me,we,Me,He.identifier,at),findTextInFiles:(me,we,Me,at)=>{(0,Be.checkProposedApiEnabled)(He,"findTextInFiles");let It,At;return typeof we=="object"?(It=we,At=Me):(It={},At=we,at=Me),pt.findTextInFiles(me,It||{},At,He.identifier,at)},saveAll:me=>pt.saveAll(me),applyEdit(me,we){return Un.applyWorkspaceEdit(me,He,we)},createFileSystemWatcher:(me,we,Me,at)=>Gt.createFileSystemWatcher(pt,He,me,we,Me,at),get textDocuments(){return gt.getAllDocumentData().map(me=>me.document)},set textDocuments(me){throw t.readonly()},openTextDocument(me){let we;const Me=me;if(typeof me=="string")we=Promise.resolve(D.URI.file(me));else if(D.URI.isUri(me))we=Promise.resolve(me);else if(!Me||typeof Me=="object")we=gt.createDocumentData(Me);else throw new Error("illegal argument - uriOrFileNameOrOptions");return we.then(at=>gt.ensureDocumentData(at).then(It=>It.document))},onDidOpenTextDocument:(me,we,Me)=>gt.onDidAddDocument(me,we,Me),onDidCloseTextDocument:(me,we,Me)=>gt.onDidRemoveDocument(me,we,Me),onDidChangeTextDocument:(me,we,Me)=>gt.onDidChangeDocument(me,we,Me),onDidSaveTextDocument:(me,we,Me)=>gt.onDidSaveDocument(me,we,Me),onWillSaveTextDocument:(me,we,Me)=>Jt.getOnWillSaveTextDocumentEvent(He)(me,we,Me),get notebookDocuments(){return Et.notebookDocuments.map(me=>me.apiNotebook)},async openNotebookDocument(me,we){let Me;if(D.URI.isUri(me))Me=me,await Et.openNotebookDocument(me);else if(typeof me=="string")Me=D.URI.revive(await Et.createNotebookDocument({viewType:me,content:we}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Me).apiNotebook},onDidSaveNotebookDocument(me,we,Me){return Xt.onDidSaveNotebookDocument(me,we,Me)},onDidChangeNotebookDocument(me,we,Me){return Xt.onDidChangeNotebookDocument(me,we,Me)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(me,we,Me,at){return Et.registerNotebookSerializer(He,me,we,Me,(0,Be.isProposedApiEnabled)(He,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(me,we,Me)=>An.onDidChangeConfiguration(me,we,Me),getConfiguration(me,we){return we=arguments.length===1?void 0:we,An.getConfiguration(me,we,He)},registerTextDocumentContentProvider(me,we){return $t.registerTextDocumentContentProvider(me,we)},registerTaskProvider:(me,we)=>(Ae.report("window.registerTaskProvider",He,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(He,me,we)),registerFileSystemProvider(me,we,Me){return(0,Le.combinedDisposable)(bn.registerFileSystemProvider(He,me,we,Me),kt.addFileSystemProvider(me,we))},get fs(){return kt.value},registerFileSearchProvider:(me,we)=>((0,Be.checkProposedApiEnabled)(He,"fileSearchProvider"),Dt.registerFileSearchProvider(me,we)),registerTextSearchProvider:(me,we)=>((0,Be.checkProposedApiEnabled)(He,"textSearchProvider"),Dt.registerTextSearchProvider(me,we)),registerRemoteAuthorityResolver:(me,we)=>((0,Be.checkProposedApiEnabled)(He,"resolvers"),Mt.registerRemoteAuthorityResolver(me,we)),registerResourceLabelFormatter:me=>((0,Be.checkProposedApiEnabled)(He,"resolvers"),vn.$registerResourceLabelFormatter(me)),onDidCreateFiles:(me,we,Me)=>Gt.onDidCreateFile(me,we,Me),onDidDeleteFiles:(me,we,Me)=>Gt.onDidDeleteFile(me,we,Me),onDidRenameFiles:(me,we,Me)=>Gt.onDidRenameFile(me,we,Me),onWillCreateFiles:(me,we,Me)=>Gt.getOnWillCreateFileEvent(He)(me,we,Me),onWillDeleteFiles:(me,we,Me)=>Gt.getOnWillDeleteFileEvent(He)(me,we,Me),onWillRenameFiles:(me,we,Me)=>Gt.getOnWillRenameFileEvent(He)(me,we,Me),openTunnel:me=>((0,Be.checkProposedApiEnabled)(He,"tunnels"),Pt.openTunnel(He,me).then(we=>{if(!we)throw new Error("cannot open tunnel");return we})),get tunnels(){return(0,Be.checkProposedApiEnabled)(He,"tunnels"),Pt.getTunnels()},onDidChangeTunnels:(me,we,Me)=>((0,Be.checkProposedApiEnabled)(He,"tunnels"),Pt.onDidChangeTunnels(me,we,Me)),registerPortAttributesProvider:(me,we)=>((0,Be.checkProposedApiEnabled)(He,"portsAttributes"),Pt.registerPortsAttributesProvider(me,we)),registerTimelineProvider:(me,we)=>((0,Be.checkProposedApiEnabled)(He,"timeline"),En.registerTimelineProvider(me,we,He.identifier,Qe.converter)),get isTrusted(){return pt.trusted},requestWorkspaceTrust:me=>((0,Be.checkProposedApiEnabled)(He,"workspaceTrust"),pt.requestWorkspaceTrust(me)),onDidGrantWorkspaceTrust:(me,we,Me)=>pt.onDidGrantWorkspaceTrust(me,we,Me),registerEditSessionIdentityProvider:(me,we)=>((0,Be.checkProposedApiEnabled)(He,"editSessionIdentityProvider"),pt.registerEditSessionIdentityProvider(me,we))},Hn={get inputBox(){return Ae.report("scm.inputBox",He,"Use 'SourceControl.inputBox' instead"),un.getLastInputBox(He)},createSourceControl(me,we,Me){return un.createSourceControl(He,me,we,Me)}},jn={createCommentController(me,we){return wn.createCommentController(He,me,we)}},Vn={get activeDebugSession(){return tt.activeDebugSession},get activeDebugConsole(){return tt.activeDebugConsole},get breakpoints(){return tt.breakpoints},onDidStartDebugSession(me,we,Me){return tt.onDidStartDebugSession(me,we,Me)},onDidTerminateDebugSession(me,we,Me){return tt.onDidTerminateDebugSession(me,we,Me)},onDidChangeActiveDebugSession(me,we,Me){return tt.onDidChangeActiveDebugSession(me,we,Me)},onDidReceiveDebugSessionCustomEvent(me,we,Me){return tt.onDidReceiveDebugSessionCustomEvent(me,we,Me)},onDidChangeBreakpoints(me,we,Me){return tt.onDidChangeBreakpoints(me,we,Me)},registerDebugConfigurationProvider(me,we,Me){return tt.registerDebugConfigurationProvider(me,we,Me||Xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(me,we){return tt.registerDebugAdapterDescriptorFactory(He,me,we)},registerDebugAdapterTrackerFactory(me,we){return tt.registerDebugAdapterTrackerFactory(me,we)},startDebugging(me,we,Me){return!Me||typeof Me=="object"&&"configuration"in Me?tt.startDebugging(me,we,{parentSession:Me}):tt.startDebugging(me,we,Me||{})},stopDebugging(me){return tt.stopDebugging(me)},addBreakpoints(me){return tt.addBreakpoints(me)},removeBreakpoints(me){return tt.removeBreakpoints(me)},asDebugSourceUri(me,we){return tt.asDebugSourceUri(me,we)}},qn={registerTaskProvider:(me,we)=>vt.registerTaskProvider(He,me,we),fetchTasks:me=>vt.fetchTasks(me),executeTask:me=>vt.executeTask(He,me),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(me,we,Me)=>vt.onDidStartTask(me,we,Me),onDidEndTask:(me,we,Me)=>vt.onDidEndTask(me,we,Me),onDidStartTaskProcess:(me,we,Me)=>vt.onDidStartTaskProcess(me,we,Me),onDidEndTaskProcess:(me,we,Me)=>vt.onDidEndTaskProcess(me,we,Me)},Gn={createNotebookController(me,we,Me,at,It){return Bt.createNotebookController(He,me,we,Me,at,(0,Be.isProposedApiEnabled)(He,"notebookMessaging")?It:void 0)},registerNotebookCellStatusBarItemProvider:(me,we)=>Et.registerNotebookCellStatusBarItemProvider(He,me,we),createRendererMessaging(me){return pn.createRendererMessaging(He,me)},createNotebookControllerDetectionTask(me){return(0,Be.checkProposedApiEnabled)(He,"notebookKernelSource"),Bt.createNotebookControllerDetectionTask(He,me)},registerKernelSourceActionProvider(me,we){return(0,Be.checkProposedApiEnabled)(He,"notebookKernelSource"),Bt.registerKernelSourceActionProvider(He,me,we)},onDidChangeNotebookCellExecutionState(me,we,Me){return(0,Be.checkProposedApiEnabled)(He,"notebookCellExecutionState"),Bt.onDidChangeNotebookCellExecutionState(me,we,Me)}},Kn={t(...me){if(typeof me[0]=="string"){const we=me.shift(),Me=!me||typeof me[0]!="object"?me:me[0];return St.getMessage(He.identifier.value,{message:we,args:Me})}return St.getMessage(He.identifier.value,me[0])},get bundle(){return St.getBundle(He.identifier.value)},get uri(){return St.getBundleUri(He.identifier.value)}};return{version:rt.version,authentication:Bn,commands:$n,comments:jn,debug:Vn,env:hn,extensions:fn,l10n:Kn,languages:Wn,notebooks:Gn,scm:Hn,tasks:qn,tests:zn,window:Ht,workspace:an,Breakpoint:H.Breakpoint,CallHierarchyIncomingCall:H.CallHierarchyIncomingCall,CallHierarchyItem:H.CallHierarchyItem,CallHierarchyOutgoingCall:H.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:a.CancellationTokenSource,CandidatePortSource:E.CandidatePortSource,CodeAction:H.CodeAction,CodeActionKind:H.CodeActionKind,CodeActionTriggerKind:H.CodeActionTriggerKind,CodeLens:H.CodeLens,Color:H.Color,ColorInformation:H.ColorInformation,ColorPresentation:H.ColorPresentation,ColorThemeKind:H.ColorThemeKind,CommentMode:H.CommentMode,CommentThreadCollapsibleState:H.CommentThreadCollapsibleState,CommentThreadState:H.CommentThreadState,CompletionItem:H.CompletionItem,CompletionItemKind:H.CompletionItemKind,CompletionItemTag:H.CompletionItemTag,CompletionList:H.CompletionList,CompletionTriggerKind:H.CompletionTriggerKind,ConfigurationTarget:H.ConfigurationTarget,CustomExecution:H.CustomExecution,DebugAdapterExecutable:H.DebugAdapterExecutable,DebugAdapterInlineImplementation:H.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:H.DebugAdapterNamedPipeServer,DebugAdapterServer:H.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:H.DebugConsoleMode,DecorationRangeBehavior:H.DecorationRangeBehavior,Diagnostic:H.Diagnostic,DiagnosticRelatedInformation:H.DiagnosticRelatedInformation,DiagnosticSeverity:H.DiagnosticSeverity,DiagnosticTag:H.DiagnosticTag,Disposable:H.Disposable,DocumentHighlight:H.DocumentHighlight,DocumentHighlightKind:H.DocumentHighlightKind,DocumentLink:H.DocumentLink,DocumentSymbol:H.DocumentSymbol,EndOfLine:H.EndOfLine,EnvironmentVariableMutatorType:H.EnvironmentVariableMutatorType,EvaluatableExpression:H.EvaluatableExpression,InlineValueText:H.InlineValueText,InlineValueVariableLookup:H.InlineValueVariableLookup,InlineValueEvaluatableExpression:H.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:H.InlineCompletionTriggerKind,EventEmitter:k.Emitter,ExtensionKind:H.ExtensionKind,ExtensionMode:H.ExtensionMode,ExternalUriOpenerPriority:H.ExternalUriOpenerPriority,FileChangeType:H.FileChangeType,FileDecoration:H.FileDecoration,FileDecoration2:H.FileDecoration,FileSystemError:H.FileSystemError,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:H.FoldingRange,FoldingRangeKind:H.FoldingRangeKind,FunctionBreakpoint:H.FunctionBreakpoint,InlineCompletionItem:H.InlineSuggestion,InlineCompletionList:H.InlineSuggestionList,Hover:H.Hover,IndentAction:C.IndentAction,Location:H.Location,MarkdownString:H.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:H.ParameterInformation,PortAutoForwardAction:H.PortAutoForwardAction,Position:H.Position,ProcessExecution:H.ProcessExecution,ProgressLocation:H.ProgressLocation,QuickInputButtons:H.QuickInputButtons,Range:H.Range,RelativePattern:H.RelativePattern,Selection:H.Selection,SelectionRange:H.SelectionRange,SemanticTokens:H.SemanticTokens,SemanticTokensBuilder:H.SemanticTokensBuilder,SemanticTokensEdit:H.SemanticTokensEdit,SemanticTokensEdits:H.SemanticTokensEdits,SemanticTokensLegend:H.SemanticTokensLegend,ShellExecution:H.ShellExecution,ShellQuoting:H.ShellQuoting,SignatureHelp:H.SignatureHelp,SignatureHelpTriggerKind:H.SignatureHelpTriggerKind,SignatureInformation:H.SignatureInformation,SnippetString:H.SnippetString,SourceBreakpoint:H.SourceBreakpoint,StandardTokenType:H.StandardTokenType,StatusBarAlignment:H.StatusBarAlignment,SymbolInformation:H.SymbolInformation,SymbolKind:H.SymbolKind,SymbolTag:H.SymbolTag,Task:H.Task,TaskGroup:H.TaskGroup,TaskPanelKind:H.TaskPanelKind,TaskRevealKind:H.TaskRevealKind,TaskScope:H.TaskScope,TerminalLink:H.TerminalLink,TerminalLocation:H.TerminalLocation,TerminalProfile:H.TerminalProfile,TextDocumentSaveReason:H.TextDocumentSaveReason,TextEdit:H.TextEdit,SnippetTextEdit:H.SnippetTextEdit,TextEditorCursorStyle:T.TextEditorCursorStyle,TextEditorLineNumbersStyle:H.TextEditorLineNumbersStyle,TextEditorRevealType:H.TextEditorRevealType,TextEditorSelectionChangeKind:H.TextEditorSelectionChangeKind,TextDocumentChangeReason:H.TextDocumentChangeReason,ThemeColor:H.ThemeColor,ThemeIcon:H.ThemeIcon,TreeItem:H.TreeItem,TreeItem2:H.TreeItem,TreeItemCheckboxState:H.TreeItemCheckboxState,TreeItemCollapsibleState:H.TreeItemCollapsibleState,TypeHierarchyItem:H.TypeHierarchyItem,UIKind:y.UIKind,Uri:D.URI,ViewColumn:H.ViewColumn,WorkspaceEdit:H.WorkspaceEdit,DocumentDropEdit:H.DocumentDropEdit,DocumentPasteEdit:H.DocumentPasteEdit,InlayHint:H.InlayHint,InlayHintLabelPart:H.InlayHintLabelPart,InlayHintKind:H.InlayHintKind,RemoteAuthorityResolverError:H.RemoteAuthorityResolverError,ResolvedAuthority:H.ResolvedAuthority,SourceControlInputBoxValidationType:H.SourceControlInputBoxValidationType,ExtensionRuntime:H.ExtensionRuntime,TimelineItem:H.TimelineItem,NotebookRange:H.NotebookRange,NotebookCellKind:H.NotebookCellKind,NotebookCellExecutionState:H.NotebookCellExecutionState,NotebookCellData:H.NotebookCellData,NotebookData:H.NotebookData,NotebookRendererScript:H.NotebookRendererScript,NotebookCellStatusBarAlignment:H.NotebookCellStatusBarAlignment,NotebookEditorRevealType:H.NotebookEditorRevealType,NotebookCellOutput:H.NotebookCellOutput,NotebookCellOutputItem:H.NotebookCellOutputItem,NotebookCellStatusBarItem:H.NotebookCellStatusBarItem,NotebookControllerAffinity:H.NotebookControllerAffinity,NotebookControllerAffinity2:H.NotebookControllerAffinity2,NotebookEdit:H.NotebookEdit,NotebookKernelSourceAction:H.NotebookKernelSourceAction,PortAttributes:H.PortAttributes,LinkedEditingRanges:H.LinkedEditingRanges,TestResultState:H.TestResultState,TestRunRequest:H.TestRunRequest,TestMessage:H.TestMessage,TestTag:H.TestTag,TestRunProfileKind:H.TestRunProfileKind,TextSearchCompleteMessageType:ht.TextSearchCompleteMessageType,DataTransfer:H.DataTransfer,DataTransferItem:H.DataTransferItem,CoveredCount:H.CoveredCount,FileCoverage:H.FileCoverage,StatementCoverage:H.StatementCoverage,BranchCoverage:H.BranchCoverage,FunctionCoverage:H.FunctionCoverage,WorkspaceTrustState:H.WorkspaceTrustState,LanguageStatusSeverity:H.LanguageStatusSeverity,QuickPickItemKind:H.QuickPickItemKind,InputBoxValidationSeverity:H.InputBoxValidationSeverity,TabInputText:H.TextTabInput,TabInputTextDiff:H.TextDiffTabInput,TabInputTextMerge:H.TextMergeTabInput,TabInputCustom:H.CustomEditorTabInput,TabInputNotebook:H.NotebookEditorTabInput,TabInputNotebookDiff:H.NotebookDiffEditorTabInput,TabInputWebview:H.WebviewEditorTabInput,TabInputTerminal:H.TerminalEditorTabInput,TabInputInteractiveWindow:H.InteractiveWindowInput,TrustedTelemetryValue:K.TrustedTelemetryValue,TerminalExitReason:H.TerminalExitReason,LogLevel:$e.LogLevel,EditSessionIdentityMatch:ft.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=lt}),define(Se[303],ye([1,0,275,312,313,2,314]),function(te,e,a,t,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function T(P,E,y,v,d,g){const h=g.environment.useHostProxy,w=typeof h=="boolean"?h:!g.remote.isRemote,m=(0,D.createProxyResolver)({resolveProxy:b=>P.resolveProxy(b),getHttpProxySetting:()=>E.getConfiguration("http").get("proxy"),log:(b,s,...o)=>{switch(b){case D.LogLevel.Trace:v.trace(s,...o);break;case D.LogLevel.Debug:v.debug(s,...o);break;case D.LogLevel.Info:v.info(s,...o);break;case D.LogLevel.Warning:v.warn(s,...o);break;case D.LogLevel.Error:v.error(s,...o);break;case D.LogLevel.Critical:v.error(s,...o);break;case D.LogLevel.Off:break;default:c(b,s,o);break}function c(u,r,...l){v.error("Unknown log level",u),v.error(r,...l)}},getLogLevel:()=>v.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:w,env:process.env}),f=S(E,m);return R(y,f)}e.connectProxyResolver=T;function S(P,E){const y={config:P.getConfiguration("http").get("proxySupport")||"off"};P.onDidChangeConfiguration(d=>{y.config=P.getConfiguration("http").get("proxySupport")||"off"});const v={config:!!P.getConfiguration("http").get("systemCertificates")};return P.onDidChangeConfiguration(d=>{v.config=!!P.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},a,(0,D.createHttpPatch)(a,E,{config:"off"},v,!0)),on:Object.assign({},a,(0,D.createHttpPatch)(a,E,{config:"on"},v,!0)),override:Object.assign({},a,(0,D.createHttpPatch)(a,E,{config:"override"},v,!0)),onRequest:Object.assign({},a,(0,D.createHttpPatch)(a,E,y,v,!0)),default:Object.assign(a,(0,D.createHttpPatch)(a,E,y,v,!1))},https:{off:Object.assign({},t,(0,D.createHttpPatch)(t,E,{config:"off"},v,!0)),on:Object.assign({},t,(0,D.createHttpPatch)(t,E,{config:"on"},v,!0)),override:Object.assign({},t,(0,D.createHttpPatch)(t,E,{config:"override"},v,!0)),onRequest:Object.assign({},t,(0,D.createHttpPatch)(t,E,y,v,!0)),default:Object.assign(t,(0,D.createHttpPatch)(t,E,y,v,!1))},tls:Object.assign(k,(0,D.createTlsPatch)(k))}}const C=new Map;function R(P,E){return P.getExtensionPathIndex().then(y=>{const v=globalThis._VSCODE_NODE_MODULES.module,d=v._load;v._load=function(h,w,m){if(h==="tls")return E.tls;if(h!=="http"&&h!=="https")return d.apply(this,arguments);const f=E[h],b=y.findSubstr(A.URI.file(w.filename));let s=C.get(b);if(s||C.set(b,s={}),!s[h]){const o=f.default;s[h]={...o}}return s[h]}})}}),define(Se[304],ye([1,0,75,302,289,303,41,277,2,15,7,274,113,276]),function(te,e,a,t,k,A,D,T,S,C,R,P,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class v extends k.RequireInterceptor{j(){const h=this,w=globalThis._VSCODE_NODE_MODULES.module,m=w._load;w._load=function(o,c,u){return o=b(o),h.a.has(o)?h.a.get(o).load(o,S.URI.file((0,E.realpathSync)(c.filename)),r=>m.apply(this,[r,c,u])):m.apply(this,arguments)};const f=w._resolveLookupPaths;w._resolveLookupPaths=(s,o)=>f.call(this,b(s),o);const b=s=>{for(const o of h.b){const c=o(s);if(c){s=c;break}}return s}}}class d extends D.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Node}async pb(){this.h.createInstance(y.ExtHostConsoleForwarder);const h=this.h.invokeFunction(t.createApiFactoryAndRegisterActors);if(this.h.createInstance(T.ExtHostDownloadService),this.f.remote.isRemote&&this.f.remote.authority){const f=this.h.createInstance(P.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=f.ipcHandlePath}await this.h.createInstance(v,h,{mine:this.F,all:this.G}).install(),a.mark("code/extHost/didInitAPI");const m=await this.k.getConfigProvider();await(0,A.connectProxyResolver)(this.j,m,this,this.l,this.u,this.f),a.mark("code/extHost/didInitProxyResolver")}qb(h){return h.main}async rb(h,w,m){if(w.scheme!==C.Schemas.file)throw new Error(`Cannot load URI: '${w}', must be of file-scheme`);let f=null;m.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${w.toString(!0)}`),this.l.flush();const b=h?.identifier.value;h&&await this.s.initializeLocalizedMessages(h);try{b&&a.mark(`code/extHost/willLoadExtensionCode/${b}`),f=te.__$__nodeRequire(w.fsPath)}finally{b&&a.mark(`code/extHost/didLoadExtensionCode/${b}`),m.codeLoadingStop()}return f}async $setRemoteEnvironment(h){if(!!this.f.remote.isRemote)for(const w in h){const m=h[w];m===null?delete process.env[w]:process.env[w]=m}}}e.ExtHostExtensionService=d}),define(Se[144],ye([1,0,44,315,298,17,79,37,9,8,2,31,73,316,296,98]),function(te,e,a,t,k,A,D,T,S,C,R,P,E,y,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const g=v.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class h{constructor(p){this.a=p}provideTextSearchResults(p,I,L,U){return this.a.appendLine(`provideTextSearchResults ${p.pattern}, ${JSON.stringify({...I,folder:I.folder.toString()})}`),new Promise((G,V)=>{U.onCancellationRequested(()=>q());const O=o(p,I),B=I.folder.fsPath,F=O.map(de=>de.match(/^-/)?de:`'${de}'`).join(" ");this.a.appendLine(`${g} ${F}
 - cwd: ${B}`);let $=a.spawn(g,O,{cwd:B});$.on("error",de=>{console.error(de),this.a.appendLine("Error: "+(de&&de.message)),V((0,P.serializeSearchError)(new P.SearchError(de&&de.message,P.SearchErrorCode.rgProcessError)))});let M=!1;const H=new f(I.maxResults,B,I.previewOptions);H.on("result",de=>{M=!0,Q="",L.report(de)});let K=!1;const q=()=>{K=!0,$?.kill(),H?.cancel()};let Y=!1;H.on("hitLimit",()=>{Y=!0,q()});let Q="";$.stdout.on("data",de=>{H.handleData(de),M||(Q+=de)});let ce=!1;$.stdout.once("data",()=>ce=!0);let ie="";$.stderr.on("data",de=>{const J=de.toString();this.a.appendLine(J),ie.length+J.length<1e6&&(ie+=J)}),$.on("close",()=>{if(this.a.appendLine(ce?"Got data from stdout":"No data from stdout"),this.a.appendLine(M?"Got result from parser":"No result from parser"),Q&&this.a.appendLine(`Got data without result: ${Q}`),this.a.appendLine(""),K)G({limitHit:Y});else{H.flush(),$=null;let de;ie&&!ce&&(de=w(ie))?V((0,P.serializeSearchError)(new P.SearchError(de.message,de.code))):G({limitHit:Y})}})})}}e.RipgrepTextSearchEngine=h;function w(i){const p=i.split(`
`),I=p[0].trim();if(p.some(U=>U.startsWith("regex parse error")))return new P.SearchError(m(p),P.SearchErrorCode.regexParseError);const L=I.match(/grep config error: unknown encoding: (.*)/);if(L)return new P.SearchError(`Unknown encoding: ${L[1]}`,P.SearchErrorCode.unknownEncoding);if(I.startsWith("error parsing glob"))return new P.SearchError(I.charAt(0).toUpperCase()+I.substr(1),P.SearchErrorCode.globParseError);if(I.startsWith("the literal"))return new P.SearchError(I.charAt(0).toUpperCase()+I.substr(1),P.SearchErrorCode.invalidLiteral);if(I.startsWith("PCRE2: error compiling pattern"))return new P.SearchError(I,P.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=w;function m(i){const p=["Regex parse error"],I=i.filter(L=>L.startsWith("PCRE2:"));if(I.length>=1){const L=I[0].replace("PCRE2:","");if(L.indexOf(":")!==-1&&L.split(":").length>=2){const U=L.split(":")[1];p.push(":"+U)}}return p.join("")}e.buildRegexParseError=m;class f extends t.EventEmitter{constructor(p,I,L){super(),this.g=p,this.h=I,this.j=L,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new k.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(p,I){return super.on(p,I),this}handleData(p){if(this.b)return;const I=typeof p=="string"?p:this.d.write(p);this.k(I)}k(p){let I=p.indexOf(`
`);const L=this.a+p;if(I>=0)I+=this.a.length;else{this.a=L;return}let U=0;for(;I>=0;)this.m(L.substring(U,I).trim()),U=I+1,I=L.indexOf(`
`,U);this.a=L.substring(U)}m(p){if(this.b||!p)return;let I;try{I=JSON.parse(p)}catch{throw new Error(`malformed line from rg: ${p}`)}if(I.type==="match"){const L=b(I.data.path),U=R.URI.file(S.join(this.h,L)),G=this.n(I.data,U);this.p(G),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(I.type==="context"){const L=b(I.data.path),U=R.URI.file(S.join(this.h,L));this.o(I.data,U).forEach(V=>this.p(V))}}n(p,I){const L=p.line_number-1,U=b(p.lines),G=Buffer.from(U);let V=0,O=0,B=L;p.submatches.length===0&&p.submatches.push(U.length?{start:0,end:1,match:{text:U[0]}}:{start:0,end:0,match:{text:""}});const F=(0,A.coalesce)(p.submatches.map(($,M)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const H=b($.match),K=G.slice(V,$.start).toString(),q=s(K),Y=q.numLines>0?q.lastLineLength:q.lastLineLength+O,Q=s(H),ce=q.numLines+B,ie=Q.numLines+ce,de=Q.numLines>0?Q.lastLineLength:Q.lastLineLength+Y;return V=$.end,O=de,B=ie,new E.Range(ce,Y,ie,de)}));return(0,d.createTextSearchResult)(I,U,F,this.j)}o(p,I){const L=b(p.lines),U=p.line_number;return L.replace(/\r?\n$/,"").split(`
`).map((G,V)=>({text:G,uri:I,lineNumber:U+V}))}p(p){this.emit("result",p)}}e.RipgrepParser=f;function b(i){return i.bytes?Buffer.from(i.bytes,"base64").toString():i.text}function s(i){const p=/\n/g;let I=0,L=-1,U;for(;U=p.exec(i);)I++,L=U.index;const G=L>=0?i.length-L-1:i.length;return{numLines:I,lastLineLength:G}}function o(i,p){const I=["--hidden"];I.push(i.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:L,otherIncludes:U}=(0,D.groupBy)(p.includes,V=>V.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(U&&U.length){const V=new Set;U.forEach(O=>{V.add(O)}),I.push("-g","!*"),V.forEach(O=>{c(O).map(d.anchorGlob).forEach(B=>{I.push("-g",B)})})}L&&L.length&&L.forEach(V=>{I.push("-g",V)}),p.excludes.map(d.anchorGlob).forEach(V=>I.push("-g",`!${V}`)),p.maxFileSize&&I.push("--max-filesize",p.maxFileSize+""),p.useIgnoreFiles?p.useParentIgnoreFiles||I.push("--no-ignore-parent"):I.push("--no-ignore"),p.followSymlinks&&I.push("--follow"),p.encoding&&p.encoding!=="utf8"&&I.push("--encoding",p.encoding),i.pattern==="--"&&(i.isRegExp=!0,i.pattern="\\-\\-"),i.isMultiline&&!i.isRegExp&&(i.pattern=(0,C.escapeRegExpCharacters)(i.pattern),i.isRegExp=!0),p.usePCRE2&&I.push("--pcre2"),I.push("--crlf"),i.isRegExp&&(i.pattern=u(i.pattern),I.push("--engine","auto"));let G;if(i.isWordMatch){const O=(0,C.createRegExp)(i.pattern,!!i.isRegExp,{wholeWord:i.isWordMatch}).source.replace(/\\\//g,"/");I.push("--regexp",O)}else if(i.isRegExp){let V=l(i.pattern);V=n(V),I.push("--regexp",V)}else G=i.pattern,I.push("--fixed-strings");return I.push("--no-config"),p.useGlobalIgnoreFiles||I.push("--no-ignore-global"),I.push("--json"),i.isMultiline&&I.push("--multiline"),p.beforeContext&&I.push("--before-context",p.beforeContext+""),p.afterContext&&I.push("--after-context",p.afterContext+""),I.push("--"),G&&I.push(G),I.push("."),I}function c(i){const p=(0,T.splitGlobAware)(i,"/");return p.map((I,L)=>p.slice(0,L+1).join("/"))}e.spreadGlobComponents=c;function u(i){const p=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;i.match(p);)i=i.replace(p,"$1\\x{$2}");const I=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;i.match(I);)i=i.replace(I,"$1\\x{$2}");return i}e.unicodeEscapesToPCRE2=u;const r=i=>i.type==="Assertion"&&i.kind==="lookbehind";function l(i){let p;try{p=new y.RegExpParser().parsePattern(i)}catch{return i}let I="",L=0;const U=(O,B,F)=>{I+=i.slice(L,O)+F,L=B},G=[];return new y.RegExpVisitor({onCharacterEnter(O){if(O.raw!=="\\n")return;const B=G[0];if(!B)U(O.start,O.end,"\\r?\\n");else if(!G.some(r))if(B.type==="CharacterClass")if(B.negate){const F=i.slice(B.start+2,O.start)+i.slice(O.end,B.end-1);B.parent?.type==="Quantifier"?U(B.start,B.end,F?`[^${F}]`:"."):U(B.start,B.end,"(?!\\r?\\n"+(F?`|[${F}]`:"")+")")}else{const F=i.slice(B.start+1,O.start)+i.slice(O.end,B.end-1);U(B.start,B.end,F===""?"\\r?\\n":`(?:[${F}]|\\r?\\n)`)}else B.type==="Quantifier"&&U(O.start,O.end,"(?:\\r?\\n)")},onQuantifierEnter(O){G.unshift(O)},onQuantifierLeave(){G.shift()},onCharacterClassRangeEnter(O){G.unshift(O)},onCharacterClassRangeLeave(){G.shift()},onCharacterClassEnter(O){G.unshift(O)},onCharacterClassLeave(){G.shift()},onAssertionEnter(O){r(O)&&G.push(O)},onAssertionLeave(O){G[0]===O&&G.shift()}}).visit(p),I+=i.slice(L),I}e.fixRegexNewline=l;function n(i){return i.replace(/\n/g,"\\r?\\n")}e.fixNewline=n}),define(Se[305],ye([1,0,21,144,124,15]),function(te,e,a,t,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class D{constructor(C){this.b=C,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(C,R,P,E){const y=new t.RipgrepTextSearchEngine(this.b);if(R.folder.scheme===A.Schemas.vscodeUserData){const v={...R,folder:R.folder.with({scheme:A.Schemas.file})},d=new k.Progress(g=>P.report({...g,uri:g.uri.with({scheme:R.folder.scheme})}));return this.c(E,g=>y.provideTextSearchResults(C,v,d,g))}else return this.c(E,v=>y.provideTextSearchResults(C,R,P,v))}async c(C,R){const P=T(C);this.a.add(P);const E=await R(P.token);return this.a.delete(P),E}d(){this.a.forEach(C=>C.cancel())}}e.RipgrepSearchProvider=D;function T(S){const C=new a.CancellationTokenSource;return S.onCancellationRequested(()=>C.cancel()),C}}),define(Se[306],ye([1,0,29,144,143]),function(te,e,a,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class A{constructor(S){this.a=S}search(S,C,R){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(y){R({message:y})}},E=new k.NativeTextSearchManager(this.a,new t.RipgrepTextSearchEngine(P),a);return new Promise((y,v)=>E.search(d=>{C(d.map(D))},S).then(d=>y({limitHit:d.limitHit,type:"success",stats:d.stats}),v))}}e.TextSearchEngineAdapter=A;function D(T){return{path:T.resource&&T.resource.fsPath,results:T.results,numMatches:(T.results||[]).reduce((S,C)=>{if(C.ranges){const R=C;return S+(Array.isArray(R.ranges)?R.ranges.length:1)}else return S+1},0)}}}),define(Se[307],ye([1,0,17,18,10,4,109,9,51,2,38,31,297,306]),function(te,e,a,t,k,A,D,T,S,C,R,P,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class v{constructor(f="searchProcess"){this.d=f,this.b=Object.create(null)}fileSearch(f){let b;const s=h(f),o=new A.Emitter({onDidAddFirstListener:()=>{b=(0,t.createCancelablePromise)(c=>this.doFileSearchWithEngine(E.Engine,s,u=>o.fire(u),c)),b.then(c=>o.fire(c),c=>o.fire({type:"error",error:{message:c.message,stack:c.stack}}))},onDidRemoveLastListener:()=>{b.cancel()}});return o.event}textSearch(f){let b;const s=h(f),o=new A.Emitter({onDidAddFirstListener:()=>{b=(0,t.createCancelablePromise)(c=>this.f(s,u=>o.fire(u),c)),b.then(c=>o.fire(c),c=>o.fire({type:"error",error:{message:c.message,stack:c.stack}}))},onDidRemoveLastListener:()=>{b.cancel()}});return o.event}f(f,b,s){return f.maxFileSize=(0,R.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new y.TextSearchEngineAdapter(f).search(s,b,b)}doFileSearch(f,b,s){return this.doFileSearchWithEngine(E.Engine,f,b,s)}doFileSearchWithEngine(f,b,s,o,c=v.a){let u=0;const r=n=>{Array.isArray(n)?(u+=n.length,s(n.map(i=>this.g(i)))):n.relativePath?(u++,s(this.g(n))):s(n)};if(b.sortByScore){let n=this.k(b,r,o);if(!n){const i=b.maxResults?Object.assign({},b,{maxResults:null}):b,p=new f(i);n=this.h(p,b,s,r,o)}return new Promise((i,p)=>{n.then(([I,L])=>{const U=L.map(G=>this.g(G));this.n(U,s,c),i(I)},p)})}const l=new f(b);return this.q(l,r,c,o).then(n=>({limitHit:n.limitHit,type:"success",stats:{detailStats:n.stats,type:this.d,fromCache:!1,resultCount:u,sortingTime:void 0}}))}g(f){return{path:f.base?(0,T.join)(f.base,f.relativePath):f.relativePath}}h(f,b,s,o,c){const u=new A.Emitter;let r=(0,t.createCancelablePromise)(n=>{let i=[];const p=I=>{Array.isArray(I)?i=I:(o(I),u.fire(I))};return this.q(f,p,-1,n).then(I=>[I,i])}),l;if(b.cacheKey){l=this.j(b.cacheKey);const n={promise:r,event:u.event,resolved:!1};l.resultsToSearchCache[b.filePattern||""]=n,r.then(()=>{n.resolved=!0},i=>{delete l.resultsToSearchCache[b.filePattern||""]}),r=this.r(r)}return r.then(([n,i])=>{const p=l?l.scorerCache:Object.create(null),I=(typeof b.maxResults!="number"||b.maxResults>0)&&S.StopWatch.create(!1);return this.l(b,i,p,c).then(L=>{const U=I?I.elapsed():-1;return[{type:"success",stats:{detailStats:n.stats,sortingTime:U,fromCache:!1,type:this.d,workspaceFolderCount:b.folderQueries.length,resultCount:L.length},messages:n.messages,limitHit:n.limitHit||typeof b.maxResults=="number"&&i.length>b.maxResults},L]})})}j(f){const b=this.b[f];return b||(this.b[f]=new d)}k(f,b,s){const o=f.cacheKey&&this.b[f.cacheKey];if(!o)return;const c=this.o(o,f.filePattern||"",b,s);if(c)return c.then(([u,r,l])=>{const n=S.StopWatch.create(!1);return this.l(f,r,o.scorerCache,s).then(i=>{const p=n.elapsed(),I={fromCache:!0,detailStats:l,type:this.d,resultCount:r.length,sortingTime:p};return[{type:"success",limitHit:u.limitHit||typeof f.maxResults=="number"&&r.length>f.maxResults,stats:I},i]})})}l(f,b,s,o){const c=(0,D.prepareQuery)(f.filePattern||""),u=(l,n)=>(0,D.compareItemsByFuzzyScore)(l,n,c,!0,g,s),r=typeof f.maxResults=="number"?f.maxResults:Number.MAX_VALUE;return a.topAsync(b,u,r,1e4,o)}n(f,b,s){if(s&&s>0)for(let o=0;o<f.length;o+=s)b(f.slice(o,o+s));else b(f)}o(f,b,s,o){const c=S.StopWatch.create(!1),u=b.indexOf(T.sep)>=0;let r;for(const p in f.resultsToSearchCache)if(b.startsWith(p)){if(u&&p.indexOf(T.sep)<0&&p!=="")continue;const I=f.resultsToSearchCache[p];r={promise:this.r(I.promise),event:I.event,resolved:I.resolved};break}if(!r)return null;const l=c.elapsed(),n=S.StopWatch.create(!1),i=r.event(s);return o&&o.onCancellationRequested(()=>{i.dispose()}),r.promise.then(([p,I])=>{if(o&&o.isCancellationRequested)throw(0,k.canceled)();const L=[],U=(0,D.prepareQuery)(b).normalizedLowercase;for(const G of I)!(0,P.isFilePatternMatch)(G,U)||L.push(G);return[p,L,{cacheWasResolved:r.resolved,cacheLookupTime:l,cacheFilterTime:n.elapsed(),cacheEntryCount:I.length}]})}q(f,b,s,o){return new Promise((c,u)=>{let r=[];o?.onCancellationRequested(()=>f.cancel()),f.search(l=>{l&&(s?(r.push(l),s>0&&r.length>=s&&(b(r),r=[])):b(l))},l=>{b(l)},(l,n)=>{r.length&&b(r),l?u(l):c(n)})})}clearCache(f){return delete this.b[f],Promise.resolve(void 0)}r(f){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(b,s){return f.then(b,s)}catch(b){return this.then(void 0,b)}finally(b){return f.finally(b)}}}}e.SearchService=v,v.a=512;class d{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const g=new class{getItemLabel(m){return(0,T.basename)(m.relativePath)}getItemDescription(m){return(0,T.dirname)(m.relativePath)}getItemPath(m){return m.relativePath}};function h(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(w),extraFileResources:m.extraFileResources&&m.extraFileResources.map(f=>C.URI.revive(f))}}function w(m){return{...m,folder:C.URI.revive(m.folder)}}}),define(Se[308],ye([1,0,6,15,2,29,13,25,16,77,55,31,307,305,98,143]),function(te,e,a,t,k,A,D,T,S,C,R,P,E,y,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let g=class extends C.ExtHostSearch{constructor(w,m,f,b){super(w,f,b),this.s=A,this.t=-1,this.v=null,this.w=!1;const s=new v.OutputChannel("RipgrepSearchUD",this.n);this.registerTextSearchProvider(t.Schemas.vscodeUserData,new y.RipgrepSearchProvider(s)),m.remote.isRemote&&m.remote.authority&&this.x()}$enableExtensionHostSearch(){this.x()}x(){if(this.w)return;this.w=!0;const w=new v.OutputChannel("RipgrepSearchEH",this.n);this.registerTextSearchProvider(t.Schemas.file,new y.RipgrepSearchProvider(w)),this.y(t.Schemas.file,new E.SearchService("fileSearchProvider"))}y(w,m){const f=this.d++;return this.v=m,this.t=f,this.c.$registerFileSearchProvider(f,this.o(w)),(0,a.toDisposable)(()=>{this.v=null,this.c.$unregisterProvider(f)})}$provideFileSearchResults(w,m,f,b){const s=(0,C.reviveQuery)(f);return w===this.t?this.A(w,m,s,b):super.$provideFileSearchResults(w,m,f,b)}A(w,m,f,b){const s=o=>{if((0,P.isSerializedFileMatch)(o)&&(o=[o]),Array.isArray(o)){this.c.$handleFileMatch(w,m,o.map(c=>k.URI.file(c.path)));return}o.message&&this.n.debug("ExtHostSearch",o.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(f,s,b)}$clearCache(w){return this.v?.clearCache(w),super.$clearCache(w)}q(w,m){return new d.NativeTextSearchManager(w,m,void 0,"textSearchProvider")}};g=Ve([We(0,S.IExtHostRpcService),We(1,T.IExtHostInitDataService),We(2,R.IURITransformerService),We(3,D.ILogService)],g),e.NativeExtHostSearch=g}),define(Se[309],ye([1,0,86,280,292,291,308,304,281,76,41,77,74,40,54,71,279,278,13,293,47]),function(te,e,a,t,k,A,D,T,S,C,R,P,E,y,v,d,g,h,w,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(R.IExtHostExtensionService,T.ExtHostExtensionService,0),(0,a.registerSingleton)(w.ILoggerService,h.ExtHostLoggerService,1),(0,a.registerSingleton)(d.IExtensionStoragePaths,g.ExtensionStoragePaths,0),(0,a.registerSingleton)(C.IExtHostDebugService,A.ExtHostDebugService,0),(0,a.registerSingleton)(P.IExtHostSearch,D.NativeExtHostSearch,0),(0,a.registerSingleton)(E.IExtHostTask,k.ExtHostTask,0),(0,a.registerSingleton)(y.IExtHostTerminalService,t.ExtHostTerminalService,0),(0,a.registerSingleton)(v.IExtHostTunnelService,S.ExtHostTunnelService,0),(0,a.registerSingleton)(f.IExtHostVariableResolverProvider,m.NodeExtHostVariableResolverProviderService,0)}),define(Se[317],ye([1,0,219,318,75,10,116,117,200,93,290,22,29,113,18,119,215,229,294,309]),function(te,e,a,t,k,A,D,T,S,C,R,P,E,y,v,d,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let l=0;l<process.execArgv.length;l++)process.execArgv[l]==="--inspect-port=0"&&(process.execArgv.splice(l,1),l--)}();const w=t(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const r=globalThis._VSCODE_NODE_MODULES.module,l=r._load;r._load=function(n){if(n==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return l.apply(this,arguments)}})();const m=process.exit.bind(process);function f(r){process.exit=function(l){if(r)m(l);else{const n=new Error("An extension called process.exit() and this was prevented.");console.warn(n.stack)}},process.crash=function(){const l=new Error("An extension called process.crash() and this was prevented.");console.warn(l.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let b=function(r){m()};function s(){const r=(0,h.readExtHostConnection)(process.env);if(r.type===3)return new Promise((l,n)=>{const i=p=>{const I=p[0],L=new D.BufferedEmitter;I.on("message",U=>L.fire(P.VSBuffer.wrap(U.data))),I.on("close",()=>{b("renderer closed the MessagePort")}),I.start(),l({onMessage:L.event,send:U=>I.postMessage(U.buffer)})};process?.parentPort.on("message",p=>i(p.ports))});if(r.type===2)return new Promise((l,n)=>{let i=null;const p=setTimeout(()=>{b("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),I=108e5,L=3e5,U=new v.ProcessTimeRunOnceScheduler(()=>b("renderer disconnected for too long (1)"),I),G=new v.ProcessTimeRunOnceScheduler(()=>b("renderer disconnected for too long (2)"),L);process.on("message",(O,B)=>{if(O&&O.type==="VSCODE_EXTHOST_IPC_SOCKET"){B.setNoDelay(!0);const F=P.VSBuffer.wrap(Buffer.from(O.initialDataChunk,"base64"));let $;if(O.skipWebSocketFrames)$=new T.NodeSocket(B,"extHost-socket");else{const M=P.VSBuffer.wrap(Buffer.from(O.inflateBytes,"base64"));$=new T.WebSocketNodeSocket(new T.NodeSocket(B,"extHost-socket"),O.permessageDeflate,M,!1)}i?(U.cancel(),G.cancel(),i.beginAcceptReconnection($,F),i.endAcceptReconnection(),i.sendResume()):(clearTimeout(p),i=new D.PersistentProtocol($,F),i.sendResume(),i.onDidDispose(()=>b("renderer disconnected")),l(i),i.onSocketClose(()=>{U.schedule()}))}if(O&&O.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(G.isScheduled())return;U.isScheduled()&&G.schedule()}});const V={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(V)});{const l=r.pipeName;return new Promise((n,i)=>{const p=a.createConnection(l,()=>{p.removeListener("error",i);const I=new D.PersistentProtocol(new T.NodeSocket(p,"extHost-renderer"));I.sendResume(),n(I)});p.once("error",i),p.on("close",()=>{b("renderer closed the socket")})})}}async function o(){const r=await s();return new class{constructor(){this.a=new D.BufferedEmitter,this.onMessage=this.a.event,this.b=!1,r.onMessage(l=>{(0,C.isMessageOfType)(l,2)?(this.b=!0,b("received terminate message from renderer")):this.a.fire(l)})}send(l){this.b||r.send(l)}async drain(){if(r.drain)return r.drain()}}}function c(r){return new Promise(l=>{const n=r.onMessage(i=>{n.dispose();const p=JSON.parse(i.toString()),I=p.commit,L=S.default.commit;if(I&&L&&I!==L&&m(55),p.parentPid){let U=0;setInterval(function(){try{process.kill(p.parentPid,0),U=0}catch(V){V&&V.code==="EPERM"?(U++,U>=3&&b(`parent process ${p.parentPid} does not exist anymore (3 x EPERM): ${V.message} (code: ${V.code}) (errno: ${V.errno})`)):b(`parent process ${p.parentPid} does not exist anymore: ${V.message} (code: ${V.code}) (errno: ${V.errno})`)}},1e3);let G;try{G=globalThis._VSCODE_NODE_MODULES["native-watchdog"],G.start(p.parentPid)}catch(V){(0,A.onUnexpectedError)(V)}}r.send((0,C.createMessageOfType)(0)),l({protocol:r,initData:p})});r.send((0,C.createMessageOfType)(1))})}async function u(){const r=[];process.on("unhandledRejection",(U,G)=>{r.push(G),setTimeout(()=>{const V=r.indexOf(G);V>=0&&G.catch(O=>{r.splice(V,1),(0,A.isCancellationError)(O)||(console.warn(`rejected promise not handled within 1 second: ${O}`),O&&O.stack&&console.warn(`stack trace: ${O.stack}`),U&&(0,A.onUnexpectedError)(U))})},1e3)}),process.on("rejectionHandled",U=>{const G=r.indexOf(U);G>=0&&r.splice(G,1)}),process.on("uncaughtException",function(U){(0,A.onUnexpectedError)(U)}),k.mark("code/extHost/willConnectToRenderer");const l=await o();k.mark("code/extHost/didConnectToRenderer");const n=await c(l);k.mark("code/extHost/didWaitForInitData");const{initData:i}=n;f(!!i.environment.extensionTestsLocationURI),i.environment.useHostProxy=w.useHostProxy!==void 0?w.useHostProxy!=="false":void 0,i.environment.skipWorkspaceStorageLock=(0,d.boolean)(w.skipWorkspaceStorageLock,!1);const p=new class{constructor(){this.pid=process.pid}exit(G){m(G)}exists(G){return E.Promises.exists(G)}realpath(G){return(0,y.realpath)(G)}};let I=null;i.remote.authority&&w.transformURIs&&(I=(0,g.createURITransformer)(i.remote.authority));const L=new R.ExtensionHostMain(n.protocol,i,p,I);b=U=>L.terminate(U)}u().catch(r=>console.log(r))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f730160c5d5fe36a7ad8db51f74f40a9d316e8b2/core/vs/workbench/api/node/extensionHostProcess.js.map
